local function cl(x,y) return "|cffffaaaa"..x..","..y.."|r" end
local function cq(q) return "|cffaaaaff`"..q.."'|r" end
ZygorGuidesViewer_HordeGuide = {
	{ sectiontitle = "Undead (1-13)",
	  defaultfor = "Scourge",
	  nextsection = 6,
	  steps = {
		{
			"Go outside of the crypt",
			completion={{location={mapzone="Tirisfal Glades",x=30.3,y=72.8, dist=0.3}}},
			mapzone="Tirisfal Glades",
			level=1,
		}, {
			"Go to "..cl(30,72),
			"	a. Talk to Undertaken Mordo",
			"		i. Accept "..cq("Rude Awakening"),
			completion={{questaccepted="Rude Awakening"}},
			mapzone="Tirisfal Glades",
			level=1,
			mapnote=71710190,
		}, {
			"Go north to "..cl(31,66),
			"	a. Talk to Shadow Priest Sarvis",
			"		i. Turn in "..cq("Rude Awakening"),
			"		ii. Accept "..cq("The Mindless Ones"),
			completion={{questturnedin="Rude Awakening"},{questaccepted="The Mindless Ones"}},
			mapzone="Tirisfal Glades",
			level=1,
			mapnote=66209700,
		}, {
			"Go northeast to "..cl(32,64),
			"	a. Kill 8 Mindless Zombies",
			"	b. Kill 8 Wretched Zombies",
			completion={{questgoal={"*","Mindless Zombie slain",8}},{questgoal={"*","Wretched Zombie slain",8}}},
			mapzone="Tirisfal Glades",
			level=1,
			mapnote=63709550,
		}, {
			"Grind to level 3",
			completion={{level=3}},
			mapzone="Tirisfal Glades",
			level=2,
		}, {
			"Go southwest to "..cl(31,66),
			"	a. Talk to Shadow Priest Sarvis",
			"		i. Turn in "..cq("The Mindless Ones"),
			"		ii. Accept "..cq("Rattling the Rattlecages"),
			"	b. Talk to Novice Elreth",
			"		i. Accept "..cq("The Damned"),
			completion={{questturnedin="The Mindless Ones"},{questaccepted="The Damned"},{questaccepted="Rattling the Rattlecages"}},
			mapzone="Tirisfal Glades",
			level=3,
			mapnote=66209700,
		}, {
			"Go northeast to "..cl(33,61),
			"	a. Kill 12 Rattlecage Skeletons",
			completion={{questgoal={"*","Rattlecage Skeleton slain",12}}},
			mapzone="Tirisfal Glades",
			level=3,
			mapnote=61309380,
		}, {
			"Grind to level 4",
			completion={{level=4}},
			mapzone="Tirisfal Glades",
			level=3,
		}, {
			"Go northwest to "..cl(32,59),
			"	a. Kill wolves",
			"	b. Get 6 Scavenger Paws",
			"	c. Kill bats",
			"	d. Get 6 Duskbat Wings",
			completion={{questgoal={"*","Scavenger Paw",6}},{questgoal={"*","Duskbat Wing",6}}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=58709040,
		}, {
			"Go south to "..cl(31,66),
			"	a. Talk to Novice Elreth",
			"		i. Turn in "..cq("The Damned"),
			"		ii. Accept "..cq("Marla's Last Wish"),
			"	b. Talk to Shadow Priest Sarvis",
			"		i. Turn in "..cq("Rattling the Rattlecages"),
			completion={{questturnedin="The Damned"},{questaccepted="Marla's Last Wish"},{questturnedin="Rattling the Rattlecages"}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=66209700,
		}, {
			"Go to "..cl(32,66),
			"	a. Talk to Executor Arren",
			"		i. Accept "..cq("Night Web's Hollow"),
			completion={{questaccepted="Night Web's Hollow"}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=66009820,
		}, {
			"Also at "..cl(32,66),
			"	a. Talk to Deathguard Saltain",
			"		i. Accept "..cq("Scavenging Deathknell"),
			completion={{questaccepted="Scavenging Deathknell"}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=65609720,
		}, {
			"Go northeast to "..cl(33,64),
			"	a. Click the Scavenged Goods boxes",
			"	b. Get 6 Scavenged Goods",
			completion={{questgoal={"*","Scavenged Goods",6}}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=63709690,
		}, {
			"Go northwest to "..cl(29,58),
			"	a. Kill 10 Young Night Web Spiders",
			completion={{questgoal={"*","Young Night Web Spider slain",10}}},
			mapzone="Tirisfal Glades",
			level=4,
			mapnote=58608800,
		}, {
			"Grind to level 5",
			completion={{level=5}},
			mapzone="Tirisfal Glades",
			level=4,
		}, {
			"Go west to "..cl(27,59),
			"	a. Go inside the cave",
			"	b. Kill 8 Night Web Spiders",
			completion={{questgoal={"*","Night Web Spider slain",8}}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=59408630,
		}, {
			"Go east to "..cl(37,62),
			"	a. Kill Samuel Fipps",
			"	b. Get Samuel's Remains",
			completion={{item={"Samuel's Remains",1}}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=61509820,
		}, {
			"Go southwest to "..cl(31,65),
			"	a. Click   Marla's Grave",
			"	b. Bury Samuel's Remains",
			completion={{questgoal={"*","Samuel's Remains Buried",1}}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=65109630,
		}, {
			"Go to "..cl(32,66),
			"	a. Talk to Deathguard Saltain",
			"		i. Turn in "..cq("Scavenging Deathknell"),
			completion={{questturnedin="Scavenging Deathknell"}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=65609720,
		}, {
			"Go to "..cl(32,66),
			"	a. Talk to Executor Arren",
			"		i. Turn in "..cq("Night Web's Hollow"),
			"		ii. Accept "..cq("The Scarlet Crusade"),
			completion={{questturnedin="Night Web's Hollow"},{questaccepted="The Scarlet Crusade"}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=66009820,
		}, {
			"Go to "..cl(31,66),
			"	a. Talk to Novice Elreth",
			"		i. Turn in "..cq("Marla's Last Wish"),
			completion={{questturnedin="Marla's Last Wish"}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=66209700,
		}, {
			"Go east to "..cl(36,67),
			"	a. Kill scarlet mobs",
			"	b. Get 12 Scarlet Armbands",
			completion={{questgoal={"*","Scarlet Armband",12}}},
			mapzone="Tirisfal Glades",
			level=5,
			mapnote=67110320,
		}, {
			"Grind to level 6",
			completion={{level=6}},
			mapzone="Tirisfal Glades",
			level=5,
		}, {
			"Go west to "..cl(32,66),
			"	a. Talk to Executor Arren",
			"		i. Turn in "..cq("The Scarlet Crusade"),
			"		ii. Accept "..cq("The Red Messenger"),
			completion={{questturnedin="The Scarlet Crusade"},{questaccepted="The Red Messenger"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=66009820,
		}, {
			"Go southeast to "..cl(36,69),
			"	a. Kill Meven Korgal",
			"	b. Get the Scarlet Crusade Documents",
			completion={{questgoal={"*","Scarlet Crusade Documents",1}}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=68810530,
		}, {
			"Go northwest to "..cl(32,66),
			"	a. Talk to Executor Arren",
			"		i. Turn in "..cq("The Red Messenger"),
			"		ii. Accept "..cq("Vital Intelligence"),
			completion={{questturnedin="The Red Messenger"},{questaccepted="Vital Intelligence"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=66009820,
		}, {
			"Go northeast to "..cl(38,57),
			"	a. Talk to Calvin Montague",
			"		i. Accept "..cq("A Rogue's Deal part 1"),
			completion={{questaccepted="A Rogue's Deal part 1"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=56809500,
		}, {
			"Go northeast to "..cl(41,54),
			"	a. Talk to Deathguard Simmer",
			"		i. Accept "..cq("Fields of Grief part 1"),
			completion={{questaccepted="Fields of Grief part 1"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=54209510,
		}, {
			"Go southeast to "..cl(46,57),
			"	a. Talk to Gordo",
			"	b. He wanders around this area, you may need to search for him",
			"		i. Accept "..cq("Gordo's Task"),
			completion={{questaccepted="Gordo's Task"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=56610220,
		}, {
			"Go northeast to "..cl(53,52),
			"	a. Click the Gloom Weeds",
			"	b. Get 3 Gloom Weeds",
			completion={{questgoal={"*","Gloom Weed",3}}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=52110500,
		}, {
			"Go east to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=6,
		}, {
			"Go to "..cl(58,51),
			"	a. Talk to Deathguard Dillinger",
			"		i. Accept "..cq("A Putrid Task"),
			completion={{questaccepted="A Putrid Task"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=51410960,
		}, {
			"Go to "..cl(59,52),
			"	a. Talk to Apothecary Johaan",
			"		i. Accept "..cq("A New Plague"),
			completion={{questaccepted="A New Plague"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=52411180,
		}, {
			"Go to "..cl(61,52),
			"	a. Talk to Executor Zygand",
			"		i. Turn in "..cq("Vital Intelligence"),
			"		ii. Accept "..cq("At War With The Scarlet Crusade part 1"),
			completion={{questturnedin="Vital Intelligence"},{questaccepted="At War With The Scarlet Crusade part 1"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=51811240,
		}, {
			"Also at "..cl(61,52),
			"	a. Click the Wanted Posted",
			"		i. Accept "..cq("Wanted: Maggot Eye"),
			completion={{questaccepted="Wanted: Maggot Eye"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=51511220,
		}, {
			"Go to "..cl(61,51),
			"	a. Talk to Magistrate Sevren",
			"		i. Accept "..cq("Graverobbers"),
			completion={{questaccepted="Graverobbers"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=50811210,
		}, {
			"Go to "..cl(62,52),
			"	a. Talk to Innkeeper Renee",
			"		i. Turn in "..cq("A Rogue's Deal part 1"),
			completion={{questturnedin="A Rogue's Deal part 1"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=52011370,
		}, {
			"Make Brill your home",
			completion={{home="Brill"}},
			mapzone="Tirisfal Glades",
			level=6,
		}, {
			"Go to "..cl(58,49),
			"	a. Talk to Junior Apothecary Holland",
			"		i. Turn in "..cq("Gordo's Task"),
			"		ii. Accept "..cq("Doom Weed"),
			completion={{questturnedin="Gordo's Task"},{questaccepted="Doom Weed"}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=48710630,
		}, {
			"Go southwest to "..cl(55,51),
			"	a. Kill zombies",
			"	b. Get 7 Putrid Claws",
			completion={{questgoal={"*","Putrid Claw",7}}},
			mapzone="Tirisfal Glades",
			level=6,
			mapnote=51110630,
		}, {
			"Grind to level 7",
			completion={{level=7}},
			mapzone="Tirisfal Glades",
			level=6,
		}, {
			"Go southwest to "..cl(50,60),
			"	a. Kill Cursed Darkhounds",
			"	b. Get 5 Darkhound Blood",
			completion={{questgoal={"*","Darkhound Blood",5}}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=59911030,
		}, {
			"Go northwest to "..cl(38,57),
			"	a. Talk to Calvin Montague",
			"		i. Accept "..cq("A Rogue's Deal part 2"),
			"		ii. Fight him until he gives up",
			"		iii. Turn in "..cq("A Rogue's Deal part 2"),
			completion={{questaccepted="A Rogue's Deal part 2"},{questturnedin="A Rogue's Deal part 2"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=56809500,
		}, {
			"Go north to "..cl(37,52),
			"	a. Click the Tirisfal Pumpkins",
			"	b. Get 10 Tirisfal Pumpkins",
			completion={{questgoal={"*","Tirisfal Pumpkin",10}}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=52208940,
		}, {
			"Go northwest to "..cl(33,50),
			"	a. Kill 10 Scarlet Warriors",
			completion={{questgoal={"*","Scarlet Warrior slain",10}}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=50408340,
		}, {
			"Hearth to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=7,
		}, {
			"Go to "..cl(62,52),
			"	a. Talk to Coleman Farthing",
			"		i. Accept "..cq("Deaths in the Family"),
			"		ii. Accept "..cq("The Haunted Mills"),
			completion={{questaccepted="The Haunted Mills"},{questaccepted="Deaths in the Family"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=52311400,
		}, {
			"Go to "..cl(62,53),
			"	a. Talk to Gretchen Dedmar",
			"		i. Accept "..cq("The Chill of Death"),
			completion={{questaccepted="The Chill of Death"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=52711460,
		}, {
			"Go to "..cl(61,52),
			"	a. Talk to Executor Zygand",
			"		i. Turn in "..cq("At War With The Scarlet Crusade part 1"),
			"		ii. Accept "..cq("At War With The Scarlet Crusade part 2"),
			completion={{questturnedin="At War With The Scarlet Crusade part 1"},{questaccepted="At War With The Scarlet Crusade part 2"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=51811240,
		}, {
			"Also at "..cl(61,52),
			"	a. Talk to Deathguard Burgess",
			"		i. Accept "..cq("Proof of Demise"),
			completion={{questaccepted="Proof of Demise"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=52011290,
		}, {
			"Go to "..cl(59,52),
			"	a. Talk to Apothecary Johaan",
			"		i. Turn in "..cq("Fields of Grief part 1"),
			"		ii. Accept "..cq("Fields of Grief part 2"),
			"		iii. Turn in "..cq("A New Plague part 1"),
			"		iv. Accept "..cq("A New Plague part 2"),
			completion={{questturnedin="Fields of Grief part 1"},{questturnedin="A New Plague part 1"},{questaccepted="A New Plague part 2"},{questaccepted="Fields of Grief part 2"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=52411180,
		}, {
			"Go inside the inn",
			"	a. Go to the basement",
			completion={{location={mapzone="Tirisfal Glades",x=61.6,y=51.6, dist=0.2}}},
			mapzone="Tirisfal Glades",
			level=7,
		}, {
			"Go to "..cl(62,51),
			"	a. Talk to Captured Scarlet Zealot",
			"		i. Turn in "..cq("Fields of Grief part 2"),
			completion={{questturnedin="Fields of Grief part 2"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=51311330,
		}, {
			"Go to "..cl(58,51),
			"	a. Talk to Deathguard Dillinger",
			"		i. Turn in "..cq("A Putrid Task"),
			"		ii. Accept "..cq("The Mills Overrun"),
			completion={{questturnedin="A Putrid Task"},{questaccepted="The Mills Overrun"}},
			mapzone="Tirisfal Glades",
			level=7,
			mapnote=51410960,
		}, {
			"Grind to level 8",
			completion={{level=8}},
			mapzone="Tirisfal Glades",
			level=7,
		}, {
			"Go north to "..cl(57,41),
			"	a. Kill 8 Rot Hide Graverobbers",
			"	b. Click the Doom Weeds",
			"	c. Get 10 Doom Weeds",
			completion={{questgoal={"*","Rot Hide Graverobber slain",8}},{questgoal={"*","Doom Weed",10}}},
			mapzone="Tirisfal Glades",
			level=8,
			mapnote=41109860,
		}, {
			"Go north to "..cl(58,35),
			"	a. Kill 5 Rot Hide Mongrels",
			"	b. Kill Rot Hide gnolls",
			"	c. Get 8 Embalming Ichor",
			completion={{questgoal={"*","Rot Hide Mongrel slain",5}},{questgoal={"*","Embalming Ichor",8}}},
			mapzone="Tirisfal Glades",
			level=8,
			mapnote=35309360,
		}, {
			"Go north to "..cl(59,30),
			"	a. Kill Maggot Eye",
			"	b. Get Maggot Eye's Paw",
			completion={{questgoal={"*","Maggot Eye's Paw",1}}},
			mapzone="Tirisfal Glades",
			level=8,
			mapnote=30708940,
		}, {
			"Go east to "..cl(60,30),
			"	a. Kill murlocs",
			"	b. Get 5 Vile Fin Scales",
			completion={{questgoal={"*","Vile Fin Scale",5}}},
			mapzone="Tirisfal Glades",
			level=8,
			mapnote=29909010,
		}, {
			"Go southeast to "..cl(65,34),
			"	a. Kill bats",
			"	b. Get 5 Duskbat Pelts",
			completion={{questgoal={"*","Duskbat Pelt",5}}},
			mapzone="Tirisfal Glades",
			level=8,
			mapnote=33709840,
		}, {
			"Grind to level 9",
			completion={{level=9}},
			mapzone="Tirisfal Glades",
			level=8,
		}, {
			"Go southwest to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=9,
		}, {
			"Go to "..cl(61,52),
			"	a. Talk to Abigail Shiel",
			"		i. Buy 1 Coarse Thread",
			completion={{item={"Coarse Thread",1}}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=52411340,
		}, {
			"Also at "..cl(61,52),
			"	a. Talk to Executor Zygand",
			"		i. Turn in "..cq("Wanted: Maggot Eye"),
			completion={{questturnedin="Wanted: Maggot Eye"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=51811240,
		}, {
			"Go to "..cl(62,53),
			"	a. Talk to Gretchen Dedmar",
			"		i. Turn in "..cq("The Chill of Death"),
			completion={{questturnedin="The Chill of Death"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=52711460,
		}, {
			"Go to "..cl(61,51),
			"	a. Talk to Magistrate Sevren",
			"		i. Turn in "..cq("Graverobbers"),
			"		ii. Accept "..cq("Forsaken Duties"),
			completion={{questturnedin="Graverobbers"},{questaccepted="Forsaken Duties"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=50811210,
		}, {
			"Go to "..cl(59,52),
			"	a. Talk to Apothecary Johaan",
			"		i. Turn in "..cq("A New Plague part 2"),
			"		ii. Accept "..cq("A New Plague part 3"),
			completion={{questturnedin="A New Plague part 2"},{questaccepted="A New Plague part 3"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=52411180,
		}, {
			"Go to "..cl(57,49),
			"	a. Talk to Junior Apothecary Holland",
			"		i. Turn in "..cq("Doom Weed"),
			completion={{questturnedin="Doom Weed"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=48710630,
		}, {
			"Go northwest to "..cl(47,42),
			"	a. Kill Devlin Agamand",
			"	b. Get Devlin's Remains",
			completion={{questgoal={"*","Devlin's Remains",1}}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=42008950,
		}, {
			"Go east to "..cl(48,42),
			"	a. Kill Rattlecage Soldiers",
			"	b. Get 5 Notched Ribs",
			"	c. Kill Darkeye Bonecasters",
			"	d. Get 3 Blackened Skulls",
			"	e. Kill skeletons",
			"	f. Get A Letter to Yvette",
			"	g. Click the Letter to Yvette",
			"		i. Accept "..cq("A Letter Undelivered"),
			completion={{questgoal={"*","Notched Rib",5}},{questgoal={"*","Blackened Skull",3}},{questaccepted="A Letter Undelivered"}},
			mapzone="Tirisfal Glades",
			level=9,
			mapnote=42109050,
		}, {
			"Grind to level 10",
			completion={{level=10}},
			mapzone="Tirisfal Glades",
			level=9,
		}, {
			"Go northeast to "..cl(49,36),
			"	a. Kill Nissa Agamand",
			"	b. Get Nissa's Remains",
			completion={{questgoal={"*","Nissa's Remains",1}}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=36108560,
		}, {
			"Go northwest to "..cl(46,32),
			"	a. Kill Gregor Agamand",
			"	b. Get Gregor's Remains",
			completion={{questgoal={"*","Gregor's Remains",1}}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=31807780,
		}, {
			"Go southwest to "..cl(44,36),
			"	a. Kill Thurman Agamand",
			"	b. Get Thurman's Remains",
			completion={{questgoal={"*","Thurman's Remains",1}}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=36007990,
		}, {
			"Hearth to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=10,
		}, {
			"Go to "..cl(62,52),
			"	a. Talk to Coleman Farthing",
			"		i. Turn in "..cq("Deaths in the Family"),
			"		ii. Turn in "..cq("The Haunted Mills"),
			"		iii. Accept "..cq("Speak with Sevren"),
			completion={{questturnedin="Deaths in the Family"},{questturnedin="The Haunted Mills"},{questaccepted="Speak with Sevren"}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=52311400,
		}, {
			"Go to "..cl(62,53),
			"	a. Talk to Yvette Farthling",
			"		i. Turn in "..cq("A Letter Undelivered"),
			completion={{questturnedin="A Letter Undelivered"}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=52611420,
		}, {
			"Go to "..cl(61,51),
			"	a. Talk to Magistrate Sevren",
			"		i. Turn in "..cq("Speak with Sevren"),
			completion={{questturnedin="Speak with Sevren"}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=50811210,
		}, {
			"Go to "..cl(58,51),
			"	a. Talk to Deathguard Dillinger",
			"		i. Turn in "..cq("The Mills Overrun"),
			completion={{questturnedin="The Mills Overrun"}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=51410960,
		}, {
			"Go southeast to "..cl(65,60),
			"	a. Talk to Deathguard Linnea",
			"		i. Turn in "..cq("Forsaken Duties"),
			"		ii. Accept "..cq("Return to the Magistrate"),
			"		iii. Accept "..cq("Rear Guard Patrol"),
			completion={{questturnedin="Forsaken Duties"},{questaccepted="Rear Guard Patrol"},{questaccepted="Return to the Magistrate"}},
			mapzone="Tirisfal Glades",
			level=10,
			mapnote=60312590,
		}, {
			"Grind to level 11",
			completion={{level=11}},
			mapzone="Tirisfal Glades",
			level=10,
		}, {
			"Go east to "..cl(75,61),
			"	a. Kill 8 Bleeding Horrors",
			"	b. Kill 8 Wandering Spirits",
			completion={{questgoal={"*","Bleeding Horror slain",8}},{questgoal={"*","Wandering Spirit slain",8}}},
			mapzone="Tirisfal Glades",
			level=11,
			mapnote=61513620,
		}, {
			"Go west to "..cl(65,60),
			"	a. Talk to Deathguard Linnea",
			"		i. Turn in "..cq("Rear Guard Patrol"),
			completion={{questturnedin="Rear Guard Patrol"}},
			mapzone="Tirisfal Glades",
			level=11,
			mapnote=60312590,
		}, {
			"Go northwest to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=11,
		}, {
			"Go to "..cl(61,51),
			"	a. Talk to Magistrate Sevren",
			"		i. Turn in "..cq("Return to the Magistrate"),
			completion={{questturnedin="Return to the Magistrate"}},
			mapzone="Tirisfal Glades",
			level=11,
			mapnote=50811210,
		}, {
			"Go southwest to "..cl(53,66),
			"	a. Kill 3 Scarlet Zealots",
			"	b. Kill 3 Scarlet Missionaries",
			"	c. Kill Scarlet mobs",
			"	d. Get 10 Scarlet Insignia Rings",
			completion={{questgoal={"*","Scarlet Zealot slain",3}},{questgoal={"*","Scarlet Missionary slain",3}},{questgoal={"*","Scarlet Insignia Ring",10}}},
			mapzone="Tirisfal Glades",
			level=11,
			mapnote=65811890,
		}, {
			"Go southwest to "..cl(51,68),
			"	a. Kill Captain Perrine",
			completion={{questgoal={"*","Captain Perrine slain",1}}},
			mapzone="Tirisfal Glades",
			level=11,
			mapnote=67911900,
		}, {
			"Grind to level 12",
			completion={{level=12}},
			mapzone="Tirisfal Glades",
			level=11,
		}, {
			"Go northeast to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=12,
		}, {
			"Go to "..cl(61,52),
			"	a. Talk to Executor Zygand",
			"		i. Turn in "..cq("At War With The Scarlet Crusade part 2"),
			"		ii. Accept "..cq("At War With The Scarlet Crusade part 3"),
			completion={{questturnedin="At War With The Scarlet Crusade part 2"},{questaccepted="At War With The Scarlet Crusade part 3"}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=51811240,
		}, {
			"Also at "..cl(61,52),
			"	a. Talk to Deathguard Burgess",
			"		i. Turn in "..cq("Proof of Demise"),
			completion={{questturnedin="Proof of Demise"}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=52011290,
		}, {
			"Go east to "..cl(76,54),
			"	a. Kill 5 Scarlet Friars",
			completion={{questgoal={"*","Scarlet Friar slain",5}}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=54313050,
		}, {
			"Go southeast to "..cl(79,56),
			"	a. Kill Captain Vachon",
			completion={{questgoal={"*","Captain Vachon slain",1}}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=56013480,
		}, {
			"Go northeast to "..cl(82,54),
			"	a. Kill Vicious Night Web Spiders",
			"	b. Get 4 Vicious Night Web Spider Venom",
			completion={{questgoal={"*","Vicious Night Web Spider Venom",4}}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=54313660,
		}, {
			"Hearth to Brill",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=52.4, dist=3}}},
			mapzone="Tirisfal Glades",
			level=12,
		}, {
			"Go to "..cl(61,52),
			"	a. Talk to Executor Zygand",
			"		i. Turn in "..cq("At War With The Scarlet Crusade part 3"),
			completion={{questturnedin="At War With The Scarlet Crusade part 3"}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=51811240,
		}, {
			"Go to "..cl(59,52),
			"	a. Talk to Apothecary Johaan",
			"		i. Turn in "..cq("A New Plague part 3"),
			"		ii. Accept "..cq("A New Plague part 4"),
			completion={{questturnedin="A New Plague part 3"},{questaccepted="A New Plague part 4"}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=52411180,
		}, {
			"Go to "..cl(62,51),
			"	a. Talk to the Captured Mountaineer",
			"		i. Turn in "..cq("A New Plague part 4"),
			completion={{questturnedin="A New Plague part 4"}},
			mapzone="Tirisfal Glades",
			level=12,
			mapnote=51311330,
		}, {
			"Grind to level 13",
			completion={{level=13}},
			mapzone="Tirisfal Glades",
			level=12,
		}, {
			"Go south to "..cl(61,59),
			"	a. Ride the zeppelin to Orgrimmar",
			completion={{location={mapzone="Durotar",x=50.8,y=13.2, dist=1}}},
			mapzone="Tirisfal Glades",
			level=13,
			mapnote=58811960,
		}, {
			"Go northwest to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=13,
		}, {
			"Go to "..cl(45,64),
			"	a. Talk to Doras",
			"		i. Get the Orgrimmar Flight Path",
			completion={{flightpath="Orgrimmar"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=63910900,
		}, {
			"Go outside of Orgrimmar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=13,
		}, {
			"Go southeast to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=13,
		}, {
			"Go to "..cl(51,44),
			"	a. Talk to Takrin Pathseeker",
			"		i. Accept "..cq("Conscript of the Horde"),
			completion={{questaccepted="Conscript of the Horde"}},
			mapzone="Durotar",
			level=13,
			mapnote=43609440,
		}, {
			"Go west to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Durotar",
			level=13,
		}
	  },
	},
	{ sectiontitle = "Tauren (1-13)",
	  defaultfor = "Tauren",
	  nextsection = 6,
	  steps = {
		{
			"Go to "..cl(45,77),
			"	a. Talk to Grull Hawkwind",
			"		i. Accept "..cq("The Hunt Begins"),
			completion={{questaccepted="The Hunt Begins"}},
			mapzone="Mulgore",
			level=1,
			mapnote=77112200,
		}, {
			"Go to "..cl(44,76),
			"	a. Talk to Chief Hawkwind",
			"		i. Accept "..cq("A Humble Task part 1"),
			completion={{questaccepted="A Humble Task part 1"}},
			mapzone="Mulgore",
			level=1,
			mapnote=76112030,
		}, {
			"Go south to "..cl(46,79),
			"	a. Kill plainstriders",
			"	b. Get 7 Plainstrider Meat",
			"	c. Get 7 Plainstrider Feather",
			completion={{questgoal={"*","Plainstrider Meat",7}},{questgoal={"*","Plainstrider Feather",7}}},
			mapzone="Mulgore",
			level=1,
			mapnote=79412500,
		}, {
			"Grind to level 2",
			completion={{level=2}},
			mapzone="Mulgore",
			level=1,
		}, {
			"Go north to "..cl(45,77),
			"	a. Talk to Grull Hawkwind",
			"		i. Turn in "..cq("The Hunt Begins"),
			"		ii. Accept "..cq("The Hunt Continues"),
			completion={{questturnedin="The Hunt Begins"},{questaccepted="The Hunt Continues"}},
			mapzone="Mulgore",
			level=2,
			mapnote=77112200,
		}, {
			"Go southeast to "..cl(50,81),
			"	a. Talk to Greatmother Hawkwind",
			"		i. Turn in "..cq("A Humble Task part 1"),
			"		ii. Accept "..cq("A Humble Task part 2"),
			"	b. Click a little Water Pitcher sitting on the windmill",
			completion={{questturnedin="A Humble Task part 1"},{questaccepted="A Humble Task part 2"},{questgoal={"*","Water Pitcher",1}}},
			mapzone="Mulgore",
			level=2,
			mapnote=81213120,
		}, {
			"Go northwest to "..cl(44,76),
			"	a. Talk to Chief Hawkwind",
			"		i. Turn in "..cq("A Humble Task part 2"),
			"		ii. Accept "..cq("Rites of the Earthmother part 1"),
			completion={{questturnedin="A Humble Task part 2"},{questaccepted="Rites of the Earthmother part 1"}},
			mapzone="Mulgore",
			level=2,
			mapnote=76112030,
		}, {
			"Grind to level 3",
			completion={{level=3}},
			mapzone="Mulgore",
			level=2,
		}, {
			"Go south to "..cl(45,88),
			"	a. Kill Mountain Cougars",
			"	b. Get 10 Mountain Cougar Pelts",
			completion={{questgoal={"*","Mountain Cougar Pelt",10}}},
			mapzone="Mulgore",
			level=3,
			mapnote=88113320,
		}, {
			"Grind to level 4",
			completion={{level=4}},
			mapzone="Mulgore",
			level=3,
		}, {
			"Go southwest to "..cl(43,92),
			"	a. Talk to Seer Graytongue",
			"		i. Turn in "..cq("Rites of the Earthmother part 1"),
			"		ii. Accept "..cq("Rite of Strength"),
			completion={{questturnedin="Rites of the Earthmother part 1"},{questaccepted="Rite of Strength"}},
			mapzone="Mulgore",
			level=4,
			mapnote=92213480,
		}, {
			"Go northeast to "..cl(45,77),
			"	a. Talk to Grull Hawkwind",
			"		i. Turn in "..cq("The Hunt Continues"),
			"		ii. Accept "..cq("The Battleboars"),
			completion={{questturnedin="The Hunt Continues"},{questaccepted="The Battleboars"}},
			mapzone="Mulgore",
			level=4,
			mapnote=77112200,
		}, {
			"Go to "..cl(45,77),
			"	a. Talk to Brave Windfeather",
			"		i. Accept "..cq("Break Sharptusk!"),
			completion={{questaccepted="Break Sharptusk!"}},
			mapzone="Mulgore",
			level=4,
			mapnote=76712130,
		}, {
			"Go east to "..cl(52,79),
			"	a. Kill Battleboars",
			"	b. Get 8 Battleboar Snouts",
			"	c. Get 8 Battleboar Flanks",
			completion={{questgoal={"*","Battleboar Snout",8}},{questgoal={"*","Battleboar Flank",8}}},
			mapzone="Mulgore",
			level=4,
			mapnote=78813110,
		}, {
			"Go southeast to "..cl(58,85),
			"	a. Kill quilboars",
			"	b. Get 12 Bristleback Belts",
			completion={{questgoal={"*","Bristleback Belt",12}}},
			mapzone="Mulgore",
			level=4,
			mapnote=84914310,
		}, {
			"Grind to level 5",
			completion={{level=5}},
			mapzone="Mulgore",
			level=4,
		}, {
			"Go northeast to "..cl(65,78),
			"	a. Kill Chief Sharptusk Thornmantle",
			"	b. Get Chief Sharptusk Thornmantle's Head",
			completion={{questgoal={"*","Chief Sharptusk Thornmantle's Head",1}}},
			mapzone="Mulgore",
			level=5,
			mapnote=77714240,
		}, {
			"Hearth to Camp Narache",
			completion={{location={mapzone="Mulgore",x=44.8,y=76.8, dist=2}}},
			mapzone="Mulgore",
			level=5,
		}, {
			"Go to "..cl(45,77),
			"	a. Talk to Grull Hawkwind",
			"		i. Turn in "..cq("The Battleboars"),
			completion={{questturnedin="The Battleboars"}},
			mapzone="Mulgore",
			level=5,
			mapnote=77112200,
		}, {
			"Also at "..cl(45,77),
			"	a. Talk to Brave Windfeather",
			"		i. Turn in "..cq("Break Sharptusk!"),
			completion={{questturnedin="Break Sharptusk!"}},
			mapzone="Mulgore",
			level=5,
			mapnote=76712130,
		}, {
			"Go to "..cl(44,76),
			"	a. Talk to Chief Hawkwind",
			"		i. Turn in "..cq("Rite of Strength"),
			"		ii. Accept "..cq("Rites of the Earthmother part 2"),
			completion={{questturnedin="Rite of Strength"},{questaccepted="Rites of the Earthmother part 2"}},
			mapzone="Mulgore",
			level=5,
			mapnote=76112030,
		}, {
			"Grind to level 6",
			completion={{level=6}},
			mapzone="Mulgore",
			level=5,
		}, {
			"Go southwest to "..cl(39,82),
			"	a. Talk to Antur Fallow",
			"		i. Accept "..cq("A Task Unfinished"),
			completion={{questaccepted="A Task Unfinished"}},
			mapzone="Mulgore",
			level=6,
			mapnote=81612010,
		}, {
			"Go northeast to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=6,
		}, {
			"Go to "..cl(47,62),
			"	a. Talk to Ruul Eagletalon",
			"		i. Accept "..cq("Dangers of the Windfury"),
			completion={{questaccepted="Dangers of the Windfury"}},
			mapzone="Mulgore",
			level=6,
			mapnote=62010940,
		}, {
			"Go to "..cl(48,60),
			"	a. Talk to Baine Bloodhoof",
			"		i. Turn in "..cq("Rites of the Earthmother part 2"),
			"		ii. Accept "..cq("Sharing the Land"),
			"		iii. Accept "..cq("Rite of Vision part 1"),
			"		iv. Accept "..cq("Dwarven Digging"),
			completion={{questturnedin="Rites of the Earthmother part 2"},{questaccepted="Dwarven Digging"},{questaccepted="Sharing the Land"},{questaccepted="Rite of Vision part 1"}},
			mapzone="Mulgore",
			level=6,
			mapnote=60210770,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Accept "..cq("Poison Water"),
			completion={{questaccepted="Poison Water"}},
			mapzone="Mulgore",
			level=6,
			mapnote=60410890,
		}, {
			"Go to "..cl(49,59),
			"	a. Talk to Harken Windtotem",
			"		i. Accept "..cq("Swoop Hunting"),
			completion={{questaccepted="Swoop Hunting"}},
			mapzone="Mulgore",
			level=6,
			mapnote=59310800,
		}, {
			"Go to "..cl(48,58),
			"	a. Talk to Zarlman Two-Moons",
			"		i. Turn in "..cq("Rite of Vision part 1"),
			"		ii. Accept "..cq("Rite of Vision part 2"),
			completion={{questturnedin="Rite of Vision part 1"},{questaccepted="Rite of Vision part 2"}},
			mapzone="Mulgore",
			level=6,
			mapnote=57510530,
		}, {
			"Go to "..cl(47,57),
			"	a. Talk to Maur Raincaller",
			"		i. Accept "..cq("Mazzranache"),
			completion={{questaccepted="Mazzranache"}},
			mapzone="Mulgore",
			level=6,
			mapnote=57110410,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Innkeeper Kauth",
			"		i. Turn in "..cq("A Task Unfinished"),
			completion={{questturnedin="A Task Unfinished"}},
			mapzone="Mulgore",
			level=6,
			mapnote=61110770,
		}, {
			"Make Bloodhoof Village your home",
			completion={{home="Bloodhoof Village"}},
			mapzone="Mulgore",
			level=6,
		}, {
			"As you do quests around Mulgore:",
			"	a. Kill wolves",
			"		i. Get a Prairie Wolf Heart",
			"	b. Kill cougars",
			"		i. Get a Flatland Cougar Femur",
			"	c. Kill plainstriders",
			"		i. Get a Plainstrider Scale",
			"	d. Kill swoops",
			"		i. Get a Swoop Gizzard",
			completion={{questgoal={"*","Prairie Wolf Heart",1}},{questgoal={"*","Flatland Cougar Femur",1}},{questgoal={"*","Plainstrider Scale",1}},{questgoal={"*","Swoop Gizzard",1}}},
			mapzone="Mulgore",
			level=6,
			mapnote=71412750,
		}, {
			"Go east to "..cl(52,64),
			"	a. Click the little brown pine cones on the ground",
			"	b. Get 2 Ambercorns",
			completion={{questgoal={"*","Ambercorn",2}}},
			mapzone="Mulgore",
			level=6,
			mapnote=63611560,
		}, {
			"Go southeast to "..cl(53,66),
			"	a. Click the flat grey rocks laying around the well",
			"	b. Get 2 Well Stones",
			completion={{questgoal={"*","Well Stone",2}}},
			mapzone="Mulgore",
			level=6,
			mapnote=65711900,
		}, {
			"Go southwest to "..cl(52,67),
			"	a. Kill wolves",
			"	b. Get 6 Prairie Wolf Paws",
			"	c. Kill plainstriders",
			"	d. Get 4 Plainstrider Talons",
			completion={{questgoal={"*","Prairie Wolf Paw",6}},{questgoal={"*","Plainstrider Talon",4}}},
			mapzone="Mulgore",
			level=6,
			mapnote=66911890,
		}, {
			"Grind to level 7",
			completion={{level=7}},
			mapzone="Mulgore",
			level=6,
		}, {
			"Go south to "..cl(53,71),
			"	a. Kill 10 Palemane Tanners",
			"	b. Kill 8 Palemane Skinners",
			"	c. Kill 5 Palemane Poachers",
			completion={{questgoal={"*","Palemane Tanner slain",10}},{questgoal={"*","Palemane Skinner slain",8}},{questgoal={"*","Palemane Poacher slain",5}}},
			mapzone="Mulgore",
			level=7,
			mapnote=71212400,
		}, {
			"Go east to "..cl(56,71),
			"	a. Kill swoops",
			"	b. Get 8 Trophy Swoop Quills",
			completion={{questgoal={"*","Trophy Swoop Quill",8}}},
			mapzone="Mulgore",
			level=7,
			mapnote=71412750,
		}, {
			"Grind to level 8",
			completion={{level=8}},
			mapzone="Mulgore",
			level=7,
		}, {
			"Go west to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=8,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Poison Water"),
			"		ii. Accept "..cq("Winterhoof Cleansing"),
			completion={{questturnedin="Poison Water"},{questaccepted="Winterhoof Cleansing"}},
			mapzone="Mulgore",
			level=8,
			mapnote=60410890,
		}, {
			"Go to "..cl(49,59),
			"	a. Talk to Harken Windtotem",
			"		i. Turn in "..cq("Swoop Hunting"),
			completion={{questturnedin="Swoop Hunting"}},
			mapzone="Mulgore",
			level=8,
			mapnote=59310800,
		}, {
			"Go to "..cl(48,60),
			"	a. Talk to Baine Bloodhoof",
			"		i. Turn in "..cq("Sharing the Land"),
			completion={{questturnedin="Sharing the Land"}},
			mapzone="Mulgore",
			level=8,
			mapnote=60210770,
		}, {
			"Go to "..cl(48,58),
			"	a. Talk to Zarlman Two-Moons",
			"		i. Turn in "..cq("Rite of Vision part 2"),
			"		ii. Accept "..cq("Rite of Vision part 3"),
			completion={{questturnedin="Rite of Vision part 2"},{questaccepted="Rite of Vision part 3"}},
			mapzone="Mulgore",
			level=8,
			mapnote=57510530,
		}, {
			"Go to "..cl(47,57),
			"	a. Talk to Maur Raincaller",
			"		i. Turn in "..cq("Mazzranache"),
			completion={{questturnedin="Mazzranache"}},
			mapzone="Mulgore",
			level=8,
			mapnote=57110410,
		}, {
			"Go southeast to "..cl(54,66),
			"	a. Stand next to the windmill",
			"	b. Use your Winterhoof Cleansing Totem",
			"	c. Cleanse the Winterhoof Water Well",
			completion={{questgoal={"*","Cleanse the Winterhoof Water Well",1}}},
			mapzone="Mulgore",
			level=8,
			mapnote=66211990,
		}, {
			"Go northwest to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=8,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Winterhoof Cleansing"),
			"		ii. Accept "..cq("Thunderhorn Totem"),
			completion={{questturnedin="Winterhoof Cleansing"},{questaccepted="Thunderhorn Totem"}},
			mapzone="Mulgore",
			level=8,
			mapnote=60410890,
		}, {
			"Go to "..cl(48,57),
			"	a. Stand next to the bonfire",
			"	b. Use the Water of the Seers in your bags",
			mapzone="Mulgore",
			level=8,
		}, {
			"Follow the ghost wolf northwest to "..cl(33,36),
			"	a. Talk to Seer Wiserunner",
			"		i. Turn in "..cq("Rite of Vision part 3"),
			completion={{questturnedin="Rite of Vision part 3"}},
			mapzone="Mulgore",
			level=8,
			mapnote=36106880,
		}, {
			"Go east to "..cl(35,36),
			"	a. Kill Flatland Cougars",
			"	b. Get 6 Cougar Claws",
			"	c. Kill Prairie Stalkers",
			"	d. Get 6 Stalker Claws",
			completion={{questgoal={"*","Cougar Claws",6}},{questgoal={"*","Stalker Claws",6}}},
			mapzone="Mulgore",
			level=8,
			mapnote=35807120,
		}, {
			"Grind to level 9",
			completion={{level=9}},
			mapzone="Mulgore",
			level=8,
		}, {
			"Go south to "..cl(35,47),
			"	a. Kill dwarves",
			"	b. Get 5 Prospector's Picks",
			completion={{item={"Prospector's Pick",5}}},
			mapzone="Mulgore",
			level=9,
			mapnote=60410890,
		}, {
			"Go southwest to "..cl(31,50),
			"	a. Stand next to the forge",
			"	b. Click the 5 Prospector's Picks in your bags to break them",
			"	c. Get 5 Broken Tools",
			completion={{questgoal={"*","Broken Tools",5}}},
			mapzone="Mulgore",
			level=9,
			mapnote=46908160,
		}, {
			"Hearth to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=9,
		}, {
			"Go to "..cl(48,60),
			"	a. Talk to Baine Bloodhoof",
			"		i. Turn in "..cq("Dwarven Digging"),
			completion={{questturnedin="Dwarven Digging"}},
			mapzone="Mulgore",
			level=9,
			mapnote=60210770,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Thunderhorn Totem"),
			"		ii. Accept "..cq("Thunderhorn Cleansing"),
			completion={{questturnedin="Thunderhorn Totem"},{questaccepted="Thunderhorn Cleansing"}},
			mapzone="Mulgore",
			level=9,
			mapnote=60410890,
		}, {
			"Go to "..cl(48,53),
			"	a. Talk to Ahab Wheathoof",
			"		i. Accept "..cq("Kyle's Gone Missing!"),
			completion={{questaccepted="Kyle's Gone Missing!"}},
			mapzone="Mulgore",
			level=9,
			mapnote=53310150,
		}, {
			"Go northwest to "..cl(46,46),
			"	a. Kill plainstriders",
			"	b. Get a Tender Strider Meat",
			completion={{item={"Tender Strider Meat",1}}},
			mapzone="Mulgore",
			level=9,
			mapnote=46409220,
		}, {
			"Go northwest to "..cl(44,45),
			"	a. Stand next to the windmill",
			"	b. Use your Thunderhorn Cleansing Totem",
			"	c. Cleanse the Thunderhorn Water Well",
			completion={{questgoal={"*","Cleanse the Thunderhorn Water Well",1}}},
			mapzone="Mulgore",
			level=9,
			mapnote=45408990,
		}, {
			"Go southeast to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=9,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Thunderhorn Cleansing"),
			"		ii. Accept "..cq("Wildmane Totem"),
			completion={{questturnedin="Thunderhorn Cleansing"},{questaccepted="Wildmane Totem"}},
			mapzone="Mulgore",
			level=9,
			mapnote=60410890,
		}, {
			"Go southeast to "..cl(49,61),
			"	a. Kyle is a wolf that runs in a circle in this area",
			"	b. Use the Tender Wolf Steak in your bags when Kyle gets near you",
			"	c. Feed Kyle",
			completion={{questgoal={"*","Kyle Fed",1}}},
			mapzone="Mulgore",
			level=9,
			mapnote=61311060,
		}, {
			"Go to "..cl(48,53),
			"	a. Talk to Ahab Wheathoof",
			"		i. Turn in "..cq("Kyle's Gone Missing!"),
			completion={{questturnedin="Kyle's Gone Missing!"}},
			mapzone="Mulgore",
			level=9,
			mapnote=53310150,
		}, {
			"Grind to level 10",
			completion={{level=10}},
			mapzone="Mulgore",
			level=9,
		}, {
			"Go to east to "..cl(59,62),
			"	a. Talk to Morin Cloudstalker",
			"		i. Accept "..cq("The Ravaged Caravan part 1"),
			completion={{questaccepted="The Ravaged Caravan part 1"}},
			mapzone="Mulgore",
			level=10,
			mapnote=62212150,
		}, {
			"Go northeast to "..cl(54,48),
			"	a. Click the Sealed Supply Crate",
			"		i. Turn in "..cq("The Ravaged Caravan part 1"),
			"		ii. Accept "..cq("The Ravaged Caravan part 2"),
			completion={{questturnedin="The Ravaged Caravan part 1"},{questaccepted="The Ravaged Caravan part 2"}},
			mapzone="Mulgore",
			level=10,
			mapnote=48210190,
		}, {
			"Go southeast to "..cl(59,62),
			"	a. Talk to Morin Cloudstalker",
			"		i. Turn in "..cq("The Ravaged Caravan part 2"),
			"		ii. Accept "..cq("The Venture Co."),
			"		iii. Accept "..cq("Supervisor Fizsprocket"),
			completion={{questturnedin="The Ravaged Caravan part 2"},{questaccepted="Supervisor Fizsprocket"},{questaccepted="The Venture Co."}},
			mapzone="Mulgore",
			level=10,
			mapnote=62212150,
		}, {
			"Go east to "..cl(63,62),
			"	a. Kill Prairie Wolf Alphas",
			"	b. Get 8 Prairie Alpha Teeth",
			completion={{questgoal={"*","Prairie Alpha Tooth",8}}},
			mapzone="Mulgore",
			level=10,
			mapnote=61712490,
		}, {
			"Go southeast to "..cl(66,69),
			"	a. Kill harpies",
			"	b. Get 8 Windfury Talons",
			completion={{questgoal={"*","Windfury Talon",8}}},
			mapzone="Mulgore",
			level=10,
			mapnote=68813500,
		}, {
			"Hearth to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Mulgore",
			level=10,
		}, {
			"Go to "..cl(47,60),
			"	a. Talk to Skorn Whitecloud",
			"		i. Accept "..cq("The Hunter's Way"),
			completion={{questaccepted="The Hunter's Way"}},
			mapzone="Mulgore",
			level=10,
			mapnote=60210700,
		}, {
			"Go to "..cl(47,62),
			"	a. Talk to Ruul Eagletalon",
			"		i. Turn in "..cq("Dangers of the Windfury"),
			completion={{questturnedin="Dangers of the Windfury"}},
			mapzone="Mulgore",
			level=10,
			mapnote=62010940,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Wildmane Totem"),
			"		ii. Accept "..cq("Wildmane Cleansing"),
			completion={{questturnedin="Wildmane Totem"},{questaccepted="Wildmane Cleansing"}},
			mapzone="Mulgore",
			level=10,
			mapnote=60410890,
		}, {
			"Grind to level 11",
			completion={{level=11}},
			mapzone="Mulgore",
			level=10,
		}, {
			"Go northeast to "..cl(59,49),
			"	a. Kill 14 Venture Co. Workers",
			"	b. Kill 6 Venture Co. Supervisors",
			completion={{questgoal={"*","Venture Co. Worker slain",14}},{questgoal={"*","Venture Co. Supervisor slain",6}}},
			mapzone="Mulgore",
			level=11,
			mapnote=48810800,
		}, {
			"Go up the hill and into the mine",
			completion={{location={mapzone="Mulgore",x=61.4,y=47.3, dist=0.3}}},
			mapzone="Mulgore",
			level=11,
		}, {
			"Go northeast into the mine to "..cl(64,43),
			"	a. Keep heading right inside the mine and you will run into him",
			"	b. Kill Supervisor Fizsprocket",
			"	c. Get Fizsprocket's Clipboard",
			completion={{questgoal={"*","Fizsprocket's Clipboard",1}}},
			mapzone="Mulgore",
			level=11,
			mapnote=43510790,
		}, {
			"Go southwest to "..cl(59,62),
			"	a. Talk to Morin Cloudstalker",
			"		i. Turn in "..cq("The Venture Co."),
			"		ii. Turn in "..cq("Supervisor Fizsprocket"),
			completion={{questturnedin="The Venture Co."},{questturnedin="Supervisor Fizsprocket"}},
			mapzone="Mulgore",
			level=11,
			mapnote=62212150,
		}, {
			"Go northwest to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Mulgore",
			level=11,
		}, {
			"Go to "..cl(38,60),
			"	a. Talk to Eyahn Eagletalon",
			"		i. Accept "..cq("Preparation for Ceremony"),
			completion={{questaccepted="Preparation for Ceremony"}},
			mapzone="Thunder Bluff",
			level=11,
			mapnote=59609730,
		}, {
			"Leave Thunder Bluff",
			completion={{location={mapzone="Mulgore"}}},
			mapzone="Thunder Bluff",
			level=11,
		}, {
			"Go to "..cl(45,16),
			"	a. Kill Flatland Prowlers",
			"	b. Get 4 Flatland Prowler Claws",
			completion={{questgoal={"*","Flatland Prowler Claw",4}}},
			mapzone="Mulgore",
			level=11,
			mapnote=16506160,
		}, {
			"Go northwest to "..cl(43,14),
			"	a. Stand next to the windmill",
			"	b. Use your Wildmane Cleansing Totem",
			"	c. Cleanse the Wildmane Well",
			completion={{questgoal={"*","Cleanse the Wildmane Well",1}}},
			mapzone="Mulgore",
			level=11,
			mapnote=14105680,
		}, {
			"Go southwest to "..cl(32,21),
			"	a. Kill harpies",
			"	b. Get 6 Azure Feathers",
			"	c. Get 6 Bronze Feathers",
			completion={{questgoal={"*","Azure Feather",6}},{questgoal={"*","Bronze Feather",6}}},
			mapzone="Mulgore",
			level=11,
			mapnote=21305300,
		}, {
			"Grind to level 12",
			completion={{level=12}},
			mapzone="Mulgore",
			level=11,
		}, {
			"Go southeast to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Mulgore",
			level=12,
		}, {
			"Go to "..cl(38,60),
			"	a. Talk to Eyahn Eagletalon",
			"		i. Turn in "..cq("Preparation for Ceremony"),
			completion={{questturnedin="Preparation for Ceremony"}},
			mapzone="Thunder Bluff",
			level=11,
			mapnote=59609730,
		}, {
			"Go to "..cl(62,81),
			"	a. Talk to Melor Stonehoof",
			"		i. Turn in "..cq("The Hunter's Way"),
			"		ii. Accept "..cq("Sergra Darkthorn"),
			completion={{questturnedin="The Hunter's Way"},{questaccepted="Sergra Darkthorn"}},
			mapzone="Thunder Bluff",
			level=11,
			mapnote=80914240,
		}, {
			"Hearth to Bloodhoof Village",
			completion={{location={mapzone="Mulgore",x=47.2,y=59.5, dist=4}}},
			mapzone="Thunder Bluff",
			level=11,
		}, {
			"Go to "..cl(49,60),
			"	a. Talk to Mull Thunderhorn",
			"		i. Turn in "..cq("Wildmane Cleansing"),
			completion={{questturnedin="Wildmane Cleansing"}},
			mapzone="Mulgore",
			level=12,
			mapnote=60410890,
		}, {
			"Grind to level 13",
			completion={{level=13}},
			mapzone="Mulgore",
			level=12,
		}, {
			"Go east to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Mulgore",
			level=13,
		}, {
			"Go east to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go to "..cl(44,59),
			"	a. Talk to Kirge Sternhorn",
			"		i. Accept "..cq("Journey to the Crossroads"),
			completion={{questaccepted="Journey to the Crossroads"}},
			mapzone="The Barrens",
			level=13,
			mapnote=58610350,
		}, {
			"Go northeast to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("Sergra Darkthorn"),
			completion={{questturnedin="Sergra Darkthorn"}},
			mapzone="The Barrens",
			level=13,
			mapnote=31008320,
		}, {
			"Go to "..cl(51,31),
			"	a. Talk to Thork",
			"		i. Turn in "..cq("Journey to the Crossroads"),
			completion={{questturnedin="Journey to the Crossroads"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30908240,
		}, {
			"Go to "..cl(52,30),
			"	a. Talk to Devrak",
			"		i. Get the Crossroads Flight Path",
			completion={{flightpath="Crossroads"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30308180,
		}, {
			"Go northeast to Durotar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go northeast to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=13,
		}, {
			"Go to "..cl(45,64),
			"	a. Talk to Doras",
			"		i. Get the Orgrimmar Flight Path",
			completion={{flightpath="Orgrimmar"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=63910900,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Orgrimmar",
			level=13,
		}
	  },
	},
	{ sectiontitle = "Orc (1-13)",
	  defaultfor = "Orc",
	  nextsection = 6,
	  steps = {
		{
			"Go to "..cl(43,69),
			"	a. Talk to Kaltunk",
			"		i. Accept "..cq("Your Place In The World"),
			completion={{questaccepted="Your Place In The World"}},
			mapzone="Durotar",
			level=1,
			mapnote=68511180,
		}, {
			"Also at "..cl(43,69),
			"	a. Talk to Ruzan",
			"		i. Accept "..cq("Vile Familiars part 1"),
			completion={{questaccepted="Vile Familiars part 1"}},
			mapzone="Durotar",
			level=1,
			mapnote=69011160,
		}, {
			"Go west to 42,68 inside the cave",
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Your Place In The World"),
			"		ii. Accept "..cq("Cutting Teeth"),
			completion={{questturnedin="Your Place In The World"},{questaccepted="Cutting Teeth"}},
			mapzone="Durotar",
			level=1,
			mapnote=68311040,
		}, {
			"Go southeast to "..cl(44,70),
			"	a. Kill 10 Mottled Boars",
			completion={{questgoal={"*","Mottled Boar slain",10}}},
			mapzone="Durotar",
			level=1,
			mapnote=70011380,
		}, {
			"Go northwest into the cave to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Cutting Teeth"),
			"		ii. Accept "..cq("Sting of the Scorpid"),
			completion={{questturnedin="Cutting Teeth"},{questaccepted="Sting of the Scorpid"}},
			mapzone="Durotar",
			level=1,
			mapnote=68311040,
		}, {
			"Go northeast to "..cl(43,67),
			"	a. Talk to Galgar",
			"		i. Accept "..cq("Galgar's Cactus Apple Surprise"),
			completion={{questaccepted="Galgar's Cactus Apple Surprise"}},
			mapzone="Durotar",
			level=1,
			mapnote=67210990,
		}, {
			"Grind to level 3",
			completion={{level=3}},mapzone="Durotar",
			level=2,			
		}, {
			"Go southeast to "..cl(45,71),
			"	a. Kill Scorpid Workers",
			"	b. Get 10 Scorpid Worker Tails",
			completion={{questgoal={"*","Scorpid Worker Tail",10}}},
			mapzone="Durotar",
			level=3,
			mapnote=70911560,
		}, {
			"Grind to level 4",
			completion={{level=4}},
			mapzone="Durotar",
			level=3,			
		}, {
			"Go northwest into the cave to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Sting of the Scorpid"),
			completion={{questturnedin="Sting of the Scorpid"}},
			mapzone="Durotar",
			level=4,
			mapnote=68311040,
		}, {
			"Go east to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Accept "..cq("Lazy Peons"),
			completion={{questaccepted="Lazy Peons"}},
			mapzone="Durotar",
			level=4,
			mapnote=68611320,
		}, {
			"Go east to "..cl(45,70),
			"	a. Start here and head south along the Cliffside",
			"	b. Use your Foreman's Blackjack on Lazy Peons",
			"		i. They are sleeping under the trees",
			"	c. Awaken 5 Peons",
			completion={{questgoal={"*","Peons Awoken",5}}},
			mapzone="Durotar",
			level=4,
			mapnote=69911520,
		}, {
			"Go to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Turn in "..cq("Lazy Peons"),
			"		ii. Accept "..cq("Thazz'ril's Pick"),
			completion={{questturnedin="Lazy Peons"},{questaccepted="Thazz'ril's Pick"}},
			mapzone="Durotar",
			level=4,
			mapnote=68611320,
		}, {
			"Go north to "..cl(44,65),
			"	a. They look liked small cactuses with little pink apples on them",
			"	b. Click the Cactus Apples",
			"	c. Get 10 Cactus Apples",
			completion={{questgoal={"*","Cactus Apple",10}}},
			mapzone="Durotar",
			level=4,
			mapnote=65410950,
		}, {
			"Go northeast to "..cl(46,59),
			"	a. Kill Vile Familiars",
			"	b. Get 6 Vile Familiar Heads",
			completion={{questgoal={"*","Vile Familiar Head",6}}},
			mapzone="Durotar",
			level=4,
			mapnote=59310510,
		}, {
			"Go inside the cave",
			"	a. Follow the path to the left",
			completion={{location={mapzone="Durotar",x=44.2,y=55.2, dist=0.3}}},
			mapzone="Durotar",
			level=4,			
		}, {
			"Go to "..cl(44,54),
			"	a. Click Thazz'ril's Pick",
			"	b. Get Thazz'ril's Pick",
			completion={{questgoal={"*","Thazz'ril's Pick",1}}},
			mapzone="Durotar",
			level=4,
			mapnote=53809760,
		}, {
			"Grind to level 5",
			completion={{level=5}},
			mapzone="Durotar",
			level=4,			
		}, {
			"Leave the cave",
			completion={{location={mapzone="Durotar",x=45.3,y=56.7, dist=0.5}}},
			mapzone="Durotar",
			level=5,			
		}, {
			"Go southwest to "..cl(41,63),
			"	a. Talk to Hana'zua",
			"		i. Accept "..cq("Sarkoth part 1"),
			completion={{questaccepted="Sarkoth part 1"}},
			mapzone="Durotar",
			level=5,
			mapnote=62610320,
		}, {
			"Go south to "..cl(41,67),
			"	a. Kill Sarkoth",
			"	b. Get Sarkoth's Mangled Claw",
			completion={{questgoal={"*","Sarkoth's Mangled Claw",1}}},
			mapzone="Durotar",
			level=5,
			mapnote=66610720,
		}, {
			"Go north to "..cl(41,63),
			"	a. Talk to Hana'zua",
			"		i. Turn in "..cq("Sarkoth part 1"),
			"		ii. Accept "..cq("Sarkoth part 2"),
			completion={{questturnedin="Sarkoth part 1"},{questaccepted="Sarkoth part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=62610320,
		}, {
			"Go southeast to "..cl(43,67),
			"	a. Talk to Galgar",
			"		i. Turn in "..cq("Galgar's Cactus Apple Surprise"),
			completion={{questturnedin="Galgar's Cactus Apple Surprise"}},
			mapzone="Durotar",
			level=5,
			mapnote=67210990,
		}, {
			"Go to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Sarkoth part 2"),
			completion={{questturnedin="Sarkoth part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=68311040,
		}, {
			"Go to "..cl(43,69),
			"	a. Talk to Ruzan",
			"		i. Turn in "..cq("Vile Familiars part 1"),
			"		ii. Accept "..cq("Vile Familiars part 2"),
			completion={{questturnedin="Vile Familiars part 1"},{questaccepted="Vile Familiars part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=69011160,
		}, {
			"Also at "..cl(43,69),
			"	a. Talk to Zureetha Fargaze",
			"		i. Turn in "..cq("Vile Familiars part 2"),
			"		ii. Accept "..cq("Burning Blade Medallion"),
			completion={{questturnedin="Vile Familiars part 2"},{questaccepted="Burning Blade Medallion"}},
			mapzone="Durotar",
			level=5,
			mapnote=69111190,
		}, {
			"Go east to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Turn in "..cq("Thazz'ril's Pick"),
			completion={{questturnedin="Thazz'ril's Pick"}},
			mapzone="Durotar",
			level=5,
			mapnote=68611320,
		}, {
			"Grind to level 6",
			completion={{level=6}},
			mapzone="Durotar",
			level=5,			
		}, {
			"Go north to "..cl(45,56),
			"	a. Go inside the cave",
			"	b. Follow the path to the right",
			completion={{location={mapzone="Durotar",x=45.3,y=56.7, dist=0.5}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(43,53),
			"	a. Kill Yarrog Boneshadow",
			"	b. Get the Burning Blade Medallion",
			completion={{questgoal={"*","Burning Blade Medallion",1}}},
			mapzone="Durotar",
			level=6,
			mapnote=53009570,
		}, {
			"Hearth to the Valley of Trials",
			completion={{location={mapzone="Durotar",x=43.3,y=68.8, dist=3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(43,69),
			"	a. Talk to Zureetha Fargaze",
			"		i. Turn in "..cq("Burning Blade Medallion"),
			"		ii. Accept "..cq("Report to Sen'jin Village"),
			completion={{questturnedin="Burning Blade Medallion"},{questaccepted="Report to Sen'jin Village"}},
			mapzone="Durotar",
			level=6,
			mapnote=69111190,
		}, {
			"Go east along the road through the big gate",
			completion={{location={mapzone="Durotar",x=49.8,y=68.4, dist=0.3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(52,68),
			"	a. Talk to Ukor",
			"		i. Accept "..cq("A Peon's Burden"),
			completion={{questaccepted="A Peon's Burden"}},
			mapzone="Durotar",
			level=6,
			mapnote=68312040,
		}, {
			"Go southeast to "..cl(54,73),
			"	a. Talk to Lar Prowltusk",
			"		i. Accept "..cq("Thwarting Kolkar Aggression"),
			completion={{questaccepted="Thwarting Kolkar Aggression"}},
			mapzone="Durotar",
			level=6,
			mapnote=73312750,
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Gadrin",
			"		i. Turn in "..cq("Report to Sen'jin Village"),
			"		ii. Accept "..cq("Minshina's Skull"),
			"		iii. Accept "..cq("Zalazane"),
			"		iv. Accept "..cq("Report to Orgnil"),
			"	b. Talk to Master Vornal",
			"		i. Accept "..cq("A Solvent Spirit"),
			completion={{questturnedin="Report to Sen'jin Village"},{questaccepted="Minshina's Skull"},{questaccepted="Zalazane"},{questaccepted="Report to Orgnil"},{questaccepted="A Solvent Spirit"}},
			mapzone="Durotar",
			level=6,
			mapnote=74513040,
		}, {
			"Go to "..cl(56,74),
			"	a. Talk to Vel'rin Fang",
			"		i. Accept "..cq("Practical Prey"),
			completion={{questaccepted="Practical Prey"}},
			mapzone="Durotar",
			level=6,
			mapnote=74012990,
		}, {
			"Go north to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Orgnil Soulscar",
			"		i. Turn in "..cq("Report to Orgnil"),
			"		ii. Accept "..cq("Dark Storms"),
			completion={{questturnedin="Report to Orgnil"},{questaccepted="Dark Storms"}},
			mapzone="Durotar",
			level=6,
			mapnote=43209540,
		}, {
			"Also at "..cl(52,43),
			"	a. Talk to Gar'Thok",
			"		i. Accept "..cq("Vanquish the Betrayers"),
			"		ii. Accept "..cq("Encroachment"),
			completion={{questaccepted="Encroachment"},{questaccepted="Vanquish the Betrayers"}},
			mapzone="Durotar",
			level=6,
			mapnote=43509540,
		}, {
			"Go to "..cl(51,42),
			"	a. Talk to Cook Torka",
			"		i. Accept "..cq("Break a Few Eggs"),
			completion={{questaccepted="Break a Few Eggs"}},
			mapzone="Durotar",
			level=6,
			mapnote=42409350,
		}, {
			"Go to "..cl(52,42),
			"	a. Talk to Innkeeper Grosk",
			"		i. Turn in "..cq("A Peon's Burden"),
			completion={{questturnedin="A Peon's Burden"}},
			mapzone="Durotar",
			level=6,
			mapnote=41609310,
		}, {
			"Make Razor Hill your home",
			completion={{home="Razor Hill"}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(50,40),
			"	a. Talk to Furl Scornbrow",
			"		i. Accept "..cq("Carry Your Weight"),
			completion={{questaccepted="Carry Your Weight"}},
			mapzone="Durotar",
			level=6,
			mapnote=40409030,
		}, {
			"Grind to level 7",
			completion={{level=7}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go southeast to "..cl(55,51),
			"	a. Kill 10 Kul Tiras Sailors",
			"	b. Kill 8 Kul Tiras Marines",
			"	c. Kill Kul Tiras mobs",
			"	d. Get 8 Canvas Scraps",
			completion={{questgoal={"*","Kul Tiras Sailor slain",10}},{questgoal={"*","Kul Tiras Marine slain",8}},{questgoal={"*","Canvas Scraps",8}}},
			mapzone="Durotar",
			level=7,
			mapnote=51210670,
		}, {
			"Go southeast to 60,58 upstairs in the fort",
			"	a. Kill Lieutenant Benedict",
			"	b. Get Benedict's Key",
			completion={{questgoal={"*","Lieutenant Benedict slain",1}},{questgoal={"*","Benedict's Key",1}}},
			mapzone="Durotar",
			level=7,
			mapnote=58311800,
		}, {
			"Leave the room and run across the hall and up the wooden steps",
			completion={{location={mapzone="Durotar",x=60.0,y=57.6, dist=0.3}}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(59,58),
			"	a. Open Benedict's Chest",
			"	b. Get the Aged Envelope",
			"	c. Click the Aged Envelope",
			"		i. Accept "..cq("The Admiral's Orders part 1"),
			completion={{questaccepted="The Admiral's Orders part 1"}},
			mapzone="Durotar",
			level=7,
			mapnote=57711700,
		}, {
			"Go northwest to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(52,44),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("Vanquish the Betrayers"),
			"		ii. Accept "..cq("From The Wreckage...."),
			"		iii. Turn in "..cq("The Admiral's Orders part 1"),
			"		iv. Accept "..cq("The Admiral's Orders part 2"),
			completion={{questturnedin="Vanquish the Betrayers"},{questturnedin="The Admiral's Orders part 1"},{questaccepted="The Admiral's Orders part 2"},{questaccepted="From The Wreckage...."}},
			mapzone="Durotar",
			level=7,
			mapnote=43509540,
		}, {
			"Grind to level 8",
			completion={{level=8}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(50,40),
			"	a. Talk to Furl Scornbrow",
			"		i. Turn in "..cq("Carry Your Weight"),
			completion={{questturnedin="Carry Your Weight"}},
			mapzone="Durotar",
			level=8,
			mapnote=40409030,
		}, {
			"Go east to "..cl(61,47),
			"	a. Kill Pygmy Surf Crawlers",
			"	b. Get 8 Crawler Mucus",
			"	c. Kill Makrura Shellhides",
			"	d. Get 4 Intact Makrura Eyes",
			"	e. Click the Gnomish Toolboxes",
			"	f. Get 3 Gnomish Tools",
			completion={{questgoal={"*","Crawler Mucus",8}},{questgoal={"*","Intact Makrura Eye",4}},{questgoal={"*","Gnomish Tools",3}}},
			mapzone="Durotar",
			level=8,
			mapnote=46910770,
		}, {
			"Go west to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=8,			
		}, {
			"Go to "..cl(52,44),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("From The Wreckage...."),
			completion={{questturnedin="From The Wreckage...."}},
			mapzone="Durotar",
			level=8,
			mapnote=43509540,
		}, {
			"Go southwest to "..cl(45,49),
			"	a. Kill 4 Razormane Quilboars",
			"	b. Kill 4 Razormane Scouts",
			completion={{questgoal={"*","Razormane Quilboar slain",4}},{questgoal={"*","Razormane Scout slain",4}}},
			mapzone="Durotar",
			level=8,
			mapnote=48609320,
		}, {
			"Grind to level 9",
			completion={{level=9}},
			mapzone="Durotar",
			level=8,			
		}, {
			"Go southeast to "..cl(51,79),
			"	a. The path to 'Thwarting Kolkar Aggression' starts here",
			completion={{location={mapzone="Durotar",x=51.3,y=79.1, dist=0.3}}},
			mapzone="Durotar",
			level=9,
			mapnote=79113040,
		}, {
			"Go southwest to "..cl(50,81),
			"	a. Click the Attack Plan: Valley of Trials",
			"	b. Destroy the Attack Plan: Valley of Trials",
			completion={{questgoal={"*","Attack Plan: Valley of Trials destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=81313110,
		}, {
			"Go northwest to "..cl(48,77),
			"	a. Click the Attack Plan: Sen'jin Village",
			"	b. Destroy the Attack Plan: Sen'jin Village",
			completion={{questgoal={"*","Attack Plan: Sen'jin Village destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=77312500,
		}, {
			"Go southwest to "..cl(46,79),
			"	a. Click the Attack Plan: Orgrimmar",
			"	b. Destroy the Attack Plan: Orgrimmar",
			completion={{questgoal={"*","Attack Plan: Orgrimmar destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=78912510,
		}, {
			"Go northeast to Sen'jin Village",
			completion={{location={mapzone="Durotar",x=55.8,y=74.5, dist=2}}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Go to "..cl(54,73),
			"	a. Talk to Lar Prowltusk",
			"		i. Turn in "..cq("Thwarting Kolkar Aggression"),
			completion={{questturnedin="Thwarting Kolkar Aggression"}},
			mapzone="Durotar",
			level=9,
			mapnote=73312750,
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Vornal",
			"		i. Turn in "..cq("A Solvent Spirit"),
			completion={{questturnedin="A Solvent Spirit"}},
			mapzone="Durotar",
			level=9,
			mapnote=74513040,
		}, {
			"Go southeast to "..cl(60,83),
			"	a. Click the purple Taillasher Eggs",
			"	b. Get 3 Taillasher Eggs",
			"	c. Kill Durotar Tigers",
			"	d. Get 4 Durotar Tiger Furs",
			completion={{questgoal={"*","Taillasher Egg",3}},{questgoal={"*","Durotar Tiger Fur",4}}},
			mapzone="Durotar",
			level=9,
			mapnote=82914320,
		}, {
			"Go east to "..cl(65,83),
			"	a. Kill 8 Hexed Trolls",
			"	b. Kill 8 Voodoo Trolls",
			completion={{questgoal={"*","Hexed Troll slain",8}},{questgoal={"*","Voodoo Troll slain",8}}},
			mapzone="Durotar",
			level=9,
			mapnote=83314870,
		}, {
			"Go southeast to "..cl(68,87),
			"	a. Kill Zalazane",
			"	b. Get Zalazane's Head",
			completion={{questgoal={"*","Zalazane's Head",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=86515410,
		}, {
			"Go south to "..cl(67,88),
			"	a. They look like little skulls inside a round demonic symbol up on the hill",
			"	b. Click an Imprisoned Darkspear",
			"	c. Get Minshina's Skull",
			completion={{questgoal={"*","Minshina's Skull",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=87815530,
		}, {
			"Go northwest to Sen'jin Village",
			completion={{location={mapzone="Durotar",x=55.8,y=74.5, dist=2}}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Gadrin",
			"		i. Turn in "..cq("Minshina's Skull"),
			"		ii. Turn in "..cq("Zalazane"),
			completion={{questturnedin="Minshina's Skull"},{questturnedin="Zalazane"}},
			mapzone="Durotar",
			level=9,
			mapnote=74513040,
		}, {
			"Go to "..cl(56,74),
			"	a. Talk to Vel'rin Fang",
			"		i. Turn in "..cq("Practical Prey"),
			completion={{questturnedin="Practical Prey"}},
			mapzone="Durotar",
			level=9,
			mapnote=74012990,
		}, {
			"Grind to level 10",
			completion={{level=10}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=10,			
		}, {
			"Go to "..cl(51,42),
			"	a. Talk to Cook Torka",
			"		i. Turn in "..cq("Break a Few Eggs"),
			completion={{questturnedin="Break a Few Eggs"}},
			mapzone="Durotar",
			level=10,
			mapnote=42409350,
		}, {
			"Go to "..cl(51,44),
			"	a. Talk to Takrin Pathseeker",
			"		i. Accept "..cq("Conscript of the Horde"),
			completion={{questaccepted="Conscript of the Horde"}},
			mapzone="Durotar",
			level=10,
			mapnote=43609440,
		}, {
			"Go northwest to "..cl(45,41),
			"	a. Kill 4 Razormane Dustrunners",
			"	b. Kill 4 Razormane Battleguards",
			completion={{questgoal={"*","Razormane Dustrunner slain",4}},{questgoal={"*","Razormane Battleguard slain",4}}},
			mapzone="Durotar",
			level=10,
			mapnote=41008550,
		}, {
			"Go northwest to "..cl(43,30),
			"	a. Talk to Misha Tor'kren",
			"		i. Accept "..cq("Lost But Not Forgotten"),
			completion={{questaccepted="Lost But Not Forgotten"}},
			mapzone="Durotar",
			level=10,
			mapnote=30207330,
		}, {
			"Go northeast to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Accept "..cq("Winds in the Desert"),
			completion={{questaccepted="Winds in the Desert"}},
			mapzone="Durotar",
			level=10,
			mapnote=22906930,
		}, {
			"Go southeast to "..cl(51,32),
			"	a. The path to 'Winds in the Desert' starts here",
			completion={{location={mapzone="Durotar",x=50.7,y=31.7, dist=0.3}}},
			mapzone="Durotar",
			level=10,
			mapnote=31608240,
		}, {
			"Go southwest to "..cl(49,34),
			"	a. They look like small tan bags",
			"	b. Click the Stolen Supply Sacks",
			"	c. Get 5 Sacks of Supplies",
			completion={{questgoal={"*","Sack of Supplies",5}}},
			mapzone="Durotar",
			level=10,
			mapnote=33508210,
		}, {
			"Go northwest to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Turn in "..cq("Winds in the Desert"),
			"		ii. Accept "..cq("Securing the Lines"),
			completion={{questturnedin="Winds in the Desert"},{questaccepted="Securing the Lines"}},
			mapzone="Durotar",
			level=10,
			mapnote=22906930,
		}, {
			"Go southeast to "..cl(52,27),
			"	a. The path to 'Securing the Lines' starts here",
			completion={{location={mapzone="Durotar",x=51.7,y=27.3, dist=0.3}}},
			mapzone="Durotar",
			level=10,
			mapnote=27407910,
		}, {
			"Go east to "..cl(54,27),
			"	a. Kill 12 Dustwind Savages",
			"	b. Kill 8 Dustwind Storm Witches",
			completion={{questgoal={"*","Dustwind Savage slain",12}},{questgoal={"*","Dustwind Storm Witch slain",8}}},
			mapzone="Durotar",
			level=10,
			mapnote=26908100,
		}, {
			"Grind to level 11",
			completion={{level=11}},
			mapzone="Durotar",
			level=10,			
		}, {
			"Go south to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("Encroachment"),
			completion={{questturnedin="Encroachment"}},
			mapzone="Durotar",
			level=11,
			mapnote=43509540,
		}, {
			"Go northwest to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Turn in "..cq("Securing the Lines"),
			completion={{questturnedin="Securing the Lines"}},
			mapzone="Durotar",
			level=11,
			mapnote=22906930,
		}, {
			"Go northwest to "..cl(42,19),
			"	a. Talk to Rhinag",
			"		i. Accept "..cq("Need for a Cure"),
			completion={{questaccepted="Need for a Cure"}},
			mapzone="Durotar",
			level=11,
			mapnote=18606010,
		}, {
			"Go northeast to Orgimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(47,54),
			"	a. Talk to Kor'ghan",
			"		i. Accept "..cq("Finding the Antidote"),
			completion={{questaccepted="Finding the Antidote"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=53610080,
		}, {
			"Go southwest to "..cl(40,21),
			"	a. Kill scorpions",
			"	b. Get 4 Venomtail Poison Sacs",
			completion={{questgoal={"*","Venomtail Poison Sac",4}}},
			mapzone="Durotar",
			level=11,
			mapnote=20906080,
		}, {
			"Go northeast to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(47,54),
			"	a. Talk to Kor'ghan",
			"		i. Turn in "..cq("Finding the Antidote"),
			completion={{questturnedin="Finding the Antidote"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=53610080,
		}, {
			"Go to "..cl(34,36),
			"	a. Talk to Vol'jin",
			"		i. Turn in "..cq("The Admiral's Orders"),
			completion={{questturnedin="The Admiral's Orders"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=36307060,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Accept "..cq("Hidden Enemies part 1"),
			completion={{questaccepted="Hidden Enemies part 1"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=37806960,
		}, {
			"Go southwest to "..cl(42,19),
			"	a. Talk to Rhinag",
			"		i. Turn in "..cq("Need for a Cure"),
			completion={{questturnedin="Need for a Cure"}},
			mapzone="Durotar",
			level=11,
			mapnote=18606010,
		}, {
			"Grind to level 12",
			completion={{level=12}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go west to "..cl(37,17),
			"	a. Kill crocolisks in the river",
			"	b. Get Kron's Amulet",
			completion={{questgoal={"*","Kron's Amulet",1}}},
			mapzone="Durotar",
			level=12,
			mapnote=17405460,
		}, {
			"Go southeast to "..cl(39,33),
			"	a. The path to 'Dark Storms' and 'Hidden Enemies' starts here",
			completion={{location={mapzone="Durotar",x=39.2,y=32.5, dist=0.5}}},
			mapzone="Durotar",
			level=12,
			mapnote=32507170,
		}, {
			"Go northeast to "..cl(42,27),
			"	a. Kill Fizzle Darkstorm",
			"	b. Get Fizzle's Claw",
			"	c. Kill Burning Blade mobs",
			"	d. Get a Lieutenant's Insignia",
			completion={{questgoal={"*","Fizzle's Claw",1}},{questgoal={"*","Lieutenant's Insignia",1}}},
			mapzone="Durotar",
			level=12,
			mapnote=26606870,
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=12,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Orgnil Soulscar",
			"		i. Turn in "..cq("Dark Storms"),
			"		ii. Accept "..cq("Margoz"),
			completion={{questturnedin="Dark Storms"},{questaccepted="Margoz"}},
			mapzone="Durotar",
			level=12,
			mapnote=43209540,
		}, {
			"Go northwest to "..cl(43,30),
			"	a. Talk to Misha Tor'kren",
			"		i. Turn in "..cq("Lost But Not Forgotten"),
			completion={{questturnedin="Lost But Not Forgotten"}},
			mapzone="Durotar",
			level=12,
			mapnote=30207330,
		}, {
			"Go northeast to "..cl(56,20),
			"	a. Talk to Margoz",
			"		i. Turn in "..cq("Margoz"),
			"		ii. Accept "..cq("Skull Rock"),
			completion={{questturnedin="Margoz"},{questaccepted="Skull Rock"}},
			mapzone="Durotar",
			level=12,
			mapnote=20007640,
		}, {
			"Go north to "..cl(55,10),
			"	a. Kill Burning Blade mobs inside the cave",
			"	b. Get 6 Searing Collars",
			completion={{questgoal={"*","Searing Collar",6}}},
			mapzone="Durotar",
			level=12,
			mapnote=10106520,
		}, {
			"Go south to "..cl(56,20),
			"	a. Talk to Margoz",
			"		i. Turn in "..cq("Skull Rock"),
			"		ii. Accept "..cq("Neeru Fireblade"),
			completion={{questturnedin="Skull Rock"},{questaccepted="Neeru Fireblade"}},
			mapzone="Durotar",
			level=12,
			mapnote=20007640,
		}, {
			"Grind to level 13",
			completion={{level=13}},
			mapzone="Durotar",
			level=12,			
		}, {
			"Go to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=13,			
		}, {
			"Go to "..cl(49,51),
			"	a. Talk to Neeru Fireblade",
			"		i. Turn in "..cq("Neeru Fireblade"),
			"		ii. Accept "..cq("Ak'Zeloth"),
			completion={{questturnedin="Neeru Fireblade"},{questaccepted="Ak'Zeloth"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=50610010,
		}, {
			"Go to "..cl(39,38),
			"	a. Talk to Zor Lonetree",
			"		i. Accept "..cq("The Spirits of Stonetalon"),
			completion={{questaccepted="The Spirits of Stonetalon"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=38407730,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Turn in "..cq("Hidden Enemies part 1"),
			"		ii. Accept "..cq("Hidden Enemies part 2"),
			completion={{questturnedin="Hidden Enemies part 1"},{questaccepted="Hidden Enemies part 2"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=37806960,
		}, {
			"Go to "..cl(49,51),
			"	a. Talk to Neeru Fireblade",
			"	b. Click "..cq("You may speak frankly, Neeru..."),
			"	c. Continue talking to him",
			"	d. Gauge Neeru Fireblade's reaction to your being a member of the Burning Blade",
			completion={{questgoal={"*","Gauge Neeru Fireblade's reaction to you being a member of the Burning Blade",1}}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=50610010,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Turn in "..cq("Hidden Enemies part 2"),
			completion={{questturnedin="Hidden Enemies part 2"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=37806960,
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Orgrimmar",
			level=13,			
		}, {
			"Go west to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Durotar",
			level=13,
		}
	  },
	},
	{ sectiontitle = "Troll (1-13)",
	  defaultfor = "Troll",
	  nextsection = 6,
	  steps = {
		{
			"Go to "..cl(43,69),
			"	a. Talk to Kaltunk",
			"		i. Accept "..cq("Your Place In The World"),
			completion={{questaccepted="Your Place In The World"}},
			mapzone="Durotar",
			level=1,
			mapnote=68511180,
		}, {
			"Also at "..cl(43,69),
			"	a. Talk to Ruzan",
			"		i. Accept "..cq("Vile Familiars part 1"),
			completion={{questaccepted="Vile Familiars part 1"}},
			mapzone="Durotar",
			level=1,
			mapnote=69011160,
		}, {
			"Go west to 42,68 inside the cave",
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Your Place In The World"),
			"		ii. Accept "..cq("Cutting Teeth"),
			completion={{questturnedin="Your Place In The World"},{questaccepted="Cutting Teeth"}},
			mapzone="Durotar",
			level=1,
			mapnote=68311040,
		}, {
			"Go southeast to "..cl(44,70),
			"	a. Kill 10 Mottled Boars",
			completion={{questgoal={"*","Mottled Boar slain",10}}},
			mapzone="Durotar",
			level=1,
			mapnote=70011380,
		}, {
			"Go northwest into the cave to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Cutting Teeth"),
			"		ii. Accept "..cq("Sting of the Scorpid"),
			completion={{questturnedin="Cutting Teeth"},{questaccepted="Sting of the Scorpid"}},
			mapzone="Durotar",
			level=1,
			mapnote=68311040,
		}, {
			"Go northeast to "..cl(43,67),
			"	a. Talk to Galgar",
			"		i. Accept "..cq("Galgar's Cactus Apple Surprise"),
			completion={{questaccepted="Galgar's Cactus Apple Surprise"}},
			mapzone="Durotar",
			level=1,
			mapnote=67210990,
		}, {
			"Grind to level 3",
			completion={{level=3}},mapzone="Durotar",
			level=2,			
		}, {
			"Go southeast to "..cl(45,71),
			"	a. Kill Scorpid Workers",
			"	b. Get 10 Scorpid Worker Tails",
			completion={{questgoal={"*","Scorpid Worker Tail",10}}},
			mapzone="Durotar",
			level=3,
			mapnote=70911560,
		}, {
			"Grind to level 4",
			completion={{level=4}},
			mapzone="Durotar",
			level=3,			
		}, {
			"Go northwest into the cave to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Sting of the Scorpid"),
			completion={{questturnedin="Sting of the Scorpid"}},
			mapzone="Durotar",
			level=4,
			mapnote=68311040,
		}, {
			"Go east to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Accept "..cq("Lazy Peons"),
			completion={{questaccepted="Lazy Peons"}},
			mapzone="Durotar",
			level=4,
			mapnote=68611320,
		}, {
			"Go east to "..cl(45,70),
			"	a. Start here and head south along the Cliffside",
			"	b. Use your Foreman's Blackjack on Lazy Peons",
			"		i. They are sleeping under the trees",
			"	c. Awaken 5 Peons",
			completion={{questgoal={"*","Peons Awoken",5}}},
			mapzone="Durotar",
			level=4,
			mapnote=69911520,
		}, {
			"Go to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Turn in "..cq("Lazy Peons"),
			"		ii. Accept "..cq("Thazz'ril's Pick"),
			completion={{questturnedin="Lazy Peons"},{questaccepted="Thazz'ril's Pick"}},
			mapzone="Durotar",
			level=4,
			mapnote=68611320,
		}, {
			"Go north to "..cl(44,65),
			"	a. They look liked small cactuses with little pink apples on them",
			"	b. Click the Cactus Apples",
			"	c. Get 10 Cactus Apples",
			completion={{questgoal={"*","Cactus Apple",10}}},
			mapzone="Durotar",
			level=4,
			mapnote=65410950,
		}, {
			"Go northeast to "..cl(46,59),
			"	a. Kill Vile Familiars",
			"	b. Get 6 Vile Familiar Heads",
			completion={{questgoal={"*","Vile Familiar Head",6}}},
			mapzone="Durotar",
			level=4,
			mapnote=59310510,
		}, {
			"Go inside the cave",
			"	a. Follow the path to the left",
			completion={{location={mapzone="Durotar",x=44.2,y=55.2, dist=0.3}}},
			mapzone="Durotar",
			level=4,			
		}, {
			"Go to "..cl(44,54),
			"	a. Click Thazz'ril's Pick",
			"	b. Get Thazz'ril's Pick",
			completion={{questgoal={"*","Thazz'ril's Pick",1}}},
			mapzone="Durotar",
			level=4,
			mapnote=53809760,
		}, {
			"Grind to level 5",
			completion={{level=5}},
			mapzone="Durotar",
			level=4,			
		}, {
			"Leave the cave",
			completion={{location={mapzone="Durotar",x=45.3,y=56.7, dist=0.5}}},
			mapzone="Durotar",
			level=5,			
		}, {
			"Go southwest to "..cl(41,63),
			"	a. Talk to Hana'zua",
			"		i. Accept "..cq("Sarkoth part 1"),
			completion={{questaccepted="Sarkoth part 1"}},
			mapzone="Durotar",
			level=5,
			mapnote=62610320,
		}, {
			"Go south to "..cl(41,67),
			"	a. Kill Sarkoth",
			"	b. Get Sarkoth's Mangled Claw",
			completion={{questgoal={"*","Sarkoth's Mangled Claw",1}}},
			mapzone="Durotar",
			level=5,
			mapnote=66610720,
		}, {
			"Go north to "..cl(41,63),
			"	a. Talk to Hana'zua",
			"		i. Turn in "..cq("Sarkoth part 1"),
			"		ii. Accept "..cq("Sarkoth part 2"),
			completion={{questturnedin="Sarkoth part 1"},{questaccepted="Sarkoth part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=62610320,
		}, {
			"Go southeast to "..cl(43,67),
			"	a. Talk to Galgar",
			"		i. Turn in "..cq("Galgar's Cactus Apple Surprise"),
			completion={{questturnedin="Galgar's Cactus Apple Surprise"}},
			mapzone="Durotar",
			level=5,
			mapnote=67210990,
		}, {
			"Go to "..cl(42,68),
			"	a. Talk to Gornek",
			"		i. Turn in "..cq("Sarkoth part 2"),
			completion={{questturnedin="Sarkoth part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=68311040,
		}, {
			"Go to "..cl(43,69),
			"	a. Talk to Ruzan",
			"		i. Turn in "..cq("Vile Familiars part 1"),
			"		ii. Accept "..cq("Vile Familiars part 2"),
			completion={{questturnedin="Vile Familiars part 1"},{questaccepted="Vile Familiars part 2"}},
			mapzone="Durotar",
			level=5,
			mapnote=69011160,
		}, {
			"Also at "..cl(43,69),
			"	a. Talk to Zureetha Fargaze",
			"		i. Turn in "..cq("Vile Familiars part 2"),
			"		ii. Accept "..cq("Burning Blade Medallion"),
			completion={{questturnedin="Vile Familiars part 2"},{questaccepted="Burning Blade Medallion"}},
			mapzone="Durotar",
			level=5,
			mapnote=69111190,
		}, {
			"Go east to "..cl(45,69),
			"	a. Talk to Foreman Thazz'ril",
			"		i. Turn in "..cq("Thazz'ril's Pick"),
			completion={{questturnedin="Thazz'ril's Pick"}},
			mapzone="Durotar",
			level=5,
			mapnote=68611320,
		}, {
			"Grind to level 6",
			completion={{level=6}},
			mapzone="Durotar",
			level=5,			
		}, {
			"Go north to "..cl(45,56),
			"	a. Go inside the cave",
			"	b. Follow the path to the right",
			completion={{location={mapzone="Durotar",x=45.3,y=56.7, dist=0.5}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(43,53),
			"	a. Kill Yarrog Boneshadow",
			"	b. Get the Burning Blade Medallion",
			completion={{questgoal={"*","Burning Blade Medallion",1}}},
			mapzone="Durotar",
			level=6,
			mapnote=53009570,
		}, {
			"Hearth to the Valley of Trials",
			completion={{location={mapzone="Durotar",x=43.3,y=68.8, dist=3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(43,69),
			"	a. Talk to Zureetha Fargaze",
			"		i. Turn in "..cq("Burning Blade Medallion"),
			"		ii. Accept "..cq("Report to Sen'jin Village"),
			completion={{questturnedin="Burning Blade Medallion"},{questaccepted="Report to Sen'jin Village"}},
			mapzone="Durotar",
			level=6,
			mapnote=69111190,
		}, {
			"Go east along the road through the big gate",
			completion={{location={mapzone="Durotar",x=49.8,y=68.4, dist=0.3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(52,68),
			"	a. Talk to Ukor",
			"		i. Accept "..cq("A Peon's Burden"),
			completion={{questaccepted="A Peon's Burden"}},
			mapzone="Durotar",
			level=6,
			mapnote=68312040,
		}, {
			"Go southeast to "..cl(54,73),
			"	a. Talk to Lar Prowltusk",
			"		i. Accept "..cq("Thwarting Kolkar Aggression"),
			completion={{questaccepted="Thwarting Kolkar Aggression"}},
			mapzone="Durotar",
			level=6,
			mapnote=73312750,
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Gadrin",
			"		i. Turn in "..cq("Report to Sen'jin Village"),
			"		ii. Accept "..cq("Minshina's Skull"),
			"		iii. Accept "..cq("Zalazane"),
			"		iv. Accept "..cq("Report to Orgnil"),
			"	b. Talk to Master Vornal",
			"		i. Accept "..cq("A Solvent Spirit"),
			completion={{questturnedin="Report to Sen'jin Village"},{questaccepted="Minshina's Skull"},{questaccepted="Zalazane"},{questaccepted="Report to Orgnil"},{questaccepted="A Solvent Spirit"}},
			mapzone="Durotar",
			level=6,
			mapnote=74513040,
		}, {
			"Go to "..cl(56,74),
			"	a. Talk to Vel'rin Fang",
			"		i. Accept "..cq("Practical Prey"),
			completion={{questaccepted="Practical Prey"}},
			mapzone="Durotar",
			level=6,
			mapnote=74012990,
		}, {
			"Go north to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Orgnil Soulscar",
			"		i. Turn in "..cq("Report to Orgnil"),
			"		ii. Accept "..cq("Dark Storms"),
			completion={{questturnedin="Report to Orgnil"},{questaccepted="Dark Storms"}},
			mapzone="Durotar",
			level=6,
			mapnote=43209540,
		}, {
			"Also at "..cl(52,43),
			"	a. Talk to Gar'Thok",
			"		i. Accept "..cq("Vanquish the Betrayers"),
			"		ii. Accept "..cq("Encroachment"),
			completion={{questaccepted="Encroachment"},{questaccepted="Vanquish the Betrayers"}},
			mapzone="Durotar",
			level=6,
			mapnote=43509540,
		}, {
			"Go to "..cl(51,42),
			"	a. Talk to Cook Torka",
			"		i. Accept "..cq("Break a Few Eggs"),
			completion={{questaccepted="Break a Few Eggs"}},
			mapzone="Durotar",
			level=6,
			mapnote=42409350,
		}, {
			"Go to "..cl(52,42),
			"	a. Talk to Innkeeper Grosk",
			"		i. Turn in "..cq("A Peon's Burden"),
			completion={{questturnedin="A Peon's Burden"}},
			mapzone="Durotar",
			level=6,
			mapnote=41609310,
		}, {
			"Make Razor Hill your home",
			completion={{home="Razor Hill"}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go to "..cl(50,40),
			"	a. Talk to Furl Scornbrow",
			"		i. Accept "..cq("Carry Your Weight"),
			completion={{questaccepted="Carry Your Weight"}},
			mapzone="Durotar",
			level=6,
			mapnote=40409030,
		}, {
			"Grind to level 7",
			completion={{level=7}},
			mapzone="Durotar",
			level=6,			
		}, {
			"Go southeast to "..cl(55,51),
			"	a. Kill 10 Kul Tiras Sailors",
			"	b. Kill 8 Kul Tiras Marines",
			"	c. Kill Kul Tiras mobs",
			"	d. Get 8 Canvas Scraps",
			completion={{questgoal={"*","Kul Tiras Sailor slain",10}},{questgoal={"*","Kul Tiras Marine slain",8}},{questgoal={"*","Canvas Scraps",8}}},
			mapzone="Durotar",
			level=7,
			mapnote=51210670,
		}, {
			"Go southeast to 60,58 upstairs in the fort",
			"	a. Kill Lieutenant Benedict",
			"	b. Get Benedict's Key",
			completion={{questgoal={"*","Lieutenant Benedict slain",1}},{questgoal={"*","Benedict's Key",1}}},
			mapzone="Durotar",
			level=7,
			mapnote=58311800,
		}, {
			"Leave the room and run across the hall and up the wooden steps",
			completion={{location={mapzone="Durotar",x=60.0,y=57.6, dist=0.3}}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(59,58),
			"	a. Open Benedict's Chest",
			"	b. Get the Aged Envelope",
			"	c. Click the Aged Envelope",
			"		i. Accept "..cq("The Admiral's Orders part 1"),
			completion={{questaccepted="The Admiral's Orders part 1"}},
			mapzone="Durotar",
			level=7,
			mapnote=57711700,
		}, {
			"Go northwest to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(52,44),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("Vanquish the Betrayers"),
			"		ii. Accept "..cq("From The Wreckage...."),
			"		iii. Turn in "..cq("The Admiral's Orders part 1"),
			"		iv. Accept "..cq("The Admiral's Orders part 2"),
			completion={{questturnedin="Vanquish the Betrayers"},{questturnedin="The Admiral's Orders part 1"},{questaccepted="The Admiral's Orders part 2"},{questaccepted="From The Wreckage...."}},
			mapzone="Durotar",
			level=7,
			mapnote=43509540,
		}, {
			"Grind to level 8",
			completion={{level=8}},
			mapzone="Durotar",
			level=7,			
		}, {
			"Go to "..cl(50,40),
			"	a. Talk to Furl Scornbrow",
			"		i. Turn in "..cq("Carry Your Weight"),
			completion={{questturnedin="Carry Your Weight"}},
			mapzone="Durotar",
			level=8,
			mapnote=40409030,
		}, {
			"Go east to "..cl(61,47),
			"	a. Kill Pygmy Surf Crawlers",
			"	b. Get 8 Crawler Mucus",
			"	c. Kill Makrura Shellhides",
			"	d. Get 4 Intact Makrura Eyes",
			"	e. Click the Gnomish Toolboxes",
			"	f. Get 3 Gnomish Tools",
			completion={{questgoal={"*","Crawler Mucus",8}},{questgoal={"*","Intact Makrura Eye",4}},{questgoal={"*","Gnomish Tools",3}}},
			mapzone="Durotar",
			level=8,
			mapnote=46910770,
		}, {
			"Go west to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=8,			
		}, {
			"Go to "..cl(52,44),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("From The Wreckage...."),
			completion={{questturnedin="From The Wreckage...."}},
			mapzone="Durotar",
			level=8,
			mapnote=43509540,
		}, {
			"Go southwest to "..cl(45,49),
			"	a. Kill 4 Razormane Quilboars",
			"	b. Kill 4 Razormane Scouts",
			completion={{questgoal={"*","Razormane Quilboar slain",4}},{questgoal={"*","Razormane Scout slain",4}}},
			mapzone="Durotar",
			level=8,
			mapnote=48609320,
		}, {
			"Grind to level 9",
			completion={{level=9}},
			mapzone="Durotar",
			level=8,			
		}, {
			"Go southeast to "..cl(51,79),
			"	a. The path to 'Thwarting Kolkar Aggression' starts here",
			completion={{location={mapzone="Durotar",x=51.3,y=79.1, dist=0.3}}},
			mapzone="Durotar",
			level=9,
			mapnote=79113040,
		}, {
			"Go southwest to "..cl(50,81),
			"	a. Click the Attack Plan: Valley of Trials",
			"	b. Destroy the Attack Plan: Valley of Trials",
			completion={{questgoal={"*","Attack Plan: Valley of Trials destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=81313110,
		}, {
			"Go northwest to "..cl(48,77),
			"	a. Click the Attack Plan: Sen'jin Village",
			"	b. Destroy the Attack Plan: Sen'jin Village",
			completion={{questgoal={"*","Attack Plan: Sen'jin Village destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=77312500,
		}, {
			"Go southwest to "..cl(46,79),
			"	a. Click the Attack Plan: Orgrimmar",
			"	b. Destroy the Attack Plan: Orgrimmar",
			completion={{questgoal={"*","Attack Plan: Orgrimmar destroyed",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=78912510,
		}, {
			"Go northeast to Sen'jin Village",
			completion={{location={mapzone="Durotar",x=55.8,y=74.5, dist=2}}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Go to "..cl(54,73),
			"	a. Talk to Lar Prowltusk",
			"		i. Turn in "..cq("Thwarting Kolkar Aggression"),
			completion={{questturnedin="Thwarting Kolkar Aggression"}},
			mapzone="Durotar",
			level=9,
			mapnote=73312750,
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Vornal",
			"		i. Turn in "..cq("A Solvent Spirit"),
			completion={{questturnedin="A Solvent Spirit"}},
			mapzone="Durotar",
			level=9,
			mapnote=74513040,
		}, {
			"Go southeast to "..cl(60,83),
			"	a. Click the purple Taillasher Eggs",
			"	b. Get 3 Taillasher Eggs",
			"	c. Kill Durotar Tigers",
			"	d. Get 4 Durotar Tiger Furs",
			completion={{questgoal={"*","Taillasher Egg",3}},{questgoal={"*","Durotar Tiger Fur",4}}},
			mapzone="Durotar",
			level=9,
			mapnote=82914320,
		}, {
			"Go east to "..cl(65,83),
			"	a. Kill 8 Hexed Trolls",
			"	b. Kill 8 Voodoo Trolls",
			completion={{questgoal={"*","Hexed Troll slain",8}},{questgoal={"*","Voodoo Troll slain",8}}},
			mapzone="Durotar",
			level=9,
			mapnote=83314870,
		}, {
			"Go southeast to "..cl(68,87),
			"	a. Kill Zalazane",
			"	b. Get Zalazane's Head",
			completion={{questgoal={"*","Zalazane's Head",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=86515410,
		}, {
			"Go south to "..cl(67,88),
			"	a. They look like little skulls inside a round demonic symbol up on the hill",
			"	b. Click an Imprisoned Darkspear",
			"	c. Get Minshina's Skull",
			completion={{questgoal={"*","Minshina's Skull",1}}},
			mapzone="Durotar",
			level=9,
			mapnote=87815530,
		}, {
			"Go northwest to Sen'jin Village",
			completion={{location={mapzone="Durotar",x=55.8,y=74.5, dist=2}}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Go to "..cl(56,75),
			"	a. Talk to Master Gadrin",
			"		i. Turn in "..cq("Minshina's Skull"),
			"		ii. Turn in "..cq("Zalazane"),
			completion={{questturnedin="Minshina's Skull"},{questturnedin="Zalazane"}},
			mapzone="Durotar",
			level=9,
			mapnote=74513040,
		}, {
			"Go to "..cl(56,74),
			"	a. Talk to Vel'rin Fang",
			"		i. Turn in "..cq("Practical Prey"),
			completion={{questturnedin="Practical Prey"}},
			mapzone="Durotar",
			level=9,
			mapnote=74012990,
		}, {
			"Grind to level 10",
			completion={{level=10}},
			mapzone="Durotar",
			level=9,			
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=10,			
		}, {
			"Go to "..cl(51,42),
			"	a. Talk to Cook Torka",
			"		i. Turn in "..cq("Break a Few Eggs"),
			completion={{questturnedin="Break a Few Eggs"}},
			mapzone="Durotar",
			level=10,
			mapnote=42409350,
		}, {
			"Go to "..cl(51,44),
			"	a. Talk to Takrin Pathseeker",
			"		i. Accept "..cq("Conscript of the Horde"),
			completion={{questaccepted="Conscript of the Horde"}},
			mapzone="Durotar",
			level=10,
			mapnote=43609440,
		}, {
			"Go northwest to "..cl(45,41),
			"	a. Kill 4 Razormane Dustrunners",
			"	b. Kill 4 Razormane Battleguards",
			completion={{questgoal={"*","Razormane Dustrunner slain",4}},{questgoal={"*","Razormane Battleguard slain",4}}},
			mapzone="Durotar",
			level=10,
			mapnote=41008550,
		}, {
			"Go northwest to "..cl(43,30),
			"	a. Talk to Misha Tor'kren",
			"		i. Accept "..cq("Lost But Not Forgotten"),
			completion={{questaccepted="Lost But Not Forgotten"}},
			mapzone="Durotar",
			level=10,
			mapnote=30207330,
		}, {
			"Go northeast to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Accept "..cq("Winds in the Desert"),
			completion={{questaccepted="Winds in the Desert"}},
			mapzone="Durotar",
			level=10,
			mapnote=22906930,
		}, {
			"Go southeast to "..cl(51,32),
			"	a. The path to 'Winds in the Desert' starts here",
			completion={{location={mapzone="Durotar",x=50.7,y=31.7, dist=0.3}}},
			mapzone="Durotar",
			level=10,
			mapnote=31608240,
		}, {
			"Go southwest to "..cl(49,34),
			"	a. They look like small tan bags",
			"	b. Click the Stolen Supply Sacks",
			"	c. Get 5 Sacks of Supplies",
			completion={{questgoal={"*","Sack of Supplies",5}}},
			mapzone="Durotar",
			level=10,
			mapnote=33508210,
		}, {
			"Go northwest to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Turn in "..cq("Winds in the Desert"),
			"		ii. Accept "..cq("Securing the Lines"),
			completion={{questturnedin="Winds in the Desert"},{questaccepted="Securing the Lines"}},
			mapzone="Durotar",
			level=10,
			mapnote=22906930,
		}, {
			"Go southeast to "..cl(52,27),
			"	a. The path to 'Securing the Lines' starts here",
			completion={{location={mapzone="Durotar",x=51.7,y=27.3, dist=0.3}}},
			mapzone="Durotar",
			level=10,
			mapnote=27407910,
		}, {
			"Go east to "..cl(54,27),
			"	a. Kill 12 Dustwind Savages",
			"	b. Kill 8 Dustwind Storm Witches",
			completion={{questgoal={"*","Dustwind Savage slain",12}},{questgoal={"*","Dustwind Storm Witch slain",8}}},
			mapzone="Durotar",
			level=10,
			mapnote=26908100,
		}, {
			"Grind to level 11",
			completion={{level=11}},
			mapzone="Durotar",
			level=10,			
		}, {
			"Go south to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Gar'Thok",
			"		i. Turn in "..cq("Encroachment"),
			completion={{questturnedin="Encroachment"}},
			mapzone="Durotar",
			level=11,
			mapnote=43509540,
		}, {
			"Go northwest to "..cl(46,23),
			"	a. Talk to Rezlak",
			"		i. Turn in "..cq("Securing the Lines"),
			completion={{questturnedin="Securing the Lines"}},
			mapzone="Durotar",
			level=11,
			mapnote=22906930,
		}, {
			"Go northwest to "..cl(42,19),
			"	a. Talk to Rhinag",
			"		i. Accept "..cq("Need for a Cure"),
			completion={{questaccepted="Need for a Cure"}},
			mapzone="Durotar",
			level=11,
			mapnote=18606010,
		}, {
			"Go northeast to Orgimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(47,54),
			"	a. Talk to Kor'ghan",
			"		i. Accept "..cq("Finding the Antidote"),
			completion={{questaccepted="Finding the Antidote"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=53610080,
		}, {
			"Go southwest to "..cl(40,21),
			"	a. Kill scorpions",
			"	b. Get 4 Venomtail Poison Sacs",
			completion={{questgoal={"*","Venomtail Poison Sac",4}}},
			mapzone="Durotar",
			level=11,
			mapnote=20906080,
		}, {
			"Go northeast to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go to "..cl(47,54),
			"	a. Talk to Kor'ghan",
			"		i. Turn in "..cq("Finding the Antidote"),
			completion={{questturnedin="Finding the Antidote"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=53610080,
		}, {
			"Go to "..cl(34,36),
			"	a. Talk to Vol'jin",
			"		i. Turn in "..cq("The Admiral's Orders"),
			completion={{questturnedin="The Admiral's Orders"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=36307060,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Accept "..cq("Hidden Enemies part 1"),
			completion={{questaccepted="Hidden Enemies part 1"}},
			mapzone="Orgrimmar",
			level=11,
			mapnote=37806960,
		}, {
			"Go southwest to "..cl(42,19),
			"	a. Talk to Rhinag",
			"		i. Turn in "..cq("Need for a Cure"),
			completion={{questturnedin="Need for a Cure"}},
			mapzone="Durotar",
			level=11,
			mapnote=18606010,
		}, {
			"Grind to level 12",
			completion={{level=12}},
			mapzone="Durotar",
			level=11,			
		}, {
			"Go west to "..cl(37,17),
			"	a. Kill crocolisks in the river",
			"	b. Get Kron's Amulet",
			completion={{questgoal={"*","Kron's Amulet",1}}},
			mapzone="Durotar",
			level=12,
			mapnote=17405460,
		}, {
			"Go southeast to "..cl(39,33),
			"	a. The path to 'Dark Storms' and 'Hidden Enemies' starts here",
			completion={{location={mapzone="Durotar",x=39.2,y=32.5, dist=0.5}}},
			mapzone="Durotar",
			level=12,
			mapnote=32507170,
		}, {
			"Go northeast to "..cl(42,27),
			"	a. Kill Fizzle Darkstorm",
			"	b. Get Fizzle's Claw",
			"	c. Kill Burning Blade mobs",
			"	d. Get a Lieutenant's Insignia",
			completion={{questgoal={"*","Fizzle's Claw",1}},{questgoal={"*","Lieutenant's Insignia",1}}},
			mapzone="Durotar",
			level=12,
			mapnote=26606870,
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=12,			
		}, {
			"Go to "..cl(52,43),
			"	a. Talk to Orgnil Soulscar",
			"		i. Turn in "..cq("Dark Storms"),
			"		ii. Accept "..cq("Margoz"),
			completion={{questturnedin="Dark Storms"},{questaccepted="Margoz"}},
			mapzone="Durotar",
			level=12,
			mapnote=43209540,
		}, {
			"Go northwest to "..cl(43,30),
			"	a. Talk to Misha Tor'kren",
			"		i. Turn in "..cq("Lost But Not Forgotten"),
			completion={{questturnedin="Lost But Not Forgotten"}},
			mapzone="Durotar",
			level=12,
			mapnote=30207330,
		}, {
			"Go northeast to "..cl(56,20),
			"	a. Talk to Margoz",
			"		i. Turn in "..cq("Margoz"),
			"		ii. Accept "..cq("Skull Rock"),
			completion={{questturnedin="Margoz"},{questaccepted="Skull Rock"}},
			mapzone="Durotar",
			level=12,
			mapnote=20007640,
		}, {
			"Go north to "..cl(55,10),
			"	a. Kill Burning Blade mobs inside the cave",
			"	b. Get 6 Searing Collars",
			completion={{questgoal={"*","Searing Collar",6}}},
			mapzone="Durotar",
			level=12,
			mapnote=10106520,
		}, {
			"Go south to "..cl(56,20),
			"	a. Talk to Margoz",
			"		i. Turn in "..cq("Skull Rock"),
			"		ii. Accept "..cq("Neeru Fireblade"),
			completion={{questturnedin="Skull Rock"},{questaccepted="Neeru Fireblade"}},
			mapzone="Durotar",
			level=12,
			mapnote=20007640,
		}, {
			"Grind to level 13",
			completion={{level=13}},
			mapzone="Durotar",
			level=12,			
		}, {
			"Go to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=13,			
		}, {
			"Go to "..cl(49,51),
			"	a. Talk to Neeru Fireblade",
			"		i. Turn in "..cq("Neeru Fireblade"),
			"		ii. Accept "..cq("Ak'Zeloth"),
			completion={{questturnedin="Neeru Fireblade"},{questaccepted="Ak'Zeloth"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=50610010,
		}, {
			"Go to "..cl(39,38),
			"	a. Talk to Zor Lonetree",
			"		i. Accept "..cq("The Spirits of Stonetalon"),
			completion={{questaccepted="The Spirits of Stonetalon"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=38407730,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Turn in "..cq("Hidden Enemies part 1"),
			"		ii. Accept "..cq("Hidden Enemies part 2"),
			completion={{questturnedin="Hidden Enemies part 1"},{questaccepted="Hidden Enemies part 2"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=37806960,
		}, {
			"Go to "..cl(49,51),
			"	a. Talk to Neeru Fireblade",
			"	b. Click "..cq("You may speak frankly, Neeru..."),
			"	c. Continue talking to him",
			"	d. Gauge Neeru Fireblade's reaction to your being a member of the Burning Blade",
			completion={{questgoal={"*","Gauge Neeru Fireblade's reaction to you being a member of the Burning Blade",1}}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=50610010,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Thrall",
			"		i. Turn in "..cq("Hidden Enemies part 2"),
			completion={{questturnedin="Hidden Enemies part 2"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=37806960,
		}, {
			"Hearth to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Orgrimmar",
			level=13,			
		}, {
			"Go west to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Durotar",
			level=13,
		}
	  },
	},
	{ sectiontitle = "Blood Elf (1-13)",
	  defaultfor = "BloodElf",
	  nextsection = 6,
	  steps = {
		{
			"Go to "..cl(38,21),
			"	a. Talk to Magistrix Erona",
			"		i. Accept "..cq("Reclaiming Sunstrider Isle"),
			completion={{questaccepted="Reclaiming Sunstrider Isle"}},
			mapzone="Eversong Woods",
			level=1,
			mapnote=20805900,
		}, {
			"Go west to "..cl(36,20),
			"	a. Kill 8 Mana Wyrms",
			completion={{questgoal={"*","Mana Wyrm slain",8}}},
			mapzone="Eversong Woods",
			level=1,
			mapnote=20505670,
		}, {
			"Grind to level 2",
			completion={{level=2}},
			mapzone="Eversong Woods",
			level=1,
		}, {
			"Go east to "..cl(38,21),
			"	a. Talk to Magistrix Erona",
			"		i. Turn in "..cq("Reclaiming Sunstrider Isle"),
			"		ii. Accept "..cq("Unfortunate Measures"),
			completion={{questturnedin="Reclaiming Sunstrider Isle"},{questaccepted="Unfortunate Measures"}},
			mapzone="Eversong Woods",
			level=2,
			mapnote=20805900,
		}, {
			"Go to "..cl(39,19),
			"	a. Talk to Well Watcher Solanian",
			"		i. Accept "..cq("Solanian's Belongings"),
			"		ii. Accept "..cq("The Shrine of Dath'Remar"),
			completion={{questaccepted="The Shrine of Dath'Remar"},{questaccepted="Solanian's Belongings"}},
			mapzone="Eversong Woods",
			level=2,
			mapnote=19405820,
		}, {
			"Go to "..cl(38,19),
			"	a. Talk to Arcanist Ithanas",
			"		i. Accept "..cq("A Fistful of Slivers"),
			completion={{questaccepted="A Fistful of Slivers"}},
			mapzone="Eversong Woods",
			level=2,
			mapnote=19105740,
		}, {
			"Go to "..cl(37,19),
			"	a. Talk to Arcanist Helion",
			"		i. Accept "..cq("Thirst Unending"),
			completion={{questaccepted="Thirst Unending"}},
			mapzone="Eversong Woods",
			level=2,
			mapnote=18905610,
		}, {
			"Go southwest to "..cl(35,20),
			"	a. Use your Mana Tap ability on the Mana Wyrms",
			"	b. Mana Tap 6 creatures",
			"	c. Kill Mana Wyrms",
			"	d. Get 6 Arcane Slivers",
			completion={{questgoal={"*","Arcane Sliver",6}},{questgoal={"*","Mana Tap Creature",6}}},
			mapzone="Eversong Woods",
			level=2,
			mapnote=20105490,
		}, {
			"Grind to level 3",
			completion={{level=3}},
			mapzone="Eversong Woods",
			level=2,
		}, {
			"Go southwest to "..cl(34,22),
			"	a. Kill Springpaw Lynxes",
			"	b. Get 8 Lynx Collars",
			completion={{questgoal={"*","Lynx Collar",8}}},
			mapzone="Eversong Woods",
			level=3,
			mapnote=22505610,
		}, {
			"Go east to "..cl(38,21),
			"	a. Talk to Magistrix Erona",
			"		i. Turn in "..cq("Unfortunate Measures"),
			"		ii. Accept "..cq("Report to Lanthan Perilon"),
			completion={{questturnedin="Unfortunate Measures"},{questaccepted="Report to Lanthan Perilon"}},
			mapzone="Eversong Woods",
			level=3,
			mapnote=20805900,
		}, {
			"Go to "..cl(38,19),
			"	a. Talk to Arcanist Ithanas",
			"		i. Turn in "..cq("A Fistful of Slivers"),
			completion={{questturnedin="A Fistful of Slivers"}},
			mapzone="Eversong Woods",
			level=3,
			mapnote=19105740,
		}, {
			"Go to "..cl(37,19),
			"	a. Talk to Arcanist Helion",
			"		i. Turn in "..cq("Thirst Unending"),
			completion={{questturnedin="Thirst Unending"}},
			mapzone="Eversong Woods",
			level=3,
			mapnote=18905610,
		}, {
			"Grind to level 4",
			completion={{level=4}},
			mapzone="Eversong Woods",
			level=3,
		}, {
			"Go southwest to "..cl(35,23),
			"	a. Talk to Lanthan Perilon",
			"		i. Turn in "..cq("Report to Lanthan Perilon"),
			"		ii. Accept "..cq("Aggression"),
			completion={{questturnedin="Report to Lanthan Perilon"},{questaccepted="Aggression"}},
			mapzone="Eversong Woods",
			level=4,
			mapnote=22505790,
		}, {
			"Go southwest to "..cl(33,24),
			"	a. Kill 7 Tenders",
			"	b. Kill 7 Feral Tenders",
			completion={{questgoal={"*","Tender slain",7}},{questgoal={"*","Feral Tender slain",7}}},
			mapzone="Eversong Woods",
			level=4,
			mapnote=24205770,
		}, {
			"Grind to level 5",
			completion={{level=5}},
			mapzone="Eversong Woods",
			level=4,
		}, {
			"Go northwest to "..cl(30,19),
			"	a. Click the shiny plaque on the side of the huge statue",
			"	b. Read the Shrine of Dath'Remar",
			completion={{questgoal={"*","Shrine of Dath'Remar Read",1}}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=19404900,
		}, {
			"Go southeast to "..cl(31,23),
			"	a. Click the Scroll of Scourge Magic",
			"	b. Get the Scroll of Scourge Magic",
			completion={{questgoal={"*","Scroll of Scourge Magic",1}}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=22705400,
		}, {
			"Go southeast to "..cl(35,29),
			"	a. Click Solanian's Scrying Orb",
			"	b. Get Solanian's Scrying Orb",
			completion={{questgoal={"*","Solanian's Scrying Orb",1}}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=28906400,
		}, {
			"Go northeast to "..cl(38,25),
			"	a. Click Solanian's Journal",
			"	b. Get Solanian's Journal",
			completion={{questgoal={"*","Solanian's Journal",1}}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=24906260,
		}, {
			"Go north to "..cl(39,19),
			"	a. Talk to Well Watcher Solanian",
			"		i. Turn in "..cq("Solanian's Belongings"),
			"		ii. Turn in "..cq("The Shrine of Dath'Remar"),
			completion={{questturnedin="Solanian's Belongings"},{questturnedin="The Shrine of Dath'Remar"}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=19405820,
		}, {
			"Go to "..cl(35,23),
			"	a. Talk to Lanthan Perilon",
			"		i. Turn in "..cq("Aggression"),
			"		ii. Accept "..cq("Felendren the Banished"),
			completion={{questturnedin="Aggression"},{questaccepted="Felendren the Banished"}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=22505790,
		}, {
			"Go southwest to "..cl(32,26),
			"	a. Kill 8 Arcane Wraiths",
			"	b. Kill 2 Tainted Arcane Wraiths",
			"	c. Kill wraiths",
			"	d. Get a Tainted Arcane Sliver",
			"	e. Click the Tained Arcane Sliver",
			"		i. Accept "..cq("Tainted Arcane Sliver"),
			completion={{questgoal={"*","Arcane Wraith slain",8}},{questgoal={"*","Tainted Arcane Wraith slain",2}},{questaccepted="Tainted Arcane Sliver"}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=25905810,
		}, {
			"Follow the ramps all the way to the top",
			mapzone="Eversong Woods",
			level=5,
		}, {
			"Go to "..cl(31,27),
			"	a. Kill Felendren the Banished",
			"	b. Get Felendren's Head",
			completion={{questgoal={"*","Felendren's Head",1}}},
			mapzone="Eversong Woods",
			level=5,
			mapnote=27105790,
		}, {
			"Grind to level 6",
			completion={{level=6}},
			mapzone="Eversong Woods",
			level=5,
		}, {
			"Go northeast to "..cl(35,23),
			"	a. Talk to Lanthan Perilon",
			"		i. Turn in "..cq("Felendren the Banished"),
			"		ii. Accept "..cq("Aiding the Outrunners"),
			completion={{questturnedin="Felendren the Banished"},{questaccepted="Aiding the Outrunners"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=22505790,
		}, {
			"Go to "..cl(37,19),
			"	a. Talk to Arcanist Helion",
			"		i. Turn in "..cq("Tainted Arcane Sliver"),
			completion={{questturnedin="Tainted Arcane Sliver"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=18905610,
		}, {
			"Go southeast over the bridge",
			completion={{location={mapzone="Eversong Woods",x=40.0,y=31.4, dist=0.5}}},
			mapzone="Eversong Woods",
			level=6,
		}, {
			"Go to "..cl(40,32),
			"	a. Talk to Outrunner Alarion",
			"		i. Turn in "..cq("Aiding the Outrunners"),
			"		ii. Accept "..cq("Slain by the Wretched"),
			completion={{questturnedin="Aiding the Outrunners"},{questaccepted="Slain by the Wretched"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=32207260,
		}, {
			"Go southeast to "..cl(42,36),
			"	a. Click the Slain Outrunner",
			"		i. Turn in "..cq("Slain by the Wretched"),
			"		ii. Accept "..cq("Package Recovery"),
			completion={{questturnedin="Slain by the Wretched"},{questaccepted="Package Recovery"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=35707770,
		}, {
			"Go northwest to "..cl(40,32),
			"	a. Talk to Outrunner Alarion",
			"		i. Turn in "..cq("Package Recovery"),
			"		ii. Accept "..cq("Completing the Delivery"),
			completion={{questturnedin="Package Recovery"},{questaccepted="Completing the Delivery"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=32207260,
		}, {
			"Go southeast to "..cl(47,46),
			"	a. Talk to Magister Jaronis",
			"		i. Accept "..cq("Major Malfunction"),
			completion={{questaccepted="Major Malfunction"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=46309360,
		}, {
			"Go to "..cl(48,48),
			"	a. Talk to Innkeeper Delaniel",
			"		i. Turn in "..cq("Completing the Delivery"),
			completion={{questturnedin="Completing the Delivery"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=47709580,
		}, {
			"Make Falconwing Square your home",
			completion={{home="Falconwing Square"}},
			mapzone="Eversong Woods",
			level=6,
		}, {
			"Go to "..cl(48,46),
			"	a. Talk to Aeldon Sunbrand",
			"		i. Accept "..cq("Unstable Mana Crystals"),
			completion={{questaccepted="Unstable Mana Crystals"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=46009420,
		}, {
			"Also at "..cl(48,46),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("Wanted: Thaelis the Hungerer"),
			completion={{questaccepted="Wanted: Thaelis the Hungerer"}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=46309450,
		}, {
			"Go northwest to "..cl(46,44),
			"	a. Click the Unstable Mana Crystal Crates",
			"	b. Get 6 Unstable Mana Crystals",
			"	c. Kill Arcane Patrollers",
			"	d. Get 6 Arcane Cores",
			completion={{questgoal={"*","Unstable Mana Crystal",6}},{questgoal={"*","Arcane Core",6}}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=43708960,
		}, {
			"Go north to "..cl(45,38),
			"	a. Kill Thaelis the Hungerer",
			"	b. Get Thaelis's Head",
			completion={{questgoal={"*","Thaelis's Head",1}}},
			mapzone="Eversong Woods",
			level=6,
			mapnote=37808280,
		}, {
			"Grind to level 7",
			completion={{level=7}},
			mapzone="Eversong Woods",
			level=6,
		}, {
			"Go southeast to "..cl(47,46),
			"	a. Talk to Magis Jaronis",
			"		i. Turn in "..cq("Major Malfunction"),
			"		ii. Accept "..cq("Delivery to the North Sanctum"),
			completion={{questturnedin="Major Malfunction"},{questaccepted="Delivery to the North Sanctum"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=46309360,
		}, {
			"Go to "..cl(47,46),
			"	a. Talk to Sergeant Kan'ren",
			"		i. Turn in "..cq("Wanted: Thaelis the Hungerer"),
			completion={{questturnedin="Wanted: Thaelis the Hungerer"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=46609440,
		}, {
			"Go to "..cl(48,46),
			"	a. Talk to Aeldon Sunbrand",
			"		i. Turn in "..cq("Unstable Mana Crystals"),
			"		ii. Accept "..cq("Darnassian Intrusions"),
			completion={{questturnedin="Unstable Mana Crystals"},{questaccepted="Darnassian Intrusions"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=46009420,
		}, {
			"Go southwest to "..cl(45,53),
			"	a. Talk to Ley-Keeper Caidanis",
			"		i. Turn in "..cq("Delivery to the North Sanctum"),
			"		ii. Accept "..cq("Malfunction at the West Sanctum"),
			completion={{questturnedin="Delivery to the North Sanctum"},{questaccepted="Malfunction at the West Sanctum"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=53109770,
		}, {
			"Go south to "..cl(45,56),
			"	a. Talk to Apprentice Ralen",
			"		i. Accept "..cq("Roadside Ambush"),
			completion={{questaccepted="Roadside Ambush"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=56410160,
		}, {
			"Go west to "..cl(37,57),
			"	a. Talk to Ley-Keeper Velania",
			"		i. Turn in "..cq("Malfunction at the West Sanctum"),
			"		ii. Accept "..cq("Arcane Instability"),
			completion={{questturnedin="Malfunction at the West Sanctum"},{questaccepted="Arcane Instability"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=57409410,
		}, {
			"Go west to "..cl(35,57),
			"	a. Kill 5 Manawraiths",
			"	b. Kill 5 Mana Stalkers",
			completion={{questgoal={"*","Manawraith slain",5}},{questgoal={"*","Mana Stalker slain",5}}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=57409280,
		}, {
			"Go southwest to "..cl(34,58),
			"	a. Kill a Darnassian Scout",
			"	b. Defeat an Intruder",
			"	c. Kill Darnassian Scouts",
			"	d. Get the Incriminating Documents",
			"	e. Click the Incriminating Documents",
			"		i. Accept "..cq("Incriminating Documents"),
			completion={{questgoal={"*","Intruder Defeated",1}},{questaccepted="Incriminating Documents"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=58409230,
		}, {
			"Go east to "..cl(37,57),
			"	a. Talk to Ley-Keeper Velania",
			"		i. Turn in "..cq("Darnassian Intrusions"),
			"		ii. Turn in "..cq("Arcane Instability"),
			completion={{questturnedin="Darnassian Intrusions"},{questturnedin="Arcane Instability"}},
			mapzone="Eversong Woods",
			level=7,
			mapnote=57409410,
		}, {
			"Grind to level 8",
			completion={{level=8}},
			mapzone="Eversong Woods",
			level=7,
		}, {
			"Go west to "..cl(30,58),
			"	a. Talk to Hathvelion Sungaze",
			"		i. Accept "..cq("Fish Heads, Fish Heads..."),
			completion={{questaccepted="Fish Heads, Fish Heads..."}},
			mapzone="Eversong Woods",
			level=8,
			mapnote=58308850,
		}, {
			"Go west to "..cl(27,57),
			"	a. Kill murlocs",
			"	b. Get 8 Grimscale Murloc Heads",
			"	c. Get Captain Kelisendra's Lost Rutters",
			"	d. Click Captain Kelisendra's Lost Rutters",
			"		i. Accept "..cq("Captain Kelisendra's Lost Rutters"),
			completion={{questgoal={"*","Grimscale Murloc Head",8}},{questaccepted="Captain Kelisendra's Lost Rutters"}},
			mapzone="Eversong Woods",
			level=8,
			mapnote=57208450,
		}, {
			"Go east to "..cl(30,58),
			"	a. Talk to Hathvelion Sungaze",
			"		i. Turn in "..cq("Fish Heads, Fish Heads..."),
			completion={{questturnedin="Fish Heads, Fish Heads..."}},
			mapzone="Eversong Woods",
			level=8,
			mapnote=58308850,
		}, {
			"Go southeast to "..cl(36,67),
			"	a. Talk to Captain Kelisendra",
			"		i. Turn in "..cq("Captain Kelisendra's Lost Rutters"),
			"		ii. Accept "..cq("Grimscale Pirates!"),
			"	b. Talk to Velendris Whitemorn",
			"		i. Accept "..cq("Lost Armaments"),
			completion={{questturnedin="Captain Kelisendra's Lost Rutters"},{questaccepted="Lost Armaments"},{questaccepted="Grimscale Pirates!"}},
			mapzone="Eversong Woods",
			level=8,
			mapnote=66710310,
		}, {
			"Go west to "..cl(32,69),
			"	a. Click the Weapon Containers",
			"	b. Get 8 Sin'dorei Armaments",
			completion={{questgoal={"*","Sin'dorei Armaments",8}}},
			mapzone="Eversong Woods",
			level=8,
			mapnote=69110080,
		}, {
			"Grind to level 9",
			completion={{level=9}},
			mapzone="Eversong Woods",
			level=8,
		}, {
			"Go west to "..cl(25,71),
			"	a. Kill murlocs",
			"	b. Get 6 Captain Kelisendra's Cargo",
			completion={{questgoal={"*","Captain Kelisendra's Cargo",8}}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=70809640,
		}, {
			"Go east to "..cl(36,67),
			"	a. Talk to Captain Kelisendra",
			"		i. Turn in "..cq("Grimscale Pirates!"),
			"	b. Talk to Velendris Whitemorn",
			"		i. Turn in "..cq("Lost Armaments"),
			"		ii. Accept "..cq("Wretched Ringleader"),
			completion={{questturnedin="Grimscale Pirates!"},{questturnedin="Lost Armaments"},{questaccepted="Wretched Ringleader"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=66710310,
		}, {
			"Go southwest to "..cl(33,70),
			"	a. Go all the way to the top of the big building",
			"	b. Kill Aldaron the Reckless",
			"	c. Get Aldaron's Head",
			completion={{questgoal={"*","Aldaron's Head",1}}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=69610240,
		}, {
			"Go northeast to "..cl(36,67),
			"	a. Talk to Velendris Whitemorn",
			"		i. Turn in "..cq("Wretched Ringleader"),
			completion={{questturnedin="Wretched Ringleader"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=66710310,
		}, {
			"Go southeast to Fairbreeze Village",
			completion={{location={mapzone="Eversong Woods",x=44.4,y=70.2,dist=2}}},
			mapzone="Eversong Woods",
			level=9,
		}, {
			"Go to "..cl(45,70),
			"	a. Talk to Velan Brightoak",
			"		i. Accept "..cq("Pelt Collection"),
			completion={{questaccepted="Pelt Collection"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=69611430,
		}, {
			"Go to "..cl(44,71),
			"	a. Talk to Magistrix Landra Dawnstrider",
			"		i. Accept "..cq("Saltheril's Haven"),
			"		ii. Accept "..cq("The Wayward Apprentice"),
			completion={{questaccepted="The Wayward Apprentice"},{questaccepted="Saltheril's Haven"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=70811480,
		}, {
			"Also at "..cl(44,71),
			"	a. Talk to Marniel Amberlight",
			"		i. Accept "..cq("Ranger Sareyn"),
			completion={{questaccepted="Ranger Sareyn"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=71211490,
		}, {
			"Make Fairbreeze Village your home",
			completion={{home="Fairbreeze Village"}},
			mapzone="Eversong Woods",
			level=9,
		}, {
			"Go to "..cl(43,71),
			"	a. Talk to Ranger Degolien",
			"		i. Accept "..cq("Situation at Sunsail Anchorage"),
			completion={{questaccepted="Situation at Sunsail Anchorage"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=70811410,
		}, {
			"Go north to "..cl(45,61),
			"	a. Talk to Apprentice Meledor",
			"		i. Turn in "..cq("Roadside Ambush"),
			"		ii. Accept "..cq("Soaked Pages"),
			completion={{questturnedin="Roadside Ambush"},{questaccepted="Soaked Pages"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=61010590,
		}, {
			"Go southwest to "..cl(44,62),
			"	a. Click the Soaked Tome",
			"	b. Get Antheol's Elemental Grimoire",
			completion={{questgoal={"*","Antheol's Elemental Grimoire",1}}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=62010630,
		}, {
			"Go northeast to "..cl(45,61),
			"	a. Talk to Apprentice Meledor",
			"		i. Turn in "..cq("Soaked Pages"),
			"		ii. Accept "..cq("Taking the Fall"),
			completion={{questturnedin="Soaked Pages"},{questaccepted="Taking the Fall"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=61010590,
		}, {
			"Go northeast to "..cl(48,46),
			"	a. Talk to Aeldon Sunbrand",
			"		i. Turn in "..cq("Incriminating Documents"),
			"		ii. Accept "..cq("The Dwarven Spy"),
			completion={{questturnedin="Incriminating Documents"},{questaccepted="The Dwarven Spy"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=46009420,
		}, {
			"Go southwest to "..cl(45,53),
			"	a. Talk to Prospector Anvilward",
			"		i. Lure him away",
			"		ii. Kill Prospector Anvilward",
			"		iii. Get Prospector Anvilward's Head",
			completion={{questgoal={"*","Prospector Anvilward's Head",1}}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=53109770,
		}, {
			"Go northeast to "..cl(48,46),
			"	a. Talk to Aeldon Sunbrand",
			"		i. Turn in "..cq("The Dwarven Spy"),
			completion={{questturnedin="The Dwarven Spy"}},
			mapzone="Eversong Woods",
			level=9,
			mapnote=46009420,
		}, {
			"Grind to level 10",
			completion={{level=10}},
			mapzone="Eversong Woods",
			level=9,
		}, {
			"Go southeast to "..cl(50,51),
			"	a. Talk to Ranger Jaela",
			"		i. Accept "..cq("The Dead Scar"),
			completion={{questaccepted="The Dead Scar"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=50810110,
		}, {
			"Go south to "..cl(50,53),
			"	a. Kill 8 Plaguebone Pillagers",
			completion={{questgoal={"*","Plaguebone Pillager slain",8}}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=52810280,
		}, {
			"Go north to "..cl(50,51),
			"	a. Talk to Ranger Jaela",
			"		i. Turn in "..cq("The Dead Scar"),
			completion={{questturnedin="The Dead Scar"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=50810110,
		}, {
			"Go southeast to "..cl(56,54),
			"	a. Talk to Instructor Antheol",
			"		i. Turn in "..cq("Taking the Fall"),
			"		ii. Accept "..cq("Swift Discipline"),
			completion={{questturnedin="Taking the Fall"},{questaccepted="Swift Discipline"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=54511020,
		}, {
			"Go south to "..cl(54,71),
			"	a. Talk to Apprentice Mirveda",
			"		i. Turn in "..cq("The Wayward Apprentice"),
			"		ii. Accept "..cq("Corrupted Soil"),
			completion={{questturnedin="The Wayward Apprentice"},{questaccepted="Corrupted Soil"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71012530,
		}, {
			"Go west to "..cl(52,71),
			"	a. Click the Corrupted Soil Samples",
			"	b. Get 8 Tainted Soil Samples",
			completion={{questgoal={"*","Tainted Soil Sample",8}}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=70912350,
		}, {
			"Go east to "..cl(54,71),
			"	a. Talk to Apprentice Mirveda",
			"		i. Turn in "..cq("Corrupted Soil"),
			"		ii. Prepare for battle",
			"		iii. Accept "..cq("Unexpected Results"),
			completion={{questturnedin="Corrupted Soil"},{questaccepted="Unexpected Results"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71012530,
		}, {
			"Protect Apprentice Mirveda from the ambushers",
			"	a. Turn in "..cq("Unexpected Results"),
			"	b. Accept "..cq("Research Notes"),
			completion={{questturnedin="Unexpected Results"},{questaccepted="Research Notes"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71012530,
		}, {
			"Go west to "..cl(47,72),
			"	a. Talk to Ranger Sareyn",
			"		i. Turn in "..cq("Ranger Sareyn"),
			"		ii. Accept "..cq("Defending Fairbreeze Village"),
			completion={{questturnedin="Ranger Sareyn"},{questaccepted="Defending Fairbreeze Village"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71811870,
		}, {
			"Go southeast to "..cl(51,75),
			"	a. Kill 4 Rotlimb Marauders",
			"	b. Kill 4 Darkwraiths",
			completion={{questgoal={"*","Rotlimb Marauder slain",4}},{questgoal={"*","Darkwraith slain",4}}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=75512620,
		}, {
			"Go northwest to "..cl(47,72),
			"	a. Talk to Ranger Sareyn",
			"		i. Turn in "..cq("Defending Fairbreeze Village"),
			completion={{questturnedin="Defending Fairbreeze Village"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71811870,
		}, {
			"Go to "..cl(44,71),
			"	a. Talk to Magistrix Landra Dawnstrider",
			"		i. Turn in "..cq("Research Notes"),
			completion={{questturnedin="Research Notes"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=70811480,
		}, {
			"Go southwest to "..cl(38,74),
			"	a. Talk to Lord Saltheril",
			"		i. Turn in "..cq("Saltheril's Haven"),
			"		ii. Accept "..cq("The Party Never Ends"),
			completion={{questturnedin="Saltheril's Haven"},{questaccepted="The Party Never Ends"}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=73611170,
		}, {
			"Go northwest to "..cl(33,71),
			"	a. Kill 5 Wretched Thugs",
			"	b. Kill 5 Wretched Hooligans",
			completion={{questgoal={"*","Wretched Thug slain",5}},{questgoal={"*","Wretched Hooligan slain",5}}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=71610510,
		}, {
			"Go northeast to "..cl(40,66),
			"	a. Kill Springpaw Stalkers",
			"	b. Get 6 Springpaw Pelts",
			completion={{questgoal={"*","Springpaw Pelt",6}}},
			mapzone="Eversong Woods",
			level=10,
			mapnote=66210630,
		}, {
			"Grind to level 11",
			completion={{level=11}},
			mapzone="Eversong Woods",
			level=10,
		}, {
			"Go southeast to Fairbreeze Village",
			completion={{location={mapzone="Eversong Woods",x=44.4,y=70.2,dist=2}}},
			mapzone="Eversong Woods",
			level=11,
		}, {
			"Go to "..cl(45,70),
			"	a. Talk to Velan Brightoak",
			"		i. Turn in "..cq("Pelt Collection"),
			completion={{questturnedin="Pelt Collection"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=69611430,
		}, {
			"Go to "..cl(44,70),
			"	a. Talk to Halis Dawnstrider",
			"		i. Buy a Bundle of Fireworks",
			completion={{questgoal={"*","Bundle of Fireworks",1}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=70311440,
		}, {
			"Go to "..cl(43,71),
			"	a. Talk to Ranger Degolien",
			"		i. Turn in "..cq("Situation at Sunsail Anchorage"),
			"		ii. Accept "..cq("Farstrider Retreat"),
			completion={{questturnedin="Situation at Sunsail Anchorage"},{questaccepted="Farstrider Retreat"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=70811410,
		}, {
			"Go north to "..cl(45,61),
			"	a. Use Antheol's Disciplinary Rod on Apprentice Meledor",
			"	b. Discipline Apprentice Meledor",
			completion={{questgoal={"*","Apprentice Meledor Disciplined",1}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=61010590,
		}, {
			"Go north to "..cl(45,56),
			"	a. Use Antheol's Disciplinary Rod on Apprentice Ralen",
			"	b. Discipline Apprentice Ralen",
			completion={{questgoal={"*","Apprentice Ralen Disciplined",1}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=56410160,
		}, {
			"Go east to "..cl(56,55),
			"	a. Talk to Instructor Antheol",
			"	b. Turn in "..cq("Swift Discipline"),
			completion={{questturnedin="Swift Discipline"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=54511020,
		}, {
			"Go north to Silvermoon City",
			completion={{location={mapzone="Silvermoon City"}}},
			mapzone="Eversong Woods",
			level=11,
		}, {
			"Go to "..cl(80,59),
			"	a. Talk to Vinemaster Suntouched",
			"		i. Buy a Suntouched Special Reserve",
			completion={{questgoal={"*","Suntouched Special Reserve",1}}},
			mapzone="Silvermoon City",
			level=11,
			mapnote=58513800,
		}, {
			"Leave Silvermoon City",
			completion={{location={mapzone="Eversong Woods",x=56.7,y=49.5, dist=1}}},
			mapzone="Silvermoon City",
			level=11,
		}, {
			"Go southeast to "..cl(60,63),
			"	a. Talk to Lieutenant Dawnrunner",
			"		i. Turn in "..cq("Farstrider Retreat"),
			"		ii. Accept "..cq("Amani Encroachment"),
			completion={{questturnedin="Farstrider Retreat"},{questaccepted="Amani Encroachment"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=62812310,
		}, {
			"Also at "..cl(60,63),
			"	a. Talk to Arathel Sunforge",
			"		i. Accept "..cq("The Spearcrafter's Hammer"),
			completion={{questaccepted="The Spearcrafter's Hammer"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=62612210,
		}, {
			"Go to "..cl(60,61),
			"	a. Talk to Magister Duskwither",
			"		i. Accept "..cq("The Magister's Apprentice"),
			completion={{questaccepted="The Magister's Apprentice"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=61412170,
		}, {
			"Go northeast to "..cl(68,57),
			"	a. Talk to Apprentice Loralthalis",
			"		i. Turn in "..cq("The Magister's Apprentice"),
			"		ii. Accept "..cq("Deactivating the Spire"),
			"		iii. Accept "..cq("Where's Wyllithen?"),
			completion={{questturnedin="The Magister's Apprentice"},{questaccepted="Where's Wyllithen?"},{questaccepted="Deactivating the Spire"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=56512430,
		}, {
			"Go northeast to "..cl(69,52),
			"	a. Click the orb of Translocation",
			"		i. It will teleport you up to the building",
			"	b. Click the Duskwither Spire Power Sources",
			"		i. The Second Power Source is on the second floor",
			"	c. Deactivate the First Power Source",
			"	d. Deactivate the Second Power Source",
			completion={{questgoal={"*","First Power Source Deactivated",1}},{questgoal={"*","Second Power Source Deactivated",1}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=51912080,
		}, {
			"Go up the big staircase",
			mapzone="Eversong Woods",
			level=11,
		}, {
			"Go southeast to "..cl(70,53),
			"	a. Click the Duskwither Spire Power Source",
			"	b. Deactivate the Third Power Source",
			"	c. Click Magister Duskwither's Journal",
			"		i. Accept "..cq("Abandoned Investigations"),
			"	c. Click the Orb of Translocation",
			"		i. It will teleport you back down",
			completion={{questgoal={"*","Third Power Source Deactivated",1}},{questaccepted="Abandoned Investigations"},{location={mapzone="Eversong Woods",x=68.3,y=52.5, dist=0.2}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=53312300,
		}, {
			"Go north to "..cl(69,47),
			"	a. Talk to Groundskeeper Wyllithen",
			"		i. Turn in "..cq("Where's Wyllithen?"),
			"		ii. Accept "..cq("Cleaning up the Grounds"),
			completion={{questturnedin="Where's Wyllithen?"},{questaccepted="Cleaning up the Grounds"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=46911560,
		}, {
			"Go southeast to "..cl(69,58),
			"	a. Kill 6 Mana Serpents",
			"	b. Kill 6 Ether Fiends",
			completion={{questgoal={"*","Mana Serpent slain",6}},{questgoal={"*","Ether Fiend slain",6}}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=48111760,
		}, {
			"Go northwest to "..cl(69,47),
			"	a. Talk to Groundskeeper Wyllithen",
			"		i. Turn in "..cq("Cleaning up the Grounds"),
			completion={{questturnedin="Cleaning up the Grounds"}},
			mapzone="Eversong Woods",
			level=11,
			mapnote=46911560,
		}, {
			"Grind to level 12",
			completion={{level=12}},
			mapzone="Eversong Woods",
			level=11,
		}, {
			"Go south to "..cl(68,56),
			"	a. Talk to Apprentice Loralthalis",
			"		i. Turn in "..cq("Deactivating the Spire"),
			"		ii. Accept "..cq("Word from the Spire"),
			completion={{questturnedin="Deactivating the Spire"},{questaccepted="Word from the Spire"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=56512430,
		}, {
			"Go southwest to Farstrider Retreat",
			completion={{location={mapzone="Eversong Woods",x=60.4,y=62.5, dist=1.5}}},
			mapzone="Eversong Woods",
			level=12,
		}, {
			"Go to "..cl(60,62),
			"	a. Talk to Zalene Firstlight",
			"		i. Buy Springpaw Appetizers",
			completion={{questgoal={"*","Springpaw Appetizers",1}}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=62512290,
		}, {
			"Go to "..cl(60,61),
			"	a. Talk to Magister Duskwither",
			"		i. Turn in "..cq("Word from the Spire"),
			"		i. Turn in "..cq("Abandoned Investigations"),
			completion={{questturnedin="Word from the Spire"},{questturnedin="Abandoned Investigations"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=61412170,
		}, {
			"Go southeast to "..cl(68,72),
			"	a. Kill 5 Amani Berserkers",
			"	b. Kill 5 Amani Axe Throwers",
			completion={{questgoal={"*","Amani Berserker slain",5}},{questgoal={"*","Amani Axe Thrower slain",5}}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=71914020,
		}, {
			"Go east to "..cl(70,72),
			"	a. Kill Spearcrafter Otembe",
			"	b. Get Otembe's Hammer",
			completion={{questgoal={"*","Otembe's Hammer",1}}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=72314230,
		}, {
			"Go east to "..cl(71,72),
			"	a. Talk to Ven'jashi",
			"		i. Accept "..cq("Zul'Marosh"),
			completion={{questaccepted="Zul'Marosh"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=72314280,
		}, {
			"Go southwest to "..cl(63,80),
			"	a. He's at the very top of the big building",
			"	b. Kill Chieftain Zul'Marosh",
			"	c. Get Chieftain Zul'Marosh's Head",
			"	d. Get the Amani Invasion Plans",
			"	e. Click the Amani Invasion Plans",
			"		i. Accept "..cq("Amani Invasion"),
			completion={{questgoal={"*","Chieftain Zul'Marosh's Head",1}},{questaccepted="Amani Invasion"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=79714230,
		}, {
			"Go northeast to "..cl(71,72),
			"	a. Talk to Ven'jashi",
			"		i. Turn in "..cq("Zul'Marosh"),
			completion={{questturnedin="Zul'Marosh"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=72314280,
		}, {
			"Go northwest to Farstrider Retreat",
			completion={{location={mapzone="Eversong Woods",x=60.4,y=62.5, dist=1.5}}},
			mapzone="Eversong Woods",
			level=12,
		}, {
			"Go to "..cl(60,63),
			"	a. Talk to Lieutenant Dawnrunner",
			"		i. Turn in "..cq("Amani Encroachment"),
			"		ii. Turn in "..cq("Amani Invasion"),
			"		iii. Accept "..cq("Warning Fairbreeze Village"),
			completion={{questturnedin="Amani Encroachment"},{questturnedin="Amani Invasion"},{questaccepted="Warning Fairbreeze Village"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=62812310,
		}, {
			"Also at "..cl(60,63),
			"	a. Talk to Arathel Sunforge",
			"		i. Turn in "..cq("The Spearcrafter's Hammer"),
			completion={{questturnedin="The Spearcrafter's Hammer"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=62612210,
		}, {
			"Hearth to Fairbreeze Village",
			completion={{location={mapzone="Eversong Woods",x=43.7,y=71.2, dist=0.3}}},
			mapzone="Eversong Woods",
			level=12,
		}, {
			"Go to "..cl(43,71),
			"	a. Talk to Ranger Degolien",
			"		i. Turn in "..cq("Warning Fairbreeze Village"),
			completion={{questturnedin="Warning Fairbreeze Village"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=70811410,
		}, {
			"Go southwest to "..cl(38,74),
			"	a. Talk to Lord Saltheril",
			"		i. Turn in "..cq("The Party Never Ends"),
			completion={{questturnedin="The Party Never Ends"}},
			mapzone="Eversong Woods",
			level=12,
			mapnote=73611170,
		}, {
			"Grind to level 13",
			completion={{level=13}},
			mapzone="Eversong Woods",
			level=12,
		}, {
			"Go northeast to Silvermoon City",
			completion={{location={mapzone="Silvermoon City"}}},
			mapzone="Eversong Woods",
			level=13,
		}, {
			"Go to "..cl(50,15),
			"	a. Click the Orb of Translocation",
			"		i. It will teleport you to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Silvermoon City",
			level=13,
			mapnote=14806430,
		}, {
			"Go outside of Undercity",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Undercity",
			level=13,
		}, {
			"Go north to "..cl(61,59),
			"	a. Ride the zeppelin to Orgrimmar",
			completion={{location={mapzone="Durotar",x=50.8,y=13.2, dist=1}}},
			mapzone="Tirisfal Glades",
			level=13,
			mapnote=58811960,
		}, {
			"Go northwest to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=13,
		}, {
			"Go to "..cl(45,64),
			"	a. Talk to Doras",
			"		i. Get the Orgrimmar Flight Path",
			completion={{flightpath="Orgrimmar"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=63910900,
		}, {
			"Go outside of Orgrimmar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=13,
		}, {
			"Go southeast to Razor Hill",
			completion={{location={mapzone="Durotar",x=52.7,y=42.6, dist=3}}},
			mapzone="Durotar",
			level=13,
		}, {
			"Go to "..cl(51,44),
			"	a. Talk to Takrin Pathseeker",
			"		i. Accept "..cq("Conscript of the Horde"),
			completion={{questaccepted="Conscript of the Horde"}},
			mapzone="Durotar",
			level=13,
			mapnote=43609440,
		}, {
			"Go west to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Durotar",
			level=13,
		}
	  },
	},
	{ sectiontitle = "Main Guide (13-20)",
	  steps = {
		{
			"Go to "..cl(62,19),
			"	a. Talk to Kargal Battlescar",
			"		i. Turn in "..cq("Conscript of the Horde"),
			"		ii. Accept "..cq("Crossroads Conscription"),
			completion={{questturnedin="Conscript of the Horde"},{questaccepted="Crossroads Conscription"}},
			mapzone="The Barrens",
			level=13,
			mapnote=19408170,
		}, {
			"Go to "..cl(62,20),
			"	a. Talk to Ak'Zeloth",
			"		i. Turn in "..cq("Ak'Zeloth"),
			completion={{questturnedin="Ak'Zeloth"}},
			mapzone="The Barrens",
			level=13,
			mapnote=20108240,
		}, {
			"Go southwest to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go to "..cl(53,30),
			"	a. Talk to Zargh",
			"		i. Accept "..cq("Meats to Orgrimmar"),
			completion={{questaccepted="Meats to Orgrimmar"}},
			mapzone="The Barrens",
			level=13,
			mapnote=29808240,
		}, {
			"Make the Crossroads your home",
			completion={{home="the Crossroads"}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go to "..cl(52,30),
			"	a. Talk to Gazrog",
			"		i. Accept "..cq("Raptor Thieves"),
			completion={{questaccepted="Raptor Thieves"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30308220,
		}, {
			"Also at "..cl(52,30),
			"	a. Talk to Devrak",
			"		i. Get the Crossroads Flight Path",
			"		ii. Turn in "..cq("Meats to Orgrimmar"),
			"		iii. Accept "..cq("Ride to Orgrimmar"),
			completion={{flightpath="Crossroads"},{questturnedin="Meats to Orgrimmar"},{questaccepted="Ride to Orgrimmar"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30308180,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Apothecary Helbrim",
			"		i. Accept "..cq("Wharfmaster Dizzywig"),
			"		ii. Accept "..cq("Fungal Spores"),
			completion={{questaccepted="Fungal Spores"},{questaccepted="Wharfmaster Dizzywig"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30208160,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go to "..cl(54,68),
			"	a. Talk to Innkeeper Gryshka",
			"		i. Turn in "..cq("Ride to Orgrimmar"),
			"		ii. Accept "..cq("Doras the Wind Rider Master"),
			completion={{questturnedin="Ride to Orgrimmar"},{questaccepted="Doras the Wind Rider Master"}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=68412250,
		}, {
			"Go to "..cl(45,64),
			"	b. Talk to Doras",
			"		i. Turn in "..cq("Doras the Wind Rider Master"),
			"		ii. Accept "..cq("Return to the Crossroads."),
			completion={{questturnedin="Doras the Wind Rider Master"},{questaccepted="Return to the Crossroads."}},
			mapzone="Orgrimmar",
			level=13,
			mapnote=63910900,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Orgrimmar",
			level=13,
		}, {
			"Go to "..cl(51,31),
			"	a. Talk to Thork",
			"		i. Accept "..cq("Disrupt the Attacks"),
			"		ii. Accept "..cq("Supplies for the Crossroads"),
			completion={{questaccepted="Supplies for the Crossroads"},{questaccepted="Disrupt the Attacks"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30908240,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Darsok Swiftdagger",
			"		i. Accept "..cq("Harpy Raiders"),
			completion={{questaccepted="Harpy Raiders"}},
			mapzone="The Barrens",
			level=13,
			mapnote=30908250,
		}, {
			"Also at "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("Crossroads Conscription"),
			"		ii. Accept "..cq("Plainstrider Menace"),
			completion={{questturnedin="Crossroads Conscription"},{questaccepted="Plainstrider Menace"}},
			mapzone="The Barrens",
			level=13,
			mapnote=31008320,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Tonga Runetotem",
			"		i. Accept "..cq("The Forgotten Pools"),
			completion={{questaccepted="The Forgotten Pools"}},
			mapzone="The Barrens",
			level=13,
			mapnote=31908420,
		}, {
			"Go to "..cl(53,30),
			"	a. Talk to Zargh",
			"		i. Turn in "..cq("Return to the Crossroads."),
			completion={{questturnedin="Return to the Crossroads."}},
			mapzone="The Barrens",
			level=13,
			mapnote=29808240,
		}, {
			"Go northeast to "..cl(53,29),
			"	a. Kill Plainstriders",
			"	b. Get 7 Plainstrider Beaks",
			completion={{questgoal={"*","Plainstrider Beak",7}}},
			mapzone="The Barrens",
			level=13,
			mapnote=29108240,
		}, {
			"Go north to "..cl(54,25),
			"	a. Kill 8 Razormane Water Seekers",
			"	b. Kill 8 Razormane Thornweavers",
			"	c. Kill 3 Razormane Hunters",
			completion={{questgoal={"*","Razormane Water Seeker slain",8}},{questgoal={"*","Razormane Thornweaver slain",8}},{questgoal={"*","Razormane Hunter slain",3}}},
			mapzone="The Barrens",
			level=13,
			mapnote=25307950,
		}, {
			"Go east to "..cl(59,24),
			"	a. Click the Crossroads' Supply Crates",
			"	b. Get the Crossroads' Supply Crates",
			completion={{questgoal={"*","Crossroads' Supply Crates",8}}},
			mapzone="The Barrens",
			level=13,
			mapnote=24408360,
		}, {
			"Grind to level 14",
			completion={{level=14}},
			mapzone="The Barrens",
			level=13,
		}, {
			"Go northwest to "..cl(53,16),
			"	a. Kill raptors",
			"	b. Get 12 Raptor Heads",
			completion={{questgoal={"*","Raptor Head",12}}},
			mapzone="The Barrens",
			level=14,
			mapnote=16506920,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=14,
		}, {
			"Go to "..cl(52,30),
			"	a. Talk to Gazrog",
			"		i. Turn in "..cq("Raptor Thieves"),
			"		ii. Accept "..cq("Stolen Silver"),
			completion={{questturnedin="Raptor Thieves"},{questaccepted="Stolen Silver"}},
			mapzone="The Barrens",
			level=14,
			mapnote=30308220,
		}, {
			"Go to "..cl(51,31),
			"	a. Talk to Thork",
			"		i. Turn in "..cq("Disrupt the Attacks"),
			"		ii. Accept "..cq("The Disruption Ends"),
			"		iii. Turn in "..cq("Supplies for the Crossroads"),
			completion={{questturnedin="Disrupt the Attacks"},{questaccepted="The Disruption Ends"},{questturnedin="Supplies for the Crossroads"}},
			mapzone="The Barrens",
			level=14,
			mapnote=30908240,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("Plainstrider Menace"),
			"		ii. Accept "..cq("The Zhevra"),
			completion={{questturnedin="Plainstrider Menace"},{questaccepted="The Zhevra"}},
			mapzone="The Barrens",
			level=14,
			mapnote=31008320,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Mankrik",
			"		i. Accept "..cq("Consumed by Hatred"),
			"		ii. Accept "..cq("Lost in Battle"),
			completion={{questaccepted="Consumed by Hatred"},{questaccepted="Lost in Battle"}},
			mapzone="The Barrens",
			level=14,
			mapnote=31608360,
		}, {
			"Go west to "..cl(45,28),
			"	a. Talk to Regthar Deathgate",
			"		i. Accept "..cq("Centaur Bracers"),
			"		ii. Accept "..cq("Kolkar Leaders"),
			completion={{questaccepted="Centaur Bracers"},{questaccepted="Kolkar Leaders"}},
			mapzone="The Barrens",
			level=14,
			mapnote=28407370,
		}, {
			"Go northeast to "..cl(46,27),
			"	a. Kill zhevras",
			"	b. Get 4 Zhevra Hooves",
			completion={{questgoal={"*","Zhevra Hooves",4}}},
			mapzone="The Barrens",
			level=14,
			mapnote=27207320,
		}, {
			"Go north to "..cl(45,23),
			"	a. They look like big blue mushrooms around the lake",
			"	b. Click the Laden Mushrooms",
			"	c. Get 4 Fungal Spores",
			"	d. Swim underwater to the bubble",
			"	e. Explore the waters of the Forgotten Pools",
			completion={{questgoal={"*","Fungal Spores",4}},{questgoal={"*","Explore the waters of the Forgotten Pools",1}}},
			mapzone="The Barrens",
			level=14,
			mapnote=22906820,
		}, {
			"Go west to "..cl(43,23),
			"	a. Kill Barak Kodobane",
			"	b. Get Barak's Head",
			completion={{questgoal={"*","Barak's Head",1}}},
			mapzone="The Barrens",
			level=14,
			mapnote=23406600,
		}, {
			"Also at "..cl(43,23),
			"	a. Kill centaurs",
			"	b. Get 15 Centaur Bracers",
			completion={{questgoal={"*","Centaur Bracers",15}}},
			mapzone="The Barrens",
			level=14,
			mapnote=26007210,
		}, {
			"Go northwest to "..cl(41,20),
			"	a. Kill harpies",
			"	b. Get 8 Witchwing Talons",
			completion={{questgoal={"*","Witchwing Talon",8}}},
			mapzone="The Barrens",
			level=14,
			mapnote=19706040,
		}, {
			"Grind to level 15",
			completion={{level=15}},
			mapzone="The Barrens",
			level=14,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=15,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Apothecary Helbrim",
			"		i. Turn in "..cq("Fungal Spores"),
			completion={{questturnedin="Fungal Spores"}},
			mapzone="The Barrens",
			level=15,
			mapnote=30208160,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Darsok Swiftdagger",
			"		i. Turn in "..cq("Harpy Raiders"),
			"		ii. Accept "..cq("Harpy Lieutenants"),
			completion={{questturnedin="Harpy Raiders"},{questaccepted="Harpy Lieutenants"}},
			mapzone="The Barrens",
			level=15,
			mapnote=30908250,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Tonga Runetotem",
			"		i. Turn in "..cq("The Forgotten Pools"),
			"		ii. Accept "..cq("The Stagnant Oasis"),
			completion={{questturnedin="The Forgotten Pools"},{questaccepted="The Stagnant Oasis"}},
			mapzone="The Barrens",
			level=15,
			mapnote=31908420,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("The Zhevra"),
			"		ii. Accept "..cq("Prowlers of the Barrens"),
			completion={{questturnedin="The Zhevra"},{questaccepted="Prowlers of the Barrens"}},
			mapzone="The Barrens",
			level=15,
			mapnote=31008320,
		}, {
			"Go northeast to "..cl(56,24),
			"	a. Kill 8 Razormane Geomancers",
			"	b. Kill 8 Razormane Defenders",
			completion={{questgoal={"*","Razormane Geomancer slain",8}},{questgoal={"*","Razormane Defender slain",8}}},
			mapzone="The Barrens",
			level=15,
			mapnote=24208060,
		}, {
			"Go southeast to "..cl(59,27),
			"	a. Kill Kreenig Snarlsnout",
			"	b. Get Kreenig Snarlsnout's Tusk",
			completion={{questgoal={"*","Kreenig Snarlsnout's Tusk",1}}},
			mapzone="The Barrens",
			level=15,
			mapnote=26908570,
		}, {
			"Go southeast to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=15,
		}, {
			"Go to "..cl(63,36),
			"	a. Talk to Gazlowe",
			"		i. Accept "..cq("Southsea Freebooters"),
			completion={{questaccepted="Southsea Freebooters"}},
			mapzone="The Barrens",
			level=15,
			mapnote=36209890,
		}, {
			"Go to "..cl(63,37),
			"	a. Talk to Bragok",
			"		i. Get the Ratchet Flight Path",
			completion={{flightpath="Ratchet"}},
			mapzone="The Barrens",
			level=15,
			mapnote=37210030,
		}, {
			"Also at "..cl(63,37),
			"	a. Talk to Sputtervalve",
			"		i. Accept "..cq("Samophlange part 1"),
			completion={{questaccepted="Samophlange part 1"}},
			mapzone="The Barrens",
			level=15,
			mapnote=37210020,
		}, {
			"Go to "..cl(63,37),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("WANTED: Baron Longshore"),
			completion={{questaccepted="WANTED: Baron Longshore"}},
			mapzone="The Barrens",
			level=15,
			mapnote=37510010,
		}, {
			"Go to "..cl(62,38),
			"	a. Talk to Mebok Mizzyrix",
			"		i. Accept "..cq("Raptor Horns"),
			"		ii. Accept "..cq("Deepmoss Spider Eggs"),
			completion={{questaccepted="Raptor Horns"},{questaccepted="Deepmoss Spider Eggs"}},
			mapzone="The Barrens",
			level=15,
			mapnote=37610000,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Wharfmaster Dizzywig",
			"		i. Turn in "..cq("Wharfmaster Dizzywig"),
			"		ii. Accept "..cq("Miner's Fortune"),
			completion={{questturnedin="Wharfmaster Dizzywig"},{questaccepted="Miner's Fortune"}},
			mapzone="The Barrens",
			level=15,
			mapnote=38510190,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Captain Thalo'thas Brightsun",
			"		i. Accept "..cq("The Guns of Northwatch"),
			completion={{questaccepted="The Guns of Northwatch"}},
			mapzone="The Barrens",
			level=15,
			mapnote=39010130,
		}, {
			"Go southeast to "..cl(64,43),
			"	a. Kill 12 Southsea Brigands",
			"	b. Kill 6 Southsea Cannoneers",
			completion={{questgoal={"*","Southsea Brigand slain",12}},{questgoal={"*","Southsea Cannoneer slain",6}}},
			mapzone="The Barrens",
			level=15,
			mapnote=43510720,
		}, {
			"Go south to "..cl(63,50),
			"	a. He spawns randomly in the camps around this area",
			"	b. Kill Baron Longshore",
			"	c. Get Baron Longshore's Head",
			completion={{questgoal={"*","Baron Longshore's Head",1}}},
			mapzone="The Barrens",
			level=15,
			mapnote=49711300,
		}, {
			"Grind to level 16",
			completion={{level=16}},
			mapzone="The Barrens",
			level=15,
		}, {
			"Go north to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=16,
		}, {
			"Go to "..cl(63,36),
			"	a. Talk to Gazlowe",
			"		i. Turn in "..cq("Southsea Freebooters"),
			"		ii. Accept "..cq("The Missing Shipment part 1"),
			"		iii. Turn in "..cq("WANTED: Baron Longshore"),
			completion={{questturnedin="Southsea Freebooters"},{questaccepted="The Missing Shipment part 1"},{questturnedin="WANTED: Baron Longshore"}},
			mapzone="The Barrens",
			level=16,
			mapnote=36209890,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Wharfmaster Dizzywig",
			"		i. Turn in "..cq("The Missing Shipment part 1"),
			"		ii. Accept "..cq("The Missing Shipment part 2"),
			completion={{questturnedin="The Missing Shipment part 1"},{questaccepted="The Missing Shipment part 2"}},
			mapzone="The Barrens",
			level=16,
			mapnote=38510190,
		}, {
			"Go to "..cl(63,36),
			"	a. Talk to Gazlowe",
			"		i. Turn in "..cq("The Missing Shipment part 2"),
			"		ii. Accept "..cq("Stolen Booty"),
			completion={{questturnedin="The Missing Shipment part 2"},{questaccepted="Stolen Booty"}},
			mapzone="The Barrens",
			level=16,
			mapnote=36209890,
		}, {
			"Go south to "..cl(64,49),
			"	a. Click the Fragile - Do NOT Drop box",
			"	b. Get the Telescopic Lens",
			completion={{questgoal={"*","Telescopic Lens",1}}},
			mapzone="The Barrens",
			level=16,
			mapnote=49311290,
		}, {
			"Go southwest to "..cl(63,50),
			"	a. Click the Drizzlik's Emporium box",
			"	b. Get the Shipment of Boots",
			completion={{questgoal={"*","Shipment of Boots",1}}},
			mapzone="The Barrens",
			level=16,
			mapnote=49611220,
		}, {
			"Go north to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=16,
		}, {
			"Go to "..cl(63,36),
			"	a. Talk to Gazlowe",
			"		i. Turn in "..cq("Stolen Booty"),
			completion={{questturnedin="Stolen Booty"}},
			mapzone="The Barrens",
			level=16,
			mapnote=36209890,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=16,
		}, {
			"Go to "..cl(51,31),
			"	a. Talk to Thork",
			"		i. Turn in "..cq("The Disruption Ends"),
			completion={{questturnedin="The Disruption Ends"}},
			mapzone="The Barrens",
			level=16,
			mapnote=30908240,
		}, {
			"Go west to "..cl(45,28),
			"	a. Talk to Regthar Deathgate",
			"		i. Turn in "..cq("Kolkar Leaders"),
			"		ii. Accept "..cq("Verog the Dervish"),
			"		iii. Turn in "..cq("Centaur Bracers"),
			completion={{questturnedin="Kolkar Leaders"},{questaccepted="Verog the Dervish"},{questturnedin="Centaur Bracers"}},
			mapzone="The Barrens",
			level=16,
			mapnote=28407370,
		}, {
			"Go west to "..cl(35,28),
			"	a. Talk to Seereth Stonebreak",
			"		i. Turn in "..cq("The Spirits of Stonetalon"),
			"		ii. Accept "..cq("Goblin Invaders"),
			"	b. Talk to Makaba Flathoof",
			"		i. Accept "..cq("Avenge My Village"),
			completion={{questturnedin="The Spirits of Stonetalon"},{questaccepted="Goblin Invaders"},{questaccepted="Avenge My Village"}},
			mapzone="The Barrens",
			level=16,
			mapnote=27806300,
		}, {
			"Go west to Stonetalon Mountains",
			completion={{location={mapzone="Stonetalon Mountains"}}},
			mapzone="The Barrens",
			level=16,
		}, {
			"Go northwest to "..cl(81,90),
			"	a. Kill 8 Grimtotem Ruffians",
			"	b. Kill 6 Grimtotem Mercenaries",
			completion={{questgoal={"*","Grimtotem Ruffian slain",8}},{questgoal={"*","Grimtotem Mercenary slain",6}}},
			mapzone="Stonetalon Mountains",
			level=16,
			mapnote=90317090,
		}, {
			"Go southeast to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Stonetalon Mountains",
			level=16,
		}, {
			"Go to "..cl(35,28),
			"	a. Talk to Makaba Flathoof",
			"		i. Turn in "..cq("Avenge My Village"),
			"		ii. Accept "..cq("Kill Grundig Darkcloud"),
			completion={{questturnedin="Avenge My Village"},{questaccepted="Kill Grundig Darkcloud"}},
			mapzone="The Barrens",
			level=16,
			mapnote=27806300,
		}, {
			"Go west to Stonetalon Mountains",
			completion={{location={mapzone="Stonetalon Mountains"}}},
			mapzone="The Barrens",
			level=16,
		}, {
			"Go northwest to "..cl(72,88),
			"	a. Kill 6 Grimtotem Brutes",
			completion={{questgoal={"*","Grimtotem Brute slain",6}}},
			mapzone="Stonetalon Mountains",
			level=16,
			mapnote=88015950,
		}, {
			"Go northeast to "..cl(74,86),
			"	a. Kill Grundig Darkcloud",
			completion={{questgoal={"*","Grundig Darkcloud slain",1}}},
			mapzone="Stonetalon Mountains",
			level=16,
			mapnote=86115980,
		}, {
			"Grind to level 17",
			completion={{level=17}},
			mapzone="Stonetalon Mountains",
			level=16,
		}, {
			"Go southeast to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Stonetalon Mountains",
			level=17,
		}, {
			"Go to "..cl(35,28),
			"	a. Talk to Makaba Flathoof",
			"		i. Turn in "..cq("Kill Grundig Darkcloud"),
			completion={{questturnedin="Kill Grundig Darkcloud"}},
			mapzone="The Barrens",
			level=17,
			mapnote=27806300,
		}, {
			"Go east to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=17,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Korran",
			"		i. Accept "..cq("Egg Hunt"),
			completion={{questaccepted="Egg Hunt"}},
			mapzone="The Barrens",
			level=17,
			mapnote=29608070,
		}, {
			"Also at "..cl(51,30),
			"	a. Talk to Apothecary Helbrim",
			"		i. Accept "..cq("Apothecary Zamah"),
			completion={{questaccepted="Apothecary Zamah"}},
			mapzone="The Barrens",
			level=17,
			mapnote=30208160,
		}, {
			"Go to "..cl(51,31),
			"	a. Talk to Thork",
			"		i. Accept "..cq("Report to Kadrak"),
			completion={{questaccepted="Report to Kadrak"}},
			mapzone="The Barrens",
			level=17,
			mapnote=30908240,
		}, {
			"Go south to "..cl(49,50),
			"	a. Click the Beaten Corpse",
			"	b. Find Mankrik's Wife",
			completion={{questgoal={"*","Find Mankrik's Wife",1}}},
			mapzone="The Barrens",
			level=17,
			mapnote=50309960,
		}, {
			"Go southwest to "..cl(45,58),
			"	a. Talk to Tatternack Steelforge",
			"		i. Accept "..cq("Weapons of Choice"),
			completion={{questaccepted="Weapons of Choice"}},
			mapzone="The Barrens",
			level=17,
			mapnote=57710280,
		}, {
			"Go to "..cl(45,59),
			"	a. Talk to Mangletooth",
			"		i. Accept "..cq("Tribes at War"),
			completion={{questaccepted="Tribes at War"}},
			mapzone="The Barrens",
			level=17,
			mapnote=59210380,
		}, {
			"Go to "..cl(44,59),
			"Talk to Omusa Thunderhorn",
			"	a. Get the Camp Taurajo Flight Path",
			completion={{flightpath="Camp Taurajo"}},
			mapzone="The Barrens",
			level=17,
			mapnote=59210360,
		}, {
			"Go west to Mulgore",
			completion={{location={mapzone="Mulgore"}}},
			mapzone="The Barrens",
			level=17,
		}, {
			"Go northwest to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Mulgore",
			level=17,
		}, {
			"Go to "..cl(23,21),
			"	a. Talk to Apothecary Zamah",
			"		i. Turn in "..cq("Apothecary Zamah"),
			completion={{questturnedin="Apothecary Zamah"}},
			mapzone="Thunder Bluff",
			level=17,
			mapnote=20904370,
		}, {
			"Go to "..cl(47,50),
			"	a. Talk to Tal",
			"		i. Get the Thunder Bluff Flight Path",
			completion={{flightpath="Thunder Bluff"}},
			mapzone="Thunder Bluff",
			level=17,
			mapnote=49909690,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Thunder Bluff",
			level=17,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Mankrik",
			"		i. Turn in "..cq("Lost in Battle"),
			completion={{questturnedin="Lost in Battle"}},
			mapzone="The Barrens",
			level=17,
			mapnote=31608360,
		}, {
			"Go northwest to "..cl(41,24),
			"	a. Kill Savannah Prowlers",
			"	b. Get 7 Prowler Claws",
			completion={{questgoal={"*","Prowler Claws",7}}},
			mapzone="The Barrens",
			level=17,
			mapnote=23906510,
		}, {
			"Go north to "..cl(40,17),
			"	a. Kill Witchwing Slayers",
			"	b. Get 6 Harpy Lieutenant Rings",
			completion={{questgoal={"*","Harpy Lieutenant Ring",6}}},
			mapzone="The Barrens",
			level=17,
			mapnote=17205710,
		}, {
			"Go northeast to "..cl(45,14),
			"	a. Kill raptors",
			"	b. Get 5 Intact Raptor Horns",
			completion={{questgoal={"*","Intact Raptor Horn",5}}},
			mapzone="The Barrens",
			level=17,
			mapnote=13905940,
		}, {
			"Go northeast to "..cl(52,12),
			"	a. Click the Control Console",
			"		i. Turn in "..cq("Samophlange part 1"),
			"		ii. Accept "..cq("Samophlange part 2"),
			completion={{questturnedin="Samophlange part 1"},{questaccepted="Samophlange part 2"}},
			mapzone="The Barrens",
			level=17,
			mapnote=11606400,
		}, {
			"Also at "..cl(52,12),
			"	a. Click the Main Control Valve",
			"	b. Shut off the Main Control Valve",
			completion={{questgoal={"*","Shut off Main Control Valve",1}}},
			mapzone="The Barrens",
			level=17,
			mapnote=11606390,
		}, {
			"Also at "..cl(52,12),
			"	a. Click the Regulator Valve",
			"	b. Shut off the Regulator Valve",
			completion={{questgoal={"*","Shut off Regulator Valve",1}}},
			mapzone="The Barrens",
			level=17,
			mapnote=11406370,
		}, {
			"Also at "..cl(52,12),
			"	a. Click the Fuel Control Valve",
			"	b. Shut off the Fuel Control Valve",
			completion={{questgoal={"*","Shut off Fuel Control Valve",1}}},
			mapzone="The Barrens",
			level=17,
			mapnote=11406380,
		}, {
			"Also at "..cl(52,12),
			"	a. Click the Control Console",
			"		i. Turn in "..cq("Samophlange part 2"),
			"		ii. Accept "..cq("Samophlange part 3"),
			completion={{questturnedin="Samophlange part 2"},{questaccepted="Samophlange part 3"}},
			mapzone="The Barrens",
			level=17,
			mapnote=11606400,
		}, {
			"Go northeast to "..cl(53,10),
			"	a. Kill Tinkerer Sniggles",
			"	b. Get the Console Key",
			completion={{questgoal={"*","Console Key",1}}},
			mapzone="The Barrens",
			level=17,
			mapnote=10406320,
		}, {
			"Go southwest to "..cl(52,12),
			"	a. Click the Control Console",
			"		i. Turn in "..cq("Samophlange part 3"),
			"		ii. Accept "..cq("Samophlange part 4"),
			completion={{questturnedin="Samophlange part 3"},{questaccepted="Samophlange part 4"}},
			mapzone="The Barrens",
			level=17,
			mapnote=11606400,
		}, {
			"Grind to level 18",
			completion={{level=18}},
			mapzone="The Barrens",
			level=17,
		}, {
			"Go northeast to "..cl(57,7),
			"	a. Talk to Wizzlecrank's Shredder",
			"		i. Accept "..cq("Ignition"),
			completion={{questaccepted="Ignition"}},
			mapzone="The Barrens",
			level=18,
			mapnote=7506400,
		}, {
			"Go southwest to "..cl(56,8),
			"	a. Kill Supervisor Lugwizzle",
			"	b. Get the Ignition Key",
			completion={{questgoal={"*","Ignition Key",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=8306450,
		}, {
			"Go northeast to "..cl(57,7),
			"	a. Talk to Wizzlecrank's Shredder",
			"		i. Turn in "..cq("Ignition"),
			"		ii. Accept "..cq("The Escape"),
			"	b. Escort Wizzlecrank out of the Venture Co. drill site",
			completion={{questturnedin="Ignition"},{questaccepted="The Escape"},{questgoal={"*","Escort Wizzlecrank out of the Venture Co. drill site",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=7506400,
		}, {
			"Go east to "..cl(62,6),
			"	a. Kill Venture Co. mobs",
			"	b. Get the Cats Eye Emerald",
			completion={{questgoal={"*","Cats Eye Emerald",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=5906740,
		}, {
			"Go south to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=18,
		}, {
			"Go to "..cl(63,37),
			"	a. Talk to Sputtervalve",
			"		i. Turn in "..cq("Samophlange part 4"),
			"		ii. Turn in "..cq("The Escape"),
			"		iii. Accept "..cq("Ziz Fizziks"),
			completion={{questturnedin="Samophlange part 4"},{questturnedin="The Escape"},{questaccepted="Ziz Fizziks"}},
			mapzone="The Barrens",
			level=18,
			mapnote=37210020,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Wharfmaster Dizzywig",
			"		i. Turn in "..cq("Miner's Fortune"),
			completion={{questturnedin="Miner's Fortune"}},
			mapzone="The Barrens",
			level=18,
			mapnote=38510190,
		}, {
			"Go to "..cl(62,38),
			"	a. Talk to Mebok Mizzyrix",
			"		i. Turn in "..cq("Raptor Horns"),
			completion={{questturnedin="Raptor Horns"}},
			mapzone="The Barrens",
			level=18,
			mapnote=37610000,
		}, {
			"Go southwest to "..cl(55,41),
			"	a. Kill centaurs until a centaur says 'I am slain! Summon Verog!' as it dies",
			mapzone="The Barrens",
			level=18,
			mapnote=41009620,
		}, {
			"Go southwest to "..cl(53,42),
			"	a. Kill Verog the Dervish",
			"	b. Get Verog's Head",
			completion={{questgoal={"*","Verog's Head",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=41009620,
		}, {
			"Go southeast to "..cl(56,43),
			"	a. Swim underwater to the bubbles",
			"	b. Click the Bubbling Fissure",
			"	c. Test the Dried Seeds",
			completion={{questgoal={"*","Test the Dried Seeds",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=42809840,
		}, {
			"Go northwest to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=18,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Tonga Runetotem",
			"		i. Turn in "..cq("The Stagnant Oasis"),
			"		ii. Accept "..cq("Altered Beings"),
			completion={{questturnedin="The Stagnant Oasis"},{questaccepted="Altered Beings"}},
			mapzone="The Barrens",
			level=18,
			mapnote=31908420,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("Prowlers of the Barrens"),
			"		ii. Accept "..cq("Echeyakee"),
			completion={{questturnedin="Prowlers of the Barrens"},{questaccepted="Echeyakee"}},
			mapzone="The Barrens",
			level=18,
			mapnote=31008320,
		}, {
			"Also at "..cl(52,31),
			"	a. Talk to Darsok Swiftdagger",
			"		i. Turn in "..cq("Harpy Lieutenants"),
			"		ii. Accept "..cq("Serena Bloodfeather"),
			completion={{questturnedin="Harpy Lieutenants"},{questaccepted="Serena Bloodfeather"}},
			mapzone="The Barrens",
			level=18,
			mapnote=30908250,
		}, {
			"Go northeast to "..cl(56,17),
			"	a. Use the Horn of Echeyakee to summon him",
			"	b. Kill Echeyakee",
			"	c. Get Echeyakee's Hide",
			completion={{questgoal={"*","Echeyakee's Hide",1}}},
			mapzone="The Barrens",
			level=18,
			mapnote=17107290,
		}, {
			"Go northwest to 48,5",
			"	a. Talk to Kadrak",
			"		i. Turn in "..cq("Report to Kadrak"),
			completion={{questturnedin="Report to Kadrak"}},
			mapzone="The Barrens",
			level=18,
			mapnote=5405350,
		}, {
			"Grind to level 19",
			completion={{level=19}},
			mapzone="The Barrens",
			level=18,
		}, {
			"Go west to "..cl(40,12),
			"	a. Kill Serena Bloodfeather",
			"	b. Get Serena's Head",
			completion={{questgoal={"*","Serena's Head",1}}},
			mapzone="The Barrens",
			level=19,
			mapnote=12505200,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=19,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("Echeyakee"),
			"		ii. Accept "..cq("The Angry Scytheclaws"),
			completion={{questturnedin="Echeyakee"},{questaccepted="The Angry Scytheclaws"}},
			mapzone="The Barrens",
			level=19,
			mapnote=31008320,
		}, {
			"also at "..cl(52,31),
			"	a. Talk to Darsok Swiftdagger",
			"		i. Turn in "..cq("Serena Bloodfeather"),
			"		ii. Accept "..cq("Letter to Jin'Zil"),
			completion={{questturnedin="Serena Bloodfeather"},{questaccepted="Letter to Jin'Zil"}},
			mapzone="The Barrens",
			level=19,
			mapnote=30908250,
		}, {
			"Go southeast to "..cl(55,43),
			"	a. Kill snapjaws",
			"	b. Get 8 Altered Snapjaw Shells",
			completion={{questgoal={"*","Altered Snapjaw Shell",8}}},
			mapzone="The Barrens",
			level=19,
			mapnote=43509890,
		}, {
			"Go southwest to "..cl(52,46),
			"	a. Kill raptors",
			"	b. Get 3 Sunscale Feathers",
			"	c. Click the Blue Raptor Nest",
			"	d. Visit the Blue Raptor Nest",
			"	e. Click the Yellow Raptor Nest",
			"	f. Visit the Yellow Raptor Nest",
			"	g. Click the Red Raptor Nest",
			"	h. Visit the Red Raptor Nest",
			completion={{questgoal={"*","Visit Blue Raptor Nest",1}},{questgoal={"*","Visit Yellow Raptor Nest",1}},{questgoal={"*","Visit Red Raptor Nest",1}}},
			mapzone="The Barrens",
			level=19,
			mapnote=46109830,
		}, {
			"Go southeast to "..cl(57,52),
			"	a. The path to 'Stolen Silver' starts here",
			completion={{location={dist=0.5}}},
			mapzone="The Barrens",
			level=19,
			mapnote=51910930,
		}, {
			"Go south to "..cl(58,54),
			"	a. Click the chest of Stolen Silver",
			"	b. Get the Stolen Silver",
			completion={{questgoal={"*","Stolen Silver",1}}},
			mapzone="The Barrens",
			level=19,
			mapnote=53911190,
		}, {
			"Go west to "..cl(54,52),
			"	a. Kill 6 Bristleback Water Seekers",
			"	b. Kill 12 Bristleback Thornweavers",
			"	c. Kill 12 Bristleback Geomancers",
			"	d. Kill Bristleback mobs",
			"	e. Get 60 Bristleback Quilboar Tusks",
			"	f. Get 1 Blood Shard",
			completion={{questgoal={"*","Bristleback Water Seeker slain",6}},{questgoal={"*","Bristleback Thornweaver slain",12}},{questgoal={"*","Bristleback Geomancer slain",12}},{questgoal={"*","Bristleback Quilboar Tusk",60}},{questgoal={"*","Blood Shard",1}}},
			mapzone="The Barrens",
			level=19,
			mapnote=52010550,
		}, {
			"Grind to level 20",
			completion={{level=20}},
			mapzone="The Barrens",
			level=19,
		}
	  },
	},
	{ sectiontitle = "Levels (20-25)",
	  steps = {
		{
			"Go southwest to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="The Barrens",
			level=20,
		}, {
			"Go to "..cl(45,59),
			"	a. Talk to Jorn Skyseer",
			"		i. Accept "..cq("Melor Sends Word"),
			completion={{questaccepted="Melor Sends Word"}},
			mapzone="The Barrens",
			level=20,
			mapnote=59110400,
		}, {
			"Also at "..cl(45,59),
			"	a. Talk to Mangletooth",
			"		i. Turn in "..cq("Tribes at War"),
			"		ii. Accept "..cq("Blood Shards of Agamaggan"),
			"		iii. Turn in "..cq("Blood Shards of Agamaggan"),
			"		iv. Accept "..cq("Betrayal from Within part 1"),
			completion={{questturnedin="Tribes at War"},{questaccepted="Blood Shards of Agamaggan"},{questturnedin="Blood Shards of Agamaggan"},{questaccepted="Betrayal from Within part 1"}},
			mapzone="The Barrens",
			level=20,
			mapnote=59210380,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=20,
		}, {
			"Go to "..cl(52,30),
			"	a. Talk to Gazrog",
			"		i. Turn in "..cq("Stolen Silver"),
			completion={{questturnedin="Stolen Silver"}},
			mapzone="The Barrens",
			level=20,
			mapnote=30308220,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Sergra Darkthorn",
			"		i. Turn in "..cq("The Angry Scytheclaws"),
			"		ii. Accept "..cq("Jorn Skyseer"),
			completion={{questturnedin="The Angry Scytheclaws"},{questaccepted="Jorn Skyseer"}},
			mapzone="The Barrens",
			level=20,
			mapnote=31008320,
		}, {
			"Go to "..cl(52,32),
			"	a. Talk to Mankrik",
			"		i. Turn in "..cq("Consumed by Hatred"),
			completion={{questturnedin="Consumed by Hatred"}},
			mapzone="The Barrens",
			level=20,
			mapnote=31608360,
		}, {
			"Also at "..cl(52,32),
			"	a. Talk to Tonga Runetotem",
			"		i. Turn in "..cq("Altered Beings"),
			"		ii. Accept "..cq("Hamuul Runetotem"),
			completion={{questturnedin="Altered Beings"},{questaccepted="Hamuul Runetotem"}},
			mapzone="The Barrens",
			level=20,
			mapnote=31908420,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="The Barrens",
			level=20,
		}, {
			"Go to "..cl(45,38),
			"	a. Talk to Warcaller Gorlach",
			"		i. Accept "..cq("The Ashenvale Hunt"),
			completion={{questaccepted="The Ashenvale Hunt"}},
			mapzone="Orgrimmar",
			level=20,
			mapnote=38408140,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Orgrimmar",
			level=20,
		}, {
			"Go south to "..cl(62,38),
			"	a. Kill Theramore Marines",
			"	b. Get 10 Theramore Medals",
			completion={{questgoal={"*","Theramore Medal",10}}},
			mapzone="The Barrens",
			level=20,
			mapnote=53711570,
		}, {
			"Go south to "..cl(62,54),
			"	a. Go to the top of the tower",
			"	b. Kill Captain Fairmount",
			completion={{questgoal={"*","Captain Fairmount slain",1}}},
			mapzone="The Barrens",
			level=20,
			mapnote=54711660,
		}, {
			"Go southeast to "..cl(63,57),
			"	a. Go to the top of the tower",
			"	b. Kill Cannoneer Smythe",
			completion={{questgoal={"*","Cannoneer Smythe slain",1}}},
			mapzone="The Barrens",
			level=20,
			mapnote=56711980,
		}, {
			"Go northwest to "..cl(60,55),
			"	a. Go to the top of the tower",
			"	b. Kill Cannoneer Whessan",
			completion={{questgoal={"*","Cannoneer Whessan slain",1}}},
			mapzone="The Barrens",
			level=20,
			mapnote=54811530,
		}, {
			"Go east to "..cl(62,55),
			"	a. Talk to Gilthares Firebough",
			"		i. Accept "..cq("Free From the Hold"),
			"	b. Escort Gilthares Firebough back to Ratchet",
			completion={{questaccepted="Free From the Hold"},{questgoal={"*","Escort Gilthares Firebough back to Ratchet",1}}},
			mapzone="The Barrens",
			level=20,
			mapnote=55011700,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Captain Thalo'thas Brightsun",
			"		i. Turn in "..cq("The Guns of Northwatch"),
			"		ii. Turn in "..cq("Free From the Hold"),
			completion={{questturnedin="The Guns of Northwatch"},{questturnedin="Free From the Hold"}},
			mapzone="The Barrens",
			level=20,
			mapnote=39010130,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=20,
		}, {
			"Go west to "..cl(45,28),
			"	a. Talk to Regthar Deathgate",
			"		i. Turn in "..cq("Verog the Dervish"),
			completion={{questturnedin="Verog the Dervish"}},
			mapzone="The Barrens",
			level=20,
			mapnote=28407370,
		}, {
			"Grind to level 21",
			completion={{level=21}},
			mapzone="The Barrens",
			level=20,
		}, {
			"Go west to Stonetalon Mountains",
			completion={{location={mapzone="Stonetalon Mountains"}}},
			mapzone="The Barrens",
			level=21,
		}, {
			"Go west to "..cl(71,95),
			"	a. Talk to Xen'Zilla",
			"		i. Accept "..cq("Blood Feeders"),
			completion={{questaccepted="Blood Feeders"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=95016620,
		}, {
			"Go to "..cl(73,95),
			"	a. Talk to Darn Talongrip",
			"		i. Accept "..cq("Report to Kadrak"),
			completion={{questaccepted="Report to Kadrak"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=94916810,
		}, {
			"Go to "..cl(75,98),
			"	a. Talk to Witch Doctor Jin'Zil",
			"		i. Turn in "..cq("Letter to Jin'Zil"),
			"		ii. Accept "..cq("Jin'Zil's Forest Magic"),
			completion={{questturnedin="Letter to Jin'Zil"},{questaccepted="Jin'Zil's Forest Magic"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=97917240,
		}, {
			"Go northwest to "..cl(70,88),
			"	a. Kill 10 Deepmoss Creepers",
			completion={{questgoal={"*","Deepmoss Creeper slain",10}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=88415810,
		}, {
			"Go northwest to "..cl(61,67),
			"	a. Kill 7 Deepmoss Venomspitters",
			completion={{questgoal={"*","Deepmoss Venomspitter slain",7}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=67212850,
		}, {
			"Go north to "..cl(61,64),
			"	a. Click the Deepmoss Eggs",
			"	b. Get 15 Deepmoss Eggs",
			completion={{questgoal={"*","Deepmoss Egg",15}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=64212520,
		}, {
			"Go west to "..cl(59,63),
			"	a. Talk to Ziz Fizziks",
			"		i. Turn in "..cq("Ziz Fizziks"),
			"		ii. Accept "..cq("Super Reaper 6000"),
			completion={{questturnedin="Ziz Fizziks"},{questaccepted="Super Reaper 6000"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=62612160,
		}, {
			"Go northeast to "..cl(65,58),
			"	a. Kill 15 Venture Co. Loggers",
			completion={{questgoal={"*","Venture Co. Logger slain",15}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=57712220,
		}, {
			"Go northwest to "..cl(63,54),
			"	a. Kill Venture Co. Operators",
			"	b. Get the Super Reaper 6000 Blueprints",
			completion={{questgoal={"*","Super Reaper 6000 Blueprints",1}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=53811640,
		}, {
			"Go southwest to "..cl(59,63),
			"	a. Talk to Ziz Fizziks",
			"		i. Turn in "..cq("Super Reaper 6000"),
			"		ii. Accept "..cq("Further Instructions part 1"),
			completion={{questturnedin="Super Reaper 6000"},{questaccepted="Further Instructions part 1"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=62612160,
		}, {
			"Go northwest to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Stonetalon Mountains",
			level=21,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Maggran Earthbinder",
			"		i. Accept "..cq("Harpies Threaten"),
			completion={{questaccepted="Harpies Threaten"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=61210840,
		}, {
			"Go to "..cl(47,58),
			"	a. Talk to Tammra Windfield",
			"		i. Accept "..cq("Cycle of Rebirth"),
			completion={{questaccepted="Cycle of Rebirth"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=58410590,
		}, {
			"Go to "..cl(46,60),
			"	a. Talk to Braelyn Firehand",
			"		i. Accept "..cq("Cenarius' Legacy"),
			completion={{questaccepted="Cenarius' Legacy"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=60410630,
		}, {
			"Go to "..cl(45,60),
			"	a. Talk to Tharm",
			"		i. Get the Sun Rock Retreat Flight Path",
			completion={{flightpath="Sun Rock Retreat"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=59810490,
		}, {
			"To the right of Tharm, there is a path up the hill",
			"	a. Follow the path up and take the first left",
			completion={{location={mapzone="Stonetalon Mountains",x=44.6,y=61.8, dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=21,
		}, {
			"Go to "..cl(47,64),
			"	a. Talk to Mor'rogal",
			"		i. Accept "..cq("Boulderslide Ravine"),
			"	b. Talk to Tsunaman",
			"		i. Accept "..cq("Trouble in the Deeps"),
			"		ii. Accept "..cq("Elemental War"),
			completion={{questaccepted="Boulderslide Ravine"},{questaccepted="Trouble in the Deeps"},{questaccepted="Elemental War"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=64211140,
		}, {
			"Go southeast to "..cl(67,88),
			"	a. The path to 'Boulderslide Ravine' starts here",
			completion={{location={dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=88215540,
		}, {
			"Go southwest to "..cl(61,92),
			"	a. Click the Resonite Crystals inside the cave",
			"	b. Get 10 Resonite Crystals",
			completion={{questgoal={"*","Resonite Crystal",10}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=92415370,
		}, {
			"Go northwest to 59,90 inside the cave",
			"	a. Investigate the Cave in Boulderslide Ravine",
			completion={{questgoal={"*","Investigate Cave in Boulderslide Ravine",1}}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=90014910,
		}, {
			"Leave the cave",
			completion={{location={mapzone="Stonetalon Mountains",x=61.8,y=93.0, dist=0.5}}},
			mapzone="Stonetalon Mountains",
			level=21,
		}, {
			"Go southeast to "..cl(71,95),
			"	a. Talk to Xen'Zilla",
			"		i. Turn in "..cq("Blood Feeders"),
			completion={{questturnedin="Blood Feeders"}},
			mapzone="Stonetalon Mountains",
			level=21,
			mapnote=95016620,
		}, {
			"Go southeast to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Stonetalon Mountains",
			level=21,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Seereth Stonebreak",
			"		i. Turn in "..cq("Goblin Invaders"),
			"		ii. Accept "..cq("The Elder Crone"),
			"		iii. Accept "..cq("Shredding Machines"),
			completion={{questturnedin="Goblin Invaders"},{questaccepted="The Elder Crone"},{questaccepted="Shredding Machines"}},
			mapzone="The Barrens",
			level=21,
			mapnote=27806300,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=21,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=21,
		}, {
			"Go to "..cl(63,37),
			"	a. Talk to Sputtervalve",
			"		i. Turn in "..cq("Further Instructions part 1"),
			"		ii. Accept "..cq("Further Instructions part 2"),
			completion={{questturnedin="Further Instructions part 1"},{questaccepted="Further Instructions part 2"}},
			mapzone="The Barrens",
			level=21,
			mapnote=37210020,
		}, {
			"Go to "..cl(62,38),
			"	a. Talk to Mebok Mizzyrix",
			"		i. Turn in "..cq("Deepmoss Spider Eggs"),
			completion={{questturnedin="Deepmoss Spider Eggs"}},
			mapzone="The Barrens",
			level=21,
			mapnote=37610000,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="The Barrens",
			level=21,
		}, {
			"Go to "..cl(62,81),
			"	a. Talk to Melor Stonehoof",
			"		i. Turn in "..cq("Melor Sends Word"),
			"		ii. Accept "..cq("Steelsnap"),
			completion={{questturnedin="Melor Sends Word"},{questaccepted="Steelsnap"}},
			mapzone="Thunder Bluff",
			level=21,
			mapnote=80914240,
		}, {
			"Go to "..cl(70,31),
			"	a. Talk to Magatha Grimtotem",
			"		i. Turn in "..cq("The Elder Crone"),
			"		ii. Accept "..cq("Forsaken Aid"),
			completion={{questturnedin="The Elder Crone"},{questaccepted="Forsaken Aid"}},
			mapzone="Thunder Bluff",
			level=21,
			mapnote=30910080,
		}, {
			"Go to "..cl(79,29),
			"	a. Talk to Arch Druid Hamuul Runetotem",
			"		i. Turn in "..cq("Hamuul Runetotem"),
			"		ii. Accept "..cq("Nara Wildmane"),
			completion={{questturnedin="Hamuul Runetotem"},{questaccepted="Nara Wildmane"}},
			mapzone="Thunder Bluff",
			level=21,
			mapnote=28510710,
		}, {
			"Go to "..cl(76,32),
			"	a. Talk to Nara Wildmane",
			"		i. Turn in "..cq("Nara Wildmane"),
			completion={{questturnedin="Nara Wildmane"}},
			mapzone="Thunder Bluff",
			level=21,
			mapnote=31610730,
		}, {
			"Go to "..cl(23,21),
			"	a. Talk to Apothecary Zamah",
			"		i. Turn in "..cq("Forsaken Aid"),
			"		ii. Accept "..cq("Journey to Tarren Mill"),
			completion={{questturnedin="Forsaken Aid"},{questaccepted="Journey to Tarren Mill"}},
			mapzone="Thunder Bluff",
			level=21,
			mapnote=20904370,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Thunder Bluff",
			level=21,
		}, {
			"Go northwest to 48,5",
			"	a. Talk to Kadrak",
			"		i. Turn in "..cq("Report to Kadrak"),
			completion={{questturnedin="Report to Kadrak"}},
			mapzone="The Barrens",
			level=21,
			mapnote=5405350,
		}, {
			"Grind to level 22",
			completion={{level=22}},
			mapzone="The Barrens",
			level=21,
		}, {
			"Go north to Ashenvale",
			completion={{location={mapzone="Ashenvale"}}},
			mapzone="The Barrens",
			level=22,
		}, {
			"Go northeast to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=71.3,y=68.0, dist=2}}},
			mapzone="Ashenvale",
			level=22,
		}, {
			"Go to "..cl(74,61),
			"	a. Talk to Senani Thunderheart",
			"		i. Turn in "..cq("The Ashenvale Hunt"),
			completion={{questturnedin="The Ashenvale Hunt"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=61513530,
		}, {
			"Go to "..cl(73,62),
			"	a. Talk to Vhulgra",
			"		i. Get the Splintertree Post Flight Path",
			completion={{flightpath="Splintertree Post"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=61613480,
		}, {
			"Go west to "..cl(37,57),
			"	a. The path to bypass Astranaar starts here",
			completion={{location={mapzone="Ashenvale",x=36.6,y=57.2, dist=0.3}}},
			mapzone="Ashenvale",
			level=22,
			mapnote=57109370,
		}, {
			"Go northwest to the Zoram Strand",
			completion={{location={mapzone="Ashenvale",x=16.8,y=28.9, dist=2}}},
			mapzone="Ashenvale",
			level=22,
		}, {
			"Go to "..cl(12,34),
			"	a. Talk to Andruk",
			"		i. Get the Zoram Strand Flight Path",
			completion={{flightpath="Zoram Strand"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=33804600,
		}, {
			"Go to "..cl(12,35),
			"	a. Talk to Marukai",
			"		i. Accept "..cq("Naga at the Zoram Strand"),
			completion={{questaccepted="Naga at the Zoram Strand"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=34904660,
		}, {
			"Go to "..cl(12,34),
			"	a. Talk to Je'neu Sancrea",
			"		i. Turn in "..cq("Trouble in the Deeps"),
			completion={{questturnedin="Trouble in the Deeps"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=34304590,
		}, {
			"Go north to "..cl(13,31),
			"	a. Kill nagas",
			"		i. Get 20 Wrathtail Heads",
			completion={{questgoal={"*","Wrathtail Head",20}}},
			mapzone="Ashenvale",
			level=22,
			mapnote=30804340,
		}, {
			"Go south to "..cl(12,35),
			"	a. Talk to Marukai",
			"		i. Turn in "..cq("Naga at the Zoram Strand"),
			completion={{questturnedin="Naga at the Zoram Strand"}},
			mapzone="Ashenvale",
			level=22,
			mapnote=34904660,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Ashenvale",
			level=22,
		}, {
			"Fly to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="The Barrens",
			level=22,
		}, {
			"Go to "..cl(45,49),
			"	a. Talk to Jorn Skyseer",
			"		i. Turn in "..cq("Jorn Skyseer"),
			"		ii. Accept "..cq("Ishamuhale"),
			completion={{questturnedin="Jorn Skyseer"},{questaccepted="Ishamuhale"}},
			mapzone="The Barrens",
			level=22,
			mapnote=59110400,
		}, {
			"Make Camp Taurajo your home",
			completion={{home="Camp Taurajo"}},
			mapzone="The Barrens",
			level=22,
		}, {
			"Go south to "..cl(45,62),
			"Click Chen's Empty Keg",
			"	a. Get Chen's Empty Keg",
			"	b. Click Chen's Empty Keg in your bags",
			"		i. Accept "..cq("Chen's Empty Keg"),
			completion={{questaccepted="Chen's Empty Keg"}},
			mapzone="The Barrens",
			level=22,
			mapnote=62210720,
		}, {
			"Go south to "..cl(45,69),
			"	a. Click the Silithid Mounds",
			"	b. Get 12 Silithid Eggs",
			completion={{questgoal={"*","Silithid Egg",12}}},
			mapzone="The Barrens",
			level=22,
			mapnote=69211430,
		}, {
			"Go south to "..cl(46,79),
			"	a. He walks north and south on this road",
			"	b. Talk to Gann Stonespire",
			"		i. Accept "..cq("Gann's Reclamation"),
			completion={{questaccepted="Gann's Reclamation"}},
			mapzone="The Barrens",
			level=22,
			mapnote=79112510,
		}, {
			"Go southwest to "..cl(45,81),
			"	a. He wanders around this area",
			"	b. Kill Kuz",
			"	c. Get Kuz's Skull",
			completion={{questgoal={"*","Kuz's Skull",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=80812580,
		}, {
			"Go northwest to "..cl(44,80),
			"	a. Kill Razormane Pathfinders",
			"	b. Get a Razormane Backstabber",
			completion={{questgoal={"*","Razormane Backstabber",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=80212460,
		}, {
			"Go northwest to "..cl(42,79),
			"	a. Kill Razormane Seers",
			"	b. Get a Charred Razormane Wand",
			"	c. Kill Razormane Warfrenzies",
			"	d. Get a Razormane War Shield",
			completion={{questgoal={"*","Charred Razormane Wand",1}},{questgoal={"*","Razormane War Shield",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=78912090,
		}, {
			"Go southwest to "..cl(41,81),
			"	a. The path up to 'Betrayal From Within' starts here",
			completion={{location={mapzone="The Barrens",x=41.1,y=80.5, dist=0.3}}},
			mapzone="The Barrens",
			level=22,
			mapnote=80612170,
		}, {
			"Go west to "..cl(40,81),
			"	a. Kill Lok Orcbane",
			"	b. Get Lok's Skull",
			completion={{questgoal={"*","Lok's Skull",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=80612070,
		}, {
			"Go southeast to "..cl(44,83),
			"	a. He walks around this area",
			"	b. Kill Nak",
			"	c. Get Nak's Skull",
			completion={{questgoal={"*","Nak's Skull",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=83312720,
		}, {
			"Go southeast to "..cl(46,85),
			"	a. Kill 15 Bael'dun Excavators",
			"	b. Kill 5 Bael'dun Foremen",
			completion={{questgoal={"*","Bael'dun Excavator slain",15}},{questgoal={"*","Bael'dun Foreman slain",5}}},
			mapzone="The Barrens",
			level=22,
			mapnote=85213170,
		}, {
			"Go northeast to "..cl(47,85),
			"	a. Kill Prospector Khazgorm",
			"	b. Get Khazgorm's Journal",
			completion={{questgoal={"*","Khazgorm's Journal",1}}},
			mapzone="The Barrens",
			level=22,
			mapnote=84913220,
		}, {
			"Go northwest to "..cl(46,79),
			"	a. He walks north and south on this road",
			"	b. Talk to Gann Stonespire",
			"		i. Turn in "..cq("Gann's Reclamation"),
			"		ii. Accept "..cq("Revenge of Gann part 1"),
			completion={{questturnedin="Gann's Reclamation"},{questaccepted="Revenge of Gann part 1"}},
			mapzone="The Barrens",
			level=22,
			mapnote=79112510,
		}, {
			"Hearth to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="The Barrens",
			level=22,
		}, {
			"Go to "..cl(45,58),
			"	a. Talk to Tatternack Steelforge",
			"		i. Turn in "..cq("Weapons of Choice"),
			completion={{questturnedin="Weapons of Choice"}},
			mapzone="The Barrens",
			level=22,
			mapnote=57710280,
		}, {
			"Go to "..cl(45,59),
			"	a. Talk to Mangletooth",
			"		i. Turn in "..cq("Betrayal from Within part 1"),
			"		ii. Accept "..cq("Betrayal from Within part 2"),
			completion={{questturnedin="Betrayal from Within part 1"},{questaccepted="Betrayal from Within part 2"}},
			mapzone="The Barrens",
			level=22,
			mapnote=59210380,
		}, {
			"Grind to level 23",
			completion={{level=23}},
			mapzone="The Barrens",
			level=22,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=23,
		}, {
			"Go to "..cl(52,31),
			"	a. Talk to Thork",
			"		i. Turn in "..cq("Betrayal from Within part 2"),
			completion={{questturnedin="Betrayal from Within part 2"}},
			mapzone="The Barrens",
			level=23,
			mapnote=30908240,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Korran",
			"		i. Turn in "..cq("Egg Hunt"),
			completion={{questturnedin="Egg Hunt"}},
			mapzone="The Barrens",
			level=23,
			mapnote=29608070,
		}, {
			"Kill a Zhevra anywhere and get a Fresh Zhevra Carcass",
			completion={{questgoal={"*","Fresh Zhevra Carcass",1}}},
			mapzone="The Barrens",
			level=23,
		}, {
			"Go east to "..cl(60,30),
			"	a. Stand next to the bushes at the base of the tree with no leaves",
			"	b. Use the Fresh Zhevra Carcass to summon Ishamuhale",
			"	c. Kill Ishamuhale",
			"	d. Get Ishamuhale's Fang",
			completion={{questgoal={"*","Ishamuhale's Fang",1}}},
			mapzone="The Barrens",
			level=23,
			mapnote=30008980,
		}, {
			"Go southeast to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=23,
		}, {
			"Go to "..cl(62,38),
			"	a. Talk to Brewmaster Drohn",
			"		i. Turn in "..cq("Chen's Empty Keg"),
			completion={{questturnedin="Chen's Empty Keg"}},
			mapzone="The Barrens",
			level=23,
			mapnote=38410070,
		}, {
			"Fly to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="The Barrens",
			level=23,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Maggran Earthbinder",
			"		i. Accept "..cq("Calling in the Reserves"),
			completion={{questaccepted="Calling in the Reserves"}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=61210840,
		}, {
			"Make Sun Rock Retreat your home",
			completion={{home="Sun Rock Retreat"}},
			mapzone="Stonetalon Mountains",
			level=23,
		}, {
			"Go to "..cl(47,64),
			"	a. Talk to Mor'rogal",
			"		i. Turn in "..cq("Boulderslide Ravine"),
			completion={{questturnedin="Boulderslide Ravine"}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=64211140,
		}, {
			"Go northeast to "..cl(52,43),
			"	a. Click the Gaea Seeds",
			"	b. Get 10 Gaea Seeds",
			completion={{questgoal={"*","Gaea Seed",10}}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=42609440,
		}, {
			"Go northwest to "..cl(46,27),
			"	a. Kill coursers",
			"	b. Get 30 Courser Eyes",
			completion={{questgoal={"*","Courser Eye",30}}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=26507270,
		}, {
			"Go northwest to "..cl(38,18),
			"	a. Kill Sap Beasts",
			"	b. Get 5 Stonetalon Saps",
			"	c. Kill Fey Dragons",
			"	d. Get a Fey Dragon Scale",
			completion={{questgoal={"*","Stonetalon Sap",5}},{questgoal={"*","Fey Dragon Scale",1}}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=18605630,
		}, {
			"Go northwest to "..cl(37,16),
			"	a. Kill 4 Sons of Cenarius",
			"	b. Kill 4 Daughters of Cenarius",
			"	c. Kill 4 Cenarion Botanists",
			completion={{questgoal={"*","Son of Cenarius slain",4}},{questgoal={"*","Daughter of Cenarius slain",4}},{questgoal={"*","Cenarion Botanist slain",4}}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=15905270,
		}, {
			"Go northwest to 34,8",
			"	a. Kill Twilight Runners",
			"	b. Get 5 Twilight Whiskers",
			completion={{questgoal={"*","Twilight Whisker",5}}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=8204190,
		}, {
			"Go southeast to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Stonetalon Mountains",
			level=23,
		}, {
			"Go to "..cl(47,58),
			"	a. Talk to Tammra Windfield",
			"		i. Turn in "..cq("Cycle of Rebirth"),
			"		ii. Accept "..cq("New Life"),
			completion={{questturnedin="Cycle of Rebirth"},{questaccepted="New Life"}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=58410590,
		}, {
			"Go to "..cl(46,60),
			"	a. Talk to Braelyn Firehand",
			"		i. Turn in "..cq("Cenarius' Legacy"),
			completion={{questturnedin="Cenarius' Legacy"}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=60410630,
		}, {
			"Go east to "..cl(59,63),
			"	a. Talk to Ziz Fizziks",
			"		i. Turn in "..cq("Further Instructions part 2"),
			"		ii. Accept "..cq("Gerenzo Wrenchwhistle"),
			completion={{questturnedin="Further Instructions part 2"},{questaccepted="Gerenzo Wrenchwhistle"}},
			mapzone="Stonetalon Mountains",
			level=23,
			mapnote=62612160,
		}, {
			"Grind to level 24",
			completion={{level=24}},
			mapzone="Stonetalon Mountains",
			level=23,
		}, {
			"Go northeast to "..cl(61,55),
			"	a. XT:9 wanders around this area",
			"	b. Kill XT:9",
			completion={{questgoal={"*","XT:9 slain",1}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=54611610,
		}, {
			"Go northeast to "..cl(72,46),
			"	a. XT:4 wanders around this area",
			"	b. Kill XT:4",
			completion={{questgoal={"*","XT:4 slain",1}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=46411800,
		}, {
			"Go northwest to "..cl(70,41),
			"	a. The path up to 'Gerenzo Wrenchwhistle' starts here",
			completion={{location={mapzone="Stonetalon Mountains",x=70.1,y=40.7, dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=40711090,
		}, {
			"Go west to "..cl(64,39),
			"	a. He spawns in different places on this dock high rise thing",
			"	b. Kill Gerenzo Wrenchwhistle",
			"	c. Get Gerenzo's Mechanical Arm",
			completion={{questgoal={"*","Gerenzo's Mechanical Arm",1}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=38910300,
		}, {
			"Go southwest to "..cl(59,63),
			"	a. Talk to Ziz Fizziks",
			"		i. Turn in "..cq("Gerenzo Wrenchwhistle"),
			completion={{questturnedin="Gerenzo Wrenchwhistle"}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=62612160,
		}, {
			"Go south to "..cl(59,76),
			"	a. Click the Wanted Poster: Besseleth",
			"		i. Accept "..cq("Arachnophobia"),
			completion={{questaccepted="Arachnophobia"}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=75713480,
		}, {
			"Go west to "..cl(58,76),
			"	a. The path up to 'Arachnophobia' starts here",
			completion={{location={mapzone="Stonetalon Mountains",x=58.1,y=76.1, dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=76013400,
		}, {
			"Go northwest to "..cl(55,72),
			"	a. She's a big orange spider",
			"	b. She spawns in different spots in this valley",
			"	c. Kill Besseleth",
			"	d. Get Besseleth's Fang",
			completion={{questgoal={"*","Besseleth's Fang",1}}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=71912650,
		}, {
			"Go southeast to "..cl(75,98),
			"	a. Talk to Witch Doctor Jin'Zil",
			"		i. Turn in "..cq("Jin'Zil's Forest Magic"),
			completion={{questturnedin="Jin'Zil's Forest Magic"}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=97917240,
		}, {
			"Go southeast to the Barrens",
			completion={{location={mapzone="The Barrens"}}},
			mapzone="Stonetalon Mountains",
			level=24,
		}, {
			"Go to "..cl(35,28),
			"	a. Talk to Seereth Stonebreak",
			"		i. Turn in "..cq("Shredding Machines"),
			completion={{questturnedin="Shredding Machines"}},
			mapzone="The Barrens",
			level=24,
			mapnote=27806300,
		}, {
			"Hearth to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="The Barrens",
			level=24,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Maggran Earthbinder",
			"		i. Turn in "..cq("Arachnophobia"),
			completion={{questturnedin="Arachnophobia"}},
			mapzone="Stonetalon Mountains",
			level=24,
			mapnote=61210840,
		}, {
			"Fly to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="Stonetalon Mountains",
			level=24,
		}, {
			"Go to "..cl(45,59),
			"	a. Talk to Jorn Skyseer",
			"		i. Turn in "..cq("Ishamuhale"),
			"		ii. Accept "..cq("Enraged Thunder Lizards"),
			completion={{questturnedin="Ishamuhale"},{questaccepted="Enraged Thunder Lizards"}},
			mapzone="The Barrens",
			level=24,
			mapnote=59110400,
		}, {
			"Make Camp Taurajo your home",
			completion={{home="Camp Taurajo"}},
			mapzone="The Barrens",
			level=24,
		}, {
			"Go northeast to "..cl(48,57),
			"	a. Kill Thunderheads",
			"	b. Get 3 Thunder Lizard Blood",
			completion={{questgoal={"*","Thunder Lizard Blood",3}}},
			mapzone="The Barrens",
			level=24,
			mapnote=56610440,
		}, {
			"Go south to "..cl(49,85),
			"	a. Kill Bael'dun mobs",
			"	b. Get 6 Nitroglycerin",
			"	c. Get 6 Wood Pulp",
			"	d. Get 6 Sodium Nitrate",
			completion={{questgoal={"*","Nitroglycerin",6}},{questgoal={"*","Wood Pulp",6}},{questgoal={"*","Sodium Nitrate",6}}},
			mapzone="The Barrens",
			level=24,
			mapnote=84613310,
		}, {
			"Go northwest to "..cl(46,79),
			"	a. He walks north and south on this road",
			"	b. Talk to Gann Stonespire",
			"		i. Turn in "..cq("Revenge of Gann part 1"),
			"		ii. Accept "..cq("Revenge of Gann part 2"),
			completion={{questturnedin="Revenge of Gann part 1"},{questaccepted="Revenge of Gann part 2"}},
			mapzone="The Barrens",
			level=24,
			mapnote=79112510,
		}, {
			"Go south to "..cl(47,86),
			"	a. Click the Bael Modan Flying Machine",
			"	b. Destroy the Bael Modan Flying Machine",
			completion={{questgoal={"*","Bael Modan Flying Machine destroyed",1}}},
			mapzone="The Barrens",
			level=24,
			mapnote=85613260,
		}, {
			"Go north to "..cl(46,79),
			"	a. He walks north and south on this road",
			"	b. Talk to Gann Stonespire",
			"		i. Turn in "..cq("Revenge of Gann part 2"),
			completion={{questturnedin="Revenge of Gann part 2"}},
			mapzone="The Barrens",
			level=24,
			mapnote=79112510,
		}, {
			"Go southwest to Thousand Needles",
			completion={{location={mapzone="Thousand Needles"}}},
			mapzone="The Barrens",
			level=24,
		}, {
			"Go to "..cl(32,22),
			"	a. Talk to Grish Longrunner",
			"		i. Turn in "..cq("Calling in the Reserves"),
			completion={{questturnedin="Calling in the Reserves"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=21705360,
		}, {
			"Also at "..cl(32,22),
			"	a. Talk to Brave Moonhorn",
			"		i. Accept "..cq("Message to Freewind Post"),
			completion={{questaccepted="Message to Freewind Post"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=22205440,
		}, {
			"Go southeast to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Thousand Needles",
			level=24,
		}, {
			"Go to "..cl(45,49),
			"	a. Talk to Nyse",
			"		i. Get the Freewind Post Flight Path",
			completion={{flightpath="Freewind Post"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=49109420,
		}, {
			"Go to "..cl(45,50),
			"	a. Talk to Hagar Lightninghoof",
			"		i. Accept "..cq("Alien Egg"),
			completion={{questaccepted="Alien Egg"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=50309490,
		}, {
			"Go to "..cl(46,51),
			"	a. Talk to Cliffwatcher Longhorn",
			"		i. Turn in "..cq("Message to Freewind Post"),
			"		ii. Accept "..cq("Pacify the Centaur"),
			completion={{questturnedin="Message to Freewind Post"},{questaccepted="Pacify the Centaur"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=50809640,
		}, {
			"Also at "..cl(46,51),
			"	a. Click the Wanted Poster - Arnak Grimtotem",
			"		i. Accept "..cq("Wanted - Arnak Grimtotem"),
			completion={{questaccepted="Wanted - Arnak Grimtotem"}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=50809680,
		}, {
			"Go northeast to "..cl(49,43),
			"	a. Kill 12 Galak Scouts",
			"	b. Kill 10 Galak Wranglers",
			"	c. Kill 6 Galak Windchasers",
			completion={{questgoal={"*","Galak Scout slain",12}},{questgoal={"*","Galak Wrangler slain",10}},{questgoal={"*","Galak Windchaser slain",6}}},
			mapzone="Thousand Needles",
			level=24,
			mapnote=42609120,
		}, {
			"Grind to level 25",
			completion={{level=25}},
		}
	  },
	},
	{ sectiontitle = "Levels (25-30)",
	  steps = {
		{
			"Go southeast to "..cl(55,45),
			"	a. The path up to the Weathered Nook starts here",
			completion={{location={mapzone="Thousand Needles",x=54.7,y=44.6, dist=0.3}}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=44509920,
		}, {
			"Go northwest to "..cl(54,41),
			"	a. Talk to Dorn Plainstalker",
			"		i. Accept "..cq("Test of Faith"),
			completion={{questaccepted="Test of Faith"}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=41509540,
		}, {
			"Go to "..cl(26,32),
			"	a. Stand on the 2 planks",
			"	b. Jump off of the plateau",
			"	c. You will not die",
			"	d. You will be teleported back to the cave",
			mapzone="Thousand Needles",
			level=25,
			mapnote=32405880,
		}, {
			"Go to "..cl(54,41),
			"	a. Talk to Dorn Plainstalker",
			"		i. Turn in "..cq("Test of Faith"),
			completion={{questturnedin="Test of Faith"}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=41509540,
		}, {
			"Go south to "..cl(52,55),
			"	a. Click the big white Alien Egg",
			"	b. Get the Alien Egg",
			"	c. If the egg is not here, that are 2 other places it could be - they are:",
			"		i. At "..cl(56,60),
			"		ii. At "..cl(38,56),
			completion={{questgoal={"*","Alien Egg",1}}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=54610680,
		}, {
			"Go to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Thousand Needles",
			level=25,
		}, {
			"Go to "..cl(46,51),
			"	a. Talk to Cliffwatcher Longhorn",
			"		i. Turn in "..cq("Pacify the Centaur"),
			"		ii. Accept "..cq("Grimtotem Spying"),
			completion={{questturnedin="Pacify the Centaur"},{questaccepted="Grimtotem Spying"}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=50809640,
		}, {
			"Go to "..cl(45,50),
			"	a. Talk to Hagar Lightninghoof",
			"		i. Turn in "..cq("Alien Egg"),
			"		ii. Accept "..cq("Serpent Wild"),
			completion={{questturnedin="Alien Egg"},{questaccepted="Serpent Wild"}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=50309490,
		}, {
			"Go to "..cl(45,49),
			"	a. Talk to Elu",
			"		i. Accept "..cq("Wind Rider"),
			completion={{questaccepted="Wind Rider"}},
			mapzone="Thousand Needles",
			level=25,
			mapnote=49009380,
		}, {
			"Hearth to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="Thousand Needles",
			level=25,
		}, {
			"Go to "..cl(45,59),
			"	a. Talk to Jorn Skyseer",
			"		i. Turn in "..cq("Enraged Thunder Lizards"),
			"		ii. Accept "..cq("Cry of the Thunderhawk"),
			completion={{questturnedin="Enraged Thunder Lizards"},{questaccepted="Cry of the Thunderhawk"}},
			mapzone="The Barrens",
			level=25,
			mapnote=59110400,
		}, {
			"Go northeast to "..cl(46,57),
			"	a. Kill thunderhawks",
			"	b. Get a Thunderhawk Wings",
			completion={{questgoal={"*","Thunderhawk Wings",1}}},
			mapzone="The Barrens",
			level=25,
			mapnote=57010350,
		}, {
			"Go southwest to "..cl(45,59),
			"	a. Jorn Skyseer",
			"		i. Turn in "..cq("Cry of the Thunderhawk"),
			completion={{questturnedin="Cry of the Thunderhawk"}},
			mapzone="The Barrens",
			level=25,
			mapnote=59110400,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="The Barrens",
			level=25,
		}, {
			"Go to "..cl(55,51),
			"	a. Talk to Zangen Stonehoof",
			"		i. Accept "..cq("The Sacred Flame part 1"),
			completion={{questaccepted="The Sacred Flame part 1"}},
			mapzone="Thunder Bluff",
			level=25,
			mapnote=51410640,
		}, {
			"Fly to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Thunder Bluff",
			level=25,
		}, {
			"Go up the path to the right of the Flight Path",
			"	a. Follow it over to the Charred Vale",
			completion={{location={mapzone="Stonetalon Mountains",x=44.6,y=61.8, dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=25,
		}, {
			"Go to "..cl(38,66),
			"	a. They look like dirt mounds",
			"	b. Click the Gaea Dirt Mounds",
			"	c. Plant 10 Gaea Seeds",
			completion={{questgoal={"*","Gaea seed planted",10}}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=66210400,
		}, {
			"Go west to "..cl(36,65),
			"	a. Kill fire elementals",
			"	b. Get 10 Incendrites",
			completion={{questgoal={"*","Incendrites",10}}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=65310120,
		}, {
			"Go south to "..cl(36,68),
			"	a. Kill 7 Bloodfury Slayers",
			"	b. Kill 7 Bloodfury Roguefeathers",
			completion={{questgoal={"*","Bloodfury Slayer slain",7}},{questgoal={"*","Bloodfury Roguefeather slain",7}}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=68710440,
		}, {
			"Go northwest to "..cl(33,67),
			"	a. Kill 7 Bloodfury Harpies",
			"	b. Kill 7 Bloodfury Ambushers",
			completion={{questgoal={"*","Bloodfury Harpy slain",7}},{questgoal={"*","Bloodfury Ambusher slain",7}}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=67209980,
		}, {
			"Go to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Stonetalon Mountains",
			level=25,
		}, {
			"Go to "..cl(47,64),
			"	a. Talk to Tsunaman",
			"		i. Turn in "..cq("Elemental War"),
			completion={{questturnedin="Elemental War"}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=64211140,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Maggran Earthbinder",
			"		i. Turn in "..cq("Harpies Threaten"),
			"		ii. Accept "..cq("Bloodfury Bloodline"),
			completion={{questturnedin="Harpies Threaten"},{questaccepted="Bloodfury Bloodline"}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=61210840,
		}, {
			"Go to "..cl(47,58),
			"	a. Talk to Tammra Windfield",
			"		i. Turn in "..cq("New Life"),
			completion={{questturnedin="New Life"}},
			mapzone="Stonetalon Mountains",
			level=25,
			mapnote=58410590,
		}, {
			"Grind to level 26",
			completion={{level=26}},
			mapzone="Stonetalon Mountains",
			level=25,
		}, {
			"Fly to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Stonetalon Mountains",
			level=26,
		}, {
			"Make Splintertree Post your home",
			completion={{home="Splintertree Post"}},
			mapzone="Ashenvale",
			level=26,
		}, {
			"Go to "..cl(74,60),
			"	a. Talk to Mastok Wrilehiss",
			"		i. Accept "..cq("Stonetalon Standstill"),
			completion={{questaccepted="Stonetalon Standstill"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=60013370,
		}, {
			"Go to "..cl(73,61),
			"	a. Talk to Pixel",
			"		i. Accept "..cq("Satyr Horns"),
			completion={{questaccepted="Satyr Horns"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=61513460,
		}, {
			"Go to "..cl(71,68),
			"	a. Talk to Kuray'bin",
			"		i. Accept "..cq("Ashenvale Outrunners"),
			completion={{questaccepted="Ashenvale Outrunners"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=68113920,
		}, {
			"Go southeast to "..cl(72,71),
			"	a. They are stealthed around this area",
			"	b. Kill 9 Ashenvale Outrunners",
			completion={{questgoal={"*","Ashenvale Outrunner slain",9}}},
			mapzone="Ashenvale",
			level=26,
			mapnote=70614260,
		}, {
			"Go southwest to "..cl(68,75),
			"	a. Talk to Torek",
			"		i. Make sure the 3 Splintertree Raiders are there",
			"		ii. Accept "..cq("Torek's Assault"),
			"	b. Escort Torek",
			"	c. Take Silverwing Outpost.",
			completion={{questaccepted="Torek's Assault"},{questgoal={"*","Take Silverwing Outpost.",1}}},
			mapzone="Ashenvale",
			level=26,
			mapnote=75314360,
		}, {
			"Go northwest to "..cl(49,70),
			"	a. Stand in the glowing gazebo",
			"	b. Scout the gazebo on Mystral Lake that overlooks the nearby Alliance outpost.",
			completion={{questgoal={"*","Scout the gazebo on Mystral Lake that overlooks the nearby Alliance outpost.",1}}},
			mapzone="Ashenvale",
			level=26,
			mapnote=69611850,
		}, {
			"Go west to "..cl(48,70),
			"	a. Kill 12 Befouled Water Elementals",
			"	b. Tideress walks around this area",
			"	c. Kill Tideress",
			"	d. Get the Befouled Water Globe",
			"	e. Click the Befouled Water Globe",
			"		i. Accept "..cq("The Befouled Element"),
			completion={{questgoal={"*","Befouled Water Elemental slain",12}},{questaccepted="The Befouled Element"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=69711740,
		}, {
			"Go northwest to "..cl(42,66),
			"	a. Ursangous wanders around this area",
			"	b. Kill Ursangous",
			"	c. Get Ursangous's Paw",
			"	d. Click Ursangous's Paw",
			"		i. Accept "..cq("Ursangous's Paw"),
			completion={{questaccepted="Ursangous's Paw"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=65610790,
		}, {
			"Go northeast to "..cl(58,56),
			"	a. Kill Laughing Sisters",
			"	b. Get an Etched Phial",
			"	c. Shadumbra walks around this area",
			"	d. Kill Shadumbra",
			"	e. Get Shadumbra's Head",
			"	f. Click Shadumbra's Head",
			"		i. Accept "..cq("Shadumbra's Head"),
			completion={{questgoal={"*","Etched Phial",1}},{questaccepted="Shadumbra's Head"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=56211410,
		}, {
			"Hearth to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Ashenvale",
			level=26,
		}, {
			"Go to "..cl(74,60),
			"	a. Talk to Mastok Wrilehiss",
			"		i. Turn in "..cq("Stonetalon Standstill"),
			"		ii. Turn in "..cq("The Befouled Element"),
			"		iii. Accept "..cq("Je'neu of the Earthen Ring"),
			completion={{questturnedin="Stonetalon Standstill"},{questturnedin="The Befouled Element"},{questaccepted="Je'neu of the Earthen Ring"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=60013370,
		}, {
			"Go to "..cl(74,61),
			"	a. Talk to Senani Thunderheart",
			"		i. Turn in "..cq("Ursangous's Paw"),
			"		ii. Turn in "..cq("Shadumbra's Head"),
			completion={{questturnedin="Ursangous's Paw"},{questturnedin="Shadumbra's Head"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=61513530,
		}, {
			"Go to "..cl(73,62),
			"	a. Talk to Ertog Ragetusk",
			"		i. Turn in "..cq("Torek's Assault"),
			completion={{questturnedin="Torek's Assault"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=62513550,
		}, {
			"Go to "..cl(71,68),
			"	a. Talk to Kuray'bin",
			"		i. Turn in "..cq("Ashenvale Outrunners"),
			completion={{questturnedin="Ashenvale Outrunners"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=68113920,
		}, {
			"Go southwest to "..cl(70,71),
			"	a. Talk to Gurda Ragescar",
			"		i. Accept "..cq("The Lost Pages"),
			completion={{questaccepted="The Lost Pages"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=71214120,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Ashenvale",
			level=26,
		}, {
			"Buy any pages you need from the Auction House",
			"	a. You need the following pages of the Shredder Operating Manual:",
			"		i. Chapter 1 - 1, 2, 3, 4",
			"		ii. Chapter 2 - 5, 6, 7, 8",
			"		iii. Chapter 3 - 9, 10, 11, 12",
			completion={{questgoal={"*","Shredder Operating Manual - Chapter 1",1}},{questgoal={"*","Shredder Operating Manual - Chapter 2",1}},{questgoal={"*","Shredder Operating Manual - Chapter 3",1}}},
			mapzone="Orgrimmar",
			level=26,
		}, {
			"Fly to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Orgrimmar",
			level=26,
		}, {
			"Go southwest to "..cl(70,71),
			"	a. Talk to Gurda Ragescar",
			"		i. Turn in "..cq("The Lost Pages"),
			completion={{questturnedin="The Lost Pages"}},
			mapzone="Ashenvale",
			level=26,
			mapnote=71214120,
		}, {
			"Grind to level 27",
			completion={{level=27}},
			mapzone="Ashenvale",
			level=26,
		}, {
			"Go northeast to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go to "..cl(73,60),
			"	a. Talk to Valusha",
			"		i. Accept "..cq("Destroy the Legion"),
			completion={{questaccepted="Destroy the Legion"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=60413360,
		}, {
			"Fly to Zoram'gar Outpost",
			completion={{location={mapzone="Ashenvale",x=12.1,y=34.2, dist=2}}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go to "..cl(12,34),
			"	a. Talk to Je'neu Sancrea",
			"		i. Turn in "..cq("Je'neu of the Earthen Ring"),
			completion={{questturnedin="Je'neu of the Earthen Ring"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34304590,
		}, {
			"Go to "..cl(12,35),
			"	a. Talk to Karang Amakkar",
			"		i. Accept "..cq("Between a Rock and a Thistlefur"),
			completion={{questaccepted="Between a Rock and a Thistlefur"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34504640,
		}, {
			"Also at "..cl(12,35),
			"	a. Talk to Mitsuwa",
			"		i. Accept "..cq("Troll Charm"),
			completion={{questaccepted="Troll Charm"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34904660,
		}, {
			"Also at "..cl(12,35),
			"	a. Talk to Muglash",
			"		i. Accept "..cq("Vorsha the Lasher"),
			"	d. Escort and protect Muglash",
			"	e. Kill Vorsha the Lasher",
			completion={{questaccepted="Vorsha the Lasher"},{questgoal={"*","Defeat Vorsha the Lasher",1}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34604670,
		}, {
			"Go southeast to "..cl(12,34),
			"	a. Talk to Warsong Runner",
			"		i. Turn in "..cq("Vorsha the Lasher"),
			completion={{questturnedin="Vorsha the Lasher"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34204640,
		}, {
			"Go southeast to "..cl(31,47),
			"	a. The path to 'Between a Rock and a Thistlefur' starts here",
			completion={{location={mapzone="Ashenvale",x=31.3,y=46.6, dist=0.3}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=46607790,
		}, {
			"Go north to "..cl(31,45),
			"	a. Kill 12 Thistlefur Avengers",
			"	b. Kill 12 Thistlefur Shamans",
			completion={{questgoal={"*","Thistlefur Avenger slain",12}},{questgoal={"*","Thistlefur Shaman slain",12}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=44807610,
		}, {
			"Go northeast to "..cl(37,32),
			"	a. The path up to 'Troll Charm' starts here",
			completion={{location={mapzone="Ashenvale",x=37.4,y=32.3, dist=0.3}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=32406990,
		}, {
			"Go into the cave",
			completion={{location={mapzone="Ashenvale",x=38.4,y=30.6, dist=0.5}}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go east to "..cl(40,32),
			"	a. Click the Troll Chests inside the cave",
			"	b. Get 8 Troll Charms",
			completion={{questgoal={"*","Troll Charm",8}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=32507250,
		}, {
			"Go northwest to Zoram'gar Outpost",
			completion={{location={mapzone="Ashenvale",x=12.1,y=34.2, dist=2}}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go to "..cl(12,35),
			"	a. Talk to Karang Amakkar",
			"		i. Turn in "..cq("Between a Rock and a Thistlefur"),
			completion={{questturnedin="Between a Rock and a Thistlefur"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34504640,
		}, {
			"Also at "..cl(12,35),
			"	a. Talk to Mitsuwa",
			"		i. Turn in "..cq("Troll Charm"),
			completion={{questturnedin="Troll Charm"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=34904660,
		}, {
			"Hearth to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go west to "..cl(60,73),
			"	a. Use your Etched Phial while standing in the moonwell water",
			"	b. Get a Filled Etched Phial",
			completion={{questgoal={"*","Filled Etched Phial",1}}},
			mapzone="Ashenvale",
			level=27,
			mapnote=72913310,
		}, {
			"Go east to "..cl(80,68),
			"	a. Kill 6 Mannoroc Lashers",
			"	b. Kill 6 Roaming Felguards",
			"	c. Kill 6 Searing Infernals",
			"	d. Kill Legion mobs",
			"	e. Get the Diabolical Plans",
			"	f. Click the Diabolical Plans",
			"		i. Accept "..cq("Diabolical Plans"),
			completion={{questgoal={"*","Mannoroc Lasher slain",6}},{questgoal={"*","Roaming Felguard slain",6}},{questgoal={"*","Searing Infernal slain",6}},{questaccepted="Diabolical Plans"}},
			mapzone="Ashenvale",
			level=27,
			mapnote=68014830,
		}, {
			"Grind to level 28",
			completion={{level=28}},
			mapzone="Ashenvale",
			level=27,
		}, {
			"Go north to "..cl(82,52),
			"	a. Kill satyrs",
			"	b. Get 16 Satyr Horns",
			completion={{questgoal={"*","Satyr Horns",16}}},
			mapzone="Ashenvale",
			level=28,
			mapnote=52013380,
		}, {
			"Go southwest to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Ashenvale",
			level=28,
		}, {
			"Go to "..cl(73,60),
			"	a. Talk to Valusha",
			"		i. Turn in "..cq("Destroy the Legion"),
			"		ii. Turn in "..cq("Diabolical Plans"),
			completion={{questturnedin="Destroy the Legion"},{questturnedin="Diabolical Plans"}},
			mapzone="Ashenvale",
			level=28,
			mapnote=60413360,
		}, {
			"Go to "..cl(73,61),
			"	a. Talk to Pixel",
			"		i. Turn in "..cq("Satyr Horns"),
			completion={{questturnedin="Satyr Horns"}},
			mapzone="Ashenvale",
			level=28,
			mapnote=61513460,
		}, {
			"Fly to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Ashenvale",
			level=28,
		}, {
			"Follow the path to the right of the Flight Path over to the Charred Vale",
			completion={{location={mapzone="Stonetalon Mountains",x=44.6,y=61.8, dist=0.3}}},
			mapzone="Stonetalon Mountains",
			level=28,
		}, {
			"Go northwest to "..cl(31,62),
			"	a. Kill the Bloodfury Ripper",
			"	b. Get the Bloodfury Ripper's Remains",
			completion={{questgoal={"*","Bloodfury Ripper's Remains",1}}},
			mapzone="Stonetalon Mountains",
			level=28,
			mapnote=62409320,
		}, {
			"Go to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Stonetalon Mountains",
			level=28,
		}, {
			"Go to "..cl(47,61),
			"	a. Talk to Maggran Earthbinder",
			"		i. Turn in "..cq("Bloodfury Bloodline"),
			completion={{questturnedin="Bloodfury Bloodline"}},
			mapzone="Stonetalon Mountains",
			level=28,
			mapnote=61210840,
		}, {
			"Make Sun Rock Retreat your home",
			completion={{home="Sun Rock Retreat"}},
			mapzone="Stonetalon Mountains",
			level=28,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Stonetalon Mountains",
			level=28,
		}, {
			"Go to "..cl(55,51),
			"	a. Talk to Zangen Stonehoof",
			"		i. Turn in "..cq("The Sacred Flame part 1"),
			"		ii. Accept "..cq("The Sacred Flame part 2"),
			completion={{questturnedin="The Sacred Flame part 1"},{questaccepted="The Sacred Flame part 2"}},
			mapzone="Thunder Bluff",
			level=28,
			mapnote=51410640,
		}, {
			"Fly to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Thunder Bluff",
			level=28,
		}, {
			"Go to "..cl(46,52),
			"	a. Talk to Rau Cliffrunner",
			"		i. Turn in "..cq("The Sacred Flame part 2"),
			"		ii. Accept "..cq("The Sacred Flame part 3"),
			completion={{questturnedin="The Sacred Flame part 2"},{questaccepted="The Sacred Flame part 3"}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=51709780,
		}, {
			"Go to "..cl(46,50),
			"	a. Talk to Magistrix Elosai",
			"		i. Accept "..cq("A Different Approach"),
			completion={{questaccepted="A Different Approach"}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=50409660,
		}, {
			"Go northwest to "..cl(44,37),
			"	a. The path to 'The Sacred Flame' part 3 starts here",
			"	b. Go inside the cave",
			"	c. Follow the path to the left",
			completion={{location={mapzone="Thousand Needles",x=44.0,y=37.3, dist=0.3}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=37308140,
		}, {
			"Go to "..cl(42,31),
			"	a. Click the Ancient Brazier",
			"	b. Get the Cloven Hoof",
			completion={{questgoal={"*","Cloven Hoof",1}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=31507350,
		}, {
			"Go west to "..cl(21,32),
			"	a. Talk to Motega Firemane",
			"		i. Turn in "..cq("Serpent Wild"),
			"		ii. Accept "..cq("Sacred Fire"),
			completion={{questturnedin="Serpent Wild"},{questaccepted="Sacred Fire"}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=32405390,
		}, {
			"Go east to "..cl(34,34),
			"	a. Click the Incendia Agave in the water",
			"	b. Get 10 Incendia Agave",
			completion={{questgoal={"*","Incendia Agave",10}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=34106770,
		}, {
			"Go northwest to "..cl(18,28),
			"	a. Steelsnap wanders around this area",
			"	b. Kill Steelsnap",
			"	c. Get Steelsnap's Rib",
			completion={{questgoal={"*","Steelsnap's Rib",1}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=28204580,
		}, {
			"Go southwest to "..cl(15,32),
			"	a. The path up to 'Wind Rider' starts here",
			completion={{location={mapzone="Thousand Needles",x=14.6,y=32.6, dist=0.3}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=32504700,
		}, {
			"Go northwest to "..cl(11,31),
			"	a. Click the Highperch Wyvern Eggs on the ground",
			"	b. Get 10 Highperch Wyvern Eggs",
			completion={{questgoal={"*","Highperch Wyvern Egg",10}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=30804150,
		}, {
			"Go southeast to "..cl(13,39),
			"	a. The path up to Pao'ka Swiftmountain starts here",
			completion={{location={mapzone="Thousand Needles",x=13.2,y=39.4, dist=0.3}},{questgoal={"*","Escort Pao'ka from Highperch",1}}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=39505270,
		}, {
			"Go east to "..cl(18,41),
			"	a. Talk to Pao'ka Swiftmountain",
			"		i. Accept "..cq("Homeward Bound"),
			"	b. Escort Pao'ka Swiftmountain to safety",
			completion={{questaccepted="Homeward Bound"}},
			mapzone="Thousand Needles",
			level=28,
			mapnote=40605850,
		}, {
			"Grind to level 29",
			completion={{level=29}},
			mapzone="Thousand Needles",
			level=28,
		}, {
			"Go northwest to "..cl(13,26),
			"	a. Kill Thundering Boulderkin",
			"	b. Get 2 Purifying Earth",
			completion={{questgoal={"*","Purifying Earth",2}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=26303950,
		}, {
			"Hearth to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Thousand Needles",
			level=29,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Thousand Needles",
			level=29,
		}, {
			"Go to "..cl(70,31),
			"	a. Talk Magatha Grimtotem",
			"		i. Turn in "..cq("Sacred Fire"),
			"		ii. Accept "..cq("Arikara"),
			completion={{questturnedin="Sacred Fire"},{questaccepted="Arikara"}},
			mapzone="Thunder Bluff",
			level=29,
			mapnote=30910080,
		}, {
			"Go to "..cl(62,81),
			"	b. Talk to Melor Stonehoof",
			"		i. Turn in "..cq("Steelsnap"),
			"		ii. Accept "..cq("Frostmaw"),
			completion={{questturnedin="Steelsnap"},{questaccepted="Frostmaw"}},
			mapzone="Thunder Bluff",
			level=29,
			mapnote=80914240,
		}, {
			"Fly to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Thunder Bluff",
			level=29,
		}, {
			"Go to "..cl(45,49),
			"	a. Talk to Elu",
			"		i. Turn in "..cq("Wind Rider"),
			completion={{questturnedin="Wind Rider"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=49009380,
		}, {
			"Go to "..cl(46,52),
			"	a. Talk to Rau Cliffrunner",
			"		i. Turn in "..cq("The Sacred Flame part 3"),
			completion={{questturnedin="The Sacred Flame part 3"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=51709780,
		}, {
			"Make Freewind Post your home",
			completion={{home="Freewind Post"}},
			mapzone="Thousand Needles",
			level=29,
		}, {
			"Go northwest to "..cl(31,37),
			"	a. The path up to 'Grimtotem Spying' starts here",
			completion={{location={mapzone="Thousand Needles",x=31.2,y=36.9, dist=0.3}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=36906810,
		}, {
			"Go southeast to "..cl(34,40),
			"	a. Click the Document Chest in the big tent",
			"	b. Get the Secret Note #2",
			completion={{questgoal={"*","Secret Note #2",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=40007380,
		}, {
			"Go northwest to "..cl(32,33),
			"	a. Click the Document Chest",
			"	b. Get the Secret Note #1",
			completion={{questgoal={"*","Secret Note #1",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=32606440,
		}, {
			"Go southeast to "..cl(39,42),
			"	a. Click the Document Chest in the big tent",
			"	b. Get the Secret Note #3",
			completion={{questgoal={"*","Secret Note #3",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=41508080,
		}, {
			"Go northwest to "..cl(38,35),
			"	a. Click the Sacred Fire of Life",
			"	b. Light the Sacred Fire of Life to summon Arikara",
			"	c. Kill Arikara",
			"	d. Get the Arikara Serpent Skin",
			completion={{questgoal={"*","Light the Sacred Fire of Life",1}},{questgoal={"*","Arikara Serpent Skin",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=35307330,
		}, {
			"Go north to "..cl(39,29),
			"	a. Arnak Grimtotem walks around here",
			"	b. Kill Arnak Grimtotem",
			"	c. Get Arnak's Hoof",
			completion={{questgoal={"*","Arnak's Hoof",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=28606750,
		}, {
			"Go northwest to "..cl(38,27),
			"	a. Talk to Lakota Windsong",
			"		i. Accept "..cq("Free at Last"),
			"	c. Escort Lakota Windsong from the Darkcloud Pinnacle.",
			completion={{questaccepted="Free at Last"},{questgoal={"*","Escort Lakota Windsong from the Darkcloud Pinnacle.",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=26706440,
		}, {
			"Go northwest to "..cl(21,32),
			"	a. Talk to Motega Firemane",
			"		i. Turn in "..cq("Homeward Bound"),
			"		ii. Turn in "..cq("Arikara"),
			"	d. Talk to Wizlo Bearingshiner",
			"		i. Turn in "..cq("A Different Approach"),
			"		ii. Accept "..cq("A Dip in the Moonwell"),
			completion={{questturnedin="Homeward Bound"},{questturnedin="Arikara"},{questturnedin="A Different Approach"},{questaccepted="A Dip in the Moonwell"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=32405390,
		}, {
			"Go to "..cl(22,31),
			"	a. Walk east and west on this road from this spot to the fork to the east",
			"	b. Find the Galak Messenger",
			"	c. Kill the Galak Messenger",
			"	d. Get the Assassination Note",
			"	e. Click the Assassination Note",
			"		i. Accept "..cq("Assassination Plot"),
			completion={{questaccepted="Assassination Plot"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=31005310,
		}, {
			"Go to "..cl(21,32),
			"	a. Talk to Kanati Greycloud",
			"		i. Turn in "..cq("Assassination Plot"),
			"		ii. Accept "..cq("Protect Kanati Greycloud"),
			"	b. Protect Kanati Greycloud from centaur attack",
			"		i. Turn in "..cq("Protect Kanati Greycloud"),
			completion={{questturnedin="Assassination Plot"},{questaccepted="Protect Kanati Greycloud"},{questturnedin="Protect Kanati Greycloud"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=32105340,
		}, {
			"Go northwest to "..cl(12,19),
			"	a. The path to 'A Dip in the Moonwell' starts here",
			"		i. You can get up on the ledge at this spot",
			completion={{location={mapzone="Thousand Needles",x=12.0,y=18.8, dist=0.3}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=18803080,
		}, {
			"Go to 9,19",
			"	a. Stand next to the Concealed Control Panel",
			"	b. Dismiss your pet if you have one",
			"	c. Use your Robotron Control Unit",
			"	d. While in control of the Robotron 3000:",
			"		i. Walk west to the moonwell",
			"		ii. Use the Gather Water ability on the Roboton 3000 pet toolbar while standing in the moonwell water",
			"	e. Get the Thalanaar Moonwell Water",
			completion={{questgoal={"*","Thalanaar Moonwell Water",1}}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=18702820,
		}, {
			"Go southeast to "..cl(21,32),
			"	a. Talk to Wizlo Bearingshiner",
			"		i. Turn in "..cq("A Dip in the Moonwell"),
			"		ii. Accept "..cq("Testing the Tonic"),
			completion={{questturnedin="A Dip in the Moonwell"},{questaccepted="Testing the Tonic"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=32405390,
		}, {
			"Hearth to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Thousand Needles",
			level=29,
		}, {
			"Go to "..cl(46,52),
			"	a. Talk to Thalia Amberhide",
			"		i. Turn in "..cq("Free at Last"),
			completion={{questturnedin="Free at Last"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=51709780,
		}, {
			"Go to "..cl(46,51),
			"	a. Talk to Cliffwatcher Longhorn",
			"		i. Turn in "..cq("Grimtotem Spying"),
			"		ii. Turn in "..cq("Wanted - Arnak Grimtotem"),
			completion={{questturnedin="Grimtotem Spying"},{questturnedin="Wanted - Arnak Grimtotem"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=50809640,
		}, {
			"Go to "..cl(46,50),
			"	a. Talk to Magistrix Elosai",
			"		i. Turn in "..cq("Testing the Tonic"),
			completion={{questturnedin="Testing the Tonic"}},
			mapzone="Thousand Needles",
			level=29,
			mapnote=50409660,
		}, {
			"Grind to level 30",
			completion={{level=30}},
			mapzone="Thousand Needles",
			level=29,
		}
	  },
	},
	{ sectiontitle = "Levels (30-35)",
	  steps = {
		{
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Thousand Needles",
			level=30,
		}, {
			"Make Orgrimmar your home",
			completion={{home="Orgrimmar"}},
			mapzone="Orgrimmar",
			level=30,
		}, {
			"Go outside to Durotar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=30,
		}, {
			"Go east to "..cl(51,14),
			"	a. Ride the zeppelin to Undercity",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=58.8, dist=2}}},
			mapzone="Durotar",
			level=30,
			mapnote=13306410,
		}, {
			"Go southwest to Silverpine Forest",
			completion={{location={mapzone="Silverpine Forest"}}},
			mapzone="Tirisfal Glades",
			level=30,
		}, {
			"Go south to Hillsbrad Foothills",
			completion={{location={mapzone="Hillsbrad Foothills"}}},
			mapzone="Silverpine Forest",
			level=30,
		}, {
			"Go east to "..cl(21,47),
			"	a. Talk to Deathstalker Lesh",
			"		i. Accept "..cq("Time To Strike"),
			completion={{questaccepted="Time To Strike"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=47406820,
		}, {
			"Go northeast to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Hillsbrad Foothills",
			level=30,
		}, {
			"Go to "..cl(60,19),
			"	a. Talk to Zarise",
			"		i. Get the Tarren Mill Flight Path",
			completion={{flightpath="Tarren Mill"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=18607870,
		}, {
			"Go to "..cl(61,19),
			"	a. Talk to Apothecary Lydon",
			"		i. Turn in "..cq("Journey to Tarren Mill"),
			"		ii. Accept "..cq("Elixir of Pain part 1"),
			completion={{questturnedin="Journey to Tarren Mill"},{questaccepted="Elixir of Pain part 1"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=19108050,
		}, {
			"Go to "..cl(62,20),
			"	a. Talk to Tallow",
			"		i. Accept "..cq("The Hammer May Fall"),
			completion={{questaccepted="The Hammer May Fall"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=19608150,
		}, {
			"Also at "..cl(62,20),
			"	a. Talk to High Executor Darthalia",
			"		i. Turn in "..cq("Time To Strike"),
			completion={{questturnedin="Time To Strike"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=20308270,
		}, {
			"Go to "..cl(63,21),
			"	a. Talk to Krusk",
			"		i. Accept "..cq("Regthar Deathgate"),
			completion={{questaccepted="Regthar Deathgate"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=20708390,
		}, {
			"Go to "..cl(64,20),
			"	a. Talk to Novice Thaivand",
			"		i. Accept "..cq("Helcular's Revenge part 1"),
			completion={{questaccepted="Helcular's Revenge part 1"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=19708360,
		}, {
			"Go southwest to "..cl(48,31),
			"	a. Kill yetis inside and around the cave",
			"	b. Get Helcular's Rod",
			completion={{questgoal={"*","Helcular's Rod",1}}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=31407950,
		}, {
			"Go northwest to Alterac Mountains",
			completion={{location={mapzone="Alterac Mountains"}}},
			mapzone="Hillsbrad Foothills",
			level=30,
		}, {
			"Go east to "..cl(31,79),
			"	a. Kill Mountain Lions",
			"	b. Get 10 Mountain Lion Blood",
			completion={{questgoal={"*","Mountain Lion Blood",10}}},
			mapzone="Alterac Mountains",
			level=30,
			mapnote=79211010,
		}, {
			"Go south to Hillsbrad Foothills",
			completion={{location={mapzone="Hillsbrad Foothills"}}},
			mapzone="Alterac Mountains",
			level=30,
		}, {
			"Go northeast to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Hillsbrad Foothils",
			level=30,
		}, {
			"Go to "..cl(61,19),
			"	a. Talk to Apothecary Lydon",
			"		i. Turn in "..cq("Elixir of Pain part 1"),
			completion={{questturnedin="Elixir of Pain part 1"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=19108050,
		}, {
			"Go to "..cl(64,20),
			"	a. Talk to Novice Thaivand",
			"		i. Turn in "..cq("Helcular's Revenge part 1"),
			"		ii. Accept "..cq("Helcular's Revenge part 2"),
			completion={{questturnedin="Helcular's Revenge part 1"},{questaccepted="Helcular's Revenge part 2"}},
			mapzone="Hillsbrad Foothills",
			level=30,
			mapnote=19708360,
		}, {
			"Go southeast to Arathi Highlands",
			completion={{location={mapzone="Arathi Highlands"}}},
			mapzone="Hillsbrad Foothills",
			level=30,
		}, {
			"Go southeast to "..cl(31,48),
			"	a. Kill 8 Boulderfist Ogres",
			completion={{questgoal={"*","Boulderfist Ogre slain",8}}},
			mapzone="Arathi Highlands",
			level=30,
			mapnote=48407930,
		}, {
			"Grind to level 31",
			completion={{level=31}},
			mapzone="Arathi Highlands",
			level=30,
		}, {
			"Go northeast to "..cl(35,44),
			"	a. Kill 10 Boulderfist Enforcers inside the cave",
			completion={{questgoal={"*","Boulderfist Enforcer slain",10}}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=44307940,
		}, {
			"Go northeast to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Arathi Highlands",
			level=31,
		}, {
			"Go to "..cl(73,33),
			"	a. Talk to Urda",
			"		i. Get the Hammerfall Flight Path",
			completion={{flightpath="Hammerfall"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=32710570,
		}, {
			"Go to "..cl(74,34),
			"	a. Talk to Drum Fel",
			"		i. Turn in "..cq("The Hammer May Fall"),
			completion={{questturnedin="The Hammer May Fall"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=33910810,
		}, {
			"Go to "..cl(73,34),
			"	a. Talk to Gor'mul",
			"		i. Accept "..cq("Hammerfall"),
			completion={{questaccepted="Hammerfall"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=33910650,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Turn in "..cq("Hammerfall"),
			"		ii. Accept "..cq("Raising Spirits part 1"),
			completion={{questturnedin="Hammerfall"},{questaccepted="Raising Spirits part 1"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=36311100,
		}, {
			"Go west to "..cl(70,36),
			"	a. Kill raptors",
			"	b. Get 10 Highland Raptor Eyes",
			completion={{questgoal={"*","Highland Raptor Eye",10}}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=36210610,
		}, {
			"Go east to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Arathi Highlands",
			level=31,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Turn in "..cq("Raising Spirits part 1"),
			"		ii. Accept "..cq("Raising Spirits part 2"),
			completion={{questturnedin="Raising Spirits part 1"},{questaccepted="Raising Spirits part 2"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=36311100,
		}, {
			"Go to "..cl(73,34),
			"	a. Talk to Gor'mul",
			"		i. Turn in "..cq("Raising Spirits part 2"),
			"		ii. Accept "..cq("Raising Spirits part 3"),
			completion={{questturnedin="Raising Spirits part 2"},{questaccepted="Raising Spirits part 3"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=33910650,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Turn in "..cq("Raising Spirits part 3"),
			"		ii. Accept "..cq("Foul Magics part 1"),
			completion={{questturnedin="Raising Spirits part 3"},{questaccepted="Foul Magics part 1"}},
			mapzone="Arathi Highlands",
			level=31,
			mapnote=36311100,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Arathi Highlands",
			level=31,
		}, {
			"Go outside to Durotar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=31,
		}, {
			"Go east to "..cl(51,14),
			"	a. Ride the zeppelin to Grom'Gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Durotar",
			level=31,
			mapnote=13306410,
		}, {
			"Go to "..cl(33,29),
			"	a. Talk to Thysta",
			"		i. Get the Grom'gol Base Camp Flight Path",
			completion={{flightpath="Grom'gol Base Camp"}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=29406190,
		}, {
			"Go northeast to "..cl(36,11),
			"	a. Talk to Barnil Stonepot",
			"		i. Accept "..cq("Welcome to the Jungle"),
			"	b. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Welcome to the Jungle"),
			"		ii. Accept "..cq("Raptor Mastery part 1"),
			"	c. Talk to Ajeck Rouack",
			"		i. Accept "..cq("Tiger Mastery part 1"),
			"	d. Talk to Sir S.J. Erlgadin",
			"		i. Accept "..cq("Panther Mastery part 1"),
			completion={{questturnedin="Welcome to the Jungle"},{questaccepted="Welcome to the Jungle"},{questaccepted="Raptor Mastery part 1"},{questaccepted="Tiger Mastery part 1"},{questaccepted="Panther Mastery part 1"}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=10604620,
		}, {
			"Go east to "..cl(41,12),
			"	a. Kill 10 Young Panthers",
			completion={{questgoal={"*","Young Panther slain",10}}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=12005320,
		}, {
			"Go west to "..cl(36,11),
			"	a. Talk to Sir S.J. Erlgadin",
			"		i. Turn in "..cq("Panther Mastery part 1"),
			"		ii. Accept "..cq("Panther Mastery part 2"),
			completion={{questturnedin="Panther Mastery part 1"},{questaccepted="Panther Mastery part 2"}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=10604620,
		}, {
			"Go south to "..cl(35,12),
			"	a. Kill 10 Young Stranglethorn Tigers",
			completion={{questgoal={"*","Young Stranglethorn Tiger slain",10}}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=12104750,
		}, {
			"Go north to "..cl(36,11),
			"	a. Talk to Ajeck Rouack",
			"		i. Turn in "..cq("Tiger Mastery part 1"),
			"		ii. Accept "..cq("Tiger Mastery part 2"),
			completion={{questturnedin="Tiger Mastery part 1"},{questaccepted="Tiger Mastery part 2"}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=10604620,
		}, {
			"Go west to "..cl(30,11),
			"	a. Kill 10 Stranglethorn Tigers",
			"	b. Kill 10 Panthers",
			completion={{questgoal={"*","Stranglethorn Tiger slain",10}},{questgoal={"*","Panther slain",10}}},
			mapzone="Stranglethorn Vale",
			level=31,
			mapnote=10704030,
		}, {
			"Grind to level 32",
			completion={{level=32}},
			mapzone="Stranglethorn Vale",
			level=31,
		}, {
			"Go southwest to "..cl(28,15),
			"	a. Kill 10 Stranglethorn Raptors",
			completion={{questgoal={"*","Stranglethorn Raptor slain",10}}},
			mapzone="Stranglethorn Vale",
			level=32,
			mapnote=15504350,
		}, {
			"Go northeast to "..cl(36,11),
			"	a. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Raptor Mastery part 1"),
			"		ii. Accept "..cq("Raptor Mastery part 2"),
			"	b. Talk to Ajeck Rouack",
			"		i. Turn in "..cq("Tiger Mastery part 2"),
			"		ii. Accept "..cq("Tiger Mastery part 3"),
			"	c. Talk to Sir S.J. Erlgadin",
			"		i. Turn in "..cq("Panther Mastery part 2"),
			"		ii. Accept "..cq("Panther Mastery part 3"),
			completion={{questturnedin="Raptor Mastery part 1"},{questturnedin="Tiger Mastery part 2"},{questturnedin="Panther Mastery part 2"},{questaccepted="Raptor Mastery part 2"},{questaccepted="Tiger Mastery part 3"},{questaccepted="Panther Mastery part 3"}},
			mapzone="Stranglethorn Vale",
			level=32,
			mapnote=10604620,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Stranglethorn Vale",
			level=32,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Orgrimmar",
			level=32,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Korran",
			"		i. Accept "..cq("The Swarm Grows"),
			completion={{questaccepted="The Swarm Grows"}},
			mapzone="The Barrens",
			level=32,
			mapnote=29608070,
		}, {
			"Go west to "..cl(45,28),
			"	a. Talk to Regthar Deathgate",
			"		i. Turn in "..cq("Regthar Deathgate"),
			"		ii. Accept "..cq("The Kolkar of Desolace"),
			completion={{questturnedin="Regthar Deathgate"},{questaccepted="The Kolkar of Desolace"}},
			mapzone="The Barrens",
			level=32,
			mapnote=28407370,
		}, {
			"Go east to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="The Barrens",
			level=32,
		}, {
			"Fly to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="The Barrens",
			level=32,
		}, {
			"Go to "..cl(56,51),
			"	a. Talk to Cliffwatcher Longhorn",
			"		i. Accept "..cq("Family Tree"),
			completion={{questaccepted="Family Tree"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=50809640,
		}, {
			"Go east to the Shimmering Flats",
			"	a. Go southeast to the Mirage Raceway",
			completion={{location={mapzone="Thousand Needles",x=78.6,y=76.0, dist=6}}},
			mapzone="Thousand Needles",
			level=32,
		}, {
			"Go southeast to "..cl(78,77),
			"	a. Talk to Wizzle Brassbolts",
			"		i. Accept "..cq("Hardened Shells"),
			"	b. Talk to Fizzle Brassbolts",
			"		i. Accept "..cq("Salt Flat Venom"),
			completion={{questaccepted="Hardened Shells"},{questaccepted="Salt Flat Venom"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=77115520,
		}, {
			"Also at "..cl(78,77),
			"	a. Talk to Kravel Koalbeard",
			"		i. Accept "..cq("Rocket Car Parts"),
			"		ii. Accept "..cq("Hemet Nesingwary Jr."),
			"		iii. Accept "..cq("Wharfmaster Dizzywig"),
			completion={{questaccepted="Rocket Car Parts"},{questaccepted="Hemet Nesingwary Jr."},{questaccepted="Wharfmaster Dizzywig"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=77315510,
		}, {
			"Go northeast to "..cl(80,76),
			"	a. Talk to Pozzik",
			"		i. Accept "..cq("Load Lightening"),
			completion={{questaccepted="Load Lightening"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=75915610,
		}, {
			"Go southeast to "..cl(82,78),
			"	a. Talk to Trackmaster Zherin",
			"		i. Accept "..cq("A Bump in the Road"),
			completion={{questaccepted="A Bump in the Road"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=78015960,
		}, {
			"Get Rocket Car Parts as you quest around Shimmering Flats",
			mapzone="Thousand Needles",
			level=32,
		}, {
			"Go southwest to "..cl(79,85),
			"	a. Kill 10 Saltstone Crystalhides",
			"	b. Kill 6 Saltstone Gazers",
			completion={{questgoal={"*","Saltstone Crystalhide slain",10}},{questgoal={"*","Saltstone Gazer slain",6}}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=84716330,
		}, {
			"Go northeast to "..cl(88,67),
			"	a. Kill vultures",
			"	b. Get 10 Hollow Vulture Bones",
			completion={{questgoal={"*","Hollow Vulture Bone",10}}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=67115490,
		}, {
			"Go northwest to "..cl(83,55),
			"	a. Kill turtles",
			"	b. Get 9 Hardened Tortoise Shells",
			completion={{questgoal={"*","Hardened Tortoise Shell",9}}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=55513870,
		}, {
			"Go west to "..cl(75,55),
			"	a. Kill 10 Saltstone Basilisks",
			"	b. Finish getting the 30 Rocket Car Parts you need",
			completion={{questgoal={"*","Saltstone Basilisk slain",10}},{questgoal={"*","Rocket Car Parts",30}}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=54913040,
		}, {
			"Go southwest to "..cl(72,73),
			"	a. Kill scorpions",
			"	b. Get 6 Salty Scorpid Venom",
			completion={{questgoal={"*","Salty Scorpid Venom",6}}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=72614430,
		}, {
			"Go southeast to the Mirage Raceway",
			completion={{location={mapzone="Thousand Needles",x=78.6,y=76.0, dist=6}}},
			mapzone="Thousand Needles",
			level=32,
		}, {
			"Go to "..cl(78,77),
			"	a. Talk to Kravel Koalbeard",
			"		i. Turn in "..cq("Rocket Car Parts"),
			completion={{questturnedin="Rocket Car Parts"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=77315510,
		}, {
			"Also at "..cl(78,77),
			"	a. Talk to Fizzle Brassbolts",
			"		i. Turn in "..cq("Salt Flat Venom"),
			"	b. Talk to Wizzle Brassbolts",
			"		i. Turn in "..cq("Hardened Shells"),
			"	c. Talk to Fizzle Brassbolts",
			"		i. Accept "..cq("Martek the Exiled"),
			completion={{questturnedin="Salt Flat Venom"},{questturnedin="Hardened Shells"},{questaccepted="Martek the Exiled"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=77115520,
		}, {
			"Go to "..cl(80,76),
			"	a. Talk to Pozzik",
			"		i. Turn in "..cq("Load Lightening"),
			"		ii. Accept "..cq("Goblin Sponsorship part 1"),
			completion={{questturnedin="Load Lightening"},{questaccepted="Goblin Sponsorship part 1"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=75915610,
		}, {
			"Go to "..cl(82,78),
			"	a. Talk to Trackmaster Zherin",
			"		i. Turn in "..cq("A Bump in the Road"),
			completion={{questturnedin="A Bump in the Road"}},
			mapzone="Thousand Needles",
			level=32,
			mapnote=78015960,
		}, {
			"Go southwest to Tanaris",
			completion={{location={mapzone="Tanaris"}}},
			mapzone="Thousand Needles",
			level=32,
		}, {
			"Go south to "..cl(52,25),
			"	a. Talk to Bulkrek Ragefist",
			"		i. Get the Gadgetzan Flight Path",
			completion={{flightpath="Gadgetzan"}},
			mapzone="Tanaris",
			level=32,
			mapnote=25407700,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Tanaris",
			level=32,
		}, {
			"Go to "..cl(75,34),
			"	a. Talk to Belgrom Rockmaul",
			"		i. Turn in "..cq("The Swarm Grows part 1"),
			completion={{questturnedin="The Swarm Grows part 1"}},
			mapzone="Orgrimmar",
			level=32,
			mapnote=34210940,
		}, {
			"Go to "..cl(45,52),
			"	a. Talk to Craven Drok",
			"		i. Accept "..cq("Alliance Relations part 1"),
			completion={{questaccepted="Alliance Relations part 1"}},
			mapzone="Orgrimmar",
			level=32,
			mapnote=51609690,
		}, {
			"Go to "..cl(22,54),
			"	a. Talk to Keldran",
			"		i. Turn in "..cq("Alliance Relations part 1"),
			"		ii. Accept "..cq("Alliance Relations part 2"),
			completion={{questturnedin="Alliance Relations part 1"},{questaccepted="Alliance Relations part 2"}},
			mapzone="Orgrimmar",
			level=32,
			mapnote=53807610,
		}, {
			"Fly to Sun Rock Retreat",
			completion={{location={mapzone="Stonetalon Mountains",x=46.5,y=60.1, dist=3}}},
			mapzone="Orgrimmar",
			level=32,
		}, {
			"Grind to level 33",
			completion={{level=33}},
			mapzone="Stonetalon Mountains",
			level=32,
		}, {
			"Go southwest to Desolace",
			completion={{location={mapzone="Desolace"}}},
			mapzone="Stonetalon Mountains",
			level=33,
		}, {
			"Go southeast to "..cl(58,22),
			"	a. Kill Burning Blade mobs",
			"	b. Get a Flayed Demon Skin",
			"	c. Click the Flayed Demon Skin",
			"		i. Accept "..cq("The Corrupter part 1"),
			completion={{questaccepted="The Corrupter part 1"}},
			mapzone="Desolace",
			level=33,
			mapnote=21707950,
		}, {
			"Go southeast to "..cl(62,39),
			"	a. Talk to Bibbly F'utzbuckle",
			"		i. Accept "..cq("Bone Collector"),
			completion={{questaccepted="Bone Collector"}},
			mapzone="Desolace",
			level=33,
			mapnote=39010130,
		}, {
			"Go south to "..cl(61,62),
			"	a. Talk to Smeed Scrabblescrew",
			"		i. Accept "..cq("Kodo Roundup"),
			completion={{questaccepted="Kodo Roundup"}},
			mapzone="Desolace",
			level=33,
			mapnote=61912280,
		}, {
			"Go west to "..cl(56,62),
			"	a. Use your Kodo Kombobulator on Angient, Aged, or Dying Kodos",
			"	b. Lead the tamed kodo back to Smeed Scrabblescrew",
			"	c. Talk to the Tamed Kodo at Smeed Scrabblescrew's hut",
			"	d. Do this 5 times",
			"	e. Tame 5 Kodos",
			completion={{questgoal={"*","Kodos Tamed",5}}},
			mapzone="Desolace",
			level=33,
			mapnote=62511860,
		}, {
			"Go to "..cl(61,62),
			"	a. Talk to Smeed Scrabblescrew",
			"		i. Turn in "..cq("Kodo Roundup"),
			completion={{questturnedin="Kodo Roundup"}},
			mapzone="Desolace",
			level=33,
			mapnote=61912280,
		}, {
			"Go northwest to "..cl(54,60),
			"	a. Click the Kodo Bones",
			"	b. Run away if a Kodo Apparition spawns",
			"	c. Get 10 Kodo Bones",
			completion={{questgoal={"*","Kodo Bone",10}}},
			mapzone="Desolace",
			level=33,
			mapnote=60511490,
		}, {
			"Go east to "..cl(56,60),
			"	a. Talk to Felgur Twocuts",
			"		i. Turn in "..cq("The Kolkar of Desolace"),
			"		ii. Accept "..cq("Khan Dez'hepah"),
			"	b. Talk to Gurda Wildmane",
			"		i. Accept "..cq("Gelkis Alliance"),
			completion={{questturnedin="The Kolkar of Desolace"},{questaccepted="Khan Dez'hepah"},{questaccepted="Gelkis Alliance"}},
			mapzone="Desolace",
			level=33,
			mapnote=59611580,
		}, {
			"Go north to "..cl(55,56),
			"	a. Talk to Nataka Longhorn",
			"		i. Turn in "..cq("Family Tree"),
			completion={{questturnedin="Family Tree"}},
			mapzone="Desolace",
			level=33,
			mapnote=55811120,
		}, {
			"Go northwest to "..cl(53,54),
			"	a. Talk to Takata Steelblade",
			"		i. Turn in "..cq("Alliance Relations part 1"),
			"		ii. Accept "..cq("Alliance Relations part 2"),
			"		iii. Accept "..cq("Befouled by Satyr"),
			completion={{questturnedin="Alliance Relations part 1"},{questaccepted="Alliance Relations part 2"},{questaccepted="Befouled by Satyr"}},
			mapzone="Desolace",
			level=33,
			mapnote=54410700,
		}, {
			"Go northwest to "..cl(52,53),
			"	a. Talk to Maurin Bonesplitter",
			"		i. Turn in "..cq("Alliance Relations part 2"),
			"		ii. Accept "..cq("The Burning of Spirits"),
			"		iii. Turn in "..cq("The Corrupter part 1"),
			"		iv. Accept "..cq("The Corrupter part 2"),
			completion={{questturnedin="Alliance Relations part 2"},{questturnedin="The Corrupter part 1"},{questaccepted="The Burning of Spirits"},{questaccepted="The Corrupter part 2"}},
			mapzone="Desolace",
			level=33,
			mapnote=53410560,
		}, {
			"Go northeast to "..cl(62,39),
			"	a. Talk to Bibbly F'utzbuckle",
			"		i. Turn in "..cq("Bone Collector"),
			completion={{questturnedin="Bone Collector"}},
			mapzone="Desolace",
			level=33,
			mapnote=39010130,
		}, {
			"Go northeast to "..cl(72,24),
			"	a. Kill 7 Hatefury Rogues",
			"	b. Kill 7 Hatefury Felsworn",
			"	c. Kill 7 Hatefury Betrayers",
			"	d. Kill 7 Hatefury Hellcallers",
			"	e. Kill Hatefury Shadowstalkers",
			"	f. Get a Shadowstalker Scalp",
			completion={{questgoal={"*","Hatefury Rogue slain",7}},{questgoal={"*","Hatefury Felsworn slain",7}},{questgoal={"*","Hatefury Betrayer slain",7}},{questgoal={"*","Hatefury Hellcaller slain",7}},{questgoal={"*","Shadowstalker Scalp",1}}},
			mapzone="Desolace",
			level=33,
			mapnote=23609590,
		}, {
			"Go southeast to "..cl(75,49),
			"	a. Kill Khan Dez'hepah",
			"	b. Get the Khan Dez'hepah's Head",
			"	c. You may need to search for him",
			completion={{questgoal={"*","Khan Dez'hepah's Head",1}}},
			mapzone="Desolace",
			level=33,
			mapnote=48812340,
		}, {
			"Go south to "..cl(74,67),
			"	a. Kill Magram centaurs until you are friendly with the Gelkis Clan Centaur",
			"	b. It takes about 50 kills",
			completion={{questgoal={"*","Gelkis Clan Centaur (Friendly)",1}}},
			mapzone="Desolace",
			level=33,
			mapnote=67014080,
		}, {
			"Go northwest to Ghost Walker Post",
			completion={{location={mapzone="Desolace",x=56.1,y=57.1, dist=2}}},
			mapzone="Desolace",
			level=33,
		}, {
			"Go to "..cl(56,60),
			"	a. Talk to Felgur Twocuts",
			"		i. Turn in "..cq("Khan Dez'hepah"),
			"		ii. Accept "..cq("Centaur Bounty"),
			completion={{questturnedin="Khan Dez'hepah"},{questaccepted="Centaur Bounty"}},
			mapzone="Desolace",
			level=33,
			mapnote=59611580,
		}, {
			"Go north to "..cl(55,56),
			"	a. Talk to Nataka Longhorn",
			"		i. Accept "..cq("Catch of the Day"),
			completion={{questaccepted="Catch of the Day"}},
			mapzone="Desolace",
			level=33,
			mapnote=55811120,
		}, {
			"Go northwest to "..cl(53,54),
			"	a. Talk to Takata Steelblade",
			"		i. Turn in "..cq("Befouled by Satyr"),
			completion={{questturnedin="Befouled by Satyr"}},
			mapzone="Desolace",
			level=33,
			mapnote=54410700,
		}, {
			"Go northwest to "..cl(52,53),
			"	a. Talk to Maurin Bonesplitter",
			"		i. Turn in "..cq("The Corrupter part 2"),
			"		ii. Accept "..cq("The Corrupter part 3"),
			completion={{questturnedin="The Corrupter part 2"},{questaccepted="The Corrupter part 3"}},
			mapzone="Desolace",
			level=33,
			mapnote=53410560,
		}, {
			"Grind to level 34",
			completion={{level=34}},
			mapzone="Desolace",
			level=33,
		}, {
			"Go southwest to "..cl(36,79),
			"	a. Talk to Uthek the Wise",
			"		i. Turn in "..cq("Gelkis Alliance"),
			"		ii. Accept "..cq("Stealing Supplies"),
			completion={{questturnedin="Gelkis Alliance"},{questaccepted="Stealing Supplies"}},
			mapzone="Desolace",
			level=34,
			mapnote=79311550,
		}, {
			"Go northwest to Shadowprey Village",
			completion={{location={mapzone="Desolace",x=24.0,y=68.0, dist=6.5}}},
			mapzone="Desolace",
			level=34,
		}, {
			"Go to "..cl(25,72),
			"	a. Talk to Roon Wildmane",
			"		i. Accept "..cq("Hunting in Stranglethorn"),
			completion={{questaccepted="Hunting in Stranglethorn"}},
			mapzone="Desolace",
			level=34,
			mapnote=72309740,
		}, {
			"Go to "..cl(26,68),
			"	a. Talk to Taiga Wisemane",
			"		i. Accept "..cq("Hand of Iruxos"),
			completion={{questaccepted="Hand of Iruxos"}},
			mapzone="Desolace",
			level=34,
			mapnote=68209400,
		}, {
			"Make Shadowprey Village your home",
			completion={{home="Shadowprey Village"}},
			mapzone="Desolace",
			level=34,
		}, {
			"Go to "..cl(23,73),
			"	a. Talk to Drulzegar Skraghook",
			"		i. Accept "..cq("Other Fish to Fry"),
			completion={{questaccepted="Other Fish to Fry"}},
			mapzone="Desolace",
			level=34,
			mapnote=72909620,
		}, {
			"Go to "..cl(23,72),
			"	a. Talk to Mai'lahii",
			"		i. Accept "..cq("Clam Bait"),
			completion={{questaccepted="Clam Bait"}},
			mapzone="Desolace",
			level=34,
			mapnote=72009460,
		}, {
			"Go to "..cl(22,74),
			"	a. Talk to Thalon",
			"		i. Get the Shadowprey Village Flight Path",
			completion={{flightpath="Shadowprey Village"}},
			mapzone="Desolace",
			level=34,
			mapnote=74109570,
		}, {
			"Go southwest to "..cl(19,76),
			"	a. Click the Shellfish Traps underwater",
			"	b. Get 10 Shellfish",
			completion={{questgoal={"*","Shellfish",10}}},
			mapzone="Desolace",
			level=34,
			mapnote=75909540,
		}, {
			"Go northeast to "..cl(22,73),
			"	a. Talk to Jinar'Zillen",
			"		i. Turn in 'Fish in a Bucket' twice",
			"		ii. Get 2 Bloodbelly Fish",
			completion={{questgoal={"*","Bloodbelly Fish",2}}},
			mapzone="Desolace",
			level=34,
			mapnote=73109560,
		}, {
			"Go northeast to "..cl(25,40),
			"	a. Click the Giant Softshell Clams underwater",
			"	b. Get 10 Soft-shelled Clam Meat",
			completion={{questgoal={"*","Soft-shelled Clam Meat",10}}},
			mapzone="Desolace",
			level=34,
			mapnote=40006500,
		}, {
			"Go northeast to "..cl(36,30),
			"	a. Click Rackmore's Log",
			"		i. Accept "..cq("Claim Rackmore's Treasure!"),
			completion={{questaccepted="Claim Rackmore's Treasure!"}},
			mapzone="Desolace",
			level=34,
			mapnote=30406650,
		}, {
			"Go west to "..cl(34,20),
			"	a. Kill Drysnaps underwater",
			"	b. Get Rackmore's Silver Key",
			completion={{questgoal={"*","Rackmore's Silver Key",1}}},
			mapzone="Desolace",
			level=34,
			mapnote=30006380,
		}, {
			"Go northeast to "..cl(36,36),
			"	a. Kill nagas underwater",
			"	b. Get Rackmore's Golden Key",
			"	c. Kill 7 Slitherblade Nagas",
			"	d. Kill 5 Slitherblade Sorceresses",
			completion={{questgoal={"*","Rackmore's Golden Key",1}},{questgoal={"*","Slitherblade Naga slain",7}},{questgoal={"*","Slitherblade Sorceress slain",5}}},
			mapzone="Desolace",
			level=34,
			mapnote=25706130,
		}, {
			"Go east to "..cl(39,27),
			"	a. Talk to Azore Aldamort",
			"		i. Accept "..cq("Sceptre of Light"),
			completion={{questaccepted="Sceptre of Light"}},
			mapzone="Desolace",
			level=34,
			mapnote=27206610,
		}, {
			"Go east to "..cl(56,31),
			"	a. Kill Burning Blade mobs",
			"	b. When they are almost dead, use you Burning Gem on them",
			"	c. Get 15 Infused Burning Gems",
			completion={{questgoal={"*","Infused Burning Gem",15}}},
			mapzone="Desolace",
			level=34,
			mapnote=30808720,
		}, {
			"Go west to "..cl(55,30),
			"	a. Kill the Burning Blade Seer at the top of the tower",
			"	b. Get the Sceptre of Light",
			completion={{questgoal={"*","Sceptre of Light",1}}},
			mapzone="Desolace",
			level=34,
			mapnote=30108530,
		}, {
			"Go north to "..cl(55,27),
			"	a. Go inside the big building",
			"	b. Click the big red crystal in the middle of the room",
			"	c. Kill the Demon Spirit that spawns",
			"	d. Get the Demon Box",
			completion={{questgoal={"*","Hand of Iruxos Crystal broken",1}},{questgoal={"*","Demon Box",1}}},
			mapzone="Desolace",
			level=34,
			mapnote=26708160,
		}, {
			"Go west to "..cl(39,27),
			"	a. Talk to Azore Aldamort",
			"		i. Turn in "..cq("Sceptre of Light"),
			"		ii. Accept "..cq("Book of the Ancients"),
			completion={{questturnedin="Sceptre of Light"},{questaccepted="Book of the Ancients"}},
			mapzone="Desolace",
			level=34,
			mapnote=27206610,
		}, {
			"Go northwest to "..cl(37,18),
			"	a. Kill Slitherblade Oracles",
			"	b. Get the Oracle Crystal",
			completion={{questgoal={"*","Oracle Crystal",1}}},
			mapzone="Desolace",
			level=34,
			mapnote=18105540,
		}, {
			"Go northwest to "..cl(33,15),
			"	a. Kill 7 Slitherblade Myrmidons",
			completion={{questgoal={"*","Slitherblade Myrmidon slain",7}}},
			mapzone="Desolace",
			level=34,
			mapnote=14904770,
		}, {
			"Go northwest to 30,9",
			"	a. Click Rackmore's Chest",
			"		i. Turn in "..cq("Claim Rackmore's Treasure!"),
			completion={{questturnedin="Claim Rackmore's Treasure!"}},
			mapzone="Desolace",
			level=34,
			mapnote=8703870,
		}, {
			"Go northwest to 28,7",
			"	a. Use the Gem of the Serpent on the Serpent Statue",
			"	b. Kill Lord Kragaru that spawns",
			"	c. Get the Book of the Ancients",
			completion={{questgoal={"*","Book of the Ancients",1}}},
			mapzone="Desolace",
			level=34,
			mapnote=6603480,
		}, {
			"Go southeast to "..cl(39,27),
			"	a. Talk to Azore Aldamort",
			"		i. Turn in "..cq("Book of the Ancients"),
			completion={{questturnedin="Book of the Ancients"}},
			mapzone="Desolace",
			level=34,
			mapnote=27206610,
		}, {
			"Go southeast to Ghost Walker Post",
			completion={{location={mapzone="Desolace",x=56.1,y=57.1, dist=2}}},
			mapzone="Desolace",
			level=34,
		}, {
			"Go to "..cl(55,56),
			"	a. Talk to Nataka Longhorn",
			"		i. Turn in "..cq("Catch of the Day"),
			completion={{questturnedin="Catch of the Day"}},
			mapzone="Desolace",
			level=34,
			mapnote=55811120,
		}, {
			"Go northwest to "..cl(52,53),
			"	a. Talk to Maurin Bonesplitter",
			"		i. Turn in "..cq("The Burning of Spirits"),
			"		ii. Turn in "..cq("The Corrupter part 3"),
			"		iii. Accept "..cq("The Corrupter part 4"),
			completion={{questturnedin="The Burning of Spirits"},{questturnedin="The Corrupter part 3"},{questaccepted="The Corrupter part 4"}},
			mapzone="Desolace",
			level=34,
			mapnote=53410560,
		}, {
			"Go south to "..cl(53,54),
			"	a. Talk to Takata Steelblade",
			"		i. Turn in "..cq("The Corrupter part 4"),
			completion={{questturnedin="The Corrupter part 4"}},
			mapzone="Desolace",
			level=34,
			mapnote=54410700,
		}, {
			"Go southeast to "..cl(70,70),
			"	a. Kill Magram centaurs",
			"	b. Get 15 Centaur Ears",
			completion={{questgoal={"*","Centaur Ear",15}}},
			mapzone="Desolace",
			level=34,
			mapnote=70113990,
		}, {
			"Go south to "..cl(71,75),
			"	a. Click the Sacks of Meat",
			"	b. Get 6 Crudely Dried Meat",
			completion={{questgoal={"*","Crudely Dried Meat",6}}},
			mapzone="Desolace",
			level=34,
			mapnote=75414630,
		}, {
			"Grind to level 35",
			completion={{level=35}},
			mapzone="Desolace",
			level=34,
		}
	  },
	},
	{ sectiontitle = "Levels (35-40)",
	  steps = {
		{
			"Go northwest to Ghost Walker Post",
			completion={{location={mapzone="Desolace",x=56.1,y=57.1, dist=2}}},
			mapzone="Desolace",
			level=35,
		}, {
			"Go to "..cl(56,60),
			"	a. Talk to Felgur Twocuts",
			"		i. Turn in "..cq("Centaur Bounty"),
			completion={{questturnedin="Centaur Bounty"}},
			mapzone="Desolace",
			level=35,
			mapnote=59611580,
		}, {
			"Hearth to Shadowprey Village",
			completion={{location={mapzone="Desolace",x=24.0,y=68.0, dist=6.5}}},
			mapzone="Desolace",
			level=35,
		}, {
			"Go to "..cl(26,68),
			"	a. Talk to Taiga Wisemane",
			"		i. Turn in "..cq("Hand of Iruxos"),
			completion={{questturnedin="Hand of Iruxos"}},
			mapzone="Desolace",
			level=35,
			mapnote=68209400,
		}, {
			"Go to "..cl(23,73),
			"	a. Talk to Drulzegar Skraghook",
			"		i. Turn in "..cq("Other Fish to Fry"),
			completion={{questturnedin="Other Fish to Fry"}},
			mapzone="Desolace",
			level=35,
			mapnote=72909620,
		}, {
			"Go to "..cl(23,72),
			"	a. Talk to Mai'Lahii",
			"		i. Turn in "..cq("Clam Bait"),
			completion={{questturnedin="Clam Bait"}},
			mapzone="Desolace",
			level=35,
			mapnote=72009460,
		}, {
			"Go southeast to "..cl(36,79),
			"	a. Talk to Uthek the Wise",
			"		i. Turn in "..cq("Stealing Supplies"),
			completion={{questturnedin="Stealing Supplies"}},
			mapzone="Desolace",
			level=35,
			mapnote=79311550,
		}, {
			"Go northwest to Shadowprey Village",
			completion={{location={mapzone="Desolace",x=24.0,y=68.0, dist=6.5}}},
			mapzone="Desolace",
			level=35,
		}, {
			"Fly to Camp Taurajo",
			completion={{location={mapzone="The Barrens",x=44.7,y=58.7, dist=2}}},
			mapzone="Desolace",
			level=35,
		}, {
			"Go southeast to Dustwallow Marsh",
			completion={{location={mapzone="Dustwallow Marsh"}}},
			mapzone="The Barrens",
			level=35,
		}, {
			"Go to "..cl(30,48),
			"	a. Click the Hoofprints",
			"		i. Accept "..cq("Suspicious Hoofprints"),
			completion={{questaccepted="Suspicious Hoofprints"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=47607730,
		}, {
			"Also at "..cl(30,48),
			"	a. Click the Theramore Guard Badge",
			"		i. Accept "..cq("Lieutenant Paval Reethe"),
			completion={{questaccepted="Lieutenant Paval Reethe"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=48207800,
		}, {
			"Go to "..cl(30,49),
			"	a. Click the Black Shield",
			"		i. Accept "..cq("The Black Shield part 1"),
			completion={{questaccepted="The Black Shield part 1"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=48607820,
		}, {
			"Go northeast to "..cl(36,32),
			"	a. Talk to Krog",
			"		i. Turn in "..cq("Suspicious Hoofprints"),
			"		ii. Turn in "..cq("Lieutenant Paval Reethe"),
			"		iii. Turn in "..cq("The Black Shield part 1"),
			"		iv. Accept "..cq("The Black Shield part 2"),
			completion={{questturnedin="Suspicious Hoofprints"},{questturnedin="Lieutenant Paval Reethe"},{questturnedin="The Black Shield part 1"},{questaccepted="The Black Shield part 2"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=31906830,
		}, {
			"Go to "..cl(37,31),
			"	a. Talk to Do'gol",
			"		i. Turn in "..cq("The Black Shield part 2"),
			completion={{questturnedin="The Black Shield part 2"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=30806730,
		}, {
			"Go to "..cl(36,32),
			"	a. Talk to Shardi",
			"		i. Get the Brackenwall Village Flight Path",
			completion={{flightpath="Brackenwall Village"}},
			mapzone="Dustwallow Marsh",
			level=35,
			mapnote=31906750,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=35,
		}, {
			"Go to "..cl(63,36),
			"	a. Talk to Gazlowe",
			"		i. Turn in "..cq("Goblin Sponsorship part 1"),
			"		ii. Accept "..cq("Goblin Sponsorship part 2"),
			completion={{questturnedin="Goblin Sponsorship part 1"},{questaccepted="Goblin Sponsorship part 2"}},
			mapzone="The Barrens",
			level=35,
			mapnote=36209890,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Wharfmaster Dizzywig",
			"		i. Turn in "..cq("Wharfmaster Dizzywig"),
			"		ii. Accept "..cq("Parts for Kravel"),
			completion={{questturnedin="Wharfmaster Dizzywig"},{questaccepted="Parts for Kravel"}},
			mapzone="The Barrens",
			level=35,
			mapnote=38510190,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=35,
		}, {
			"Go to "..cl(26,74),
			"	a. Talk to Wharfmaster Lozgil",
			"		i. Turn in "..cq("Goblin Sponsorship part 2"),
			"		ii. Accept "..cq("Goblin Sponsorship part 3"),
			completion={{questturnedin="Goblin Sponsorship part 2"},{questaccepted="Goblin Sponsorship part 3"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=73610000,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to 'Sea Wolf' MacKinley",
			"		i. Accept "..cq("Scaring Shaky"),
			completion={{questaccepted="Scaring Shaky"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=77110490,
		}, {
			"Go to "..cl(28,78),
			"	a. Talk to Drizzlik",
			"		i. Accept "..cq("Supply and Demand"),
			completion={{questaccepted="Supply and Demand"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=77610590,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Crank Fizzlebub",
			"		i. Accept "..cq("Singing Blue Shards"),
			"		ii. Accept "..cq("Zanzil's Secret"),
			completion={{questaccepted="Singing Blue Shards"},{questaccepted="Zanzil's Secret"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=77210430,
		}, {
			"Make Booty Bay your home",
			completion={{home="Booty Bay"}},
			mapzone="Stranglethorn Vale",
			level=35,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Kebok",
			"		i. Accept "..cq("Bloodscalp Ears"),
			"		ii. Accept "..cq("Hostile Takeover"),
			"	b. Talk to Krazek",
			"		i. Accept "..cq("Investigate the Camp"),
			completion={{questaccepted="Bloodscalp Ears"},{questaccepted="Hostile Takeover"},{questaccepted="Investigate the Camp"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=77210420,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Baron Revilgaz",
			"		i. Turn in "..cq("Goblin Sponsorship part 3"),
			"		ii. Accept "..cq("Goblin Sponsorship part 4"),
			completion={{questturnedin="Goblin Sponsorship part 3"},{questaccepted="Goblin Sponsorship part 4"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=76910410,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Gringer",
			"		i. Get the Booty Bay Flight Path",
			completion={{flightpath="Booty Bay"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=77110400,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=35,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Accept "..cq("Mok'thardin's Enchantment part 1"),
			completion={{questaccepted="Mok'thardin's Enchantment part 1"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=29206130,
		}, {
			"Also at "..cl(32,29),
			"	a. Talk to Commander Aggro'gosh",
			"		i. Accept "..cq("The Defense of Grom'gol part 1"),
			completion={{questaccepted="The Defense of Grom'gol part 1"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=28906110,
		}, {
			"Also at "..cl(32,29),
			"	a. Talk to Nemoth Hawkeye",
			"		i. Accept "..cq("Bloodscalp Insight"),
			completion={{questaccepted="Bloodscalp Insight"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=28906110,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Nimboya",
			"		i. Accept "..cq("Hunt for Yenniku"),
			"		ii. Accept "..cq("Grim Message"),
			"	b. Talk to Kin'weelay",
			"		i. Accept "..cq("Bloody Bone Necklaces"),
			"		ii. Accept "..cq("The Vile Reef"),
			completion={{questaccepted="Hunt for Yenniku"},{questaccepted="Grim Message"},{questaccepted="Bloody Bone Necklaces"},{questaccepted="The Vile Reef"}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=27705990,
		}, {
			"Go northwest to "..cl(27,19),
			"	a. Kill basilisks",
			"	b. Get 10 Singing Crystal Shards",
			completion={{questgoal={"*","Singing Crystal Shard",10}}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=18504520,
		}, {
			"Go to "..cl(29,20),
			"	a. Kill trolls",
			"	b. Get 9 Bloodscalp Tusks",
			"	c. Get 15 Bloodscalp Ears",
			"	d. Get 25 Bloody Bone Necklaces",
			"	e. Kill Bloodscalp Shamans",
			"	f. Get a Bloodscalp Totem",
			completion={{questgoal={"*","Bloodscalp Tusk",9}},{questgoal={"*","Bloodscalp Ear",15}},{questgoal={"*","Bloody Bone Necklace",25}},{questgoal={"*","Bloodscalp Totem",1}}},
			mapzone="Stranglethorn Vale",
			level=35,
			mapnote=19704850,
		}, {
			"Grind to level 36",
			completion={{level=36}},
			mapzone="Stranglethorn Vale",
			level=35,
		}, {
			"Go east to "..cl(32,19),
			"	a. Kill 10 Elder Stranglethorn Tigers",
			completion={{questgoal={"*","Elder Stranglethorn Tiger slain",10}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=19205100,
		}, {
			"Go south to "..cl(32,21),
			"	a. Kill 10 Lashtail Raptors",
			completion={{questgoal={"*","Lashtail Raptor slain",10}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=21305370,
		}, {
			"Go south to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=36,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Nimboya",
			"		i. Turn in "..cq("Hunt for Yenniku"),
			"		ii. Accept "..cq("Headhunting"),
			"	b. Talk to Kin'weelay",
			"		i. Turn in "..cq("Bloody Bone Necklaces"),
			completion={{questturnedin="Hunt for Yenniku"},{questaccepted="Headhunting"},{questturnedin="Bloody Bone Necklaces"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=27705990,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Nemeth Hawkeye",
			"		i. Turn in "..cq("Bloodscalp Insight"),
			"		ii. Accept "..cq("An Unusual Patron"),
			completion={{questturnedin="Bloodscalp Insight"},{questaccepted="An Unusual Patron"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=28606060,
		}, {
			"Also at "..cl(32,29),
			"	a. Talk to Commander Aggro'gosh",
			"		i. Turn in "..cq("The Defense of Grom'gol part 1"),
			"		ii. Accept "..cq("The Defense of Grom'gol part 2"),
			completion={{questturnedin="The Defense of Grom'gol part 1"},{questaccepted="The Defense of Grom'gol part 2"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=28906110,
		}, {
			"Go northwest to "..cl(20,14),
			"	a. Kill Bloodscalp Headhunters",
			"	b. Get 20 Shrunken Heads",
			completion={{questgoal={"*","Shrunken Head",20}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=14003410,
		}, {
			"Go south to "..cl(20,23),
			"	a. It looks like a stone box",
			"	b. Use your Gift of Naias while standing next to the Altar of Naias",
			"	c. Kill Naias",
			"	d. Get the Heart of Naias",
			completion={{questgoal={"*","Heart of Naias",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=22604240,
		}, {
			"Go east to "..cl(25,23),
			"	a. It looks like a stone tablet leaning against a wall underwater",
			"	b. Click the Gri'lek the Wanderer Tabet",
			"	c. Get the Tablet Shard",
			completion={{questgoal={"*","Tablet Shard",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=23104790,
		}, {
			"Go northeast to "..cl(36,11),
			"	a. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Raptor Mastery part 2"),
			"		ii. Accept "..cq("Raptor Mastery part 3"),
			"		iii. Turn in "..cq("Hemet Nesingwary Jr."),
			"		iv. Turn in "..cq("Hunting in Stranglethorn"),
			"	b. Talk to Ajeck Rouack",
			"		i. Turn in "..cq("Tiger Mastery part 3"),
			"		ii. Accept "..cq("Tiger Mastery part 4"),
			"	c. See a message saying you Investigated the Camp",
			completion={{questturnedin="Raptor Mastery part 2"},{questturnedin="Hemet Nesingwary Jr."},{questturnedin="Hunting in Stranglethorn"},{questturnedin="Tiger Mastery part 3"},{questaccepted="Raptor Mastery part 3"},{questaccepted="Tiger Mastery part 4"},{questgoal={"*","Locate the hunters' camp",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=10604620,
		}, {
			"Go southeast to "..cl(40,12),
			"	a. Kill River Crocolisks",
			"	b. Get 2 Large River Crocolisk Skins",
			completion={{questgoal={"*","Large River Crocolisk Skin",2}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=12405270,
		}, {
			"Go southeast to "..cl(43,18),
			"	a. Kill Foreman Cozzle",
			"	b. Get Cozzle's Key",
			completion={{questgoal={"*","Cozzle's Key",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=18406110,
		}, {
			"Go southeast to "..cl(43,20),
			"	a. It's a brown chest inside the small house",
			"	b. Click Cozzle's Footlocker",
			"	c. Get the Fuel Regulator Blueprints",
			completion={{questgoal={"*","Fuel Regulator Blueprints",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=20306360,
		}, {
			"Go east to "..cl(46,20),
			"	a. Kill Venture Co. Geologists",
			"	b. Get 8 Tumbled Crystals",
			completion={{questgoal={"*","Tumbled Crystal",8}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=21106660,
		}, {
			"Go southeast to "..cl(47,23),
			"	a. Kill 10 Shadowmaw Panthers",
			"	b. Kill Shadowmaw Panthers",
			"	c. Get 8 Shadowmaw Claws",
			"	d. Kill Stranglethorn Tigresses",
			"	e. Get a Pristine Tigress Fang",
			completion={{questgoal={"*","Shadowmaw Panther slain",10}},{questgoal={"*","Shadowmaw Claw",8}},{questgoal={"*","Pristine Tigress Fang",1}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=22907000,
		}, {
			"Go southwest to "..cl(37,29),
			"	a. Kill 10 Mosh'Ogg Brutes",
			"	b. Kill 5 Mosh'Ogg Witch Doctors",
			completion={{questgoal={"*","Mosh'Ogg Brute slain",10}},{questgoal={"*","Mosh'Ogg Witch Doctor slain",5}}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=29306670,
		}, {
			"Go northwest to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=36,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Turn in "..cq("Mok'thardin's Enchantment part 1"),
			"		ii. Accept "..cq("Mok'thardin's Enchantment part 2"),
			completion={{questturnedin="Mok'thardin's Enchantment part 1"},{questaccepted="Mok'thardin's Enchantment part 2"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=29206130,
		}, {
			"Also at "..cl(32,29),
			"	a. Talk to Commander Aggro'gosh",
			"		i. Turn in "..cq("The Defense of Grom'gol part 1"),
			completion={{questturnedin="The Defense of Grom'gol part 1"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=28906110,
		}, {
			"Also at "..cl(32,29),
			"	a. Talk to Nemeth Hawkeye",
			"		i. Turn in "..cq("An Unusual Patron"),
			completion={{questturnedin="An Unusual Patron"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=28606060,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Nimboya",
			"		i. Turn in "..cq("Headhunting"),
			"		ii. Accept "..cq("Trollbane"),
			"	b. Talk to Kin'weelay",
			"		i. Turn in "..cq("The Vile Reef"),
			completion={{questturnedin="Headhunting"},{questaccepted="Trollbane"},{questturnedin="The Vile Reef"}},
			mapzone="Stranglethorn Vale",
			level=36,
			mapnote=27705990,
		}, {
			"Grind to level 37",
			completion={{level=37}},
			mapzone="Stranglethorn Vale",
			level=36,
		}, {
			"Hearth to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=37,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Crank Fizzlebub",
			"		i. Turn in "..cq("Singing Blue Shards"),
			completion={{questturnedin="Singing Blue Shards"}},
			mapzone="Stranglethorn Vale",
			level=37,
			mapnote=77210430,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Kebok",
			"		i. Turn in "..cq("Bloodscalp Ears"),
			"		ii. Turn in "..cq("Hostile Takeover"),
			"	b. Talk to Krazek",
			"		i. Turn in "..cq("Investigate the Camp"),
			completion={{questturnedin="Bloodscalp Ears"},{questturnedin="Hostile Takeover"},{questturnedin="Investigate the Camp"}},
			mapzone="Stranglethorn Vale",
			level=37,
			mapnote=77210420,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Baron Revilgaz",
			"		i. Turn in "..cq("Goblin Sponsorship part 4"),
			"		ii. Accept "..cq("Goblin Sponsorship part 5"),
			completion={{questturnedin="Goblin Sponsorship part 4"},{questaccepted="Goblin Sponsorship part 5"}},
			mapzone="Stranglethorn Vale",
			level=37,
			mapnote=76910410,
		}, {
			"Go to "..cl(28,78),
			"	a. Talk to Drizzlik",
			"		i. Turn in "..cq("Supply and Demand"),
			"		ii. Accept "..cq("Some Assembly Required"),
			completion={{questturnedin="Supply and Demand"},{questaccepted="Some Assembly Required"}},
			mapzone="Stranglethorn Vale",
			level=37,
			mapnote=77610590,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=37,
		}, {
			"Ride the zeppelin to Undercity",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=58.8, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=37,
		}, {
			"Go south to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Tirisfal Glades",
			level=37,
		}, {
			"Go to "..cl(63,49),
			"	a. Talk to Michael Garrett",
			"		i. Get the Undercity Flight Path",
			completion={{flightpath="Undercity"}},
			mapzone="Undercity",
			level=37,
			mapnote=48611180,
		}, {
			"Go to "..cl(64,49),
			"	a. Talk to Genavie Callow",
			"		i. Accept "..cq("To Steal From Thieves"),
			completion={{questaccepted="To Steal From Thieves"}},
			mapzone="Undercity",
			level=37,
			mapnote=49511330,
		}, {
			"Fly to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Undercity",
			level=37,
		}, {
			"Go to "..cl(74,34),
			"	a. Talk to Zengu",
			"		i. Turn in "..cq("Trollbane"),
			completion={{questturnedin="Trollbane"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=34010780,
		}, {
			"Also at "..cl(74,34),
			"	a. Talk to Drum Fel",
			"		i. Accept "..cq("Call to Arms part 1"),
			completion={{questaccepted="Call to Arms part 1"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=33910810,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Accept "..cq("Guile of the Raptor part 1"),
			completion={{questaccepted="Guile of the Raptor part 1"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=36311100,
		}, {
			"Go south to "..cl(70,59),
			"	a. Kill 10 Witherbark Axe Throwers",
			"	b. Kill 10 Witherbark Headhunters",
			"	c. Kill 10 Witherbark Witch Doctors",
			completion={{questgoal={"*","Witherbark Axe Thrower slain",10}},{questgoal={"*","Witherbark Headhunter slain",10}},{questgoal={"*","Witherbark Witch Doctor slain",10}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=58912910,
		}, {
			"Go northwest to "..cl(63,34),
			"	a. Click the Shards of Myzrael",
			"		i. Accept "..cq("The Princess Trapped"),
			completion={{questaccepted="The Princess Trapped"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=33809630,
		}, {
			"Go east to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Arathi Highlands",
			level=37,
		}, {
			"Make Hammerfall your home",
			completion={{home="Hammerfall"}},
			mapzone="Arathi Highlands",
			level=37,
		}, {
			"Go to "..cl(74,34),
			"	a. Talk to Drum Fel",
			"		i. Turn in "..cq("Call to Arms part 1"),
			"		ii. Accept "..cq("Call to Arms part 2"),
			completion={{questturnedin="Call to Arms part 1"},{questaccepted="Call to Arms part 2"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=33910810,
		}, {
			"Go southeast to "..cl(81,40),
			"	a. The path up to 'The Princess Trapped' starts here",
			completion={{location={mapzone="Arathi Highlands",x=80.8,y=40.0, dist=0.5}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=39912080,
		}, {
			"Go northeast to "..cl(83,36),
			"	a. Kill kobolds",
			"	b. Get 12 Motes of Myzrael",
			completion={{questgoal={"*","Mote of Myzrael",12}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=36511910,
		}, {
			"Go northeast to "..cl(84,31),
			"	a. Click the Iridescent Shards",
			"		i. Turn in "..cq("The Princess Trapped"),
			"		ii. Accept "..cq("Stones of Binding"),
			completion={{questturnedin="The Princess Trapped"},{questaccepted="Stones of Binding"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=31011530,
		}, {
			"Go northwest to "..cl(67,30),
			"	a. Click the Stone of East Binding",
			"	b. Get the Cresting Key",
			completion={{questgoal={"*","Cresting Key",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=29709650,
		}, {
			"Go southwest to "..cl(56,36),
			"	a. Kill Kenata Dabyrie",
			"	b. Get Kenata's Head",
			completion={{questgoal={"*","Kenata's Head",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=36109250,
		}, {
			"Go southwest to "..cl(54,38),
			"	a. Kill Marcel Dabyrie",
			"	b. Get Marcel's Head",
			completion={{questgoal={"*","Marcel's Head",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=38309250,
		}, {
			"Go southeast to "..cl(57,40),
			"	a. Kill Fardel Dabyrie",
			"	b. Get Fardel's Head",
			completion={{questgoal={"*","Fardel's Head",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=40409710,
		}, {
			"Go southwest to "..cl(52,51),
			"	a. Click the Stone of Outer Binding",
			"	b. Get the Thundering Key",
			completion={{questgoal={"*","Thundering Key",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=50710280,
		}, {
			"Go south to "..cl(52,67),
			"	a. Kill Highland Fleshstalkers",
			"	b. Get 12 Raptor Hearts",
			completion={{questgoal={"*","Raptor Heart",12}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=67411970,
		}, {
			"Go south to "..cl(53,73),
			"	a. Kill 10 Boulderfist Brutes",
			"	b. Kill 4 Boulderfist Magus",
			completion={{questgoal={"*","Boulderfist Brute slain",10}},{questgoal={"*","Boulderfist Magus slain",4}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=72812580,
		}, {
			"Go northwest to "..cl(34,32),
			"	a. Kill Syndicate mobs",
			"	b. Get 10 Bloodstone Amulets",
			completion={{questgoal={"*","Bloodstone Amulet",10}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=31606570,
		}, {
			"Go west to "..cl(26,30),
			"	a. Click the Stone of West Binding",
			"	b. Get the Burning Key",
			completion={{questgoal={"*","Burning Key",1}}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=30205570,
		}, {
			"Go southeast to "..cl(36,57),
			"	a. Click the Stone of Inner Binding",
			"		i. Turn in "..cq("Stones of Binding"),
			completion={{questturnedin="Stones of Binding"}},
			mapzone="Arathi Highlands",
			level=37,
			mapnote=57309350,
		}, {
			"Grind to level 38",
			completion={{level=38}},
		}, {
			"Go southwest to "..cl(31,65),
			"	a. The path over to Faldir's Cove starts here",
			completion={{location={mapzone="Arathi Highlands",x=31.6,y=64.0, dist=0.5}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=64609590,
		}, {
			"Go south to "..cl(32,83),
			"	a. Talk to Lolo the Lookout",
			"		i. Accept "..cq("Land Ho!"),
			completion={{questaccepted="Land Ho!"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=82711450,
		}, {
			"Go to "..cl(32,81),
			"	a. Talk to Shakes O'Breen",
			"		i. Turn in "..cq("Land Ho!"),
			completion={{questturnedin="Land Ho!"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=81411370,
		}, {
			"Go to "..cl(53,81),
			"	a. Talk to First Mate Nilzlix",
			"		i. Accept "..cq("Deep Sea Salvage"),
			completion={{questaccepted="Deep Sea Salvage"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=81511430,
		}, {
			"Go to "..cl(34,81),
			"	a. Talk to Captain Steelgut",
			"		i. Accept "..cq("Drowned Sorrows"),
			"	b. Talk to Professor Phizzlethorpe",
			"		i. Accept "..cq("Sunken Treasure part 1"),
			"	c. Escort Professor Phizzlethorpe",
			"	d. Talk to Doctor Draxlegauge",
			"		i. Turn in "..cq("Sunken Treasure part 1"),
			"		ii. Accept "..cq("Sunken Treasure part 2"),
			completion={{questaccepted="Drowned Sorrows"},{questaccepted="Sunken Treasure part 1"},{questturnedin="Sunken Treasure part 1"},{questaccepted="Sunken Treasure part 2"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=80711460,
		}, {
			"Go southwest to "..cl(25,85),
			"	a. Kill 10 Daggerspine Raiders",
			"	b. Kill 3 Daggerspine Sorceresses",
			completion={{questgoal={"*","Daggerspine Raider slain",10}},{questgoal={"*","Daggerspine Sorceress slain",3}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=84710990,
		}, {
			"Go west to "..cl(24,85),
			"	a. Click the Maiden's Folly Log",
			"	b. Get the Maiden's Folly Log",
			completion={{questgoal={"*","Maiden's Folly Log",1}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=85110850,
		}, {
			"Go northwest to "..cl(23,85),
			"	a. Click the Maiden's Folly Charts",
			"	b. Get the Maiden's Folly Charts",
			completion={{questgoal={"*","Maiden's Folly Charts",1}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=84510750,
		}, {
			"Go southwest to "..cl(21,86),
			"	a. Click the Spirit of Silverpine Charts",
			"	b. Get the Spirit of Silverpine Charts",
			completion={{questgoal={"*","Spirit of Silverpine Charts",1}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=85610610,
		}, {
			"Go north to "..cl(21,85),
			"	a. Click the Spirit of Silverpine Log",
			"	b. Get the Spirit of Silverpine Log",
			completion={{questgoal={"*","Spirit of Silverpine Log",1}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=85110570,
		}, {
			"Go northeast to "..cl(22,84),
			"	a. Put on your Goggles of Gem Hunting",
			"	b. Click the Calcified Elven Gems",
			"	c. Get 10 Elven Gems",
			completion={{questgoal={"*","Elven Gem",10}}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=83710560,
		}, {
			"Go northeast to "..cl(33,81),
			"	a. Talk to First Mate Nilzlix",
			"		i. Turn in "..cq("Deep Sea Salvage"),
			completion={{questturnedin="Deep Sea Salvage"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=81511430,
		}, {
			"Go to "..cl(34,81),
			"	a. Talk to Captain Steelgut",
			"		i. Turn in "..cq("Drowned Sorrows"),
			"	b. Talk to Doctor Draxlegauge",
			"		i. Turn in "..cq("Sunken Treasure part 2"),
			"		ii. Accept "..cq("Sunken Treasure part 3"),
			completion={{questturnedin="Drowned Sorrows"},{questturnedin="Sunken Treasure part 2"},{questaccepted="Sunken Treasure part 3"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=80711460,
		}, {
			"Go to "..cl(32,81),
			"	a. Talk to Shakes O'Breen",
			"		i. Turn in "..cq("Sunken Treasure part 3"),
			"		ii. Accept "..cq("Sunken Treasure part 4"),
			completion={{questturnedin="Sunken Treasure part 3"},{questaccepted="Sunken Treasure part 4"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=81411370,
		}, {
			"Hearth to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Arathi Highlands",
			level=38,
		}, {
			"Go to "..cl(74,34),
			"	a. Talk to Drum Fel",
			"		i. Turn in "..cq("Call to Arms part 2"),
			completion={{questturnedin="Call to Arms part 2"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=33910810,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Turn in "..cq("Foul Magics part 1"),
			"		ii. Turn in "..cq("Guile of the Raptor part 1"),
			"		iii. Accept "..cq("Guile of the Raptor part 2"),
			completion={{questturnedin="Foul Magics part 1"},{questturnedin="Guile of the Raptor part 1"},{questaccepted="Guile of the Raptor part 2"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=36311100,
		}, {
			"Go to "..cl(73,34),
			"	a. Talk to Gor'mul",
			"		i. Turn in "..cq("Guile of the Raptor part 2"),
			"		ii. Accept "..cq("Guile of the Raptor part 3"),
			completion={{questturnedin="Guile of the Raptor part 2"},{questaccepted="Guile of the Raptor part 3"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=33910650,
		}, {
			"Go to "..cl(75,36),
			"	a. Talk to Tor'gan",
			"		i. Turn in "..cq("Guile of the Raptor part 3"),
			completion={{questturnedin="Guile of the Raptor part 3"}},
			mapzone="Arathi Highlands",
			level=38,
			mapnote=36311100,
		}, {
			"Fly to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Arathi Highlands",
			level=38,
		}, {
			"Go to "..cl(62,21),
			"	a. Talk to Magus Worden Voidglare",
			"		i. Accept "..cq("Prison Break In"),
			"	b. Talk to Keeper Bel'varil",
			"		i. Accept "..cq("Stone Tokens"),
			completion={{questaccepted="Prison Break In"},{questaccepted="Stone Tokens"}},
			mapzone="Hillsbrad Foothills",
			level=38,
			mapnote=20908240,
		}, {
			"Go northwest to Alterac Mountains",
			completion={{location={mapzone="Alterac Mountains"}}},
			mapzone="Hillsbrad Foothills",
			level=38,
		}, {
			"Go to "..cl(22,84),
			"	a. Kill Dalaran mobs",
			"	b. Get 10 Worn Stone Tokens",
			completion={{questgoal={"*","Worn Stone Token",10}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=83910520,
		}, {
			"Go west to "..cl(20,84),
			"	a. Kill Ricter",
			"	b. Get the Bloodstone Marble",
			completion={{questgoal={"*","Bloodstone Marble",1}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=84110420,
		}, {
			"Go south to "..cl(20,86),
			"	a. Kill Alina",
			"	b. Get the Bloodstone Shard",
			"	c. Kill Dermot",
			"	d. Get the Bloodstone Wedge",
			completion={{questgoal={"*","Bloodstone Shard",1}},{questgoal={"*","Bloodstone Wedge",1}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=86410660,
		}, {
			"Go northwest to "..cl(18,83),
			"	a. Kill Kegan Darkmar",
			"	b. Get the Bloodstone Oval",
			completion={{questgoal={"*","Bloodstone Oval",1}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=83210100,
		}, {
			"Go southeast to Hillsbrad Foothills",
			completion={{location={mapzone="Hillsbrad Foothills"}}},
			mapzone="Alterac Mountains",
			level=38,
		}, {
			"Go inside the yeti cave at "..cl(46,31),
			completion={{location={mapzone="Hillsbrad Foothills",x=46.2,y=31.8, dist=0.5}}},
			mapzone="Hillsbrad Foothills",
			level=38,
		}, {
			"Go northwest to 44,28 inside the cave",
			"	a. Click the Flame of Azel",
			"	b. Charge the Flame of Azel",
			completion={{questgoal={"*","Flame of Azel charged",1}}},
			mapzone="Hillsbrad Foothills",
			level=38,
			mapnote=28107200,
		}, {
			"Go north to 44,27 inside the cave",
			"	a. Click the Flame of Veraz",
			"	b. Charge the Flame of Veraz",
			completion={{questgoal={"*","Flame of Veraz charged",1}}},
			mapzone="Hillsbrad Foothills",
			level=38,
			mapnote=26507060,
		}, {
			"Go northeast to Tarren Mill",
			"	a. Kill a mountain lion on the way to Tarren Mill",
			"	b. Get a Fresh Carcass",
			completion={{questgoal={"*","Fresh Carcass",1}}},
			mapzone="Hillsbrad Foothills",
			level=38,
		}, {
			"Go to "..cl(62,21),
			"	a. Talk to Magus Worden Voidglare",
			"		i. Turn in "..cq("Prison Break In"),
			"		ii. Accept "..cq("Dalaran Patrols"),
			"	b. Talk to Keeper Bel'varil",
			"		i. Turn in "..cq("Stone Tokens"),
			"		ii. Accept "..cq("Bracers of Binding"),
			completion={{questturnedin="Prison Break In"},{questturnedin="Stone Tokens"},{questaccepted="Dalaran Patrols"},{questaccepted="Bracers of Binding"}},
			mapzone="Hillsbrad Foothills",
			level=38,
			mapnote=20908240,
		}, {
			"Go north to Alterac Mountains",
			completion={{location={mapzone="Alterac Mountains"}}},
			mapzone="Hillsbrad Foothills",
			level=38,
		}, {
			"Go northwest to "..cl(38,66),
			"	a. Click the Flame of Uzel",
			"	b. Charge the Flame of Uzel",
			"	c. Use your Fresh Carcass next to the Flame of Uzel",
			"	d. Frostmaw will walk to the mouth of the cave from outside",
			"	e. Kill Frostmaw",
			"	f. Get Frostmaw's Mane",
			completion={{questgoal={"*","Flame of Uzel charged",1}},{questgoal={"*","Frostmaw's Mane",1}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=66310380,
		}, {
			"Go southwest to "..cl(20,74),
			"	a. Kill 6 Dalaran Summoners",
			"	b. Kill 12 Elemental Slaves",
			"	c. Kill Elemental Slanves",
			"	d. Get 4 Bracers of Earth Binding",
			completion={{questgoal={"*","Dalaran Summoner slain",6}},{questgoal={"*","Elemental Slave slain",12}},{questgoal={"*","Bracers of Earth Binding",4}}},
			mapzone="Alterac Mountains",
			level=38,
			mapnote=74009400,
		}, {
			"Go to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Alterac Mountains",
			level=38,
		}, {
			"Go to "..cl(62,21),
			"	a. Talk to Magus Wordeen Voidglare",
			"		i. Turn in "..cq("Dalaran Patrols"),
			"	b. Talk to Keeper Bel'varil",
			"		i. Turn in "..cq("Bracers of Binding"),
			completion={{questturnedin="Dalaran Patrols"},{questturnedin="Bracers of Binding"}},
			mapzone="Hillsbrad Foothills",
			level=38,
			mapnote=20908240,
		}, {
			"Grind to level 39",
			completion={{level=39}},
			mapzone="Hillsbrad Foothills",
			level=38,
		}, {
			"Go southwest to "..cl(53,53),
			"	a. Click Helcular's Grave",
			"		i. Turn in "..cq("Helcular's Revenge"),
			completion={{questturnedin="Helcular's Revenge"}},
			mapzone="Hillsbrad Foothills",
			level=39,
			mapnote=53410610,
		}, {
			"Go northeast to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Hillsbrad Foothills",
			level=39,
		}, {
			"Fly to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Hillsbrad Foothills",
			level=39,
		}, {
			"Go to "..cl(63,49),
			"	a. Talk to Genavie Callow",
			"		i. Turn in "..cq("To Steal From Thieves"),
			completion={{questturnedin="To Steal From Thieves"}},
			mapzone="Undercity",
			level=39,
			mapnote=49511330,
		}, {
			"Go outside of Undercity",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Undercity",
			level=39,
		}, {
			"Go north to "..cl(61,59),
			"	a. Ride the zeppelin to Orgrimmar",
			completion={{location={mapzone="Durotar",x=50.8,y=13.2, dist=1}}},
			mapzone="Tirisfal Glades",
			level=39,
			mapnote=58811960,
		}, {
			"Go northwest to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=39,
		}, {
			"Go to "..cl(75,34),
			"	a. Talk to Belgrom Rockmaul",
			"		i. Accept "..cq("The Swarm Grows part 2"),
			completion={{questaccepted="The Swarm Grows part 2"}},
			mapzone="Orgrimmar",
			level=39,
			mapnote=34210940,
		}, {
			"Fly to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Orgrimmar",
			level=39,
		}, {
			"Make the Crossroads your home",
			completion={{home="the Crossroads"}},
			mapzone="The Barrens",
			level=39,
		}, {
			"Fly to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="The Barrens",
			level=39,
		}, {
			"Go southeast to "..cl(68,64),
			"	a. Talk to Moktar Krin",
			"		i. Turn in "..cq("The Swarm Grows part 2"),
			"		ii. Accept "..cq("The Swarm Grows part 3"),
			completion={{questturnedin="The Swarm Grows part 2"},{questaccepted="The Swarm Grows part 3"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=63913150,
		}, {
			"Go south to "..cl(68,81),
			"	a. Kill 5 Silithid Searchers",
			"	b. Kill 5 Silithid Hive Drones",
			"	c. Kill 5 Silithid Invaders",
			"	d. Kill Silithid mobs",
			"	e. Get a Cracked Silithid Carapace",
			"	f. Click the Crack Silithid Carapace",
			"		i. Accept "..cq("Parts of the Swarm part 1"),
			completion={{questgoal={"*","Silithid Searcher slain",5}},{questgoal={"*","Silithid Hive Drone slain",5}},{questgoal={"*","Silithid Invader slain",5}},{questaccepted="Parts of the Swarm part 1"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=81214950,
		}, {
			"Go south to "..cl(68,86),
			"	a. Kill Silithid mobs",
			"	b. Get 1 Silithid Heart",
			"	c. Get 5 Silithid Talons",
			"	d. Get 3 Intact Silithid Carapaces",
			completion={{questgoal={"*","Silithid Heart",1}},{questgoal={"*","Silithid Talon",5}},{questgoal={"*","Intact Silithid Carapace",3}}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=85815420,
		}, {
			"Go northeast to the Mirage Raceway",
			completion={{location={mapzone="Thousand Needles",x=78.6,y=76.0, dist=6}}},
			mapzone="Thousand Needles",
			level=39,
		}, {
			"Go to "..cl(78,77),
			"	a. Talk to Kravel Koalbeard",
			"		i. Turn in "..cq("Parts for Kravel"),
			"		ii. Accept "..cq("Delivery to the Gnomes"),
			completion={{questturnedin="Parts for Kravel"},{questaccepted="Delivery to the Gnomes"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=77315510,
		}, {
			"Also at "..cl(78,77),
			"	a. Talk to Fizzle Brassbolts",
			"		i. Turn in "..cq("Delivery to the Gnomes"),
			completion={{questturnedin="Delivery to the Gnomes"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=77115520,
		}, {
			"Go to "..cl(80,76),
			"	a. Talk to Pozzik",
			"		i. Turn in "..cq("Goblin Sponsorship part 5"),
			"		ii. Accept "..cq("The Eighteenth Pilot"),
			completion={{questturnedin="Goblin Sponsorship part 5"},{questaccepted="The Eighteenth Pilot"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=75915610,
		}, {
			"Also at "..cl(80,76),
			"	a. Talk to Razzeric",
			"		i. Turn in "..cq("The Eighteenth Pilot"),
			"		ii. Accept "..cq("Razzeric's Tweaking"),
			completion={{questturnedin="The Eighteenth Pilot"},{questaccepted="Razzeric's Tweaking"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=76115640,
		}, {
			"Go to "..cl(78,77),
			"	a. Talk to Kravel Koalbeard",
			"		i. Accept "..cq("The Rumormonger"),
			completion={{questaccepted="The Rumormonger"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=77315510,
		}, {
			"Go northwest to "..cl(68,64),
			"	a. Talk to Moktar Krin",
			"		i. Turn in "..cq("The Swarm Grows part 3"),
			completion={{questturnedin="The Swarm Grows part 3"}},
			mapzone="Thousand Needles",
			level=39,
			mapnote=63913150,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Thousand Needles",
			level=39,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Korran",
			"		i. Turn in "..cq("Parts of the Swarm part 1"),
			"		ii. Accept "..cq("Parts of the Swarm part 2"),
			completion={{questturnedin="Parts of the Swarm part 1"},{questaccepted="Parts of the Swarm part 2"}},
			mapzone="The Barrens",
			level=39,
			mapnote=29608070,
		}, {
			"Fly to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="The Barrens",
			level=39,
		}, {
			"Go to "..cl(35,31),
			"	a. Talk to Nazeer Bloodpike",
			"		i. Accept "..cq("Theramore Spies"),
			"		ii. Accept "..cq("Check Up on Tabetha"),
			"		iii. Accept "..cq("Help Mudsprocket"),
			completion={{questaccepted="Theramore Spies"},{questaccepted="Check Up on Tabetha"},{questaccepted="Help Mudsprocket"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=30706590,
		}, {
			"Go to "..cl(36,32),
			"	a. Talk to Krog",
			"		i. Accept "..cq("Inspecting the Ruins"),
			completion={{questaccepted="Inspecting the Ruins"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=31906830,
		}, {
			"Also at "..cl(36,32),
			"	a. Talk to Balandar Brightstar",
			"		i. Accept "..cq("Twilight of the Dawn Runner"),
			completion={{questaccepted="Twilight of the Dawn Runner"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=31706760,
		}, {
			"Go southwest to "..cl(30,48),
			"	a. Talk to Inspector Tarem",
			"		i. Turn in "..cq("Inspecting the Ruins"),
			completion={{questturnedin="Inspecting the Ruins"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=47607730,
		}, {
			"Go southeast to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=39,
		}, {
			"Go to "..cl(43,72),
			"	a. Talk to Dyslix Silvergrub",
			"		i. Get the Mudsprocket Flight Path",
			completion={{flightpath="Mudsprocket"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=72411520,
		}, {
			"Go to "..cl(42,73),
			"	a. Talk to Drazzit Dripvalve",
			"		i. Turn in "..cq("Help Mudsprocket"),
			completion={{questturnedin="Help Mudsprocket"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=72911520,
		}, {
			"Also at "..cl(42,73),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("WANTED: Goreclaw the Ravenous"),
			completion={{questaccepted="WANTED: Goreclaw the Ravenous"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=73111490,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Accept "..cq("Bloodfen Feathers"),
			completion={{questaccepted="Bloodfen Feathers"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=74011590,
		}, {
			"Go southwest to "..cl(35,65),
			"	a. Kill raptors",
			"	b. Get 5 Bloodfen Feathers",
			completion={{questgoal={"*","Bloodfen Feather",5}}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=65010000,
		}, {
			"Go southwest to "..cl(32,66),
			"	a. Kill Goreclaw the Ravenous",
			completion={{questgoal={"*","Goreclaw the Ravenous slain",1}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=65709770,
		}, {
			"Go southeast to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=39,
		}, {
			"Go to "..cl(42,73),
			"	a. Talk to Drazzit Dripvalve",
			"		i. Turn in "..cq("WANTED: Goreclaw the Ravenous"),
			completion={{questturnedin="WANTED: Goreclaw the Ravenous"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=72911520,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Turn in "..cq("Bloodfen Feathers"),
			completion={{questturnedin="Bloodfen Feathers"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=74011590,
		}, {
			"Go northeast to "..cl(46,57),
			"	a. Talk to Tabetha",
			"		i. Turn in "..cq("Check Up on Tabetha"),
			"	b. Talk to Apprentice Morlann",
			"		i. Accept "..cq("The Zeppelin Crash"),
			completion={{questturnedin="Check Up on Tabetha"},{questaccepted="The Zeppelin Crash"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=57210330,
		}, {
			"Go east to "..cl(54,57),
			"	a. Talk to Moxie Steelgrille",
			"		i. Turn in "..cq("The Zeppelin Crash"),
			"		ii. Accept "..cq("Corrosion Prevention"),
			"		iii. Accept "..cq("Secure the Cargo!"),
			completion={{questturnedin="The Zeppelin Crash"},{questaccepted="Corrosion Prevention"},{questaccepted="Secure the Cargo!"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=56911050,
		}, {
			"Go west to "..cl(53,56),
			"	a. Click the Zeppelin Cargo",
			"	b. Get 8 Zeppelin Cargo",
			"	c. Use your Ooze Buster on oozes",
			"		i. You to be near a Power Core Fragment (the things that connect lightning to you)",
			"	d. Dissolve 10 Oozes",
			completion={{questgoal={"*","Zeppelin Cargo",8}},{questgoal={"*","Oozes Dissolved",10}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=56010900,
		}, {
			"Go east to "..cl(54,57),
			"	a. Talk to Moxie Steelgrille",
			"		i. Turn in "..cq("Corrosion Prevention"),
			"		ii. Turn in "..cq("Secure the Cargo!"),
			"		iii. Accept "..cq("Delivery for Drazzit"),
			completion={{questturnedin="Corrosion Prevention"},{questturnedin="Secure the Cargo!"},{questaccepted="Delivery for Drazzit"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=56911050,
		}, {
			"Go southeast to "..cl(54,56),
			"	a. Click the Gizmorium Shipping Crate",
			"	b. Get the Seaforium Booster",
			completion={{questgoal={"*","Seaforium Booster",1}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=56511060,
		}, {
			"Go northwest to "..cl(43,31),
			"	a. Run behind the tents along the road",
			"	b. Kill 9 Theramore Infiltrators",
			"	c. They are stealted, so look really hard, they won't attack you first",
			completion={{questgoal={"*","Theramore Infiltrator slain",9}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=31307410,
		}, {
			"Go northeast to "..cl(47,24),
			"	a. Talk to Ithania",
			"	b. Rescue Ithania from North Point Tower",
			"	c. Go to the top of the tower",
			"	d. Click the Warped Crates",
			"	e. Get the Dawn Runner Cargo",
			completion={{questgoal={"*","Rescue Ithania from North Point Tower",1}},{questgoal={"*","Dawn Runner Cargo",1}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=24407100,
		}, {
			"Go east to "..cl(55,26),
			"	a. Talk to 'Swamp Eye' Jarl",
			"		i. Accept "..cq("Marsh Frog Legs"),
			"	b. Talk to Mordant Grimsby",
			"		i. Accept "..cq("What's Haunting Witch Hill?"),
			"	c. Click the Loose Dirt",
			"		i. Accept "..cq("The Lost Report"),
			completion={{questaccepted="Marsh Frog Legs"},{questaccepted="What's Haunting Witch Hill?"},{questaccepted="The Lost Report"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=26308170,
		}, {
			"Also at "..cl(55,26),
			"	a. Click the Loose Dirt",
			"		i. Accept "..cq("The Lost Report"),
			completion={{questaccepted="The Lost Report"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=25908130,
		}, {
			"Kill Giant Marsh Frogs around 'Swamp Eye' Jarl's house",
			"	a. Get 10 Marsh Frog Legs",
			completion={{questgoal={"*","Marsh Frog Leg",10}}},
			mapzone="Dustwallow Marsh",
			level=39,
		}, {
			"Go to "..cl(55,26),
			"	a. Talk to 'Swamp Eye' Jarl",
			"		i. Turn in "..cq("Marsh Frog Legs"),
			"		ii. Accept "..cq("Jarl Needs Eyes"),
			completion={{questturnedin="Marsh Frog Legs"},{questaccepted="Jarl Needs Eyes"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=26308170,
		}, {
			"Go south to "..cl(55,31),
			"	a. Kill Risen Husks",
			"	b. Kill Risen Spirits",
			"	c. Gather 10 Information",
			completion={{questgoal={"*","Information Gathered",10}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=31008600,
		}, {
			"Go north to "..cl(55,26),
			"	a. Talk to Mordant Grimsby",
			"		i. Turn in "..cq("What's Haunting Witch Hill?"),
			"		ii. Accept "..cq("The Witch's Bane"),
			completion={{questturnedin="What's Haunting Witch Hill?"},{questaccepted="The Witch's Bane"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=26308170,
		}, {
			"Go southeast to "..cl(56,27),
			"	a. Click Witchbane plants",
			"	b. Get 9 Witchbane",
			completion={{questgoal={"*","Witchbane",9}}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=27008300,
		}, {
			"Go northwest to "..cl(55,26),
			"	a. Talk to Mordant Grimsby",
			"		i. Turn in "..cq("The Witch's Bane"),
			"		ii. Accept "..cq("Cleansing Witch Hill"),
			completion={{questturnedin="The Witch's Bane"},{questaccepted="Cleansing Witch Hill"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=26308170,
		}, {
			"Use the torch while standing at the end of the dock right outside",
			"	a. A flying demon will appear",
			"	b. Kill Zelfrax",
			"	c. Cleanse Witch Hill",
			completion={{questgoal={"*","Witch Hill Cleansed",1}}},
			mapzone="Dustwallow Marsh",
			level=39,
		}, {
			"Go to "..cl(55,26),
			"	a. Talk to Mordant Grimsby",
			"		i. Turn in "..cq("Cleansing Witch Hill"),
			completion={{questturnedin="Cleansing Witch Hill"}},
			mapzone="Dustwallow Marsh",
			level=39,
			mapnote=26308170,
		}, {
			"Grind to level 40",
			completion={{level=40}},
			mapzone="Dustwallow Marsh",
			level=39,
		}
	  },
	},
	{ sectiontitle = "Levels (40-45)",
	  steps = {
		{
			"Go northwest to "..cl(47,18),
			"	a. Talk to 'Stinky' Ignatz",
			"		i. Accept "..cq("Stinky's Escape"),
			"	b. Escort Stinky Ignatz",
			completion={{questaccepted="Stinky's Escape"},{questgoal={"*","Help Stinky find Bogbean Leaves",1}}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=17506440,
		}, {
			"Go southwest to "..cl(35,23),
			"	a. Kill spiders",
			"	b. Get 20 Unpopped Darkmist Eyes",
			completion={{questgoal={"*","Unpopped Darkmist Eye",20}}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=22705760,
		}, {
			"Go south to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="Dustwallow Marsh",
			level=40,
		}, {
			"Go to "..cl(35,31),
			"	a. Talk to Nazeer Bloodpike",
			"		i. Turn in "..cq("Theramore Spies"),
			"		ii. Turn in "..cq("The Lost Report"),
			completion={{questturnedin="Theramore Spies"},{questturnedin="The Lost Report"}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=30706590,
		}, {
			"Go to "..cl(36,32),
			"	a. Talk to Balandar Brightstar",
			"		i. Turn in "..cq("Twilight of the Dawn Runner"),
			completion={{questturnedin="Twilight of the Dawn Runner"}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=31706760,
		}, {
			"Go northeast to "..cl(55,26),
			"	a. Talk to 'Swamp Eye' Jarl",
			"		i. Turn in "..cq("Jarl Needs Eyes"),
			completion={{questturnedin="Jarl Needs Eyes"}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=26308170,
		}, {
			"Also at "..cl(55,26),
			"	a. Click the Loose Dirt",
			"		i. Accept "..cq("The Severed Head"),
			completion={{questaccepted="The Severed Head"}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=25908130,
		}, {
			"Go to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="Dustwallow Marsh",
			level=40,
		}, {
			"Go to "..cl(35,31),
			"	a. Talk to Nazeer Bloodpike",
			"		i. Turn in "..cq("The Severed Head"),
			"		ii. Accept "..cq("The Troll Witchdoctor"),
			completion={{questturnedin="The Severed Head"},{questaccepted="The Troll Witchdoctor"}},
			mapzone="Dustwallow Marsh",
			level=40,
			mapnote=30706590,
		}, {
			"Hearth to the Crossroads",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=40,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="The Barrens",
			level=40,
		}, {
			"Go to "..cl(62,38),
			"	a. Talk to Mebok Mizzyrix",
			"		i. Turn in "..cq("Stinky's Escape"),
			completion={{questturnedin="Stinky's Escape"}},
			mapzone="The Barrens",
			level=40,
			mapnote=37610000,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=40,
		}, {
			"Go to "..cl(28,76),
			"	a. Talk to First Mate Crazz",
			"		i. Accept "..cq("The Bloodsail Buccaneers part 1"),
			completion={{questaccepted="The Bloodsail Buccaneers part 1"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=76210430,
		}, {
			"Make Booty Bay your home",
			completion={{home="Booty Bay"}},
			mapzone="Stranglethorn Vale",
			level=40,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Cank Fizzlebub",
			"		i. Accept "..cq("Venture Company Mining"),
			completion={{questaccepted="Venture Company Mining"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=77210430,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Krazek",
			"		i. Turn in "..cq("The Rumormonger"),
			completion={{questturnedin="The Rumormonger"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=77210420,
		}, {
			"Also at "..cl(27,77),
			"	c. Talk to Fleet Master Seahorn",
			"		i. Turn in "..cq("Sunken Treasure part 4"),
			completion={{questturnedin="Sunken Treasure part 4"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=76910410,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=40,
		}, {
			"Go to "..cl(32,28),
			"	a. Talk to Kin'weelay",
			"		i. Turn in "..cq("The Troll Witchdoctor"),
			"	b. Click the Bubbling Cauldron",
			"		i. Accept "..cq("Marg Speaks"),
			completion={{questturnedin="The Troll Witchdoctor"},{questaccepted="Marg Speaks"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=27705990,
		}, {
			"Go south to "..cl(34,37),
			"	a. Kill 10 Jungle Stalkers",
			"	b. Kill Jungle Stalkers",
			"	c. Get 10 Jungle Stalker Feathers",
			completion={{questgoal={"*","Jungle Stalker slain",10}},{questgoal={"*","Jungle Stalker Feather",10}}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=37307100,
		}, {
			"Go southeast to "..cl(41,44),
			"	a. Kill goblins",
			"	b. Get 10 Singing Blue Crystals",
			completion={{questgoal={"*","Singing Blue Crystal",10}}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=43608470,
		}, {
			"Go northwest to "..cl(40,28),
			"	a. Kill Snapjaw Crocolisks",
			"	b. Get 5 Snapjaw Crocolisk Skins",
			completion={{questgoal={"*","Snapjaw Crocolisk Skin",5}}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=27606750,
		}, {
			"Go northwest to "..cl(32,17),
			"	a. Kill Sin'Dall",
			"	b. Get the Paw of Sin'Dall",
			completion={{questgoal={"*","Paw of Sin'Dall",1}}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=17404960,
		}, {
			"Go northeast to "..cl(36,11),
			"	a. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Raptor Mastery part 3"),
			"		ii. Accept "..cq("Raptor Mastery part 4"),
			"	b. Talk to Ajeck Rouack",
			"		i. Turn in "..cq("Tiger Mastery part 4"),
			"	c. Talk to Sir S.J. Erlgadin",
			"		i. Turn in "..cq("Panther Mastery part 3"),
			"		ii. Accept "..cq("Panther Mastery part 4"),
			completion={{questturnedin="Raptor Mastery part 3"},{questturnedin="Tiger Mastery part 4"},{questturnedin="Panther Mastery part 3"},{questaccepted="Raptor Mastery part 4"},{questaccepted="Panther Mastery part 4"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=10604620,
		}, {
			"Go southwest to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=40,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Turn in "..cq("Mok'thardin's Enchantment part 2"),
			"		ii. Accept "..cq("Mok'thardin's Enchantment part 3"),
			completion={{questturnedin="Mok'thardin's Enchantment part 2"},{questaccepted="Mok'thardin's Enchantment part 3"}},
			mapzone="Stranglethorn Vale",
			level=40,
			mapnote=29206130,
		}, {
			"Grind to level 41",
			completion={{level=41}},
			mapzone="Stranglethorn Vale",
			level=40,
		}, {
			"Go northeast to "..cl(50,24),
			"	a. Kill Bhag'thera",
			"	b. Get the Fang of Bhag'thera",
			completion={{questgoal={"*","Fang of Bhag'thera",1}}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=24007400,
		}, {
			"Go northwest to "..cl(36,11),
			"	a. Talk to Sir S.J. Erlgadin",
			"		i. Turn in "..cq("Panther Mastery part 4"),
			completion={{questturnedin="Panther Mastery part 4"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=10604620,
		}, {
			"Hearth to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Crank Fizzlebub",
			"		i. Turn in "..cq("Venture Company Mining"),
			completion={{questturnedin="Venture Company Mining"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=77210430,
		}, {
			"Go to "..cl(28,78),
			"	a. Talk to Drizzlik",
			"		i. Turn in "..cq("Some Assembly Required"),
			"		ii. Accept "..cq("Excelsior"),
			completion={{questturnedin="Some Assembly Required"},{questaccepted="Excelsior"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=77610590,
		}, {

			"Go north to "..cl(27,70),
			"	a. Click the Bloodsail Correspondence",
			"		i. Turn in "..cq("The Bloodsail Buccaneers part 1"),
			"		ii. Accept "..cq("The Bloodsail Buccaneers part 2"),
			completion={{questturnedin="The Bloodsail Buccaneers part 1"},{questaccepted="The Bloodsail Buccaneers part 2"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=69509680,
		}, {
			"Go northeast to "..cl(32,67),
			"	a. Kill gorillas",
			"	b. Get 5 Mistvale Giblets",
			"	c. Get 1 Aged Gorilla Sinew",
			completion={{questgoal={"*","Mistvale Giblets",5}},{questgoal={"*","Aged Gorilla Sinew",1}}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=67309890,
		}, {
			"Go southwest to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Go to "..cl(27,74),
			"	a. Talk to 'Shaky' Phillipe",
			"		i. Turn in "..cq("Scaring Shaky"),
			"		ii. Accept "..cq("Return to MacKinley"),
			completion={{questturnedin="Scaring Shaky"},{questaccepted="Return to MacKinley"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=73610050,
		}, {
			"Go to "..cl(28,76),
			"	a. Talk to First Mate Crazz",
			"		i. Turn in "..cq("The Bloodsail Buccaneers part 2"),
			"		ii. Accept "..cq("The Bloodsail Buccaneers part 3"),
			completion={{questturnedin="The Bloodsail Buccaneers part 2"},{questaccepted="The Bloodsail Buccaneers part 3"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=76210430,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to 'Sea Wolf' MacKinley",
			"		i. Turn in "..cq("Return to MacKinley"),
			completion={{questturnedin="Return to MacKinley"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=77110490,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Fleet Master Seahorn",
			"		i. Turn in "..cq("The Bloodsail Buccaneers part 3"),
			completion={{questturnedin="The Bloodsail Buccaneers part 3"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=76910410,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Turn in "..cq("Mok'thardin's Enchantment part 3"),
			completion={{questturnedin="Mok'thardin's Enchantment part 3"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=29206130,
		}, {
			"Go northwest to "..cl(30,26),
			"	a. Kill 1 Elder Saltwater Crocolisk",
			"	b. Get 1 Elder Crocolisk Skin",
			completion={{questgoal={"*","Elder Crocolisk Skin",1}}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=26005600,
		}, {
			"Go southwest to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Fly to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Go to "..cl(28,78),
			"	a. Talk to Drizzlik",
			"		i. Turn in "..cq("Excelsior"),
			completion={{questturnedin="Excelsior"}},
			mapzone="Stranglethorn Vale",
			level=41,
			mapnote=77610590,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Ride the zeppelin to Undercity",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=58.8, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=41,
		}, {
			"Go south to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Tirisfal Glades",
			level=41,
		}, {
			"Buy the following items from the Auction House:",
			"	a. 1 Healing Potion",
			"	b. 1 Lesser Invisibility Potion",
			"	c. 1 Gyrochronatom (or get an Engineer to make you one)",
			"	d. 1 Frost Oil",
			completion={{item={"Healing Potion", 1}},{item={"Lesser Invisibility Potion", 1}},{item={"Gyrochronatom", 1}},{item={"Frost Oil", 1}}},
			mapzone="Undercity",
			level=41,
		}, {
			"Fly to Hammerfall",
			completion={{location={mapzone="Arathi Highlands",x=74.0,y=35.1, dist=4}}},
			mapzone="Undercity",
			level=41,
		}, {
			"Go southwest to the Wetlands",
			completion={{location={mapzone="Wetlands"}}},
			mapzone="Arathi Highlands",
			level=41,
		}, {
			"Go south to Loch Modan",
			completion={{location={mapzone="Loch Modan",x=25.6,y=10.6, dist=1}}},
			mapzone="Wetlands",
			level=41,
		}, {
			"Go southeast to the Badlands",
			completion={{location={mapzone="Badlands"}}},
			mapzone="Loch Modan",
			level=41,
		}, {
			"Go southwest to "..cl(42,53),
			"	a. Talk to Martek the Exiled",
			"		i. Turn in "..cq("Martek the Exiled"),
			"		ii. Accept "..cq("Indurium"),
			completion={{questturnedin="Martek the Exiled"},{questaccepted="Indurium"}},
			mapzone="Badlands",
			level=41,
			mapnote=52809520,
		}, {
			"Go northwest to "..cl(26,45),
			"	a. Talk to Lotwil Veriatus",
			"		i. Accept "..cq("Study of the Elements: Rock part 1"),
			"		ii. Accept "..cq("Coolant Heads Prevail"),
			"		iii. Turn in "..cq("Coolant Heads Prevail"),
			"		iv. Accept "..cq("Gyro... What?"),
			"		v. Turn in "..cq("Gyro... What?"),
			"	b. Talk to Lucien Tosselwrench",
			"		i. Accept "..cq("Liquid Stone"),
			"		ii. Turn in "..cq("Liquid Stone"),
			completion={{questaccepted="Study of the Elements: Rock part 1"},{questaccepted="Coolant Heads Prevail"},{questaccepted="Gyro... What?"},{questaccepted="Liquid Stone"},{questturnedin="Coolant Heads Prevail"},{questturnedin="Gyro... What?"},{questturnedin="Liquid Stone"}},
			mapzone="Badlands",
			level=41,
			mapnote=44607050,
		}, {
			"Go west to "..cl(23,44),
			"	a. Kill Lesser Rock Elementals",
			"	b. Get 10 Small Stone Shards",
			completion={{questgoal={"*","Small Stone Shard",10}}},
			mapzone="Badlands",
			level=41,
			mapnote=44506740,
		}, {
			"Go east to "..cl(26,45),
			"	a. Talk to Lotwil Veriatus",
			"		i. Turn in "..cq("Study of the Elements: Rock part 1"),
			"		ii. Accept "..cq("Study of the Elements: Rock part 2"),
			completion={{questturnedin="Study of the Elements: Rock part 1"},{questaccepted="Study of the Elements: Rock part 2"}},
			mapzone="Badlands",
			level=41,
			mapnote=44607050,
		}, {
			"Go west to Kargath",
			completion={{location={mapzone="Badlands",x=4.7,y=46.6, dist=4}}},
			mapzone="Badlands",
			level=41,
		}, {
			"Go to 4,45",
			"	a. Talk to Gorrik",
			"		i. Get the Kargath Flight Path",
			completion={{flightpath="Kargath"}},
			mapzone="Badlands",
			level=41,
			mapnote=44804880,
		}, {
			"Go to "..cl(2,46),
			"	a. Talk to Jarkal Mossmeld",
			"		i. Accept "..cq("Badlands Reagent Run"),
			completion={{questaccepted="Badlands Reagent Run"}},
			mapzone="Badlands",
			level=41,
			mapnote=46104850,
		}, {
			"Go to "..cl(6,48),
			"	a. Talk to Advisor Sarophas",
			"		i. Accept "..cq("Unclaimed Baggage"),
			completion={{questaccepted="Unclaimed Baggage"}},
			mapzone="Badlands",
			level=41,
			mapnote=48105410,
		}, {
			"Go to "..cl(6,47),
			"	a. Talk to Neeka Bloodscar",
			"		i. Accept "..cq("Coyote Thieves"),
			"		ii. Accept "..cq("Report to Helgrum"),
			completion={{questaccepted="Coyote Thieves"},{questaccepted="Report to Helgrum"}},
			mapzone="Badlands",
			level=41,
			mapnote=47205370,
		}, {
			"Go southeast to "..cl(17,60),
			"	a. Kill buzzards",
			"	b. Get 5 Buzzard Gizzards",
			completion={{questgoal={"*","Buzzard Gizzard",5}}},
			mapzone="Badlands",
			level=41,
			mapnote=60107750,
		}, {
			"Go northeast to "..cl(20,49),
			"	a. Kill Lesser Rock Elementals",
			"	b. Get 5 Rock Elemental Shards",
			completion={{questgoal={"*","Rock Elemental Shard",5}}},
			mapzone="Badlands",
			level=41,
			mapnote=49406940,
		}, {
			"Go southeast to "..cl(22,53),
			"	a. Kill coyotes",
			"	b. Get 10 Crag Coyote Fangs",
			"	c. Get 30 Coyote Jawbones",
			completion={{questgoal={"*","Crag Coyote Fang",10}},{questgoal={"*","Coyote Jawbone",30}}},
			mapzone="Badlands",
			level=41,
			mapnote=53107480,

		}, {
			"Go southeast to "..cl(38,72),
			"	a. Kill Rock Elementals",
			"	b. Get 3 Large Stone Slabs",
			completion={{questgoal={"*","Large Stone Slab",3}}},
			mapzone="Badlands",
			level=41,
			mapnote=72311050,
		}, {
			"Grind to level 42",
			completion={{level=42}},
			mapzone="Badlands",
			level=41,
		}, {
			"Go east to "..cl(48,73),
			"	a. Kill Stonevault troggs",
			"	b. Get 10 Indurium Flakes",
			completion={{questgoal={"*","Indurium Flake",10}}},
			mapzone="Badlands",
			level=42,
			mapnote=73112120,
		}, {
			"Go northwest to "..cl(42,52),
			"	a. Talk to Martek the Exiled",
			"		i. Turn in "..cq("Indurium"),
			"		ii. Accept "..cq("News for Fizzle"),
			completion={{questturnedin="Indurium"},{questaccepted="News for Fizzle"}},
			mapzone="Badlands",
			level=42,
			mapnote=52809520,
		}, {
			"Go north to "..cl(41,29),
			"	a. Inside Angor Fortress",
			"	b. Click the Empty Barrel",
			"	c. Get the Advisor's Pack",
			completion={{questgoal={"*","Advisor's Pack",1}}},
			mapzone="Badlands",
			level=42,
			mapnote=29207030,
		}, {
			"Go northeast to "..cl(42,27),
			"	a. Inside Angor Fortress",
			"	b. Click the Weapon Rack",
			"	c. Get the Advisor's Rapier",
			completion={{questgoal={"*","Advisor's Rapier",1}}},
			mapzone="Badlands",
			level=42,
			mapnote=26806850,
		}, {
			"Go southwest to "..cl(26,45),
			"	a. Talk to Lotwil Veriatus",
			"		i. Turn in "..cq("Study of the Elements: Rock part 2"),
			"		ii. Accept "..cq("Study of the Elements: Rock part 3"),
			completion={{questturnedin="Study of the Elements: Rock part 2"},{questaccepted="Study of the Elements: Rock part 3"}},
			mapzone="Badlands",
			level=42,
			mapnote=44607050,
		}, {
			"Go west to Kargath",
			completion={{location={mapzone="Badlands",x=4.7,y=46.6, dist=4}}},
			mapzone="Badlands",
			level=42,
		}, {
			"Go to "..cl(6,48),
			"	a. Talk to Advisor Sarophas",
			"		i. Turn in "..cq("Unclaimed Baggage"),
			completion={{questturnedin="Unclaimed Baggage"}},
			mapzone="Badlands",
			level=42,
			mapnote=48105410,
		}, {
			"Go to "..cl(6,47),
			"	a. Talk to Neeka Bloodscar",
			"		i. Turn in "..cq("Coyote Thieves"),
			completion={{questturnedin="Coyote Thieves"}},
			mapzone="Badlands",
			level=42,
			mapnote=47205370,
		}, {
			"Go to "..cl(2,46),
			"	a. Talk to Jarkal Mossmeld",
			"		i. Turn in "..cq("Badlands Reagent Run"),
			completion={{questturnedin="Badlands Reagent Run"}},
			mapzone="Badlands",
			level=42,
			mapnote=46104850,
		}, {
			"Go southeast to "..cl(9,72),
			"	a. The path up to 'Study of the Elements: Rock' part 3 starts here",
			completion={{location={mapzone="Badlands",x=8.7,y=72.3, dist=0.5}}},
			mapzone="Badlands",
			level=42,
			mapnote=72208110,
		}, {
			"Go southwest to "..cl(4,78),
			"	a. Kill Greater Rock Elementals",
			"	b. Get 5 Bracers of Rock Binding",
			completion={{questgoal={"*","Bracers of Rock Binding",5}}},
			mapzone="Badlands",
			level=42,
			mapnote=78008170,
		}, {
			"Go northeast to "..cl(26,45),
			"	a. Talk to Lotwil Veriatus",
			"		i. Turn in "..cq("Study of the Elements: Rock part 3"),
			"		ii. Accept "..cq("This Is Going to Be Hard part 1"),
			"	b. Talk to Lucien Tosselwrench",
			"		i. Turn in "..cq("This Is Going to Be Hard part 1"),
			"		ii. Accept "..cq("This Is Going to Be Hard part 2"),
			"	c. Talk to Lotwil Veriatus",
			"		i. Turn in "..cq("This Is Going to Be Hard part 2"),
			"		ii. Accept "..cq("This Is Going to Be Hard part 3"),
			"	d. Kill the Fam'retor Guardian that spawns",
			"	e. Get Lotwil's Shackles of Elemental Binding",
			"		i. Turn in "..cq("This Is Going to Be Hard part 3"),
			completion={{questturnedin="Study of the Elements: Rock part 3"},{questturnedin="This Is Going to Be Hard part 1"},{questaccepted="This Is Going to Be Hard part 1"},{questaccepted="This Is Going to Be Hard part 2"},{questaccepted="This Is Going to Be Hard part 3"},{questturnedin="This Is Going to Be Hard part 2"},{questturnedin="This Is Going to Be Hard part 3"}},
			mapzone="Badlands",
			level=42,
			mapnote=44607050,
		}, {
			"Hearth to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Badlands",
			level=42,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=42,
		}, {
			"Go northeast to Duskwood",
			completion={{location={mapzone="Duskwood"}}},
			mapzone="Stranglethorn Vale",
			level=42,
		}, {
			"Go northeast to "..cl(88,36),
			"	a. Talk to Deathstalker Zraedus",
			"		i. Accept "..cq("Nothing But The Truth part 1"),
			"	b. Talk to Apothecary Faustin",
			"		i. Turn in "..cq("Nothing But The Truth part 1"),
			completion={{questaccepted="Nothing But The Truth part 1"},{questturnedin="Nothing But The Truth part 1"}},
			mapzone="Duskwood",
			level=42,
			mapnote=35512310,
		}, {
			"Go southeast to Deadwind Pass",
			completion={{location={mapzone="Deadwind Pass"}}},
			mapzone="Duskwood",
			level=42,
		}, {
			"Go east to Swamp of Sorrows",
			completion={{location={mapzone="Swamp of Sorrows"}}},
			mapzone="Deadwind Pass",
			level=42,
		}, {
			"Go southeast to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=42,
		}, {
			"Make Stonard your home",
			completion={{home="Stonard"}},
			mapzone="Swamp of Sorrows",
			level=42,
		}, {
			"Go to "..cl(45,57),
			"	a. Talk to Dar",
			"		i. Accept "..cq("Lack of Surplus part 1"),
			completion={{questaccepted="Lack of Surplus part 1"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=57210190,
		}, {
			"Go to "..cl(46,55),
			"	a. Talk to Breyk",
			"		i. Get the Stonard Flight Path",
			completion={{flightpath="Stonard"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=54810090,
		}, {
			"Go to "..cl(48,55),
			"	a. Talk to Helgrum the Swift",
			"		i. Turn in "..cq("Report to Helgrum"),
			completion={{questturnedin="Report to Helgrum"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=55010290,
		}, {
			"Go southeast to "..cl(82,68),
			"	a. Kill Sawtooth Snappers",
			"	b. Get 8 Unprepared Sawtooth Flanks",
			completion={{questgoal={"*","Unprepared Sawtooth Flank",8}}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=68315050,
		}, {
			"Go south to "..cl(81,81),
			"	a. Talk to Tok'Kar",
			"		i. Turn in "..cq("Lack of Surplus part 1"),
			"		ii. Accept "..cq("Lack of Surplus part 2"),
			completion={{questturnedin="Lack of Surplus part 1"},{questaccepted="Lack of Surplus part 2"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=81016230,
		}, {
			"Go north to "..cl(82,68),
			"	a. Kill Sawtooth Snappers",
			"	b. Get 6 Sawtooth Snapper Claws",
			completion={{questgoal={"*","Sawtooth Snapper Claw",6}}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=68315050,
		}, {
			"Go south to "..cl(81,81),
			"	a. Talk to Tok'Kar",
			"		i. Turn in "..cq("Lack of Surplus part 2"),
			"		ii. Accept "..cq("Threat From the Sea part 1"),
			completion={{questturnedin="Lack of Surplus part 2"},{questaccepted="Threat From the Sea part 1"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=81016230,
		}, {
			"Go east to "..cl(84,80),
			"	a. Talk to Katar",
			"		i. Turn in "..cq("Threat From the Sea part 1"),
			"		ii. Accept "..cq("Threat From the Sea part 2"),
			completion={{questturnedin="Threat From the Sea part 1"},{questaccepted="Threat From the Sea part 2"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=80416420,
		}, {
			"Go east to "..cl(86,81),
			"	a. Kill 10 Marsh Murlocs",
			"	b. Kill 10 Marsh Inkspewers",
			completion={{questgoal={"*","Marsh Murloc slain",10}},{questgoal={"*","Marsh Inkspewer slain",10}}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=80816680,
		}, {
			"Go northeast to "..cl(91,72),
			"	a. Kill 10 Marsh Flesheaters",
			completion={{questgoal={"*","Marsh Flesheater slain",10}}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=72016300,
		}, {
			"Go southwest to "..cl(84,80),
			"	a. Talk to Katar",
			"		i. Turn in "..cq("Threat From the Sea part 2"),
			"		ii. Accept "..cq("Threat From the Sea part 3"),
			completion={{questturnedin="Threat From the Sea part 2"},{questaccepted="Threat From the Sea part 3"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=80416420,
		}, {
			"Go west to "..cl(81,81),
			"	a. Talk to Tok'Karr",
			"		i. Turn in "..cq("Threat From the Sea part 3"),
			completion={{questturnedin="Threat From the Sea part 3"}},
			mapzone="Swamp of Sorrows",
			level=42,
			mapnote=81016230,
		}, {
			"Grind to level 43",
			completion={{level=43}},
			mapzone="Swamp of Sorrows",
			level=42,
		}, {
			"Go east to "..cl(84,80),
			"	a. Talk to Katar",
			"		i. Accept "..cq("Continued Threat"),
			completion={{questaccepted="Continued Threat"}},
			mapzone="Swamp of Sorrows",
			level=43,
			mapnote=80416420,
		}, {
			"Go northeast to "..cl(87,79),
			"	a. Complete this while heading north on the beach",
			"	b. Kill 10 Marsh Inkspewers",
			"	c. Kill 10 Marsh Flesheaters",
			completion={{questgoal={"*","Marsh Inkspewer slain",10}},{questgoal={"*","Marsh Flesheater slain",10}}},
			mapzone="Swamp of Sorrows",
			level=43,
			mapnote=78716550,
		}, {
			"Go northeast to "..cl(94,63),
			"	a. Kill 10 Marsh Oracles",
			completion={{questgoal={"*","Marsh Oracle slain",10}}},
			mapzone="Swamp of Sorrows",
			level=43,mapnote=80416420,
			mapnote=62715690,
		}, {
			"Go southwest to "..cl(84,80),
			"	a. Talk to Katar",
			"		i. Turn in "..cq("Continued Threat"),
			completion={{questturnedin="Continued Threat"}},
			mapzone="Swamp of Sorrows",
			level=43,
			mapnote=80416420,
		}, {
			"Hearth to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=43,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Swamp of Sorrows",
			level=43,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Accept "..cq("Mok'thardin's Enchantment part 4"),
			completion={{questaccepted="Mok'thardin's Enchantment part 4"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=29206130,
		}, {
			"Fly to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=43,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Fleet Master Seahorn",
			"		i. Accept "..cq("The Bloodsail Buccaneers part 4"),
			completion={{questaccepted="The Bloodsail Buccaneers part 4"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=76910410,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Krazek",
			"		i. Accept "..cq("Tran'rek"),
			completion={{questaccepted="Tran'rek"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77210420,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Deeg",
			"		i. Accept "..cq("Up to Snuff"),
			completion={{questaccepted="Up to Snuff"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77310420,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Whiskey Slim",
			"		i. Accept "..cq("Whiskey Slim's Lost Grog"),
			completion={{questaccepted="Whiskey Slim's Lost Grog"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77510460,
		}, {
			"Make Booty Bay your home",
			completion={{home="Booty Bay"}},
			mapzone="Stranglethorn Vale",
			level=43,
		}, {
			"Go to "..cl(27,76),
			"	a. Talk to Privateer Bloads",
			"		i. Accept "..cq("Akiris by the Bundle"),
			completion={{questaccepted="Akiris by the Bundle"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=76410320,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to 'Sea Wolf' MacKinley",
			"		i. Accept "..cq("Voodoo Dues"),
			"		ii. Accept "..cq("Stoley's Debt"),
			completion={{questaccepted="Voodoo Dues"},{questaccepted="Stoley's Debt"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77110490,
		}, {
			"Go to "..cl(29,76),
			"	a. Talk to Dizzy One-Eye",
			"		i. Accept "..cq("Keep An Eye Out"),
			completion={{questaccepted="Keep An Eye Out"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=75910450,
		}, {
			"Go east to "..cl(33,75),
			"	a. Kill Bloodsail pirates",
			"	b. Get 15 Snuff",
			completion={{questgoal={"*","Snuff",15}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=75010800,
		}, {
			"Go southwest to "..cl(32,79),
			"	a. Kill 10 Bloodsail Swashbucklers",
			"	b. Kill Bloodsail pirates",
			"	c. Get Dizzy's Eye",
			completion={{questgoal={"*","Bloodsail Swashbuckler slain",10}},{questgoal={"*","Dizzy's Eye",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=78611050,
		}, {
			"Go southwest to "..cl(30,81),
			"	a. Click the Bloodsail Orders",
			"	b. Get the Bloodsail Orders",
			"	c. Click the Bloodsail Charts",
			"	d. Get the Bloodsail Charts",
			"	e. They can also spawn in the camp to the southwest",
			completion={{questgoal={"*","Bloodsail Charts",1}},{questgoal={"*","Bloodsail Orders",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=80911050,
		}, {
			"Go northwest to "..cl(27,59),
			"	a. Kill 10 Naga Explorers",
			"	b. Kill nagas",
			"	c. Get 10 Akiris Reeds",
			completion={{questgoal={"*","Naga Explorer slain",10}},{questgoal={"*","Akiris Reed",10}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=59008600,
		}, {
			"Go southeast to "..cl(29,62),
			"	a. Click the Holy Spring",
			"	b. Get the Holy Spring Water",
			completion={{questgoal={"*","Holy Spring Water",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=62009090,
		}, {
			"Go northeast to "..cl(35,52),
			"	a. Kill Jon-Jon the Crow",
			"	b. Get Jon-Jon's Golden Spyglass",
			completion={{questgoal={"*","Jon-Jon's Golden Spyglass",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=51808660,
		}, {
			"Go north to "..cl(35,51),
			"	a. Kill Maury 'Club Foot' Wilkins",
			"	b. Get Maury's Clubbed Foot",
			completion={{questgoal={"*","Maury's Clubbed Foot",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=51208640,
		}, {
			"Go southeast to "..cl(40,58),
			"	a. Kill Chucky 'Ten Thumbs'",
			"	b. Get Chucky's Huge Ring",
			completion={{questgoal={"*","Chucky's Huge Ring",1}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=58209830,
		}, {
			"Go southwest to "..cl(39,59),
			"	a. Kill Zanzil mobs",
			"	b. Get 12 Zanzil's Mixture",
			completion={{questgoal={"*","Zanzil's Mixture",12}}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=59009800,
		}, {
			"Hearth to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=43,
		}, {
			"Go to "..cl(27,27),
			"	a. Talk to Crank Fizzlebub",
			"		i. Turn in "..cq("Zanzil's Secret"),
			completion={{questturnedin="Zanzil's Secret"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77210430,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Deeg",
			"		i. Turn in "..cq("Up to Snuff"),
			completion={{questturnedin="Up to Snuff"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77310420,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Fleet Master Seahorn",
			"		i. Turn in "..cq("The Bloodsail Buccaneers part 4"),
			completion={{questturnedin="The Bloodsail Buccaneers part 4"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=76910410,
		}, {
			"Go to "..cl(27,76),
			"	a. Talk to Privateer Bloads",
			"		i. Turn in "..cq("Akiris by the Bundle"),
			completion={{questturnedin="Akiris by the Bundle"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=76410320,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to 'Sea Wolf' MacKinley",
			"		i. Turn in "..cq("Voodoo Dues"),
			completion={{questturnedin="Voodoo Dues"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=77110490,
		}, {
			"Go to "..cl(29,76),
			"	a. Talk to Dizzy One-Eye",
			"		i. Turn in "..cq("Keep An Eye Out"),
			completion={{questturnedin="Keep An Eye Out"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=75910450,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=43,
		}, {
			"Go to "..cl(32,29),
			"	a. Talk to Far Seer Mok'thardin",
			"		i. Turn in "..cq("Mok'thardin's Enchantment part 4"),
			completion={{questturnedin="Mok'thardin's Enchantment part 4"}},
			mapzone="Stranglethorn Vale",
			level=43,
			mapnote=29206130,
		}, {
			"Grind to level 44",
			completion={{level=44}},
			mapzone="Stranglethorn Vale",
			level=43,
		}, {
			"Ride the zeppelin to Orgrimmar",
			completion={{location={mapzone="Durotar",x=50.8,y=13.2, dist=1}}},
			mapzone="Stranglethorn Vale",
			level=44,

		}, {
			"Go northwest to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=44,
		}, {
			"Go to "..cl(75,34),
			"	a. Talk to Belgrom Rockmaul",
			"		i. Turn in Parts of the Swarm part 2",
			"		ii. Accept "..cq("A Threat in Feralas"),
			completion={{questaccepted="A Threat in Feralas"}},
			mapzone="Orgrimmar",
			level=44,
			mapnote=34210940,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Orgrimmar",
			level=44,
		}, {
			"Go to "..cl(62,81),
			"	a. Talk to Melor Stonehoof",
			"		i. Turn in "..cq("Frostmaw"),
			"		ii. Accept "..cq("Deadmire"),
			completion={{questturnedin="Frostmaw"},{questaccepted="Deadmire"}},
			mapzone="Thunder Bluff",
			level=44,
			mapnote=80914240,
		}, {
			"Fly to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="Thunder Bluff",
			level=44,
		}, {
			"Go to "..cl(36,31),
			"	a. Talk to Overlord Mok'Morokk",
			"		i. Accept "..cq("Overlord Mok'Morokk's Concern"),
			completion={{questaccepted="Overlord Mok'Morokk's Concern"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31406770,
		}, {
			"Go to "..cl(37,33),
			"	a. Talk to Draz'Zilb",
			"		i. Accept "..cq("Identifying the Brood"),
			completion={{questaccepted="Identifying the Brood"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=33107030,
		}, {
			"Go to "..cl(37,31),
			"	a. Talk to Tharg",
			"		i. Accept "..cq("Army of the Black Dragon"),
			completion={{questaccepted="Army of the Black Dragon"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31406880,
		}, {
			"Go southeast to "..cl(41,37),
			"	a. Talk to Ogron",
			"		i. Accept "..cq("Questioning Reethe"),
			"	b. Escort Ogron",
			completion={{questaccepted="Questioning Reethe"},{questgoal={"*","Question Reethe with Ogron",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=36707770,
		}, {
			"Go southeast to "..cl(46,53),
			"	a. Kill Deadmire",
			"	b. Get Deadmire's Tooth",
			completion={{questgoal={"*","Deadmire's Tooth",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=52709830,
		}, {
			"Go south to "..cl(46,57),
			"	a. Talk to Apprentice Garion",
			"		i. Accept "..cq("The Reagent Thief"),
			"	b. Talk to Apprentice Morlann",
			"		i. Accept "..cq("Direhorn Raiders"),
			completion={{questaccepted="The Reagent Thief"},{questaccepted="Direhorn Raiders"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=57210330,
		}, {
			"Go north to "..cl(45,54),
			"	a. Kill Darkfang Creepers",
			"	b. Kill Noxious Shredders",
			"	c. Get 6 Marsh Venom",
			completion={{questgoal={"*","Marsh Venom",6}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=54009900,
		}, {
			"Go north to "..cl(47,50),
			"	a. Kill Grimtotem mobs",
			"	b. Kill 12 Direhorn Grimtotems",
			completion={{questgoal={"*","Direhorn Grimtotems killed",12}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=50009700,
		}, {
			"Go north to "..cl(47,47),
			"	a. Kill Apothecary Cylla",
			"	b. Get the Sealed Letter",
			"	c. Click the Sealed Letter",
			"		i. Accept "..cq("Signs of Treachery?"),
			completion={{questaccepted="Signs of Treachery?"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=46609380,
		}, {
			"Go south to "..cl(46,57),
			"	a. Talk to Apprentice Garion",
			"		i. Turn in "..cq("The Reagent Thief"),
			"	b. Talk to Apprentice Morlann",
			"		i. Turn in "..cq("Direhorn Raiders"),
			completion={{questturnedin="The Reagent Thief"},{questturnedin="Direhorn Raiders"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=57210330,
		}, {
			"Go southwest to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(42,73),
			"	a. Talk to Drazzit Dripvalve",
			"		i. Turn in "..cq("Delivery for Drazzit"),
			completion={{questturnedin="Delivery for Drazzit"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=72911520,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Accept "..cq("Banner of the Stonemaul"),
			"		ii. Accept "..cq("The Essence of Enmity"),
			completion={{questaccepted="Banner of the Stonemaul"},{questaccepted="The Essence of Enmity"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74011590,
		}, {
			"Go to "..cl(42,73),
			"	a. Talk to Gizzix Grimegurgle",
			"		i. Accept "..cq("Catch a Dragon by the Tail"),
			completion={{questaccepted="Catch a Dragon by the Tail"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=73011450,
		}, {
			"Go northwest to "..cl(39,66),
			"	a. Kill Firemane mobs",
			"	b. Use Brogg's Totem on their corpses",
			"	c. Get 10 Black Dragonkin Essences",
			completion={{questgoal={"*","Black Dragonkin Essence",10}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=66010500,
		}, {
			"Go north to "..cl(39,65),
			"	a. Click Mok'Morokk's Grog",
			"	b. Get Mok'Morokk's Grog",
			completion={{questgoal={"*","Mok'Morokk's Grog",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=65610430,
		}, {
			"Go southwest into the cave to "..cl(38,69),
			"	a. Click the Stonemaul Banner",
			"	b. Get the Stonemaul Banner",
			completion={{questgoal={"*","Stonemaul Banner",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=69410750,
		}, {
			"Go southwest inside the cave to "..cl(37,70),
			"	a. Click Mok'Morokk's Strongbox",
			"	b. Get Mok'Morokk's Strongbox",
			completion={{questgoal={"*","Mok'Morokk's Strongbox",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=69610620,
		}, {
			"Leave the cave",
			completion={{location={mapzone="Dustwallow Marsh",x=38.5,y=66.0, dist=0.5}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go southeast to "..cl(42,67),
			"	a. Kill 10 Firemane Scouts",
			"	b. Kill 10 Firemane Ash Tails",
			completion={{questgoal={"*","Firemane Scout slain",10}},{questgoal={"*","Firemane Ash Tail slain",10}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=67310900,
		}, {
			"Go east to "..cl(44,66),
			"	a. Click Mok'Morokk's Snuff",
			"	b. Get Mok'Morokk's Snuff",
			completion={{questgoal={"*","Mok'Morokk's Snuff",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=66011050,
		}, {
			"Go south to "..cl(46,74),
			"	a. Click the Wyrmtails",
			"	b. Get 8 Wyrmtails",
			completion={{questgoal={"*","Wyrmtail",8}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74012000,
		}, {
			"Go southwest to "..cl(42,78),
			"	a. Kill Searing Hatchlings",
			"	b. Kill Searing Whelps",
			"	c. Get 7 Searing Tongues",
			"	d. Get 7 Searing Hearts",
			completion={{questgoal={"*","Searing Tongue",7}},{questgoal={"*","Searing Heart",7}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=77811980,
		}, {
			"Go north to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Turn in "..cq("Banner of the Stonemaul"),
			"		ii. Turn in "..cq("The Essence of Enmity"),
			"		iii. Accept "..cq("Spirits of Stonemaul Hold"),
			completion={{questturnedin="Banner of the Stonemaul"},{questturnedin="The Essence of Enmity"},{questaccepted="Spirits of Stonemaul Hold"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74011590,
		}, {
			"Go to "..cl(42,73),
			"	a. Talk to Gizzix Grimegurgle",
			"		i. Turn in "..cq("Catch a Dragon by the Tail"),
			completion={{questturnedin="Catch a Dragon by the Tail"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=73011450,
		}, {
			"Go northeast to "..cl(46,69),
			"	a. Click the Ogre Remains",
			"	b. Kill the Ogre Spirits",
			"	c. Lay 10 Stonemaul Spirits to rest",
			completion={{questgoal={"*","Stonemaul Spirits laid to rest",10}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=69011500,
		}, {
			"Go southwest to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Turn in "..cq("Spirits of Stonemaul Hold"),
			"		ii. Accept "..cq("Challege to the Black Flight"),
			completion={{questturnedin="Spirits of Stonemaul Hold"},{questaccepted="Challege to the Black Flight"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74011590,
		}, {
			"Go east to "..cl(51,75),
			"	a. Kill 5 Firemane Scalebanes",
			completion={{questgoal={"*","Firemane Scalebane slain",5}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74912630,
		}, {
			"Go southeast to "..cl(52,76),
			"	a. Use your Stonemaul Banner at the foot of the stone ramp",
			"		i. A dragon will appear",
			"	b. Kill Smolderwing",
			"	c. Avenge the Stonemaul Clan",
			completion={{questgoal={"*","Stonemaul Clan Avenged",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=75812790,
		}, {
			"Go northeast to "..cl(55,68),
			"	a. The path over to 'Marg Speaks' starts here",
			completion={{location={mapzone="Dustwallow Marsh",x=55.5,y=67.9, dist=0.5}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=67912340,
		}, {
			"Go north to "..cl(56,65),
			"	a. Kill Muckshell mobs",
			"	b. Get the Jeweled Pendant",
			completion={{questgoal={"*","Jeweled Pendant",1}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=65012080,
		}, {
			"Go southwest to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(42,74),
			"	a. Talk to Brogg",
			"		i. Turn in "..cq("Challenge to the Black Flight"),
			completion={{questturnedin="Challenge to the Black Flight"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=74011590,
		}, {
			"Fly to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(35,31),
			"	a. Talk to Nazeer Bloodpike",
			"		i. Turn in "..cq("Marg Speaks"),
			"		ii. Accept "..cq("Report to Zor"),
			"		iii. Turn in "..cq("Signs of Treachery?"),
			completion={{questturnedin="Marg Speaks"},{questaccepted="Report to Zor"},{questturnedin="Signs of Treachery?"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=30706590,
		}, {
			"Go to "..cl(36,31),
			"	a. Talk to Overlord Mok'Morokk",
			"		i. Turn in "..cq("Overlord Mok'Morokk's Concern"),
			completion={{questturnedin="Overlord Mok'Morokk's Concern"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31406770,
		}, {
			"Go to "..cl(36,32),
			"	a. Talk to Krog",
			"		i. Turn in "..cq("Questioning Reethe"),
			completion={{questturnedin="Questioning Reethe"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31906830,
		}, {
			"Go to "..cl(37,33),
			"	a. Talk to Draz'Zilb",
			"		i. Turn in "..cq("Identifying the Brood"),
			"		ii. Accept "..cq("The Brood of Onyxia part 1"),
			completion={{questturnedin="Identifying the Brood"},{questaccepted="The Brood of Onyxia part 1"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=33107030,
		}, {
			"Go to "..cl(36,31),
			"	a. Talk to Overlord Mok'Morokk",
			"		i. Turn in "..cq("The Brood of Onyxia part 1"),
			"		ii. Accept "..cq("The Brood of Onyxia part 2"),
			completion={{questturnedin="The Brood of Onyxia part 1"},{questaccepted="The Brood of Onyxia part 2"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31406770,
		}, {
			"Go to "..cl(37,33),
			"	a. Talk to Draz'Zilb",
			"		i. Turn in "..cq("The Brood of Onyxia part 2"),
			"		ii. Accept "..cq("The Brood of Onyxia part 3"),
			completion={{questturnedin="The Brood of Onyxia part 2"},{questaccepted="The Brood of Onyxia part 3"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=33107030,
		}, {
			"Go to "..cl(37,31),
			"	a. Talk to Tharg",
			"		i. Turn in "..cq("Army of the Black Dragon"),
			completion={{questturnedin="Army of the Black Dragon"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=31406880,
		}, {
			"Fly to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go southeast to "..cl(48,76),
			"	a. Click the Eggs of Onyxia",
			"	b. Destroy 4 Eggs of Onyxia",
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=76012440,
		}, {
			"Go north to "..cl(48,74),
			"	a. Click an Egg of Onyxia",
			"	b. Destroy 1 Egg of Onyxia",
			completion={{questgoal={"*","Egg of Onyxia destroyed",5}}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=73612210,
		}, {
			"Go west to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Fly to Brackenwall Village",
			completion={{location={mapzone="Dustwallow Marsh",x=36.2,y=31.3, dist=3}}},
			mapzone="Dustwallow Marsh",
			level=44,
		}, {
			"Go to "..cl(37,33),
			"	a. Talk to Draz'Zilb",
			"		i. Turn in "..cq("The Brood of Onyxia part 3"),
			completion={{questturnedin="The Brood of Onyxia part 3"}},
			mapzone="Dustwallow Marsh",
			level=44,
			mapnote=33107030,
		}, {
			"Grind to level 45",
			completion={{level=45}},
			mapzone="Dustwallow Marsh",
			level=44,
		}
	  },
	},
	{ sectiontitle = "Levels (45-50)",
	  steps = {
		{
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Dustwallow Marsh",
			level=45,
		}, {
			"Go to "..cl(62,81),
			"	a. Talk to Melor Stonehoof",
			"		i. Turn in "..cq("Deadmire"),
			completion={{questturnedin="Deadmire"}},
			mapzone="Thunder Bluff",
			level=45,
			mapnote=80914240,
		}, {
			"Fly to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Thunder Bluff",
			level=45,
		}, {
			"Go to "..cl(52,27),
			"	a. Talk to Tran'rek",
			"		i. Turn in "..cq("Tran'rek"),
			completion={{questturnedin="Tran'rek"}},
			mapzone="Tanaris",
			level=45,
			mapnote=26807840,
		}, {
			"Also at "..cl(52,27),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("WANTED: Caliph Scorpidsting"),
			"		ii. Accept "..cq("WANTED: Andre Firebeard"),
			completion={{questaccepted="WANTED: Caliph Scorpidsting"},{questaccepted="WANTED: Andre Firebeard"}},
			mapzone="Tanaris",
			level=45,
			mapnote=27007880,
		}, {
			"Make Gadgetzan your home",
			completion={{home="Gadgetzan"}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Spigot Operator Luglunket",
			"		i. Accept "..cq("Water Pouch Bounty"),
			"	b. Talk to Chief Engineer Bilgewhizzle",
			"		i. Accept "..cq("Wastewander Justice"),
			completion={{questaccepted="Water Pouch Bounty"},{questaccepted="Wastewander Justice"}},
			mapzone="Tanaris",
			level=45,
			mapnote=28508100,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Senior Surveyor Fizzledowser",
			"		i. Accept "..cq("Gadgetzan Water Survey"),
			completion={{questaccepted="Gadgetzan Water Survey"}},
			mapzone="Tanaris",
			level=45,
			mapnote=27507770,
		}, {
			"Go north to Thousand Needles",
			completion={{location={mapzone="Thousand Needles"}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go north to the Mirage Raceway",
			completion={{location={mapzone="Thousand Needles",x=78.6,y=76.0, dist=6}}},
			mapzone="Thousand Needles",
			level=45,
		}, {
			"Go to "..cl(78,77),
			"	a. Talk to Fizzle Brassbolts",
			"		i. Turn in "..cq("News for Fizzle"),
			completion={{questturnedin="News for Fizzle"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=77115520,
		}, {
			"Go to "..cl(80,76),
			"	a. Talk to Pozzik",
			"		i. Accept "..cq("Keeping Pace"),
			completion={{questaccepted="Keeping Pace"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=75915610,
		}, {
			"Go to "..cl(80,77),
			"	a. Talk to Zamek",
			"		i. Turn in "..cq("Zamek's Distraction"),
			"		ii. He will make a distraction",
			completion={{questturnedin="Zamek's Distraction"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=77015680,
		}, {
			"Go to "..cl(77,77),
			"	a. Click Rizzle's Unguarded Plans",
			"		i. Turn in "..cq("Keeping Pace"),
			"		ii. Accept "..cq("Rizzle's Schematics"),
			completion={{questturnedin="Keeping Pace"},{questaccepted="Rizzle's Schematics"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=77415460,
		}, {
			"Go to "..cl(80,76),
			"	a. Talk to Pozzik",
			"		i. Turn in "..cq("Rizzle's Schematics"),
			completion={{questturnedin="Rizzle's Schematics"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=75915610,
		}, {
			"Also at "..cl(80,76),
			"	a. Talk to Razzeric",
			"		i. Turn in "..cq("Razzeric's Tweaking"),
			"		ii. Accept "..cq("Safety First part 1"),
			completion={{questturnedin="Razzeric's Tweaking"},{questaccepted="Safety First part 1"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=76115640,
		}, {
			"Hearth to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Thousand Needles",
			level=45,
		}, {
			"Go to "..cl(51,27),
			"	a. Talk to Shreev",
			"		i. Turn in "..cq("Safety First part 1"),
			"		ii. Accept "..cq("Safety First part 2"),
			completion={{questturnedin="Safety First part 1"},{questaccepted="Safety First part 2"}},
			mapzone="Tanaris",
			level=45,
			mapnote=27207820,
		}, {
			"Go north to Thousand Needles",
			completion={{location={mapzone="Thousand Needles"}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go northeast to "..cl(80,76),
			"	a. Talk to Razzeric",
			"		i. Turn in "..cq("Safety First part 2"),
			completion={{questturnedin="Safety First part 2"}},
			mapzone="Thousand Needles",
			level=45,
			mapnote=76115640,
		}, {
			"Go southwest to Tanaris",
			completion={{location={mapzone="Tanaris"}}},
			mapzone="Thousand Needles",
			level=45,
		}, {
			"Go west to "..cl(39,29),
			"	a. Use your Untapped Dowsing Widget while standing next to the water",
			"	b. Get a Tapped Dowsing Widget",
			"	c. Run away from the insects that spawn",
			completion={{questgoal={"*","Tapped Dowsing Widget",1}}},
			mapzone="Tanaris",
			level=45,
			mapnote=29406800,
		}, {
			"Go east to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Surveyor Fizzledowser",
			"		i. Turn in "..cq("Gadgetzan Water Survey"),
			completion={{questturnedin="Gadgetzan Water Survey"}},
			mapzone="Tanaris",
			level=45,
			mapnote=27507770,
		}, {
			"Go northeast to "..cl(60,25),
			"	a. Kill 10 Wastewander Bandits",
			"	b. Kill 10 Wastewander Thieves",
			"	c. Kill Wastewander mobs",
			"	d. Get 5 Wastewander Water Pouches",
			completion={{questgoal={"*","Wastewander Bandit slain",10}},{questgoal={"*","Wastewander Thief slain",10}},{questgoal={"*","Wastewander Water Pouch",5}}},
			mapzone="Tanaris",
			level=45,
			mapnote=24908440,
		}, {
			"Go east to Steamwheedle Port",
			completion={{location={mapzone="Tanaris",x=66.7,y=23.1, dist=2}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go to "..cl(67,24),
			"	a. Talk to Security Chief Bilgewhizzle",
			"		i. Accept "..cq("Southsea Shakedown"),
			"	b. Talk to Stoley",
			"		i. Turn in "..cq("Stoley's Debt"),
			"		ii. Accept "..cq("Stoley's Shipment"),
			completion={{questturnedin="Stoley's Debt"},{questaccepted="Southsea Shakedown"},{questaccepted="Stoley's Shipment"}},
			mapzone="Tanaris",
			level=45,
			mapnote=23909100,
		}, {
			"Go to "..cl(67,22),
			"	a. Talk to Haughty Modiste",
			"		i. Accept "..cq("Pirate Hats Ahoy!"),
			completion={{questaccepted="Pirate Hats Ahoy!"}},
			mapzone="Tanaris",
			level=45,
			mapnote=22308890,
		}, {
			"Also at "..cl(67,22),
			"	a. Talk to Yeh'kinya",
			"		i. Accept "..cq("Screecher Spirits"),
			completion={{questaccepted="Screecher Spirits"}},
			mapzone="Tanaris",
			level=45,
			mapnote=22408940,
		}, {
			"Go to "..cl(63,35),
			"	a. Kill Caliph Scorpidsting",
			"	b. Get Caliph Scorpidsting's Head",
			completion={{questgoal={"*","Caliph Scorpidsting's Head",1}}},
			mapzone="Tanaris",
			level=45,
			mapnote=34709750,
		}, {
			"Go southeast to "..cl(71,43),
			"	a. Kill 10 Southsea Pirates",
			"	b. Kill 10 Southsea Freebooters",
			"	c. Kill Southsea mobs",
			"	d. Get 20 Southsea Pirate Hats",
			completion={{questgoal={"*","Southsea Pirate slain",10}},{questgoal={"*","Southsea Freebooter slain",10}},{questgoal={"*","Southsea Pirate Hat",20}}},
			mapzone="Tanaris",
			level=45,
			mapnote=42711350,
		}, {
			"Go southeast to "..cl(73,46),
			"	a. Kill 10 Southsea Dock Workers",
			"	b. Kill 10 Southsea Swashbucklers",
			completion={{questgoal={"*","Southsea Dock Worker slain",10}},{questgoal={"*","Southsea Swashbuckler slain",10}}},
			mapzone="Tanaris",
			level=45,
			mapnote=46211950,
		}, {
			"Go south to "..cl(73,47),
			"	a. Kill Andre Firebeard",
			"	b. Get Firebeard's Head",
			completion={{questgoal={"*","Firebeard's Head",1}}},
			mapzone="Tanaris",
			level=45,
			mapnote=47112040,
		}, {
			"Go west to "..cl(72,47),
			"	a. Click the Stolen Cargo",
			"	b. Get Stoley's Shipment",
			completion={{questgoal={"*","Stoley's Shipment",1}}},
			mapzone="Tanaris",
			level=45,
			mapnote=46711890,
		}, {
			"Hearth to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Spigot Operator Luglunket",
			"		i. Turn in "..cq("Water Pouch Bounty"),
			"	b. Talk to Chief Engineer Bilgewhizzle",
			"		i. Turn in "..cq("Wastewander Justice"),
			"		ii. Accept "..cq("More Wastewander Justice"),
			"		iii. Turn in "..cq("WANTED: Caliph Scorpidsting"),
			completion={{questturnedin="Water Pouch Bounty"},{questturnedin="Wastewander Justice"},{questaccepted="More Wastewander Justice"},{questturnedin="WANTED: Caliph Scorpidsting"}},
			mapzone="Tanaris",
			level=45,
			mapnote=28508100,
		}, {
			"Go southeast to "..cl(60,33),
			"	a. Kill 8 Wastewander Rogues",
			"	b. Kill 6 Wastewander Assassins",
			"	c. Kill 10 Wastewander Shadow Mages",
			"	d. Save 5 Wastewander Water Pouches for later",
			completion={{questgoal={"*","Wastewander Rogue slain",8}},{questgoal={"*","Wastewander Assassin slain",6}},{questgoal={"*","Wastewander Shadow Mage slain",10}}},
			mapzone="Tanaris",
			level=45,
			mapnote=32609240,
		}, {
			"Go northeast to Steamwheedle Port",
			completion={{location={mapzone="Tanaris",x=66.7,y=23.1, dist=2}}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go to "..cl(67,24),
			"	a. Talk to Security Chief Bilgewhizzle",
			"		i. Turn in "..cq("WANTED: Andre Firebeard"),
			"		ii. Turn in "..cq("Southsea Shakedown"),
			"	b. Talk to Stoley",
			"		i. Turn in "..cq("Stoley's Shipment"),
			"		ii. Accept "..cq("Deliver to MacKinley"),
			completion={{questturnedin="WANTED: Andre Firebeard"},{questturnedin="Southsea Shakedown"},{questturnedin="Stoley's Shipment"},{questaccepted="Deliver to MacKinley"}},
			mapzone="Tanaris",
			level=45,
			mapnote=23909100,
		}, {
			"Go to "..cl(67,22),
			"	a. Talk to Haughty Modiste",
			"		i. Turn in "..cq("Pirate Hats Ahoy!"),
			completion={{questturnedin="Pirate Hats Ahoy!"}},
			mapzone="Tanaris",
			level=45,
			mapnote=22308890,
		}, {
			"Grind to level 46",
			completion={{level=46}},
			mapzone="Tanaris",
			level=45,
		}, {
			"Go southwest to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=46,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Chief Engineer Bilgewhizzle",
			"		i. Turn in "..cq("More Wastewander Justice"),
			completion={{questturnedin="More Wastewander Justice"}},
			mapzone="Tanaris",
			level=46,
			mapnote=28508100,
		}, {
			"Fly to Freewind Post",
			completion={{location={mapzone="Thousand Needles",x=45.5,y=50.4, dist=2}}},
			mapzone="Tanaris",
			level=46,
		}, {
			"Go northwest to Feralas",
			completion={{location={mapzone="Feralas"}}},
			mapzone="Thousand Needles",
			level=46,
		}, {
			"Go west to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go to "..cl(76,43),
			"	a. Talk to Krueg Skullsplitter",
			"		i. Accept "..cq("A New Cloak's Sheen"),
			completion={{questaccepted="A New Cloak's Sheen"}},
			mapzone="Feralas",
			level=46,
			mapnote=42711860,
		}, {
			"Go to "..cl(76,44),
			"	a. Talk to Rok Orhan",
			"		i. Turn in "..cq("A Threat in Feralas"),
			"		ii. Accept "..cq("The Ogres of Feralas part 1"),
			completion={{questturnedin="A Threat in Feralas"},{questaccepted="The Ogres of Feralas part 1"}},
			mapzone="Feralas",
			level=46,
			mapnote=43611950,
		}, {
			"Also at "..cl(76,44),
			"	a. Talk to Talo Thornhoof",
			"		i. Accept "..cq("Dark Heart"),
			"		ii. Accept "..cq("Vengeance on the Northspring"),
			completion={{questaccepted="Dark Heart"},{questaccepted="Vengeance on the Northspring"}},
			mapzone="Feralas",
			level=46,
			mapnote=43812000,
		}, {
			"Also at "..cl(76,44),
			"	a. Talk to Orwin Gizzmick",
			"		i. Accept "..cq("Gordunni Cobalt"),
			completion={{questaccepted="Gordunni Cobalt"}},
			mapzone="Feralas",
			level=46,
			mapnote=44312000,
		}, {
			"Go to "..cl(75,44),
			"	a. Talk to Shyn",
			"		i. Get the Camp Mojache Flight Path",
			completion={{flightpath="Camp Mojache"}},
			mapzone="Feralas",
			level=46,
			mapnote=44411980,
		}, {
			"Go to "..cl(75,42),
			"	a. Talk to Hadoken Swiftstrider",
			"		i. Accept "..cq("War on the Woodpaw"),
			completion={{questaccepted="War on the Woodpaw"}},
			mapzone="Feralas",
			level=46,
			mapnote=42511740,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Jangdor Swiftstrider",
			"		i. Accept "..cq("The Mark of Quality"),
			completion={{questaccepted="The Mark of Quality"}},
			mapzone="Feralas",
			level=46,
			mapnote=42911730,
		}, {
			"Also at "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Accept "..cq("A Strange Request"),
			completion={{questaccepted="A Strange Request"}},
			mapzone="Feralas",
			level=46,
			mapnote=43411780,
		}, {
			"Make Camp Mojache your home",
			completion={{home="Camp Mojache"}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go northwest to "..cl(72,40),
			"	a. Kill Woodpaw gnolls",
			"	b. Get 10 Woodpaw Gnoll Manes",
			completion={{questgoal={"*","Woodpaw Gnoll Mane",10}}},
			mapzone="Feralas",
			level=46,
			mapnote=40211270,
		}, {
			"Go northeast to "..cl(75,34),
			"	a. Kill 10 Gordunni Ogres",
			"	b. Kill 10 Gordunni Ogre Mages",
			"	c. Kill 5 Gordunni Brutes",
			"	d. Use Orwin's Shovel on top of the blue glowing spots on the ground",
			"	e. Click the dirt mounds",
			"	f. Get 12 Gordunni Cobalt",
			completion={{questgoal={"*","Gordunni Ogre slain",10}},{questgoal={"*","Gordunni Ogre Mage slain",10}},{questgoal={"*","Gordunni Brute slain",5}},{questgoal={"*","Gordunni Cobalt",12}}},
			mapzone="Feralas",
			level=46,
			mapnote=34310970,
		}, {
			"Go east to "..cl(81,34),
			"	a. Click the Gordunni Scroll",
			"		i. It can spawn in different spots, so just look for it on the ground",
			"	b. Get the Gordunni Scroll",
			"	c. Click Gordunni Scroll in your bags",
			"		i. Accept "..cq("The Gordunni Scroll"),
			completion={{questaccepted="The Gordunni Scroll"}},
			mapzone="Feralas",
			level=46,
			mapnote=34311490,
		}, {
			"Go south to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go to "..cl(75,42),
			"	a. Talk to Hadoken Swiftstrider",
			"		i. Turn in "..cq("War on the Woodpaw"),
			"		ii. Accept "..cq("Alpha Strike"),
			completion={{questturnedin="War on the Woodpaw"},{questaccepted="Alpha Strike"}},
			mapzone="Feralas",
			level=46,
			mapnote=42511740,
		}, {
			"Go to "..cl(76,44),
			"	a. Talk to Orwin Gizzmick",
			"		i. Turn in "..cq("Gordunni Cobalt"),
			completion={{questturnedin="Gordunni Cobalt"}},
			mapzone="Feralas",
			level=46,
			mapnote=44312000,
		}, {
			"Also at "..cl(76,44),
			"	a. Talk to Rok Orhan",
			"		i. Turn in "..cq("The Ogres of Feralas part 1"),
			"		ii. Accept "..cq("The Ogres of Feralas part 2"),
			"		iii. Turn in "..cq("The Gordunni Scroll"),
			"		iv. Accept "..cq("Dark Ceremony"),
			completion={{questturnedin="The Ogres of Feralas part 1"},{questturnedin="The Gordunni Scroll"},{questaccepted="The Ogres of Feralas part 2"},{questaccepted="Dark Ceremony"}},
			mapzone="Feralas",
			level=46,
			mapnote=43611950,
		}, {
			"Go southwest to "..cl(73,55),
			"	a. They are always in the camps with tents",
			"	b. Kill 5 Woodpaw Alphas",
			completion={{questgoal={"*","Woodpaw Alpha slain",5}}},
			mapzone="Feralas",
			level=46,
			mapnote=55512900,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go to "..cl(75,42),
			"	a. Talk to Hadoken Swiftstrider",
			"		i. Turn in "..cq("Alpha Strike"),
			"		ii. Accept "..cq("Woodpaw Investigation"),
			completion={{questturnedin="Alpha Strike"},{questaccepted="Woodpaw Investigation"}},
			mapzone="Feralas",
			level=46,
			mapnote=42511740,
		}, {
			"Go southwest to "..cl(72,56),
			"	a. Click the Woodpaw Battle Map",
			"		i. Turn in "..cq("Woodpaw Investigation"),
			"		ii. Accept "..cq("The Battle Plans"),
			completion={{questturnedin="Woodpaw Investigation"},{questaccepted="The Battle Plans"}},
			mapzone="Feralas",
			level=46,
			mapnote=55912750,
		}, {
			"Go northwest to "..cl(69,49),
			"	a. Kill Sprite Darters",
			"	b. Get 10 Iridescent Sprite Darter Wings",
			completion={{questgoal={"*","Iridescent Sprite Darter Wing",10}}},
			mapzone="Feralas",
			level=46,
			mapnote=49011800,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go to "..cl(75,42),
			"	a. Talk to Hadoken Swiftstrider",
			"		i. Turn in "..cq("The Battle Plans"),
			"		ii. Accept "..cq("Zukk'ash Infestation"),
			"		iii. Accept "..cq("Stinglasher"),
			completion={{questturnedin="The Battle Plans"},{questaccepted="Zukk'ash Infestation"},{questaccepted="Stinglasher"}},
			mapzone="Feralas",
			level=46,
			mapnote=42511740,
		}, {
			"Go to "..cl(76,43),
			"	a. Talk to Krueg Skullsplitter",
			"		i. Turn in "..cq("A New Cloak's Sheen"),
			"		ii. Accept "..cq("A Grim Discovery part 1"),
			completion={{questturnedin="A New Cloak's Sheen"},{questaccepted="A Grim Discovery part 1"}},
			mapzone="Feralas",
			level=46,
			mapnote=42711860,
		}, {
			"Go south to "..cl(75,60),
			"	a. Stinglasher wanders around this area and inside the hive",
			"	b. Kill Stinglasher",
			"	c. Get Stinglasher's Glands",
			completion={{questgoal={"*","Stinglasher's Glands",1}}},
			mapzone="Feralas",
			level=46,
			mapnote=60613590,
		}, {
			"Go southwest to "..cl(73,63),
			"	a. Kill Zukk'ash mobs",
			"	b. Get 20 Zukk'ash Carapaces",
			completion={{questgoal={"*","Zukk'ash Carapace",20}}},
			mapzone="Feralas",
			level=46,
			mapnote=62813560,
		}, {
			"Go northwest to "..cl(70,48),
			"	a. Kill Grimtotem mobs",
			"	b. Get 20 Grimtotem Horns",
			completion={{questgoal={"*","Grimtotem Horn",20}}},
			mapzone="Feralas",
			level=46,
			mapnote=47711730,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go to "..cl(75,42),
			"	a. Talk to Hadoken Swiftstrider",
			"		i. Turn in "..cq("Zukk'ash Infestation"),
			"		ii. Turn in "..cq("Stinglasher"),
			"		iii. Accept "..cq("Zukk'ash Report"),
			completion={{questturnedin="Zukk'ash Infestation"},{questturnedin="Stinglasher"},{questaccepted="Zukk'ash Report"}},
			mapzone="Feralas",
			level=46,
			mapnote=42511740,
		}, {
			"Go to "..cl(76,43),
			"	a. Talk to Krueg Skullsplitter",
			"		i. Turn in "..cq("A Grim Discovery part 1"),
			"		ii. Accept "..cq("A Grim Discovery part 2"),
			completion={{questturnedin="A Grim Discovery part 1"},{questaccepted="A Grim Discovery part 2"}},
			mapzone="Feralas",
			level=46,
			mapnote=42711860,
		}, {
			"Go west to "..cl(46,47),
			"	a. Kill Vale Screechers",
			"	b. Use Yeh'kinya's Bramble on the Vale Screecher corpses",
			"	c. Talk to the Screecher Spirits to collect them",
			"	d. Collect 3 Screecher Spirits",
			completion={{questgoal={"*","Screecher Spirits Collected",3}}},
			mapzone="Feralas",
			level=46,
			mapnote=47109360,
		}, {
			"Go southeast to "..cl(55,54),
			"	a. Kill Feral Scar Yetis",
			"	b. Get 10 Thick Yeti Hides",
			completion={{questgoal={"*","Thick Yeti Hide",10}}},
			mapzone="Feralas",
			level=46,
			mapnote=54410980,
		}, {
			"Go southeast to "..cl(59,62),
			"	a. Kill 10 Gordunni Shamans",
			"	b. Kill 10 Gordunni Warlocks",
			"	c. Kill 5 Gordunni Maulers",
			completion={{questgoal={"*","Gordunni Shaman slain",10}},{questgoal={"*","Gordunni Warlock slain",10}},{questgoal={"*","Gordunni Mauler slain",5}}},
			mapzone="Feralas",
			level=46,
			mapnote=62612170,
		}, {
			"Go south to "..cl(59,68),
			"	a. Kill Gordunni Mage-Lords",
			"	b. Get a Gordunni Orb",
			completion={{questgoal={"*","Gordunni Orb",1}}},
			mapzone="Feralas",
			level=46,
			mapnote=68412790,
		}, {
			"Grind to level 47",
			completion={{level=47}},
			mapzone="Feralas",
			level=46,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=47,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Accept "..cq("The Sunken Temple"),
			completion={{questaccepted="The Sunken Temple"}},
			mapzone="Feralas",
			level=47,
			mapnote=43411780,
		}, {
			"Also at "..cl(74,43),
			"	a. Talk to Jungdor Swiftstrider",
			"		i. Turn in "..cq("The Mark of Quality"),
			"		ii. Accept "..cq("Improved Quality"),
			completion={{questturnedin="The Mark of Quality"},{questaccepted="Improved Quality"}},
			mapzone="Feralas",
			level=47,
			mapnote=42911730,
		}, {
			"Go to 76, 44",
			"	a. Talk to Rok Orhan",
			"		i. Turn in "..cq("Dark Ceremony"),
			"		ii. Accept "..cq("The Gordunni Orb"),
			"		iii. Turn in "..cq("The Ogres of Feralas part 2"),
			completion={{questturnedin="Dark Ceremony"},{questaccepted="The Gordunni Orb"},{questturnedin="The Ogres of Feralas part 2"}},
			mapzone="Feralas",
			level=47,
			mapnote=43611950,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Feralas",
			level=47,
		}, {
			"Go to "..cl(39,86),
			"	a. Talk to Uthel'nay",
			"		i. Turn in "..cq("The Gordunni Orb"),
			completion={{questturnedin="The Gordunni Orb"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=86312550,
		}, {
			"Go to "..cl(49,51),
			"	a. Talk to Neeru Fireblade",
			"		i. Turn in "..cq("A Strange Request"),
			"		ii. Accept "..cq("Return to Witch Doctor Uzer'i"),
			completion={{questturnedin="A Strange Request"},{questaccepted="Return to Witch Doctor Uzer'i"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=50610010,
		}, {
			"Go to "..cl(56,47),
			"	a. Talk to Zilzibin Drumlore",
			"		i. Turn in "..cq("Zukk'ash Report"),
			completion={{questturnedin="Zukk'ash Report"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=46710290,
		}, {
			"Go to "..cl(59,37),
			"	a. Talk to Dran Droffers",
			"		i. Accept "..cq("Ripple Recover part 1"),
			"	b. Talk to Malton Droffers",
			"		i. Turn in "..cq("Ripple Recovery part 1"),
			"		ii. Accept "..cq("Ripple Recovery part 2"),
			completion={{questturnedin="Ripple Recovery part 1"},{questaccepted="Ripple Recover part 1"},{questaccepted="Ripple Recovery part 2"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=36809630,
		}, {
			"Go to "..cl(75,34),
			"	a. Talk to Belgrom Rockmaul",
			"		i. Turn in "..cq("A Grim Discovery part 2"),
			"		ii. Accept "..cq("Betrayed part 1"),
			completion={{questturnedin="A Grim Discovery part 2"},{questaccepted="Betrayed part 1"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=34210940,
		}, {
			"Go to "..cl(39,38),
			"	a. Talk to Zor Lonetree",
			"		i. Turn in "..cq("Report to Zor"),
			"		ii. Turn in "..cq("Service to the Horde"),
			completion={{questturnedin="Report to Zor"},{questturnedin="Service to the Horde"}},
			mapzone="Orgrimmar",
			level=47,
			mapnote=38407730,
		}, {
			"Hearth to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Orgrimmar",
			level=47,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Return to Witch Doctor Uzer'i"),
			"		ii. Accept "..cq("Natural Materials"),
			"		iii. Accept "..cq("Testing the Vessel"),
			completion={{questturnedin="Return to Witch Doctor Uzer'i"},{questaccepted="Natural Materials"},{questaccepted="Testing the Vessel"}},
			mapzone="Feralas",
			level=47,
			mapnote=43411780,
		}, {
			"Go southwest to "..cl(68,49),
			"	a. Kill Sprite Darters",
			"	b. Get 6 Encrusted Minerals",
			completion={{questgoal={"*","Encrusted Minerals",6}}},
			mapzone="Feralas",
			level=47,
			mapnote=49211760,
		}, {
			"Go southwest to "..cl(56,61),
			"	a. Kill Wandering Forest Walkers",
			"	b. Get 2 Splintered Logs",
			"	c. Kill hippogryphs",
			"	d. Get 20 Resilient Sinew",
			"	e. Get 40 Metallic Fragments",
			completion={{questgoal={"*","Splintered Log",2}},{questgoal={"*","Resilient Sinew",20}},{questgoal={"*","Metallic Fragments",40}}},
			mapzone="Feralas",
			level=47,
			mapnote=61011730,
		}, {
			"Hearth to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=47,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Natural Materials"),
			completion={{questturnedin="Natural Materials"}},
			mapzone="Feralas",
			level=47,
			mapnote=43411780,
		}, {
			"Fly to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Feralas",
			level=47,
		}, {
			"Go northeast to Azshara",
			completion={{location={mapzone="Azshara"}}},
			mapzone="Ashenvale",
			level=47,
		}, {
			"Go southeast to "..cl(11,78),
			"	a. Talk to Loh'atu",
			"		i. Accept "..cq("Spiritual Unrest"),
			"		ii. Accept "..cq("A Land Filled with Hatred"),
			completion={{questaccepted="Spiritual Unrest"},{questaccepted="A Land Filled with Hatred"}},
			mapzone="Azshara",
			level=47,
			mapnote=78208960,
		}, {
			"Go northeast to "..cl(13,74),
			"	a. Kill 6 Highborne Apparitions",
			"	b. Kill 6 Highborne Lichlings",
			completion={{questgoal={"*","Highborne Apparition slain",6}},{questgoal={"*","Highborne Lichling slain",6}}},
			mapzone="Azshara",
			level=47,
			mapnote=73908730,
		}, {
			"Go northeast to "..cl(19,64),
			"	a. Kill 6 Haldarr Satyr",
			"	b. Kill 2 Haldarr Tricksters",
			"	c. Kill 2 Haldarr Felsworn",
			completion={{questgoal={"*","Haldarr Satyr slain",6}},{questgoal={"*","Haldarr Trickster slain",2}},{questgoal={"*","Haldarr Felsworn slain",2}}},
			mapzone="Azshara",
			level=47,
			mapnote=64008330,
		}, {
			"Go southwest to "..cl(11,78),
			"	a. Talk to Loh'atu",
			"		i. Turn in "..cq("Spiritual Unrest"),
			"		ii. Turn in "..cq("A Land Filled with Hatred"),
			completion={{questturnedin="Spiritual Unrest"},{questturnedin="A Land Filled with Hatred"}},
			mapzone="Azshara",
			level=47,
			mapnote=78208960,
		}, {
			"Go northeast to "..cl(22,51),
			"	a. Talk to Ag'tor Bloodfist",
			"		i. Turn in "..cq("Betrayed part 1"),
			completion={{questturnedin="Betrayed part 1"}},
			mapzone="Azshara",
			level=47,
			mapnote=51507380,
		}, {
			"Go to "..cl(22,50),
			"	a. Talk to Kroum",
			"		i. Get the Valormok Flight Path",
			completion={{flightpath="Valormok"}},
			mapzone="Azshara",
			level=47,
			mapnote=49607160,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Azshara",
			level=47,
		}, {
			"Go outside to Durotar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=47,
		}, {
			"Ride the zeppelin to Undercity",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=58.8, dist=2}}},
			mapzone="Durotar",
			level=47,
			mapnote=13306410,
		}, {
			"Go south to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Tirisfal Glades",
			level=47,
		}, {
			"Go to "..cl(73,33),
			"	a. Talk to Oran Snakewrithe",
			"		i. Accept "..cq("Lines of Communication"),
			completion={{questaccepted="Lines of Communication"}},
			mapzone="Undercity",
			level=47,
			mapnote=32910590,
		}, {
			"Go to "..cl(49,71),
			"	a. Talk to Chemist Cuely",
			"		i. Accept "..cq("Seeping Corruption part 1"),
			completion={{questaccepted="Seeping Corruption part 1"}},
			mapzone="Undercity",
			level=47,
			mapnote=71812020,
		}, {
			"Go to "..cl(50,68),
			"	a. Talk to Apothecary Zinge",
			"		i. Accept "..cq("Errand for Apothecary Zinge part 1"),
			completion={{questaccepted="Errand for Apothecary Zinge part 1"}},
			mapzone="Undercity",
			level=47,
			mapnote=68411830,
		}, {
			"Go to "..cl(59,55),
			"	a. Talk to Alessandro Luca",
			"		i. Turn in "..cq("Errand for Apothecary Zinge part 1"),
			"		ii. Accept "..cq("Errand for Apothecary Zinge part 2"),
			completion={{questturnedin="Errand for Apothecary Zinge part 1"},{questaccepted="Errand for Apothecary Zinge part 2"}},
			mapzone="Undercity",
			level=47,
			mapnote=54711330,
		}, {
			"Go to "..cl(50,64),
			"	a. Talk to Apothecary Zinge",
			"		i. Turn in "..cq("Errand for Apothecary Zinge part 2"),
			"		ii. Accept "..cq("Into the Field"),
			completion={{questturnedin="Errand for Apothecary Zinge part 2"},{questaccepted="Into the Field"}},
			mapzone="Undercity",
			level=47,
			mapnote=68411830,
		}, {
			"Fly to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="Undercity",
			level=47,
		}, {
			"Make Tarren Mill your home",
			completion={{home="Tarren Mill"}},
			mapzone="Hillsbrad Foothills",
			level=47,
		}, {
			"Go southeast to "..cl(85,32),
			"	a. The path to the Hinterlands starts here",
			completion={{location={mapzone="Hillsbrad Foothills",x=84.9,y=31.8, dist=1}}},
			mapzone="Hillsbrad Foothills",
			level=47,
			mapnote=32011700,
		}, {
			"Go northeast to the Hinterlands",
			completion={{location={mapzone="The Hinterlands"}}},
			mapzone="Hillsbrad Foothills",
			level=47,
		}, {
			"Go northeast to "..cl(20,48),
			"	a. The path up to Gilveradin Sunchaser starts here",
			completion={{location={mapzone="The Hinterlands",x=20.3,y=48.3, dist=0.5}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=48206860,
		}, {
			"Go east to "..cl(27,49),
			"	a. Talk to Gilveradin Sunchaser",
			"		i. Turn in "..cq("Ripple Recovery part 2"),
			"		ii. Accept "..cq("A Sticky Situation"),
			completion={{questturnedin="Ripple Recovery part 2"},{questaccepted="A Sticky Situation"}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=48607530,
		}, {
			"Go northeast to "..cl(28,46),
			"	a. Click the Highvale Report",
			"	b. Burn the Highvale Report",
			completion={{questgoal={"*","Burn the Highvale Report",1}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=46107470,
		}, {
			"Go southeast to "..cl(29,49),
			"	a. Click the Highvale Notes",
			"	b. Burn the Highvale Notes",
			completion={{questgoal={"*","Burn the Highvale Notes",1}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=48707830,
		}, {
			"Go northeast to "..cl(32,47),
			"	a. Click the Highvale Records",
			"	b. Burn the Highvale Records",
			completion={{questgoal={"*","Burn the Highvale Records",1}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=46807880,
		}, {
			"Go west to "..cl(31,47),
			"	a. Talk to Rin'ji",
			"		i. Accept "..cq("Rin'ji is Trapped!"),
			"	b. Escort Rin'ji to safety",
			completion={{questaccepted="Rin'ji is Trapped!"},{questgoal={"*","Escort Rin'ji to safety",1}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=47007770,
		}, {
			"Go southeast to "..cl(33,57),
			"	a. Kill Witherbark trolls",
			"	b. Get 20 Witherbark Skulls",
			"	c. Click Nimboya's Pike in your bags once you have 20 Witherbark Skulls",
			"	d. Click Nimboya's Laden Pike inside the troll billage",
			"	e. Plant the Grim Message",
			completion={{questgoal={"*","Place the grim message.",1}}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=56808940,
		}, {
			"Go southwest to "..cl(31,58),
			"	a. Click a Venom Bottle",
			"		i. Get "..cq("Venom Bottles"),
			completion={{questaccepted="Venom Bottles"}},
			mapzone="The Hinterlands",
			level=47,
			mapnote=57708920,
		}, {
			"Grind to level 48",
			completion={{level=48}},
			mapzone="The Hinterlands",
			level=47,
		}, {
			"Go northeast to "..cl(47,40),
			"	a. Click the Horde Supply Crates",
			"	b. Get 10 Hinterlands Honey Ripple",
			completion={{questgoal={"*","Hinterlands Honey Ripple",10}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=40308750,
		}, {
			"Go southeast to "..cl(71,65),
			"	a. The path down to Revantusk Village starts here",
			completion={{location={mapzone="The Hinterlands",x=71.2,y=64.7, dist=0.5}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=64713590,
		}, {
			"Go southeast to Revantusk Village",
			completion={{location={mapzone="The Hinterlands",x=78.4,y=80.6, dist=6}}},
			mapzone="The Hinterlands",
			level=48,
		}, {
			"Go to "..cl(79,78),
			"	a. Talk to Mystic Yayo'jin",
			"		i. Accept "..cq("Cannibalistic Cousins"),
			completion={{questaccepted="Cannibalistic Cousins"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=78215700,
		}, {
			"Go to "..cl(79,79),
			"	a. Talk to Otho Moji'ko",
			"		i. Accept "..cq("Message to the Wildhammer"),
			completion={{questaccepted="Message to the Wildhammer"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=79115850,
		}, {
			"Go to "..cl(79,80),
			"	a. Talk to Huntsman Markhor",
			"		i. Accept "..cq("Stalking the Stalkers"),
			"		ii. Accept "..cq("Hunt the Savages"),
			"		iii. Accept "..cq("Avenging the Fallen"),
			completion={{questaccepted="Stalking the Stalkers"},{questaccepted="Hunt the Savages"},{questaccepted="Avenging the Fallen"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=79515870,
		}, {
			"Go to "..cl(82,82),
			"	a. Talk to Gorkas",
			"		i. Get the Revantusk Village Flight Path",
			completion={{flightpath="Revantusk Village"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=81816350,
		}, {
			"Go to "..cl(78,80),
			"	a. Talk to Smith Slagtree",
			"		i. Accept "..cq("Vilebranch Hooligans"),
			completion={{questaccepted="Vilebranch Hooligans"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=80315780,
		}, {
			"Go north to "..cl(77,76),
			"	a. Click the Pupellyverbos Port bottles",
			"	b. Get 12 Pupellyverbos Port",
			completion={{questgoal={"*","Pupellyverbos Port",12}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=76115330,
		}, {
			"Go northeast to "..cl(86,59),
			"	a. Click Rin'ji's Secret",
			"		i. Turn in "..cq("Rin'ji is Trapped!"),
			"		ii. Accept "..cq("Rin'ji's Secret"),
			completion={{questturnedin="Rin'ji is Trapped!"},{questaccepted="Rin'ji's Secret"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=59014530,
		}, {
			"Go west to "..cl(70,59),
			"	a. Kill 10 Silvermane Stalkers",
			completion={{questgoal={"*","Silvermane Stalker slain",10}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=58912920,
		}, {
			"Slagtree's Lost Tools can be at any of these 5 spots:",
			"	a. "..cl(73,53),
			"	b. "..cl(71,49),
			"	c. "..cl(66,45),
			"	d. "..cl(57,43),
			"	e. "..cl(53,39),
			"	f. Click Slagtree's Lost Tools",
			"	g. Get Slagtree's Lost Tools",
			"	h. Spawn Location #1",
			completion={{questgoal={"*","Slagtree's Lost Tools",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=53012560,
		}, {
			"Slagtree's Lost Tools may also be here.",
			"	a. Spawn Location #2",
			completion={{questgoal={"*","Slagtree's Lost Tools",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=48611960,
		}, {
			"Slagtree's Lost Tools may also be here.",
			"	a. Spawn Location #3",
			completion={{questgoal={"*","Slagtree's Lost Tools",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=44711110,
		}, {
			"Slagtree's Lost Tools may also be here.",
			"	a. Spawn Location #4",
			completion={{questgoal={"*","Slagtree's Lost Tools",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=42610000,
		}, {
			"Slagtree's Lost Tools may also be here.",
			"	a. Spawn Location #5",
			completion={{questgoal={"*","Slagtree's Lost Tools",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=38809210,
		}, {
			"Go northwest to "..cl(71,49),
			"	a. Kill 15 Vilebranch Scalpers",
			"	b. Kill 10 Vilebranch Soothsayers",
			completion={{questgoal={"*","Vilebranch Scalper slain",15}},{questgoal={"*","Vilebranch Soothsayer slain",10}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=49512030,
		}, {
			"Go west to "..cl(63,52),
			"	a. Kill 20 Savage Owlbeasts",
			"	b. Use the Wildkin Muisek Vessel on their corpses",
			"	c. Get 10 Wildkin Muiseks",
			completion={{questgoal={"*","Savage Owlbeast slain",20}},{questgoal={"*","Wildkin Muisek",10}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=51911450,
		}, {
			"Go southwest to "..cl(59,54),
			"	a. Kill a Razorbeak Skylord",
			"	b. Get a Skylord Plume",
			completion={{questgoal={"*","Skylord Plume",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=53711310,
		}, {
			"Go southwest to "..cl(44,59),
			"	a. Kill 10 Silvermane Howlers",
			completion={{questgoal={"*","Silvermane Howler slain",10}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=58710260,
		}, {
			"Go to Revantusk Village",
			completion={{location={mapzone="The Hinterlands",x=78.4,y=80.6, dist=6}}},
			mapzone="The Hinterlands",
			level=48,
		}, {
			"Go to "..cl(78,80),
			"	a. Talk to Smith Slagtree",
			"		i. Turn in "..cq("Vilebranch Hooligans"),
			completion={{questturnedin="Vilebranch Hooligans"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=80315780,
		}, {
			"Go to "..cl(79,78),
			"	a. Talk to Mystic Yayo'jin",
			"		i. Turn in "..cq("Cannibalistic Cousins"),
			completion={{questturnedin="Cannibalistic Cousins"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=78215700,
		}, {
			"Go to "..cl(79,80),
			"	a. Talk to Huntsman Markhor",
			"		i. Turn in "..cq("Stalking the Stalkers"),
			"		ii. Turn in "..cq("Hunt the Savages"),
			"		iii. Turn in "..cq("Avenging the Fallen"),
			completion={{questturnedin="Stalking the Stalkers"},{questturnedin="Hunt the Savages"},{questturnedin="Avenging the Fallen"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=79515870,
		}, {
			"Fly to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="The Hinterlands",
			level=48,
		}, {
			"Go to "..cl(61,19),
			"	a. Talk to Apothecary Lydon",
			"		i. Turn in "..cq("Venom Bottles"),
			"		ii. Accept "..cq("Undamaged Venom Sac"),
			completion={{questturnedin="Venom Bottles"},{questaccepted="Undamaged Venom Sac"}},
			mapzone="Hillsbrad Foothills",
			level=48,
			mapnote=19108050,
		}, {
			"Southeast to "..cl(85,32),
			"	a. The path to the Hinterlands starts here",
			completion={{location={mapzone="Hillsbrad Foothills",x=84.9,y=31.8, dist=1}}},
			mapzone="Hillsbrad Foothills",
			level=48,
			mapnote=32011700,
		}, {
			"Go northeast to the Hinterlands",
			completion={{location={mapzone="The Hinterlands"}}},
			mapzone="Hillsbrad Foothills",
			level=48,
		}, {
			"Go northeast to "..cl(27,49),
			"	a. Talk to Gilveradin Sunchaser",
			"		i. Turn in "..cq("A Sticky Situation"),
			"		ii. Accept "..cq("Ripple Delivery"),
			completion={{questturnedin="A Sticky Situation"},{questaccepted="Ripple Delivery"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=48607530,
		}, {
			"Go southeast to "..cl(29,51),
			"	a. Kill 15 Highvale Scouts",
			"	b. Kill 15 Highvale Outrunners",
			"	c. Kill 15 Highvale Rangers",
			"	d. Kill 15 Highvale Marksman",
			completion={{questgoal={"*","Highvale Scout slain",15}},{questgoal={"*","Highvale Outrunner slain",15}},{questgoal={"*","Highvale Ranger slain",15}},{questgoal={"*","Highvale Marksman slain",15}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=51508060,
		}, {
			"Go southeast to "..cl(36,65),
			"	a. Kill spiders",
			"	b. Get an Undamaged Venom Sac",
			"		i. This item has a timed expiration, so hurry",
			completion={{questgoal={"*","Undamaged Venom Sac",1}}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=64810050,
		}, {
			"Go east to Revantusk Village",
			completion={{location={mapzone="The Hinterlands",x=78.4,y=80.6, dist=6}}},
			mapzone="The Hinterlands",
			level=48,
		}, {
			"Go to "..cl(79,79),
			"	a. Talk to Otho Moji'ko",
			"		i. Turn in "..cq("Message to the Wildhammer"),
			completion={{questturnedin="Message to the Wildhammer"}},
			mapzone="The Hinterlands",
			level=48,
			mapnote=79115850,
		}, {
			"Hearth to Tarren Mill",
			completion={{location={mapzone="Hillsbrad Foothills",x=61.4,y=23.0, dist=4}}},
			mapzone="The Hinterlands",
			level=48,
		}, {
			"Go to "..cl(61,19),
			"	a. Talk to Apothecary Lydon",
			"		i. Turn in "..cq("Undamaged Venom Sac"),
			completion={{questturnedin="Undamaged Venom Sac"}},
			mapzone="Hillsbrad Foothills",
			level=48,
			mapnote=19108050,
		}, {
			"Fly to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Hillsbrad Foothills",
			level=48,
		}, {
			"Go to "..cl(73,33),
			"	a. Talk to Oran Snakewrithe",
			"		i. Turn in "..cq("Rin'ji's Secret"),
			"		ii. Turn in "..cq("Lines of Communication"),
			"		iii. Turn in "..cq("Oran's Gratitude"),
			completion={{questturnedin="Rin'ji's Secret"},{questturnedin="Lines of Communication"},{questturnedin="Oran's Gratitude"}},
			mapzone="Undercity",
			level=48,
			mapnote=32910590,
		}, {
			"Fly to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Undercity",
			level=48,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk Nimboya",
			"		i. Turn in "..cq("Grim Message"),
			completion={{questturnedin="Grim Message"}},
			mapzone="Stranglethorn Vale",
			level=48,
			mapnote=27705990,
		}, {
			"Grind to level 49",
			completion={{level=49}},
			mapzone="Stranglethorn Vale",
			level=48,
		}, {
			"Go southwest to "..cl(29,44),
			"	a. Kill Tethis",
			"	b. Get the Talon of Tethis",
			completion={{questgoal={"*","Talon of Tethis",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=44107330,
		}, {
			"Go northeast to "..cl(36,11),
			"	a. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Raptor Mastery part 4"),
			"		ii. Accept "..cq("Big Game Hunter"),
			completion={{questturnedin="Raptor Mastery part 4"},{questaccepted="Big Game Hunter"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=10604620,
		}, {
			"Go southeast to "..cl(38,66),
			"	a. Kill King Bangalash",
			"	b. Get the Head of Bangalash",
			completion={{questgoal={"*","Head of Bangalash",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=36407460,
		}, {
			"Go northwest to "..cl(36,11),
			"	a. Talk to Hemet Nesingwary Jr.",
			"		i. Turn in "..cq("Big Game Hunter"),
			completion={{questturnedin="Big Game Hunter"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=10604620,
		}, {
			"Go southwest to Grom'gol Base Camp",
			completion={{location={mapzone="Stranglethorn Vale",x=31.9,y=28.4, dist=3}}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Fly to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Fleet Master Seahorn",
			"		i. Accept "..cq("The Bloodsail Buccaneers part 5"),
			completion={{questaccepted="The Bloodsail Buccaneers part 5"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=76910410,
		}, {
			"Also at "..cl(27,77),
			"	a. Talk to Whiskey Slim",
			"		i. Turn in "..cq("Whiskey Slim's Lost Grog"),
			completion={{questturnedin="Whiskey Slim's Lost Grog"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=77510460,
		}, {
			"Make Booty Bay your home",
			completion={{home="Booty Bay"}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to 'Sea Wolf' MacKinley",
			"		i. Turn in "..cq("Deliver to MacKinley"),
			completion={{questturnedin="Deliver to MacKinley"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=77110490,
		}, {
			"Also at "..cl(28,77),
			"	a. Talk to Fin Fizracket",
			"		i. Accept "..cq("Stranglethorn Fever"),
			completion={{questaccepted="Stranglethorn Fever"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=76710430,
		}, {
			"Go northeast to "..cl(31,68),
			"	a. Kill gorillas",
			"	b. Get 1 Gorilla Fang",
			completion={{item={"Gorilla Fang", 1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=68109920,
		}, {
			"Go northeast to "..cl(35,60),
			"	a. Talk to Witch Doctor Unbagwa",
			"		i. Give him 1 Gorilla Fang",
			"	b. 3 gorillas will attack you one at a time",
			"		i. Mokk the Savage is the final gorilla",
			"	c. Kill Mokk the Savage",
			"	d. Get the Heart of Mokk",
			completion={{questgoal={"*","Heart of Mokk",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=60409570,
		}, {
			"Go south to "..cl(35,73),
			"	a. They are very small, blueish, bottles buried randomly in the sand near the water",
			"	b. Click the Half-Buried Bottles",
			"	c. Get the Carefully Folded Note",
			"	d. Click the Carefully Folded Note",
			"		i. Accept "..cq("Message in a Bottle part 1"),
			completion={{questaccepted="Message in a Bottle part 1"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=72910800,
		}, {
			"Go southeast to "..cl(39,81),
			"	a. Talk to Princess Poobah",
			"		i. Turn in "..cq("Message in a Bottle part 1"),
			"		ii. Accept "..cq("Message in a Bottle part 2"),
			completion={{questturnedin="Message in a Bottle part 1"},{questaccepted="Message in a Bottle part 2"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=80611910,
		}, {
			"Go southeast to "..cl(41,83),
			"	a. Kill King Mukla",
			"	b. Get the Shackle Key",
			completion={{questgoal={"*","Shackle Key",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=83012400,
		}, {
			"Go northwest to "..cl(39,81),
			"	a. Talk to Princess Poobah",
			"		i. Turn in "..cq("Message in a Bottle part 2"),
			completion={{questturnedin="Message in a Bottle part 2"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=80611910,
		}, {
			"While doing the next 3 steps, look for Cortello's Riddle on the ships",
			"	a. It's a scroll",
			"	b. Click Cortello's Riddle",
			"		i. Accept "..cq("Cortello's Riddle part 1"),
			completion={{questaccepted="Cortello's Riddle part 1"}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Go southwest to "..cl(33,88),
			"	a. Kill Captain Stillwater on the ship",
			completion={{questgoal={"*","Captain Stillwater slain",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=88212110,
		}, {
			"Go southwest to "..cl(31,90),
			"	a. Kill Fleet Master Firallon on the ship",
			completion={{questgoal={"*","Fleet Master Firallon slain",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=90612120,
		}, {
			"Go northwest to "..cl(29,88),
			"	a. Kill Captain Keelhaul on the ship",
			completion={{questgoal={"*","Captain Keelhaul slain",1}}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=88311750,
		}, {
			"Hearth to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Go to "..cl(27,77),
			"	a. Talk to Fleet Master Seahorn",
			"		i. Turn in "..cq("The Bloodsail Buccaneers part 5"),
			completion={{questturnedin="The Bloodsail Buccaneers part 5"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=76910410,
		}, {
			"Go to "..cl(28,77),
			"	a. Talk to Fin Fizracket",
			"		i. Turn in "..cq("Stranglethorn Fever"),
			completion={{questturnedin="Stranglethorn Fever"}},
			mapzone="Stranglethorn Vale",
			level=49,
			mapnote=76710430,
		}, {
			"Ride the boat to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=49,
		}, {
			"Fly to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="The Barrens",
			level=49,
		}, {
			"Go to "..cl(76,44),
			"	a. Talk to Talo Thornhoof",
			"		i. Accept "..cq("The Strength of Corruption"),
			completion={{questaccepted="The Strength of Corruption"}},
			mapzone="Feralas",
			level=49,
			mapnote=43812000,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Testing the Vessel"),
			"		ii. Accept "..cq("Hippogryph Muisek"),
			completion={{questturnedin="Testing the Vessel"},{questaccepted="Hippogryph Muisek"}},
			mapzone="Feralas",
			level=49,
			mapnote=43411780,
		}, {
			"Make Camp Taurajo your home",
			completion={{home="Camp Taurajo"}},
			mapzone="Feralas",
			level=49,
		}, {
			"Go southwest to "..cl(57,62),
			"	a. Kill hippogryphs",
			"	b. Use the Hippogryph Muisek Vessel on their corpses",
			"	c. Get 10 Hippogryph Muiseks",
			completion={{questgoal={"*","Hippogryph Muisek",10}}},
			mapzone="Feralas",
			level=49,
			mapnote=62011870,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=49,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Hippogryph Muisek"),
			"		ii. Accept "..cq("Faerie Dragon Muisek"),
			completion={{questturnedin="Hippogryph Muisek"},{questaccepted="Faerie Dragon Muisek"}},
			mapzone="Feralas",
			level=49,
			mapnote=43411780,
		}, {
			"Go southwest to "..cl(69,46),
			"	a. Kill Sprite Darters",
			"	b. Use the Faerie Dragon Muisek Vessel on their corpses",
			"	c. Get 8 Faerie Dragon Muiseks",
			completion={{questgoal={"*","Faerie Dragon Muisek",8}}},
			mapzone="Feralas",
			level=49,
			mapnote=46411580,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=49,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Faerie Dragon Muisek"),
			"		ii. Accept "..cq("Treant Muisek"),
			completion={{questturnedin="Faerie Dragon Muisek"},{questaccepted="Treant Muisek"}},
			mapzone="Feralas",
			level=49,
			mapnote=43411780,
		}, {
			"The next step is going to take a while, so just grind on hippogryphs while you do it",
			mapzone="Feralas",
			level=49,
		}, {
			"Go southwest to "..cl(54,63),
			"	a. Kill Wandering Forest Walkers",
			"	b. Use the Treant Muisek Vessel on their corpses",
			"	c. Get 3 Treant Muiseks",
			completion={{questgoal={"*","Treant Muisek",3}}},
			mapzone="Feralas",
			level=49,
			mapnote=67512180,
		}, {
			"Go northeast to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=49,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Treant Muisek"),
			"		ii. Accept "..cq("Mountain Giant Muisek"),
			completion={{questturnedin="Treant Muisek"},{questaccepted="Mountain Giant Muisek"}},
			mapzone="Feralas",
			level=49,
			mapnote=43411780,
		}, {
			"Go west to "..cl(45,43),
			"	a. Talk to Zorbin Fandazzle",
			"		i. Accept "..cq("Zapped Giants"),
			"		ii. Accept "..cq("Fuel for the Zapping"),
			completion={{questaccepted="Zapped Giants"},{questaccepted="Fuel for the Zapping"}},
			mapzone="Feralas",
			level=49,
			mapnote=43408820,
		}, {
			"Go south to "..cl(45,51),
			"	a. Kill water elementals",
			"	b. Get 10 Water Elemental Cores",
			"	c. Use Zorbin's Ultra-Shrinker on the giants",
			"	d. Kill the shrunken giants",
			"	e. Get 15 Miniaturization Residue",
			completion={{questgoal={"*","Water Elemental Core",10}},{questgoal={"*","Miniaturization Residue",15}}},
			mapzone="Feralas",
			level=49,
			mapnote=51409600,
		}, {
			"Go north to "..cl(45,43),
			"	a. Talk to Zorbin Fandazzle",
			"		i. Turn in "..cq("Zapped Giants"),
			"		ii. Turn in "..cq("Fuel for the Zapping"),
			"		iii. Accept "..cq("Again With the Zapped Giants"),
			completion={{questturnedin="Zapped Giants"},{questturnedin="Fuel for the Zapping"},{questaccepted="Again With the Zapped Giants"}},
			mapzone="Feralas",
			level=49,
			mapnote=43408820,
		}, {
			"Grind to level 50",
			completion={{level=50}},
			mapzone="Feralas",
			level=49,
		}
	  },
	},
	{ sectiontitle = "Levels (50-55)",
	  steps = {
		{
			"Go northeast to "..cl(51,32),
			"	a. Kill Rage Scar yetis",
			"	b. Get 10 Rage Scar Yeti Hides",
			"	c. Get a Perfect Yeti Hide",
			"	d. Click the Perfect Yeti Hide",
			"		i. Accept "..cq("Perfect Yeti Hide"),
			completion={{questgoal={"*","Rage Scar Yeti Hide",10}},{questaccepted="Perfect Yeti Hide"}},
			mapzone="Feralas",
			level=50,
			mapnote=31808460,
		}, {
			"Go northwest to "..cl(41,11),
			"	a. Kill 4 Northspring Harpies",
			"	b. Kill 4 Northspring Roguefeathers",
			"	c. Kill 4 Northspring Slayers",
			"	d. Kill 4 Northspring Windcallers",
			"	e. Kill harpies",
			"	f. Get the Horn of Hatetalon",
			completion={{questgoal={"*","Northspring Harpy slain",4}},{questgoal={"*","Northspring Roguefeather slain",4}},{questgoal={"*","Northspring Slayer slain",4}},{questgoal={"*","Northspring Windcaller slain",4}},{item={"Horn of Hatetalon",1}}},
			mapzone="Feralas",
			level=50,
			mapnote=11005200,
		}, {
			"Go northwest to "..cl(40,9),
			"	a. Use the Horn of Hatetalon to summon Edana Hatetalon",
			"	b. Get Edana's Dark Heart",
			completion={{questgoal={"*","Edana's Dark Heart",1}}},
			mapzone="Feralas",
			level=50,
			mapnote=8604890,
		}, {
			"Go south to "..cl(39,21),
			"	a. Use Zorbin's Ultra-Shrinker on the rock giants",
			"	b. Kill the rock giants",
			"	c. Use the Mountain Giant Muisek Vessel on their corpses",
			"	d. Get 7 Mountain Giant Muiseks",
			completion={{questgoal={"*","Mountain Giant Muisek",7}}},
			mapzone="Feralas",
			level=50,
			mapnote=21006000,
		}, {
			"Abandon the quest "..cq("Again With the Zapped Giants"),
			mapzone="Feralas",
			level=50,
		}, {
			"Hearth to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Feralas",
			level=50,
		}, {
			"Go to "..cl(74,43),
			"	a. Talk to Witch Doctor Uzer'i",
			"		i. Turn in "..cq("Mountain Giant Muisek"),
			"		ii. Accept "..cq("Weapons of Spirit"),
			"		iii. Turn in "..cq("Weapons of Spirit"),
			completion={{questturnedin="Mountain Giant Muisek"},{questaccepted="Weapons of Spirit"},{questturnedin="Weapons of Spirit"}},
			mapzone="Feralas",
			level=50,
			mapnote=43411780,
		}, {
			"Also at "..cl(74,43),
			"	a. Talk to Jangdor Swiftstrider",
			"		i. Turn in "..cq("Improved Quality"),
			"		ii. Turn in "..cq("Perfect Yeti Hide"),
			completion={{questturnedin="Improved Quality"},{questturnedin="Perfect Yeti Hide"}},
			mapzone="Feralas",
			level=50,
			mapnote=42911730,
		}, {
			"Go to "..cl(76,44),
			"	a. Talk to Talo Thornhoof",
			"		i. Turn in "..cq("Dark Heart"),
			"		ii. Turn in "..cq("Vengeance on the Northspring"),
			completion={{questturnedin="Dark Heart"},{questturnedin="Vengeance on the Northspring"}},
			mapzone="Feralas",
			level=50,
			mapnote=43812000,
		}, {
			"Fly to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Feralas",
			level=50,
		}, {
			"Go to "..cl(52,27),
			"	a. Talk to Tran'rek",
			"		i. Accept "..cq("Thistleshrub Valley"),
			"		ii. Accept "..cq("Super Sticky"),
			completion={{questaccepted="Thistleshrub Valley"},{questaccepted="Super Sticky"}},
			mapzone="Tanaris",
			level=50,
			mapnote=26807840,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Senior Surveyor Fizzledowser",
			"		i. Accept "..cq("Noxious Lair Investigation"),
			completion={{questaccepted="Noxious Lair Investigation"}},
			mapzone="Tanaris",
			level=50,
			mapnote=27507770,
		}, {
			"Go to "..cl(52,29),
			"	a. Talk to Marin Noggenfogger",
			"		i. Accept "..cq("The Thirsty Goblin"),
			completion={{questaccepted="The Thirsty Goblin"}},
			mapzone="Tanaris",
			level=50,
			mapnote=28608040,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Chief Engineer Bilgewhizzle",
			"		i. Turn in "..cq("Into the Field"),
			"		ii. Accept "..cq("Slake That Thirst"),
			"		iii. Turn in "..cq("Slake That Thirst"),
			"	b. Click the Model 4711-FTZ Power Source in your bags",
			"		i. Accept "..cq("Tanaris Field Sampling"),
			completion={{questturnedin="Into the Field"},{questturnedin="Slake That Thirst"},{questaccepted="Slake That Thirst"},{questaccepted="Tanaris Field Sampling"}},
			mapzone="Tanaris",
			level=50,
			mapnote=28508100,
		}, {
			"Go south to "..cl(50,34),
			"	a. Kill basilisks",
			"	b. Kill hyenas",
			"	c. Kill scorpids",
			"	d. Click their Untested Samples",
			"	e. Get 8 Acceptable Basilisk Samples",
			"	f. Get 8 Acceptable Hyena Samples",
			"	g. Get 8 Acceptable Scorpid Samples",
			completion={{questgoal={"*","Acceptable Basilisk Sample",8}},{questgoal={"*","Acceptable Hyena Sample",8}},{questgoal={"*","Acceptable Scorpid Sample",8}}},
			mapzone="Tanaris",
			level=50,
			mapnote=34008400,
		}, {
			"Go north to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=50,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Chief Engineer Bilgewhizzle",
			"		i. Turn in "..cq("Tanaris Field Sampling"),
			"		ii. Accept "..cq("Return to Apothecary Zinge"),
			completion={{questturnedin="Tanaris Field Sampling"},{questaccepted="Return to Apothecary Zinge"}},
			mapzone="Tanaris",
			level=50,
			mapnote=28508100,
		}, {
			"Make Gadgetzan your home",
			completion={{home="Gadgetzan"}},
			mapzone="Tanaris",
			level=50,
		}, {
			"Go to "..cl(53,27),
			"	a. Talk to Andi Lynn",
			"		i. Accept "..cq("The Dunemaul Compound"),
			completion={{questaccepted="The Dunemaul Compound"}},
			mapzone="Tanaris",
			level=50,
			mapnote=27408020,
		}, {
			"Go south to "..cl(53,46),
			"	a. Talk to Marvon Rivetseeker",
			"		i. Turn in "..cq("The Sunken Temple"),
			"		ii. Accept "..cq("The Stone Circle"),
			"		iii. Accept "..cq("Gahz'ridian"),
			completion={{questturnedin="The Sunken Temple"},{questaccepted="The Stone Circle"},{questaccepted="Gahz'ridian"}},
			mapzone="Tanaris",
			level=50,
			mapnote=45909860,
		}, {
			"Go southwest to "..cl(42,54),
			"	a. Kill 10 Dunemaul Brutes",
			"	b. Kill 10 Dunemaul Enforcers",
			completion={{questgoal={"*","Dunemaul Brute slain",10}},{questgoal={"*","Dunemaul Enforcer slain",10}}},
			mapzone="Tanaris",
			level=50,
			mapnote=54009600,
		}, {
			"Go south to "..cl(42,58),
			"	a. Kill Gor'marok the Ravager",
			completion={{questgoal={"*","Gor'marok the Ravager slain",1}}},
			mapzone="Tanaris",
			level=50,
			mapnote=57809930,
		}, {
			"Go south to "..cl(41,71),
			"	a. Click the Gahz'ridian",
			"	b. Get 30 Gahz'ridian Ornaments",
			completion={{questgoal={"*","Gahz'ridian Ornament",30}}},
			mapzone="Tanaris",
			level=50,
			mapnote=71011200,
		}, {
			"Go northwest to "..cl(31,51),
			"	a. Kill insects",
			"	b. Get 5 Centipaar Insect Parts",
			completion={{questgoal={"*","Centipaar Insect Parts",5}}},
			mapzone="Tanaris",
			level=50,
			mapnote=51008200,
		}, {
			"Go southwest to "..cl(29,63),
			"	a. Kill 8 Gnarled Thistleshrubs",
			"	b. Kill 8 Thistleshrub Rootshapers",
			"	c. Kill Thistleshrub Dew Collectors",
			"	d. Get a Laden Dew Gland",
			completion={{questgoal={"*","Gnarled Thistleshrub slain",8}},{questgoal={"*","Thistleshrub Rootshaper slain",8}},{questgoal={"*","Laden Dew Gland",1}}},
			mapzone="Tanaris",
			level=50,
			mapnote=63009200,
		}, {
			"Hearth to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=50,
		}, {
			"Go to "..cl(52,29),
			"	a. Talk to Marin Noggenfogger",
			"		i. Turn in "..cq("The Thirsty Goblin"),
			"		ii. Accept "..cq("In Good Taste"),
			completion={{questturnedin="The Thirsty Goblin"},{questaccepted="In Good Taste"}},
			mapzone="Tanaris",
			level=50,
			mapnote=28608040,
		}, {
			"Go to "..cl(51,27),
			"	a. Talk to Sprinkle",
			"		i. Turn in "..cq("In Good Taste"),
			"		ii. Accept "..cq("Sprinkle's Secret Ingredient"),
			completion={{questturnedin="In Good Taste"},{questaccepted="Sprinkle's Secret Ingredient"}},
			mapzone="Tanaris",
			level=50,
			mapnote=26907800,
		}, {
			"Also at "..cl(51,27),
			"	a. Talk to Alchemist Pestlezugg",
			"		i. Turn in "..cq("Noxious Lair Investigation"),
			completion={{questturnedin="Noxious Lair Investigation"}},
			mapzone="Tanaris",
			level=50,
			mapnote=27007790,
		}, {
			"Go to "..cl(52,27),
			"	a. Talk to Tran'rek",
			"		i. Turn in "..cq("Thistleshrub Valley"),
			completion={{questturnedin="Thistleshrub Valley"}},
			mapzone="Tanaris",
			level=50,
			mapnote=26807840,
		}, {
			"Go to "..cl(53,27),
			"	a. Talk to Andi Lynn",
			"		i. Turn in "..cq("The Dunemaul Compound"),
			completion={{questturnedin="The Dunemaul Compound"}},
			mapzone="Tanaris",
			level=50,
			mapnote=27408020,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Senior Surveyor Fizzledowser",
			"		i. Accept "..cq("The Scrimshank Redemption"),
			completion={{questaccepted="The Scrimshank Redemption"}},
			mapzone="Tanaris",
			level=50,
			mapnote=27507770,
		}, {
			"Grind to level 51",
			completion={{level=51}},
			mapzone="Tanaris",
			level=50,
		}, {
			"Go south to "..cl(53,46),
			"	a. Talk to Marvon Rivetseeker",
			"		i. Turn in "..cq("Gahz'ridian"),
			completion={{questturnedin="Gahz'ridian"}},
			mapzone="Tanaris",
			level=51,
			mapnote=45909860,
		}, {
			"Go southeast to "..cl(55,70),
			"	a. The path down to 'The Scrimshank Redemption' starts here",
			completion={{location={mapzone="Tanaris",x=55.9,y=70.2, dist=1}}},
			mapzone="Tanaris",
			level=51,
			mapnote=69712430,
		}, {
			"Go north to "..cl(56,69),
			"	a. Enter this tunnel heading north",
			"	b. Take a right at the fork in the path into a big round room",
			"	c. Enter the tunnel on the other side of the room",
			"	d. Take a right at the fork into a smaller round room",
			completion={{location={mapzone="Tanaris",x=55.8,y=68.9, dist=0.5}}},
			mapzone="Tanaris",
			level=51,
			mapnote=68812440,
		}, {
			"Go south to "..cl(56,71),
			"	a. Click Scrimshank's Surveying Gear",
			"	b. Get Scrimshank's Surveying Gear",
			completion={{questgoal={"*","Scrimshank's Surveying Gear",1}}},
			mapzone="Tanaris",
			level=51,
			mapnote=71212720,
		}, {
			"Go northeast to Steamwheedle Port",
			completion={{location={mapzone="Tanaris",x=66.7,y=23.1, dist=2}}},
			mapzone="Tanaris",
			level=51,
		}, {
			"Go to "..cl(67,24),
			"	a. Talk to Yorba Screwspigot",
			"		i. Accept "..cq("Yuka Screwspigot"),
			completion={{questaccepted="Yuka Screwspigot"}},
			mapzone="Tanaris",
			level=51,
			mapnote=23909100,
		}, {
			"Go to "..cl(67,22),
			"	a. Talk to Yeh'kinya",
			"		i. Turn in "..cq("Screecher Spirits"),
			completion={{questturnedin="Screecher Spirits"}},
			mapzone="Tanaris",
			level=51,
			mapnote=22408940,
		}, {
			"Go west to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=51,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Senior Surveyor Fizzledowser",
			"		i. Turn in "..cq("The Scrimshank Redemption"),
			"		ii. Accept "..cq("Insect Part Analysis part 1"),
			completion={{questturnedin="The Scrimshank Redemption"},{questaccepted="Insect Part Analysis part 1"}},
			mapzone="Tanaris",
			level=51,
			mapnote=27507770,
		}, {
			"Go to "..cl(51,27),
			"	a. Talk to Alchemist Pestlezugg",
			"		i. Turn in "..cq("Insect Part Analysis part 1"),
			"		ii. Accept "..cq("Insect Part Analysis part 2"),
			completion={{questturnedin="Insect Part Analysis part 1"},{questaccepted="Insect Part Analysis part 2"}},
			mapzone="Tanaris",
			level=51,
			mapnote=27007790,
		}, {
			"Go to "..cl(50,27),
			"	a. Talk to Senior Surveyor Fizzledowser",
			"		i. Turn in "..cq("Insect Part Analysis part 2"),
			"		ii. Accept "..cq("Rise of the Silithid"),
			completion={{questturnedin="Insect Part Analysis part 2"},{questaccepted="Rise of the Silithid"}},
			mapzone="Tanaris",
			level=51,
			mapnote=27507770,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Tanaris",
			level=51,
		}, {
			"Go to "..cl(62,39),
			"	a. Click Marvon's Chest",
			"	b. Get the Stone Circle",
			"	c. Talk to Live Rizzlefix",
			"		i. Accept "..cq("Volcanic Activity"),
			completion={{questgoal={"*","Stone Circle",1}},{questaccepted="Volcanic Activity"}},
			mapzone="The Barrens",
			level=51,
			mapnote=38510100,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=51,
		}, {
			"Buy 15 silk cloth from the Auction House",
			completion={{item={"Silk Cloth",15}}},
			mapzone="Stranglethorn Vale",
			level=51,
		}, {
			"Fly to Kargath",
			completion={{location={mapzone="Badlands",x=4.7,y=46.6, dist=4}}},
			mapzone="Stranglethorn Vale",
			level=51,
		}, {
			"Go south to "..cl(5,61),
			"	a. The path over to Searing Gorge starts here",
			completion={{location={mapzone="Badlands",x=4.9,y=61.2, dist=0.3}}},
			mapzone="Badlands",
			level=51,
			mapnote=61306580,
		}, {
			"Go west to Searing Gorge",
			completion={{location={mapzone="Searing Gorge"}}},
			mapzone="Badlands",
			level=51,
		}, {
			"Go northwest to Thorium Point",
			completion={{location={mapzone="Searing Gorge",x=35.9,y=27.7, dist=3}}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"Go to "..cl(38,27),
			"	a. Click the Wanted/Missing/Lost & Found Poster",
			"		i. Accept "..cq("JOB OPPORTUNITY: Culling the Competition"),
			"		ii. Accept "..cq("STOLEN: Smithing Tuyere and Lookout's Spyglass"),
			"		iii. Accept "..cq("WANTED: Overseer Maltorius"),
			completion={{questaccepted="JOB OPPORTUNITY: Culling the Competition"},{questaccepted="STOLEN: Smithing Tuyere and Lookout's Spyglass"},{questaccepted="WANTED: Overseer Maltorius"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=26506410,
		}, {
			"Go to "..cl(39,28),
			"	a. Talk to Hansel Heavyhands",
			"		i. Accept "..cq("Curse These Fat Fingers"),
			"		ii. Accept "..cq("Fiery Menace!"),
			"		iii. Accept "..cq("Incendosaurs? Whateverosaur is More Like It"),
			completion={{questaccepted="Curse These Fat Fingers"},{questaccepted="Fiery Menace!"},{questaccepted="Incendosaurs? Whateverosaur is More Like It"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=27806640,
		}, {
			"Go to "..cl(39,29),
			"	a. Talk to Master Smith Burninate",
			"		i. Accept "..cq("What the Flux?"),
			completion={{questaccepted="What the Flux?"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=28506730,
		}, {
			"Go to "..cl(35,31),
			"	a. Talk to Grisha",
			"		i. Get the Thorium Point Flight Path",
			completion={{flightpath="Thorium Point"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=30906570,
		}, {
			"Go southeast to "..cl(39,39),
			"	a. Talk to Kalaran Windblade",
			"		i. Accept "..cq("Divine Retribution"),
			"		ii. Listen to his story",
			"		iii. Turn in "..cq("Divine Retribution"),
			"		iv. Accept "..cq("The Flawless Flame"),
			completion={{questturnedin="Divine Retribution"},{questaccepted="Divine Retribution"},{questaccepted="The Flawless Flame"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=39007810,
		}, {
			"Go south to "..cl(37,49),
			"	a. Kill Dark Iron Steamsmiths",
			"	b. Get the Smithing Tuyere",
			"	c. Kill Dark Iron dwarves",
			"	d. Get the Grimesilt Outhouse Key",
			"	e. Click the Grimesilt Outhouse Key",
			"		i. Accept "..cq("The Key to Freedom"),
			completion={{questgoal={"*","Smithing Tuyere",1}},{questaccepted="The Key to Freedom"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=49008600,
		}, {
			"Go west to "..cl(33,49),
			"	a. Kill 20 Heavy War Golems",
			completion={{questgoal={"*","Heavy War Golem slain",20}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=49008200,
		}, {
			"Go southeast to "..cl(33,52),
			"	a. Kill Dark Iron Lookouts",
			"	b. Get the Lookout's Spyglass",
			completion={{questgoal={"*","Lookout's Spyglass",1}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=52008500,
		}, {
			"Go south to "..cl(32,62),
			"	a. Kill 20 Greater Lava Spiders",
			completion={{questgoal={"*","Greater Lava Spider slain",20}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=62009400,
		}, {
			"Go south to "..cl(31,75),
			"	a. Kill Magma Elementals",
			"	b. Get 4 Golem Oils",
			"	c. Kill Inferno Elementals",
			"	d. Get 4 Hearts of Flame",
			completion={{questgoal={"*","Golem Oil",4}},{questgoal={"*","Heart of Flame",4}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=75010600,
		}, {
			"Go northeast to "..cl(66,62),
			"	a. Click the Wooden Outhouse",
			"		i. Turn in "..cq("The Key to Freedom"),
			"		ii. Accept "..cq("Caught!"),
			completion={{questturnedin="The Key to Freedom"},{questaccepted="Caught!"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=62312790,
		}, {
			"Go northwest to "..cl(63,60),
			"	a. Kill 8 Dark Iron Geologists",
			completion={{questgoal={"*","Dark Iron Geologist slain",8}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=60012300,
		}, {
			"Go southeast to "..cl(66,62),
			"	a. Click the Wooden Outhouse",
			"		i. Turn in "..cq("Caught!"),
			"		ii. Accept "..cq("Ledger from Tanaris"),
			"	b. Click the book he slides under the door",
			"	c. Get the Goodsteel Ledger",
			completion={{questturnedin="Caught!"},{questaccepted="Ledger from Tanaris"},{questgoal={"*","Goodsteel Ledger",1}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=62312790,
		}, {
			"Go southwest to "..cl(62,72),
			"	a. Kill Glassweb Spiders",
			"	b. Get 20 Solid Crystal Leg Shafts",
			completion={{questgoal={"*","Solid Crystal Leg Shaft",20}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=72013400,
		}, {
			"Go northwest to "..cl(39,39),
			"	a. Talk to Kalaran Windblade",
			"		i. Turn in "..cq("The Flawless Flame"),
			"		ii. Accept "..cq("Forging the Shaft"),
			completion={{questturnedin="The Flawless Flame"},{questaccepted="Forging the Shaft"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=39007810,
		}, {
			"Go southeast to "..cl(42,47),
			"	a. Kill Dark Iron Steamsmiths",
			"	b. Get 8 Thorium Plated Daggers",
			completion={{questgoal={"*","Thorium Plated Dagger",8}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=47008900,
		}, {
			"Go northwest to "..cl(39,39),
			"	a. Talk to Kalaran Windblade",
			"		i. Turn in "..cq("Forging the Shaft"),
			"		ii. Accept "..cq("The Flame's Casing"),
			completion={{questturnedin="Forging the Shaft"},{questaccepted="The Flame's Casing"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=39007810,
		}, {
			"Go southeast to "..cl(41,54),
			"	a. The entrance to the Slag Pit starts here",
			"		i. It's up on the metal riser walkway things",
			completion={{location={mapzone="Searing Gorge",x=41.5,y=54.7, dist=0.5}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=53909530,
		}, {
			"Follow the path",
			"	a. Go through the Jail Door",
			completion={{location={mapzone="Searing Gorge",x=37.6,y=44.3, dist=0.5}}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"While in the Slag Pit:",
			"	a. Kill 15 Dark Iron Taskmasters",
			"	b. Kill 15 Dark Iron Slavers",
			completion={{questgoal={"*","Dark Iron Taskmaster slain",15}},{questgoal={"*","Dark Iron Slaver slain",15}}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"Go up the big metal ramp into the big room",
			completion={{location={mapzone="Searing Gorge",x=42.9,y=33.2, dist=0.5}}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"Go southwest to "..cl(41,36),
			"	a. Kill Overseer Maltorius",
			"	b. Get the Head of Overseer Maltorius",
			completion={{questgoal={"*","Head of Overseer Maltorius",1}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=35807670,
		}, {
			"Also at "..cl(41,36),
			"	a. Click the Secret Plans: Fiery Flux",
			"		i. It's behind Overseer Maltorius",
			"	b. Get the Secret Plans: Fiery Flux",
			completion={{questgoal={"*","Secret Plans: Fiery Flux",1}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=35707620,
		}, {
			"Go southeast to "..cl(48,42),
			"	a. Jump off the bridge to the path below",
			completion={{location={mapzone="Searing Gorge",x=47.6,y=41.9, dist=0.3}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=42109000,
		}, {
			"Go northeast to "..cl(52,37),
			"	a. Kill 20 Incendosaurs",
			completion={{questgoal={"*","Incendosaur slain",20}}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=37008900,
		}, {
			"Go to Thorium Point",
			completion={{location={mapzone="Searing Gorge",x=35.9,y=27.7, dist=3}}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"Go to "..cl(38,27),
			"	a. Talk to Lookout Captain Lolo Longstriker",
			"		i. Turn in "..cq("WANTED: Overseer Maltorius"),
			completion={{questturnedin="WANTED: Overseer Maltorius"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=26506410,
		}, {
			"Go to "..cl(39,28),
			"	a. Talk to Hansel Heavyhands",
			"		i. Turn in "..cq("Curse These Fat Fingers"),
			"		ii. Turn in "..cq("Fiery Menace!"),
			"		iii. Turn in "..cq("Incendosaurs? Whateverosaur is More Like It"),
			completion={{questturnedin="Curse These Fat Fingers"},{questturnedin="Fiery Menace!"},{questturnedin="Incendosaurs? Whateverosaur is More Like It"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=27806640,
		}, {
			"Also at "..cl(39,28),
			"	a. Talk to Taskmaster Scrange",
			"		i. Turn in "..cq("STOLEN: Smithing Tuyere and Lookout's Spyglass"),
			"		ii. Turn in "..cq("JOB OPPORTUNITY: Culling the Competition"),
			completion={{questturnedin="STOLEN: Smithing Tuyere and Lookout's Spyglass"},{questturnedin="JOB OPPORTUNITY: Culling the Competition"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=27506650,
		}, {
			"Go to "..cl(39,39),
			"	a. Talk to Master Smith Burninate",
			"		i. Turn in "..cq("What the Flux?"),
			completion={{questturnedin="What the Flux?"}},
			mapzone="Searing Gorge",
			level=51,
			mapnote=28506730,
		}, {
			"Grind to level 52",
			completion={{level=52}},
			mapzone="Searing Gorge",
			level=51,
		}, {
			"Go southwest to "..cl(26,34),
			"	a. Kill Twilight mobs",
			"	b. Get the Symbol of Ragnaros",
			completion={{questgoal={"*","Symbol of Ragnaros",1}}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=34006000,
		}, {
			"Go east to "..cl(39,39),
			"	a. Talk to Kalaran Windblade",
			"		i. Turn in "..cq("The Flame's Casing"),
			"		ii. Accept "..cq("The Torch of Retribution part 1"),
			"		iii. Turn in "..cq("The Torch of Retribution part 1"),
			"		iv. Accept "..cq("The Torch of Retribution part 2"),
			"	b. Click the green glowing Torch of Retribution",
			"		i. Turn in "..cq("The Torch of Retribution part 2"),
			"		ii. Accept "..cq("Squire Maltrake"),
			"	c. Talk to Squire Maltrake",
			"		i. Turn in "..cq("Squire Maltrake"),
			"		ii. Accept "..cq("Set Them Ablaze!"),
			completion={{questturnedin="The Flame's Casing"},{questturnedin="The Torch of Retribution part 1"},{questturnedin="The Torch of Retribution part 2"},{questturnedin="Squire Maltrake"},{questaccepted="The Torch of Retribution part 1"},{questaccepted="The Torch of Retribution part 2"},{questaccepted="Squire Maltrake"},{questaccepted="Set Them Ablaze!"}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=39007810,
		}, {
			"Go southwest to "..cl(33,54),
			"	a. Click the Sentry Brazier",
			"	b. Set the Northern Tower Ablaze",
			completion={{questgoal={"*","Northern Tower Ablaze",1}}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=54508780,
		}, {
			"Go southeast to "..cl(36,61),
			"	a. Click the Sentry Brazier",
			"	b. Set the Western Tower Ablaze",
			completion={{questgoal={"*","Western Tower Ablaze",1}}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=60709640,
		}, {
			"Go east to "..cl(44,61),
			"	a. Click the Sentry Brazier",
			"	b. Set the Southern Tower Ablaze",
			completion={{questgoal={"*","Southern Tower Ablaze",1}}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=60910490,
		}, {
			"Go northeast to "..cl(50,55),
			"	a. Click the Sentry Brazier",
			"	b. Set the Eastern Tower Ablaze",
			completion={{questgoal={"*","Eastern Tower Ablaze",1}}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=54710480,
		}, {
			"Go northwest to "..cl(39,39),
			"	a. Talk to Squire Maltrake",
			"		i. Turn in "..cq("Set Them Ablaze!"),
			"	b. Click the small grey chest on the ground",
			"		i. Accept "..cq("Trinkets..."),
			"	c. Click the chest again",
			"		i. Turn in "..cq("Trinkets..."),
			"	d. Make sure to save the Black Dragonflight Molt",
			completion={{questturnedin="Set Them Ablaze!"},{questaccepted="Trinkets..."},{questturnedin="Trinkets..."}},
			mapzone="Searing Gorge",
			level=52,
			mapnote=39007810,
		}, {
			"Go south to Blackrock Mountain",
			completion={{location={mapzone="Searing Gorge",x=34.5,y=83.6, dist=1}}},
			mapzone="Searing Gorge",
			level=52,
		}, {
			"Run through Blackrock Mountain over to the Burning Steppes",
			completion={{location={mapzone="Burning Steppes"}}},
			mapzone="Searing Gorge",
			level=52,
		}, {
			"Go northeast to "..cl(66,24),
			"	a. Talk to Vahgruk",
			"		i. Get the Flame Crest Flight Path",
			completion={{flightpath="Flame Crest"}},
			mapzone="Burning Steppes",
			level=52,
			mapnote=24208990,
		}, {
			"Fly to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Burning Steppes",
			level=52,
		}, {
			"Make Stonard your home",
			completion={{home="Stonard"}},
			mapzone="Swamp of Sorrows",
			level=52,
		}, {
			"Go southwest to "..cl(34,66),
			"	a. Talk to the Fallen Hero of the Horde",
			"		i. Accept "..cq("Fall From Grace"),
			"		ii. Listen to his story",
			"		iii. Turn in "..cq("Fall From Grace"),
			"		iv. Accept "..cq("The Disgraced One"),
			completion={{questaccepted="Fall From Grace"},{questturnedin="Fall From Grace"},{questaccepted="The Disgraced One"}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=66110040,
		}, {
			"Go northwest to "..cl(23,48),
			"	a. Click the Soggy Scroll",
			"		i. Turn in "..cq("Cortello's Riddle part 1"),
			"		ii. Accept "..cq("Cortello's Riddle part 2"),
			completion={{questturnedin="Cortello's Riddle part 1"},{questaccepted="Cortello's Riddle part 2"}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=48207110,
		}, {
			"Hearth to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=52,
		}, {
			"Go to "..cl(48,55),
			"	a. Talk to Dispatch Commander Ruag",
			"		i. Turn in "..cq("The Disgraced One"),
			"		ii. Accept "..cq("The Missing Orders"),
			completion={{questturnedin="The Disgraced One"},{questaccepted="The Missing Orders"}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=55010290,
		}, {
			"Go to "..cl(45,57),
			"	a. Talk to Bengor",
			"		i. Turn in "..cq("The Missing Orders"),
			"		ii. Accept "..cq("The Swamp Talker"),
			completion={{questturnedin="The Missing Orders"},{questaccepted="The Swamp Talker"}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=57410240,
		}, {
			"Go southeast to "..cl(66,76),
			"	a. The path to 'The Swamp Talker' starts here",
			completion={{location={mapzone="Swamp of Sorrows",x=66.2,y=77.0, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=76214260,
		}, {
			"Go southwest to "..cl(63,88),
			"	a. Follow the path inside the cave to this spot",
			"	b. Kill Swamp Talker",
			"	c. Get the Warchief's Orders",
			completion={{questgoal={"*","Warchief's Orders",1}}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=88315110,
		}, {
			"Go northeast to "..cl(92,68),
			"	a. He spawns at different spots all along this beach",
			"	b. He is a grey Murloc",
			"	c. Kill Jarquia",
			"	d. Get Goodsteel's Balanced Flameberge",
			completion={{questgoal={"*","Goodsteel's Balanced Flameberge",1}}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=67615920,
		}, {
			"Go west to "..cl(34,66),
			"	a. Talk to the Fallen Hero of the Horde",
			"		i. Turn in "..cq("The Swamp Talker"),
			"		ii. Accept "..cq("A Tale of Sorrow"),
			"		iii. Listen to his story",
			"		iv. Turn in "..cq("A Tale of Sorrow"),
			completion={{questturnedin="The Swamp Talker"},{questaccepted="A Tale of Sorrow"},{questturnedin="A Tale of Sorrow"}},
			mapzone="Swamp of Sorrows",
			level=52,
			mapnote=66110040,
		}, {
			"Go northeast to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=52,
		}, {
			"Fly to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=52,
		}, {
			"Ride the boat to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=52,
		}, {
			"Fly to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="The Barrens",
			level=52,
		}, {
			"Go northwest to "..cl(31,66),
			"	a. Click the Musty Scroll",
			"		i. Turn in "..cq("Cortello's Riddle part 2"),
			"		ii. Accept "..cq("Cortello's Riddle part 3"),
			completion={{questturnedin="Cortello's Riddle part 2"},{questaccepted="Cortello's Riddle part 3"}},
			mapzone="Dustwallow Marsh",
			level=52,
			mapnote=66109720,
		}, {
			"Go northeast to "..cl(54,56),
			"	a. Click the Damaged Crate",
			"	b. Get the Overdue Package",
			completion={{questgoal={"*","Overdue Package",1}}},
			mapzone="Dustwallow Marsh",
			level=52,
			mapnote=55911000,
		}, {
			"Go southwest to Mudsprocket",
			completion={{location={mapzone="Dustwallow Marsh",x=42.0,y=73.3, dist=2}}},
			mapzone="Dustwallow Marsh",
			level=52,
		}, {
			"Fly to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Dustwallow Marsh",
			level=52,
		}, {
			"Go to "..cl(51,29),
			"	a. Talk to Krinkle Goodsteel",
			"		i. Turn in "..cq("Ledger from Tanaris"),
			completion={{questturnedin="Ledger from Tanaris"}},
			mapzone="Tanaris",
			level=52,
			mapnote=28808030,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Tanaris",
			level=52,
		}, {
			"Make Orgrimmar your home",
			completion={{home="Orgrimmar"}},
			mapzone="Orgrimmar",
			level=52,
		}, {
			"Go to "..cl(59,37),
			"	a. Talk to Dran Droffers",
			"		i. Turn in "..cq("Ripple Delivery"),
			completion={{questturnedin="Ripple Delivery"}},
			mapzone="Orgrimmar",
			level=52,
			mapnote=36809630,
		}, {
			"Fly to Valormok",
			completion={{location={mapzone="Azshara",x=22.0,y=50.9, dist=2}}},
			mapzone="Orgrimmar",
			level=52,
		}, {
			"Go to "..cl(23,51),
			"	a. Talk to Jediga",
			"		i. Accept "..cq("Stealing Knowledge"),
			completion={{questaccepted="Stealing Knowledge"}},
			mapzone="Azshara",
			level=52,
			mapnote=51407400,
		}, {
			"Go to "..cl(22,51),
			"	a. Talk to Ag'tor Bloodfist",
			"		i. Accept "..cq("Betrayed part 2"),
			completion={{questaccepted="Betrayed part 2"}},
			mapzone="Azshara",
			level=52,
			mapnote=51507380,
		}, {
			"Go southeast to "..cl(35,54),
			"	a. They spawn in different spots around this area",
			"	b. The Tablet of Sael'hai is a big stone slab with a yellow symbol on it",
			"	c. The Tablet of Markri is a small stone slab with a green symbol on it",
			"	d. The Tablet of Beth'Amara is a small stone slab with a pink symbol on it",
			"	e. The Tablet of Jin'yael is a small stone slab with a blue symbol on it",
			"	f. Click the 4 tablets",
			"	g. Get the Tablet of Sael'hai",
			"	h. Get the Tablet of Markri",
			"	i. Get the Tablet of Beth'Amara",
			"	j. Get the Tablet of Jin'yael",
			completion={{questgoal={"*","Tablet of Sael'hai",1}},{questgoal={"*","Tablet of Markri",1}},{questgoal={"*","Tablet of Beth'Amara",1}},{questgoal={"*","Tablet of Jin'yael",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=54108890,
		}, {
			"Go southeast to "..cl(48,61),
			"	a. Use the Vial Labeled #1 while standing in the small pool of water here",
			"	b. Fill the Vial Labeled #1",
			completion={{questgoal={"*","Filled Vial Labeled #1",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=61110870,
		}, {
			"Go north to "..cl(48,52),
			"	a. Use the Vial Labeled #2 while standing in the small pool of water here",
			"	b. Fill the Vial Labeled #2",
			completion={{questgoal={"*","Filled Vial Labeled #2",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=51609950,
		}, {
			"Go northeast to "..cl(49,49),
			"	a. Use the Vial Labeled #3 while standing in the small pool of water here",
			"	b. Fill the Vial Labeled #3",
			completion={{questgoal={"*","Filled Vial Labeled #3",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=48609720,
		}, {
			"Go northwest to "..cl(47,47),
			"	a. Use the Vial Labeled #4 while standing in the small pool of water here",
			"	b. Fill the Vial Labeled #4",
			completion={{questgoal={"*","Filled Vial Labeled #4",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=46509390,
		}, {
			"Go west to "..cl(43,47),
			"	a. The path back up to the Ruins of Eldarath starts here",
			completion={{location={mapzone="Azshara",x=43.4,y=47.4, dist=0.5}}},
			mapzone="Azshara",
			level=52,
			mapnote=47509080,
		}, {
			"Go west to "..cl(23,51),
			"	a. Talk to Jediga",
			"		i. Turn in "..cq("Stealing Knowledge"),
			"		ii. Accept "..cq("Delivery to Magatha"),
			"		iii. Accept "..cq("Delivery to Jes'rimon"),
			"		iv. Accept "..cq("Delivery to Andron Gant"),
			"		v. Accept "..cq("Delivery to Archmage Xylem"),
			completion={{questturnedin="Stealing Knowledge"},{questaccepted="Delivery to Magatha"},{questaccepted="Delivery to Jes'rimon"},{questaccepted="Delivery to Andron Gant"},{questaccepted="Delivery to Archmage Xylem"}},
			mapzone="Azshara",
			level=52,
			mapnote=51407400,
		}, {
			"Go east to "..cl(28,50),
			"	a. Talk to Sanath Lim-yo",
			"		i. Turn in "..cq("Meeting with the Master"),
			"		ii. He will teleport you up into the mountains",
			completion={{location={mapzone="Azshara",x=26.3,y=46.2, dist=0.5}}},
			mapzone="Azshara",
			level=52,
			mapnote=50107820,
		}, {
			"Follow the path up the mountain into the tower at the top",
			completion={{location={mapzone="Azshara",x=29.0,y=41.0, dist=0.5}}},
			mapzone="Azshara",
			level=52,
		}, {
			"Go to "..cl(29,40),
			"	a. Talk to Archmage Xylem",
			"		i. Turn in "..cq("Delivery to Archmage Xylem"),
			"		ii. Accept "..cq("Xylem's Payment to Jediga"),
			completion={{questturnedin="Delivery to Archmage Xylem"},{questaccepted="Xylem's Payment to Jediga"}},
			mapzone="Azshara",
			level=52,
			mapnote=40406980,
		}, {
			"Go back down the path",
			completion={{location={mapzone="Azshara",x=26.9,y=42.8, dist=1}}},
			mapzone="Azshara",
			level=52,
		}, {
			"Go to "..cl(26,46),
			"	a. Talk to Nyrill",
			"		i. Accept "..cq("Return Trip"),
			"		ii. Turn in "..cq("Return Trip"),
			"		iii. He will teleport you back down out of the mountains",
			completion={{questaccepted="Return Trip"},{questturnedin="Return Trip"}},
			mapzone="Azshara",
			level=52,
			mapnote=46307280,
		}, {
			"Go west to "..cl(23,51),
			"	a. Talk to Jediga",
			"		i. Turn in "..cq("Xylem's Payment to Jediga"),
			completion={{questturnedin="Xylem's Payment to Jediga"}},
			mapzone="Azshara",
			level=52,
			mapnote=51407400,
		}, {
			"Go northeast to "..cl(54,19),
			"	a. The path up to Kim'jael starts here",
			completion={{location={mapzone="Azshara",x=53.8,y=19.0, dist=0.5}}},
			mapzone="Azshara",
			level=52,
			mapnote=18907280,
		}, {
			"Go south to "..cl(53,22),
			"	a. Talk to Kim'jael",
			"		i. Accept "..cq("Kim'jael Indeed!"),
			completion={{questaccepted="Kim'jael Indeed!"}},
			mapzone="Azshara",
			level=52,
			mapnote=21807530,
		}, {
			"Go southeast to "..cl(56,25),
			"	a. Kill 10 Blood Elf Reclaimers",
			"	b. Kill 10 Blood Elf Surveyors",
			completion={{questgoal={"*","Blood Elf Reclaimer slain",10}},{questgoal={"*","Blood Elf Surveyor slain",10}}},
			mapzone="Azshara",
			level=52,
			mapnote=25008100,
		}, {
			"Go east to "..cl(59,25),
			"	a. Click Kim'jael's Equipment box #1",
			mapzone="Azshara",
			level=52,
			mapnote=25008350,
		}, {
			"Go south to "..cl(58,29),
			"	a. Click Kim'jael's Equipment box #2",
			"	b. Click Kim'jael's Equipment box #3",
			mapzone="Azshara",
			level=52,
			mapnote=29008770,
		}, {
			"Keep clicking Kim'jael's Equipment boxes until you have found:",
			"	a. Kim'jael's Compass",
			"	b. Kim'jael's Scope",
			"	c. Kim'jael's Stuffed Chicken",
			"	d. Kim'jael's Wizzlegoober",
			completion={{questgoal={"*","Kim'Jael's Compass",1}},{questgoal={"*","Kim'Jael's Scope",1}},{questgoal={"*","Kim'Jael's Stuffed Chicken",1}},{questgoal={"*","Kim'Jael's Wizzlegoober",1}}},
			mapzone="Azshara",
			level=52,
		}, {
			"Go southeast to "..cl(60,31),
			"	a. Find Magus Rimtori's Camp",
			completion={{questgoal={"*","Find Magus Rimtori's camp",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=31309080,
		}, {
			"Also at "..cl(60,31),
			"	a. Click the Kaldorei Tome of Summoning",
			"		i. Turn in "..cq("Betrayed part 2"),
			"		ii. Accept "..cq("Betrayed part 3"),
			completion={{questturnedin="Betrayed part 2"},{questaccepted="Betrayed part 3"}},
			mapzone="Azshara",
			level=52,
			mapnote=31309080,
		}, {
			"Also at "..cl(60,31),
			"	a. Click the Arcane Focusing Crystals",
			"	b. Kill the Blood Elf Defender when it spawns",
			"	c. After the Blood Elf Defender dies, Magus Rimtori will spawn",
			"	d. Kill Magus Rimtori",
			"	e. Get the Head of Magus Rimtori",
			completion={{questgoal={"*","Head of Magus Rimtori",1}}},
			mapzone="Azshara",
			level=52,
			mapnote=31609110,
		}, {
			"Go northwest to "..cl(53,22),
			"	a. Talk to Kim'jael",
			"		i. Turn in "..cq("Kim'jael Indeed!"),
			completion={{questturnedin="Kim'jael Indeed!"}},
			mapzone="Azshara",
			level=52,
			mapnote=21807530,
		}, {
			"Go southwest to "..cl(22,51),
			"	a. Talk to Ag'tor Bloodfist",
			"		i. Turn in "..cq("Betrayed part 3"),
			"		ii. Accept "..cq("Betrayed part 4"),
			completion={{questturnedin="Betrayed part 3"},{questaccepted="Betrayed part 4"}},
			mapzone="Azshara",
			level=52,
			mapnote=51507380,
		}, {
			"Grind to level 53",
			completion={{level=53}},
			mapzone="Azshara",
			level=52,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Azshara",
			level=53,
		}, {
			"Go to "..cl(70,31),
			"	a. Talk to Magatha Grimtotem",
			"		i. Turn in "..cq("Delivery to Magatha"),
			"		ii. Accept "..cq("Magatha's Payment to Jediga"),
			completion={{questturnedin="Delivery to Magatha"},{questaccepted="Magatha's Payment to Jediga"}},
			mapzone="Thunder Bluff",
			level=53,
			mapnote=30910080,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Thunder Bluff",
			level=53,
		}, {
			"Go to "..cl(56,47),
			"	a. Talk to Zilzibin Drumlore",
			"		i. Turn in "..cq("Rise of the Silithid"),
			"		ii. Accept "..cq("March of the Silithid"),
			completion={{questturnedin="Rise of the Silithid"},{questaccepted="March of the Silithid"}},
			mapzone="Orgrimmar",
			level=53,
			mapnote=46710290,
		}, {
			"Go to "..cl(56,34),
			"	a. Talk to Jes'rimon",
			"		i. Turn in "..cq("Delivery to Jes'rimon"),
			"		ii. Accept "..cq("Jes'rimon's Payment to Jediga"),
			"		iii. Accept "..cq("Bone-Bladed Weapons"),
			completion={{questturnedin="Delivery to Jes'rimon"},{questaccepted="Jes'rimon's Payment to Jediga"},{questaccepted="Bone-Bladed Weapons"}},
			mapzone="Orgrimmar",
			level=53,
			mapnote=34108970,
		}, {
			"Go to "..cl(75,34),
			"	a. Talk to Belgrom Rockmaul",
			"		i. Turn in "..cq("Betrayed part 4"),
			completion={{questturnedin="Betrayed part 4"}},
			mapzone="Orgrimmar",
			level=53,
			mapnote=34210940,
		}, {
			"Go outside of Orgrimmar",
			completion={{location={mapzone="Durotar"}}},
			mapzone="Orgrimmar",
			level=53,
		}, {
			"Ride the zeppelin to Undercity",
			completion={{location={mapzone="Tirisfal Glades",x=60.7,y=58.8, dist=2}}},
			mapzone="Durotar",
			level=53,
		}, {
			"Go south to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Tirisfal Glades",
			level=53,
		}, {
			"Go to "..cl(55,76),
			"	a. Talk to Andron Gant",
			"		i. Turn in "..cq("Delivery to Andron Gant"),
			"		ii. Accept "..cq("Andron's Payment to Jediga"),
			completion={{questturnedin="Delivery to Andron Gant"},{questaccepted="Andron's Payment to Jediga"}},
			mapzone="Undercity",
			level=53,
			mapnote=75413020,
		}, {
			"Go to "..cl(49,71),
			"	a. Talk to Chemist Cuely",
			"		i. Turn in "..cq("Seeping Corruption part 1"),
			"		ii. Accept "..cq("Seeping Corruption part 2"),
			"	b. Talk to Thersa Windsong",
			"		i. Turn in "..cq("Seeping Corruption part 2"),
			"		ii. Accept "..cq("Seeping Corruption part 3"),
			"	c. Talk to Chemist Cuely",
			"		i. Turn in "..cq("Seeping Corruption part 3"),
			completion={{questturnedin="Seeping Corruption part 1"},{questturnedin="Seeping Corruption part 2"},{questaccepted="Seeping Corruption part 2"},{questaccepted="Seeping Corruption part 3"},{questturnedin="Seeping Corruption part 3"}},
			mapzone="Undercity",
			level=53,
			mapnote=71812020,
		}, {
			"Go to "..cl(50,68),
			"	a. Talk to Apothecary Zinge",
			"		i. Turn in "..cq("Return to Apothecary Zinge"),
			"		ii. Accept "..cq("Vivian Lagrave"),
			completion={{questturnedin="Return to Apothecary Zinge"},{questaccepted="Vivian Lagrave"}},
			mapzone="Undercity",
			level=53,
			mapnote=68411830,
		}, {
			"Go to "..cl(47,73),
			"	a. Talk to Chemist Fuely",
			"		i. Accept "..cq("A Sample of Slime..."),
			"		ii. Accept "..cq("... and a Batch of Ooze"),
			completion={{questaccepted="A Sample of Slime..."},{questaccepted="... and a Batch of Ooze"}},
			mapzone="Undercity",
			level=53,
			mapnote=73112060,
		}, {
			"Fly to Revantusk Village",
			completion={{location={mapzone="The Hinterlands",x=78.4,y=80.6, dist=6}}},
			mapzone="Undercity",
			level=53,
		}, {
			"Go to "..cl(80,82),
			"	a. Talk to Katoom the Angler",
			"		i. Accept "..cq("Snapjaws, Mon!"),
			"		ii. Accept "..cq("Gammerita, Mon!"),
			completion={{questaccepted="Snapjaws, Mon!"},{questaccepted="Gammerita, Mon!"}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=81416170,
		}, {
			"Go to "..cl(78,81),
			"	a. Talk to Lard",
			"		i. Accept "..cq("Lard Lost His Lunch"),
			completion={{questaccepted="Lard Lost His Lunch"}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=81315950,
		}, {
			"Go north to "..cl(78,69),
			"	a. Kill 15 Saltwater Snapjaws",
			completion={{questgoal={"*","Saltwater Snapjaw slain",15}}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=69014700,
		}, {
			"Go northeast to "..cl(79,62),
			"	a. Kill Gammerita",
			"	b. Get Katoom's Best Lure",
			completion={{questgoal={"*","Katoom's Best Lure",1}}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=62014100,
		}, {
			"Go north to "..cl(81,47),
			"	a. Click Cortello's Treasure",
			"		i. Turn in "..cq("Cortello's Riddle part 3"),
			completion={{questturnedin="Cortello's Riddle part 3"}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=46812760,
		}, {
			"Go northeast to "..cl(84,41),
			"	a. Click Lard's Picnic Basket",
			"	b. Kill the 3 trolls that spawn",
			"	c. Get Lard's Lunch",
			completion={{questgoal={"*","Lard's Lunch",1}}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=41212550,
		}, {
			"Go southwest to Revantusk Village",
			completion={{location={mapzone="The Hinterlands",x=78.4,y=80.6, dist=6}}},
			mapzone="The Hinterlands",
			level=53,
		}, {
			"Go to "..cl(78,81),
			"	a. Talk to Lard",
			"		i. Turn in "..cq("Lard Lost His Lunch"),
			completion={{questturnedin="Lard Lost His Lunch"}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=81315950,
		}, {
			"Go to "..cl(80,82),
			"	a. Talk to Katoom the Angler",
			"		i. Turn in "..cq("Snapjaws, Mon!"),
			"		ii. Turn in "..cq("Gammerita, Mon!"),
			completion={{questturnedin="Snapjaws, Mon!"},{questturnedin="Gammerita, Mon!"}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=81416170,
		}, {
			"Go northwest to "..cl(41,59),
			"	a. Click a Violet Tragan",
			"	b. Get a Violet Tragan",
			completion={{questgoal={"*","Violet Tragan",1}}},
			mapzone="The Hinterlands",
			level=53,
			mapnote=59010000,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="The Hinterlands",
			level=53,
		}, {
			"Fly to Valormok",
			completion={{location={mapzone="Azshara",x=22.0,y=50.9, dist=2}}},
			mapzone="Orgrimmar",
			level=53,
		}, {
			"Go to "..cl(23,51),
			"	a. Talk to Jediga",
			"		i. Turn in "..cq("Magatha's Payment to Jediga"),
			"		ii. Turn in "..cq("Jes'rimon's Payment to Jediga"),
			"		iii. Turn in "..cq("Andron's Payment to Jediga"),
			completion={{questturnedin="Magatha's Payment to Jediga"},{questturnedin="Jes'rimon's Payment to Jediga"},{questturnedin="Andron's Payment to Jediga"}},
			mapzone="Azshara",
			level=53,
			mapnote=51407400,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Azshara",
			level=53,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=53,
		}, {
			"Fly to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=53,
		}, {
			"Go southwest to the Blasted Lands",
			completion={{location={mapzone="Blasted Lands"}}},
			mapzone="Swamp of Sorrows",
			level=53,
		}, {
			"Go south to "..cl(51,14),
			"	a. Talk to Bloodmage Drazial",
			"		i. Accept "..cq("Snickerfang Jowls"),
			"		ii. Accept "..cq("A Boar's Vitality"),
			"		iii. Accept "..cq("The Decisive Striker"),
			"	b. Talk to Bloodmage Lynnore",
			"		i. Accept "..cq("The Basilisk's Bite"),
			"		ii. Accept "..cq("Vulture's Vigor"),
			completion={{questaccepted="Snickerfang Jowls"},{questaccepted="A Boar's Vitality"},{questaccepted="The Decisive Striker"},{questaccepted="The Basilisk's Bite"},{questaccepted="Vulture's Vigor"}},
			mapzone="Blasted Lands",
			level=53,
			mapnote=14206480,
		}, {
			"Follow the Grinding Circle until you have:",
			"	a. 6 Blasted Boar Lungs",
			"	b. 5 Snickerfang Jowls",
			"	c. 14 Vulture Gizzards",
			"	d. 11 Basilisk Brains",
			"	e. 6 Scorpok Pincers",
			mapzone="Blasted Lands",
			level=53,
		}, {
			"Go southwest to "..cl(49,18),
			"	a. This is Grind Point One",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=18006700,
		}, {
			"Go southwest to "..cl(45,26),
			"	a. This is Grind Point Two",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=26007100,
		}, {
			"Go south to "..cl(46,34),
			"	a. This is Grind Point Three",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=34008000,
		}, {
			"Go east to "..cl(56,37),
			"	a. This is Grind Point Four",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=37009300,
		}, {
			"Go north to "..cl(56,30),
			"	a. This is Grind Point Five",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=30508680,
		}, {
			"Go northeast to "..cl(63,28),
			"	a. This is Grind Point Six",
			"	b. Kill boars, hyenas, bultures, basilisks, and scorpions",
			mapzone="Blasted Lands",
			level=53,
			mapnote=28009100,
		}, {
			"Go to "..cl(51,14),
			"	a. Talk to Bloodmage Drazial",
			"		i. Turn in "..cq("Snickerfang Jowls"),
			"		ii. Turn in "..cq("A Boar's Vitality"),
			"		iii. Turn in "..cq("The Decisive Striker"),
			"	b. Talk to Bloodmage Lynnore",
			"		i. Turn in "..cq("The Basilisk's Bite"),
			"		ii. Turn in "..cq("Vulture's Vigor"),
			completion={{questturnedin="Snickerfang Jowls"},{questturnedin="A Boar's Vitality"},{questturnedin="The Decisive Striker"},{questturnedin="The Basilisk's Bite"},{questturnedin="Vulture's Vigor"}},
			mapzone="Blasted Lands",
			level=53,
			mapnote=14206480,
		}, {
			"Grind to level 54",
			completion={{level=54}},
			mapzone="Blasted Lands",
			level=53,
		}, {
			"Go to "..cl(52,36),
			"	a. Talk to Kum'isha the Collector",
			"	b. If you found an Imperfect Draenethyst Fragment while grinding:",
			"		i. Accept "..cq("Everything Counts In Large Amounts"),
			"	c. If you found a Flawless Draenethyst Sphere while grinding:",
			"		i. Accept "..cq("To Serve Kum'isha"),
			"		ii. Turn in "..cq("Everything Counts In Large Amounts"),
			"		iii. Turn in "..cq("To Serve Kum'isha"),
			completion={{questaccepted="Everything Counts In Large Amounts"},{questaccepted="To Serve Kum'isha"},{questturnedin="Everything Counts In Large Amounts"},{questturnedin="To Serve Kum'isha"}},
			mapzone="Blasted Lands",
			level=54,
			mapnote=35608740,
		}, {
			"Hearth to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Blasted Lands",
			level=54,
		}, {
			"Buy a Mithril Casing from the Auction House",
			completion={{item={"Mithril Casing",1}}},
			mapzone="Orgrimmar",
			level=54,
		}, {
			"Fly to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Orgrimmar",
			level=54,
		}, {
			"Go to "..cl(51,27),
			"	a. Talk to Sprinkle",
			"		i. Turn in "..cq("Sprinkle's Secret Ingredient"),
			"		ii. Accept "..cq("Delivery for Marin"),
			completion={{questturnedin="Sprinkle's Secret Ingredient"},{questaccepted="Delivery for Marin"}},
			mapzone="Tanaris",
			level=54,
			mapnote=26907800,
		}, {
			"Also at "..cl(51,27),
			"	a. Talk to Alchemist Pestlezugg",
			"		i. Turn in "..cq("March of the Silithid"),
			"		ii. Accept "..cq("Bungle in the Jungle"),
			completion={{questturnedin="March of the Silithid"},{questaccepted="Bungle in the Jungle"}},
			mapzone="Tanaris",
			level=54,
			mapnote=27007790,
		}, {
			"Go to "..cl(52,29),
			"	a. Talk to Marin Noggenfogger",
			"		i. Turn in "..cq("Delivery for Marin"),
			"		ii. Accept "..cq("Noggenfogger Elixir"),
			"		iii. Turn in "..cq("Noggenfogger Elixir"),
			completion={{questturnedin="Delivery for Marin"},{questaccepted="Noggenfogger Elixir"},{questturnedin="Noggenfogger Elixir"}},
			mapzone="Tanaris",
			level=54,
			mapnote=28608040,
		}, {
			"Go south "..cl(53,46),
			"	a. Talk to Marvon Rivetseeker",
			"		i. Turn in "..cq("The Stone Circle"),
			completion={{questturnedin="The Stone Circle"}},
			mapzone="Tanaris",
			level=54,
			mapnote=45909860,
		}, {
			"Go southwest to Un'Goro Crater",
			completion={{location={mapzone="Un'Goro Crater"}}},
			mapzone="Tanaris",
			level=54,
		}, {
			"Kill every ooze you see in Un'Goro Crater",
			"	a. Get 25 Un'Goro Slime Samples",
			mapzone="Un'Goro Crater",
			level=54,
		}, {
			"Go to "..cl(72,76),
			"	b. Talk to Torwa Pathfinder",
			"		i. Accept "..cq("The Apes of Un'Goro"),
			"		ii. Accept "..cq("The Fare of Lar'korwi"),
			completion={{questaccepted="The Apes of Un'Goro"},{questaccepted="The Fare of Lar'korwi"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=76014760,
		}, {
			"While questing in Un'Goro Crater, look for the following items on the ground:",
			"	a. Green Power Crystals - Get 7 of these",
			"	b. Red Power Crystals - Get 7 of these",
			"	c. Blue Power Crystals - Get 7 of these",
			"	d. Yellow Power Crystals - Get 7 of these",
			"	e. Un'Goro Dirt Piles - Get 25 of these",
			mapzone="Un'Goro Crater",
			level=54,
		}, {
			"Go west to "..cl(68,76),
			"	a. Kill Ravagers",
			"	b. Get A Mangled Journal",
			"	c. Click the Mangled Journal",
			"		i. Accept "..cq("Williden's Journal"),
			"	d. Kill Ravasaurs",
			"	e. Get 8 White Ravasaur Claws",
			completion={{questgoal={"*","White Ravasaur Claw",8}},{questaccepted="Williden's Journal"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=76014400,
		}, {
			"Go northwest to "..cl(63,69),
			"	a. Click the Wrecked Rift",
			"		i. Accept "..cq("It's a Secret to Everybody part 1"),
			completion={{questaccepted="It's a Secret to Everybody part 1"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=68513150,
		}, {
			"Also at "..cl(63,69),	
			"	a. Click the Small Pack underwater next to the shore",
			"		i. Turn in "..cq("It's a Secret to Everybody part 1"),
			"		ii. Accept "..cq("It's a Secret to Everybody part 2"),
			"	b. Click the Small Pack in your bags",
			"		i. Get the Large Compass",
			"		ii. Get the Curled Map Parchment",
			"		iii. Get the Lion-headed Key",
			completion={{questturnedin="It's a Secret to Everybody part 1"},{questaccepted="It's a Secret to Everybody part 2"},{questgoal={"*","Large Compass",1}},{questgoal={"*","Curled Map Parchment",1}},{questgoal={"*","Lion-headed Key",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=69113220,
		}, {
			"Go northeast to "..cl(69,57),
			"	a. Click the Fresh Threshadon Carcass",
			"	b. Get a Piece of Threshadon Carcass",
			completion={{questgoal={"*","Piece of Threshadon Carcass",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=57212580,
		}, {
			"Go southeast to "..cl(72,76),
			"	a. Talk to Torwa Pathfinder",
			"		i. Turn in "..cq("The Fare of Lar'korwi"),
			"		ii. Accept "..cq("The Scent of Lar'korwi"),
			completion={{questturnedin="The Fare of Lar'korwi"},{questaccepted="The Scent of Lar'korwi"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=76014760,
		}, {
			"Go northwest to "..cl(67,73),
			"	a. Kill raptors near egg nests",
			"	b. Stand on the egg nests around this area",
			"	c. Kill Lar'korwi Mates",
			"	d. Get 2 Ravasaur Pheromone Glands",
			completion={{questgoal={"*","Ravasaur Pheromone Gland",2}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=73014030,
		}, {
			"Go southeast to "..cl(72,76),
			"	a. Talk to Torwa Pathfinder",
			"		i. Turn in "..cq("The Scent of Lar'korwi"),
			"		ii. Accept "..cq("The Bait for Lar'korwi"),
			completion={{questturnedin="The Scent of Lar'korwi"},{questaccepted="The Bait for Lar'korwi"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=76014760,
		}, {
			"Go northeast to "..cl(80,50),
			"	a. Stand on the big grey flat rock",
			"	b. Click Torwa's Pouch in your bags",
			"	c. Click the Preserved Threshadon Meat in your bags",
			"	d. Click the Preserved Pheromone Mixture in your bags",
			"	e. Kill Lar'korwi",
			"	f. Get Lar'korwi's Head",
			completion={{questgoal={"*","Lar'korwi's Head",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=49912980,
		}, {
			"Go northwest to "..cl(66,16),
			"	a. Kill Un'Goro Gorillas inside the cave",
			"	b. Get 2 Un'Goro Gorilla Pelts",
			"	c. Kill Un'Goro Stompers inside the cave",
			"	d. Get 2 Un'Goro Stomper Pelts",
			"	e. Kill Un'Goro Thunderers inside the cave",
			"	f. Get 2 Un'Goro Thunderer Pelts",
			completion={{questgoal={"*","Un'Goro Gorilla Pelt",2}},{questgoal={"*","Un'Goro Stomper Pelt",2}},{questgoal={"*","Un'Goro Thunderer Pelt",2}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=16008200,
		}, {
			"Go west to "..cl(46,13),
			"	a. Talk to Karna Remtravel",
			"		i. Accept "..cq("Chasing A-Me 01 part 1"),
			completion={{questaccepted="Chasing A-Me 01 part 1"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=13505990,
		}, {
			"Go northwest to "..cl(45,8),
			"	a. Talk to Linken",
			"		i. Turn in "..cq("It's a Secret to Everybody part 2"),
			"		ii. Accept "..cq("It's a Secret to Everybody part 3"),
			completion={{questturnedin="It's a Secret to Everybody part 2"},{questaccepted="It's a Secret to Everybody part 3"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=8105280,
		}, {
			"Go to "..cl(46,9),
			"	a. Talk to Larion",
			"		i. Accept "..cq("Larion and Muigin"),
			completion={{questaccepted="Larion and Muigin"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=8705420,
		}, {
			"Go to "..cl(45,6),
			"	a. Talk to Gryfe",
			"		i. Get the Marshal's Refuge Flight Path",
			completion={{flightpath="Marshal's Refuge"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=5805100,
		}, {
			"Go to "..cl(44,7),
			"	a. Talk to Williden Marshal",
			"		i. Turn in "..cq("Williden's Journal"),
			"		ii. Accept "..cq("Expedition Salvation"),
			"	b. Talk to Hol'anyee Marshal",
			"		i. Accept "..cq("Alien Ecology"),
			completion={{questturnedin="Williden's Journal"},{questaccepted="Expedition Salvation"},{questaccepted="Alien Ecology"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=7205110,
		}, {
			"Go to "..cl(43,7),
			"	a. Talk to Spark Nilminer",
			"		i. Accept "..cq("Roll the Bones"),
			completion={{questaccepted="Roll the Bones"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=7305090,
		}, {
			"Go to "..cl(44,8),
			"	a. Click the sign",
			"		i. Accept "..cq("Beware of Pterrordax"),
			"	b. Talk to Spraggle Frock",
			"		i. Accept "..cq("Lost!"),
			completion={{questaccepted="Beware of Pterrordax"},{questaccepted="Lost!"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=8405200,
		}, {
			"Go to "..cl(44,12),
			"	a. Talk to Shizzle",
			"		i. Accept "..cq("Shizzle's Flyer"),
			completion={{questaccepted="Shizzle's Flyer"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=11605580,
		}, {
			"Go to "..cl(42,3),
			"	a. Talk to J.D. Collie inside cave",
			"		i. Accept "..cq("Crystals of Power"),
			"		ii. Turn in "..cq("Crystals of Power"),
			"		iii. Accept "..cq("The Northern Pylon"),
			"		iv. Accept "..cq("The Eastern Pylon"),
			"		v. Accept "..cq("The Western Pylon"),
			completion={{questaccepted="Crystals of Power"},{questturnedin="Crystals of Power"},{questaccepted="The Northern Pylon"},{questaccepted="The Eastern Pylon"},{questaccepted="The Western Pylon"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=2704460,
		}, {
			"Go south to "..cl(47,19),
			"	a. Kill Tar mobs",
			"	b. Get 12 Super Sticky Tar",
			completion={{questgoal={"*","Super Sticky Tar",12}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=19006600,
		}, {
			"Go east to "..cl(56,18),
			"	a. Kill 5 Bloodpetal Flayers",
			completion={{questgoal={"*","Bloodpetal Flayer slain",5}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=18007400,
		}, {
			"Go north to "..cl(57,12),
			"	a. Go up the hill",
			"	b. Click the Northern Pylon",
			"	c. Examine the Northern Pylon",
			completion={{questgoal={"*","Discover and examine the Northern Crystal Pylon",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=12406890,
		}, {
			"Go north to "..cl(57,9),
			"	a. Kill 10 Pterrordaxes",
			completion={{questgoal={"*","Pterrordax slain",10}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=9006600,
		}, {
			"Go east into the gorilla cave",
			completion={{location={mapzone="Un'Goro Crater",x=63.1,y=17.1, dist=1}}},
			mapzone="Un'Goro Crater",
			level=54,
		}, {
			"Go to "..cl(68,17),
			"	a. Talk to A-Me 01",
			"		i. Turn in "..cq("Chasing A-Me 01 part 1"),
			completion={{questturnedin="Chasing A-Me 01 part 1"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=16808440,
		}, {
			"Go south to "..cl(67,33),
			"	a. Kill Pterrordaxes",
			"	b. Get 8 Webbed Pterrordax Scales",
			"	c. Kill Diemetradons",
			"	d. Get 8 Webbed Diemetradon Scales",
			"	e. Get 8 Dinosaur Bones",
			"	f. Kill 5 Bloodpetal Lashers",
			"	g. Kill 5 Bloodpetal Threshers",
			completion={{questgoal={"*","Webbed Pterrordax Scale",8}},{questgoal={"*","Webbed Diemetradon Scale",8}},{questgoal={"*","Dinosaur Bone",8}},{questgoal={"*","Bloodpetal Lasher slain",5}},{questgoal={"*","Bloodpetal Thresher slain",5}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=33010000,
		}, {
			"Go southeast to "..cl(69,37),
			"	a. Click the Crate of Foodstuffs",
			"	b. Get the Crate of Foodstuffs",
			completion={{questgoal={"*","Crate of Foodstuffs",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=36610510,
		}, {
			"Go southeast to "..cl(77,50),
			"	a. Go up the hill",
			"	b. Click the Eastern Pylon",
			"	c. Examine the Eastern Pylon",
			completion={{questgoal={"*","Discover and examine the Eastern Crystal Pylon",1}}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=49912710,
		}, {
			"Go southwest to "..cl(72,76),
			"	a. Talk to Torwa Pathfinder",
			"		i. Turn in "..cq("The Apes of Un'Goro"),
			"		ii. Accept "..cq("The Mighty U'cha"),
			"		iii. Turn in "..cq("The Bait for Lar'korwi"),
			completion={{questturnedin="The Apes of Un'Goro"},{questturnedin="The Bait for Lar'korwi"},{questaccepted="The Mighty U'cha"}},
			mapzone="Un'Goro Crater",
			level=54,
			mapnote=76014760,
		}, {
			"Grind to level 55",
			completion={{level=55}},
			mapzone="Un'Goro Crater",
			level=54,			
		}
	  },
	},
	{ sectiontitle = "Levels (55-60)",
	  steps = {
		{
			"Go west to "..cl(50,78),
			"	a. The path down to 'Alien Ecology' starts here",
			completion={{location={mapzone="Un'Goro Crater",x=50.5,y=78.4, dist=0.5}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=77912830,
		}, {
			"Go to "..cl(49,85),
			"	a. Go down the path",
			"	b. Go left at the fork into the circular room",
			"	c. Use your Unused Scraing Vial in the middle of the room",
			"	d. Get a Hive Wall Sample",
			completion={{questgoal={"*","Hive Wall Sample",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=85213380,
		}, {
			"Go out of the hive",
			"	a. Kill Gorishi insects",
			"	b. Get a Gorishi Scent Gland",
			completion={{questgoal={"*","Gorishi Scent Gland",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=77612640,
		}, {
			"Kill 5 Bloodpetal Trappers",
			completion={{questgoal={"*","Bloodpetal Trapper slain",5}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=69010900,
		}, {
			"Go northwest to "..cl(38,66),
			"	a. Click the Research Equipment",
			"	b. Get the Research Equipment",
			completion={{questgoal={"*","Research Equipment",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=66110460,
		}, {
			"Go northwest to "..cl(24,59),
			"	a. Go up the hill",
			"	b. Click the Western Pylon",
			"	c. Examine the Western Pylon",
			completion={{questgoal={"*","Discover and examine the Western Crystal Pylon",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=59208300,
		}, {
			"Go west to "..cl(21,59),
			"	a. Kill 15 Frenzied Pterrordaxes",
			completion={{questgoal={"*","Frenzied Pterrordax slain",15}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=59008000,
		}, {
			"Make sure you have 25 Un'Goro Slime Samples",
			"Make sure you have 25 Un'Goro Soil",
			completion={{item={"Un'Goro Slime Sample",25}},{item={"Un'Goro Soil",25}}},
			mapzone="Un'Goro Crater",
			level=54,
		}, {
			"Go northeast to "..cl(31,50),
			"	a. Talk to Krakle",
			"		i. Accept "..cq("Finding the Source"),
			completion={{questaccepted="Finding the Source"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=50408130,
		}, {
			"Go northeast to "..cl(52,42),
			"	a. The path up to 'Finding the Source' starts here",
			completion={{location={mapzone="Un'Goro Crater",x=52.6,y=42.1, dist=0.5}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=42109480,
		}, {
			"Go southwest to "..cl(50,46),
			"	a. Follow the path up",
			"	b. Use Krakle's Thermometer on the Fire Plume Ridge Hot Spot",
			"	c. Find the hottest area of Fire Plume Ridge",
			completion={{questgoal={"*","Find the hottest area of Fire Plume Ridge",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=45709540,
		}, {
			"Go southwest to "..cl(47,53),
			"	a. Kill fire elementals",
			"	b. Get 9 Un'Goro Ash",
			completion={{questgoal={"*","Un'Goro Ash",9}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=52909950,
		}, {
			"Go southwest to "..cl(31,50),
			"	a. Talk to Krakle",
			"		i. Turn in "..cq("Finding the Source"),
			"		ii. Accept "..cq("The New Springs"),
			completion={{questturnedin="Finding the Source"},{questaccepted="The New Springs"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=50408130,
		}, {
			"Go east to "..cl(54,50),
			"	a. The path up to 'Lost!' starts here",
			completion={{location={mapzone="Un'Goro Crater",x=54.5,y=50.3, dist=0.5}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=50310470,
		}, {
			"Go west to "..cl(52,50),
			"	a. Talk to Ringo",
			"		i. Turn in "..cq("Lost!"),
			"		ii. Accept "..cq("A Little Help From My Friends"),
			"	b. Escort Ringo to safety",
			"	c. When Ringo faints, use Spraggle's Canteen on him to revive him",
			completion={{questturnedin="Lost!"},{questaccepted="A Little Help From My Friends"},{questgoal={"*","Escort Ringo to Spraggle Frock at Marshal's Refuge",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=49910180,
		}, {
			"Go to Marshal's Refuge",
			completion={{location={mapzone="Un'Goro Crater",x=44.9,y=8.2, dist=3}}},
			mapzone="Un'Goro Crater",
			level=55,
		}, {
			"Go to "..cl(44,9),
			"	a. Talk to Spraggle Frock",
			"		i. Turn in "..cq("A Little Help From My Friends"),
			"		ii. Turn in "..cq("Beware of Pterrordax"),
			completion={{questturnedin="A Little Help From My Friends"},{questturnedin="Beware of Pterrordax"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=8405200,
		}, {
			"Go to "..cl(43,7),
			"	a. Talk to Spark Nilminer",
			"		i. Turn in "..cq("Roll the Bones"),
			completion={{questturnedin="Roll the Bones"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=7305090,
		}, {
			"Go to "..cl(44,7),
			"	a. Talk to Williden Marshal",
			"		i. Turn in "..cq("Expedition Salvation"),
			"	b. Talk to Hol'anyee Marshal",
			"		i. Turn in "..cq("Alien Ecology"),
			completion={{questturnedin="Expedition Salvation"},{questturnedin="Alien Ecology"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=7205110,
		}, {
			"Go to "..cl(46,9),
			"	a. Talk to Larion",
			"		i. Turn in "..cq("Larion and Muigin"),
			"		ii. Accept "..cq("Marvon's Workshop"),
			completion={{questturnedin="Larion and Muigin"},{questaccepted="Marvon's Workshop"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=8705420,
		}, {
			"Go to "..cl(44,12),
			"	a. Talk to Shizzle",
			"		i. Turn in "..cq("Shizzle's Flyer"),
			completion={{questturnedin="Shizzle's Flyer"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=11605580,
		}, {
			"Go to "..cl(42,3),
			"	a. Talk to J.D. Collie",
			"		i. Turn in "..cq("The Northern Pylon"),
			"		ii. Turn in "..cq("The Eastern Pylon"),
			"		iii. Turn in "..cq("The Western Pylon"),
			"		iv. Accept "..cq("Making Sense of It"),
			"		v. Turn in "..cq("Making Sense of It"),
			completion={{questturnedin="The Northern Pylon"},{questturnedin="The Eastern Pylon"},{questturnedin="The Western Pylon"},{questturnedin="Making Sense of It"},{questaccepted="Making Sense of It"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=2704460,
		}, {
			"Go southeast to the gorilla cave",
			completion={{location={mapzone="Un'Goro Crater",x=63.1,y=17.1, dist=1}}},
			mapzone="Un'Goro Crater",
			level=55,
		}, {
			"Go inside the cave to "..cl(68,13),
			"	a. Inside the cave, follow the path up",
			"	b. Kill U'cha",
			"	c. Get U'cha's Pelt",
			completion={{questgoal={"*","U'cha's Pelt",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=12908130,
		}, {
			"Inside the cave, go to "..cl(68,17),
			"	a. Talk to A-Me 01",
			"		i. Accept "..cq("Chasing A-Me 01 part 2"),
			"		ii. Turn in "..cq("Chasing A-Me 01 part 2"),
			"		iii. Accept "..cq("Chasing A-Me 01 part 3"),
			"	b. Escort A-Me 01 to safety",
			completion={{questaccepted="Chasing A-Me 01 part 2"},{questturnedin="Chasing A-Me 01 part 2"},{questaccepted="Chasing A-Me 01 part 3"},{questgoal={"*","Protect A-Me 01 until you reach Karna Remtravel",1}}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=16808440,
		}, {
			"Go to "..cl(46,13),
			"	a. Talk to Karna Remtravel",
			"		i. Turn in "..cq("Chasing A-Me 01 part 3"),
			completion={{questturnedin="Chasing A-Me 01 part 3"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=13505990,
		}, {
			"Go southeast to "..cl(72,76),
			"	a. Talk to Torwa Pathfinder",
			"		i. Turn in "..cq("The Mighty U'cha"),
			completion={{questturnedin="The Mighty U'cha"}},
			mapzone="Un'Goro Crater",
			level=55,
			mapnote=76014760,
		}, {
			"Go southeast to Tanaris",
			completion={{location={mapzone="Tanaris"}}},
			mapzone="Un'Goro Crater",
			level=55,
		}, {
			"Go northeast to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Tanaris",
			level=55,
		}, {
			"Go to "..cl(52,27),
			"	a. Talk to Tran'rek",
			"		i. Turn in "..cq("Super Sticky"),
			completion={{questturnedin="Super Sticky"}},
			mapzone="Tanaris",
			level=55,
			mapnote=26807840,
		}, {
			"Go to "..cl(51,27),
			"	b. Talk to Alchemist Pestlezugg",
			"		i. Turn in "..cq("Bungle in the Jungle"),
			completion={{questturnedin="Bungle in the Jungle"}},
			mapzone="Tanaris",
			level=55,
			mapnote=27007790,
		}, {
			"Grind to level 56",
			completion={{level=56}},
			mapzone="Tanaris",
			level=55,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Tanaris",
			level=56,
		}, {
			"Go to "..cl(79,29),
			"	a. Talk to Arch Druid Hamuul Runetotem",
			"		i. Accept "..cq("Un'Goro Soil"),
			completion={{questaccepted="Un'Goro Soil"}},
			mapzone="Thunder Bluff",
			level=56,
			mapnote=28510710,
		}, {
			"Go to "..cl(77,22),
			"	a. Talk to Ghede",
			"		i. Turn in "..cq("Un'Goro Soil"),
			completion={{questturnedin="Un'Goro Soil"}},
			mapzone="Thunder Bluff",
			level=56,
			mapnote=22009940,
		}, {
			"Go to "..cl(79,29),
			"	a. Talk to Arch Druid Hamuul Runetotem",
			"		i. Accept "..cq("Morrowgrain Research part 1"),
			completion={{questaccepted="Morrowgrain Research part 1"}},
			mapzone="Thunder Bluff",
			level=56,
			mapnote=28510710,
		}, {
			"Go to "..cl(71,34),
			"	a. Talk to Bashana Runetotem",
			"		i. Turn in "..cq("Morrowgrain Research part 1"),
			completion={{questturnedin="Morrowgrain Research part 1"}},
			mapzone="Thunder Bluff",
			level=56,
			mapnote=34210530,
		}, {
			"Hearth to the Orgrimmar",
			completion={{location={mapzone="The Barrens",x=51.7,y=30.2, dist=2}}},
			mapzone="Thunder Bluff",
			level=56,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Orgrimmar",
			level=56,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Liv Rizzlefix",
			"		i. Turn in "..cq("Marvon's Workshop"),
			"		ii. Turn in "..cq("Volcanic Activity"),
			completion={{questturnedin="Marvon's Workshop"},{questturnedin="Volcanic Activity"}},
			mapzone="The Barrens",
			level=56,
			mapnote=38710120,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=56,
		}, {
			"Fly to Kargath",
			completion={{location={mapzone="Badlands",x=4.7,y=46.6, dist=4}}},
			mapzone="Stranglethorn Vale",
			level=56,
		}, {
			"Go to "..cl(3,48),
			"	a. Talk to Shadowmage Vivian Lagrave",
			"		i. Turn in "..cq("Vivian Lagrave"),
			"	b. Talk to Hierophant Theodora Mulvadania",
			"		i. Accept "..cq("The Rise of the Machines part 1"),
			completion={{questturnedin="Vivian Lagrave"},{questaccepted="The Rise of the Machines part 1"}},
			mapzone="Badlands",
			level=56,
			mapnote=47805080,
		}, {
			"Also at "..cl(3,48),
			"	a. Talk to Thal'trak Proudtusk",
			"		i. Accept "..cq("Dreadmaul Rock"),
			completion={{questaccepted="Dreadmaul Rock"}},
			mapzone="Badlands",
			level=56,
			mapnote=48105150,
		}, {
			"Fly to Flame Crest",
			completion={{location={mapzone="Burning Steppes",x=65.4,y=23.7, dist=2}}},
			mapzone="Badlands",
			level=56,
		}, {
			"Go to "..cl(65,24),
			"	a. Talk to Maxwort Uberglint",
			"		i. Accept "..cq("Tablet of the Seven"),
			"	b. Talk to Tinkee Steamboil",
			"		i. Accept "..cq("Broodling Essence"),
			completion={{questaccepted="Tablet of the Seven"},{questaccepted="Broodling Essence"}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=23908910,
		}, {
			"Go to "..cl(66,22),
			"	a. Talk to Yuka Screwspigot",
			"		i. Turn in "..cq("Yuka Screwspigot"),
			completion={{questturnedin="Yuka Screwspigot"}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=21908800,
		}, {
			"Go southeast to "..cl(85,30),
			"	a. Use your Draco-Incarcinatrix 900 on Black Broodlings",
			"	b. Kill Black Broodlings",
			"	c. Click the red crystal hovering over their corpses",
			"	d. Get 8 Broodling Essences",
			completion={{questgoal={"*","Broodling Essence",8}}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=30011500,
		}, {
			"Go southwest to "..cl(80,45),
			"	a. Go to the top of Dreadmaul Rock",
			"	b. Click Sha'ni Proudtusk's Remains to summon her",
			"	c. Talk to Sha'ni Proudtusk",
			"		i. Turn in "..cq("Dreadmaul Rock"),
			"		ii. Accept "..cq("Krom'Grul"),
			completion={{questturnedin="Dreadmaul Rock"},{questaccepted="Krom'Grul"}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=45412530,
		}, {
			"Krom'Grul can spawn in any of the 3 caves on Dreadmaul Rock",
			"	a. Kill Korm'Grul",
			"	b. Get Sha'ni's Nose-Ring",
			completion={{questgoal={"*","Sha'ni's Nose-Ring",1}}},
			mapzone="Burning Steppes",
			level=56,
		}, {
			"Go to "..cl(69,38),
			"	a. Kill War Reavers",
			"	b. Get 10 Fractured Elemental Shards",
			completion={{questgoal={"*","Fractured Elemental Shard",10}}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=37810660,
		}, {
			"Go west to "..cl(54,41),
			"	a. Click the Tablet of the Seven",
			"	b. Transcribe the Tablet",
			"	c. Get the Tablet Transcript",
			completion={{questgoal={"*","Tablet Transcript",1}}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=40709480,
		}, {
			"Go northeast to "..cl(65,24),
			"	a. Talk to Tinkee Steamboil",
			"		i. Turn in "..cq("Broodling Essence"),
			"		ii. Accept "..cq("Felnok Steelspring"),
			"	b. Talk to Maxwort Uberglint",
			"		i. Turn in "..cq("Tablet of the Seven"),
			completion={{questturnedin="Broodling Essence"},{questturnedin="Tablet of the Seven"},{questaccepted="Felnok Steelspring"}},
			mapzone="Burning Steppes",
			level=56,
			mapnote=23908910,
		}, {
			"Fly to Kargath",
			completion={{location={mapzone="Badlands",x=4.7,y=46.6, dist=4}}},
			mapzone="Burning Steppes",
			level=56,
		}, {
			"Go to "..cl(3,48),
			"	a. Talk to Thal'trak Proudtusk",
			"		i. Turn in "..cq("Krom'Grul"),
			completion={{questturnedin="Krom'Grul"}},
			mapzone="Badlands",
			level=56,
			mapnote=48105150,
		}, {
			"Also at "..cl(3,48),
			"	a. Talk to Hierophant Theodora Mulvadania",
			"		i. Turn in "..cq("The Rise of the Machines part 1"),
			"		ii. Accept "..cq("The Rise of the Machines part 2"),
			completion={{questturnedin="The Rise of the Machines part 1"},{questaccepted="The Rise of the Machines part 2"}},
			mapzone="Badlands",
			level=56,
			mapnote=47805080,
		}, {
			"Go east to "..cl(26,45),
			"	a. Talk to Lotwil Veriatus",
			"		i. Turn in "..cq("The Rise of the Machines part 2"),
			completion={{questturnedin="The Rise of the Machines part 2"}},
			mapzone="Badlands",
			level=56,
			mapnote=44607050,
		}, {
			"Hearth to the Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Badlands",
			level=56,
		}, {
			"Go to "..cl(56,34),
			"	a. Talk Jes'rimon",
			"		i. Turn in "..cq("Bone-Bladed Weapons"),
			completion={{questturnedin="Bone-Bladed Weapons"}},
			mapzone="Orgrimmar",
			level=56,
			mapnote=34108970,
		}, {
			"Go to "..cl(43,38),
			"	a. Talk to Warcaller Gorlach",
			"		i. Accept "..cq("The New Frontier"),
			"		ii. Accept "..cq("Camp Mojache"),
			completion={{questaccepted="The New Frontier"},{questaccepted="Camp Mojache"}},
			mapzone="Orgrimmar",
			level=56,
			mapnote=38408140,
		}, {
			"Go to "..cl(48,66),
			"	a. Talk to Cenarion Emissary Blackhoof",
			"		i. Accept "..cq("Taking Back Silithus"),
			completion={{questaccepted="Taking Back Silithus"}},
			mapzone="Orgrimmar",
			level=56,
			mapnote=65711330,
		}, {
			"Fly to Splintertree Post",
			completion={{location={mapzone="Ashenvale",x=73.4,y=61.6, dist=2}}},
			mapzone="Orgrimmar",
			level=56,
		}, {
			"Go northwest to Felwood",
			completion={{location={mapzone="Felwood"}}},
			mapzone="Ashenvale",
			level=56,
		}, {
			"Go to "..cl(51,85),
			"	a. Talk to Grazle",
			"		i. Accept "..cq("Timbermaw Ally"),
			completion={{questaccepted="Timbermaw Ally"}},
			mapzone="Felwood",
			level=56,
			mapnote=85013590,
		}, {
			"Go north to "..cl(51,82),
			"	a. Talk to Greta Mosshoof",
			"		i. Accept "..cq("Forces of Jaedenar"),
			completion={{questaccepted="Forces of Jaedenar"}},
			mapzone="Felwood",
			level=56,
			mapnote=85013590,
		}, {
			"Go to "..cl(52,82),
			"	a. Talk to Gorrim",
			"		i. Get the Emerald Sanctuary Flight Path",
			completion={{flightpath="Emerald Sanctuary"}},
			mapzone="Felwood",
			level=56,
			mapnote=82213370,
		}, {
			"Go to "..cl(51,82),
			"	a. Talk to Taronn Redfeather",
			"		i. Accept "..cq("Verifying the Corruption"),
			completion={{questaccepted="Verifying the Corruption"}},
			mapzone="Felwood",
			level=56,
			mapnote=81613250,
		}, {
			"Go southwest to "..cl(49,89),
			"	a. Kill 6 Deadwood Warriors",
			"	b. Kill 6 Deadwood Pathfinders",
			"	c. Kill 6 Deadwood Gardeners",
			completion={{questgoal={"*","Deadwood Warrior slain",6}},{questgoal={"*","Deadwood Pathfinder slain",6}},{questgoal={"*","Deadwood Gardener slain",6}}},
			mapzone="Felwood",
			level=56,
			mapnote=88913830,
		}, {
			"Go northeast to "..cl(51,85),
			"	a. Talk to Grazle",
			"		i. Turn in "..cq("Timbermaw Ally"),
			"		ii. Accept "..cq("Speak to Nafien"),
			completion={{questturnedin="Timbermaw Ally"},{questaccepted="Speak to Nafien"}},
			mapzone="Felwood",
			level=56,
			mapnote=85013590,
		}, {
			"Go northwest to "..cl(47,83),
			"	a. Talk to Maybess Riverbreeze",
			"		i. Accept "..cq("Cleansing Felwood"),
			completion={{questaccepted="Cleansing Felwood"}},
			mapzone="Felwood",
			level=56,
			mapnote=83112990,
		}, {
			"Go northwest to "..cl(42,68),
			"	a. Kill oozes",
			"	b. Get 25 Felwood Slime Samples",
			completion={{item={"Felwood Slime Sample",25}}},
			mapzone="Felwood",
			level=56,
			mapnote=67811020,
		}, {
			"Go northwest to "..cl(39,58),
			"	a. Kill 4 Jaedenar Hounds",
			"	b. Kill 4 Jaedenar Guardians",
			"	c. Kill 6 Jaedenar Adepts",
			"	d. Kill 6 Jaedenar Cultists",
			completion={{questgoal={"*","Jaedenar Hound slain",4}},{questgoal={"*","Jaedenar Guardian slain",4}},{questgoal={"*","Jaedenar Adept slain",6}},{questgoal={"*","Jaedenar Cultist slain",6}}},
			mapzone="Felwood",
			level=56,
			mapnote=58209760,
		}, {
			"Go north to the river",
			"	a. Follow the river west to Bloodvenom Post",
			completion={{location={mapzone="Felwood",x=34.5,y=52.6, dist=3}}},
			mapzone="Felwood",
			level=56,
		}, {
			"Go to "..cl(34,52),
			"	a. Talk to Winna Hazzard",
			"		i. Accept "..cq("Well of Corruption"),
			completion={{questaccepted="Well of Corruption"}},
			mapzone="Felwood",
			level=56,
			mapnote=52308650,
		}, {
			"Go to "..cl(35,53),
			"	a. Talk to Dreka'Sur",
			"		i. Accept "..cq("A Husband's Last Battle"),
			"	b. Talk to Trull Failbaine",
			"		i. Accept "..cq("Wild Guardians part 1"),
			completion={{questaccepted="A Husband's Last Battle"},{questaccepted="Wild Guardians part 1"}},
			mapzone="Felwood",
			level=56,
			mapnote=52708750,
		}, {
			"Go to "..cl(34,54),
			"	a. Talk to Brakkar",
			"		i. Get the Bloodvenom Post Flight Path",
			completion={{flightpath="Bloodvenom Post"}},
			mapzone="Felwood",
			level=56,
			mapnote=54008850,
		}, {
			"Go northeast to "..cl(42,40),
			"	a. Go into this crater",
			"	b. Explore the craters in Shatter Scar Vale",
			"	c. Kill 2 Entropic Beasts",
			"	d. Kill 2 Entropic Horrors",
			completion={{questgoal={"*","Explore the craters in Shatter Scar Vale",1}},{questgoal={"*","Entropic Beast slain",2}},{questgoal={"*","Entropic Horror slain",2}}},
			mapzone="Felwood",
			level=56,
			mapnote=40308230,
		}, {
			"Go northeast to "..cl(54,16),
			"	a. Kill Warpwood elementals",
			"	b. Get 15 Blood Amber",
			completion={{questgoal={"*","Blood Amber",15}}},
			mapzone="Felwood",
			level=56,
			mapnote=16207050,
		}, {
			"Go northeast to "..cl(56,12),
			"	a. Kill 12 Angerclaw Grizzlies",
			"	b. Kill 12 Felpaw Ravagers",
			completion={{questgoal={"*","Angerclaw Grizzly slain",12}},{questgoal={"*","Felpaw Ravager slain",12}}},
			mapzone="Felwood",
			level=56,
			mapnote=12506850,
		}, {
			"Go northeast "..cl(65,8),
			"	a. Talk to Nafien",
			"		i. Turn in "..cq("Speak to Nafien"),
			"		ii. Accept "..cq("Deadwood of the North"),
			completion={{questturnedin="Speak to Nafien"},{questaccepted="Deadwood of the North"}},
			mapzone="Felwood",
			level=56,
			mapnote=8107290,
		}, {
			"Go west to "..cl(63,9),
			"	a. Kill 6 Deadwood Den Watchers",
			"	b. Kill 6 Deadwood Avengers",
			"	c. Kill 6 Deadwood Shamans",
			completion={{questgoal={"*","Deadwood Den Watcher slain",6}},{questgoal={"*","Deadwood Avenger slain",6}},{questgoal={"*","Deadwood Shaman slain",6}}},
			mapzone="Felwood",
			level=56,
			mapnote=8907200,
		}, {
			"Go east to "..cl(65,8),
			"	a. Talk to Nafien",
			"		i. Turn in "..cq("Deadwood of the North"),
			"		ii. Accept "..cq("Speak to Salfa"),
			completion={{questturnedin="Deadwood of the North"},{questaccepted="Speak to Salfa"}},
			mapzone="Felwood",
			level=56,
			mapnote=8107290,
		}, {
			"Go through the tunnel to Winterspring",
			"	a. At the fork, the tunnel heading east leads to Winterspring",
			completion={{location={mapzone="Winterspring"}}},
			mapzone="Felwood",
			level=56,
		}, {
			"Go to "..cl(28,34),
			"	a. Talk to Salfa",
			"		i. Turn in "..cq("Speak to Salfa"),
			"		ii. Accept "..cq("Winterfall Activity"),
			completion={{questturnedin="Speak to Salfa"},{questaccepted="Winterfall Activity"}},
			mapzone="Winterspring",
			level=56,
			mapnote=34506220,
		}, {
			"Go southeast to "..cl(31,45),
			"	a. Talk to Donova Snowden",
			"		i. Turn in "..cq("The New Springs"),
			"		ii. Accept "..cq("Strange Sources"),
			"		iii. Turn in "..cq("It's a Secret to Everybody part 3"),
			"		iv. Accept "..cq("The Videre Elixir"),
			"		v. Accept "..cq("Threat of the Winterfall"),
			completion={{questturnedin="The New Springs"},{questturnedin="It's a Secret to Everybody part 3"},{questaccepted="Strange Sources"},{questaccepted="The Videre Elixir"},{questaccepted="Threat of the Winterfall"}},
			mapzone="Winterspring",
			level=56,
			mapnote=45207650,
		}, {
			"Grind to level 57",
			completion={{level=57}},
			mapzone="Winterspring",
			level=56,
		}, {
			"Go northeast to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go to "..cl(60,36),
			"	a. Talk to Yugrek",
			"		i. Get the Everlook Flight Path",
			completion={{flightpath="Everlook"}},
			mapzone="Winterspring",
			level=57,
			mapnote=36309680,
		}, {
			"Go west into the tunnel",
			"	a. Go north at the fork into Moonglade",
			completion={{location={mapzone="Moonglade"}}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go northwest to "..cl(32,67),
			"	a. Talk to Fauston",
			"		i. Get the Moonglade Flight Path",
			completion={{flightpath="Moonglade"}},
			mapzone="Moonglade",
			level=57,
			mapnote=66609870,
		}, {
			"Fly to Thunder Bluff",
			completion={{location={mapzone="Thunder Bluff"}}},
			mapzone="Moonglade",
			level=57,
		}, {
			"Go to "..cl(43,62),
			"	a. Talk to Bluff Runner Windstrider",
			"	b. He walks around Thunder Bluff",
			"		i. Accept "..cq("A Call to Arms: The Plaguelands!"),
			completion={{questaccepted="A Call to Arms: The Plaguelands!"}},
			mapzone="Thunder Bluff",
			level=57,
			mapnote=62110550,
		}, {
			"Go to "..cl(79,29),
			"	a. Talk to Arch Druid Hamuul Runetotem",
			"		i. Turn in "..cq("The New Frontier"),
			"		ii. Accept "..cq("Rabine Saturna"),
			completion={{questturnedin="The New Frontier"},{questaccepted="Rabine Saturna"}},
			mapzone="Thunder Bluff",
			level=57,
			mapnote=28510710,
		}, {
			"Fly to Camp Mojache",
			completion={{location={mapzone="Feralas",x=74.7,y=44.0, dist=2}}},
			mapzone="Thunder Bluff",
			level=57,
		}, {
			"Go to "..cl(76,44),
			"	a. Talk to Talo Thornhoof",
			"		i. Turn in "..cq("The Strength of Corruption"),
			"		ii. Turn in "..cq("Camp Mojache"),
			completion={{questturnedin="The Strength of Corruption"},{questturnedin="Camp Mojache"}},
			mapzone="Feralas",
			level=57,
			mapnote=43812000,
		}, {
			"Go northwest to "..cl(45,26),
			"	a. Talk to Gregan Brewspewer",
			"		i. Buy 1 Bait",
			completion={{item={"Bait",1}}},
			mapzone="Feralas",
			level=57,
			mapnote=25607070,
		}, {
			"Go north to "..cl(45,11),
			"	a. Click the Bait in your bags to place it here",
			"	b. Miblan Snarltooth will run over to the bait and start eating it",
			"	c. The door behind him will slide open",
			"	d. Run into the stone building",
			completion={{location={mapzone="Feralas",x=44.6,y=10.5, dist=0.5}}},
			mapzone="Feralas",
			level=57,
			mapnote=10805570,
		}, {
			"Go to inside the stone building to "..cl(45,10),
			"	a. Click the Evoroot on the pedastool",
			"	b. Get an Evoroot",
			completion={{item={"Evoroot",1}}},
			mapzone="Feralas",
			level=57,
			mapnote=10805570,
		}, {
			"Go south to "..cl(45,26),
			"	a. Talk to Gregan Brewspewer",
			"		i. Turn in "..cq("The Videre Elixir"),
			completion={{item={"Videre Elixir",3}}},
			mapzone="Feralas",
			level=57,
			mapnote=25607070,
		}, {
			"Hearth to the Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Feralas",
			level=57,
		}, {
			"Fly to Emerald Sanctuary",
			completion={{location={mapzone="Felwood",x=51.1,y=81.6, dist=2}}},
			mapzone="The Barrens",
			level=57,
		}, {
			"Go to "..cl(51,82),
			"	a. Talk to Greta Mosshoof",
			"		i. Turn in "..cq("Forces of Jaedenar"),
			"		ii. Accept "..cq("Collection of the Corrupt Water"),
			completion={{questturnedin="Forces of Jaedenar"},{questaccepted="Collection of the Corrupt Water"}},
			mapzone="Felwood",
			level=57,
			mapnote=82113330,
		}, {
			"Also at "..cl(51,82),
			"	a. Talk to Taronn Redfeather",
			"		i. Turn in "..cq("Verifying the Corruption"),
			completion={{questturnedin="Verifying the Corruption"}},
			mapzone="Felwood",
			level=57,
			mapnote=81613250,
		}, {
			"Go west to "..cl(47,83),
			"	a. Talk to Maybess Riverbreeze",
			"		i. Turn in "..cq("Cleansing Felwood"),
			"	b. Talk to Maybess Riverbreeze",
			"		i. Get a Cenarion Beacon",
			completion={{questturnedin="Cleansing Felwood"},{item={"Cenarion Beacon",1}}},
			mapzone="Felwood",
			level=57,
			mapnote=83112990,
		}, {
			"Go southeast to "..cl(49,91),
			"	a. Kill furbolgs",
			"	b. Get 6 Corrupted Soul Shards",
			completion={{item={"Corrupted Soul Shard",6}}},
			mapzone="Felwood",
			level=57,
			mapnote=90813940,
		}, {
			"Go south to "..cl(48,94),
			"	a. Kill Overlord Ror",
			"	b. Get Overlord Ror's Claw",
			completion={{questgoal={"*","Overlord Ror's Claw",1}}},
			mapzone="Felwood",
			level=57,
			mapnote=94214250,
		}, {
			"Go north to "..cl(47,83),
			"	a. Talk to Maybess Riverbreeze",
			"		i. Turn in "..cq("Salve via Hunting"),
			completion={{questturnedin="Salve via Hunting"}},
			mapzone="Felwood",
			level=57,
			mapnote=83112990,
		}, {
			"Go northwest to "..cl(32,67),
			"	a. Use Hardened Flask in the small green pool of water",
			"	b. Get a Filled Flasket",
			completion={{questgoal={"*","Filled Flasket",1}}},
			mapzone="Felwood",
			level=57,
			mapnote=66509880,
		}, {
			"Go northeast to "..cl(35,60),
			"	a. Use your Empty Canteen in the small green pool of water",
			"	b. Get the Corrupt Moonwell Water",
			completion={{questgoal={"*","Corrupt Moonwell Water",1}}},
			mapzone="Felwood",
			level=57,
			mapnote=59809500,
		}, {
			"Go north to Bloodvenom Post",
			completion={{location={mapzone="Felwood",x=34.5,y=52.6, dist=3}}},
			mapzone="Felwood",
			level=57,
		}, {
			"Go to "..cl(34,52),
			"	a. Talk to Winna Hazzard",
			"		i. Turn in "..cq("Well of Corruption"),
			"		ii. Accept "..cq("Corrupted Sabers"),
			completion={{questturnedin="Well of Corruption"},{questaccepted="Corrupted Sabers"}},
			mapzone="Felwood",
			level=57,
			mapnote=52308650,
		}, {
			"Go to "..cl(35,53),
			"	a. Talk to Dreka'Sur",
			"		i. Turn in "..cq("A Husband's Last Battle"),
			completion={{questturnedin="A Husband's Last Battle"}},
			mapzone="Felwood",
			level=57,
			mapnote=52708750,
		}, {
			"Go south to "..cl(33,67),
			"	a. Use Winna's Kitten Courier near the green pool of water",
			"	b. Escort the cat back to Bloodvenom Post",
			completion={{questgoal={"*","Return the corrupted cat to Winna Hazzard",1}}},			
			mapzone="Felwood",
			level=57,
			mapnote=66609930,
		}, {
			"Go to "..cl(34,52),
			"	a. Talk to the cat",
			"	b. Release the corrupted saber to Winna",
			"	c. Talk to Winna Hazzard",
			"		i. Turn in "..cq("Corrupted Sabers"),
			completion={{questturnedin="Corrupted Sabers"}},
			mapzone="Felwood",
			level=57,
			mapnote=52308650,
		}, {
			"Fly to Emerald Sanctuary",
			completion={{location={mapzone="Felwood",x=51.1,y=81.6, dist=2}}},
			mapzone="Felwood",
			level=57,
		}, {
			"Go to "..cl(51,82),
			"	a. Talk to Greta Mosshoof",
			"		i. Turn in "..cq("Collection of the Corrupt Water"),
			completion={{questturnedin="Collection of the Corrupt Water"}},
			mapzone="Felwood",
			level=57,
			mapnote=82113330,
		}, {
			"Fly to Moonglade",
			completion={{location={mapzone="Moonglade"}}},
			mapzone="Felwood",
			level=57,
		}, {
			"Go northeast to Nighthaven",
			completion={{location={mapzone="Moonglade",x=48.9,y=39.1, dist=8}}},
			mapzone="Moonglade",
			level=57,
		}, {
			"Go to "..cl(52,45),
			"	a. Talk to Rabine Saturna",
			"		i. Turn in "..cq("Rabine Saturna"),
			"		ii. Accept "..cq("Wasteland"),
			completion={{questturnedin="Rabine Saturna"},{questaccepted="Wasteland"}},
			mapzone="Moonglade",
			level=57,
			mapnote=45109680,
		}, {
			"Fly to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Moonglade",
			level=57,
		}, {
			"Go to "..cl(61,39),
			"	a. Talk to Jessica Redpath",
			"		i. Accept "..cq("Sister Pamela"),
			"	b. Talk to Gregor Greystone",
			"		i. Accept "..cq("The Everlook Report"),
			"		ii. Accept "..cq("Duke Nicholas Zverenhoff"),
			completion={{questaccepted="Sister Pamela"},{questaccepted="The Everlook Report"},{questaccepted="Duke Nicholas Zverenhoff"}},
			mapzone="Winterspring",
			level=57,
			mapnote=39010030,
		}, {
			"Make Everlook your home",
			completion={{home="Everlook"}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Felnok Steelspring",
			"		i. Turn in "..cq("Felnok Steelspring"),
			"		ii. Accept "..cq("Chillwind Horns"),
			completion={{questturnedin="Felnok Steelspring"},{questaccepted="Chillwind Horns"}},
			mapzone="Winterspring",
			level=57,
			mapnote=38610020,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Umi Rumplesnicker",
			"		i. Accept "..cq("Are We There, Yeti? part 1"),
			completion={{questaccepted="Are We There, Yeti? part 1"}},
			mapzone="Winterspring",
			level=57,
			mapnote=37609850,
		}, {
			"Go west to "..cl(39,44),
			"	a. Kill 8 Winterfall Pathfinders",
			"	b. Kill 8 Winterfall Den Watchers",
			"	c. Kill 8 Winterfall Totemics",
			"	d. Get an Empty Firewater Flask",
			"	e. Click the Empty Firewater Flask",
			"		i. Accept "..cq("Winterfall Firewater"),
			completion={{questgoal={"*","Winterfall Pathfinder slain",8}},{questgoal={"*","Winterfall Den Watcher slain",8}},{questgoal={"*","Winterfall Totemic slain",8}},{questaccepted="Winterfall Firewater"}},
			mapzone="Winterspring",
			level=57,
			mapnote=43508270,
		}, {
			"Go west to "..cl(31,45),
			"	a. Talk to Donova Snowden",
			"		i. Turn in "..cq("The Videre Elixir"),
			"		ii. Accept "..cq("Meet at the Grave"),
			"		iii. Turn in "..cq("Threat of the Winterfall"),
			"		iv. Turn in "..cq("Winterfall Firewater"),
			completion={{questturnedin="The Videre Elixir"},{questturnedin="Threat of the Winterfall"},{questturnedin="Winterfall Firewater"},{questaccepted="Meet at the Grave"}},
			mapzone="Winterspring",
			level=57,
			mapnote=45207650,
		}, {
			"Go east to "..cl(65,42),
			"	a. Kill yetis",
			"	b. Get 10 Thick Yeti Furs",
			completion={{questgoal={"*","Thick Yeti Fur",10}}},
			mapzone="Winterspring",
			level=57,
			mapnote=41610630,
		}, {
			"Go northwest to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Umi Rumplesnicker",
			"		i. Turn in "..cq("Are We There, Yeti? part 1"),
			"		ii. Accept "..cq("Are We There. Yeti? part 2"),
			completion={{questturnedin="Are We There, Yeti? part 1"},{questaccepted="Are We There. Yeti? part 2"}},
			mapzone="Winterspring",
			level=57,
			mapnote=37609850,
		}, {
			"Go southeast to "..cl(66,43),
			"	a. Kill Ice Thistle Matriarchs",
			"	b. Kill Ice Thistle Patriarchs",
			"	c. Get 2 Pristine Yeti Horns",
			completion={{questgoal={"*","Pristine Yeti Horn",2}}},
			mapzone="Winterspring",
			level=57,
			mapnote=43010900,
		}, {
			"Go southwest to "..cl(60,74),
			"	a. Go to this spot to Discover Darkwhisper Gorge",
			completion={{questgoal={"*","Discover Darkwhisper Gorge",1}}},
			mapzone="Winterspring",
			level=57,
			mapnote=73513360,
		}, {
			"Hearth to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Umi Rumplesnicker",
			"		i. Turn in "..cq("Are We There. Yeti? part 2"),
			"		ii. Accept "..cq("Are We There, Yeti? part 3"),
			completion={{questturnedin="Are We There. Yeti? part 2"},{questaccepted="Are We There, Yeti? part 3"}},
			mapzone="Winterspring",
			level=57,
			mapnote=37609850,
		}, {
			"Go to "..cl(62,39),
			"	a. Use Umi's Mechanical Yeti on Legacki",
			"	b. Scare Legacki",
			completion={{questgoal={"*","Scare Legacki",1}}},
			mapzone="Winterspring",
			level=57,
			mapnote=38610010,
		}, {
			"Go northeast to "..cl(67,35),
			"	a. Kill 8 Winterfall Shamans",
			"	b. Kill 8 Winterfall Den Watchers (you have these from before)",
			"	c. Kill 8 Winterfall Ursas",
			completion={{questgoal={"*","Winterfall Shaman slain",8}},{questgoal={"*","Winterfall Den Watcher slain",8}},{questgoal={"*","Winterfall Ursa slain",8}}},
			mapzone="Winterspring",
			level=57,
			mapnote=35010200,
		}, {
			"Go west to "..cl(31,45),
			"	a. Talk to Donova Snowden",
			"		i. Turn in "..cq("Strange Sources"),
			completion={{questturnedin="Strange Sources"}},
			mapzone="Winterspring",
			level=57,
			mapnote=45207650,
		}, {
			"Go northwest to "..cl(28,35),
			"	a. Talk to Salfa",
			"		i. Turn in "..cq("Winterfall Activity"),
			completion={{questturnedin="Winterfall Activity"}},
			mapzone="Winterspring",
			level=57,
			mapnote=34506220,
		}, {
			"Grind to level 58",
			completion={{level=58}},
			mapzone="Winterspring",
			level=57,
		}, {
			"Go southeast to "..cl(38,39),
			"	a. Kill 15 Ragged Owlbeasts heading east",
			completion={{questgoal={"*","Ragged Owlbeast slain",15}}},
			mapzone="Winterspring",
			level=58,
			mapnote=38707720,
		}, {
			"Go northeast to "..cl(59,28),
			"	a. Kill 15 Raging Owlbeasts",
			completion={{questgoal={"*","Raging Owlbeast slain",15}}},
			mapzone="Winterspring",
			level=58,
			mapnote=28008730,
		}, {
			"Go northeast to "..cl(61,22),
			"	a. Kill Chillwind Ravagers",
			"	b. Get 8 Uncracked Chillwind Horns",
			completion={{questgoal={"*","Uncracked Chillwind Horn",8}}},
			mapzone="Winterspring",
			level=58,
			mapnote=22008300,
		}, {
			"Go south to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Winterspring",
			level=58,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Felnok Steelspring",
			"		i. Turn in "..cq("Chillwind Horns"),
			"		ii. Accept "..cq("Return to Tinkee"),
			completion={{questturnedin="Chillwind Horns"},{questaccepted="Return to Tinkee"}},
			mapzone="Winterspring",
			level=58,
			mapnote=38610020,
		}, {
			"Fly to Bloodvenom Post",
			completion={{location={mapzone="Felwood",x=34.5,y=52.6, dist=3}}},
			mapzone="Winterspring",
			level=58,
		}, {
			"Go to "..cl(35,53),
			"	a. Talk to Trull Failbaine",
			"		i. Turn in "..cq("Wild Guardians part 1"),
			completion={{questturnedin="Wild Guardians part 1"}},
			mapzone="Winterspring",
			level=58,
			mapnote=52708750,
		}, {
			"Fly to Gadgetzan",
			completion={{location={mapzone="Tanaris",x=51.7,y=27.8, dist=6}}},
			mapzone="Winterspring",
			level=58,
		}, {
			"Go to "..cl(51,27),
			"	a. Use Umi's Mechanical Yeti on Sprinkle",
			"	b. Scare Sprinkle",
			completion={{questgoal={"*","Scare Sprinkle",1}}},
			mapzone="Tanaris",
			level=58,
			mapnote=26907800,
		}, {
			"Go to "..cl(54,28),
			"	a. Drink a Videre Elixir",
			"	b. You will die",
			"	c. Release spirit, but DO NOT resurrect yet",
			mapzone="Tanaris",
			level=58,
			mapnote=28408250,
		}, {
			"As a spirit, go north to "..cl(54,23),
			"	a. Talk to Gaeriyan",
			"		i. Turn in "..cq("Meet at the Grave"),
			"		ii. Accept "..cq("A Grave Situation"),
			completion={{questturnedin="Meet at the Grave"},{questaccepted="A Grave Situation"}},
			mapzone="Tanaris",
			level=58,
			mapnote=23407740,
		}, {
			"Go south as a ghost to the graveyard",
			"	a. Resurrect now in the graveyard",
			mapzone="Tanaris",
			level=58,
		}, {
			"Go south to "..cl(54,29),
			"	a. Click the Conspicious Gravestone",
			"		i. Turn in "..cq("A Grave Situation"),
			"		ii. Accept "..cq("Linken's Sword"),
			completion={{questturnedin="A Grave Situation"},{questaccepted="Linken's Sword"}},
			mapzone="Tanaris",
			level=58,
			mapnote=29108290,
		}, {
			"Fly to Marshal's Refuge",
			completion={{location={mapzone="Un'Goro Crater",x=44.9,y=8.2, dist=3}}},
			mapzone="Tanaris",
			level=58,
		}, {
			"Go to "..cl(44,9),
			"	a. Use Umi's Mechanical Yeti on Quixxle",
			"	b. Scare Quixxil",
			completion={{questgoal={"*","Scare Quixxil",1}}},
			mapzone="Un'Goro Crater",
			level=58,
			mapnote=9405310,
		}, {
			"Go to "..cl(45,8),
			"	a. Talk to Linken",
			"		i. Turn in "..cq("Linken's Sword"),
			"		ii. Accept "..cq("A Gnome's Assistance"),
			completion={{questturnedin="Linken's Sword"},{questaccepted="A Gnome's Assistance"}},
			mapzone="Un'Goro Crater",
			level=58,
			mapnote=8105280,
		}, {
			"Go to "..cl(42,3),
			"	a. Talk to J.D. Collie",
			"		i. Turn in "..cq("A Gnome's Assistance"),
			"		ii. Accept "..cq("Linken's Memory"),
			completion={{questturnedin="A Gnome's Assistance"},{questaccepted="Linken's Memory"}},
			mapzone="Un'Goro Crater",
			level=58,
			mapnote=2704460,
		}, {
			"Go southwest to "..cl(29,22),
			"	a. The path over to Silithus starts here",
			completion={{location={mapzone="Un'Goro Crater",x=29.3,y=22.2, dist=0.5}}},
			mapzone="Un'Goro Crater",
			level=58,
			mapnote=22105130,
		}, {
			"Go west to Silithus",
			completion={{location={mapzone="Silithus"}}},
			mapzone="Un'Goro Crater",
			level=58,
		}, {
			"Go to "..cl(82,19),
			"	a. Talk to Layo Starstrike",
			"		i. Turn in "..cq("Wasteland"),
			completion={{questturnedin="Wasteland"}},
			mapzone="Silithus",
			level=58,
			mapnote=18810060,
		}, {
			"Go southwest to Cenarion Hold",
			completion={{location={mapzone="Silithus",x=50.4,y=36.5, dist=3}}},
			mapzone="Silithus",
			level=58,
		}, {
			"Go to "..cl(51,38),
			"	a. Talk to Wincaller Proudhorn",
			"		i. Turn in "..cq("Taking Back Silithus"),
			"		ii. Accept "..cq("Securing the Supply Lines"),
			completion={{questturnedin="Taking Back Silithus"},{questaccepted="Securing the Supply Lines"}},
			mapzone="Silithus",
			level=58,
			mapnote=38308950,
		}, {
			"Go to "..cl(52,39),
			"	a. Talk to Beetix Ficklespragg",
			"		i. Accept "..cq("Deadly Desert Venom"),
			completion={{questaccepted="Deadly Desert Venom"}},
			mapzone="Silithus",
			level=58,
			mapnote=38609030,
		}, {
			"Make Cenarion Hold your home",
			completion={{home="Cenarion Hold"}},
			mapzone="Silithus",
			level=58,
		}, {
			"Go to "..cl(50,37),
			"	a. Talk to Geologist Larksbane",
			"		i. Accept "..cq("The Twilight Mystery"),
			completion={{questaccepted="The Twilight Mystery"}},
			mapzone="Silithus",
			level=58,
			mapnote=37508720,
		}, {
			"Go to "..cl(49,37),
			"	a. Talk to Scout Bloodfist",
			"		i. Accept "..cq("Report to General Kirika"),
			completion={{questaccepted="Report to General Kirika"}},
			mapzone="Silithus",
			level=58,
			mapnote=36708570,
		}, {
			"Also at "..cl(49,37),
			"	a. Talk to Runk Windtamer",
			"		i. Get the Cenarion Hold Flight Path",
			completion={{flightpath="Cenarion Hold"}},
			mapzone="Silithus",
			level=58,
			mapnote=36708540,
		}, {
			"Go northeast to "..cl(54,31),
			"	a. Kill 15 Dredge Strikers",
			"	b. Kill Stonelash Scorpids",
			"	c. Kill Sand Skitterers",
			"	d. Get 8 Stonelash Scorpid Stingers",
			"	e. Get 8 Sand Skitterer Fangs",
			completion={{questgoal={"*","Dredge Striker slain",15}},{questgoal={"*","Stonelash Scorpid Stinger",8}},{questgoal={"*","Sand Skitterer Fang",8}}},
			mapzone="Silithus",
			level=58,
			mapnote=31008500,
		}, {
			"Go northwest to "..cl(25,10),
			"	a. Click Twilight Tablet Fragments",
			"	b. Get 8 Twilight Tablet Fragments",
			completion={{questgoal={"*","Twilight Tablet Fragment",8}}},
			mapzone="Silithus",
			level=58,
			mapnote=10003500,
		}, {
			"Hearth to Cenarion Hold",
			completion={{location={mapzone="Silithus",x=50.4,y=36.5, dist=3}}},
			mapzone="Silithus",
			level=58,
		}, {
			"Go to "..cl(52,39),
			"	a. Talk to Beetix Ficklespragg",
			"		i. Turn in "..cq("Deadly Desert Venom"),
			"		ii. Accept "..cq("Noggle's Last Hope"),
			completion={{questturnedin="Deadly Desert Venom"},{questaccepted="Noggle's Last Hope"}},
			mapzone="Silithus",
			level=58,
			mapnote=38609030,
		}, {
			"Go to "..cl(51,38),
			"	a. Talk to Windcaller Proudhorn",
			"		i. Turn in "..cq("Securing the Supply Lines"),
			"		ii. Accept "..cq("Stepping Up Security"),
			completion={{questturnedin="Securing the Supply Lines"},{questaccepted="Stepping Up Security"}},
			mapzone="Silithus",
			level=58,
			mapnote=38308950,
		}, {
			"Go to "..cl(50,37),
			"	a. Talk to Geologist Larksbane",
			"		i. Turn in "..cq("The Twilight Mystery"),
			"		ii. Accept "..cq("The Deserter"),
			completion={{questturnedin="The Twilight Mystery"},{questaccepted="The Deserter"}},
			mapzone="Silithus",
			level=58,
			mapnote=37508720,
		}, {
			"Go south to "..cl(55,60),
			"	a. Kill 20 Dredge Crushers",
			"	b. Kill Stonelash Pincers",
			"	c. Get 3 Stonelash Pincer Stingers",
			completion={{questgoal={"*","Dredge Crusher slain",20}},{questgoal={"*","Stonelash Pincer Stinger",3}}},
			mapzone="Silithus",
			level=58,
			mapnote=60011500,
		}, {
			"Go southeast to "..cl(67,70),
			"	a. Talk to Hermit Ortell",
			"		i. Turn in "..cq("The Deserter"),
			completion={{questturnedin="The Deserter"}},
			mapzone="Silithus",
			level=58,
			mapnote=69813700,
		}, {
			"Go southwest to "..cl(65,75),
			"	a. Kill Stonelash Flayers",
			"	b. Get 3 Stonelash Flayer Stingers",
			"	c. Kill Rock Stalkers",
			"	d. Get 3 Rock Stalker Fangs",
			completion={{questgoal={"*","Stonelash Flayer Stinger",3}},{questgoal={"*","Rock Stalker Fang",3}}},
			mapzone="Silithus",
			level=58,
			mapnote=75014000,
		}, {
			"Go northwest to "..cl(51,70),
			"	a. Talk to General Kirika",
			"		i. Turn in "..cq("Report to General Kirika"),
			completion={{questturnedin="Report to General Kirika"}},
			mapzone="Silithus",
			level=58,
			mapnote=69512020,
		}, {
			"Go north to Cenarion Hold",
			completion={{location={mapzone="Silithus",x=50.4,y=36.5, dist=3}}},
			mapzone="Silithus",
			level=58,
		}, {
			"Go to "..cl(51,38),
			"	a. Talk to Windcaller Proudhorn",
			"		i. Turn in "..cq("Stepping Up Security"),
			completion={{questturnedin="Stepping Up Security"}},
			mapzone="Silithus",
			level=58,
			mapnote=38308950,
		}, {
			"Go to "..cl(52,39),
			"	a. Talk to Beetix Ficklespragg",
			"		i. Turn in "..cq("Noggle's Last Hope"),
			completion={{questturnedin="Noggle's Last Hope"}},
			mapzone="Silithus",
			level=58,
			mapnote=38609030,
		}, {
			"Fly to Emerald Sanctuary",
			completion={{location={mapzone="Felwood",x=51.1,y=81.6, dist=2}}},
			mapzone="Silithus",
			level=58,
		}, {
			"Go to "..cl(51,82),
			"	a. Talk to Eridan Bluewind",
			"		i. Turn in "..cq("Linken's Memory"),
			completion={{questturnedin="Linken's Memory"}},
			mapzone="Felwood",
			level=58,
			mapnote=81613290,
		}, {
			"Grind to level 59",
			completion={{level=59}},
			mapzone="Felwood",
			level=58,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Felwood",
			level=59,
		}, {
			"Ride the boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=59,
		}, {
			"Fly to Flame Crest",
			completion={{location={mapzone="Burning Steppes",x=65.4,y=23.7, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=59,
		}, {
			"Go to "..cl(65,24),
			"	a. Talk to Tinkee Steamboil",
			"		i. Turn in "..cq("Return to Tinkee"),
			completion={{questturnedin="Return to Tinkee"}},
			mapzone="Burning Steppes",
			level=59,
			mapnote=23908910,
		}, {
			"Fly to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Burning Steppes",
			level=59,
		}, {
			"Go to "..cl(48,73),
			"	a. They look like 2 small pots with red and green liquid in them",
			"	b. Click the Testing Equipment on the small table next to Chemist Fuely",
			"	c. Click the Corrupt Tested Samples in your bags",
			"	d. Click the Un'Goro Tested Samples in your bags",
			"	e. Get 5 Corrupted Felwood Samples",
			"	f. Get 5 Pure Un'Goro Samples",
			completion={{questgoal={"*","Corrupted Felwood Sample",5}},{questgoal={"*","Pure Un'Goro Sample",5}}},
			mapzone="Undercity",
			level=59,
			mapnote=73112060,
		}, {
			"Go to "..cl(47,73),
			"	a. Talk to Chemist Fuely",
			"		i. Turn in "..cq("A Sample of Slime..."),
			"		ii. Turn in "..cq("... and a Batch of Ooze"),
			completion={{questturnedin="A Sample of Slime..."},{questturnedin="... and a Batch of Ooze"}},
			mapzone="Undercity",
			level=59,
			mapnote=73112060,
		}, {
			"Make Undercity your home",
			completion={{home="Undercity"}},
			mapzone="Undercity",
			level=59,
		}, {
			"Go outside of Undercity",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Undercity",
			level=59,
		}, {
			"Go east to "..cl(83,69),
			"	a. Talk to High Executor Derrington",
			"		i. Turn in "..cq("A Call to Arms: The Plaguelands!"),
			"		ii. Accept "..cq("Scarlet Diversions"),
			"	b. Click the Box of Incendiaries on the ground",
			"	c. Get a Flame in a Bottle",
			completion={{questturnedin="A Call to Arms: The Plaguelands!"},{questaccepted="Scarlet Diversions"},{item={"Flame in a Bottle",1}}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=68915200,
		}, {
			"Go to "..cl(83,68),
			"	a. Talk to Argent Officer Garush",
			"		i. Turn in "..cq("The Everlook Report"),
			"		ii. Turn in "..cq("Argent Dawn Commission"),
			completion={{questturnedin="The Everlook Report"},{item={"Argent Dawn Commission",1}}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=68515170,
		}, {
			"Equip the Argent Dawn Commission trinket in your bags",
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go south to "..cl(83,71),
			"	a. Talk to Mehlar Dawnblade",
			"		i. Accept "..cq("The So-Called Mark of the Lightbringer"),
			completion={{questaccepted="The So-Called Mark of the Lightbringer"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71315450,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Mickey Levine",
			"		i. Accept "..cq("A Plague Upon Thee part 1"),
			completion={{questaccepted="A Plague Upon Thee part 1"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=72315560,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go east to "..cl(38,54),
			"	a. Talk to Janice Felstone",
			"		i. Accept "..cq("Better Late Than Never part 1"),
			completion={{questaccepted="Better Late Than Never part 1"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=54109250,
		}, {
			"Go south inside the barn to "..cl(39,55),
			"	a. Click Janice's Parcel",
			"		i. Turn in "..cq("Better Late Than Never part 1"),
			"	b. Click Janice's Parcel again",
			"		i. Accept "..cq("Better Late Than Never part 2"),
			completion={{questturnedin="Better Late Than Never part 1"},{questaccepted="Better Late Than Never part 2"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=55309400,
		}, {
			"Go northeast to "..cl(41,52),
			"	a. Click the Command Tent",
			"	b. Burn the Command Tent",
			"	c. Click the Scourge Banner in your bags",
			"	d. Plant the Scourge Banner in the camp",
			completion={{questgoal={"*","Destroy the command tent and plant the Scourge banner in the camp",1}}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=51909260,
		}, {
			"Go west to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go to "..cl(83,69),
			"	a. Talk to High Executor Derrington",
			"		i. Turn in "..cq("Scarlet Diversions"),
			"		ii. Accept "..cq("All Along the Watchtowers"),
			"		iii. Accept "..cq("The Scourge Cauldrons"),
			completion={{questturnedin="Scarlet Diversions"},{questaccepted="All Along the Watchtowers"},{questaccepted="The Scourge Cauldrons"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=68915200,
		}, {
			"Go south to "..cl(83,72),
			"	a. Talk to Shadow Priestess Vandis",
			"		i. Turn in "..cq("The Scourge Cauldrons"),
			"		ii. Accept "..cq("Target: Felstone Field"),
			completion={{questturnedin="The Scourge Cauldrons"},{questaccepted="Target: Felstone Field"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71915490,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go east to "..cl(37,57),
			"	a. Kill Cauldron Lord Bilemaw",
			"	b. Get his Felstone Field Cauldron Key",
			"	c. Click the Scourge Cauldron",
			"		i. Turn in "..cq("Target: Felstone Field"),
			"		ii. Accept "..cq("Return to the Bulwark"),
			completion={{questturnedin="Target: Felstone Field"},{questaccepted="Return to the Bulwark"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=57209420,
		}, {
			"Go west to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Shadow Priestess Vandris",
			"		i. Turn in "..cq("Return to the Bulwark"),
			"		ii. Accept "..cq("Target: Dalson's Tears"),
			completion={{questturnedin="Return to the Bulwark"},{questaccepted="Target: Dalson's Tears"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71915490,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go east to "..cl(46,53),
			"	a. Kill Cauldron Lord Malvinious",
			"	b. Get his Dalson's Tears Cauldron Key",
			"	c. Click the Scourge Cauldron",
			"		i. Turn in "..cq("Target: Dalson's Tears"),
			"		ii. Accept "..cq("Return to the Bulwark"),
			completion={{questturnedin="Target: Dalson's Tears"},{questaccepted="Return to the Bulwark"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=52509870,
		}, {
			"Go west to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Shadow Priestess Vandis",
			"		i. Turn in "..cq("Return to the Bulwark"),
			"		ii. Accept "..cq("Target: Writhing Haunt"),
			completion={{questturnedin="Return to the Bulwark"},{questaccepted="Target: Writhing Haunt"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71915490,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go southeast to "..cl(53,66),
			"	a. Kill Cauldron Lord Razarch",
			"	b. Get his Writhing Haunt Cauldron Key",
			"	c. Click the Scourge Cauldron",
			"		i. Turn in "..cq("Target: Writhing Haunt"),
			"		ii. Accept "..cq("Return to the Bulwark"),
			completion={{questturnedin="Target: Writhing Haunt"},{questaccepted="Return to the Bulwark"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=66011900,
		}, {
			"Go northeast to "..cl(54,65),
			"	a. Talk to Mulgris Deepriver",
			"		i. Accept "..cq("The Wildlife Suffers Too"),
			completion={{questaccepted="The Wildlife Suffers Too"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=64711840,
		}, {
			"Go northwest to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Shadow Priestess Vandis",
			"		i. Turn in "..cq("Return to the Bulwark"),
			"		ii. Accept "..cq("Target: Gahrron's Withering"),
			completion={{questturnedin="Return to the Bulwark"},{questaccepted="Target: Gahrron's Withering"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71915490,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go east to "..cl(63,59),
			"	a. Kill Cauldron Lord Soulwrath",
			"	b. Get his Gahrron's Withering Cauldron Key",
			"	c. Click the Scourge Cauldron",
			"		i. Turn in "..cq("Target: Gahrron's Withering"),
			"		ii. Accept "..cq("Return to the Bulwark"),
			completion={{questturnedin="Target: Gahrron's Withering"},{questaccepted="Return to the Bulwark"}},
			mapzone="Western Plaguelands",
			level=59,
			mapnote=58912150,
		}, {
			"Go west to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Shadow Priestess Vandis",
			"		i. Turn in "..cq("Return to the Bulwark"),
			completion={{questturnedin="Return to the Bulwark"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=71915490,
		}, {
			"Go north to "..cl(83,69),
			"	a. Talk to High Executor Derrington",
			"		i. Turn in "..cq("Mission Accomplished!"),
			completion={{questturnedin="Mission Accomplished!"}},
			mapzone="Tirisfal Glades",
			level=59,
			mapnote=68915200,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=59,
		}, {
			"Go east to the Eastern Plaguelands",
			completion={{location={mapzone="Eastern Plaguelands"}}},
			mapzone="Western Plaguelands",
			level=59,
		}, {
			"Go north up the coast to "..cl(8,44),
			"	a. Talk to Tirion Fordring",
			"		i. Accept "..cq("Demon Dogs"),
			"		ii. Accept "..cq("Blood Tinged Skies"),
			"		iii. Accept "..cq("Carrion Grubbage"),
			completion={{questaccepted="Demon Dogs"},{questaccepted="Blood Tinged Skies"},{questaccepted="Carrion Grubbage"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=43605110,
		}, {
			"Go southeast to "..cl(27,75),
			"	a. Talk to Nathanos Blightcaller",
			"		i. Accept "..cq("To Kill With Purpose"),
			"		ii. Accept "..cq("Un-Life's Little Annoyances"),
			completion={{questaccepted="To Kill With Purpose"},{questaccepted="Un-Life's Little Annoyances"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=74710120,
		}, {
			"Go northeast to "..cl(35,68),
			"	a. Kill 20 Plaguehound Runts",
			"	b. Kill 30 Plaguebats",
			"	c. Kill Carrion Grubs",
			"	d. Get 15 Slabs of Worm Meat",
			completion={{questgoal={"*","Plaguehound Runt slain",20}},{questgoal={"*","Plaguebat slain",30}},{questgoal={"*","Slab of Carrion Worm Meat",15}}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=68010300,
		}, {
			"Go south to "..cl(36,91),
			"	a. Talk to Pamela Redpath",
			"		i. Turn in "..cq("Sister Pamela"),
			"		ii. Accept "..cq("Pamela's Doll"),
			completion={{questturnedin="Sister Pamela"},{questaccepted="Pamela's Doll"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=90812730,
		}, {
			"Go east to "..cl(39,92),
			"	a. The doll parts spawn in the house here, except the house Pamela is in",
			"	b. Get Pamela's Doll's Head",
			"	c. Get Pamela's Doll's Left Side",
			"	d. Get Pamela's Doll's Right Side",
			"	e. Put the doll parts together to make Pamela's Doll",
			completion={{questgoal={"*","Pamela's Doll",1}}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=92013100,
		}, {
			"Go west to "..cl(36,91),
			"	a. Talk to Pamela Redpath",
			"		i. Turn in "..cq("Pamela's Doll"),
			"		ii. Accept "..cq("Auntie Marlene"),
			"		iii. Accept "..cq("Uncle Carlin"),
			completion={{questturnedin="Pamela's Doll"},{questaccepted="Auntie Marlene"},{questaccepted="Uncle Carlin"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=90812730,
		}, {
			"Go northeast to "..cl(49,64),
			"	a. Kill 20 Noxious Plaguebats",
			"	b. Kill 5 Plaguehounds",
			completion={{questgoal={"*","Noxious Plaguebat slain",20}},{questgoal={"*","Plaguehound slain",5}}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=63811310,
		}, {
			"Go northeast to "..cl(80,57),
			"	a. Talk to Georgia",
			"		i. Get the Light's Hope Chapel Flight Path",
			completion={{flightpath="Light's Hope Chapel"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=57013720,
		}, {
			"Go to "..cl(81,60),
			"	a. Talk to Duke Nicholas Zverenhoff",
			"		i. Turn in "..cq("Duke Nicholas Zverenhoff"),
			"	b. Talk to Carlin Redpath",
			"		i. Turn in "..cq("Uncle Carlin"),
			"		ii. Accept "..cq("Defenders of Darrowshire"),
			completion={{questturnedin="Duke Nicholas Zverenhoff"},{questturnedin="Uncle Carlin"},{questaccepted="Defenders of Darrowshire"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=59814130,
		}, {
			"Go southwest to "..cl(80,64),
			"	a. Talk to Caretaker Alen",
			"		i. Accept "..cq("Zaeldarr the Outcast"),
			completion={{questaccepted="Zaeldarr the Outcast"}},
			mapzone="Eastern Plaguelands",
			level=59,
			mapnote=63914350,
		}, {
			"Grind to level 60",
			"	a. You have 2 options here. The guide continues to level you to halfway to level 61 using quests in Azeroth before going to Outland. This is to prevent you from having to grind half a level in Hellfire Peninsula in Outland. If you do not mind grinding half a level in Outland, or would prefer to run the Ramparts instance in Outland, you can do that if you wish whenever the guide tells you to grind half the level. If you would like to level using purely quests, continue following the guide.",
			completion={{level=60}},
			mapzone="Eastern Plaguelands",
			level=59,
		}, {
			"Go northwest to "..cl(63,48),
			"	a. Kill 5 Frenzied Plaguehounds",
			"	b. Kill 10 Monstrous Plaguebats",
			completion={{questgoal={"*","Frenzied Plaguehound slain",5}},{questgoal={"*","Monstrous Plaguebat slain",10}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=48011100,
		}, {
			"Go northwest to "..cl(38,32),
			"	a. Click the termite mounds",
			"	b. Get 100 Plagueland Termites",
			completion={{questgoal={"*","Plagueland Termites",100}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=32007000,
		}, {
			"Go northwest to "..cl(32,27),
			"	a. Kill mobs around this area",
			"	b. Get 7 Living Rot within 10 minutes",
			"	c. Click the Mortar and Pestle in your bags",
			"	d. Get a Coagulated Rot",
			completion={{questgoal={"*","Coagulated Rot",1}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=27205960,
		}, {
			"Go southwest to "..cl(30,30),
			"	a. Kill ghouls",
			"	b. Talk to the spirits that appear when they die",
			"	c. Free 15 Darrowshire Spirits",
			completion={{questgoal={"*","Darrowshire Spirits Freed",15}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=30006000,
		}, {
			"Hearth to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Eastern Plaguelands",
			level=60,
		}, {
			"Go to "..cl(70,43),
			"	a. Talk to Royal Overseer Bauhaus",
			"		i. Turn in "..cq("Better Late Than Never part 2"),
			"		ii. Accept "..cq("The Jeremiah Blues"),
			completion={{questturnedin="Better Late Than Never part 2"},{questaccepted="The Jeremiah Blues"}},
			mapzone="Undercity",
			level=60,
			mapnote=43111290,
		}, {
			"Go to "..cl(68,44),
			"	a. Talk to Jeremiah Payson",
			"		i. Turn in "..cq("The Jeremiah Blues"),
			"		ii. Accept "..cq("Good Luck Charm"),
			completion={{questturnedin="The Jeremiah Blues"},{questaccepted="Good Luck Charm"}},
			mapzone="Undercity",
			level=60,
			mapnote=44111170,
		}, {
			"Go outside of Undercity",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Undercity",
			level=60,
		}, {
			"Go southeast to "..cl(83,72),
			"	a. Talk to Mickey Levine",
			"		i. Turn in "..cq("A Plague Upon Thee part 1"),
			"		ii. Accept "..cq("A Plague Upon Thee part 2"),
			completion={{questturnedin="A Plague Upon Thee part 1"},{questaccepted="A Plague Upon Thee part 2"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=72315560,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=60,
		}, {
			"Go east to "..cl(38,54),
			"	a. Talk to Janice Felstone",
			"		i. Turn in "..cq("Good Luck Charm"),
			"		ii. Accept "..cq("Two Halves Become One"),
			completion={{questturnedin="Good Luck Charm"},{questaccepted="Two Halves Become One"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=54109250,
		}, {
			"Go west to "..cl(37,55),
			"	a. Kill a Jabbering Ghoul outside the house",
			"	b. Get the Good Luck Other-Half Charm",
			"	c. Click the Good Luck Other-Half Charm in your bags",
			"	d. Get the Good Luck Charm",
			completion={{questgoal={"*","Good Luck Charm",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=55009200,
		}, {
			"Go east to "..cl(38,54),
			"	a. Talk to Janice Felstone",
			"		i. Turn in "..cq("Two Halves Become One"),
			completion={{questturnedin="Two Halves Become One"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=54109250,
		}, {
			"Go east to "..cl(43,55),
			"	a. Kill 4 Diseased Wolves",
			completion={{questgoal={"*","Diseased Wolf slain",4}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=47009300,
		}, {
			"Go northeast to "..cl(46,47),
			"	a. Kill 4 Diseased Wolves",
			completion={{questgoal={"*","Diseased Wolf slain",4}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=55009800,
		}, {
			"Go southeast to "..cl(54,65),
			"	a. Talk to Mulgris Deepriver",
			"		i. Turn in "..cq("The Wildlife Suffers Too part 1"),
			"		ii. Accept "..cq("The Wildlife Suffers Too part 2"),
			completion={{questturnedin="The Wildlife Suffers Too part 1"},{questaccepted="The Wildlife Suffers Too part 2"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=64711840,
		}, {
			"Go northeast to "..cl(58,61),
			"	a. Kill 8 Diseased Grizzlies",
			completion={{questgoal={"*","Diseased Grizzly slain",8}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=61011900,
		}, {
			"Go southwest to "..cl(54,65),
			"	a. Talk to Mulgris Deepriver",
			"		i. Turn in "..cq("The Wildlife Suffers Too part 2"),
			completion={{questturnedin="The Wildlife Suffers Too part 2"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=64711840,
		}, {
			"Go southwest to "..cl(49,78),
			"	a. Talk to Marlene Redpath",
			"		i. Turn in "..cq("Auntie Marlene"),
			"		ii. Accept "..cq("A Strange Historian"),
			completion={{questturnedin="Auntie Marlene"},{questaccepted="A Strange Historian"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=78412730,
		}, {
			"Go northeast to "..cl(50,77),
			"	a. Click Joseph Redpath's Monument",
			"	b. Get Joseph's Wedding Ring",
			completion={{questgoal={"*","Joseph's Wedding Ring",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=76812650,
		}, {
			"Go northwest to "..cl(47,71),
			"	a. Use your Beacon Torch near the tower entrance",
			"	b. Mark Tower Four",
			completion={{questgoal={"*","Tower Four marked",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=71011770,
		}, {
			"Go west to "..cl(40,72),
			"	a. Use your Beacon Torch near the tower entrance",
			"	b. Mark Tower One",
			completion={{questgoal={"*","Tower One marked",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=71511160,
		}, {
			"Go north to "..cl(39,67),
			"	a. Talk to Chromie",
			"		i. Turn in "..cq("A Strange Historian"),
			"		ii. Accept "..cq("The Annals of Darrowshire"),
			"		iii. Accept "..cq("A Matter of Time"),
			completion={{questturnedin="A Strange Historian"},{questaccepted="The Annals of Darrowshire"},{questaccepted="A Matter of Time"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=66810630,
		}, {
			"Go southeast to "..cl(43,69),
			"	a. Click the Musty Tomes",
			"	b. Get the Annals of Darrowshire",
			completion={{questgoal={"*","Annals of Darrowshire",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=68911230,
		}, {
			"Go northwest to "..cl(42,66),
			"	a. Use your Beacon Torch near the tower entrance",
			"	b. Mark Tower Two",
			completion={{questgoal={"*","Tower Two marked",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=66210850,
		}, {
			"Go northeast to "..cl(44,63),
			"	a. Use your Beacon Torch near the tower entrance",
			"	b. Mark Tower Three",
			completion={{questgoal={"*","Tower Three marked",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=63410770,
		}, {
			"Go southeast to "..cl(47,66),
			"	a. Use your Temporal Displacer next to the disco ball towers",
			"	b. Kill 10 Temporal Parasites",
			completion={{questgoal={"*","Temporal Parasite slain",10}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=66011300,
		}, {
			"Go west to "..cl(39,67),
			"	a. Talk to Chromie",
			"		i. Turn in "..cq("The Annals of Darrowshire"),
			"		ii. Turn in "..cq("A Matter of Time"),
			"		iii. Accept "..cq("Counting Out Time"),
			"		iv. Accept "..cq("Brother Carlin"),
			completion={{questturnedin="The Annals of Darrowshire"},{questturnedin="A Matter of Time"},{questaccepted="Counting Out Time"},{questaccepted="Brother Carlin"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=66810630,
		}, {
			"Go southwest to "..cl(39,68),
			"	a. Click the Small Lockboxes on the ground in the crumbled houses",
			"	b. Get 5 Andorhal Watches",
			completion={{questgoal={"*","Andorhal Watch",5}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=68010700,
		}, {
			"Go northeast to "..cl(39,67),
			"	a. Talk to Chromie",
			"		i. Turn in "..cq("Counting Out Time"),
			completion={{questturnedin="Counting Out Time"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=66810630,
		}, {
			"Go northeast to the Eastern Plaguelands",
			completion={{location={mapzone="Eastern Plaguelands"}}},
			mapzone="Western Plaguelands",
			level=60,
		}, {
			"Go north along the coast to "..cl(8,44),
			"	a. Talk to Tirion Fordring",
			"		i. Turn in "..cq("Demon Dogs"),
			"		ii. Turn in "..cq("Blood Tinged Skies"),
			"		iii. Turn in "..cq("Carrion Grubbage"),
			"		iv. Accept "..cq("Redemption"),
			"		v. Listen to his story",
			"		vi. Turn in "..cq("Redemption"),
			"		vii. Accept "..cq("Of Forgotten Memories"),
			completion={{questturnedin="Demon Dogs"},{questturnedin="Blood Tinged Skies"},{questturnedin="Carrion Grubbage"},{questaccepted="Redemption"},{questturnedin="Redemption"},{questaccepted="Of Forgotten Memories"}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=43605110,
		}, {
			"Go southeast to "..cl(27,75),
			"	a. Talk to Nathanos Blightcaller",
			"		i. Turn in "..cq("To Kill With Purpose"),
			"		ii. Turn in "..cq("Un-Life's Little Annoyances"),
			completion={{questturnedin="To Kill With Purpose"},{questturnedin="Un-Life's Little Annoyances"}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=74710120,
		}, {
			"Go southeast to "..cl(28,87),
			"	a. Click the Loose Dirt Mound",
			"	b. Kill Mercutio",
			"	c. Get Taelan's Hammer",
			"	d. You may need help with this - if so, then find a group",
			completion={{questgoal={"*","Taelan's Hammer",1}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=86911520,
		}, {
			"Go northwest inside the crypt to "..cl(27,85),
			"	a. Kill Zaeldarr the Outcast",
			"	b. Get Zaeldarr's Head",
			completion={{questgoal={"*","Zaeldarr's Head",1}}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=84811230,
		}, {
			"Go northwest to "..cl(8,44),
			"	a. Talk to Tirion Fordring",
			"		i. Turn in "..cq("Of Forgotten Memories"),
			completion={{questturnedin="Of Forgotten Memories"}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=43605110,
		}, {
			"Go southeast to "..cl(80,64),
			"	a. Talk to Caretaker Alen",
			"		i. Turn in "..cq("Zaeldarr the Outcast"),
			completion={{questturnedin="Zaeldarr the Outcast"}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=63914350,
		}, {
			"Go northeast to "..cl(82,60),
			"	a. Talk to Carlin Redpath",
			"		i. Turn in "..cq("Defenders of Darrowshire"),
			"		ii. Turn in "..cq("Brother Carlin"),
			completion={{questturnedin="Defenders of Darrowshire"},{questturnedin="Brother Carlin"}},
			mapzone="Eastern Plaguelands",
			level=60,
			mapnote=59814130,
		}, {
			"Fly to Undercity",
			completion={{location={mapzone="Undercity"}}},
			mapzone="Eastern Plaguelands",
			level=60,
		}, {
			"Go outside of Undercity",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Undercity",
			level=60,
		}, {
			"Go southeast to "..cl(83,69),
			"	a. Talk to High Executor Derrington",
			"		i. Turn in "..cq("All Along the Watchtowers"),
			"		ii. Accept "..cq("Scholomance"),
			completion={{questturnedin="All Along the Watchtowers"},{questaccepted="Scholomance"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=68915200,
		}, {
			"Also at "..cl(83,69),
			"	a. Talk to Apothecary Dithers",
			"		i. Turn in "..cq("Scholomance"),
			"		ii. Accept "..cq("Skeletal Fragments"),
			completion={{questturnedin="Scholomance"},{questaccepted="Skeletal Fragments"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=69215250,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=60,
		}, {
			"Go northeast to "..cl(38,55),
			"	a. Kill skeletons",
			"	b. Get 15 Skeletal Fragments",
			completion={{questgoal={"*","Skeletal Fragments",15}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=54709230,
		}, {
			"Go northeast to "..cl(51,29),
			"	a. The path down to Kirsta Deepshadow starts here",
			"		i. Follow the path down",
			completion={{location={mapzone="Western Plaguelands",x=50.0,y=30.4, dist=0.5}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=29408000,
		}, {
			"Go northeast to "..cl(52,28),
			"	a. Talk to Kirsta Deepshadow",
			"		i. Accept "..cq("Unfinished Business part 1"),
			completion={{questaccepted="Unfinished Business part 1"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=28108000,
		}, {
			"Go south to "..cl(50,41),
			"	a. Kill 2 Scarlet Knights",
			"	b. Kill 2 Scarlet Mages",
			completion={{questgoal={"*","Scarlet Knight slain",2}},{questgoal={"*","Scarlet Mage slain",2}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=41009100,
		}, {
			"Go southeast to "..cl(51,44),
			"	a. Kill 2 Scarlet Hunters",
			"	b. Kill 2 Scarlet Medics",
			completion={{questgoal={"*","Scarlet Hunter slain",2}},{questgoal={"*","Scarlet Medic slain",2}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=44009500,
		}, {
			"Go north to "..cl(52,28),
			"	a. Talk to Kirsta Deepshadow",
			"		i. Turn in "..cq("Unfinished Business part 1"),
			"		ii. Accept "..cq("Unfinished Business part 2"),
			completion={{questturnedin="Unfinished Business part 1"},{questaccepted="Unfinished Business part 2"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=28108000,
		}, {
			"Go southeast to "..cl(55,35),
			"	a. The path up to Huntsman Radley starts here",
			"	b. Follow the path up",
			completion={{location={mapzone="Western Plaguelands",x=55.5,y=34.7, dist=0.5}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=34809030,
		}, {
			"Go southeast to "..cl(58,36),
			"	a. Kill Huntsman Radley",
			completion={{questgoal={"*","Huntsman Radley slain",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=36109390,
		}, {
			"Go north to "..cl(54,24),
			"	a. Kill Cavalier Durgen when he comes out in front of the tower",
			completion={{questgoal={"*","Cavalier Durgen slain",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=24007800,
		}, {
			"Also at "..cl(54,24),
			"	a. Go to the top of the tower",
			"	b. Click the small brown chest",
			"	c. Get the Mark of the Lightbringer",
			"	d. You may need help with this - if so, then find a group",
			completion={{questgoal={"*","Mark of the Lightbringer",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=23507870,
		}, {
			"Go southwest to "..cl(53,28),
			"	a. Jump off the cliff here to get down to Kirsta Deepshadow",
			completion={{location={mapzone="Western Plaguelands",x=53.4,y=28.6, dist=0.5}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=28508130,
		}, {
			"Go west to "..cl(52,28),
			"	a. Talk to Kirsta Deepshadow",
			"		i. Turn in "..cq("Unfinished Business part 2"),
			completion={{questturnedin="Unfinished Business part 2"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=28108000,
		}, {
			"Go southwest to "..cl(48,32),
			"	a. Click the Northridge Lumber Mill Crate",
			"	b. Place the Termite Barrel on the crate",
			"	c. Click the green smoking Termite Barrel",
			"		i. Turn in "..cq("A Plague Upon Thee part 2"),
			"		ii. Accept "..cq("A Plague Upon Thee part 3"),
			completion={{questturnedin="A Plague Upon Thee part 2"},{questaccepted="A Plague Upon Thee part 3"}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=32008040,
		}, {
			"Go southwest to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=60,
		}, {
			"Go to "..cl(83,71),
			"	a. Talk to Mehlar Dawnblade",
			"		i. Turn in "..cq("The So-Called Mark of the Lightbringer"),
			"		ii. Accept "..cq("Defiling Uther's Tomb"),
			completion={{questturnedin="The So-Called Mark of the Lightbringer"},{questaccepted="Defiling Uther's Tomb"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=71315450,
		}, {
			"Go to "..cl(83,72),
			"	a. Talk to Mickey Levine",
			"		i. Turn in "..cq("A Plague Upon Thee part 3"),
			completion={{questturnedin="A Plague Upon Thee part 3"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=72315560,
		}, {
			"Go north to "..cl(83,69),
			"	a. Talk to Apothecary Dither",
			"		i. Turn in "..cq("Skeletal Fragments"),
			completion={{questturnedin="Skeletal Fragments"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=69215250,
		}, {
			"Go east to the Western Plaguelands",
			completion={{location={mapzone="Western Plaguelands"}}},
			mapzone="Tirisfal Glades",
			level=60,
		}, {
			"Go southeast to "..cl(52,83),
			"	a. Equip the Corrupted Mark of the Lightbringer",
			"	b. Use the Corrupted Mark of the Lightbringer next to the statue",
			"	c. Defile Uther's Tomb",
			completion={{questgoal={"*","Uther's Tomb Defiled",1}}},
			mapzone="Western Plaguelands",
			level=60,
			mapnote=83513560,
		}, {
			"Go northwest to Tirisfal Glades",
			completion={{location={mapzone="Tirisfal Glades"}}},
			mapzone="Western Plaguelands",
			level=60,
		}, {
			"Go to "..cl(83,71),
			"	a. Talk to Mehlar Dawnblade",
			"		i. Turn in "..cq("Defiling Uther's Tomb"),
			completion={{questturnedin="Defiling Uther's Tomb"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=71315450,
		}, {
			"Go north to "..cl(83,68),
			"	a. Talk to Argent Officer Garush",
			"		i. Turn in "..cq("Minion's Scourgestones"),
			"		ii. Turn in any other Scourgestones you have",
			completion={{questturnedin="Minion's Scourgestones"}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=68515170,
		}, {
			"Go northwest to "..cl(61,59),
			"	a. Ride the zeppelin to Orgrimmar",
			completion={{location={mapzone="Durotar",x=50.8,y=13.2, dist=1}}},
			mapzone="Tirisfal Glades",
			level=60,
			mapnote=58811960,
		}, {
			"Go northwest to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="Durotar",
			level=60,
		}, {
			"Fly to Everlook",
			completion={{location={mapzone="Winterspring",x=61.2,y=38.3, dist=3}}},
			mapzone="Orgrimmar",
			level=60,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Umi Rumplesnicker",
			"		i. Turn in "..cq("Are We There, Yeti? part 3"),
			completion={{questturnedin="Are We There, Yeti? part 3"}},
			mapzone="Winterspring",
			level=60,
			mapnote=37609850,
		}, {
			"Grind until you are halfway to level 61",
			mapzone="Winterspring",
			level=60,
		}
	  },
	},
	{ sectiontitle = "Outlands (60-62)",
	  steps = {
		{
			"Go to the Blasted Lands",
			completion={{location={mapzone="Blasted Lands"}}},
			mapzone="Winterspring",
			level=60,
		}, {
			"Go to "..cl(58,56),
			"	a. Talk to Warlord Dar'toon",
			"		i. Accept "..cq("Through the Dark Portal"),
			completion={{questaccepted="Through the Dark Portal"}},
			mapzone="Blasted Lands",
			level=60,
			mapnote=56011410,
		}, {
			"Go into the big green portal to Outland",
			completion={{location={mapzone="Hellfire Peninsula"}}},
			mapzone="Blasted Lands",
			level=60,
		}, {
			"Go to "..cl(87,50),
			"	a. Talk to Lietenant General Orion",
			"		i. Turn in "..cq("Through the Dark Portal"),
			"		ii. Accept "..cq("Arrival in Outland"),
			completion={{questturnedin="Through the Dark Portal"},{questaccepted="Arrival in Outland"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=49813720,
		}, {
			"Go north to "..cl(87,48),
			"	a. Talk to Vlagga Freyfeather",
			"		i. Turn in "..cq("Arrival in Outland"),
			"		ii. Accept "..cq("Journey to Thrallmar"),
			completion={{questturnedin="Arrival in Outland"},{questaccepted="Journey to Thrallmar"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=48113540,
		}, {
			"Fly to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(56,37),
			"	a. Talk to General Krakork",
			"		i. Turn in "..cq("Journey to Thrallmar"),
			"		ii. Accept "..cq("Report to Nazgrel"),
			completion={{questturnedin="Journey to Thrallmar"},{questaccepted="Report to Nazgrel"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36809270,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Report to Nazgrel"),
			"		ii. Accept "..cq("Eradicate the Burning Legion"),
			completion={{questturnedin="Report to Nazgrel"},{questaccepted="Eradicate the Burning Legion"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009100,
		}, {
			"Also at "..cl(55,36),
			"	a. Talk to Vurtok Axebreaker",
			"		i. Accept "..cq("Bonechewer Blood"),
			completion={{questaccepted="Bonechewer Blood"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36409150,
		}, {
			"Go to "..cl(55,39),
			"	a. Talk to Megzeg Nukklebust",
			"		i. Accept "..cq("I Work... For the Horde!"),
			completion={{questaccepted="I Work... For the Horde!"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=38809400,
		}, {
			"Make Thrallmar your home",
			completion={{home="Thrallmar"}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go southeast to "..cl(58,41),
			"	a. Talk to Sergeant Shatterskull",
			"		i. Turn in "..cq("Eradicate the Burning Legion"),
			"		ii. Accept "..cq("Felspark Ravine"),
			completion={{questturnedin="Eradicate the Burning Legion"},{questaccepted="Felspark Ravine"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=41309930,
		}, {
			"Go northeast to "..cl(61,36),
			"	a. Kill 1 Dreadcaller",
			"	b. Kill 4 Flamewaker Imps",
			"	c. Kill 6 Infernal Warbringers",
			completion={{questgoal={"*","Dreadcaller slain",1}},{questgoal={"*","Flamewaker Imp slain",4}},{questgoal={"*","Infernal Warbringer slain",6}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=35909670,
		}, {
			"Go southwest to "..cl(58,41),
			"	a. Talk to Sergeant Shatterskull",
			"		i. Turn in "..cq("Felspark Ravine"),
			"		ii. Accept "..cq("Forward Base: Reaver's Fall"),
			completion={{questturnedin="Felspark Ravine"},{questaccepted="Forward Base: Reaver's Fall"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=41309930,
		}, {
			"Go southeast to "..cl(66,44),
			"	a. Talk to Forward Commander To'arch",
			"		i. Turn in "..cq("Forward Base: Reaver's Fall"),
			"		ii. Accept "..cq("Disrupt Their Reinforcements"),
			completion={{questturnedin="Forward Base: Reaver's Fall"},{questaccepted="Disrupt Their Reinforcements"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43610950,
		}, {
			"Go east to "..cl(71,45),
			"	a. Kill demons",
			"	b. Get 4 Demonic Rune Stones",
			"	c. Stand inside the portal",
			"	d. Click the portal",
			"	e. Disrupt Port Xilus",
			completion={{questgoal={"*","Disrupt Port Xilus",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=38711270,
		}, {
			"Go northeast to "..cl(74,39),
			"	a. Kill demons",
			"	b. Get 4 Demonic Rune Stones",
			"	c. Click the portal",
			"	d. Disrupt Port Kruul",
			completion={{questgoal={"*","Disrupt Port Kruul",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=45411620,
		}, {
			"Go southwest to "..cl(66,44),
			"	a. Talk to Forward Commander To'arch",
			"		i. Turn in "..cq("Disrupt Their Reinforcements"),
			"		ii. Accept "..cq("Mission: Gateways Murketh and Shaadraz"),
			completion={{questturnedin="Disrupt Their Reinforcements"},{questaccepted="Mission: Gateways Murketh and Shaadraz"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43610950,
		}, {
			"Also at "..cl(66,44),
			"	a. Talk to Wing Commander Brack",
			"		i. Take the flight",
			"		ii. Click the bomb in your bags, bomb Gateway Shaadraz",
			"		iii. Click the bomb in your bags, bomb Gateway Murketh",
			completion={{questgoal={"*","Gateway Murketh Destroyed",1}},{questgoal={"*","Gateway Shaadraz Destroyed",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43710980,
		}, {
			"Also at "..cl(66,44),
			"	a. Talk to Forward Commander To'arch",
			"		i. Turn in "..cq("Mission: Gateways Murketh and Shaadraz"),
			"		ii. Accept "..cq("Mission: The Abyssal Shelf"),
			"		iii. Accept "..cq("Return to Thrallmar"),
			completion={{questturnedin="Mission: Gateways Murketh and Shaadraz"},{questaccepted="Mission: The Abyssal Shelf"},{questaccepted="Return to Thrallmar"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43610950,
		}, {
			"Also at "..cl(66,44),
			"	a. Talk to Wing Commander Brack",
			"		i. Fly to the Abyssal Shelf",
			"		ii. Use the bomb in your bags to bomb the mobs",
			"		iii. Kill 20 Gan'arg Peons",
			"		iv. Kill 5 Mo'arg Overseers",
			"		v. Destroy 5 Fel Cannons",
			"		vi. If you don't complete this in the first run, you can keep flying until it's done",
			completion={{questgoal={"*","Gan'arg Peon slain",20}},{questgoal={"*","Mo'arg Overseer slain",5}},{questgoal={"*","Fel Cannon Destroyed",5}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43710980,
		}, {
			"Also at "..cl(66,44),
			"	a. Talk to Forward Commander To'arch",
			"		i. Turn in "..cq("Mission: The Abyssal Shelf"),
			completion={{questturnedin="Mission: The Abyssal Shelf"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43610950,
		}, {
			"Go northwest to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(55,39),
			"	a. Talk to Martik Tor'seldori",
			"		i. Accept "..cq("Falcon Watch"),
			completion={{questaccepted="Falcon Watch"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=39109430,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Return to Thrallmar"),
			"		ii. Accept "..cq("Forge Camp: Mageddon"),
			"		iii. Accept "..cq("The Assassin"),
			completion={{questturnedin="Return to Thrallmar"},{questaccepted="Forge Camp: Mageddon"},{questaccepted="The Assassin"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009100,
		}, {
			"Go northeast "..cl(64,30),
			"	a. Kill 10 Gan'arg Servants",
			"	b. Kill Razorsaw",
			"	c. Get the Head of Forgefiend Razorsaw",
			"	d. Get the Burning Legion Missive",
			"	e. Click the Burning Legion Missive",
			"		i. Accept "..cq("Vile Plans"),
			completion={{questgoal={"*","Gan'arg Servant slain",10}},{questgoal={"*","Head of Forgefiend Razorsaw",1}},{questaccepted="Vile Plans"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=29409300,
		}, {
			"Go southwest to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Forge Camp: Mageddon"),
			"		ii. Accept "..cq("Cannons of Rage"),
			completion={{questturnedin="Forge Camp: Mageddon"},{questaccepted="Cannons of Rage"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009100,
		}, {
			"Also at "..cl(55,36),
			"	a. Talk to Magister Bloodhawk",
			"		i. Turn in "..cq("Vile Plans"),
			completion={{questturnedin="Vile Plans"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009110,
		}, {
			"Go northeast to "..cl(57,31),
			"	a. Destroy 3 Fel Cannon MKI's",
			completion={{questgoal={"*","Fel Cannon MKI slain",3}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=31208870,
		}, {
			"Go southwest to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Cannons of Rage"),
			"		ii. Accept "..cq("Doorway to the Abyss"),
			completion={{questturnedin="Cannons of Rage"},{questaccepted="Doorway to the Abyss"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009100,
		}, {
			"Go northwest to "..cl(53,26),
			"	a. Kill Warbringer Arix'Amal",
			"	b. Get his Burning Legion Gate Key",
			completion={{questgoal={"*","Warbringer Arix'Amal slain",1}},{questgoal={"*","Burning Legion Gate Key",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=26407920,
		}, {
			"Go south to "..cl(53,28),
			"	a. Go inside the portal",
			"	b. Click the floating thing inside the portal",
			"	c. Close the Burning Legion Gate",
			completion={{questgoal={"*","Close Burning Legion Gate",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=27608070,
		}, {
			"Go southeast to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Doorway to the Abyss"),
			completion={{questturnedin="Doorway to the Abyss"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009100,
		}, {
			"Also at "..cl(55,36),
			"	a. Talk to Magister Bloodhawk",
			"		i. Accept "..cq("The Agony and the Darkness"),
			completion={{questaccepted="The Agony and the Darkness"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36009110,
		}, {
			"Go southeast to "..cl(59,45),
			"	a. Kill Bonechewer Orcs",
			"	b. Get 12 Bonechewer Blood",
			"	c. Get 8 Salvaged Metal",
			"	d. Get 8 Salvaged Wood",
			completion={{questgoal={"*","Bonechewer Blood",12}},{questgoal={"*","Salvaged Metal",8}},{questgoal={"*","Salvaged Wood",8}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=44910360,
		}, {
			"Go northwest to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(55,39),
			"	a. Talk to Megzeg Nukklebust",
			"		i. Turn in "..cq("I Work... For the Horde!"),
			"		ii. Accept "..cq("Burn It Up... For the Horde!"),
			completion={{questturnedin="I Work... For the Horde!"},{questaccepted="Burn It Up... For the Horde!"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=38809400,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Vurtok Axebreaker",
			"		i. Turn in "..cq("Bonechewer Blood"),
			"		ii. Accept "..cq("Apothecary Zelana"),
			completion={{questturnedin="Bonechewer Blood"},{questaccepted="Apothecary Zelana"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=36409150,
		}, {
			"Go southeast to "..cl(66,42),
			"	a. Talk to Apothecary Zelana",
			"		i. Turn in "..cq("Apothecary Zelana"),
			"		ii. Accept "..cq("Spinebreaker Post"),
			completion={{questturnedin="Apothecary Zelana"},{questaccepted="Spinebreaker Post"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=42010820,
		}, {
			"Go south 66,44 ",
			"	a. Talk to Wing Commander Brack",
			"		i. Fly to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=43710980,
		}, {
			"Go to "..cl(62,81),
			"	a. Talk to Amilya Airheart",
			"		i. Get the Spinebreaker Post Flight Path",
			completion={{flightpath="Spinebreaker Post"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81214290,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Ogath the Mad",
			"		i. Accept "..cq("The Warp Rifts"),
			completion={{questaccepted="The Warp Rifts"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81514340,
		}, {
			"Also at "..cl(62,82),
			"	a. Talk to Emissary Mordiba",
			"		i. Accept "..cq("Make Them Listen"),
			completion={{questaccepted="Make Them Listen"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714350,
		}, {
			"Go to "..cl(61,82),
			"	a. Talk to Apothecary Albreck",
			"		i. Turn in "..cq("Spinebreaker Post"),
			"		ii. Accept "..cq("Boiling Blood"),
			completion={{questturnedin="Spinebreaker Post"},{questaccepted="Boiling Blood"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81814290,
		}, {
			"Also at "..cl(61,82),
			"	a. Talk to Grelag",
			"		i. Accept "..cq("Preparing the Salve"),
			completion={{questaccepted="Preparing the Salve"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714260,
		}, {
			"Go to "..cl(61,81),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("Wanted: Worg Master Kruush"),
			completion={{questaccepted="Wanted: Worg Master Kruush"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=80614180,
		}, {
			"Go north to "..cl(61,78),
			"	a. They look like green plants on the ground",
			"	b. Click the Hellfire Spineleaves",
			"	c. Get 12 Hellfire Spineleaves",
			completion={{questgoal={"*","Hellfire Spineleaf",12}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=78313910,
		}, {
			"Go west to "..cl(58,79),
			"	a. Kill 12 Unyielding Footmen",
			"	b. Kill 8 Unyielding Knights",
			"	c. Kill 6 Unyielding Sorcerers",
			"	d. Kill Unyielding Mobs",
			"	e. Get A Mysterious Tome",
			"	f. Click the Mysterious Tome",
			"		i. Accept "..cq("Decipher the Tome"),
			completion={{questgoal={"*","Unyielding Footman slain",12}},{questgoal={"*","Unyielding Knight slain",8}},{questgoal={"*","Unyielding Sorcerer slain",6}},{questaccepted="Decipher the Tome"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=79013700,
		}, {
			"Go southeast to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(61,82),
			"	a. Talk to Grelag",
			"		i. Turn in "..cq("Preparing the Salve"),
			"		ii. Accept "..cq("Investigate the Crash"),
			completion={{questturnedin="Preparing the Salve"},{questaccepted="Investigate the Crash"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714260,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Althen the Historian",
			"		i. Turn in "..cq("Decipher the Tome"),
			"		ii. Accept "..cq("The Battle Horn"),
			"	b. Talk to Emissary Mordiba",
			"		i. Turn in "..cq("Make Them Listen"),
			completion={{questturnedin="Decipher the Tome"},{questturnedin="Make Them Listen"},{questaccepted="The Battle Horn"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714350,
		}, {
			"Go southwest to "..cl(55,84),
			"	a. Kill Lieutenant Commander Thalvos",
			"	b. Get the Unyielding Battle Horn",
			completion={{questgoal={"*","Unyielding Battle Horn",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=83713840,
		}, {
			"Go northeast to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Althen the Historian",
			"		i. Turn in "..cq("The Battle Horn"),
			"		ii. Accept "..cq("Bloody Vengeance"),
			completion={{questturnedin="The Battle Horn"},{questaccepted="Bloody Vengeance"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714350,
		}, {
			"Go northeast to "..cl(63,78),
			"	a. Click the Unyielding Battle Horn in your bags",
			"	b. Kill Urtrak",
			completion={{questgoal={"*","Urtrak slain",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=77614110,
		}, {
			"Go southwest to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Althen the Historian",
			"		i. Turn in "..cq("Bloody Vengeance"),
			"		ii. Accept "..cq("Honor the Fallen"),
			completion={{questturnedin="Bloody Vengeance"},{questaccepted="Honor the Fallen"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81714350,
		}, {
			"Go northwest to "..cl(57,77),
			"	a. Talk to Commander Hogarth",
			"		i. Turn in "..cq("Honor the Fallen"),
			completion={{questturnedin="Honor the Fallen"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=77413430,
		}, {
			"Go northeast to "..cl(64,74),
			"	a. Kill Bleeding Hollow Orcs",
			"	b. Get 12 Bleeding Hollow Blood",
			completion={{item={"Bleeding Hollow Blood",12}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74013800,
		}, {
			"Go northeast "..cl(65,71),
			"	a. Click the big red glowing cauldron 12 times",
			"	b. Get 12 Boiled Blood",
			"	c. Each time you click the cauldron, scarabs will run out",
			"	d. Run away and stand away from the cauldron until the scarabs disappear",
			completion={{questgoal={"*","Boiled Blood",12}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=71213640,
		}, {
			"Go southeast to "..cl(68,73),
			"	a. Kill Worg Master Kruush",
			"	b. Get the Worg Master's Head",
			completion={{questgoal={"*","Worg Master's Head",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=73614200,
		}, {
			"Go southwest to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(61,81),
			"	a. Talk to Captain Darkhowl",
			"		i. Turn in "..cq("Wanted: Worg Master Kruush"),
			"		ii. Accept "..cq("Zeth'Gor Must Burn!"),
			completion={{questturnedin="Wanted: Worg Master Kruush"},{questaccepted="Zeth'Gor Must Burn!"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81314250,
		}, {
			"Go to "..cl(61,82),
			"	a. Talk to Apothecary Albreck",
			"		i. Turn in "..cq("Boiling Blood"),
			"		ii. Accept "..cq("Apothecary Antonivich"),
			completion={{questturnedin="Boiling Blood"},{questaccepted="Apothecary Antonivich"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81814290,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Zezzak",
			"		i. Accept "..cq("The Eyes of Grillok"),
			completion={{questaccepted="The Eyes of Grillok"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81914360,
		}, {
			"Go northeast to "..cl(66,74),
			"	a. Use Zezzak's Shard on an Eye of Grillok to absorb it",
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74014040,
		}, {
			"Go southwest to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(62,82),
			"	a. Stand next to the cauldron",
			"	b. Return the Eye of Grillok",
			"	c. Talk to Zezzak",
			"		i. Turn in "..cq("The Eyes of Grillok"),
			"		ii. Accept "..cq("Grillok 'Darkeye'"),
			completion={{questturnedin="The Eyes of Grillok"},{questaccepted="Grillok 'Darkeye'"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81914360,
		}, {
			"Go northeast to "..cl(67,71),
			"	a. Go inside the cave",
			"	b. Kill Grillok "..cq("Darkeye"),
			"	c. Get Grillok's Eyepatch",
			completion={{questgoal={"*","Grillok's Eyepatch",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=71413800,
		}, {
			"Go northeast to "..cl(69,70),
			"	a. Kill 5 Bleeding Hollow Peons",
			"	b. Get 5 Bleeding Hollow Torches",
			"	c. Click the torches in your bags next to the forge",
			"	d. Get 5 Burning Bleeding Hollow Torches",
			completion={{item={"Burning Bleeding Hollow Torch",5}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=69813850,
		}, {
			"Go southeast to "..cl(70,70),
			"	a. Stand near the Eastern Hovel",
			"	b. Click a Burning Bleeding Hollow Torch",
			"	c. Burn the Eastern Hovel",
			completion={{questgoal={"*","Eastern Hovel Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=70213970,
		}, {
			"Go southwest to "..cl(69,73),
			"	a. Stand near the Stable",
			"	b. Click a Burning Bleeding Hollow Torch in your bags",
			"	c. Burn the Stable",
			completion={{questgoal={"*","Stable Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=72914150,
		}, {
			"Go southwest to "..cl(67,75),
			"	a. Stand near the Western Hovel",
			"	b. Click a Burning Bleeding Hollow Torch in your bags",
			"	c. Burn the Western Hovel",
			completion={{questgoal={"*","Western Hovel Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=75514310,
		}, {
			"Go southeast to "..cl(69,76),
			"	a. Stand near the Barracks",
			"	b. Click a Burning Bleeding Hollow Torch in your bags",
			"	c. Burn the Barracks",
			completion={{questgoal={"*","Barracks Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=76414520,
		}, {
			"Go southwest to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go to "..cl(61,81),
			"	a. Talk to Captain Darkhowl",
			"		i. Turn in "..cq("Zeth'Gor Must Burn!"),
			completion={{questturnedin="Zeth'Gor Must Burn!"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81314250,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Zezzak",
			"		i. Turn in "..cq("Grillok 'Darkeye'"),
			completion={{questturnedin="Grillok 'Darkeye'"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81914360,
		}, {
			"Go northwest to "..cl(49,75),
			"	a. Talk to 'Screaming' Screed Luckheed",
			"		i. Turn in "..cq("Investigate the Crash"),
			"		ii. Accept "..cq("In Case of Emergency..."),
			"	b. Talk to Legassi",
			"		i. Accept "..cq("Ravager Egg Roundup"),
			completion={{questturnedin="Investigate the Crash"},{questaccepted="In Case of Emergency..."},{questaccepted="Ravager Egg Roundup"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74812400,
		}, {
			"Go northeast to "..cl(58,71),
			"	a. Click Zeppelin Debris on the ground around this area",
			"	b. Get 30 pieces of Zeppelin Debris",
			completion={{questgoal={"*","Zeppelin Debris",30}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=71312940,
		}, {
			"Go southwest to "..cl(49,75),
			"	a. Talk to 'Screaming' Screed Luckheed",
			"		i. Turn in "..cq("In Case of Emergency..."),
			"		ii. Accept "..cq("Voidwalkers Gone Wild"),
			completion={{questturnedin="In Case of Emergency..."},{questaccepted="Voidwalkers Gone Wild"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74812400,
		}, {
			"Go south to "..cl(49,82),
			"	a. Kill voidwalkers",
			"	b. Get 10 Condensed Voidwalker Essences",
			completion={{questgoal={"*","Condensed Voidwalker Essence",10}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=81813130,
		}, {
			"Go southwest to "..cl(47,83),
			"	a. Use your Unstable Warp Rift Generator under the big black ball of lightning",
			"	b. Click the Unstable Warp Rift Generator and place the green circle under the big black ball of lightning",
			"	c. Kill Unstable Voidwalkers",
			"	d. Get 3 Warp Nethers",
			completion={{questgoal={"*","Warp Nether",3}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=83112990,
		}, {
			"Go west to "..cl(41,84),
			"	a. Click Ravenger Eggs",
			"	b. Kill Razorfury Ravagers",
			"	c. Get 12 Ravager Eggs",
			completion={{questgoal={"*","Ravager Egg",12}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=84412560,
		}, {
			"Go northeast to "..cl(49,75),
			"	a. Talk to 'Screaming' Screed Luckheed",
			"		i. Turn in "..cq("Voidwalkers Gone Wild"),
			"	b. Talk to Legassi",
			"		i. Turn in "..cq("Ravager Egg Roundup"),
			"		ii. Accept "..cq("Helboar, the Other White Meat"),
			completion={{questturnedin="Voidwalkers Gone Wild"},{questturnedin="Ravager Egg Roundup"},{questaccepted="Helboar, the Other White Meat"}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74812400,
		}, {
			"Go east to "..cl(50,75),
			"	a. Kill Helboars",
			"	b. Get Tainted Helboar Meat",
			"	c. Use your Purification Mixture on the Tainted Helboar Meat",
			"	d. Get 8 Purified Helboar Meat",
			"	e. The meat won't become purified every time, it can become toxic as well",
			completion={{questgoal={"*","Purified Helboar Meat",8}}},
			mapzone="Hellfire Peninsula",
			level=60,
			mapnote=74812500,
		}, {
			"Grind to level 61",
			completion={{level=61}},
			mapzone="Hellfire Peninsula",
			level=60,
		}, {
			"Go northwest to "..cl(48,66),
			"	a. Kill Crust Bursters",
			"	b. Get an Eroded Leather Case",
			"	c. Click the Eroded Leather Case",
			"		i. Accept "..cq("Missing Missive"),
			completion={{questaccepted="Missing Missive"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65811360,
		}, {
			"Go southeast to "..cl(49,75),
			"	a. Talk to Legassi",
			"		i. Turn in "..cq("Helboar, the Other White Meat"),
			"		ii. Accept "..cq("Smooth as Butter"),
			completion={{questturnedin="Helboar, the Other White Meat"},{questaccepted="Smooth as Butter"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=74812400,
		}, {
			"Go northeast to "..cl(62,67),
			"	a. Kill vultures",
			"	b. Get 12 Plump Buzzard Wings",
			completion={{questgoal={"*","Plump Buzzard Wing",12}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=67312990,
		}, {
			"Go southwest to "..cl(49,75),
			"	a. Talk to Legassi",
			"		i. Turn in "..cq("Smooth as Butter"),
			completion={{questturnedin="Smooth as Butter"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=74812400,
		}, {
			"Go southeast to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Ogath the Mad",
			"		i. Turn in "..cq("The Warp Rifts"),
			"		ii. Accept "..cq("Void Ridge"),
			completion={{questturnedin="The Warp Rifts"},{questaccepted="Void Ridge"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=81514340,
		}, {
			"Go northeast to "..cl(71,67),
			"	a. The path over to 'Void Ridge' starts here",
			completion={{location={mapzone="Hellfire Peninsula",x=71.3,y=67.4, dist=0.5}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=67413870,
		}, {
			"Go east to "..cl(75,66),
			"	a. Kill Voidwalkers",
			"	b. Get 40 Void Ridge Soul Shards",
			completion={{questgoal={"*","Void Ridge Soul Shard",40}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=66314170,
		}, {
			"Go southwest to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Ogath the Mad",
			"		i. Turn in "..cq("Void Ridge"),
			"		ii. Accept "..cq("From the Abyss"),
			completion={{questturnedin="Void Ridge"},{questaccepted="From the Abyss"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=81514340,
		}, {
			"Go northeast to "..cl(71,67),
			"	a. The path over to 'Void Ridge' start here",
			completion={{location={mapzone="Hellfire Peninsula",x=71.3,y=67.4, dist=0.5}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=67413870,
		}, {
			"Go southeast to "..cl(81,79),
			"	a. Stand next to the 2 big pink crystals",
			"	b. Click the Warp Rift Generator in  your bags",
			"	c. Kill Void Baron Galaxis",
			"	d. Get the Galaxis Soul Shard",
			completion={{questgoal={"*","Galaxis Soul Shard",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=78916000,
		}, {
			"Hearth to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(52,36),
			"	a. Talk to Apothecary Antonivich",
			"		i. Turn in "..cq("Apothecary Antonivich"),
			"		ii. Accept "..cq("A Burden of Souls"),
			completion={{questturnedin="Apothecary Antonivich"},{questaccepted="A Burden of Souls"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=36508880,
		}, {
			"Go north to "..cl(51,31),
			"	a. Talk to Foreman Razelcraz",
			"		i. Accept "..cq("Outland Sucks!"),
			completion={{questaccepted="Outland Sucks!"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Go southwest to "..cl(49,35),
			"	a. Click the Shredder Parts boxes",
			"	b. Get 6 Shredder Spare Parts",
			completion={{questgoal={"*","Shredder Spare Parts",6}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=35408430,
		}, {
			"Go southwest to "..cl(46,40),
			"	a. Kill 20 Shattered Hand Orcs",
			"	b. Reap 20 Shattered Hand Souls",
			completion={{questgoal={"*","Shattered Hand Souls Reaped",20}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=39808570,
		}, {
			"Go northeast to "..cl(51,30),
			"	a. Talk to Foreman Razelcraz",
			"		i. Turn in "..cq("Outland Sucks!"),
			"		ii. Accept "..cq("How to Serve Goblins"),
			completion={{questturnedin="Outland Sucks!"},{questaccepted="How to Serve Goblins"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Go southeast to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(52,36),
			"	a. Talk to Apothecary Antonivich",
			"		i. Turn in "..cq("A Burden of Souls"),
			"		ii. Accept "..cq("The Demoniac Scryer"),
			completion={{questturnedin="A Burden of Souls"},{questaccepted="The Demoniac Scryer"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=36508880,
		}, {
			"Go southeast to "..cl(45,41),
			"	a. Click Manni's Cage",
			"	b. Save Manni",
			completion={{questgoal={"*","Manni Saved",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=41008610,
		}, {
			"Go southeast to "..cl(46,45),
			"	a. Click Moh's Cage",
			"	b. Save Moh",
			completion={{questgoal={"*","Moh Saved",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=45209170,
		}, {
			"Go southeast to "..cl(47,46),
			"	a. Click Jakk's Cage",
			"	b. Save Jakk",
			completion={{questgoal={"*","Jakk Saved",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=46609410,
		}, {
			"Go west to "..cl(45,47),
			"	a. Use your Demoniac Scryer in this spot",
			"	b. Defend the Demoniac Scryer until a bunch of purple things start swirling around it",
			"	c. Talk to the Demoniac Scryer",
			"	d. Get the Demoniac Scryer Reading",
			completion={{questgoal={"*","Demoniac Scryer Reading",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=47209270,
		}, {
			"Hearth to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(52,36),
			"	a. Talk to Apothecary Antonivich",
			"		i. Turn in "..cq("The Demoniac Scryer"),
			"		ii. Accept "..cq("Report to Nazgrel"),
			completion={{questturnedin="The Demoniac Scryer"},{questaccepted="Report to Nazgrel"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=36508880,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("Report to Nazgrel"),
			completion={{questturnedin="Report to Nazgrel"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=36009100,
		}, {
			"Go northwest to "..cl(51,30),
			"	a. Talk to Forman Razelcraz",
			"		i. Turn in "..cq("How to Serve Goblins"),
			"		ii. Accept "..cq("Shizz Work"),
			completion={{questturnedin="How to Serve Goblins"},{questaccepted="Shizz Work"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Use the Felhound Whistle while standing next to and targeting Forman Razelcraz",
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Go northwest to "..cl(50,29),
			"	a. Kill Deranged Helboars",
			"	b. The Fel Guard Hound will eat the corpses and poop",
			"	c. Click the Felhound Poo",
			"	d. Get the Shredder Keys",
			completion={{questgoal={"*","Shredder Keys",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=29307920,
		}, {
			"Go southeast to "..cl(51,30),
			"	a. Talk to Foreman Razelcraz",
			"		i. Turn in "..cq("Shizz Work"),
			"		ii. Accept "..cq("Beneath Thrallmar"),
			completion={{questturnedin="Shizz Work"},{questaccepted="Beneath Thrallmar"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Go to inside the mine to "..cl(54,31),
			"	a. Kill Urga'zz",
			completion={{questgoal={"*","Urga'zz slain",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=31408580,
		}, {
			"Leave the mine",
			completion={{location={mapzone="Hellfire Peninsula",x=51.4,y=31.8, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(51,30),
			"	a. Talk to Foreman Razelcraz",
			"		i. Turn in "..cq("Beneath Thrallmar"),
			completion={{questturnedin="Beneath Thrallmar"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=30608200,
		}, {
			"Go southeast to "..cl(61,52),
			"	a. Click the Flaming Torch in your bags near the huge tank",
			"	b. Burn the Eastern Cannon",
			completion={{questgoal={"*","Eastern Cannon Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=52311340,
		}, {
			"Go west to "..cl(55,54),
			"	a. Click the Flaming Torch in your bags near the huge tank",
			"	b. Burn the Western Cannon",
			completion={{questgoal={"*","Western Cannon Burned",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=54010900,
		}, {
			"Go southeast to Spinebreaker Post",
			completion={{location={mapzone="Hellfire Peninsula",x=61.4,y=81.4, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(62,82),
			"	a. Talk to Ogath the Mad",
			"		i. Turn in "..cq("From the Abyss"),
			completion={{questturnedin="From the Abyss"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=81514340,
		}, {
			"Fly to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(55,39),
			"	a. Talk to Megzeg Nukklebust",
			"		i. Turn in "..cq("Burn It Up... For the Horde!"),
			completion={{questturnedin="Burn It Up... For the Horde!"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=38809400,
		}, {
			"Go west to "..cl(34,44),
			"	a. Click the Fel Orc Corpse",
			"		i. Turn in "..cq("The Assassin"),
			"		ii. Accept "..cq("A Strange Weapon"),
			completion={{questturnedin="The Assassin"},{questaccepted="A Strange Weapon"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=43507710,
		}, {
			"Go southwest to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(26,60),
			"	a. Talk to Magistrix Carinda",
			"		i. Accept "..cq("Arelion's Journal"),
			completion={{questaccepted="Arelion's Journal"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308670,
		}, {
			"Go to "..cl(27,60),
			"	a. Talk to Apothecary Azethen",
			"		i. Accept "..cq("Source of the Corruption"),
			completion={{questaccepted="Source of the Corruption"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59708650,
		}, {
			"Also at "..cl(27,60),
			"	a. Talk to Ryathen the Somber",
			"		i. Accept "..cq("In Need of Felblood"),
			completion={{questaccepted="In Need of Felblood"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59508650,
		}, {
			"Also at "..cl(27,60),
			"	a. Talk to Arcanist Calesthris Dawnstar",
			"		i. Accept "..cq("Magic of the Arakkoa"),
			completion={{questaccepted="Magic of the Arakkoa"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59808690,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Falconer Drenna Riverwind",
			"		i. Accept "..cq("Trueflight Arrows"),
			"		ii. Accept "..cq("Birds of a Feather"),
			"		iii. Accept "..cq("Helping the Cenarion Post"),
			completion={{questaccepted="Trueflight Arrows"},{questaccepted="Birds of a Feather"},{questaccepted="Helping the Cenarion Post"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308800,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Innalia",
			"		i. Get the Falcon Watch Flight Path",
			completion={{flightpath="Falcon Watch"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60008780,
		}, {
			"Go inside the building next to the Flight Path",
			"	a. Click the Orb of Translocation to go to the top of the tower",
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60208870,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Ranger Captain Venn'ren",
			"		i. Turn in "..cq("Falcon Watch"),
			"		ii. Accept "..cq("The Great Fissure"),
			"		iii. Accept "..cq("Report to Zurai"),
			completion={{questturnedin="Falcon Watch"},{questaccepted="The Great Fissure"},{questaccepted="Report to Zurai"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60208870,
		}, {
			"Click the Orb of Translocation to go to the bottom of the tower",
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go northeast to "..cl(30,54),
			"	a. Kill Bonestripper Vultures",
			"	b. Get 8 Bonestripper Tail Feathers",
			completion={{questgoal={"*","Bonestripper Tail Feather",8}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=54008420,
		}, {
			"Go northeast to "..cl(40,37),
			"	a. Click Arelion's Knapsack",
			"		i. Get Arelion's Knapsack",
			"		ii. Click Arelion's Knapsack in your bags",
			"		ii. Get Arelion's Journal",
			completion={{questgoal={"*","Arelion's Journal",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=37207730,
		}, {
			"Go northwest to "..cl(39,36),
			"	a. Kill 10 Terrorfiends",
			"	b. Kill Terrorfiends",
			"	c. Get 6 Felblood Samples",
			completion={{questgoal={"*","Terrorfiend slain",10}},{questgoal={"*","Felblood Sample",6}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=36107550,
		}, {
			"Go southwest to "..cl(35,57),
			"	a. Kill 8 Stonescythe Whelps",
			"	b. Kill 3 Stonescythe Alphas",
			completion={{questgoal={"*","Stonescythe Whelp slain",8}},{questgoal={"*","Stonescythe Alpha slain",3}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=57409290,
		}, {
			"Go west to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(26,60),
			"	a. Talk to Magistrix Carinda",
			"		i. Turn in "..cq("Arelion's Journal"),
			"		ii. Accept "..cq("Arelion's Secret"),
			completion={{questturnedin="Arelion's Journal"},{questaccepted="Arelion's Secret"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308670,
		}, {
			"Go to "..cl(27,60),
			"	a. Talk to Ryathen the Somber",
			"		i. Turn in "..cq("In Need of Felblood"),
			"		ii. Accept "..cq("The Cleansing Must Be Stopped"),
			completion={{questturnedin="In Need of Felblood"},{questaccepted="The Cleansing Must Be Stopped"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59508650,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Falconer Drenna Riverwind",
			"		i. Turn in "..cq("Trueflight Arrows"),
			completion={{questturnedin="Trueflight Arrows"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308800,
		}, {
			"Go inside the building next to the flight path",
			"	a. Click the Orb of Translocation to go to the top of the tower",
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60208870,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Ranger Captain Venn'ren",
			"		i. Turn in "..cq("The Great Fissure"),
			"		ii. Accept "..cq("Marking the Path"),
			completion={{questturnedin="The Great Fissure"},{questaccepted="Marking the Path"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60208870,
		}, {
			"Click the Orb of Translocation to go to the bottom of the tower",
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go northeast to "..cl(39,40),
			"	a. Stand on the big stone block",
			"	b. Click the Signaling Gem in your bags",
			"	c. They come walking from the west",
			"	d. Kill the Draenei Anchorite and his 2 guards",
			completion={{questgoal={"*","Draenei Anchorite slain",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=40307930,
		}, {
			"Go southwest to "..cl(18,50),
			"	a. He walks along the road from Falcon Watch to Zangarmarsh",
			"	b. Talk to Magister Aledis",
			"		i. Fight him until he's almost dead",
			"	c. Talk to Magister Aledis",
			"		i. Turn in "..cq("Arelion's Secret"),
			"		ii. Accept "..cq("The Mistress Revealed"),
			completion={{questturnedin="Arelion's Secret"},{questaccepted="The Mistress Revealed"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=49906800,
		}, {
			"Go southwest to "..cl(16,52),
			"	a. Talk to Thiah Redmane",
			"		i. Turn in "..cq("Missing Missive"),
			"		ii. Turn in "..cq("Helping the Cenarion Post"),
			"		iii. Accept "..cq("Demonic Contamination"),
			"	b. Talk to Mahuran Stouthoof",
			"		i. Accept "..cq("Keep Thornfang Hill Clear!"),
			"	c. Talk to Amythiel Mistwalker",
			"		i. Accept "..cq("The Cenarion Expedition"),
			completion={{questturnedin="Missing Missive"},{questturnedin="Helping the Cenarion Post"},{questaccepted="Demonic Contamination"},{questaccepted="Keep Thornfang Hill Clear!"},{questaccepted="The Cenarion Expedition"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=52006770,
		}, {
			"Go east to "..cl(25,55),
			"	a. Kill Hulking Helboars",
			"	b. Get 6 Helboar Blood Samples",
			completion={{questgoal={"*","Helboar Blood Sample",6}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=54307920,
		}, {
			"Go southeast to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(26,60),
			"	a. Talk to Magistrix Carinda",
			"		i. Turn in "..cq("The Mistress Revealed"),
			"		ii. Accept "..cq("Arelion's Mistress"),
			completion={{questturnedin="The Mistress Revealed"},{questaccepted="Arelion's Mistress"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308670,
		}, {
			"Go to "..cl(27,60),
			"	a. Talk to Ryathen the Somber",
			"		i. Turn in "..cq("The Cleansing Must Be Stopped"),
			completion={{questturnedin="The Cleansing Must Be Stopped"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59508650,
		}, {
			"Go east to "..cl(30,60),
			"	a. Click the Western Beacon",
			"	b. Light the Western Beacon",
			completion={{questgoal={"*","Western Beacon",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60509050,
		}, {
			"Go east to "..cl(34,60),
			"	a. Click the Central Beacon",
			"	b. Light the Central Beacon",
			completion={{questgoal={"*","Central Beacon",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60009400,
		}, {
			"Go southeast to "..cl(36,65),
			"	a. Click the Southern Beacon",
			"	b. Light the Southern Beacon",
			completion={{questgoal={"*","Southern Beacon",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65410150,
		}, {
			"Go northwest to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(28,60),
			"	a. Go inside the building next to the flight path",
			"	b. Click the Orb of Translocation to go to the top of the tower",
			"	c. Talk to Ranger Captain Venn'ren",
			"		i. Turn in "..cq("Marking the Path"),
			completion={{questturnedin="Marking the Path"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60208870,
		}, {
			"Click the Orb of Translocation to go to the bottom of the tower",
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go northwest to "..cl(16,52),
			"	a. Talk to Thiah Redmane",
			"		i. Turn in "..cq("Demonic Contamination"),
			"		ii. Accept "..cq("Testing the Antidote"),
			completion={{questturnedin="Demonic Contamination"},{questaccepted="Testing the Antidote"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=52006770,
		}, {
			"Go east to "..cl(25,54),
			"	a. Use the Cenarion Antidote on a Hulking Helboar",
			completion={{questgoal={"*","Administer Antidote",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go west to "..cl(16,52),
			"	a. Talk to Thiah Redmane",
			"		i. Turn in "..cq("Testing the Antidote"),
			completion={{questturnedin="Testing the Antidote"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=52006770,
		}, {
			"Go northwest to "..cl(12,50),
			"	a. Kill 8 Thornfang Ravagers",
			"	b. Kill 8 Thornfang Venomspitters",
			completion={{questgoal={"*","Thornfang Ravager slain",8}},{questgoal={"*","Thornfang Venomspitter slain",8}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=49906220,
		}, {
			"Go west to Zangarmash",
			completion={{location={mapzone="Zangarmarsh"}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(78,63),
			"	a. Talk to Innkeeper Coryth Stoktron",
			"		i. Buy a Cenarion Spirits",
			completion={{item={"Cenarion Spirits",1}}},
			mapzone="Zangarmarsh",
			level=61,
			mapnote=62914140,
		}, {
			"Go east to Hellfire Peninsula",
			completion={{location={mapzone="Hellfire Peninsula"}}},
			mapzone="Zangarmarsh",
			level=61,
		}, {
			"Go southeast to "..cl(16,52),
			"	a. Talk to Mahuram Stouthoof",
			"		i. Turn in "..cq("Keep Thornfang Hill Clear!"),
			completion={{questturnedin="Keep Thornfang Hill Clear!"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=52006770,
		}, {
			"Go south to "..cl(15,56),
			"	a. Kill Illidari Taskmasters",
			"	b. Get 5 Demonic Essences",
			completion={{questgoal={"*","Demonic Essence",5}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=55707080,
		}, {
			"Go south to "..cl(16,59),
			"	a. Talk to Akoru the Firecaller",
			"		i. Accept "..cq("Naladu"),
			completion={{questaccepted="Naladu"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=58807440,
		}, {
			"Go southeast to "..cl(16,65),
			"	a. Talk to Naladu",
			"		i. Turn in "..cq("Naladu"),
			"		ii. Accept "..cq("A Traitor Among Us"),
			completion={{questturnedin="Naladu"},{questaccepted="A Traitor Among Us"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65108140,
		}, {
			"Go northwest "..cl(14,64),
			"	a. Click the metal coffer in the big red hut",
			"	b. Get the Sha'naar Key",
			completion={{questgoal={"*","Sha'naar Key",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=63507780,
		}, {
			"Go southeast to "..cl(16,65),
			"	a. Talk to Naladu",
			"		i. Turn in "..cq("A Traitor Among Us"),
			"		ii. Accept "..cq("The Dreghood Elders"),
			completion={{questturnedin="A Traitor Among Us"},{questaccepted="The Dreghood Elders"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65108140,
		}, {
			"Go north to "..cl(16,59),
			"	a. Free Akoru the Firecaller",
			completion={{questgoal={"*","Akoru Freed",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=58807440,
		}, {
			"Go west to "..cl(13,58),
			"	a. Free Aylaan the Waterwaker",
			completion={{questgoal={"*","Aylaan Freed",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=58407140,
		}, {
			"Go south to "..cl(13,61),
			"	a. Free Morod the Windstirrer",
			completion={{questgoal={"*","Morod Freed",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=61007410,
		}, {
			"Go southeast to "..cl(16,65),
			"	a. Talk to Naladu",
			"		i. Turn in "..cq("The Dreghood Elders"),
			"		ii. Accept "..cq("Arzeth's Demise"),
			completion={{questturnedin="The Dreghood Elders"},{questaccepted="Arzeth's Demise"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65108140,
		}, {
			"Go northwest to "..cl(14,62),
			"	a. Wait until Arzeth the Merciless is up on top of the stairs by himself",
			"	b. Use the Staff of the Dreghood Elders on Arzeth the Merciless",
			"	c. Kill Arzeth the Powerless",
			completion={{questgoal={"*","Arzeth the Powerless slain",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=62307670,
		}, {
			"Go southeast to "..cl(16,65),
			"	a. Talk to Naladu",
			"		i. Turn in "..cq("Arzeth's Demise"),
			completion={{questturnedin="Arzeth's Demise"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=65108140,
		}, {
			"Go east to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=61,
		}, {
			"Go to "..cl(27,60),
			"	a. Talk to Apothecary Azethen",
			"		i. Turn in "..cq("Source of the Corruption"),
			completion={{questturnedin="Source of the Corruption"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=59708650,
		}, {
			"Go to "..cl(27,62),
			"	a. Talk to Viera Sunwhisper",
			"		i. Turn in "..cq("Life's Finer Pleasures"),
			"	b. Follow Viera Sunwhisper",
			"	c. When she stops, use Carinda's Scroll of Retribution on her",
			completion={{questgoal={"*","Carinda's Scroll of Retribution used",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=62108920,
		}, {
			"Go to "..cl(26,60),
			"	a. Talk to Magistrix Carinda",
			"		i. Turn in "..cq("Arelion's Mistress"),
			completion={{questturnedin="Arelion's Mistress"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=60308670,
		}, {
			"Go south to "..cl(25,70),
			"	a. Kill Haal'eshi arakkoas",
			"	b. Get 4 Haal'eshi Scrolls",
			completion={{questgoal={"*","Haal'eshi Scroll",4}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=70309590,
		}, {
			"Go south to "..cl(25,71),
			"	a. Click the Kaliri nests (small, round, with 3 glowing pinkish eggs in them)",
			"	b. When a female Kaliri hatchling spawns, use your empty birdcage",
			"	c. Cage the Female Kaliri Hatchling",
			completion={{questgoal={"*","Caged Female Kaliri Hatchling",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=71609700,
		}, {
			"Go southeast to "..cl(26,77),
			"	a. The path up to Avruu starts here",
			completion={{location={mapzone="Hellfire Peninsula",x=26.1,y=77.1, dist=0.3}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=77110330,
		}, {
			"Go northwest to "..cl(26,75),
			"	a. Kill Avruu",
			"	b. Get Avruu's Orb",
			"	c. Click Avruu's Orb",
			"		i. Accept "..cq("Avruu's Orb"),
			completion={{questaccepted="Avruu's Orb"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=75110080,
		}, {
			"Go southeast to "..cl(29,81),
			"	a. It looks like an orb sitting in a claw thing",
			"	b. Click the Haal'eshi Altar",
			"	c. Fight Aeranas until he's almost dead",
			"	d. Talk to Aeranas",
			"		i. Turn in "..cq("Avruu's Orb"),
			completion={{questturnedin="Avruu's Orb"}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=81511050,
		}, {
			"Go northwest to "..cl(25,76),
			"	a. Talk to the Wounded Blood Elf Pilgrim",
			"		i. Accept "..cq("The Road to Falcon Watch"),
			"	b. Escort the Wounded Blood Elf Pilgrim to Falcon Watch",
			completion={{questaccepted="The Road to Falcon Watch"},{questgoal={"*","Escort Wounded Blood Elf Pilgrim to Falcon Watch",1}}},
			mapzone="Hellfire Peninsula",
			level=61,
			mapnote=76010060,
		}, {
			"Grind to level 62",
			completion={{level=62}},
			mapzone="Hellfire Peninsula",
			level=61,
		}
	  },
	},
	{ sectiontitle = "Levels (62-64)",
	  steps = {
		{
			"Go to "..cl(27,62),
			"	a. Talk to Taleris Dawngazer",
			"		i. Turn in "..cq("The Road to Falcon Watch"),
			"		ii. Accept "..cq("A Pilgrim's Plight"),
			completion={{questturnedin="The Road to Falcon Watch"},{questaccepted="A Pilgrim's Plight"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=61908910,
		}, {
			"Go to "..cl(27,60),
			"	a. Talk to Arcanist Calesthris Dawnstar",
			"		i. Turn in "..cq("Magic of the Arakkoa"),
			completion={{questturnedin="Magic of the Arakkoa"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=59808690,
		}, {
			"Go to "..cl(28,60),
			"	a. Talk to Falconer Drenna Riverwind",
			"		i. Turn in "..cq("Birds of a Feather"),
			completion={{questturnedin="Birds of a Feather"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=60308800,
		}, {
			"Fly to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Magister Bloodhawk",
			"		i. Turn in "..cq("The Agony and the Darkness"),
			completion={{questturnedin="The Agony and the Darkness"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=36009110,
		}, {
			"Also at "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("A Strange Weapon"),
			"		ii. Accept "..cq("The Warchief's Mandate"),
			completion={{questturnedin="A Strange Weapon"},{questaccepted="The Warchief's Mandate"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=36009100,
		}, {
			"Go to "..cl(54,38),
			"	a. Talk to Far Seer Regulkut",
			"		i. Turn in "..cq("The Warchief's Mandate"),
			"		ii. Accept "..cq("A Spirit Guide"),
			completion={{questturnedin="The Warchief's Mandate"},{questaccepted="A Spirit Guide"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=37909210,
		}, {
			"Go west to "..cl(34,44),
			"	a. Use your Ancestral Spirit Wolf Totem next to the Fel Orc Corpse",
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=43507710,
		}, {
			"Follow the Ancestral Spirit Wolf to "..cl(32,28),
			completion={{location={mapzone="Hellfire Peninsula",x=32.0,y=28.0, dist=1}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"At "..cl(32,28),
			"	a. Talk to Gorkan Bloodfist",
			"		i. Turn in "..cq("A Spirit Guide"),
			"		ii. Accept "..cq("The Mag'har"),
			completion={{questturnedin="A Spirit Guide"},{questaccepted="The Mag'har"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=27805980,
		}, {
			"Hearth to Thrallmar",
			completion={{location={mapzone="Hellfire Peninsula",x=54.7,y=38.3, dist=5}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go to "..cl(55,36),
			"	a. Talk to Nazgrel",
			"		i. Turn in "..cq("The Mag'har"),
			"		ii. Accept "..cq("Messenger to Thrall"),
			completion={{questturnedin="The Mag'har"},{questaccepted="Messenger to Thrall"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=36009100,
		}, {
			"Fly to The Dark Portal",
			completion={{location={mapzone="Hellfire Peninsula",x=87.3,y=48.1, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go into the Dark Portal to the Blasted Lands",
			completion={{location={mapzone="Blasted Lands"}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go north to Swamp of Sorrows",
			completion={{location={mapzone="Swamp of Sorrows"}}},
			mapzone="Blasted Lands",
			level=62,
		}, {
			"Go northeast to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=62,
		}, {
			"Fly to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="Swamp of Sorrows",
			level=62,
		}, {
			"Ride the boat to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Stranglethorn Vale",
			level=62,
		}, {
			"Fly to Orgrimmar",
			completion={{location={mapzone="Orgrimmar"}}},
			mapzone="The Barrens",
			level=62,
		}, {
			"Go to "..cl(32,38),
			"	a. Talk to Thrall",
			"		i. Turn in "..cq("Messenger to Thrall"),
			"		ii. Accept "..cq("Envoy to the Mag'har"),
			completion={{questturnedin="Messenger to Thrall"},{questaccepted="Envoy to the Mag'har"}},
			mapzone="Orgrimmar",
			level=62,
			mapnote=37806960,
		}, {
			"Fly to Ratchet",
			completion={{location={mapzone="The Barrens",x=61.8,y=38.1, dist=2}}},
			mapzone="Orgrimmar",
			level=62,
		}, {
			"Ride the Boat to Booty Bay",
			completion={{location={mapzone="Stranglethorn Vale",x=27.7,y=74.6, dist=6}}},
			mapzone="The Barrens",
			level=62,
		}, {
			"Fly to Stonard",
			completion={{location={mapzone="Swamp of Sorrows",x=45.9,y=54.8, dist=6}}},
			mapzone="Stranglethorn Vale",
			level=62,
		}, {
			"Go southwest to the Blasted Lands",
			completion={{location={mapzone="Blasted Lands"}}},
			mapzone="Swamp of Sorrows",
			level=62,
		}, {
			"Go south into The Dark Portal",
			completion={{location={mapzone="Hellfire Peninsula"}}},
			mapzone="Blasted Lands",
			level=62,
		}, {
			"Fly to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go north to "..cl(30,35),
			"	a. The path up to Gorkan Bloodfist start here",
			completion={{location={mapzone="Hellfire Peninsula",x=30.3,y=35.3, dist=0.5}}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=35306560,
		}, {
			"Go northeast to "..cl(32,28),
			"	a. Talk to Gorkan Bloodfist",
			"		i. Turn in "..cq("Envoy to the Mag'har"),
			completion={{questturnedin="Envoy to the Mag'har"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=27805980,
		}, {
			"Go southwest to "..cl(22,68),
			"	a. It's a small tan sack laying on a purple rug",
			"	b. Click the Torn Pilgrim's Pack",
			"	c. Get the Torn Pilgrim's Pack",
			completion={{questgoal={"*","Torn Pilgrim's Pack",1}}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=68309040,
		}, {
			"Go northeast to Falcon Watch",
			completion={{location={mapzone="Hellfire Peninsula",x=27.2,y=61.0, dist=3}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go to "..cl(27,62),
			"	a. Talk to Taleris Dawngazer",
			"		i. Turn in "..cq("A Pilgrim's Plight"),
			completion={{questturnedin="A Pilgrim's Plight"}},
			mapzone="Hellfire Peninsula",
			level=62,
			mapnote=61908910,
		}, {
			"Go northwest to Zangarmarsh",
			completion={{location={mapzone="Zangarmarsh"}}},
			mapzone="Hellfire Peninsula",
			level=62,
		}, {
			"Go to "..cl(80,64),
			"	a. Talk to Lauranna Thar'well",
			"		i. Accept "..cq("Plants of Zangarmarsh"),
			"	b. Talk to Ikeyen",
			"		i. Accept "..cq("The Umbrafen Tribe"),
			completion={{questaccepted="Plants of Zangarmarsh"},{questaccepted="The Umbrafen Tribe"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64214460,
		}, {
			"Go to "..cl(79,65),
			"	a. Talk to Warden Hamoot",
			"		i. Accept "..cq("A Warm Welcome"),
			completion={{questaccepted="A Warm Welcome"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=65314440,
		}, {
			"Go to "..cl(79,63),
			"	a. Talk to Lethyn Moonfire",
			"		i. Accept "..cq("The Dying Balance"),
			completion={{questaccepted="The Dying Balance"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=63114160,
		}, {
			"Go to "..cl(78,62),
			"	a. Talk to Ysiel Windsinger",
			"		i. Turn in "..cq("The Cenarion Expedition"),
			"		ii. Accept "..cq("Disturbance at Umbrafen Lake"),
			completion={{questturnedin="The Cenarion Expedition"},{questaccepted="Disturbance at Umbrafen Lake"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=62014040,
		}, {
			"Go south to "..cl(80,73),
			"	a. Kill all mobs in this area",
			"	b. Get 10 Unidentified Plant Parts",
			completion={{questgoal={"*","Unidentified Plant Parts",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=73315340,
		}, {
			"Go northeast to "..cl(81,72),
			"	a. Kill Boglash",
			completion={{questgoal={"*","Boglash slain",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=72215320,
		}, {
			"Go east to "..cl(83,72),
			"	a. Kill Boglash and Fen Striders",
			"	b. Get 10 Fertile Spores",
			completion={{item={"Fertile Spores",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=72315490,
		}, {
			"Go northwest to "..cl(80,64),
			"	a. Talk to Lauranna Thar'well",
			"		i. Turn in "..cq("Plants of Zangarmarsh"),
			completion={{questturnedin="Plants of Zangarmarsh"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64214460,
		}, {
			"Go to "..cl(79,63),
			"	a. Talk to Lethyn Moonfire",
			"		i. Turn in "..cq("The Dying Balance"),
			completion={{questturnedin="The Dying Balance"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=63114160,
		}, {
			"Go southeast to "..cl(85,84),
			"	a. Kill 6 Umbrafen Oracles",
			"	b. Kill 8 Umbrafen Seers",
			"	c. Kill 6 Umbrafen Witchdoctors",
			completion={{questgoal={"*","Umbrafen Oracle slain",6}},{questgoal={"*","Umbrafen Seer slain",8}},{questgoal={"*","Umbrafen Witchdoctor slain",6}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=84416920,
		}, {
			"Go south to "..cl(85,91),
			"	a. Kill Kataru",
			completion={{questgoal={"*","Kataru slain",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=90917620,
		}, {
			"Go northwest to "..cl(83,85),
			"	a. Talk to Kayra Longmane",
			"		i. Accept "..cq("Escape from Umbrafen"),
			"	b. Escort Kayra Longmane",
			completion={{questaccepted="Escape from Umbrafen"},{questgoal={"*","Escort Kayra Longmane to safety",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=85516890,
		}, {
			"Go to "..cl(80,64),
			"	a. Talk to Ikeyen",
			"		i. Turn in "..cq("The Umbrafen Tribe"),
			"		ii. Accept "..cq("A Damp, Dark Place"),
			"	b. Talk to Lauranna Thar'well",
			"		i. Accept "..cq("Saving the Sporeloks"),
			completion={{questturnedin="The Umbrafen Tribe"},{questaccepted="A Damp, Dark Place"},{questaccepted="Saving the Sporeloks"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64214460,
		}, {
			"Go to "..cl(80,65),
			"	a. Talk to Windcaller Blackhoof",
			"		i. Accept "..cq("Safeguarding the Watchers"),
			completion={{questaccepted="Safeguarding the Watchers"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=84416920,
		}, {
			"Go to "..cl(78,62),
			"	a. Talk to Ysiel Windsinger",
			"		i. Turn in "..cq("Escape from Umbrafen"),
			completion={{questturnedin="Escape from Umbrafen"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=62014040,
		}, {
			"Go southwest to "..cl(76,90),
			"	a. Kill 10 Marsh Lurkers",
			"	b. Kill 10 Marsh Dredgers",
			completion={{questgoal={"*","Marsh Lurker slain",10}},{questgoal={"*","Marsh Dredger slain",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=90216590,
		}, {
			"Go southwest inside the cave to "..cl(70,98),
			"	a. Get Ikeyen's Belongings",
			completion={{questgoal={"*","Ikeyen's Belongings",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=97916840,
		}, {
			"Go northeast inside the cave to "..cl(73,94),
			"	a. Kill Lord Klaq",
			completion={{questgoal={"*","Lord Klaq slain",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=94016650,
		}, {
			"Go northwest to "..cl(71,82),
			"	a. Stand here to Investigate Umbrafen Lake",
			"	b. Kill nagas",
			"	c. Get 30 Naga Claws",
			completion={{questgoal={"*","Umbrafen Lake Investigated",1}},{questgoal={"*","Naga Claws",30}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=82115300,
		}, {
			"Go northeast to Cenarion Refuge",
			completion={{location={mapzone="Zangarmarsh",x=79.7,y=64.6, dist=2}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(80,65),
			"	a. Talk to Windcaller Blackhoof",
			"		i. Turn in "..cq("Safeguarding the Watchers"),
			completion={{questturnedin="Safeguarding the Watchers"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64714510,
		}, {
			"Go to "..cl(80,64),
			"	a. Talk to Ikeyen",
			"		i. Turn in "..cq("A Damp, Dark Place"),
			"	b. Talk to Lauranna Thar'well",
			"		i. Turn in "..cq("Saving the Sporeloks"),
			"		ii. Turn in any stacks of 10 Unidentified Plant Parts you have",
			"		iii. If you found an Uncatalogued Species, turn that in also",
			completion={{questturnedin="A Damp, Dark Place"},{questturnedin="Saving the Sporeloks"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64214460,
		}, {
			"Go to "..cl(80,65),
			"	a. Talk to Windcaller Blackhoof",
			"		i. Accept "..cq("Blessings of the Ancients"),
			completion={{questaccepted="Blessings of the Ancients"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64714510,
		}, {
			"Go to "..cl(79,65),
			"	a. Talk to Warden Hamoot",
			"		i. Turn in "..cq("A Warm Welcome"),
			completion={{questturnedin="A Warm Welcome"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=65314440,
		}, {
			"Go to "..cl(79,63),
			"	a. Talk to Lethyn Moonfire",
			"		i. Accept "..cq("Watcher Leesa'oh"),
			"		ii. Accept "..cq("What's Wrong at Cenarion Thicket?"),
			completion={{questaccepted="Watcher Leesa'oh"},{questaccepted="What's Wrong at Cenarion Thicket?"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=63114160,
		}, {
			"Go to "..cl(78,62),
			"	a. Talk to Ysiel Windsinger",
			"		i. Turn in "..cq("Disturbance at Umbrafen Lake"),
			"		ii. Accept "..cq("As the Crow Flies"),
			"	b. Click the Stormcrow Amulet in your bags",
			"	c. Watch yourself fly as a crow",
			"		i. Turn in "..cq("As the Crow Flies"),
			"		ii. Accept "..cq("Balance Must Be Preserved"),
			completion={{questturnedin="Disturbance at Umbrafen Lake"},{questaccepted="As the Crow Flies"},{questturnedin="As the Crow Flies"},{questaccepted="Balance Must Be Preserved"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=62014040,
		}, {
			"Go to "..cl(78,64),
			"	a. Talk to Keleth",
			"		i. Get the Mark of War",
			completion={{questgoal={"*","Mark of War",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=63814190,
		}, {
			"Go to "..cl(81,64),
			"	a. Talk to Ashyen",
			"		i. Get the Mark of Lore",
			completion={{questgoal={"*","Mark of Lore",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=63914500,
		}, {
			"Go to "..cl(80,65),
			"	a. Talk to Windcaller Blackhoof",
			"		i. Turn in "..cq("Blessings of the Ancients"),
			completion={{questturnedin="Blessings of the Ancients"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64714510,
		}, {
			"Go southwest to "..cl(71,80),
			"	a. Use your Ironvine Seeds on the Umbrafen Lake Pump Controls",
			"	b. Disable the Umbrafen Lake Pump Controls",
			completion={{questgoal={"*","Umbrafen Lake Controls Disabled",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=80315090,
		}, {
			"Go northwest to "..cl(63,64),
			"	a. Use your Ironvine Seeds on the Lagoon Pump Controls",
			"	b. Disable the Lagoon Pump Controls",
			completion={{questgoal={"*","Lagoon Controls Disabled",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=64112720,
		}, {
			"Go northeast to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(85,55),
			"	a. Talk to Gur'zil",
			"		i. Get the Swamprat Post Flight Path",
			completion={{flightpath="Swamprat Post"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=55113990,
		}, {
			"Also "..cl(85,55),
			"	a. Talk to Zurai",
			"		i. Turn in "..cq("Report to Zurai"),
			"		ii. Accept "..cq("Thick Hydra Scales"),
			"		iii. Accept "..cq("News from Zangarmarsh"),
			"		iv. Accept "..cq("Report to Shadow Hunter Denjai"),
			completion={{questturnedin="Report to Zurai"},{questaccepted="Thick Hydra Scales"},{questaccepted="News from Zangarmarsh"},{questaccepted="Report to Shadow Hunter Denjai"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54814010,
		}, {
			"Go to "..cl(85,54),
			"	a. Talk to Reavij",
			"		i. Accept "..cq("Menacing Marshfangs"),
			completion={{questaccepted="Menacing Marshfangs"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54013900,
		}, {
			"Go to "..cl(84,54),
			"	a. Talk to Magasha",
			"		i. Accept "..cq("There's No Explanation for Fashion"),
			"		ii. Accept "..cq("No More Mushrooms!"),
			completion={{questaccepted="There's No Explanation for Fashion"},{questaccepted="No More Mushrooms!"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54313870,
		}, {
			"Go southwest to "..cl(74,61),
			"	a. Kill Mire Hydras",
			"	b. Get 12 Thick Hydra Scales",
			"	c. Kill Umbrafen Eels",
			"	d. Get 8 Eel Filets",
			completion={{questgoal={"*","Thick Hydra Scale",12}},{questgoal={"*","Eel Filet",8}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=60713490,
		}, {
			"Go southwest to "..cl(80,70),
			"	a. Kill Umbraglow Stingers",
			"	b. Get 8 Diaphanous Wings",
			completion={{questgoal={"*","Diaphanous Wing",8}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=70114980,
		}, {
			"Go northeast to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(84,54),
			"	a. Talk to Magasha",
			"		i. Turn in "..cq("There's No Explanation for Fashion"),
			"		ii. Turn in "..cq("No More Mushrooms!"),
			"		iii. Accept "..cq("A Job Undone"),
			completion={{questturnedin="There's No Explanation for Fashion"},{questturnedin="No More Mushrooms!"},{questaccepted="A Job Undone"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54313870,
		}, {
			"Go to "..cl(85,55),
			"	a. Talk to Zurai",
			"		i. Turn in "..cq("Thick Hydra Scales"),
			"		ii. Accept "..cq("Searching for Scout Jyoba"),
			completion={{questturnedin="Thick Hydra Scales"},{questaccepted="Searching for Scout Jyoba"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54814010,
		}, {
			"Go northwest to "..cl(62,41),
			"	a. Use your Ironvine Seeds on the Serpent Lake Controls",
			"	b. Disable the Serpent Lake Controls",
			"	c. Kill Steam Pump Overseers, Bloodscale Overseers, and Bloodscale Wavecallers",
			"		i. Get a Drain Schematics",
			"	d. Click the Drain Schematics in your bags",
			"		i. Accept "..cq("Drain Schematics"),
			completion={{questgoal={"*","Serpent Lake Controls Disabled",1}},{questaccepted="Drain Schematics"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=40810280,
		}, {
			"Go east to "..cl(73,41),
			"	a. Kill 10 Marshfang Rippers",
			completion={{questgoal={"*","Marshfang Ripper slain",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=41511470,
		}, {
			"Go southeast to "..cl(77,46),
			"	a. Kill Sporewing",
			completion={{questgoal={"*","Sporewing slain",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=45912310,
		}, {
			"Go east to "..cl(78,45),
			"	a. Kill Withered Bog Lords",
			"	b. Get 6 Bog Lord Tendrils",
			"	c. Kill Withered Giants",
			"	d. Get a Withered Basidium",
			"	e. Click the Withered Basidium",
			"		i. Accept "..cq("Withered Basidium"),
			completion={{item={"Bog Lord Tendril",6}},{questaccepted="Withered Basidium"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=45212350,
		}, {
			"Go northeast to "..cl(81,36),
			"	a. Talk to Scout Jyoba",
			"		i. Turn in "..cq("Searching for Scout Jyoba"),
			"		ii. Accept "..cq("Jyoba's Report"),
			completion={{questturnedin="Searching for Scout Jyoba"},{questaccepted="Jyoba's Report"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=36311710,
		}, {
			"Go northeast to "..cl(82,35),
			"	a. Kill Withered Giants",
			"	b. Get Scout Jyoba's Report",
			completion={{questgoal={"*","Scout Jyoba's Report",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=35011660,
		}, {
			"Go southeast to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(84,54),
			"	a. Talk to Magasha",
			"		i. Turn in "..cq("A Job Undone"),
			completion={{questturnedin="A Job Undone"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54313870,
		}, {
			"Go to "..cl(85,54),
			"	a. Talk to Reavij",
			"		i. Turn in "..cq("Menacing Marshfangs"),
			"		ii. Accept "..cq("Nothin' Says Lovin' Like a Big Stinger"),
			"		iii. Turn in "..cq("Withered Basidium"),
			completion={{questturnedin="Menacing Marshfangs"},{questturnedin="Withered Basidium"},{questaccepted="Nothin' Says Lovin' Like a Big Stinger"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54013900,
		}, {
			"Go to "..cl(85,55),
			"	a. Talk to Zurai",
			"		i. Turn in "..cq("Jyoba's Report"),
			completion={{questturnedin="Jyoba's Report"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=54814010,
		}, {
			"Go northwest to "..cl(51,41),
			"	a. Swim straight down at this spot",
			"	b. Locate the drain in Serpent Lake",
			completion={{questgoal={"*","Drain Located",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=40809120,
		}, {
			"Go south to "..cl(49,59),
			"	a. Kill Blacksting",
			"	b. Get Blacksting's Stinger",
			completion={{questgoal={"*","Blacksting's Stinger",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=59210870,
		}, {
			"Go west to "..cl(33,59),
			"	a. Kill 'Count' Ungula",
			"	b. Get 'Count' Ungula's Mandible",
			"	c. Click 'Count' Ungula's Mandible",
			"		i. Accept "..cq("The Count of the Marshes"),
			completion={{questaccepted="The Count of the Marshes"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=59109190,
		}, {
			"Go north to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(33,49),
			"	a. Talk to Witch Doctor Tor'gash",
			"		i. Accept "..cq("Burstcap Mushrooms, Mon!"),
			completion={{questaccepted="Burstcap Mushrooms, Mon!"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=48908180,
		}, {
			"Go to "..cl(32,50),
			"	a. Talk to Zurjaya",
			"		i. Accept "..cq("Angling to Beat the Competition"),
			completion={{questaccepted="Angling to Beat the Competition"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=49608180,
		}, {
			"Go to "..cl(32,49),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("WANTED: Boss Grog'ak"),
			"		ii. Accept "..cq("Wanted: Chieftain Mummaki"),
			completion={{questaccepted="WANTED: Boss Grog'ak"},{questaccepted="Wanted: Chieftain Mummaki"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=51108420,
		}, {
			"Also at "..cl(32,49),
			"	a. Talk to Gambarinka",
			"		i. Accept "..cq("Stinging the Stingers"),
			completion={{questaccepted="Stinging the Stingers"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=49208080,
		}, {
			"Make Zabra'jin your home",
			completion={{home="Zabra'jin"}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(31,51),
			"	a. Talk to Shadow Hunter Denjai",
			"		i. Turn in "..cq("Report to Shadow Hunter Denjai"),
			completion={{questturnedin="Report to Shadow Hunter Denjai"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=50908160,
		}, {
			"Go to "..cl(32,52),
			"	a. Talk to Seer Janidi",
			"		i. Accept "..cq("Spirits of the Feralfen"),
			completion={{questaccepted="Spirits of the Feralfen"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=52008440,
		}, {
			"Go to "..cl(33,51),
			"	a. Talk to Du'ga",
			"		i. Get the Zabra'jin Flight Path",
			completion={{flightpath="Zabra'jin"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=51108420,
		}, {
			"Go southeast to "..cl(46,60),
			"	a. Kill Feralfen mobs",
			"	b. Get 10 Feralfen Protection Totems",
			completion={{questgoal={"*","Feralfen Protection Totem",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=60310630,
		}, {
			"Go north to "..cl(48,38),
			"	a. Kill 10 Fenclaw Thrashers",
			completion={{questgoal={"*","Fenclaw Thrasher slain",10}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=38408650,
		}, {
			"Go southwest to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(33,50),
			"	a. Talk to Zurjaya",
			"		i. Turn in "..cq("Angling to Beat the Competition"),
			"		ii. Accept "..cq("The Biggest of Them All"),
			"		iii. Accept "..cq("Pursuing Terrorclaw"),
			completion={{questturnedin="Angling to Beat the Competition"},{questaccepted="The Biggest of Them All"},{questaccepted="Pursuing Terrorclaw"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=49608180,
		}, {
			"Go to "..cl(32,52),
			"	a. Talk to Seer Janidi",
			"		i. Turn in "..cq("Spirits of the Feralfen"),
			"		ii. Accept "..cq("A Spirit Ally?"),
			completion={{questturnedin="Spirits of the Feralfen"},{questaccepted="A Spirit Ally?"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=52008440,
		}, {
			"Go northeast to "..cl(42,42),
			"	a. Kill Mragesh",
			completion={{questgoal={"*","Mragesh slain",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=41408360,
		}, {
			"Go south to "..cl(44,66),
			"	a. Use your Feralfen Totem at the base of the big stairs",
			"	b. Kill the Feralfen Serpent Spirit that spawns",
			completion={{questgoal={"*","Summon Serpent Spirit",1}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=66011040,
		}, {
			"Hearth to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(32,50),
			"	a. Talk to Zurjaya",
			"		i. Turn in "..cq("The Biggest of Them All"),
			completion={{questturnedin="The Biggest of Them All"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=49608180,
		}, {
			"Go to "..cl(32,52),
			"	a. Talk to Seer Janidi",
			"		i. Turn in "..cq("A Spirit Ally?"),
			completion={{questturnedin="A Spirit Ally?"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=52008440,
		}, {
			"Go west to "..cl(29,52),
			"	a. Click Burstcap Mushrooms",
			"	b. Get 6 Burstcap Mushrooms",
			completion={{questgoal={"*","Burstcap Mushroom",6}}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=52608150,
		}, {
			"Go east to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go to "..cl(33,49),
			"	a. Talk to Witch Doctor Tor'gash",
			"		i. Turn in "..cq("Burstcap Mushrooms, Mon!"),
			"		ii. Accept "..cq("Have You Ever Seen One of These?"),
			completion={{questturnedin="Burstcap Mushrooms, Mon!"},{questaccepted="Have You Ever Seen One of These?"}},
			mapzone="Zangarmarsh",
			level=62,
			mapnote=48908180,
		}, {
			"Grind to level 63",
			completion={{level=63}},
			mapzone="Zangarmarsh",
			level=62,
		}, {
			"Go southwest to "..cl(23,66),
			"	a. Talk to Watcher Leesa'oh",
			"		i. Turn in "..cq("Watcher Leesa'oh"),
			"		ii. Accept "..cq("Observing the Sporelings"),
			"		iii. Turn in "..cq("The Count of the Marshes"),
			completion={{questturnedin="Watcher Leesa'oh"},{questturnedin="The Count of the Marshes"},{questaccepted="Observing the Sporelings"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=66208950,
		}, {
			"Go northwest to "..cl(19,64),
			"	a. Talk to Fahssn",
			"		i. Accept "..cq("The Sporelings' Plight"),
			"		ii. Accept "..cq("Natural Enemies"),
			"		iii. Turn in "..cq("Natural Enemies"),
			"		iv. Accept "..cq("Sporeggar"),
			completion={{questaccepted="The Sporelings' Plight"},{questaccepted="Natural Enemies"},{questturnedin="Natural Enemies"},{questaccepted="Sporeggar"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=63908300,
		}, {
			"Go northwest to "..cl(14,62),
			"	a. Click Mature Spore Sacs",
			"	b. Get 30 Mature Spore Sacs",
			completion={{item={"Mature Spore Sac",30}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=61607610,
		}, {
			"Go northwest to "..cl(14,60),
			"	a. Go here to Investigate the Spawning Glen",
			completion={{questgoal={"*","Investigate the Spawning Glen",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=59807340,
		}, {
			"Go southeast to "..cl(19,64),
			"	a. Talk to Fahssn",
			"		i. Turn in "..cq("The Sporelings' Plight"),
			"		ii. Turn in all the Mature Spore Sacs you have",
			completion={{questturnedin="The Sporelings' Plight"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=63908300,
		}, {
			"Go southeast to "..cl(23,66),
			"	a. Talk to Watcher Leesa'oh",
			"		i. Turn in "..cq("Observing the Sporelings"),
			"		ii. Accept "..cq("A Question of Gluttony"),
			completion={{questturnedin="Observing the Sporelings"},{questaccepted="A Question of Gluttony"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=66208950,
		}, {
			"Go northeast to "..cl(27,63),
			"	a. Click Discarded Nutriments",
			"	b. Get 10 Discarded Nutriments",
			completion={{questgoal={"*","Discarded Nutriment",10}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=63309030,
		}, {
			"Go southwest to "..cl(23,66),
			"	a. Talk to Watcher Leesa'oh",
			"		i. Turn in "..cq("A Question of Gluttony"),
			"		ii. Accept "..cq("Familiar Fungi"),
			completion={{questturnedin="A Question of Gluttony"},{questaccepted="Familiar Fungi"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=66208950,
		}, {
			"Go northwest to "..cl(20,52),
			"	a. Talk to Msshi'fin",
			"		i. Turn in "..cq("Sporeggar"),
			completion={{questturnedin="Sporeggar"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=52107180,
		}, {
			"Also at "..cl(20,52),
			"	a. Talk to Gzhun'tt",
			"		i. Accept "..cq("Now That We're Friends..."),
			completion={{questaccepted="Now That We're Friends..."}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=50006950,
		}, {
			"Go to "..cl(19,49),
			"	a. Talk to Gshaff",
			"		i. Accept "..cq("Fertile Spores"),
			"		ii. Turn in "..cq("Fertile Spores"),
			completion={{questaccepted="Fertile Spores"},{questturnedin="Fertile Spores"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=49406860,
		}, {
			"Go northeast to "..cl(22,46),
			"	a. Kill Terrorclaw",
			completion={{questgoal={"*","Terrorclaw slain",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=46106850,
		}, {
			"Go northeast to "..cl(25,43),
			"	a. Use your ironvine Seeds on the Marshlight Lake Pump Controls",
			"	b. Disable the Marshlight Lake Pump Controls",
			completion={{questgoal={"*","Marshlight Lake Controls Disabled",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=42906830,
		}, {
			"Go east to "..cl(27,43),
			"	a. Kill 12 Bloodscale Slavedrivers",
			"	b. Kill 12 Bloodscale Enchantresses",
			completion={{questgoal={"*","Bloodscale Slavedriver slain",12}},{questgoal={"*","Bloodscale Enchantress slain",12}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=43006980,
		}, {
			"Go northeast to "..cl(35,35),
			"	a. Kill Boss Grog'ak",
			"	b. Get Boss Grog'ak's Head",
			completion={{questgoal={"*","Boss Grog'ak's Head",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=34806930,
		}, {
			"Go northwest to "..cl(29,28),
			"	a. Kill 8 Marshlight Bleeders",
			"	b. Kill ogres",
			"	c. Get 15 Mushroom Samples",
			completion={{questgoal={"*","Marshlight Bleeder slain",8}},{questgoal={"*","Mushroom Sample",15}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=28305790,
		}, {
			"Go south to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(32,50),
			"	a. Talk to Zurjaya",
			"		i. Turn in "..cq("Pursuing Terrorclaw"),
			completion={{questturnedin="Pursuing Terrorclaw"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=49608180,
		}, {
			"Go to "..cl(32,49),
			"	a. Talk to Gambarinka",
			"		i. Turn in "..cq("Stinging the Stingers"),
			"		ii. Accept "..cq("The Sharpest Blades"),
			completion={{questturnedin="Stinging the Stingers"},{questaccepted="The Sharpest Blades"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=49208080,
		}, {
			"Go to "..cl(31,51),
			"	a. Talk to Shadow Hunter Denjai",
			"		i. Turn in "..cq("WANTED: Boss Grog'ak"),
			"		ii. Accept "..cq("Impending Attack"),
			completion={{questturnedin="WANTED: Boss Grog'ak"},{questaccepted="Impending Attack"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=50908160,
		}, {
			"Go southeast to "..cl(37,54),
			"	a. Kill Marshfang Slicers",
			"	b. Get 10 Marshfang Slicer Blades",
			completion={{questgoal={"*","Marshfang Slicer Blade",10}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=54409160,
		}, {
			"Go northwest to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(32,49),
			"	a. Talk to Gambarinka",
			"		i. Turn in "..cq("The Sharpest Blades"),
			completion={{questturnedin="The Sharpest Blades"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=49208080,
		}, {
			"Go southwest to "..cl(23,66),
			"	a. Talk to Watcher Leesah'oh",
			"		i. Turn in "..cq("Familiar Fungi"),
			"		ii. Accept "..cq("Stealing Back the Mushrooms"),
			completion={{questturnedin="Familiar Fungi"},{questaccepted="Stealing Back the Mushrooms"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=66208950,
		}, {
			"Go northwest to "..cl(20,50),
			"	a. Talk to Gzhun'tt",
			"		i. Turn in "..cq("Now That We're Friends..."),
			completion={{questturnedin="Now That We're Friends..."}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=50006950,
		}, {
			"Go north to "..cl(20,27),
			"	a. Click the Ango'rosh Attack Plans",
			"	b. Get the Ango'rosh Attack Plans",
			completion={{questgoal={"*","Ango'rosh Attack Plans",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=27104700,
		}, {
			"Go southeast to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(31,51),
			"	a. Talk to Shadow Hunter Denjai",
			"		i. Turn in "..cq("Impending Attack"),
			"		ii. Accept "..cq("Us or Them"),
			"		iii. Accept "..cq("Message to the Daggerfen"),
			completion={{questturnedin="Impending Attack"},{questaccepted="Us or Them"},{questaccepted="Message to the Daggerfen"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=50908160,
		}, {
			"Go northwest to "..cl(24,27),
			"	a. Go to the top of the tower",
			"	b. Kill Chieftain Mummaki",
			"	c. Get Chieftain Mummaki's Totem",
			completion={{questgoal={"*","Chieftain Mummaki's Totem",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=26805060,
		}, {
			"Go north to "..cl(24,24),
			"	a. Kill 3 Daggerfen Assassins",
			"	b. Kill 15 Daggerfen Muckdwellers",
			completion={{questgoal={"*","Daggerfen Assassin slain",3}},{questgoal={"*","Daggerfen Muckdweller slain",15}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=24504830,
		}, {
			"Go northeast to "..cl(27,22),
			"	a. Clear this area of mobs",
			"	b. Stand on the big flat gray rock",
			"	c. Click the Murloc Cage in your bags",
			"	d. Release Murlocs at Daggerfen Village",
			completion={{questgoal={"*","Release Murlocs at Daggerfen Village",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=22604940,
		}, {
			"Go northwest to "..cl(17,14),
			"	a. Kill 10 Ango'rosh Maulers",
			"	b. Kill 10 Ango'rosh Souleaters",
			"	c. Kill ogres and click the brown crates",
			"	d. Get 10 Boxes of Mushrooms",
			completion={{questgoal={"*","Ango'rosh Mauler slain",10}},{questgoal={"*","Ango'rosh Souleater slain",10}},{questgoal={"*","Box of Mushrooms",10}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=14303130,
		}, {
			"Go northeast to "..cl(18,7),
			"	a. Kill Overlord Gorefist inside the cave",
			completion={{questgoal={"*","Overlord Gorefist slain",1}}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=7702600,
		}, {
			"Hearth to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(31,51),
			"	a. Talk to Shadow Hunter Denjai",
			"		i. Turn in "..cq("Us or Them"),
			"		ii. Turn in "..cq("Message to the Daggerfen"),
			"		iii. Turn in "..cq("Wanted: Chieftain Mummaki"),
			completion={{questturnedin="Us or Them"},{questturnedin="Message to the Daggerfen"},{questturnedin="Wanted: Chieftain Mummaki"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=50908160,
		}, {
			"Go to "..cl(33,49),
			"	a. Talk to Witch Doctor Tor'gash",
			"		i. Turn in "..cq("Have You Ever Seen One of These?"),
			completion={{questturnedin="Have You Ever Seen One of These?"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=48908180,
		}, {
			"Go southwest to "..cl(23,66),
			"	a. Talk to Watcher Leesa'oh",
			"		i. Turn in "..cq("Stealing Back the Mushrooms"),
			"	b. Don't follow her when she walks away",
			completion={{questturnedin="Stealing Back the Mushrooms"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=66208950,
		}, {
			"Go northeast to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Fly to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(85,54),
			"	a. Talk to Reavij",
			"		i. Turn in "..cq("Nothin' Says Lovin' Like a Big Stinger"),
			completion={{questturnedin="Nothin' Says Lovin' Like a Big Stinger"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=54013900,
		}, {
			"Go southwest to Cenarion Refuge",
			completion={{location={mapzone="Zangarmarsh",x=79.7,y=64.6, dist=2}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go to "..cl(78,62),
			"	a. Talk to Ysiel Windsinger",
			"		i. Turn in "..cq("Balance Must Be Preserved"),
			"		ii. Turn in "..cq("Drain Schematics"),
			"		iii. Accept "..cq("Warning the Cenarion Circle"),
			completion={{questturnedin="Balance Must Be Preserved"},{questturnedin="Drain Schematics"},{questaccepted="Warning the Cenarion Circle"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=62014040,
		}, {
			"Go east to Hellfire Peninsula",
			completion={{location={mapzone="Hellfire Peninsula"}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go southeast to "..cl(16,62),
			"	a. Talk to Amythiel Mistwalker",
			"		i. Turn in "..cq("Warning the Cenarion Circle"),
			"		ii. Accept "..cq("Return to the Marsh"),
			completion={{questturnedin="Warning the Cenarion Circle"},{questaccepted="Return to the Marsh"}},
			mapzone="Hellfire Peninsula",
			level=63,
			mapnote=52006770,
		}, {
			"Go northwest to Zangarmarsh",
			completion={{location={mapzone="Zangarmarsh"}}},
			mapzone="Hellfire Peninsula",
			level=63,
		}, {
			"Go to "..cl(78,62),
			"	a. Talk to Ysiel Windsinger",
			"		i. Turn in "..cq("Return to the Marsh"),
			completion={{questturnedin="Return to the Marsh"}},
			mapzone="Zangarmarsh",
			level=63,
			mapnote=62014040,
		}, {
			"Go southeast to Terokkar Forest",
			completion={{location={mapzone="Terokkar Forest"}}},
			mapzone="Zangarmarsh",
			level=63,
		}, {
			"Go south to Shattrath City",
			completion={{location={mapzone="Shattrath City"}}},
			mapzone="Terokkar Forest",
			level=63,
		}, {
			"Go to "..cl(61,14),
			"	a. Talk to the Haggard War Veteran",
			"		i. Accept "..cq("A'dal"),
			completion={{questaccepted="A'dal"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=12607380,
		}, {
			"Go to "..cl(54,45),
			"	a. Talk to A'dal",
			"		i. Turn in "..cq("A'dal"),
			completion={{questturnedin="A'dal"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=44809880,
		}, {
			"Go to "..cl(55,44),
			"	a. Talk to Khadgar",
			"		i. Accept "..cq("City of Light"),
			"	b. Follow the pink voidwalker",
			completion={{questaccepted="City of Light"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=44309910,
		}, {
			"As you follow the pink voidwalker",
			"	a. Talk to Seth at "..cl(64,14),
			"		i. Accept "..cq("Rather Be Fishin'"),
			completion={{questaccepted="Rather Be Fishin'"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=15507950,
		}, {
			"Also while you follow the pink voidwalker:",
			"	a. Talk to Rilak the Redeemed at "..cl(53,21),
			"		i. Accept "..cq("The Eyes of Skettis"),
			completion={{questaccepted="The Eyes of Skettis"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=21007360,
		}, {
			"Go to "..cl(55,44),
			"	a. Talk to Khadgar",
			"		i. Turn in "..cq("City of Light"),
			"		ii. Accept "..cq("Allegiance to the Scryers"),
			"		iii. Accept "..cq("Voren'thal the Seer"),
			completion={{questturnedin="City of Light"},{questaccepted="Allegiance to the Scryers"},{questaccepted="Voren'thal the Seer"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=44309910,
		}, {
			"Ride the elevator up to the Scryer Rise",
			completion={{location={mapzone="Shattrath City",x=50.0,y=62.9, dist=0.3}}},
			mapzone="Shattrath City",
			level=63,
		}, {
			"Go to "..cl(45,81),
			"	a. Talk to Magistrix Fyalenn",
			"		i. Accept "..cq("Firewing Signets"),
			completion={{questaccepted="Firewing Signets"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=81512670,
		}, {
			"Go to "..cl(43,92),
			"	a. Talk to Voren'thal the Seer",
			"		i. Turn in "..cq("Voren'thal the Seer"),
			completion={{questturnedin="Voren'thal the Seer"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=91713450,
		}, {
			"Make Shattrath City your home",
			completion={{home="Shattrath City"}},
			mapzone="Shattrath City",
			level=63,
		}, {
			"Go to "..cl(64,41),
			"	a. Talk to Nutral",
			"		i. Get the Shattrath City Flight Path",
			completion={{flightpath="Shattrath City"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=41110510,
		}, {
			"Go outside to Terokkar Forest",
			completion={{location={mapzone="Terokkar Forest"}}},
			mapzone="Shattrath City",
			level=63,
		}, {
			"Go northeast to "..cl(39,8),
			"	a. Kill Shimmerscale Eels",
			"	b. Get 8 Pristine Shimmerscale Eels",
			completion={{questgoal={"*","Pristine Shimmerscale Eel",8}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=8504710,
		}, {
			"Go southeast to "..cl(44,26),
			"	a. Talk to Earthbinder Tavgren",
			"		i. Turn in "..cq("What's Wrong at Cenarion Thicket?"),
			"		ii. Accept "..cq("Strange Energy"),
			"		iii. Accept "..cq("Clues in the Thicket"),
			completion={{questturnedin="What's Wrong at Cenarion Thicket?"},{questaccepted="Strange Energy"},{questaccepted="Clues in the Thicket"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=26307060,
		}, {
			"Go northeast to "..cl(45,23),
			"	a. Talk to Warden Treelos",
			"		i. Accept "..cq("It's Watching You!"),
			completion={{questaccepted="It's Watching You!"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=22506750,
		}, {
			"Go north to "..cl(45,22),
			"	a. Click the Strange Object",
			"	b. Examine the Strange Object",
			completion={{questgoal={"*","Strange Object examined",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=21806690,
		}, {
			"Go south to "..cl(44,26),
			"	a. Talk to Earthbinder Tavgren",
			"		i. Turn in "..cq("Clues in the Thicket"),
			completion={{questturnedin="Clues in the Thicket"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=26307060,
		}, {
			"Go north "..cl(43,22),
			"	a. Kill Naphthal'ar",
			completion={{questgoal={"*","Naphthal'ar slain",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=22106550,
		}, {
			"Go east to "..cl(45,23),
			"	a. Talk to Warden Treelos",
			"		i. Turn in "..cq("It's Watching You!"),
			completion={{questturnedin="It's Watching You!"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=22506750,
		}, {
			"Go southwest to "..cl(44,24),
			"	a. Kill Vicious Teromoths",
			"	b. Get 4 Vicious Teromoth Samples",
			completion={{questgoal={"*","Vicious Teromoth Sample",4}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=23806790,
		}, {
			"Go southeast to "..cl(46,30),
			"	a. Kill Teromoths",
			"	b. Get 4 Teromoth Samples",
			completion={{questgoal={"*","Teromoth Sample",4}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=29807560,
		}, {
			"Go northwest to "..cl(44,26),
			"	a. Talk to Earthbinder Tavgren",
			"		i. Turn in "..cq("Strange Energy"),
			"		ii. Accept "..cq("By Any Means Necessary"),
			completion={{questturnedin="Strange Energy"},{questaccepted="By Any Means Necessary"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=26307060,
		}, {
			"Go east to "..cl(47,27),
			"	a. Talk to Empoor",
			"	b. Fight Empoor until he's almost dead",
			"	c. Talk to Empoor",
			"		i. Turn in "..cq("By Any Means Necessary"),
			"		ii. Accept "..cq("Wind Trader Lathrai"),
			completion={{questturnedin="By Any Means Necessary"},{questaccepted="Wind Trader Lathrai"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=27007410,
		}, {
			"Go northeast to "..cl(50,19),
			"	a. The path up to the Eye of Veil Reskk starts here",
			completion={{location={mapzone="Terokkar Forest",x=49.9,y=16.5, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=16506640,
		}, {
			"Go northeast to "..cl(50,19),
			"	a. Get the Eye of Veil Reskk",
			completion={{questgoal={"*","Eye of Veil Reskk",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=19406950,
		}, {
			"Go southeast to "..cl(58,23),
			"	a. Get the Eye of Shienor",
			completion={{questgoal={"*","Eye of Veil Shienor",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=23208110,
		}, {
			"Go to Shattrath City",
			completion={{location={mapzone="Shattrath City"}}},
			mapzone="Terokkar Forest",
			level=63,
		}, {
			"Go to "..cl(53,21),
			"	a. Talk to Rilak the Redeemed",
			"		i. Turn in "..cq("The Eyes of Skettis"),
			"		ii. Accept "..cq("Seek Out Kirrik"),
			completion={{questturnedin="The Eyes of Skettis"},{questaccepted="Seek Out Kirrik"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=21007360,
		}, {
			"Go to "..cl(64,15),
			"	a. Talk to Seth",
			"		i. Turn in "..cq("Rather Be Fishin'"),
			completion={{questturnedin="Rather Be Fishin'"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=15507950,
		}, {
			"Go to "..cl(72,31),
			"	a. Talk to Wind Trader Lathrai",
			"		i. Turn in "..cq("Wind Trader Lathrai"),
			"		ii. Accept "..cq("A Personal Favor"),
			completion={{questturnedin="Wind Trader Lathrai"},{questaccepted="A Personal Favor"}},
			mapzone="Shattrath City",
			level=63,
			mapnote=30710290,
		}, {
			"Go outside to Terokkar Forest",
			completion={{location={mapzone="Terokkar Forest"}}},
			mapzone="Shattrath City",
			level=63,
		}, {
			"Go southeast to "..cl(37,51),
			"	a. Talk to Kirrik the Awakened",
			"		i. Turn in "..cq("Seek Out Kirrik"),
			"		ii. Accept "..cq("Veil Skith: Darkstone of Terokk"),
			completion={{questturnedin="Seek Out Kirrik"},{questaccepted="Veil Skith: Darkstone of Terokk"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51508890,
		}, {
			"Go to "..cl(38,51),
			"	a. Talk to Ethan",
			"		i. Accept "..cq("Missing Friends"),
			completion={{questaccepted="Missing Friends"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51308900,
		}, {
			"Go to "..cl(37,51),
			"	a. Talk to Mekeda",
			"		i. Accept "..cq("Before Darkness Falls"),
			completion={{questaccepted="Before Darkness Falls"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51208860,
		}, {
			"Go to "..cl(38,52),
			"	a. Talk to Lakotae",
			"		i. Accept "..cq("The Infested Protectors"),
			completion={{questaccepted="The Infested Protectors"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51708960,
		}, {
			"Go northwest to "..cl(35,49),
			"	a. Kill Infested Root-Walkers",
			"	b. Kill the Wood Mites that come out of their corpses",
			"	c. Kill 25 Wood Mites",
			completion={{questgoal={"*","Wood Mite slain",25}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=48808400,
		}, {
			"Go southwest to "..cl(35,53),
			"	a. Kill Cabal orcs",
			"	b. Get the Cabal Orders",
			"	c. Click the Cabal Orders",
			"		i. Accept "..cq("Cabal Orders"),
			"	d. Kill 8 Cabal Skirmishers",
			completion={{questgoal={"*","Cabal Skirmisher slain",8}},{questaccepted="Cabal Orders"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=52808500,
		}, {
			"Go east to "..cl(37,51),
			"	a. Talk to Mekeda",
			"		i. Turn in "..cq("Cabal Orders"),
			"		ii. Accept "..cq("The Shadow Tomb"),
			completion={{questturnedin="Cabal Orders"},{questaccepted="The Shadow Tomb"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51208860,
		}, {
			"Go to "..cl(38,52),
			"	a. Talk to Lakotae",
			"		i. Turn in "..cq("The Infested Protectors"),
			completion={{questturnedin="The Infested Protectors"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51708960,
		}, {
			"Go southeast to "..cl(39,55),
			"	a. Kill 4 Cabal Spell-weavers",
			"	b. Kill 2 Cabal Initiates",
			completion={{questgoal={"*","Cabal Spell-weaver slain",4}},{questgoal={"*","Cabal Initiate slain",2}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=55109450,
		}, {
			"Go northwest to "..cl(37,51),
			"	a. Talk to Mekeda",
			"		i. Turn in "..cq("Before Darkness Falls"),
			completion={{questturnedin="Before Darkness Falls"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51208860,
		}, {
			"Find a partner if you can't solo the next few things",
			mapzone="Terokkar Forest",
			level=63,
		}, {
			"Go west to "..cl(30,52),
			"	a. Click the Cabal Chest",
			"	b. Get the Gavel of K'alen",
			completion={{questgoal={"*","Gavel of K'alen",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51708140,
		}, {
			"Go east to "..cl(32,51),
			"	a. Click the Cabal Chest",
			"	b. Get the Drape of Arunen",
			completion={{questgoal={"*","Drape of Arunen",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51208330,
		}, {
			"Go north to "..cl(31,47),
			"	a. Click the Cabal Chest",
			"	b. Get the Scroll of Atalor",
			completion={{questgoal={"*","Scroll of Atalor",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=46707790,
		}, {
			"Go east to "..cl(37,51),
			"	a. Talk to Mekeda",
			"		i. Turn in "..cq("The Shadow Tomb"),
			completion={{questturnedin="The Shadow Tomb"}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=51208860,
		}, {
			"Go northwest to "..cl(32,42),
			"	a. Kill arakkoas",
			"	b. Get 5 Lathrai's Stolen Goods",
			"	c. Get Veil Skith Prison Keys",
			"	d. Click the yellow cages",
			"	e. Rescue 12 Children",
			completion={{questgoal={"*","Lathrai's Stolen Goods",5}},{questgoal={"*","Children Rescued",12}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=41707400,
		}, {
			"Go west to "..cl(31,42),
			"	a. Use the Rod of Purification on the Darkstone of Terokk",
			"	b. Purify the Darkstone of Terokk",
			completion={{questgoal={"*","Attempt to purify the Darkstone of Terrok",1}}},
			mapzone="Terokkar Forest",
			level=63,
			mapnote=42107290,
		}, {
			"Grind to level 64",
			completion={{level=64}},
			mapzone="Terokkar Forest",
			level=63,
		}
	  },
	},
	{ sectiontitle = "Levels (64-66)",
	  steps = {
		{
			"Go southeast to "..cl(37,51),
			"	a. Talk to Kirrik the Awakened",
			"		i. Turn in "..cq("Veil Skith: Darkstone of Terokk"),
			"		ii. Accept "..cq("Veil Rhaze: Unliving Evil"),
			completion={{questturnedin="Veil Skith: Darkstone of Terokk"},{questaccepted="Veil Rhaze: Unliving Evil"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51508890,
		}, {
			"Go to "..cl(38,51),
			"	a. Talk to Ethan",
			"		i. Turn in "..cq("Missing Friends"),
			completion={{questturnedin="Missing Friends"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51308900,
		}, {
			"Go west to "..cl(30,51),
			"	a. Kill 4 Deathtalon Spirits",
			"	b. Kill 4 Screeching Spirits",
			"	c. Kill 2 Spirit Ravens",
			completion={{questgoal={"*","Deathtalon Spirit slain",4}},{questgoal={"*","Screeching Spirit slain",4}},{questgoal={"*","Spirit Raven slain",2}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51108130,
		}, {
			"Go east to "..cl(37,51),
			"	a. Talk to Kirrik the Awakened",
			"		i. Turn in "..cq("Veil Rhaze: Unliving Evil"),
			"		ii. Accept "..cq("Veil Lithic: Preemptive Strike"),
			completion={{questturnedin="Veil Rhaze: Unliving Evil"},{questaccepted="Veil Lithic: Preemptive Strike"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51508890,
		}, {
			"Go southwest to "..cl(24,70),
			"	a. Open the eggs on the ground",
			"	b. Redeem 3 Hatchlings",
			"	c. Kill 3 Malevolent Hatchlings",
			completion={{questgoal={"*","Hatchlings Redeemed",3}},{questgoal={"*","Malevolent Hatchling slain",3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=70509470,
		}, {
			"Go southeast to "..cl(31,76),
			"	a. Talk to Commander Ra'vaj",
			"		i. Accept "..cq("An Improper Burial"),
			"	b. Talk to Chief Archaeologist Letoll",
			"		i. Accept "..cq("Digging Through Bones"),
			"	c. Escort the Archaeologists",
			"	d. Talk to Dwarfowitz",
			"		i. Turn in "..cq("Digging Through Bones"),
			completion={{questaccepted="An Improper Burial"},{questaccepted="Digging Through Bones"},{questgoal={"*","Protect the Explorers",1}},{questturnedin="Digging Through Bones"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=76110710,
		}, {
			"Go east to "..cl(35,76),
			"	a. Use your Sha'tari Torch on corpses",
			"	b. Burn 8 Slain Sha'tari Vindicator corpses",
			"	c. Burn 8 Slain Auchenai Warrior corpses",
			completion={{questgoal={"*","Slain Sha'tar Vindicator corpse burned",8}},{questgoal={"*","Slain Auchenai Warrior corpse burned",8}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=76511150,
		}, {
			"Go west to "..cl(31,76),
			"	a. Talk to Commander Ra'vaj",
			"		i. Turn in "..cq("An Improper Burial"),
			"		ii. Accept "..cq("A Hero Is Needed"),
			completion={{questturnedin="An Improper Burial"},{questaccepted="A Hero Is Needed"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=76110710,
		}, {
			"Go east to "..cl(37,74),
			"	a. Kill 12 Auchenai Initiates",
			"	b. Kill 5 Auchenai Doomsayers",
			completion={{questgoal={"*","Auchenai Initiate slain",12}},{questgoal={"*","Auchenai Doomsayer slain",5}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=74411110,
		}, {
			"Go west to "..cl(31,76),
			"	a. Talk to Commander Ra'vaj",
			"		i. Turn in "..cq("A Hero Is Needed"),
			"		ii. Accept "..cq("The Fallen Exarch"),
			completion={{questturnedin="A Hero Is Needed"},{questaccepted="The Fallen Exarch"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=76110710,
		}, {
			"Go northeast to "..cl(36,66),
			"	a. Click the black coffin",
			"	b. Kill the Reanimated Exarch that appears",
			completion={{questgoal={"*","Contents of the Auchenai Coffin destroyed",1}},{questgoal={"*","Reanimated Exarch slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=65710160,
		}, {
			"Go southwest to "..cl(31,76),
			"	a. Talk to Commander Ra'vaj",
			"		i. Turn in "..cq("The Fallen Exarch"),
			completion={{questturnedin="The Fallen Exarch"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=76110710,
		}, {
			"Go northeast to "..cl(37,51),
			"	a. Talk to Kirrik the Awakened",
			"		i. Turn in "..cq("Veil Lithic: Preemptive Strike"),
			"		ii. Accept "..cq("Veil Shalas: Signal Fires"),
			completion={{questturnedin="Veil Lithic: Preemptive Strike"},{questaccepted="Veil Shalas: Signal Fires"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51508890,
		}, {
			"Also at "..cl(37,51),
			"	a. Talk to High Priest Orglum",
			"		i. Accept "..cq("The Tomb of Lights"),
			completion={{questaccepted="The Tomb of Lights"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=50808830,
		}, {
			"Go southeast to "..cl(46,57),
			"	a. Kill 10 Ethereal Nethermancers",
			"	b. Kill 10 Ethereal Plunderers",
			completion={{questgoal={"*","Ethereal Nethermancer slain",10}},{questgoal={"*","Ethereal Plunderer slain",10}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=56510280,
		}, {
			"Go southeast to "..cl(55,66),
			"	a. The path up to Veil Shalas starts here",
			completion={{location={mapzone="Terokkar Forest",x=54.9,y=66.0, dist=0.5}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=66112100,
		}, {
			"Go northeast to "..cl(57,65),
			"	a. The path up to the Sapphire Signal Fire starts here",
			completion={{location={mapzone="Terokkar Forest",x=57.3,y=65.0, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=65012230,
		}, {
			"Go to "..cl(55,67),
			"	a. Click the Sapphire Signal Fire",
			"	b. Extinguish the Sapphire Signal Fire",
			completion={{questgoal={"*","Sapphire Fire Extinguished",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=67112230,
		}, {
			"Go southeast to "..cl(57,72),
			"	a. The path up to the Emerald Signal Fire starts here",
			completion={{location={mapzone="Terokkar Forest",x=57.0,y=71.8, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=71812880,
		}, {
			"Go to "..cl(56,70),
			"	a. Click the Emerald Signal Fire",
			"	b. Extinguish the Emerald Signal Fire",
			completion={{questgoal={"*","Emerald Fire Extinguished",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=69712520,
		}, {
			"Go south to "..cl(56,73),
			"	a. The path up to the Bloodstone and Violet Signal Fires starts here",
			completion={{location={mapzone="Terokkar Forest",x=56.0,y=72.7, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=72712870,
		}, {
			"Also at "..cl(56,73),
			"	a. Go up the path",
			"	b. Click the Bloodstone Signal Fire",
			completion={{questgoal={"*","Bloodstone Fire Extinguished",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=72412850,
		}, {
			"Go to "..cl(57,69),
			"	a. Click the Violet Signal Fire",
			"	b. Extinguish the Violet Signal Fire",
			completion={{questgoal={"*","Violet Fire Extinguished",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=69212590,
		}, {
			"Go northwest to "..cl(37,51),
			"	a. Talk to Kirrik the Awakened",
			"		i. Turn in "..cq("Veil Shalas: Signal Fires"),
			"		ii. Accept "..cq("Return to Shattrath"),
			completion={{questturnedin="Veil Shalas: Signal Fires"},{questaccepted="Return to Shattrath"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51508890,
		}, {
			"Also at "..cl(37,51),
			"	a. Talk to High Priest Orglum",
			"		i. Turn in "..cq("The Tomb of Lights"),
			completion={{questturnedin="The Tomb of Lights"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=50808830,
		}, {
			"Go east to "..cl(51,52),
			"	a. The path up to Stonebreaker Hold starts here",
			completion={{location={mapzone="Terokkar Forest",x=51.1,y=51.6, dist=0.5}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51610270,
		}, {
			"Go north to Stonebreaker Hold",
			completion={{location={mapzone="Terokkar Forest",x=49.2,y=45.3, dist=2.5}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go to "..cl(50,46),
			"	a. Talk to Malukaz",
			"		i. Accept "..cq("Vestments of the Wolf Spirit"),
			completion={{questaccepted="Vestments of the Wolf Spirit"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=46409660,
		}, {
			"Go to "..cl(50,45),
			"	a. Talk to Rakoria",
			"		i. Accept "..cq("Olemba Seed Oil"),
			completion={{questaccepted="Olemba Seed Oil"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=44909500,
		}, {
			"Also at "..cl(50,45),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("Wanted: Bonelashers Dead!"),
			completion={{questaccepted="Wanted: Bonelashers Dead!"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45309510,
		}, {
			"Go to "..cl(50,43),
			"	a. Talk to Mokasa",
			"		i. Turn in "..cq("News from Zangarmarsh"),
			completion={{questturnedin="News from Zangarmarsh"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=43309300,
		}, {
			"Go to "..cl(49,43),
			"	a. Talk to Kerna",
			"		i. Get the Stonebreaker Hold Flight Path",
			completion={{flightpath="Stonebreaker Hold"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=43409260,
		}, {
			"Go to "..cl(49,45),
			"	a. Talk to Rokag",
			"		i. Accept "..cq("Stymying the Arakkoa"),
			"	b. Talk to Advisor Faila",
			"		i. Accept "..cq("Speak with Scout Neftis"),
			"		ii. Accept "..cq("Arakkoa War Path"),
			completion={{questaccepted="Stymying the Arakkoa"},{questaccepted="Speak with Scout Neftis"},{questaccepted="Arakkoa War Path"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=44609360,
		}, {
			"Go to "..cl(49,46),
			"	a. Talk to Kurgatok",
			"		i. Accept "..cq("An Unwelcome Presence"),
			"		ii. Accept "..cq("Magical Disturbances"),
			completion={{questaccepted="An Unwelcome Presence"},{questaccepted="Magical Disturbances"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45709450,
		}, {
			"Make Stonebreaker Hold your home",
			completion={{home="Stonebreaker Hold"}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Fly to Shattrath City",
			completion={{location={mapzone="Shattrath City"}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go to "..cl(72,31),
			"	a. Talk to Wind Trader Lathrai",
			"		i. Turn in "..cq("A Personal Favor"),
			"		ii. Accept "..cq("Investigate Tuurem"),
			completion={{questturnedin="A Personal Favor"},{questaccepted="Investigate Tuurem"}},
			mapzone="Shattrath City",
			level=64,
			mapnote=30710290,
		}, {
			"Go to "..cl(53,21),
			"	a. Talk to Rilak the Redeemed",
			"		i. Turn in "..cq("Return to Shattrath"),
			"	b. Talk to Defender Grashna",
			"		i. Accept "..cq("The Skettis Offensive"),
			"	c. You will need help so get a parter",
			"	d. Kill the little birds that come to attack",
			"	e. Kill the big bird that attacks last",
			"	f. Thwart the Attack",
			"	g. Talk to Rilak the Redeemed",
			"		i. Turn in "..cq("The Skettis Offensive"),
			completion={{questturnedin="Return to Shattrath"},{questaccepted="The Skettis Offensive"},{questgoal={"*","Attack thwarted",1}},{questturnedin="The Skettis Offensive"}},
			mapzone="Shattrath City",
			level=64,
			mapnote=21007360,
		}, {
			"Fly to Stonebreaker Hold",
			completion={{location={mapzone="Terokkar Forest",x=49.2,y=45.3, dist=2.5}}},
			mapzone="Shattrath City",
			level=64,
		}, {
			"Go southwest to "..cl(41,51),
			"	a. Kill 20 Bonelashers",
			completion={{questgoal={"*","Bonelasher slain",20}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=51609320,
		}, {
			"Go northwest to "..cl(35,43),
			"	a. Click the Olemba Cones",
			"	b. Get 30 Olemba Seeds",
			"	c. Kill Timber Worg Alphas",
			"	d. Get 12 Timber Worg Pelts",
			"	e. Kill 10 Warp Stalkers",
			completion={{questgoal={"*","Olemba Seed",30}},{questgoal={"*","Timber Worg Pelt",12}},{questgoal={"*","Warp Stalker slain",10}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42807770,
		}, {
			"Go west to "..cl(30,42),
			"	a. The path up to Urdak starts here",
			completion={{location={mapzone="Terokkar Forest",x=30.1,y=42.5, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42807270,
		}, {
			"Go east to "..cl(31,42),
			"	a. Kill Urdak",
			completion={{questgoal={"*","Urdak slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42507390,
		}, {
			"Go east to "..cl(39,44),
			"	a. Talk to Scout Neftis",
			"		i. Turn in "..cq("Speak with Scout Neftis"),
			"		ii. Accept "..cq("Who Are They?"),
			completion={{questturnedin="Speak with Scout Neftis"},{questaccepted="Who Are They?"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=43708270,
		}, {
			"She puts an orc disguise on you",
			"	a. Be careful, the hunter in the camp can see through the disguise",
			"	b. The hunter is the guy walking around with a group of people",
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go north to "..cl(40,39),
			"	a. Talk to the Shadowy Advisor",
			completion={{questgoal={"*","Shadowy Advisor Spoken To",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=39107940,
		}, {
			"Go west to "..cl(39,40),
			"	a. Talk to the Shadowy Initiate",
			completion={{questgoal={"*","Shadowy Initiate Spoken To",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=39707870,
		}, {
			"Go west to "..cl(38,39),
			"	a. Talk to the Shadowy Laborer",
			"	b. He walks around here",
			completion={{questgoal={"*","Shadowy Laborer Spoken To",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=39307770,
		}, {
			"Go southeast to "..cl(39,44),
			"	a. Talk to Scout Neftis",
			"		i. Turn in "..cq("Who Are They?"),
			"		ii. Accept "..cq("Kill the Shadow Council!"),
			completion={{questturnedin="Who Are They?"},{questaccepted="Kill the Shadow Council!"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=43708270,
		}, {
			"Go north to "..cl(40,41),
			"	a. Kill 10 Shadowy Executioners",
			"	b. Kill 10 Shadowy Summoners",
			completion={{questgoal={"*","Shadowy Executioner slain",10}},{questgoal={"*","Shadowy Summoner slain",10}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=40808060,
		}, {
			"Go north to "..cl(40,39),
			"	a. Kill Shadowmaster Grieve",
			completion={{questgoal={"*","Shadowmaster Grieve slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=39107940,
		}, {
			"Go northeast to "..cl(54,30),
			"	a. Click the Sealed Box",
			"	b. Get the Sealed Box",
			completion={{questgoal={"*","Sealed Box",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=30008400,
		}, {
			"Go west to "..cl(44,26),
			"	a. Talk to Earthbinder Tavgren",
			"		i. Turn in "..cq("Investigate Tuurem"),
			"		ii. Accept "..cq("What Are These Things?"),
			completion={{questturnedin="Investigate Tuurem"},{questaccepted="What Are These Things?"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=26307060,
		}, {
			"Go northeast to "..cl(49,18),
			"	a. Kill 14 Shienor Talonites",
			"	b. Kill 6 Shienor Sorcerers",
			completion={{questgoal={"*","Shienor Talonite slain",14}},{questgoal={"*","Shienor Sorcerer slain",6}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=17306620,
		}, {
			"Go northeast to "..cl(50,16),
			"	a. The path up to Ashkaz starts here",
			completion={{location={mapzone="Terokkar Forest",x=49.9,y=16.5, dist=0.3}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=16506640,
		}, {
			"Go to "..cl(49,17),
			"	a. Kill Ashkaz",
			completion={{questgoal={"*","Ashkaz slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=16906600,
		}, {
			"Go southeast to "..cl(59,23),
			"	a. Kill Ayit",
			completion={{questgoal={"*","Ayit slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=23408280,
		}, {
			"Go southeast to "..cl(65,51),
			"	a. Kill 12 Warped Peons",
			completion={{questgoal={"*","Warped Peon slain",12}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=50611610,
		}, {
			"Go northwest to "..cl(63,43),
			"	a. Talk to Shadowstalker Kaide",
			"		i. Turn in "..cq("An Unwelcome Presence"),
			"		ii. Accept "..cq("The Firewing Liaison"),
			"		iii. Accept "..cq("What Happens in Terokkar Stays in Terokkar"),
			completion={{questturnedin="An Unwelcome Presence"},{questaccepted="The Firewing Liaison"},{questaccepted="What Happens in Terokkar Stays in Terokkar"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42710610,
		}, {
			"Go southeast to "..cl(69,53),
			"	a. Kill 10 Bonechaser Devastators",
			"	b. Kill 6 Bonechewer Backbreakers",
			completion={{questgoal={"*","Bonechewer Devastator slain",10}},{questgoal={"*","Bonechewer Backbreaker slain",6}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=53012210,
		}, {
			"Go west to "..cl(68,53),
			"	a. Kill Lisaile Fireweaver",
			completion={{questgoal={"*","Lisaile Fireweaver slain",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=53212120,
		}, {
			"Go northwest to "..cl(63,43),
			"	a. Talk to Shadowstalker Kaide",
			"		i. Turn in "..cq("The Firewing Liaison"),
			"		ii. Turn in "..cq("What Happens in Terokkar Stays in Terokkar"),
			completion={{questturnedin="The Firewing Liaison"},{questturnedin="What Happens in Terokkar Stays in Terokkar"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42710610,
		}, {
			"Hearth to Stonebreaker Hold",
			completion={{location={mapzone="Terokkar Forest",x=49.2,y=45.3, dist=2.5}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go to "..cl(49,45),
			"	a. Talk to Advisor Faila",
			"		i. Turn in "..cq("Kill the Shadow Council!"),
			"		ii. Turn in "..cq("Arakkoa War Path"),
			"	b. Talk to Rokag",
			"		i. Turn in "..cq("Stymying the Arakkoa"),
			completion={{questturnedin="Kill the Shadow Council!"},{questturnedin="Arakkoa War Path"},{questturnedin="Stymying the Arakkoa"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=44609360,
		}, {
			"Go to "..cl(49,46),
			"	a. Talk to Kurgatok",
			"		i. Turn in "..cq("Magical Disturbances"),
			completion={{questturnedin="Magical Disturbances"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45709450,
		}, {
			"Also at "..cl(49,46),
			"	a. Talk to Mawg Grimshot",
			"		i. Turn in "..cq("Wanted: Bonelashers Dead!"),
			completion={{questturnedin="Wanted: Bonelashers Dead!"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45909520,
		}, {
			"Go to "..cl(50,46),
			"	a. Talk to Malukaz",
			"		i. Turn in "..cq("Vestments of the Wolf Spirit"),
			"		ii. Accept "..cq("Patriarch Ironjaw"),
			completion={{questturnedin="Vestments of the Wolf Spirit"},{questaccepted="Patriarch Ironjaw"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=46409660,
		}, {
			"Also at "..cl(50,46),
			"	a. Talk to Tooki",
			"		i. Turn in "..cq("What Are These Things?"),
			"		ii. Accept "..cq("Report to Stonebreaker Camp"),
			completion={{questturnedin="What Are These Things?"},{questaccepted="Report to Stonebreaker Camp"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45909590,
		}, {
			"Go to "..cl(50,45),
			"	a. Talk to Rakoria",
			"		i. Turn in "..cq("Olemba Seed Oil"),
			"		ii. Accept "..cq("And Now, the Moment of Truth"),
			completion={{questturnedin="Olemba Seed Oil"},{questaccepted="And Now, the Moment of Truth"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=44909500,
		}, {
			"Also at "..cl(50,45),
			"	a. Talk to Grek",
			"		i. Ask him to try the weapon oil",
			completion={{questgoal={"*","Have Grek Test Olemba Oil",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45309510,
		}, {
			"Also at "..cl(50,45),
			"	a. Talk to Rakoria",
			"		i. Turn in "..cq("And Now, the Moment of Truth"),
			completion={{questturnedin="And Now, the Moment of Truth"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=44909500,
		}, {
			"Go east to "..cl(63,42),
			"	a. Talk to Sergeant Chawni",
			"		i. Turn in "..cq("Report to Stonebreaker Camp"),
			"		ii. Accept "..cq("Attack on Firewing Point"),
			completion={{questturnedin="Report to Stonebreaker Camp"},{questaccepted="Attack on Firewing Point"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42410570,
		}, {
			"Go northeast to "..cl(66,34),
			"	a. Kill Ironjaw",
			"	b. Get Ironjaw's Pelt",
			completion={{questgoal={"*","Ironjaw's Pelt",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=34710100,
		}, {
			"Go southeast to "..cl(68,36),
			"	a. Kill 10 Firewing Defenders",
			"	b. Kill 10 Firewing Bloodwarders",
			"	c. Kill 10 Firewing Warlocks",
			completion={{questgoal={"*","Firewing Defender slain",10}},{questgoal={"*","Firewing Bloodwarder slain",10}},{questgoal={"*","Firewing Warlock slain",10}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=36510460,
		}, {
			"Go southwest to "..cl(62,42),
			"	a. Talk to Sergeant Chawni",
			"		i. Turn in "..cq("Attack on Firewing Point"),
			"		ii. Accept "..cq("The Final Code"),
			completion={{questturnedin="Attack on Firewing Point"},{questaccepted="The Final Code"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=42410570,
		}, {
			"Go northeast to "..cl(73,34),
			"	a. Click the Orb of Translocation",
			"	b. It will teleport you to the top of the tower",
			mapzone="Terokkar Forest",
			level=64,
			mapnote=34610790,
		}, {
			"Go to "..cl(74,36),
			"	a. Kill Sharth Voldoun",
			"	b. Get the Final Code",
			completion={{item={"The Final Code",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=35810970,
		}, {
			"Go to "..cl(74,37),
			"	a. Click the Orb of Translocation",
			"	b. It will teleport you to the bottom of the tower",
			mapzone="Terokkar Forest",
			level=64,
			mapnote=36511070,
		}, {
			"Go west to "..cl(71,34),
			"	a. Click the Mana Bomb",
			"	b. Activate the Mana Bomb using the Final Code",
			completion={{questgoal={"*","Mana Bomb Activated",1}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=37410870,
		}, {
			"Grind here until you have 20 Firewing Signets",
			completion={{item={"Firewing Signet",20}}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=37810880,
		}, {
			"Go west to Stonebreaker Hold",
			completion={{location={mapzone="Terokkar Forest",x=49.2,y=45.3, dist=2.5}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go to "..cl(50,46),
			"	a. Talk to Tooki",
			"		i. Turn in "..cq("The Final Code"),
			"		ii. Accept "..cq("Letting Earthbinder Tavgren Know"),
			completion={{questturnedin="The Final Code"},{questaccepted="Letting Earthbinder Tavgren Know"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=45909590,
		}, {
			"Also at "..cl(50,46),
			"	a. Talk to Malukaz",
			"		i. Turn in "..cq("Patriarch Ironjaw"),
			"		ii. Accept "..cq("Welcoming the Wolf Spirit"),
			"	c. Stand next to the little white candles next to Malukaz",
			"	d. Use the Ceremonial Incense he gave you",
			"	e. Watch the Wolf talk to Malukaz",
			"	f. Talk to Malukaz",
			"		i. Turn in "..cq("Welcoming the Wolf Spirit"),
			completion={{questturnedin="Patriarch Ironjaw"},{questaccepted="Welcoming the Wolf Spirit"},{questgoal={"*","Help Malukaz summon the Wolf Spirit",1}},{questturnedin="Welcoming the Wolf Spirit"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=46409660,
		}, {
			"Fly to Shattrath City",
			completion={{location={mapzone="Shattrath City"}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go outside to Terokkar Forest",
			completion={{location={mapzone="Terokkar Forest"}}},
			mapzone="Shattrath City",
			level=64,
		}, {
			"Go to "..cl(44,26),
			"	a. Talk to Earthbinder Tavgren",
			"		i. Turn in "..cq("Letting Earthbinder Tavgren Know"),
			completion={{questturnedin="Letting Earthbinder Tavgren Know"}},
			mapzone="Terokkar Forest",
			level=64,
			mapnote=26307060,
		}, {
			"Go west to Shattrath City",
			completion={{location={mapzone="Shattrath City"}}},
			mapzone="Terokkar Forest",
			level=64,
		}, {
			"Go to "..cl(45,81),
			"	a. Talk to Magistrix Fyalenn",
			"		i. Turn in "..cq("Firewing Signets"),
			"		ii. Turn in all your Firewing Signets",
			completion={{questturnedin="Firewing Signets"}},
			mapzone="Shattrath City",
			level=64,
			mapnote=81512670,
		}, {
			"Fly to Zabra'jin",
			completion={{location={mapzone="Zangarmarsh",x=31.7,y=49.8, dist=4}}},
			mapzone="Shattrath City",
			level=64,
		}, {
			"Go to "..cl(32,50),
			"	a. Talk to Messenger Gazgrigg",
			"		i. Accept "..cq("Reinforcements for Garadar"),
			completion={{questaccepted="Reinforcements for Garadar"}},
			mapzone="Zangarmarsh",
			level=64,
			mapnote=50408240,
		}, {
			"Fly to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Zangarmarsh",
			level=64,
		}, {
			"Go southwest to Nagrand",
			completion={{location={mapzone="Nagrand"}}},
			mapzone="Zangarmarsh",
			level=64,
		}, {
			"Go southwest to "..cl(71,41),
			"	a. Talk to Shado 'Fitz' Farstrider",
			"		i. Accept "..cq("Windroc Mastery part 1"),
			"	b. Talk to Hemet Nesingwary",
			"		i. Accept "..cq("Clefthoof Mastery part 1"),
			"	c. Talk to Harold Lane",
			"		i. Accept "..cq("Talbuk Mastery part 1"),
			completion={{questaccepted="Windroc Mastery part 1"},{questaccepted="Clefthoof Mastery part 1"},{questaccepted="Talbuk Mastery part 1"}},
			mapzone="Nagrand",
			level=64,
			mapnote=40511210,
		}, {
			"Go north to "..cl(72,39),
			"	a. Kill 30 Talbuk Stags",
			completion={{questgoal={"*","Talbuk Stag slain",30}}},
			mapzone="Nagrand",
			level=64,
			mapnote=38411060,
		}, {
			"Go west to "..cl(66,39),
			"	a. Kill 30 Windrocs",
			completion={{questgoal={"*","Windroc slain",30}}},
			mapzone="Nagrand",
			level=64,
			mapnote=39510600,
		}, {
			"Go southwest to "..cl(64,45),
			"	a. Kill 30 Clefthoofs",
			"	b. Kill Dust Howlers",
			"	c. Get a Howling Wind",
			"	d. Click the Howling Wind",
			"		i. Accept "..cq("The Howling Wind"),
			"	e. Kill Elekks",
			"	f. Get 3 Pairs of Ivory Tusks",
			completion={{questgoal={"*","Clefthoof slain",30}},{item={"Pair of Ivory Tusks",3}},{questaccepted="The Howling Wind"}},
			mapzone="Nagrand",
			level=64,
			mapnote=45110910,
		}, {
			"Go northeast to "..cl(71,41),
			"	a. Talk to Shado 'Fitz' Farstrider",
			"		i. Turn in "..cq("Windroc Mastery part 1"),
			"		ii. Accept "..cq("Windroc Mastery part 2"),
			"	b. Talk to Hemet Nesingwary",
			"		i. Turn in "..cq("Clefthoof Mastery part 1"),
			"		ii. Accept "..cq("Clefthoof Mastery part 2"),
			"	c. Talk to Harold Lane",
			"		i. Turn in "..cq("Talbuk Mastery part 1"),
			"		ii. Accept "..cq("Talbuk Mastery part 2"),
			completion={{questturnedin="Windroc Mastery part 1"},{questturnedin="Clefthoof Mastery part 1"},{questturnedin="Talbuk Mastery part 1"},{questaccepted="Windroc Mastery part 2"},{questaccepted="Clefthoof Mastery part 2"},{questaccepted="Talbuk Mastery part 2"}},
			mapzone="Nagrand",
			level=64,
			mapnote=40511210,
		}, {
			"Grind to level 65",
			completion={{level=65}},
			mapzone="Nagrand",
			level=64,
		}, {
			"Go northwest to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(57,35),
			"	a. Talk to Matron Drakia",
			"		i. Accept "..cq("Missing Mag'hari Procession"),
			completion={{questaccepted="Missing Mag'hari Procession"}},
			mapzone="Nagrand",
			level=65,
			mapnote=34909200,
		}, {
			"Make Garadar your home",
			completion={{home="Garadar"}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(55,37),
			"	a. Talk to Captain Kroghan",
			"		i. Turn in "..cq("Reinforcements for Garadar"),
			completion={{questturnedin="Reinforcements for Garadar"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37409280,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Jorin Deadeye",
			"		i. Accept "..cq("The Impotent Leader"),
			completion={{questaccepted="The Impotent Leader"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Warden Bullrok",
			"		i. Accept "..cq("Proving Your Strength"),
			"	b. Click the Garadar Bulletin Board",
			"		i. Accept "..cq("Wanted: Giselda the Crone"),
			"		ii. Accept "..cq("Wanted: Zorbo the Advisor"),
			completion={{questaccepted="Proving Your Strength"},{questaccepted="Wanted: Giselda the Crone"},{questaccepted="Wanted: Zorbo the Advisor"}},
			mapzone="Nagrand",
			level=65,
			mapnote=38009380,
		}, {
			"Go to "..cl(55,39),
			"	a. Talk to Elementalist Yal'hah",
			"		i. Accept "..cq("The Throne of the Elements"),
			completion={{questaccepted="The Throne of the Elements"}},
			mapzone="Nagrand",
			level=65,
			mapnote=39009400,
		}, {
			"Go to "..cl(55,40),
			"	a. Talk to Farseer Kurkush",
			"		i. Accept "..cq("Vile Idolatry"),
			"	b. Talk to Farseer Corhuk",
			"		i. Accept "..cq("The Missing War Party"),
			"	c. Talk to Farseer Margadesh",
			"		i. Accept "..cq("Murkblood Leaders..."),
			completion={{questaccepted="Vile Idolatry"},{questaccepted="The Missing War Party"},{questaccepted="Murkblood Leaders..."}},
			mapzone="Nagrand",
			level=65,
			mapnote=39709440,
		}, {
			"Go to "..cl(57,35),
			"	a. Talk to Gursha",
			"		i. Get the Garadar Flight Path",
			completion={{flightpath="Garadar"}},
			mapzone="Nagrand",
			level=65,
			mapnote=35209240,
		}, {
			"Go to "..cl(52,35),
			"	a. Talk to the Consortium Recruiter",
			"		i. Accept "..cq("The Consortium Needs You!"),
			completion={{questaccepted="The Consortium Needs You!"}},
			mapzone="Nagrand",
			level=65,
			mapnote=34808670,
		}, {
			"Go northeast to the Throne of the Elements",
			completion={{location={mapzone="Nagrand",x=60.8,y=22.4, dist=4}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(61,22),
			"	a. Talk to Elementalist Morgh",
			"		i. Turn in "..cq("The Howling Wind"),
			"		ii. Accept "..cq("Murkblood Corrupters"),
			"	b. Talk to Elementalist Sharvak",
			"		i. Turn in "..cq("The Throne of the Elements"),
			"	c. Talk to Elementalist Lo'ap",
			"		i. Accept "..cq("A Rare Bean"),
			"		ii. Accept "..cq("Muck Diving"),
			"	d. Talk to Elementalist Untrag",
			"		i. Accept "..cq("The Underneath"),
			completion={{questturnedin="The Howling Wind"},{questturnedin="The Throne of the Elements"},{questaccepted="Murkblood Corrupters"},{questaccepted="A Rare Bean"},{questaccepted="Muck Diving"},{questaccepted="The Underneath"}},
			mapzone="Nagrand",
			level=65,
			mapnote=22408290,
		}, {
			"Go southeast to "..cl(62,24),
			"	a. Talk to Gordawg",
			"		i. Turn in "..cq("The Underneath"),
			"		ii. Accept "..cq("The Tortured Earth"),
			completion={{questturnedin="The Underneath"},{questaccepted="The Tortured Earth"}},
			mapzone="Nagrand",
			level=65,
			mapnote=24408620,
		}, {
			"Go west to "..cl(52,26),
			"	a. Kill 30 Talbuk Thorngrazers",
			"	b. Click the Dung piles",
			"	c. Get 15 Digested Caracoli",
			completion={{questgoal={"*","Talbuk Thorngrazer slain",30}},{questgoal={"*","Digested Caracoli",15}}},
			mapzone="Nagrand",
			level=65,
			mapnote=25607770,
		}, {
			"Go south to "..cl(51,31),
			"	a. Kill 30 Clefthoof Bulls",
			completion={{questgoal={"*","Clefthoof Bull slain",30}}},
			mapzone="Nagrand",
			level=65,
			mapnote=30808240,
		}, {
			"Go northwest to "..cl(48,21),
			"	a. Kill 10 Warmaul Shamans",
			"	b. Kill 10 Warmaul Reavers",
			"	c. Kill ogres",
			"	d. Get 10 Obsidian Warbeads",
			completion={{questgoal={"*","Warmaul Shaman slain",10}},{questgoal={"*","Warmaul Reaver slain",10}},{questgoal={"*","Obsidian Warbeads",10}}},
			mapzone="Nagrand",
			level=65,
			mapnote=21506980,
		}, {
			"Go northwest to "..cl(46,18),
			"	a. Kill Zorbo the Advisor",
			completion={{questgoal={"*","Zorbo the Advisor slain",10}}},
			mapzone="Nagrand",
			level=65,
			mapnote=18206470,
		}, {
			"Go southwest to "..cl(32,26),
			"	a. Talk to Saurfang the Younger",
			"		i. Turn in "..cq("The Missing War Party"),
			"		ii. Accept "..cq("Once Were Warriors"),
			"	b. Talk to Elder Yorley",
			"		i. Turn in "..cq("Missing Mag'hari Procession"),
			"		ii. Accept "..cq("War on the Warmaul"),
			"	c. Talk to Elder Ungriz",
			"		i. Accept "..cq("Finding the Survivors"),
			completion={{questturnedin="The Missing War Party"},{questturnedin="Missing Mag'hari Procession"},{questaccepted="Once Were Warriors"},{questaccepted="War on the Warmaul"},{questaccepted="Finding the Survivors"}},
			mapzone="Nagrand",
			level=65,
			mapnote=36106850,
		}, {
			"Go north to "..cl(29,31),
			"	a. The path up to 'War on the Warmaul' and 'Finding the Survivors' starts here",
			completion={{location={mapzone="Nagrand",x=29.2,y=31.6, dist=0.5}}},
			mapzone="Nagrand",
			level=65,
			mapnote=31606080,
		}, {
			"Go northwest to "..cl(23,29),
			"	a. Kill 15 Warmaul Brutes",
			"	b. Kill 15 Warmaul Warlocks",
			"	c. Kill ogres",
			"	d. Get Warmaul Prison Keys",
			"	e. Click the yellow cages",
			"	f. Free 15 Mag'har Prisoners",
			completion={{questgoal={"*","Warmaul Brute slain",15}},{questgoal={"*","Warmaul Warlock slain",15}},{questgoal={"*","Mag'har Prisoner Freed",15}}},
			mapzone="Nagrand",
			level=65,
			mapnote=29205260,
		}, {
			"Go southeast to "..cl(32,36),
			"	a. Talk to Elder Yorley",
			"		i. Turn in "..cq("War on the Warmaul"),
			"	b. Talk to Elder Ungriz",
			"		i. Turn in "..cq("Finding the Survivors"),
			completion={{questturnedin="War on the Warmaul"},{questturnedin="Finding the Survivors"}},
			mapzone="Nagrand",
			level=65,
			mapnote=36106850,
		}, {
			"Go southeast to "..cl(41,41),
			"	a. Kill Muck Spawns",
			"	b. Get 5 Muck-ridden Cores",
			completion={{questgoal={"*","Muck-ridden Core",5}}},
			mapzone="Nagrand",
			level=65,
			mapnote=40908240,
		}, {
			"Go west to "..cl(32,39),
			"	a. Kill 40 Murkblood Scavengers",
			"	b. Kill 20 Murkblood Raiders",
			"	c. Kill 8 Murkblood Putrifiers",
			"	d. Kill mobs around this area",
			"	e. Get 20 Murkblood Idols",
			completion={{questgoal={"*","Murkblood Scavenger slain",40}},{questgoal={"*","Murkblood Raider slain",20}},{questgoal={"*","Murkblood Putrifier slain",8}},{questgoal={"*","Murkblood Idol",20}}},
			mapzone="Nagrand",
			level=65,
			mapnote=39107110,
		}, {
			"Go southwest to "..cl(31,42),
			"	a. Kill Ortor of Murkblood",
			"	b. Get the Head of Ortor of Murkblood",
			completion={{questgoal={"*","Head of Ortor of Murkblood",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=42307320,
		}, {
			"Go northeast to "..cl(32,36),
			"	a. Talk to Saurfang the Younger",
			"		i. Turn in "..cq("Once Were Warriors"),
			"		ii. Accept "..cq("He Will Walk The Earth..."),
			completion={{questturnedin="Once Were Warriors"},{questaccepted="He Will Walk The Earth..."}},
			mapzone="Nagrand",
			level=65,
			mapnote=36106850,
		}, {
			"Go south to "..cl(31,58),
			"	a. Talk to Zerid",
			"		i. Accept "..cq("Gava'xi"),
			"		ii. Accept "..cq("Matters of Security"),
			completion={{questaccepted="Gava'xi"},{questaccepted="Matters of Security"}},
			mapzone="Nagrand",
			level=65,
			mapnote=58108890,
		}, {
			"Also at "..cl(31,58),
			"	a. Talk to Gezhe",
			"		i. Turn in "..cq("The Consortium Needs You!"),
			"		ii. Accept "..cq("Stealing from Thieves"),
			completion={{questturnedin="The Consortium Needs You!"},{questaccepted="Stealing from Thieves"}},
			mapzone="Nagrand",
			level=65,
			mapnote=57808920,
		}, {
			"Go to "..cl(32,57),
			"	a. Talk to Shadrek",
			"		i. Accept "..cq("A Head Full of Ivory"),
			"		ii. Turn in "..cq("A Head Full of Ivory"),
			completion={{questaccepted="A Head Full of Ivory"},{questturnedin="A Head Full of Ivory"}},
			mapzone="Nagrand",
			level=65,
			mapnote=56808860,
		}, {
			"Go southeast to "..cl(33,62),
			"	a. Click the Oshu'gun Crystal Fragments",
			"	b. Kill mobs here",
			"	c. Get 10 Oshu'gun Crystal Fragments",
			completion={{questgoal={"*","Oshu'gun Crystal Fragment",10}}},
			mapzone="Nagrand",
			level=65,
			mapnote=62409580,
		}, {
			"Go southwest "..cl(31,68),
			"	a. Kill 12 Voidspawns",
			completion={{questgoal={"*","Voidspawn slain",12}}},
			mapzone="Nagrand",
			level=65,
			mapnote=67509810,
		}, {
			"Go southeast to "..cl(42,73),
			"	a. Kill Gava'xi",
			completion={{questgoal={"*","Gava'xi slain",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=73511590,
		}, {
			"Go northeast to "..cl(48,61),
			"	a. Kill 30 Ravenous Windrocs",
			completion={{questgoal={"*","Ravenous Windroc slain",30}}},
			mapzone="Nagrand",
			level=65,
			mapnote=61510990,
		}, {
			"Go northwest to "..cl(31,58),
			"	a. Talk to Zerid",
			"		i. Turn in "..cq("Gava'xi"),
			"		ii. Turn in "..cq("Matters of Security"),
			completion={{questturnedin="Gava'xi"},{questturnedin="Matters of Security"}},
			mapzone="Nagrand",
			level=65,
			mapnote=58108890,
		}, {
			"Also at "..cl(31,58),
			"	a. Talk to Gezhe",
			"		i. Turn in "..cq("Stealing from Thieves"),
			completion={{questturnedin="Stealing from Thieves"}},
			mapzone="Nagrand",
			level=65,
			mapnote=57808920,
		}, {
			"Go southeast to "..cl(62,67),
			"	a. Talk to Wazat",
			"		i. Accept "..cq("I Must Have Them!"),
			completion={{questaccepted="I Must Have Them!"}},
			mapzone="Nagrand",
			level=65,
			mapnote=67112880,
		}, {
			"Go northeast to "..cl(69,57),
			"	a. Kill a Dust Howler",
			"	b. Get an Air Elemental Gas",
			completion={{item={"Air Elemental Gas",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=56912630,
		}, {
			"Go north to "..cl(70,52),
			"	a. Kill 2 Dust Howlers",
			"	b. Get 2 Air Elemental Gas",
			completion={{item={"Air Elemental Gas",3}}},
			mapzone="Nagrand",
			level=65,
			mapnote=51912150,
		}, {
			"Go southwest to "..cl(62,67),
			"	a. Talk to Wazat",
			"		i. Turn in "..cq("I Must Have Them!"),
			completion={{questturnedin="I Must Have Them!"}},
			mapzone="Nagrand",
			level=65,
			mapnote=67112880,
		}, {
			"Go southeast to "..cl(65,71),
			"	a. Kill 15 Tortured Earth Spirits",
			completion={{questgoal={"*","Tortured Earth Spirit slain",15}}},
			mapzone="Nagrand",
			level=65,
			mapnote=70813620,
		}, {
			"Go southeast to Terokkar Forest",
			completion={{location={mapzone="Terokkar Forest"}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go south to "..cl(20,61),
			"	a. Talk to Kilrath",
			"		i. Turn in "..cq("The Impotent Leader"),
			"		ii. Accept "..cq("Don't Kill the Fat One"),
			completion={{questturnedin="The Impotent Leader"},{questaccepted="Don't Kill the Fat One"}},
			mapzone="Terokkar Forest",
			level=65,
			mapnote=60908070,
		}, {
			"Go south to "..cl(20,63),
			"	a. Kill 10 Boulderfist Invaders",
			"	b. Fight Unkor the Ruthless until he submits",
			"	c. Talk to Unkor the Ruthless",
			"		i. Turn in "..cq("Don't Kill the Fat One"),
			"		ii. Accept "..cq("Success!"),
			completion={{questgoal={"*","Boulderfist Invader slain",10}},{questturnedin="Don't Kill the Fat One"},{questaccepted="Success!"}},
			mapzone="Terokkar Forest",
			level=65,
			mapnote=63108310,
		}, {
			"Go north to "..cl(20,61),
			"	a. Talk to Kilrath",
			"		i. Turn in "..cq("Success!"),
			"		ii. Accept "..cq("Because Kilrath is a Coward"),
			completion={{questturnedin="Success!"},{questaccepted="Because Kilrath is a Coward"}},
			mapzone="Terokkar Forest",
			level=65,
			mapnote=60908070,
		}, {
			"Hearth to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Terokkar Forest",
			level=65,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Jorin Deadeye",
			"		i. Turn in "..cq("Because Kilrath is a Coward"),
			"		ii. Accept "..cq("Message in a Battle"),
			completion={{questturnedin="Because Kilrath is a Coward"},{questaccepted="Message in a Battle"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Also at "..cl(56,38),
			"	a. Talk to Warden Bullrok",
			"		i. Turn in "..cq("Wanted: Zorbo the Advisor"),
			"		ii. Turn in "..cq("Proving Your Strength"),
			completion={{questturnedin="Wanted: Zorbo the Advisor"},{questturnedin="Proving Your Strength"}},
			mapzone="Nagrand",
			level=65,
			mapnote=38009380,
		}, {
			"Also at "..cl(56,38),
			"	a. Talk to Elkay'gan the Mystic",
			"		i. Accept "..cq("Standards and Practices"),
			completion={{questaccepted="Standards and Practices"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Go to "..cl(55,40),
			"	a. Talk to Farseer Kurkush",
			"		i. Turn in "..cq("Vile Idolatry"),
			"	b. Talk to Farseer Corhuk",
			"		i. Turn in "..cq("He Will Walk The Earth..."),
			"	c. Talk to Farseer Margadesh",
			"		i. Turn in "..cq("Murkblood Leaders..."),
			completion={{questturnedin="Vile Idolatry"},{questturnedin="He Will Walk The Earth..."},{questturnedin="Murkblood Leaders..."}},
			mapzone="Nagrand",
			level=65,
			mapnote=39709440,
		}, {
			"If Halaa is under Horde control:",
			"	a. Go southwest to Halaa",
			"	b. Go to "..cl(41,44),
			"	c. Talk to Chief Researcher Amereldine",
			"		i. Accept "..cq("Oshu'gun Crystal Powder"),
			"		ii. Turn in "..cq("Oshu'gun Crystal Powder"),
			"		iii. Turn in all other Oshu'gun Crystal Powder Samples you have",
			completion={{questaccepted="Oshu'gun Crystal Powder"},{questturnedin="Oshu'gun Crystal Powder"}},
			mapzone="Nagrand",
			level=65,
			mapnote=44308550,
		}, {
			"Go east to "..cl(71,40),
			"	a. Talk to Harold Lane",
			"		i. Turn in "..cq("Talbuk Mastery part 2"),
			"	b. Talk to Hemet Nesingwary",
			"		i. Turn in "..cq("Clefthoof Mastery part 2"),
			"	c. Talk to Shado 'Fitz' Farstrider",
			"		i. Turn in "..cq("Windroc Mastery part 2"),
			completion={{questturnedin="Talbuk Mastery part 2"},{questturnedin="Clefthoof Mastery part 2"},{questturnedin="Windroc Mastery part 2"}},
			mapzone="Nagrand",
			level=65,
			mapnote=40511210,
		}, {
			"Go northwest to the Throne of the Elements",
			completion={{location={mapzone="Nagrand",x=60.8,y=22.4, dist=4}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(62,24),
			"	a. Talk to Gordawg",
			"		i. Turn in "..cq("The Tortured Earth"),
			"		ii. Accept "..cq("Eating Damnation"),
			completion={{questturnedin="The Tortured Earth"},{questaccepted="Eating Damnation"}},
			mapzone="Nagrand",
			level=65,
			mapnote=24408620,
		}, {
			"Go to "..cl(61,22),
			"	a. Talk to Elementalist Lo'ap",
			"		i. Turn in "..cq("A Rare Bean"),
			"		ii. Accept "..cq("Agitated Spirits of Skysong"),
			"		iii. Turn in "..cq("Muck Diving"),
			"	b. Talk to Elementalist Morgh",
			"		i. Turn in "..cq("Murkblood Corrupters"),
			completion={{questturnedin="A Rare Bean"},{questturnedin="Muck Diving"},{questturnedin="Murkblood Corrupters"},{questaccepted="Agitated Spirits of Skysong"}},
			mapzone="Nagrand",
			level=65,
			mapnote=22408290,
		}, {
			"Go south to "..cl(60,27),
			"	a. Kill 12 Lake Spirits",
			completion={{questgoal={"*","Lake Spirit slain",12}}},
			mapzone="Nagrand",
			level=65,
			mapnote=27308700,
		}, {
			"Go north to "..cl(61,22),
			"	a. Talk to Elementalist Lo'ap",
			"		i. Turn in "..cq("Agitated Spirits of Skysong"),
			"		ii. Accept "..cq("Blessing of Incineratus"),
			completion={{questturnedin="Agitated Spirits of Skysong"},{questaccepted="Blessing of Incineratus"}},
			mapzone="Nagrand",
			level=65,
			mapnote=22408290,
		}, {
			"Go west to "..cl(52,20),
			"	a. Kill Enraged Crushers",
			"	b. Get 15 Enraged Crusher Cores",
			completion={{questgoal={"*","Enraged Crusher Core",15}}},
			mapzone="Nagrand",
			level=65,
			mapnote=20207220,
		}, {
			"Go southeast to "..cl(62,24),
			"	a. Talk to Gordawg",
			"		i. Turn in "..cq("Eating Damnation"),
			"		ii. Accept "..cq("Shattering the Veil"),
			completion={{questturnedin="Eating Damnation"},{questaccepted="Shattering the Veil"}},
			mapzone="Nagrand",
			level=65,
			mapnote=24408620,
		}, {
			"Go southeast to "..cl(71,51),
			"	a. Go inside the hut",
			"	b. Use your Living Fire",
			"	c. Burn the Western Hut",
			completion={{questgoal={"*","Western Hut Destroyed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=51212200,
		}, {
			"Go east to "..cl(72,50),
			"	a. Go inside the hut",
			"	b. Use your Living Fire",
			"	c. Burn the Large Hut",
			completion={{questgoal={"*","Large Hut Destroyed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=50312270,
		}, {
			"Go south to "..cl(73,55),
			"	a. Go inside the hut",
			"	b. Use your Living Fire",
			"	c. Burn the Eastern Hut",
			completion={{questgoal={"*","Eastern Hut Destroyed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=54712750,
		}, {
			"Go southwest to "..cl(71,53),
			"	a. Go inside the hut",
			"	b. Use your Living Fire",
			"	c. Burn the Southern Hut",
			completion={{questgoal={"*","Southern Hut Destroyed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=53212440,
		}, {
			"Go northwest to the Throne of the Elements",
			completion={{location={mapzone="Nagrand",x=60.8,y=22.4, dist=4}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(61,22),
			"	a. Talk to Elementalist Lo'ap",
			"		i. Turn in "..cq("Blessing of Incineratus"),
			"		ii. Accept "..cq("The Spirit Polluted"),
			completion={{questturnedin="Blessing of Incineratus"},{questaccepted="The Spirit Polluted"}},
			mapzone="Nagrand",
			level=65,
			mapnote=22408290,
		}, {
			"Go east to "..cl(72,70),
			"	a. Use your Mag'har Battle Standard next to the bonfire",
			"	b. Place the First Battle Standard",
			completion={{questgoal={"*","First Battle Standard Placed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=69914200,
		}, {
			"Go east to "..cl(73,70),
			"	a. Kill 15 Boulderfist Mystics",
			"	b. Kill 15 Boulderfist Crushers",
			completion={{questgoal={"*","Boulderfist Mystic slain",15}},{questgoal={"*","Boulderfist Crusher slain",15}}},
			mapzone="Nagrand",
			level=65,
			mapnote=69814270,
		}, {
			"Go east to "..cl(75,70),
			"	a. Use your Mag'har Battle Standard next to the bonfire",
			"	b. Place the Second Battle Standard",
			completion={{questgoal={"*","Second Battle Standard Placed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=69814450,
		}, {
			"Go northeast to "..cl(76,68),
			"	a. Use your Mag'har Battle Standard next to the bonfire",
			"	b. Place the Third Battle Standard",
			completion={{questgoal={"*","Third Battle Standard Placed",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=68414420,
		}, {
			"Go northwest to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Jorin Deadeye",
			"		i. Turn in "..cq("Message in a Battle"),
			"		ii. Accept "..cq("An Audacious Advance"),
			completion={{questturnedin="Message in a Battle"},{questaccepted="An Audacious Advance"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Also at "..cl(56,38),
			"	a. Talk to Elkay'gan the Mystic",
			"		i. Turn in "..cq("Standards and Practices"),
			"		ii. Accept "..cq("Bleeding Hollow Supply Crates"),
			completion={{questturnedin="Standards and Practices"},{questaccepted="Bleeding Hollow Supply Crates"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Go west to "..cl(41,35),
			"	a. Kill 25 Boulderfist Warriors",
			"	b. Kill 25 Boulderfist Mages",
			"	c. Click the Bleeding Hollow Supply Crates",
			"	d. Get 20 Bleeding Hollow Supply Crates",
			completion={{questgoal={"*","Boulderfist Warrior slain",25}},{questgoal={"*","Boulderfist Mage slain",25}},{questgoal={"*","Bleeding Hollow Supply Crate",20}}},
			mapzone="Nagrand",
			level=65,
			mapnote=35607630,
		}, {
			"Go southwest to "..cl(34,49),
			"	a. Kill 10 Lake Surgers",
			completion={{questgoal={"*","Lake Surger slain",10}}},
			mapzone="Nagrand",
			level=65,
			mapnote=48908270,
		}, {
			"Go southwest to "..cl(33,51),
			"	a. Kill Watoosun's Polluted Essence",
			completion={{questgoal={"*","Watoosun's Polluted Essence slain",1}}},
			mapzone="Nagrand",
			level=65,
			mapnote=50808390,
		}, {
			"Go southwest to "..cl(28,77),
			"	a. Use Gordawg's Boulder on Shattered Rumblers",
			"	b. Kill the Minions of Gurok that spawn from their corpses",
			"	c. Kill 30 Minions of Gurok",
			completion={{questgoal={"*","Minion of Gurok slain",30}}},
			mapzone="Nagrand",
			level=65,
			mapnote=77610550,
		}, {
			"Hearth to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Elkay'gan the Mystic",
			"		i. Turn in "..cq("Bleeding Hollow Supply Crates"),
			completion={{questturnedin="Bleeding Hollow Supply Crates"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Also at "..cl(56,38),
			"	a. Talk to Jorin Deadeye",
			"		i. Turn in "..cq("An Audacious Advance"),
			"		ii. Accept "..cq("Diplomatic Measures"),
			completion={{questturnedin="An Audacious Advance"},{questaccepted="Diplomatic Measures"}},
			mapzone="Nagrand",
			level=65,
			mapnote=37609310,
		}, {
			"Go southeast to the Burning Blade Ruins",
			completion={{location={mapzone="Nagrand",x=75.6,y=66.5, dist=5}}},
			mapzone="Nagrand",
			level=65,
		}, {
			"Go to "..cl(74,68),
			"	a. The path up to Lantressor of the Blade starts here",
			completion={{location={mapzone="Nagrand",x=73.8,y=68.1, dist=0.5}}},
			mapzone="Nagrand",
			level=65,
			mapnote=68114190,
		}, {
			"Go north to "..cl(74,62),
			"	a. Talk to Lantressor of the Blade",
			"		i. Listen to his story",
			"		ii. Turn in "..cq("Diplomatic Measures"),
			"		iii. Accept "..cq("Armaments for Deception"),
			"		iv. Accept "..cq("Ruthless Cunning"),
			completion={{questturnedin="Diplomatic Measures"},{questaccepted="Armaments for Deception"},{questaccepted="Ruthless Cunning"}},
			mapzone="Nagrand",
			level=65,
			mapnote=62613640,
		}, {
			"Grind to level 66",
			completion={{level=66}},
			mapzone="Nagrand",
			level=65,
		}
	  },
	},
	{ sectiontitle = "Levels (66-68)",
	  steps = {
		{
			"Go southwest to "..cl(71,79),
			"	a. Click the Kil'sorrow Armaments",
			"	b. Get 20 Kil'sorrow Armaments",
			"	c. Kill 15 Kil'sorrow Agents",
			"	d. Kill Kil'sorrow mobs",
			"	e. Use your Warmaul Ogre Banner on their corpses",
			"	f. Plant 20 Warmaul Ogre Banners",
			completion={{questgoal={"*","Kil'sorrow Armaments",20}},{questgoal={"*","Kil'sorrow Agent slain",15}},{questgoal={"*","Warmaul Ogre Banner Planted",20}}},
			mapzone="Nagrand",
			level=66,
			mapnote=79415080,
		}, {
			"Go south to "..cl(71,82),
			"	a. Kill Giselda the Crone",
			completion={{questgoal={"*","Giselda the Crone slain",1}}},
			mapzone="Nagrand",
			level=66,
			mapnote=82415350,
		}, {
			"Go northeast to "..cl(74,62),
			"	a. Talk to Lantressor of the Blade",
			"		i. Turn in "..cq("Armaments for Deception"),
			"		ii. Turn in "..cq("Ruthless Cunning"),
			"		iii. Accept "..cq("Returning the Favor"),
			"		iv. Accept "..cq("Body of Evidence"),
			completion={{questturnedin="Armaments for Deception"},{questturnedin="Ruthless Cunning"},{questaccepted="Returning the Favor"},{questaccepted="Body of Evidence"}},
			mapzone="Nagrand",
			level=66,
			mapnote=62613640,
		}, {
			"Go northwest to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Nagrand",
			level=66,
		}, {
			"Go to "..cl(56,38),
			"	a. Talk to Warden Bullrok",
			"		i. Turn in "..cq("Wanted: Giselda the Crone"),
			completion={{questturnedin="Wanted: Giselda the Crone"}},
			mapzone="Nagrand",
			level=66,
			mapnote=38009380,
		}, {
			"Go northeast to the Throne of the Elements",
			completion={{location={mapzone="Nagrand",x=60.8,y=22.4, dist=4}}},
			mapzone="Nagrand",
			level=66,
		}, {
			"Go to "..cl(62,24),
			"	a. Talk to Gordawg",
			"		i. Turn in "..cq("Shattering the Veil"),
			completion={{questturnedin="Shattering the Veil"}},
			mapzone="Nagrand",
			level=66,
			mapnote=24408620,
		}, {
			"Go to "..cl(61,22),
			"	a. Talk to Elementalist Lo'ap",
			"		i. Turn in "..cq("The Spirit Polluted"),
			completion={{questturnedin="The Spirit Polluted"}},
			mapzone="Nagrand",
			level=65,
			mapnote=22408290,
		}, {
			"Go west to "..cl(46,24),
			"	a. Kill 20 Warmaul ogres",
			"	b. Use your Kil'sorrow Banner on their copses",
			"	c. Plant 20 Kil'sorrow Banners",
			"	d. Use the Damp Blanket on the Blazing Warmaul Pyre",
			"	e. Defend the 2 ogres that spawn until they finish placing corpses around",
			completion={{questgoal={"*","Kil'sorrow Banner Planted",20}},{questgoal={"*","Kil'sorrow Bodies Planted",20}}},
			mapzone="Nagrand",
			level=66,
			mapnote=24307080,
		}, {
			"Go southeast to the Burning Blade Ruins",
			completion={{location={mapzone="Nagrand",x=75.6,y=66.5, dist=5}}},
			mapzone="Nagrand",
			level=66,
		}, {
			"Go to "..cl(74,63),
			"	a. Talk to Lantressor of the Blade",
			"		i. Turn in "..cq("Returning the Favor"),
			"		ii. Turn in "..cq("Body of Evidence"),
			"		iii. Accept "..cq("Message to Garadar"),
			completion={{questturnedin="Returning the Favor"},{questturnedin="Body of Evidence"},{questaccepted="Message to Garadar"}},
			mapzone="Nagrand",
			level=66,
			mapnote=62613640,
		}, {
			"Hearth to Garadar",
			completion={{location={mapzone="Nagrand",x=55.0,y=36.8, dist=6}}},
			mapzone="Nagrand",
			level=66,
		}, {
			"Go to "..cl(55,38),
			"	a. Talk to Garrosh",
			"		i. Turn in "..cq("Message to Garadar"),
			completion={{questturnedin="Message to Garadar"}},
			mapzone="Nagrand",
			level=66,
			mapnote=37609310,
		}, {
			"Fly to Swamprat Post",
			completion={{location={mapzone="Zangarmarsh",x=85.2,y=54.2, dist=2}}},
			mapzone="Nagrand",
			level=66,
		}, {
			"Go northwest to "..cl(70,34),
			"	a. The path to Blade's Edge Mountains starts here",
			completion={{location={mapzone="Zangarmarsh",x=70.1,y=33.8, dist=0.5}}},
			mapzone="Zangarmarsh",
			level=66,
			mapnote=33810390,
		}, {
			"Go north to Blade's Edge Mountains",
			completion={{location={mapzone="Blade's Edge Mountains"}}},
			mapzone="Zangarmarsh",
			level=66,
		}, {
			"Go to "..cl(53,96),
			"	a. Talk to Grunt Grahk",
			"		i. Accept "..cq("Killing the Crawlers"),
			completion={{questaccepted="Killing the Crawlers"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=96214920,
		}, {
			"Go north to "..cl(52,93),
			"	a. Kill 6 Cavern Crawlers as you walk through the tunnel",
			completion={{questgoal={"*","Cavern Crawler slain",6}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=93314570,
		}, {
			"Go north to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("Killing the Crawlers"),
			"		ii. Accept "..cq("The Bladespire Threat"),
			completion={{questturnedin="Killing the Crawlers"},{questaccepted="The Bladespire Threat"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Also at "..cl(52,58),
			"	a. Click the Wanted Poster",
			"		i. Accept "..cq("Felling an Ancient Tree"),
			completion={{questaccepted="Felling an Ancient Tree"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=57810970,
		}, {
			"Also at "..cl(52,58),
			"	a. Talk to Gor'drek",
			"		i. Accept "..cq("The Encroaching Wilderness"),
			completion={{questaccepted="The Encroaching Wilderness"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=57610990,
		}, {
			"Make Thunderlord Stronghold your home",
			completion={{home="Thunderlord Stronghold"}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,54),
			"	a. Talk to Unoke Tenderhoof",
			"		i. Get the Thunderlord Stronghold Flight Path",
			completion={{flightpath="Thunderlord Stronghold"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=54110620,
		}, {
			"Go south to "..cl(51,65),
			"	a. Kill 12 Bladewing Bloodletters",
			completion={{questgoal={"*","Bladewing Bloodletter slain",12}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=65511680,
		}, {
			"Go north to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,59),
			"	a. Talk to Gor'drek",
			"		i. Turn in "..cq("The Encroaching Wilderness"),
			"		ii. Accept "..cq("Dust from the Drakes"),
			completion={{questturnedin="The Encroaching Wilderness"},{questaccepted="Dust from the Drakes"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=57610990,
		}, {
			"Go west across the big bridge",
			completion={{location={mapzone="Blade's Edge Mountains",x=42.8,y=65.6, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(41,67),
			"	a. Kill Fey Drakes",
			"	b. Get 4 Dust of the Fey Drake",
			completion={{questgoal={"*","Dust of the Fey Drake",4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=67210840,
		}, {
			"Go southwest to "..cl(37,70),
			"	a. He walks up and down this road",
			"	b. Kill Stronglimb Deeproot",
			"	c. Get Stronglimb Deeproot's Trunk",
			completion={{questgoal={"*","Stronglimb Deeproot's Trunk",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=70010710,
		}, {
			"Go northeast to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("Felling an Ancient Tree"),
			completion={{questturnedin="Felling an Ancient Tree"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Also at "..cl(52,58),
			"	a. Talk to Gor'drek",
			"		i. Turn in "..cq("Dust from the Drakes"),
			"		ii. Accept "..cq("Protecting Our Own"),
			completion={{questturnedin="Dust from the Drakes"},{questaccepted="Protecting Our Own"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=57610990,
		}, {
			"Go southwest to "..cl(50,61),
			"	a. Use Gor'drek's Ointment on 5 Thunderlord Dire Wolves",
			"	b. Strengthen 5 Thunderlord Dire Wolves",
			completion={{questgoal={"*","Thunderlord Dire Wolf strengthened",5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60911130,
		}, {
			"Go northeast to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Gor'drek",
			"		i. Turn in "..cq("Protecting Our Own"),
			completion={{questturnedin="Protecting Our Own"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=57610990,
		}, {
			"Go northwest to "..cl(50,54),
			"	a. The path down to Bladespire Hold starts here",
			completion={{location={mapzone="Blade's Edge Mountains",x=49.8,y=54.1, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=54010380,
		}, {
			"Go north to "..cl(49,50),
			"	a. Kill 30 Bladespire Ogres",
			"	b. Kill 10 Bladespire Raptors",
			"	c. Kill ogres",
			"	d. Get a Thunderlord Clan Artifact",
			"	e. Click the Thunderlord Clan Artfiact",
			"		i. Accept "..cq("Thunderlord Clan Artifacts"),
			completion={{questgoal={"*","Bladespire Ogres killed",30}},{questgoal={"*","Bladespire Raptor slain",10}},{questaccepted="Thunderlord Clan Artifacts"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=50309950,
		}, {
			"Go southwest to "..cl(40,58),
			"	a. Click the Thunderlord Clan Drum",
			"	b. Get the Thunderlord Clan Drum",
			completion={{questgoal={"*","Thunderlord Clan Drum",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58309850,
		}, {
			"Go north to "..cl(41,52),
			"	a. The path up to the Thunderlord Clan Arrow starts here",
			completion={{location={mapzone="Blade's Edge Mountains",x=40.9,y=51.8, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=51909280,
		}, {
			"Go southeast to "..cl(41,53),
			"	a. Click the Thunderlord Clan Arrow",
			"	b. Get the Thunderlord Clan Arrow",
			completion={{questgoal={"*","Thunderlord Clan Arrow",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=52609410,
		}, {
			"Go north to "..cl(41,46),
			"	a. Click the Thunderlord Clan Tablet",
			"	b. Get the Thunderlord Clan Tablet",
			completion={{questgoal={"*","Thunderlord Clan Tablet",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=46508770,
		}, {
			"Go southeast to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("The Bladespire Threat"),
			"		ii. Accept "..cq("The Bloodmaul Ogres"),
			completion={{questturnedin="The Bladespire Threat"},{questaccepted="The Bloodmaul Ogres"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Go to "..cl(53,59),
			"	a. Talk to Rokgah Bloodgrip",
			"		i. Turn in "..cq("Thunderlord Clan Artifacts"),
			"		ii. Accept "..cq("Vision Guide"),
			"	b. Use the Fiery Soul Fragment she just gave you",
			"	c. Watch yourself fly around as a red whisp",
			"	d. Talk to Rokgah Bloodgrip",
			"		i. Turn in "..cq("Vision Guide"),
			"		ii. Accept "..cq("The Thunderspike"),
			completion={{questturnedin="Thunderlord Clan Artifacts"},{questaccepted="Vision Guide"},{questturnedin="Vision Guide"},{questaccepted="The Thunderspike"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=59011180,
		}, {
			"Go northwest to "..cl(50,54),
			"	a. Follow the path down",
			completion={{location={mapzone="Blade's Edge Mountains",x=49.8,y=54.1, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=54010380,
		}, {
			"Go southwest to "..cl(45,72),
			"	a. Talk to T'chali the Witch Doctor",
			"		i. Accept "..cq("They Stole Me Hookah and Me Brews!"),
			completion={{questaccepted="They Stole Me Hookah and Me Brews!"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72311730,
		}, {
			"Go southwest to "..cl(42,79),
			"	a. Kill 30 Bloodmaul ogres",
			"	b. Click the Bloodmaul Brew Kegs",
			"	c. Kill Bloodmaul Brewmasters",
			"	d. Get 16 Bloodmaul Brutebane Brew",
			completion={{questgoal={"*","Bloodmaul Ogres killed",30}},{item={"Bloodmaul Brutebane Brew",16}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=79412180,
		}, {
			"Go south to "..cl(42,81),
			"	a. Click T'chali's Hookah",
			"	b. Get T'chali's Hookah",
			completion={{questgoal={"*","T'chali's Hookah",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=81212330,
		}, {
			"Go south into the mine",
			"	a. Go all the way to the back of the cave",
			completion={{location={mapzone="Blade's Edge Mountains",x=42.5,y=83.6, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to 40,85 inside the mine",
			"	a. Click the Thunderspike",
			"	b. Kill Gor Grimgut",
			"	c. Get the Thunderspike",
			completion={{questgoal={"*","The Thunderspike",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=85512520,
		}, {
			"Go northeast to "..cl(45,72),
			"	a. Talk to T'chali the Witch Doctor",
			"		i. Turn in "..cq("They Stole Me Hookah and Me Brews!"),
			"		ii. Accept "..cq("Bladespire Kegger"),
			completion={{questturnedin="They Stole Me Hookah and Me Brews!"},{questaccepted="Bladespire Kegger"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72311730,
		}, {
			"Go northwest to "..cl(43,56),
			"	a. Use your Bloodmaul Brutebane Keg when semi-close to an ogre",
			"	b. The ogre will run and grab the beer and get drunk",
			"	c. Get 5 Bladespire Ogres drunk",
			completion={{questgoal={"*","Bladespire Ogres drunk",5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=55809850,
		}, {
			"Go southeast to "..cl(45,72),
			"	a. Talk to T'chali the Witch Doctor",
			"		i. Turn in "..cq("Bladespire Kegger"),
			"		ii. Accept "..cq("Grimnok and Korgaah, I Am For You!"),
			completion={{questturnedin="Bladespire Kegger"},{questaccepted="Grimnok and Korgaah, I Am For You!"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72311730,
		}, {
			"Go south to "..cl(45,80),
			"	a. Go to the top of the tower",
			"	b. Kill Grimnok Battleborn",
			completion={{questgoal={"*","Grimnok Battleborn slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=80412580,
		}, {
			"Go north to "..cl(43,47),
			"	a. The path up to Korgaah starts here",
			"		i. It's a stone ramp on the left side of the really tall house",
			"	b. Follow the path up",
			completion={{location={mapzone="Blade's Edge Mountains",x=42.8,y=46.7, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=46708950,
		}, {
			"Go to "..cl(43,46),
			"	a. Use your Bloodmaul Brutebane Brew at this spot on the ramp",
			"	b. Lure the ogres out 1 by 1 and kill them",
			"	c. Lure Korgaah out with the beer",
			"	d. Kill Korgaah",
			completion={{questgoal={"*","Korgaah slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=46108930,
		}, {
			"Go south to "..cl(45,72),
			"	a. Talk to T'chali the Witch Doctor",
			"		i. Turn in "..cq("Grimnok and Korgaah, I Am For You!"),
			"		ii. Accept "..cq("A Curse Upon Both of Your Clans!"),
			completion={{questturnedin="Grimnok and Korgaah, I Am For You!"},{questaccepted="A Curse Upon Both of Your Clans!"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72311730,
		}, {
			"Go southeast to "..cl(47,87),
			"	a. Use your Wicked Strong Fetish in the doorway of this building",
			"	b. Kill the spirit that spawns",
			"	c. Use your Wicked Strong Fetish on this building 2 times",
			"	d. Curse 2 Bloodmaul Outpost buildings",
			completion={{questgoal={"*","Bloodmaul Outpost building cursed",2}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=78012510,
		}, {
			"Go northwest to "..cl(42,54),
			"	a. Use your Wicked Strong Fetish in the doorway of this building",
			"	b. Kill the spirit that spawns",
			"	c. Use your Wicked Strong Fetish on this building 5 times",
			"	d. Curse 5 Bladespire Hold buildings",
			completion={{questgoal={"*","Bladespire Hold building cursed",5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=53809620,
		}, {
			"Go southeast to "..cl(45,72),
			"	a. Talk to T'chali the Witch Doctor",
			"		i. Turn in "..cq("A Curse Upon Both of Your Clans!"),
			completion={{questturnedin="A Curse Upon Both of Your Clans!"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72311730,
		}, {
			"Hearth to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("The Bloodmaul Ogres"),
			completion={{questturnedin="The Bloodmaul Ogres"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Go to "..cl(53,59),
			"	a. Talk to Rokgah Bloodgrip",
			"		i. Turn in "..cq("The Thunderspike"),
			"	b. Talk to Garm Wolfbrother",
			"		i. Accept "..cq("The Spirits Have Voices"),
			completion={{questturnedin="The Thunderspike"},{questaccepted="The Spirits Have Voices"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=59011180,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("The Spirits Have Voices"),
			"		ii. Accept "..cq("Whispers on the Wind"),
			completion={{questturnedin="The Spirits Have Voices"},{questaccepted="Whispers on the Wind"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Go southeast to "..cl(56,73),
			"	a. Follow the road east to Mok'nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=55.7,y=72.7, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72712850,
		}, {
			"Go to "..cl(76,60),
			"	a. Talk to Sky-Master Maxxor",
			"		i. Get the Mok'Nathal Flight Path",
			completion={{flightpath="Mok'Nathal"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=65914230,
		}, {
			"Go to "..cl(75,62),
			"	a. Talk to Dertrok",
			"		i. Accept "..cq("The Stones of Vekh'nir"),
			completion={{questaccepted="The Stones of Vekh'nir"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=62113720,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Turn in "..cq("Whispers on the Wind"),
			"		ii. Accept "..cq("Reunion"),
			completion={{questturnedin="Whispers on the Wind"},{questaccepted="Reunion"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go to "..cl(76,60),
			"	a. Talk to Matron Varah",
			"		i. Accept "..cq("Mok'Nathal Treats"),
			completion={{questaccepted="Mok'Nathal Treats"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60313640,
		}, {
			"Make Mok'Nathal Village your home",
			completion={{home="Mok'Nathal Village"}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(76,61),
			"	a. Talk to Taerek",
			"		i. Accept "..cq("Silkwing Cocoons"),
			"	b. Talk to Silmara",
			"		i. Accept "..cq("The Softest Wings"),
			completion={{questaccepted="Silkwing Cocoons"},{questaccepted="The Softest Wings"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=61513740,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("Reunion"),
			"		ii. Accept "..cq("On Spirit's Wings"),
			completion={{questturnedin="Reunion"},{questaccepted="On Spirit's Wings"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=58411030,
		}, {
			"Fly to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go southwest to "..cl(74,65),
			"	a. Kill Silkwing Larvas",
			"	b. Get 8 Silkwing Cocoons",
			"	c. Kill Silkwings",
			"	d. Get 12 Iridescent Wings",
			completion={{questgoal={"*","Silkwing Cocoon",8}},{questgoal={"*","Iridescent Wing",12}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=64913870,
		}, {
			"Go southeast to "..cl(76,75),
			"	a. Kill Vekh'nir arakkoas",
			"	b. Get a Vekh'nir Crystal",
			completion={{item={"Vekh'nir Crystal",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=75415180,
		}, {
			"Go east to "..cl(78,75),
			"	a. Stand on the big purple glowing circle on the ground",
			"	b. Click the Vekh'nir Crystal in your bags",
			"	c. Charge the Vekh'nir Crystal",
			completion={{questgoal={"*","Charged Vekh'nir Crystal",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=74715250,
		}, {
			"Go northwest to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,62),
			"	a. Talk to Dertrok",
			"		i. Turn in "..cq("The Stones of Vekh'nir"),
			"		ii. Accept "..cq("Trial and Error"),
			completion={{questturnedin="The Stones of Vekh'nir"},{questaccepted="Trial and Error"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=62113720,
		}, {
			"Go to "..cl(76,61),
			"	a. Talk to Taerek",
			"		i. Turn in "..cq("Silkwing Cocoons"),
			"	b. Talk to Silmara",
			"		i. Turn in "..cq("The Softest Wings"),
			completion={{questturnedin="Silkwing Cocoons"},{questturnedin="The Softest Wings"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=61513740,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Accept "..cq("Understanding the Mok'Nathal"),
			completion={{questaccepted="Understanding the Mok'Nathal"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go southwest to "..cl(73,74),
			"	a. Kill arakkoas",
			"	b. Get 4 Infused Vekh'nir Crystals",
			"	c. Use Dertrok's First Wand on the ogres",
			"		i. Test Dertrok's First Wand",
			"	d. Use Dertrok's Second Wand on the ogres",
			"		i. Test Dertrok's Second Wand",
			"	e. Use Dertrok's Third Wand on the ogres",
			"		i. Test Dertrok's Third Wand",
			"	f. Use Dertrok's Fourth Wand on the ogres",
			"		i. Test Dertrok's Fourth Wand",
			completion={{questgoal={"*","Test the first wand",1}},{questgoal={"*","Test the second wand",1}},{questgoal={"*","Test the third wand",1}},{questgoal={"*","Test the fourth wand",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=74614780,
		}, {
			"Go inside the cave",
			"	a. Keep going straight inside the cave to the back",
			completion={{location={mapzone="Blade's Edge Mountains",x=71.3,y=74.4, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(70,72),
			"	a. Kill Vekh",
			completion={{questgoal={"*","Vekh slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=72214220,
		}, {
			"Go northeast to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,62),
			"	a. Talk to Dertrok",
			"		i. Turn in "..cq("Trial and Error"),
			"		ii. Accept "..cq("Ruuan Weald"),
			completion={{questturnedin="Trial and Error"},{questaccepted="Ruuan Weald"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=62113720,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Turn in "..cq("Understanding the Mok'Nathal"),
			"		ii. Accept "..cq("Since Time Forgotten..."),
			completion={{questturnedin="Understanding the Mok'Nathal"},{questaccepted="Since Time Forgotten..."}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go to "..cl(75,60),
			"	a. Talk to Spiritcaller Dohgar",
			"		i. Accept "..cq("The Totems of My Enemy"),
			completion={{questaccepted="The Totems of My Enemy"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60513540,
		}, {
			"Go southwest to "..cl(69,67),
			"	a. Kill Scalewing Serpents",
			"	b. Get 3 Serpent Flesh",
			completion={{questgoal={"*","Serpent Flesh",3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=67213610,
		}, {
			"Go northwest to "..cl(65,57),
			"	a. Kill Daggermaw Lashtails",
			"	b. Get 3 Raptor Ribs",
			completion={{questgoal={"*","Raptor Ribs",3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=56912210,
		}, {
			"Go west to "..cl(59,56),
			"	a. Kill ogres",
			"	b. Get 5 Bladespire Totems",
			completion={{questgoal={"*","Bladespire Totem",5}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=56011530,
		}, {
			"Go northwest to "..cl(57,55),
			"	a. Kill Gnosh Brognat",
			completion={{questgoal={"*","Gnosh Brognat slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=54611170,
		}, {
			"Go southeast to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Turn in "..cq("Since Time Forgotten..."),
			"		ii. Accept "..cq("Slay the Brood Mother"),
			completion={{questturnedin="Since Time Forgotten..."},{questaccepted="Slay the Brood Mother"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go to "..cl(75,60),
			"	a. Talk to Spiritcaller Dohgar",
			"		i. Turn in "..cq("The Totems of My Enemy"),
			"		ii. Accept "..cq("Spirit Calling"),
			completion={{questturnedin="The Totems of My Enemy"},{questaccepted="Spirit Calling"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60513540,
		}, {
			"Go to "..cl(76,60),
			"	a. Talk to Matron Varah",
			"		i. Turn in "..cq("Mok'Nathal Treats"),
			completion={{questturnedin="Mok'Nathal Treats"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60313640,
		}, {
			"Go southwest to "..cl(66,75),
			"	a. Use your Spirit Calling Totems to plant Spirit alling Totems",
			"	b. Kill Lesser Nether Drakes while standing near the totems",
			"	c. Make sure to kill at least 2 drakes per totem before the totem disappears",
			"	d. If you run out of totems, you will have to run all the way back to Mok'Nathal Village to get more, so use them with care",
			"	e. Kill the drakes and get 8 Lesser Nether Drake Spirits",
			"	f. Kill Dreadwing",
			completion={{questgoal={"*","Lesser Nether Drake Spirit",8}},{questgoal={"*","Dreadwing slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=75614120,
		}, {
			"Hearth to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Turn in "..cq("Slay the Brood Mother"),
			completion={{questturnedin="Slay the Brood Mother"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go to "..cl(75,60),
			"	a. Talk to Spiritcaller Dohgar",
			"		i. Turn in "..cq("Spirit Calling"),
			"		ii. Accept "..cq("Gather the Orbs"),
			completion={{questturnedin="Spirit Calling"},{questaccepted="Gather the Orbs"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60513540,
		}, {
			"Go northwest to "..cl(65,46),
			"	a. Keep laying the Orb Collecting Totem at the base of the pole with the purple lightning circle on it",
			"	b. It will capture te Razaani Light Orbs as they are produced",
			"	c. Collect 15 Razaani Light Orbs",
			completion={{questgoal={"*","Razaani Light Orb collected",15}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=46611210,
		}, {
			"Go southeast to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,60),
			"	a. Talk to Spiritcaller Dohgar",
			"		i. Turn in "..cq("Gather the orbs"),
			"		ii. Accept "..cq("Inform Leoroxx!"),
			completion={{questturnedin="Gather the orbs"},{questaccepted="Inform Leoroxx!"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60513540,
		}, {
			"Go to "..cl(75,61),
			"	a. Talk to Leoroxx",
			"		i. Turn in "..cq("Inform Leoroxx!"),
			"		ii. Accept "..cq("There Can Be Only One Response"),
			completion={{questturnedin="Inform Leoroxx!"},{questaccepted="There Can Be Only One Response"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60913620,
		}, {
			"Go northwest to "..cl(66,44),
			"	a. Kill Razaani mummies around the portal",
			"	b. After a while, Nexus-Prince Razaan will come out of the portal",
			"	c. Kill Nexus-Prince Razaan",
			"	d. Click the Collection of Souls hovering over his corpse",
			"	e. Get the Collection of Souls",
			completion={{questgoal={"*","Collection of Souls",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=44311060,
		}, {
			"Go northwest to Ruuan Weald",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Timeon",
			"		i. Turn in "..cq("Ruuan Weald"),
			"		ii. Accept "..cq("Creating the Pendant"),
			completion={{questturnedin="Ruuan Weald"},{questaccepted="Creating the Pendant"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=39110130,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Faradrella",
			"		i. Accept "..cq("Culling the Wild"),
			completion={{questaccepted="Culling the Wild"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=38210080,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Mosswood the Ancient",
			"		i. Accept "..cq("Little Embers"),
			"		ii. Accept "..cq("From the Ashes"),
			completion={{questaccepted="Little Embers"},{questaccepted="From the Ashes"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=38409960,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Tree Warden Chawn",
			"		i. Accept "..cq("A Time for Negotiation..."),
			completion={{questaccepted="A Time for Negotiation..."}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=39510150,
		}, {
			"Go to "..cl(62,40),
			"	a. Talk to Fhyn Leafshadow",
			"		i. Get the Evergrove Flight Path",
			completion={{flightpath="Evergrove"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=39610130,
		}, {
			"Fly to Mok'Nathal Village",
			completion={{location={mapzone="Blade's Edge Mountains",x=75.4,y=61.4, dist=4.7}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go to "..cl(75,60),
			"	a. Talk to Spiritcaller Dohgar",
			"		i. Turn in "..cq("There Can Only Be One Response"),
			completion={{questturnedin="There Can Only Be One Response"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=60513540,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Make Thunderlord Stronghold your home",
			completion={{home="Thunderlord Stronghold"}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go northeast to "..cl(69,35),
			"	a. Kill 2 Fel Corrupters",
			"	b. Kill 4 Felsworn Scalewings",
			"	c. Kill 4 Felsworn Daggermaws",
			"	d. Kill Fel Corrupters",
			"	e. Get a Damaged Mask",
			"	f. Click the Damaged Mask",
			"		i. Accept "..cq("Damaged Mask"),
			completion={{questgoal={"*","Fel Corrupter slain",2}},{questgoal={"*","Felsworn Scalewing slain",4}},{questgoal={"*","Felsworn Daggermaw slain",4}},{questaccepted="Damaged Mask"}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=35610450,
		}, {
			"Go northeast to "..cl(72,22),
			"	a. Click the Fertile Volcanic Soil",
			"	b. Plant the Ironroot Seeds",
			completion={{questgoal={"*","Southern Volcanic Soil",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=22409410,
		}, {
			"Go north to "..cl(72,20),
			"	a. Click the Fertile Volcanic Soil",
			"	b. Plant the Ironroot Seeds",
			completion={{questgoal={"*","Central Volcanic Soil",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=20309190,
		}, {
			"Go west to "..cl(71,20),
			"	a. Kill 8 Scorch Imps",
			completion={{questgoal={"*","Scorch Imp slain",8}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=20209090,
		}, {
			"Go northeast to "..cl(72,18),
			"	a. Click the Fertile Volcanice Soil",
			"	b. Plant the Ironroot Seeds",
			completion={{questgoal={"*","Northern Volcanic Soil",1}}},
			mapzone="Blade's Edge Mountains",
			level=66,
			mapnote=18509010,
		}, {
			"Grind to level 67",
			completion={{level=67}},
			mapzone="Blade's Edge Mountains",
			level=66,
		}, {
			"Go southwest to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(63,40),
			"	a. Talk O'Mally Zapnabber",
			"		i. Turn in "..cq("Damaged Mask"),
			"		ii. Accept "..cq("Mystery Mask"),
			completion={{questturnedin="Damaged Mask"},{questaccepted="Mystery Mask"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=40410310,
		}, {
			"Go to "..cl(61,39),
			"	a. Talk to Wildlord Antelarion",
			"		i. Turn in "..cq("Mystery Mask"),
			"		ii. Accept "..cq("Felsworn Gas Mask"),
			completion={{questturnedin="Mystery Mask"},{questaccepted="Felsworn Gas Mask"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=40110230,
		}, {
			"Go to "..cl(63,38),
			"	a. Talk to Faradrella",
			"		i. Turn in "..cq("Culling the Wild"),
			completion={{questturnedin="Culling the Wild"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=38210080,
		}, {
			"Go to "..cl(61,38),
			"	a. Talk to Mosswood the Ancient",
			"		i. Turn in "..cq("Little Embers"),
			"		ii. Turn in "..cq("From the Ashes"),
			completion={{questturnedin="Little Embers"},{questturnedin="From the Ashes"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=38409960,
		}, {
			"Go west to "..cl(59,39),
			"	a. Talk to Overseer Nuuar",
			"	b. He wanders around the Wyrmcult camps",
			completion={{questgoal={"*","Negotiations with Overseer Nuaar complete",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39109790,
		}, {
			"Go east to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Tree Warden Chawn",
			"		i. Turn in "..cq("A Time for Negotiation..."),
			"		ii. Accept "..cq("...and a Time for Action"),
			"	b. Talk to Samia Inkling",
			"		i. Accept "..cq("Poaching from Poachers"),
			completion={{questturnedin="A Time for Negotiation..."},{questaccepted="...and a Time for Action"},{questaccepted="Poaching from Poachers"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39510150,
		}, {
			"Go west to "..cl(60,38),
			"	a. Kill 10 Wyrmcult Hewers",
			"	b. Kill Wyrmcult Poachers",
			"	c. Get 5 Wyrmcult nets",
			"	d. Kill Wyrmcult mobs",
			"	e. Get a Meeting note",
			"	f. Click the Meeting Note",
			"		i. Accept "..cq("Did You Get the Note?"),
			completion={{questgoal={"*","Wyrmcult Hewer slain",10}},{questgoal={"*","Wyrmcult Net",5}},{questaccepted="Did You Get The Note?"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=37809770,
		}, {
			"Go east to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Samia Inkling",
			"		i. Turn in "..cq("Poaching from Poachers"),
			"		ii. Accept "..cq("Whelps of the Wyrmcult"),
			"	b. Talk to Tree Warden Chawn",
			"		i. Turn in "..cq("...and a Time for Action"),
			"		ii. Turn in "..cq("Did You Get The Note?"),
			"		iii. Accept "..cq("Wyrmskull Watcher"),
			completion={{questturnedin="Poaching from Poachers"},{questturnedin="...and a Time for Action"},{questturnedin="Did You Get The Note?"},{questaccepted="Whelps of the Wyrmcult"},{questaccepted="Wyrmskull Watcher"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39510150,
		}, {
			"Make sure you have your Felsworn Gas Mask in your bags",
			"	a. It has a 60 minute timer on it",
			"	b. If you need another one, talk to Wildlord Antelarion at Evergrove",
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go east to Forge Camp Anger",
			completion={{location={mapzone="Blade's Edge Mountains",x=73.7,y=41.0, dist=2}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Put on your Felsworn Gas Mask",
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(73,40),
			"	a. Click the Legion Communicator",
			"		i. Turn in "..cq("Felsworn Gas Mask"),
			"		ii. Accept "..cq("Deceive thy Enemy"),
			completion={{questturnedin="Felsworn Gas Mask"},{questaccepted="Deceive thy Enemy"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=40011320,
		}, {
			"Go east to "..cl(75,40),
			"	a. Kill 4 Doomforge Attendants",
			"	b. Kill 4 Doomforge Engineers",
			completion={{questgoal={"*","Doomforge Attendant slain",4}},{questgoal={"*","Doomforge Engineer slain",4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39911480,
		}, {
			"Go west to "..cl(73,40),
			"	a. Put on your Felsworn Gas Mask",
			"	b. Click the Legion Communicator",
			"		i. Turn in "..cq("Deceive thy Enemy"),
			completion={{questturnedin="Deceive thy Enemy"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=40011320,
		}, {
			"Go northwest to "..cl(64,31),
			"	a. Kill Ruuan'ok arakkoas",
			"	b. Get 6 Ruuan'ok Claws",
			completion={{item={"Ruuan'ok Claw",6}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=31509540,
		}, {
			"Go southeast to "..cl(64,33),
			"	a. Use the 6 Ruuan'ok Claws inside the glowing circle",
			"	b. Kill the Harbinger of the Raven",
			"	c. Get the Harbinger's Pendant",
			completion={{questgoal={"*","Harbinger's Pendant",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=33109760,
		}, {
			"Go west to "..cl(58,31),
			"	a. Stand near to the little torch stick on the hill",
			"	b. Use Rexxar's Whistle",
			"	c. Position the green circle on the ground near the 2 ogres talking",
			"	d. The owl will fly over to them",
			"	e. Eavesdrop on the Bloodmaul ogres' plans",
			completion={{questgoal={"*","Eavesdrop on the Bloodmaul ogres' plans",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=30808920,
		}, {
			"Hearth to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("On Spirit's Wings"),
			"		ii. Accept "..cq("Baron Sablemane"),
			completion={{questturnedin="On Spirit's Wings"},{questaccepted="Baron Sablemane"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=58411030,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Timeon",
			"		i. Turn in "..cq("Creating the Pendant"),
			"		ii. Accept "..cq("Whispers of the Raven God"),
			completion={{questturnedin="Creating the Pendant"},{questaccepted="Whispers of the Raven God"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39110130,
		}, {
			"Go west to "..cl(53,41),
			"	a. Talk to Baron Sablemane",
			"		i. Turn in "..cq("Baron Sablemane"),
			"		ii. Accept "..cq("Into the Churning Gulch"),
			completion={{questturnedin="Baron Sablemane"},{questaccepted="Into the Churning Gulch"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=41209450,
		}, {
			"Go southwest to "..cl(49,44),
			"	a. Kill Crust Bursters",
			"	b. Get 7 Crust Burster Venom Glands",
			completion={{questgoal={"*","Crust Burster Venom Gland",7}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=44509350,
		}, {
			"Go northeast to "..cl(53,41),
			"	a. Talk to Baron Sablemane",
			"		i. Turn in "..cq("Into the Churning Gulch"),
			"		ii. Accept "..cq("Baron Sablemane's Poison"),
			completion={{questturnedin="Into the Churning Gulch"},{questaccepted="Baron Sablemane's Poison"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=41209450,
		}, {
			"Go east to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(52,28),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("Baron Sablemane's Poison"),
			"		ii. Accept "..cq("The Smallest Creatures"),
			"	b. Talk to Tor'chunk Twoclaws",
			"		i. Accept "..cq("Crush the Bloodmaul Camp"),
			completion={{questturnedin="Baron Sablemane's Poison"},{questaccepted="The Smallest Creatures"},{questaccepted="Crush the Bloodmaul Camp"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=58411030,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go northwest to "..cl(56,27),
			"	a. Kill 10 Bloodmaul Maulers",
			"	b. Kill 5 Bloodmaul Warlocks",
			"	c. Clear the mobs around the kegs to make the next few steps easier",
			completion={{questgoal={"*","Bloodmaul Mauler slain",10}},{questgoal={"*","Bloodmaul Warlock slain",5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=26708290,
		}, {
			"Go south to "..cl(56,29),
			"	a. Click your Kodohide Drum next to the small stone burrow",
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=29208560,
		}, {
			"As a marmot, do the following:",
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go northwest to "..cl(55,28),
			"	a. Stand next to the wooden keg",
			"	b. Click the Poison Kegs button on your pet bar",
			"	c. Poison the Ripe Moonshine Keg",
			completion={{questgoal={"*","Poison the keg of Ripe Moonshine",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=28208360,
		}, {
			"Go north to "..cl(55,26),
			"	a. Stand next to the wooden keg",
			"	b. Click the Poison Kegs button on your pet bar",
			"	c. Poison the Green Spot Grog Keg",
			completion={{questgoal={"*","Poison the keg of Green Spot Grog",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=26008130,
		}, {
			"Go north to "..cl(56,23),
			"	a. Stand next to the wooden keg",
			"	b. Click the Poison Kegs button on your pet bar",
			"	c. Poison the Fermented Seed Beer Keg",
			completion={{questgoal={"*","Poison the keg of Fermented Seed Beer",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=23107900,
		}, {
			"Go south to "..cl(56,29),
			"	a. Right-click the marmot buff at the top right of your screen to stop playing as a marmot",
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go southeast to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("The Smallest Creatures"),
			"		ii. Accept "..cq("A Boaring Time for Grulloc"),
			"	b. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("Crush the Bloodmaul Camp"),
			completion={{questturnedin="The Smallest Creatures"},{questturnedin="Crush the Bloodmaul Camp"},{questaccepted="A Boaring Time for Grulloc"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=58411030,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go southwest to "..cl(60,47),
			"	a. Use Huffer's Whistle",
			"		i. A boar will appear and start distraction Grulloc",
			"	b. Run up and click Grulloc's Sack",
			"	c. Get Grulloc's Sack",
			"	d. Run away",
			completion={{questgoal={"*","Grulloc's Sack",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=47610780,
		}, {
			"Go northwest to "..cl(53,41),
			"	a. Talk to Baron Sablemane",
			"		i. Turn in "..cq("A Boaring Time for Grulloc"),
			"		ii. Accept "..cq("It's a Trap!"),
			completion={{questturnedin="A Boaring Time for Grulloc"},{questaccepted="It's a Trap!"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=41209450,
		}, {
			"Hearth to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("It's a Trap!"),
			"		ii. Accept "..cq("Gorgrom the Dragon-Eater"),
			"	b. Talk to Tor'chunk Twoclaws",
			"		i. Accept "..cq("Slaughter at Boulder'mok"),
			completion={{questturnedin="It's a Trap!"},{questaccepted="Gorgrom the Dragon-Eater"},{questaccepted="Slaughter at Boulder'mok"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=58411030,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go northwest across the big bridge",
			completion={{location={mapzone="Blade's Edge Mountains",x=53.1,y=37.9, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(50,36),
			"	a. Talk to Watcher Moonshade",
			"		i. Turn in "..cq("Wyrmskull Watcher"),
			"		ii. Accept "..cq("Longtail is the Lynchpin"),
			completion={{questturnedin="Wyrmskull Watcher"},{questaccepted="Longtail is the Lynchpin"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=35908580,
		}, {
			"Go into the tunnel",
			completion={{location={mapzone="Blade's Edge Mountains",x=49.5,y=35.8, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go northwest to "..cl(47,33),
			"	a. Kill Draaca Longtail",
			completion={{questgoal={"*","Draaca Longtail slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=32907960,
		}, {
			"Go southeast to "..cl(50,36),
			"	a. Talk to Watcher Moonshade",
			"		i. Turn in "..cq("Longtail is the Lynchpin"),
			"		ii. Accept "..cq("Meeting at the Blackwing Coven"),
			completion={{questturnedin="Longtail is the Lynchpin"},{questaccepted="Meeting at the Blackwing Coven"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=35908580,
		}, {
			"Go northwest through the tunnel to Grishnath",
			completion={{location={mapzone="Blade's Edge Mountains",x=43.1,y=29.9, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Kill arakkoas",
			"	a. Get the Understanding Ravenspeech buff",
			"		i. Must be within melee range to receive the buff",
			"	b. The buff lasts for 2 minutes",
			"	c. Anytime the buff wears off, kill arakkoas again to get it back",
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(41,19),
			"	a. Stand next to the wooden totem with the Understanding Ravenspeech buff on",
			"	b. Receive the Third Prophecy",
			completion={{questgoal={"*","Receive the Third Prophecy",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=18705940,
		}, {
			"Go northwest to "..cl(39,17),
			"	a. Stand next to the wooden totem with the Understanding Ravenspeech buff on",
			"	b. Receive the First Prophecy",
			completion={{questgoal={"*","Receive the First Prophecy",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=17205620,
		}, {
			"Go southeast to "..cl(42,22),
			"	a. Stand next to the wooden totem with the Understanding Ravenspeech buff on",
			"	b. Receive the Second Prophecy",
			completion={{questgoal={"*","Receive the Second Prophecy",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=21606410,
		}, {
			"Go southwest to "..cl(40,23),
			"	a. Stand next to the wooden totem with the Understanding Ravenspeech buff on",
			"	b. Receive the Fourth Prophecy",
			"	c. Kill arakkoas",
			"	d. Get the Orb of the Grishna",
			"	e. Click the Ord of the Grishna",
			"		i. Accept "..cq("The Truth Unorbed"),
			completion={{questgoal={"*","Receive the Fourth Prophecy",1}},{questaccepted="The Truth Unorbed"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=23006320,
		}, {
			"Go southwest to "..cl(32,35),
			"	a. Go inside the cave",
			"	b. Use the Blackwhelp Net on Wyrmcult Blackwhelps",
			"	c. Capture 10 Wyrmcult Blackwhelps",
			"	d. Kill Wyrmcultists",
			"	e. Get 5 Costume Scraps",
			completion={{questgoal={"*","Wyrmcult Blackwhelp",10}},{item={"Costume Scraps",5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=34906720,
		}, {
			"Go south to "..cl(33,38),
			"	a. Combine your 5 Costume Scraps to make an Overseer Disguise",
			"	b. Put on the Overseer Disguise",
			"	c. Talk to Kolphis Darkscale",
			"		i. Attend the meeting with Kolphis Darkscale",
			completion={{questgoal={"*","Meeting with Kolphis Darkscale attended",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=37507010,
		}, {
			"Go northwest to "..cl(30,25),
			"	a. Kill 5 Boulder'mok Brutes",
			"	b. Kill 3 Boulder'mok Shamans",
			"	c. Kill Boulder'mok mobs",
			"	d. Get 3 Grisly Totems",
			completion={{questgoal={"*","Boulder'mok Brute slain",5}},{questgoal={"*","Boulder'mok Shaman slain",3}},{item={"Grisly Totem",3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=24605490,
		}, {
			"Go north to "..cl(31,22),
			"	a. Click Gorgrom's Altar",
			"	b. He will run up to the altar and die",
			"	c. Use the Grisly Totems on his corpse",
			"	d. Plant 3 Grisly Totems",
			completion={{questgoal={"*","Plant Grisly Totem",3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=22205280,
		}, {
			"Go east to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Samia Inkling",
			"		i. Turn in "..cq("Whelps of the Wyrmcult"),
			"	b. Talk to Tree Warden Chawn",
			"		i. Turn in "..cq("Meeting at the Blackwing Coven"),
			"		ii. Accept "..cq("Maxnar Must Die!"),
			"		iii. Turn in "..cq("The Truth Unorbed"),
			"		iv. Accept "..cq("Treebole Must Know"),
			completion={{questturnedin="Whelps of the Wyrmcult"},{questturnedin="Meeting at the Blackwing Coven"},{questturnedin="The Truth Unorbed"},{questaccepted="Maxnar Must Die!"},{questaccepted="Treebole Must Know"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39510150,
		}, {
			"Also at "..cl(62,39),
			"	a. Talk to Timeon",
			"		i. Turn in "..cq("Whispers of the Raven God"),
			completion={{questturnedin="Whispers of the Raven God"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39110130,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(52,58),
			"	a. Talk to Rexxar",
			"		i. Turn in "..cq("Gorgrom the Dragon-Eater"),
			"	b. Talk to Tor'chunk Twoclaws",
			"		i. Turn in "..cq("Slaughter at Boulder'mok"),
			completion={{questturnedin="Gorgrom the Dragon-Eater"},{questturnedin="Slaughter at Boulder'mok"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=58411030,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go northwest to "..cl(37,22),
			"	a. Talk to Treebole",
			"		i. Turn in "..cq("Treebole Must Know"),
			"		ii. Accept "..cq("Exorcising the Trees"),
			completion={{questturnedin="Treebole Must Know"},{questaccepted="Exorcising the Trees"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=22505940,
		}, {
			"Go northeast to "..cl(39,20),
			"	a. Click the purple balls in the claw looking rods",
			"	b. Get 5 Grishnath Orbs",
			completion={{item={"Grishnath Orb",5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=20205950,
		}, {
			"Go southwest to "..cl(30,29),
			"	a. Kill Dire Ravens",
			"	b. Get 5 Dire Pinfeathers",
			completion={{item={"Dire Pinfeather",5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=28605870,
		}, {
			"Go east to "..cl(34,29),
			"	a. Click your Grishnath Orbs to combine the orbs and pinfeathers",
			"	b. Create 5 Exorcism Feathers",
			"	c. Use Exorcism Feathers on the Raven's Wood Leafbeards",
			"	d. Kill the Koi Koi spirits that spawn to free the trees",
			"	e. Free 5 Raven's Wood Leafbeards",
			completion={{questgoal={"*","Leafbeard Exorcised",5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=29406320,
		}, {
			"Go northeast to "..cl(37,22),
			"	a. Talk to Treebole",
			"		i. Turn in "..cq("Exorcising the Trees"),
			completion={{questturnedin="Exorcising the Trees"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=22505940,
		}, {
			"Go southwest to the Blackwing Coven",
			completion={{location={mapzone="Blade's Edge Mountains",x=31.9,y=33.1, dist=0.5}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go inside the cave",
			completion={{location={mapzone="Blade's Edge Mountains",x=32.1,y=34.1, dist=0.3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(34,35),
			"	a. Kill Maxnar the Ashmaw",
			completion={{questgoal={"*","Maxnar the Ashmaw slain",1}}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=35406930,
		}, {
			"Hearth to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Fly to Evergrove",
			completion={{location={mapzone="Blade's Edge Mountains",x=62.4,y=38.4, dist=3}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to "..cl(62,39),
			"	a. Talk to Tree Warden Chawn",
			"		i. Turn in "..cq("Maxnar Must Die!"),
			completion={{questturnedin="Maxnar Must Die!"}},
			mapzone="Blade's Edge Mountains",
			level=67,
			mapnote=39510150,
		}, {
			"Go northeast to Netherstorm",
			completion={{location={mapzone="Netherstorm"}}},
			mapzone="Blade's Edge Mountains",
			level=67,
		}, {
			"Go to 21,56 on the bridge",
			"	a. Talk to Netherologist Coppernickels",
			"		i. Accept "..cq("Off To Area 52"),
			completion={{questaccepted="Off To Area 52"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=55607690,
		}, {
			"Go east to "..cl(32,57),
			"	a. Talk to Bot-Specialist Alley",
			"		i. Accept "..cq("Recharging the Batteries"),
			completion={{questaccepted="Recharging the Batteries"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=56608810,
		}, {
			"Go northwest to "..cl(26,52),
			"	a. Kill Phase Hunters",
			"	b. You will see a message in your chat window saying "..cq("Phase Hunter is very weak"),
			"	c. Use your Battery Recharging Blaster on them when you see this message",
			"	d. Get 10 Battery Charge Levels",
			completion={{questgoal={"*","Battery Charge Level",10}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=51907840,
		}, {
			"Go southeast to "..cl(32,57),
			"	a. Talk to Bot-Specialist Alley",
			"		i. Turn in "..cq("Recharging the Batteries"),
			completion={{questturnedin="Recharging the Batteries"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=56608810,
		}, {
			"Go south to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Boots",
			"		i. Accept "..cq("Securing the Shaleskin Shale"),
			completion={{questaccepted="Securing the Shaleskin Shale"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=63909620,
		}, {
			"Also at "..cl(32,64),
			"	a. Talk to Nether-Stalker Khay'ji",
			"		i. Accept "..cq("Consortium Crystal Collection"),
			completion={{questaccepted="Consortium Crystal Collection"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64209660,
		}, {
			"Also at "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Accept "..cq("Manaforge B'naar"),
			completion={{questaccepted="Manaforge B'naar"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64009600,
		}, {
			"Make Area 52 your home",
			completion={{home="Area 52"}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(33,65),
			"	a. Talk to Rocket-Chief Fuselage",
			"		i. Turn in "..cq("Off To Area 52"),
			"		ii. Accept "..cq("You're Hired!"),
			completion={{questturnedin="Off To Area 52"},{questaccepted="You're Hired!"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=65009770,
		}, {
			"Go to "..cl(31,66),
			"	a. Talk to Ravandwyr",
			"		i. Accept "..cq("The Archmage's Staff"),
			completion={{questaccepted="The Archmage's Staff"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66209760,
		}, {
			"Go to "..cl(34,64),
			"	a. Talk to Krexcil",
			"		i. Get the Area 52 Flight Path",
			completion={{flightpath="Area 52"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64009770,
		}, {
			"Go north to "..cl(33,60),
			"	a. Kill Shaleskin Flayers",
			"	b. Get 5 Shaleskin Shales",
			completion={{questgoal={"*","Shaleskin Shale",5}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=60009310,
		}, {
			"Go northwest to "..cl(32,57),
			"	a. Talk to Maxx A. Million Mk. V",
			"		i. Accept "..cq("Mark V is Alive!"),
			"	b. Escort Maxx A. Million Mk. V",
			"	c. While escorting Maxx A. Million Mk. V",
			"	d. Click the red glowing crystals on the ground",
			"	e. Get 10 Etherium Matrix Crystals",
			completion={{questgoal={"*","Etherlithium Matrix Crystal",10}},{questaccepted="Mark V is Alive!"},{questgoal={"*","Escort the Maxx A. Million Mk. V safely through the Ruins of Enkaat",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=56608810,
		}, {
			"Go to "..cl(32,57),
			"	a. Talk to Bot-Specialist Alley",
			"		i. Turn in "..cq("Mark V is Alive!"),
			completion={{questturnedin="Mark V is Alive!"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=56608810,
		}, {
			"Go south to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Boots",
			"		i. Turn in "..cq("Securing the Shaleskin Shale"),
			"		ii. Accept "..cq("That Little Extra Kick"),
			completion={{questturnedin="Securing the Shaleskin Shale"},{questaccepted="That Little Extra Kick"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=63909620,
		}, {
			"Go to "..cl(33,65),
			"	a. Talk to Rocket-Chief Fuselage",
			"		i. Turn in "..cq("You're Hired!"),
			"		ii. Accept "..cq("Invaluable Asset Zapping"),
			"		iii. Accept "..cq("Report to Engineering"),
			completion={{questturnedin="You're Hired!"},{questaccepted="Invaluable Asset Zapping"},{questaccepted="Report to Engineering"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=65009770,
		}, {
			"Go northeast to "..cl(32,67),
			"	a. Talk to Chief Engineer Trep",
			"		i. Turn in "..cq("Report to Engineering"),
			"		ii. Accept "..cq("Essence for the Engines"),
			completion={{questturnedin="Report to Engineering"},{questaccepted="Essence for the Engines"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66809920,
		}, {
			"Go northeast to "..cl(35,59),
			"	a. Kill Mana Wraiths",
			"	b. Get 7 Mana Wraith Essences",
			completion={{questgoal={"*","Mana Wraith Essence",7}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=59109390,
		}, {
			"Go west to "..cl(32,61),
			"	a. Kill Nether Rays",
			"	b. They are uncommon, so just grind in this area",
			"	c. Get 5 Nether Ray Stingers",
			completion={{questgoal={"*","Nether Ray Stinger",5}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=60609270,
		}, {
			"Go south to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Boots",
			"		i. Turn in "..cq("That Little Extra Kick"),
			completion={{questturnedin="That Little Extra Kick"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=63909620,
		}, {
			"Go to "..cl(32,67),
			"	a. Talk to Chief Engineer Trep",
			"		i. Turn in "..cq("Essence for the Engines"),
			"		ii. Accept "..cq("Elemental Power Extraction"),
			completion={{questturnedin="Essence for the Engines"},{questaccepted="Elemental Power Extraction"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66809920,
		}, {
			"Go west to "..cl(28,65),
			"	a. Kill Captain Arathyn",
			"	b. Get the B'naar Personnel Roster",
			completion={{questgoal={"*","B'naar Personnel Roster",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=65009280,
		}, {
			"Go southeast to "..cl(35,77),
			"	a. Use the Elemental Power Extractor on Sundered Rumblers and Warp Aberrations",
			"	b. Kill them",
			"	c. Click the blue crystal floating over their corpses",
			"	d. Get 5 Elemental Powers",
			completion={{questgoal={"*","Elemental Power",5}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=76511190,
		}, {
			"Go northeast to "..cl(40,73),
			"	a. Click the tall metal turret with the gun pointing at the ground",
			"	b. Retrieve the Multi-Spectrum Terrain Analyzer",
			completion={{questgoal={"*","Multi-Spectrum Terrain Analyzer retrieved",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=72911320,
		}, {
			"Go southeast to "..cl(41,74),
			"	a. Click the wooden cart with a big digging wheel on it",
			"	b. Retrieve the Hyper Rotational Dig-A-Matic",
			completion={{questgoal={"*","Hyper Rotational Dig-A-Matic retrieved",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=73811480,
		}, {
			"Go northeast to "..cl(42,73),
			"	a. Kill Pentatharon",
			"	b. Get the Arklon Crystal Artifact",
			completion={{questgoal={"*","Arklon Crystal Artifact",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=72811520,
		}, {
			"Go north to "..cl(43,72),
			"	a. Click the wagon with a bunch of explosives on it",
			"	b. Retrieve the Big Wagon Full of Explosives",
			completion={{questgoal={"*","Big Wagon Full of Explosives retrieved",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=72211470,
		}, {
			"Go west to "..cl(41,72),
			"	a. Click the crane digging machine with a bunch of gears on it",
			"	b. Retrive the Servo-Penumatic Dredging Claw",
			completion={{questgoal={"*","Servo-Pneumatic Dredging Claw retrieved",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=71811320,
		}, {
			"Go southwest to "..cl(41,73),
			"	a. Get next to the broken, smoking altar on the small hill",
			"	b. Use your Conjuring Powder to summon Ekkorash",
			"	c. Kill Ekkorash",
			"	d. Get Archmage Vargoth's Staff",
			completion={{questgoal={"*","Archmage Vargoth's Staff",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=72511340,
		}, {
			"Go northwest to "..cl(34,68),
			"	a. Talk to Lead Sapper Blastfizzle",
			"		i. Turn in "..cq("Invaluable Asset Zapping"),
			"		ii. Accept "..cq("Dr. Boom!"),
			completion={{questturnedin="Invaluable Asset Zapping"},{questaccepted="Dr. Boom!"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=68110230,
		}, {
			"Go north to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(31,66),
			"	a. Talk to Ravandwyr",
			"		i. Turn in "..cq("The Archmage's Staff"),
			"		ii. Accept "..cq("Rebuilding the Staff"),
			completion={{questturnedin="The Archmage's Staff"},{questaccepted="Rebuilding the Staff"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66209760,
		}, {
			"Go to "..cl(33,67),
			"	a. Talk to Chief Engineer Trep",
			"		i. Turn in "..cq("Elemental Power Extraction"),
			completion={{questturnedin="Elemental Power Extraction"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66809920,
		}, {
			"Go to "..cl(33,64),
			"	a. Talk to Nether-Stalker Khay'ji",
			"		i. Turn in "..cq("Consortium Crystal Collection"),
			"		ii. Accept "..cq("A Heap of Ethereals"),
			completion={{questturnedin="Consortium Crystal Collection"},{questaccepted="A Heap of Ethereals"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64209660,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("Manaforge B'naar"),
			"		ii. Accept "..cq("High Value Targets"),
			"	b. Talk to Magistrix Larynna",
			"		i. Accept "..cq("Bloodgem Crystals"),
			completion={{questturnedin="Manaforge B'naar"},{questaccepted="High Value Targets"},{questaccepted="Bloodgem Crystals"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64009600,
		}, {
			"Go to "..cl(33,65),
			"	a. Talk to Papa Wheeler",
			"		i. Accept "..cq("Pick Your Part"),
			completion={{questaccepted="Pick Your Part"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64709770,
		}, {
			"Go north to "..cl(34,53),
			"	a. Kill Disembodied Ghosts",
			"	b. Get 4 Flawless Crystal Shards",
			completion={{questgoal={"*","Flawless Crystal Shard",4}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=53008650,
		}, {
			"Go southeast to "..cl(35,60),
			"	a. Dr. Boom sends out little walking bombs that blow up",
			"		i. Don't let them hit you, they hurt a lot",
			"	b. When you see a clear path to Dr. Boom:",
			"		i. Click Boom's Doom in your bags",
			"		ii. Run up and throw the bomb at Dr. Boom",
			"		iii. Repeat until Dr. Boom is dead",
			completion={{questgoal={"*","Dr. Boom slain",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=59609460,
		}, {
			"Go south to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(31,66),
			"	a. Talk to Ravandwyr",
			"		i. Turn in "..cq("Rebuilding the Staff"),
			"		ii. Accept "..cq("Curse of the Violet Tower"),
			completion={{questturnedin="Rebuilding the Staff"},{questaccepted="Curse of the Violet Tower"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66209760,
		}, {
			"Go to "..cl(34,68),
			"	a. Talk to Lead Sapper Blastfizzle",
			"		i. Turn in "..cq("Dr. Boom!"),
			completion={{questturnedin="Dr. Boom!"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=68110230,
		}, {
			"Go west to "..cl(26,67),
			"	a. Kill Sunfury Magisters",
			"	b. Get a Bloodgem Shard",
			"	c. Use the Bloodgem Shard next to a big red floating crystal",
			"	d. Siphon the Bloodgem Crystal",
			completion={{questgoal={"*","Siphon Bloodgem Crystal",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=66709300,
		}, {
			"You may need to group up for the next step",
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go southeast to "..cl(27,70),
			"	a. Kill 2 Sunfury Warp-Masters",
			"	b. Kill 6 Sunfury Warp-Engineers",
			"	c. Kill 8 Sunfury Geologists",
			completion={{questgoal={"*","Sunfury Warp-Master slain",2}},{questgoal={"*","Sunfury Warp-Engineer slain",6}},{questgoal={"*","Sunfury Geologist slain",8}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=70509740,
		}, {
			"Go southeast to "..cl(30,76),
			"	a. Kill Zaxxi's mummies",
			"	b. Get 10 Zaxxi's Insignias",
			"	c. Click the Theral Technology on the ground",
			"	d. Get 10 Ethereal Technology",
			completion={{questgoal={"*","Ethereal Technology",10}},{questgoal={"*","Zaxxis Insignia",10}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=75510570,
		}, {
			"Go northeast to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=67,
		}, {
			"Go to "..cl(33,65),
			"	a. Talk to Papa Wheeler",
			"		i. Turn in "..cq("Pick Your Part"),
			"		ii. Accept "..cq("In A Scrap With The Legion"),
			"		iii. Accept "..cq("Help Mama Wheeler"),
			completion={{questturnedin="Pick Your Part"},{questaccepted="In A Scrap With The Legion"},{questaccepted="Help Mama Wheeler"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64709770,
		}, {
			"Go to "..cl(33,64),
			"	a. Talk to Nether-Stalker Khay'ji",
			"		i. Turn in "..cq("A Heap of Ethereals"),
			"		ii. Accept "..cq("Warp-Raider Nesaad"),
			completion={{questturnedin="A Heap of Ethereals"},{questaccepted="Warp-Raider Nesaad"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64209660,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("High Value Targets"),
			"		ii. Accept "..cq("Shutting Down Manaforge B'naar"),
			"	b. Talk to Magistrix Larynna",
			"		i. Turn in "..cq("Bloodgem Crystals"),
			completion={{questturnedin="High Value Targets"},{questturnedin="Bloodgem Crystals"},{questaccepted="Shutting Down Manaforge B'naar"}},
			mapzone="Netherstorm",
			level=67,
			mapnote=64009600,
		}, {
			"Grind to level 68",
			completion={{level=68}},
			mapzone="Netherstorm",
			level=67,
		}
	  },
	},
	{ sectiontitle = "Levels (68-70)",
	  steps = {
		{
			"Go southwest to Manaforge B'naar",
			completion={{location={mapzone="Netherstorm",x=23.4,y=68.6, dist=3}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go inside Manaforge B'naar",
			completion={{location={mapzone="Netherstorm",x=23.3,y=68.6, dist=1.5}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(24,71),
			"	a. Kill Overseer Theredis",
			"	b. Get the B'naar Access Crystal",
			completion={{questgoal={"*","B'naar Access Crystal",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=70709460,
		}, {
			"Go to "..cl(23,70),
			"	a. Use the B'naar Access Crystal to shut down Manaforge B'naar",
			"	b. Kill the technicians as they come to try to save the Manaforge",
			"		i. Only takes 2 minutes",
			completion={{questgoal={"*","Manaforge B'naar Shut Down",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=68509150,
		}, {
			"Hearth to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("Shutting Down Manaforge B'naar"),
			"		ii. Accept "..cq("Stealth Flight"),
			completion={{questturnedin="Shutting Down Manaforge B'naar"},{questaccepted="Stealth Flight"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64009600,
		}, {
			"Go southwest to "..cl(28,79),
			"	a. Kill Warp-Raider Nesaad",
			completion={{questgoal={"*","Warp-Raider Nesaad slain",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=79410760,
		}, {
			"Go northeast to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(33,64),
			"	a. Talk to Nether-Stalker Khay'ji",
			"		i. Turn in "..cq("Warp-Raider Nesaad"),
			"		ii. Accept "..cq("Request for Assistance"),
			completion={{questturnedin="Warp-Raider Nesaad"},{questaccepted="Request for Assistance"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64209660,
		}, {
			"Go to "..cl(34,64),
			"	a. Talk to Veronia",
			"		i. Turn in "..cq("Stealth Flight"),
			"		ii. Accept "..cq("Behind Enemy Lines"),
			"	b. Talk to Veronia",
			"		i. Click "..cq("I'm as ready as I'll ever be."),
			"		ii. You will fly to Manaforge Coruu",
			completion={{questturnedin="Stealth Flight"},{questaccepted="Behind Enemy Lines"},{location={mapzone="Netherstorm",x=48.0,y=86.0, dist=2}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64209800,
		}, {
			"When you land at "..cl(48,87),
			"	a. Talk to Caledis Brightdawn",
			"		i. Turn in "..cq("Behind Enemy Lines"),
			"		ii. Accept "..cq("A Convincing Disguise"),
			completion={{questturnedin="Behind Enemy Lines"},{questaccepted="A Convincing Disguise"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86613480,
		}, {
			"Go northwest to "..cl(48,85),
			"	a. Kill Sunfury Researchers",
			"	b. Kill Sunfury Guardians",
			"	c. Kill Sunfury Arcanists",
			"	d. Get the Sunfury Researcher Gloves",
			"	e. Get the Sunfury Guardsman Medallion",
			"	f. Get the Sunfury Arcanist Robes",
			completion={{questgoal={"*","Sunfury Researcher Gloves",1}},{questgoal={"*","Sunfury Guardsman Medallion",1}},{questgoal={"*","Sunfury Arcanist Robes",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=84913260,
		}, {
			"Go southeast to "..cl(48,87),
			"	a. Talk to Caledis Brightdawn",
			"		i. Turn in "..cq("A Convincing Disguise"),
			"		ii. Accept "..cq("Information Gathering"),
			completion={{questturnedin="A Convincing Disguise"},{questaccepted="Information Gathering"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86613480,
		}, {
			"Use the Sunfury Disguise in your bags",
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go inside Manaforge Coruu",
			"	a. Be careful to avoid the Arcane Annihilator, he can see through the disguise and will attack you",
			mapzone="Netherstorm",
			level=68,
		}, {
			"Inside Manaforge Coruu, go to "..cl(48,84),
			"	a. Stand between the 2 blood elves at the back of the room with a bunch blood elves lined up in it",
			"	b. Listen to them talk",
			"	c. Gather the Information",
			completion={{questgoal={"*","Information Gathering",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=84113230,
		}, {
			"Go south to "..cl(48,87),
			"	a. Talk to Caledis Brightdawn",
			"		i. Turn in "..cq("Information Gathering"),
			"		ii. Accept "..cq("Shutting Down Manaforge Coruu"),
			completion={{questturnedin="Information Gathering"},{questaccepted="Shutting Down Manaforge Coruu"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86613480,
		}, {
			"Go to "..cl(49,82),
			"	a. Kill Overseer Seylanna",
			"	b. Get the Coruu Access Crystal",
			"	c. Use the Coruu Access Crystal to shut down Manaforge Coruu",
			"	d. Kill the technicians as they come to try to save the Manaforge",
			"		i. Only takes 2 minutes",
			completion={{questgoal={"*","Coruu Access Crystal",1}},{questgoal={"*","Manaforge Coruu Shut Down",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=81513050,
		}, {
			"Go southwest to "..cl(48,87),
			"	a. Talk to Caledris Brightdawn",
			"		i. Turn in "..cq("Shutting Down Manaforge Coruu"),
			"		ii. Accept "..cq("Return to Thalodien"),
			completion={{questturnedin="Shutting Down Manaforge Coruu"},{questaccepted="Return to Thalodien"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86613480,
		}, {
			"Go east to Kirin'Var Village",
			completion={{location={mapzone="Netherstorm",x=59.8,y=89.2, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(58,85),
			"	a. Talk to Thadell",
			"		i. Accept "..cq("Needs More Cowbell"),
			"	b. Talk to Apprentice Andrethan",
			"		i. Accept "..cq("Indispensable Tools"),
			completion={{questaccepted="Needs More Cowbell"},{questaccepted="Indispensable Tools"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85214290,
		}, {
			"Go to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Accept "..cq("Malevolent Remnants"),
			"	b. Use Archmage Vargoth's Staff on the steps of the tower",
			"	c. Talk to the Image of Archmage Vargoth",
			"		i. Turn in "..cq("Curse of the Violet Tower"),
			"		ii. Accept "..cq("The Sigil of Krasus"),
			"	d. Talk to Lieutenant-Sorcerer Morran",
			"		i. Accept "..cq("The Unending Invasion"),
			"	e. Talk to Custodian Dieworth",
			"		i. Accept "..cq("A Fate Worse Than Death"),
			completion={{questturnedin="Curse of the Violet Tower"},{questaccepted="The Unending Invasion"},{questaccepted="A Fate Worse Than Death"},{questaccepted="Malevolent Remnants"},{questaccepted="The Sigil of Krasus"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Kill 20 Severed Spirits as you quest around this area",
			completion={{questgoal={"*","Severed Spirit slain",20}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85514420,
		}, {
			"Go northeast to "..cl(59,74),
			"	a. Talk to Bessy",
			"		i. Turn in "..cq("Needs More Cowbell"),
			"		ii. Accept "..cq("When the Cows Come Home"),
			"	b. Escort Bessy to Thadell",
			"		i. Let her get hit first or she won't help fight",
			completion={{questturnedin="Needs More Cowbell"},{questaccepted="When the Cows Come Home"},{questgoal={"*","Escort Bessy on her way home.",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=78813790,
		}, {
			"At "..cl(58,85),
			"	a. Talk to Thadell",
			"		i. Turn in "..cq("When the Cows Come Home"),
			completion={{questturnedin="When the Cows Come Home"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85214290,
		}, {
			"Go south to "..cl(58,88),
			"	a. Kill Abjurist Belmara",
			"	b. Get Belmara's Tome",
			"	c. Click Belmara's Tome",
			"		i. Accept "..cq("Abjurist Belmara"),
			completion={{questaccepted="Abjurist Belmara"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=88314670,
		}, {
			"Go east to "..cl(60,88),
			"	a. Kill Cohlien Frostweaver",
			"	b. Get Cohlien's Cap ",
			"	c. Click Cohlien's Cap",
			"		i. Accept "..cq("Cohlien Frostweaver"),
			completion={{questaccepted="Cohlien Frostweaver"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=87714730,
		}, {
			"Also at "..cl(60,88),
			"	a. Go inside the town hall looking building",
			"	b. Kill Battle-Mage Dathric",
			"	c. Get Dathric's Blade",
			"	d. Click Dathric's Blade",
			"		i. Accept "..cq("Battle-Mage Dathric"),
			completion={{questaccepted="Battle-Mage Dathric"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=88014840,
		}, {
			"Go north to "..cl(60,86),
			"	a. Kill Conjurer Luminrath",
			"	b. Get Luminrath's Mantle",
			"	c. Click Luminrath's Mantle",
			"		i. Accept "..cq("Conjurer Luminrath"),
			completion={{questaccepted="Conjurer Luminrath"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85614550,
		}, {
			"Go east to "..cl(61,85),
			"	a. Kill Kirin'Var Apprentices",
			"	b. Get a Smithing Hammer",
			completion={{questgoal={"*","Smithing Hammer",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85014600,
		}, {
			"Go west to "..cl(58,85),
			"	a. Talk to Apprentice Andrethan",
			"		i. Turn in "..cq("Indispensable Tools"),
			"		ii. Accept "..cq("Master Smith Rhonsus"),
			completion={{questturnedin="Indispensable Tools"},{questaccepted="Master Smith Rhonsus"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85214290,
		}, {
			"Go to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("Malevolent Remnants"),
			"		ii. Accept "..cq("The Annals of Kirin'Var"),
			completion={{questturnedin="Malevolent Remnants"},{questaccepted="The Annals of Kirin'Var"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go east to "..cl(62,85),
			"	a. Kill Rhonsus",
			completion={{questgoal={"*","Rhonsus slain",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85014630,
		}, {
			"Go west to "..cl(58,85),
			"	a. Talk to Apprentice Andrethan",
			"		i. Turn in "..cq("Master Smith Rhonsus"),
			completion={{questturnedin="Master Smith Rhonsus"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85214290,
		}, {
			"Kill 10 Mana Seekers and 10 Mageslayers as you do the following steps:",
			completion={{questgoal={"*","Mana Seeker slain",10}},{questgoal={"*","Mageslayer slain",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85414230,
		}, {
			"Go south to "..cl(57,87),
			"	a. Go inside the little house",
			"	b. Click Dathric's Blade when standing next to the Weapon Rack",
			"	c. Put Dathric's Spirit to Rest",
			completion={{questgoal={"*","Put Dathric's Spirit to Rest",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86814370,
		}, {
			"Go south to "..cl(56,88),
			"	a. Go inside the little house",
			"	b. Click Luminrath's Mantle when standing next to the Dresser",
			"	c. Put Luminrath's Spirit to Rest",
			completion={{questgoal={"*","Put Luminrath's Spirit to Rest",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=87814420,
		}, {
			"Go west to "..cl(56,87),
			"	a. Click the big white ball with blue dots on it",
			"	b. Get the Mana Bomb Fragment",
			completion={{questgoal={"*","Mana Bomb Fragment",1}}},
			mapzone="Netherstorm",
			level=67,
			mapnote=87214290,
		}, {
			"Go west to "..cl(55,88),
			"	a. The Footlocker is in a pile of junk in a house with no roof",
			"	b. Click Cohlien's Cap when standing next to the Foot Locker",
			"	c. Put Cohlien's Spirit to Rest",
			completion={{questgoal={"*","Put Cohlien's Spirit to Rest",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=87514260,
		}, {
			"Go north to "..cl(56,86),
			"	a. Go inside the house with a huge log laying diagonally into it",
			"	b. Click Belmara's Tome when standing next to the Bookshelf",
			"	c. Put Belmara's Spirit to Rest",
			completion={{questgoal={"*","Put Belmara's Spirit to Rest",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86514200,
		}, {
			"Go east to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("A Fate Worse Than Death"),
			"		ii. Turn in "..cq("Abjurist Belmara"),
			"		iii. Turn in "..cq("Conjurer Luminrath"),
			"		iv. Turn in "..cq("Cohlien Frostweaver"),
			"		v. Turn in "..cq("Battle-Mage Dathric"),
			"	b. Talk to Lieutenant Sorcerer Morran",
			"		i. Turn in "..cq("The Unending Invasion"),
			"		ii. Accept "..cq("Potential Energy Source"),
			completion={{questturnedin="A Fate Worse Than Death"},{questturnedin="Abjurist Belmara"},{questturnedin="Conjurer Luminrath"},{questturnedin="Cohlien Frostweaver"},{questturnedin="Battle-Mage Dathric"},{questturnedin="The Unending Invasion"},{questaccepted="Potential Energy Source"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go east to "..cl(60,88),
			"	a. Kill Battle-Mage Dathric",
			"	b. Get the Annals of Kirin'Var",
			completion={{questgoal={"*","Annals of Kirin'Var",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=88014840,
		}, {
			"Go west to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("The Annals of Kirin'Var"),
			"		ii. Accept "..cq("Searching for Evidence"),
			completion={{questturnedin="The Annals of Kirin'Var"},{questaccepted="Searching for Evidence"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go northeast to "..cl(60,78),
			"	a. Go inside the barn",
			"	b. Click the Necromantic Focus",
			"		i. Turn in "..cq("Searching for Evidence"),
			"		ii. Accept "..cq("A Lingering Suspicion"),
			completion={{questturnedin="Searching for Evidence"},{questaccepted="A Lingering Suspicion"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=78013830,
		}, {
			"Go south to "..cl(60,79),
			"	a. Kill ghosts around this area",
			"	b. Get 10 Loathsome Remnants",
			completion={{questgoal={"*","Loathsome Remnant",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=79513930,
		}, {
			"Go southwest to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("A Lingering Suspicion"),
			"		ii. Accept "..cq("Capturing the Phylactery"),
			completion={{questturnedin="A Lingering Suspicion"},{questaccepted="Capturing the Phylactery"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go northeast to "..cl(60,80),
			"	a. Go behind the first building on the right as you walk over the bridge",
			"	b. Click the Suspicious Outhouse",
			"	c. Get Naberius's Phylactery",
			completion={{questgoal={"*","Naberius's Phylactery",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=80414030,
		}, {
			"Go southwest to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("Capturing the Phylactery"),
			completion={{questturnedin="Capturing the Phylactery"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go northwest to "..cl(51,83),
			"	a. Click the little clear boxes with purple light in them on the ground",
			"	b. Get 10 Energy Isolation Cubes",
			completion={{questgoal={"*","Energy Isolation Cube",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=82513360,
		}, {
			"Go north to "..cl(51,81),
			"	a. Kill Spellbinder Maryana",
			"	b. Get the Sigil of Krasus",
			"	c. Use Archmage Vargoth's Staff",
			"	d. Talk to the Image of Archmage Vargoth",
			"		i. Turn in "..cq("The Sigil of Krasus"),
			"		ii. Accept "..cq("Krasus's Compendium"),
			completion={{questturnedin="The Sigil of Krasus"},{questaccepted="Krasus's Compendium"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=80713180,
		}, {
			"Go southeast to "..cl(58,86),
			"	a. Talk to Lieutenant-Sorcerer Morran",
			"		i. Turn in "..cq("Potential Energy Source"),
			"		ii. Accept "..cq("Building a Perimeter"),
			completion={{questturnedin="Potential Energy Source"},{questaccepted="Building a Perimeter"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go south to "..cl(58,90),
			"	a. Click the glowing scroll on the ground in the small house",
			"	b. Get Krasus's Compendium - Chapter 2",
			completion={{questgoal={"*","Krasus's Compendium - Chapter 2",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=89614720,
		}, {
			"Go east to "..cl(59,89),
			"	a. Click the glowing scroll on the ground in the small house",
			"	b. Get Krasus's Compendium - Chapter 1",
			completion={{questgoal={"*","Krasus's Compendium - Chapter 1",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=89214780,
		}, {
			"Go north to "..cl(59,88),
			"	a. Click the glowing scroll on the ground in the small house",
			"	b. Get Krasus's Compendium - Chapter 3",
			"	c. Use Archmage Vargoth's Staff",
			"	d. Talk to the Image of Archmage Vargoth",
			"		i. Turn in "..cq("Krasus's Compendium"),
			"		ii. Accept "..cq("Unlocking the Compendium"),
			completion={{questturnedin="Krasus's Compendium"},{questaccepted="Unlocking the Compendium"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=87914670,
		}, {
			"Go north to "..cl(59,85),
			"	a. Use the Rune Activation Device on the blue floating symbol",
			"	b. Activate the Eastern Rune",
			completion={{questgoal={"*","Activate Eastern Rune",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=85414460,
		}, {
			"Go northwest to "..cl(57,83),
			"	a. Use the Rune Activation Device on the blue floating symbol",
			"	b. Activate the Northeastern Rune",
			completion={{questgoal={"*","Activate Northeastern Rune",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=82914020,
		}, {
			"Go southwest to "..cl(54,86),
			"	a. Use the Rune Activation Device on the blue floating symbol",
			"	b. Activate the Western Rune",
			completion={{questgoal={"*","Activate Western Rune",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86114040,
		}, {
			"Go east to "..cl(58,86),
			"	a. Talk to Lieutenant-Sorcerer Morran",
			"		i. Turn in "..cq("Building a Perimeter"),
			"		ii. Accept "..cq("Torching Sunfury Hold"),
			"	b. Talk to Custodian Dieworth",
			"		i. Accept "..cq("The Sunfury Garrison"),
			completion={{questturnedin="Building a Perimeter"},{questaccepted="Torching Sunfury Hold"},{questaccepted="The Sunfury Garrison"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Go north to "..cl(56,80),
			"	a. Kill 10 Sunfury Archers",
			completion={{questgoal={"*","Sunfury Archer slain",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=80113650,
		}, {
			"Go north to "..cl(56,79),
			"	a. Kill Spellweaver Marathelle",
			"	b. Get the Heliotrope Oculus",
			completion={{questgoal={"*","Heliotrope Oculus",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=78513500,
		}, {
			"Go east to "..cl(57,79),
			"	a. Kill a Sunfury Flamekeeper",
			"	b. Get a Flaming Torch",
			"	c. Use te torch on the tall hut looking things and the big spear gun cars",
			"	d. Destroy 4 Sunfury Ballistas",
			"	e. Destroy 4 Sunfury Tents",
			completion={{questgoal={"*","Sunfury Ballista Destroyed",4}},{questgoal={"*","Sunfury Tent Destroyed",4}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=78513530,
		}, {
			"Go south to Kirin'Var Village",
			completion={{location={mapzone="Netherstorm",x=59.8,y=89.2, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Use Archmage Vargoth's Staff",
			"	a. Talk to the Image Archmage Vargoth",
			"		i. Turn in "..cq("Unlocking the Compendium"),
			"		ii. Accept "..cq("Summoner Kanthin's Prize"),
			completion={{questturnedin="Unlocking the Compendium"},{questaccepted="Summoner Kanthin's Prize"}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(58,86),
			"	a. Talk to Lieutenant-Sorcerer Morran",
			"		i. Turn in "..cq("Torching Sunfury Hold"),
			"	b. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("The Sunfury Garrison"),
			"		ii. Accept "..cq("Down With Daellis"),
			completion={{questturnedin="Torching Sunfury Hold"},{questturnedin="The Sunfury Garrison"},{questaccepted="Down With Daellis"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Hearth to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("Return to Thalodien"),
			"		ii. Accept "..cq("Shutting Down Manaforge Duro"),
			"	b. Talk to Magistrix Larynna",
			"		i. Accept "..cq("Kick Them While They're Down"),
			completion={{questturnedin="Return to Thalodien"},{questaccepted="Shutting Down Manaforge Duro"},{questaccepted="Kick Them While They're Down"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64009600,
		}, {
			"Go northeast to Eco-Dome Midrealm",
			completion={{location={mapzone="Netherstorm",x=45.5,y=53.1, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(47,57),
			"	a. Talk to Gahruj",
			"		i. Turn in "..cq("Request for Assistance"),
			"		ii. Accept "..cq("Rightful Repossession"),
			"		iii. Accept "..cq("Drijya Needs Your Help"),
			completion={{questturnedin="Request for Assistance"},{questaccepted="Rightful Repossession"},{questaccepted="Drijya Needs Your Help"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56910360,
		}, {
			"Also at "..cl(47,57),
			"	a. Talk to Mama Wheeler",
			"		i. Turn in "..cq("Help Mama Wheeler"),
			"		ii. Accept "..cq("One Demon's Trash..."),
			completion={{questturnedin="Help Mama Wheeler"},{questaccepted="One Demon's Trash..."}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56510310,
		}, {
			"Go to "..cl(47,56),
			"	a. Talk to Mehrdad",
			"		i. Accept "..cq("Run a Diagnostic!"),
			"		ii. Accept "..cq("New Opportunities"),
			completion={{questaccepted="Run a Diagnostic!"},{questaccepted="New Opportunities"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56410290,
		}, {
			"Also at "..cl(47,57),
			"	a. Talk to Shauly Pore",
			"		i. Accept "..cq("Keeping Up Appearances"),
			completion={{questaccepted="Keeping Up Appearances"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56010250,
		}, {
			"Go northeast to "..cl(48,55),
			"	a. Click the Diagnostic Equipment",
			"	b. Get the Diagnostic Results",
			completion={{questgoal={"*","Diagnostic Results",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=55010320,
		}, {
			"Go north to "..cl(48,54),
			"	a. Click the tall flowers pinkish purple heads",
			"	b. Get 15 Ivory Bells",
			completion={{questgoal={"*","Ivory Bell",15}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=53710190,
		}, {
			"Go northwest to "..cl(43,50),
			"	a. Kill Ripfang Lynxes",
			"	b. Get 10 Ripfang Lynx Pelts",
			completion={{questgoal={"*","Ripfang Lynx Pelt",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=50409360,
		}, {
			"Go southeast to "..cl(47,56),
			"	a. Talk to Mehrdad",
			"		i. Turn in "..cq("Run a Diagnostic!"),
			"		ii. Accept "..cq("Deal With the Saboteurs"),
			"		iii. Turn in "..cq("New Opportunities"),
			completion={{questturnedin="Run a Diagnostic!"},{questturnedin="New Opportunities"},{questaccepted="Deal With the Saboteurs"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56410290,
		}, {
			"Also at "..cl(47,56),
			"	a. Talk to Shauly Pore",
			"		i. Turn in "..cq("Keeping Up Appearances"),
			"		ii. Accept "..cq("The Dynamic Duo"),
			completion={{questturnedin="Keeping Up Appearances"},{questaccepted="The Dynamic Duo"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56010250,
		}, {
			"Go north to "..cl(47,54),
			"	a. Kill 8 Barbscale Crocolisks",
			completion={{questgoal={"*","Barbscale Crocolisk slain",8}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=54410170,
		}, {
			"Go south to "..cl(47,56),
			"	a. Talk to Mehrdad",
			"		i. Turn in "..cq("Deal With the Saboteurs"),
			"		ii. Accept "..cq("To the Stormspire"),
			completion={{questturnedin="Deal With the Saboteurs"},{questaccepted="To the Stormspire"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56410290,
		}, {
			"Go southeast to "..cl(49,52),
			"	a. Click the brown clumps of metal on the ground",
			"	b. Get 10 Fel Reaver Parts",
			completion={{questgoal={"*","Fel Reaver Part",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=59310840,
		}, {
			"Go east to "..cl(50,60),
			"	a. Kill 5 Mo'arg Doomsmiths",
			"	b. Kill 15 Gan'arg Engineers",
			completion={{questgoal={"*","Mo'arg Doomsmith slain",5}},{questgoal={"*","Gan'arg Engineer slain",15}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=59710970,
		}, {
			"Go northwest to "..cl(47,57),
			"	a. Talk to Mama Wheeler",
			"		i. Turn in "..cq("One Demon's Trash..."),
			"		ii. Accept "..cq("Declawing Doomclaw"),
			completion={{questturnedin="One Demon's Trash..."},{questaccepted="Declawing Doomclaw"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56510310,
		}, {
			"Go east to "..cl(51,57),
			"	a. Kill Doomclaw",
			"	b. Get Doomclaw's Hand",
			completion={{questgoal={"*","Doomclaw's Hand",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=57210790,
		}, {
			"Go west to "..cl(47,57),
			"	a. Talk to Mama Wheeler",
			"		i. Turn in "..cq("Declawing Doomclaw"),
			"		ii. Accept "..cq("Warn Area 52!"),
			completion={{questturnedin="Declawing Doomclaw"},{questaccepted="Warn Area 52!"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56510310,
		}, {
			"Go south to "..cl(48,63),
			"	a. Talk to Drijya",
			"		i. Turn in "..cq("Drijya Needs Your Help"),
			completion={{questturnedin="Drijya Needs Your Help"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=63511160,
		}, {
			"Go east to "..cl(56,64),
			"	a. Kill 8 Sunfury Conjurers",
			"	b. Kill 6 Sunfury Bowmen",
			"	c. Kill 4 Sunfury Centurions",
			completion={{questgoal={"*","Sunfury Conjurer slain",8}},{questgoal={"*","Sunfury Bowman slain",6}},{questgoal={"*","Sunfury Centurion slain",4}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=63811940,
		}, {
			"Go east to "..cl(57,64),
			"	a. Click the little white boxes on the ground",
			"	b. Get 10 Boxes of Surveying Equipment",
			completion={{questgoal={"*","Box of Surveying Equipment",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64112080,
		}, {
			"Go northeast to "..cl(58,63),
			"	a. Kill Summoner Kanthin",
			"		i. He wanders around this area",
			"	b. Get the Stone of Glacius",
			"	c. Use Archmage Vargoth's Staff",
			"	d. Talk to the Image of Archmage Vargoth",
			"		i. Turn in "..cq("Summoner Kanthin's Prize"),
			"		ii. Accept "..cq("Ar'kelos the Guardian"),
			completion={{questturnedin="Summoner Kanthin's Prize"},{questaccepted="Ar'kelos the Guardian"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=63012090,
		}, {
			"Go southwest to "..cl(57,66),
			"	a. Kill Master Daellis Dawnstrike",
			"		i. He walks along the cliff here",
			completion={{questgoal={"*","Master Daellis Dawnstrike slain",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=65712250,
		}, {
			"Go inside Manaforge Duro to "..cl(60,69),
			"	a. Kill Overseer Athanel",
			"	b. Get the Duro Access Crystal",
			completion={{questgoal={"*","Duro Access Crystal",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=68512850,
		}, {
			"Go northwest to "..cl(59,68),
			"	a. Use the Duro Access Crystal to shut down Manaforge Duro",
			"	b. Kill the technicians as they come to try to save the Manaforge",
			"		i. Only takes 2 minutes",
			completion={{questgoal={"*","Manaforge Duro Shut Down",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=68512850,
		}, {
			"Go east to "..cl(65,67),
			"	a. Talk to Harpax",
			"		i. Get the Cosmowrench Flight Path",
			completion={{flightpath="Cosmowrench"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=66813200,
		}, {
			"Go southwest to Kirin'Var Village",
			completion={{location={mapzone="Netherstorm",x=59.8,y=89.2, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(58,87),
			"	a. Kill Ar'kelos the Guardian",
			completion={{questgoal={"*","Ar'kelos slain",1}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86514470,
		}, {
			"Go to the top of the tower",
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(58,86),
			"	a. Talk to Archmage Vargoth",
			"		i. Turn in "..cq("Ar'kelos the Guardian"),
			completion={{questturnedin="Ar'kelos the Guardian"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86414470,
		}, {
			"Go out of the tower",
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(58,86),
			"	a. Talk to Custodian Dieworth",
			"		i. Turn in "..cq("Down With Daellis"),
			completion={{questturnedin="Down With Daellis"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=86314380,
		}, {
			"Hearth to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("Shutting Down Manaforge Duro"),
			"	b. Talk to Magistrix Larynna",
			"		i. Turn in "..cq("Kick Them While They're Down"),
			"		ii. Accept "..cq("A Defector"),
			completion={{questturnedin="Shutting Down Manaforge Duro"},{questturnedin="Kick Them While They're Down"},{questaccepted="A Defector"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64009600,
		}, {
			"Go to "..cl(33,65),
			"	a. Talk to Papa Wheeler",
			"		i. Turn in "..cq("In A Scrap With The Legion"),
			completion={{questturnedin="In A Scrap With The Legion"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64709770,
		}, {
			"Also at "..cl(33,65),
			"	a. Talk to Rocket-Chief Fuselage",
			"		i. Turn in "..cq("Warn Area 52!"),
			completion={{questturnedin="Warn Area 52!"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=65009770,
		}, {
			"Fly to Cosmowrench",
			completion={{location={mapzone="Netherstorm",x=66.3,y=67.1, dist=2}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(66,67),
			"	a. Talk to Sab'aoth",
			"		i. Accept "..cq("Bloody Imp-ossible!"),
			completion={{questaccepted="Bloody Imp-ossible!"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=67313370,
		}, {
			"Go northwest to "..cl(64,64),
			"	a. Use Zeppit's Crystal to summon Zeppit",
			"		i. He will follow you around",
			"	b. Kill Warp Chasers",
			"	c. Zeppit will run up to their corpses and create a Warp Chaser Blood for you",
			"	d. Get 8 Warp Chaser Blood",
			completion={{questgoal={"*","Warp Chaser Blood",8}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=64212860,
		}, {
			"Go southeast to Cosmowrench",
			completion={{location={mapzone="Netherstorm",x=66.3,y=67.1, dist=2}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(66,67),
			"	a. Talk to Sab'aoth",
			"		i. Turn in "..cq("Bloody Imp-ossible!"),
			completion={{questturnedin="Bloody Imp-ossible!"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=67313370,
		}, {
			"Go northwest to Eco-Dome Midrealm",
			completion={{location={mapzone="Netherstorm",x=45.5,y=53.1, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(47,57),
			"	a. Talk to Gahruj",
			"		i. Turn in "..cq("Rightful Repossession"),
			"		ii. Accept "..cq("An Audience with the Prince"),
			completion={{questturnedin="Rightful Repossession"},{questaccepted="An Audience with the Prince"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=56910360,
		}, {
			"Go north to Stormspire",
			completion={{location={mapzone="Netherstorm",x=44.8,y=35.6, dist=6}}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(42,33),
			"	a. Talk to Aurine Moonblaze",
			"		i. Accept "..cq("Flora of the Eco-Domes"),
			completion={{questaccepted="Flora of the Eco-Domes"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=32607490,
		}, {
			"Go up the lift",
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(44,35),
			"	a. Talk to Ghabar",
			"		i. Turn in "..cq("To the Stormspire"),
			"		ii. Accept "..cq("Diagnosis: Critical"),
			completion={{questturnedin="To the Stormspire"},{questaccepted="Diagnosis: Critical"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=35107860,
		}, {
			"Make Stormspire your home",
			completion={{home="Stormspire"}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go to "..cl(45,37),
			"	a. Talk to Audi the Needle",
			"		i. Turn in "..cq("The Dynamic Duo"),
			"		ii. Accept "..cq("Retrieving the Goods"),
			completion={{questturnedin="The Dynamic Duo"},{questaccepted="Retrieving the Goods"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=36708140,
		}, {
			"Go to "..cl(46,36),
			"	a. Talk to the Image of Nexus-Prince Haramad",
			"		i. Turn in "..cq("An Audience with the Prince"),
			"		ii. Accept "..cq("Triangulation Point One"),
			completion={{questturnedin="An Audience with the Prince"},{questaccepted="Triangulation Point One"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=36008190,
		}, {
			"Go to "..cl(45,35),
			"	a. Talk to Grennik",
			"		i. Get the Stormspire Flight Path",
			completion={{flightpath="Stormspire"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=34908020,
		}, {
			"Also at "..cl(45,35),
			"	a. Talk to Nether-Stalker Nauthis",
			"		i. Accept "..cq("The Minions of Culuthas"),
			"		ii. Accept "..cq("Fel Reavers, No Thanks!"),
			"	c. Talk to Zephyrion",
			"		i. Accept "..cq("Surveying the Ruins"),
			completion={{questaccepted="The Minions of Culuthas"},{questaccepted="Fel Reavers, No Thanks!"},{questaccepted="Surveying the Ruins"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=34907960,
		}, {
			"Go northwest to "..cl(41,32),
			"	a. Use the Energy Field Modulator on Farahlon Lashers",
			"	b. Kill them to Test the Energy Modulator",
			"	c. Test the Energy Modulator 10 times",
			completion={{questgoal={"*","Test Energy Modulator",10}}},
			mapzone="Netherstorm",
			level=68,
			mapnote=32207310,
		}, {
			"Go east to "..cl(42,33),
			"	a. Talk to Aurine Moonblaze",
			"		i. Turn in "..cq("Flora of the Eco-Domes"),
			"		ii. Accept "..cq("Creatures of the Eco-Domes"),
			completion={{questturnedin="Flora of the Eco-Domes"},{questaccepted="Creatures of the Eco-Domes"}},
			mapzone="Netherstorm",
			level=68,
			mapnote=32607490,
		}, {
			"Grind to level 69",
			completion={{level=69}},
			mapzone="Netherstorm",
			level=68,
		}, {
			"Go north to "..cl(43,30),
			"	a. Fight Talbuk Sires and Talbuk Does until they are almost dead",
			"	b. Use your Talbuk Tagger to tag them",
			"	c. Tag 12 Talbuks",
			completion={{questgoal={"*","Talbuk Tagged",12}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=29907310,
		}, {
			"Go northeast to "..cl(47,27),
			"	a. Stand in the small camp of equipment",
			"	b. Use your Diagnostic Device",
			"	c. Get the Diagnosis Results",
			completion={{questgoal={"*","Diagnostic Results",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=26807440,
		}, {
			"Go northeast to "..cl(49,23),
			"	a. Kill 10 Hounds of Culuthas",
			"	b. Kill 5 Eyes of Culuthas",
			completion={{questgoal={"*","Hound of Culuthas slain",10}},{questgoal={"*","Eye of Culuthas slain",5}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=22507190,
		}, {
			"Go northeast to "..cl(52,21),
			"	a. Get next to the leaning, purple glowing flag",
			"	b. Use your Surveying Markers",
			"	c. Mark Survey Marker One",
			completion={{questgoal={"*","Surveying Marker One placed",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=20507210,
		}, {
			"Go southeast to "..cl(54,23),
			"	a. Get next to the leaning, purple glowing flag",
			"	b. Use your Surveying Markers",
			"	c. Mark Survey Marker Two",
			completion={{questgoal={"*","Surveying Marker Two placed",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=22807740,
		}, {
			"Go northeat to "..cl(56,20),
			"	a. Get next to the leaning, purple glowing flag",
			"	b. Use your Surveying Markers",
			"	c. Mark Survey Marker Three",
			completion={{questgoal={"*","Surveying Marker Three placed",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=19907570,
		}, {
			"Go northwest to "..cl(44,15),
			"	a. Click the little clear cases in the raptor nests with purple eggs",
			"	b. Get 10 Dome Generator Segments",
			completion={{questgoal={"*","Dome Generator Segment",10}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=14705880,
		}, {
			"Go southwest to "..cl(39,26),
			"	a. Kill Gan'arg Mekgineers",
			"	b. Get 5 Condensed Nether Gas",
			completion={{item={"Condensed Nether Gas",5}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=26206560,
		}, {
			"Go northwest to "..cl(38,26),
			"	a. Make sure you have 5 Condensed Nether Gas",
			"	b. Talk to the Inactive Fel Reaver",
			"		i. Destroy the Inactive Fel Reaver",
			completion={{questgoal={"*","Inactive Fel Reaver Destroyed",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=25706370,
		}, {
			"Go southwest to "..cl(35,38),
			"	a. Talk to Nether-Stalker Oazul",
			"		i. Accept "..cq("Neutralizing the Nethermancers"),
			"	b. Talk to Wind Trader Tuluman",
			"		i. Accept "..cq("Dealing with the Foreman"),
			completion={{questaccepted="Neutralizing the Nethermancers"},{questaccepted="Dealing with the Foreman"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=37807240,
		}, {
			"Go southwest to "..cl(31,41),
			"	a. Kill 15 Sunfury Nethermancers",
			completion={{questgoal={"*","Sunfury Nethermancer slain",15}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41407230,
		}, {
			"Go west all the way up the hill",
			completion={{location={mapzone="Netherstorm",x=27.3,y=42.6, dist=0.5}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(26,41),
			"	a. Talk to Magister Theledorn",
			"		i. Turn in "..cq("A Defector"),
			"		ii. Accept "..cq("Damning Evidence"),
			completion={{questturnedin="A Defector"},{questaccepted="Damning Evidence"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41606780,
		}, {
			"Go north to "..cl(26,40),
			"	a. Kill demons inside and outside of Manaforge Ara",
			"	b. Get 8 Orders From Kael'thas",
			completion={{questgoal={"*","Orders From Kael'thas",8}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=39906610,
		}, {
			"Jump down the hill to the south near the entrance to the mine",
			"	a. It has a huge blanket draped over top of it",
			completion={{location={mapzone="Netherstorm",x=26.1,y=42.7, dist=0.5}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go inside the mine",
			completion={{location={mapzone="Netherstorm",x=26.4,y=44.1, dist=0.3}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go inside the mine to "..cl(26,42),
			"	a. Talk to Foreman Sundown",
			"		i. Turn in "..cq("Dealing with the Foreman"),
			"		ii. Accept "..cq("Dealing with the Overmaster"),
			completion={{questturnedin="Dealing with the Foreman"},{questaccepted="Dealing with the Overmaster"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=42306870,
		}, {
			"Go north inside the mine to "..cl(27,36),
			"	a. Kill Overmaster Grindgarr",
			"	b. He's at the very back of the cave",
			completion={{questgoal={"*","Overmaster Grindgarr slain",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35806260,
		}, {
			"Hearth to Stormspire",
			completion={{location={mapzone="Netherstorm",x=44.8,y=35.6, dist=6}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(45,35),
			"	a. Talk to Audi the Needle",
			"		i. Turn in "..cq("Retrieving the Goods"),
			completion={{questturnedin="Retrieving the Goods"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=36708140,
		}, {
			"Go to "..cl(45,35),
			"	a. Talk to Nether-Stalker Nauthis",
			"		i. Turn in "..cq("The Minions of Culuthas"),
			"		ii. Turn in "..cq("Fel Reavers, No Thanks!"),
			"		iii. Accept "..cq("The Best Defense"),
			"	b. Talk to Zephyrion",
			"		i. Turn in "..cq("Surveying the Ruins"),
			completion={{questturnedin="The Minions of Culuthas"},{questturnedin="Fel Reavers, No Thanks!"},{questturnedin="Surveying the Ruins"},{questaccepted="The Best Defense"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=34907960,
		}, {
			"Go to "..cl(44,35),
			"	a. Talk to Ghabar",
			"		i. Turn in "..cq("Diagnosis: Critical"),
			"		ii. Accept "..cq("Testing the Prototype"),
			completion={{questturnedin="Diagnosis: Critical"},{questaccepted="Testing the Prototype"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35107860,
		}, {
			"Go to "..cl(42,33),
			"	a. Talk Aurine Moonblaze",
			"		i. Turn in "..cq("Creatures of the Eco-Domes"),
			"		ii. Accept "..cq("When Nature Goes Too Far"),
			completion={{questturnedin="Creatures of the Eco-Domes"},{questaccepted="When Nature Goes Too Far"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32607490,
		}, {
			"Go northeast "..cl(45,29),
			"	a. Kill Markaru",
			"	b. Get the Hulking Hydra Heart",
			completion={{questgoal={"*","Hulking Hydra Heart",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=28507310,
		}, {
			"Go north to "..cl(45,14),
			"	a. Talk to Tashar",
			"		i. Turn in "..cq("Testing the Prototype"),
			"		ii. Accept "..cq("All Clear!"),
			completion={{questturnedin="Testing the Prototype"},{questaccepted="All Clear!"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=14605930,
		}, {
			"Go northwest to "..cl(44,13),
			"	a. Kill 12 Scythetooth Raptors",
			completion={{questgoal={"*","Scythetooth Raptor slain",12}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=13405740,
		}, {
			"Go southeast to "..cl(45,14),
			"	a. Talk to Tashar",
			"		i. Turn in "..cq("All Clear!"),
			"		ii. Accept "..cq("Success!"),
			completion={{questturnedin="All Clear!"},{questaccepted="Success!"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=14605930,
		}, {
			"Go southwest to "..cl(42,23),
			"	a. Kill 12 Wrathbringers",
			completion={{questgoal={"*","Wrathbringer slain",12}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=23506560,
		}, {
			"Go southwest to "..cl(35,38),
			"	a. Talk to Nether-Stalker Oazul",
			"		i. Turn in "..cq("Neutralizing the Nethermancers"),
			"	b. Talk to Wind Trader Tuluman",
			"		i. Turn in "..cq("Dealing with the Overmaster"),
			completion={{questturnedin="Neutralizing the Nethermancers"},{questturnedin="Dealing with the Overmaster"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=37807240,
		}, {
			"Go east to Stormspire",
			completion={{location={mapzone="Netherstorm",x=44.8,y=35.6, dist=6}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(42,33),
			"	a. Talk to Aurine Moonblaze",
			"		i. Turn in "..cq("When Nature Goes Too Far"),
			completion={{questturnedin="When Nature Goes Too Far"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32607490,
		}, {
			"Go to "..cl(44,35),
			"	a. Talk to Ghabar",
			"		i. Turn in "..cq("Success!"),
			completion={{questturnedin="Success!"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35107860,
		}, {
			"Go to "..cl(45,35),
			"	a. Talk to Nether-Stalker Nauthis",
			"		i. Turn in "..cq("The Best Defense"),
			completion={{questturnedin="The Best Defense"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=34907960,
		}, {
			"Go east to "..cl(58,32),
			"	a. Talk to Wind Trader Marid",
			"		i. Accept "..cq("A Not-So-Modest Proposal"),
			completion={{questaccepted="A Not-So-Modest Proposal"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31709000,
		}, {
			"Go to "..cl(59,33),
			"	a. Talk to Researcher Navuud",
			"		i. Accept "..cq("Electro-Shock Goodness!"),
			completion={{questaccepted="Electro-Shock Goodness!"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32609180,
		}, {
			"Also at "..cl(60,32),
			"	a. Talk to Flesh Handler Viridius",
			"		i. Accept "..cq("Captain Tyralius"),
			completion={{questaccepted="Captain Tyralius"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32109120,
		}, {
			"Also at "..cl(60,32),
			"	a. Talk to Professor Dabiri",
			"		i. Accept "..cq("Recipe for Destruction"),
			completion={{questaccepted="Recipe for Destruction"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31709180,
		}, {
			"Go southwest to "..cl(56,39),
			"	a. Use Navuud's Concoction",
			"	b. Kill Void Wastes",
			"	c. Kill the Void Waste Globules that spawn",
			"	d. Kill 30 Void Waste Globules",
			completion={{questgoal={"*","Void Waste Globule slain",30}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=39309520,
		}, {
			"Go southwest to "..cl(54,41),
			"	a. Kill Warden Icoshock",
			"	b. Get The Warden's Key",
			completion={{item={"The Warden's Key",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41109550,
		}, {
			"Go west to "..cl(53,41),
			"	a. Click the big pink bubble looking thing",
			"	b. Free Captain Tyralius",
			completion={{questgoal={"*","Captain Tyralius Freed",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41409480,
		}, {
			"Go southeast to "..cl(59,45),
			"	a. Talk to Agent Araxes",
			"		i. Accept "..cq("The Flesh Lies..."),
			completion={{questaccepted="The Flesh Lies..."}},
			mapzone="Netherstorm",
			level=69,
			mapnote=45010440,
		}, {
			"Go southeast to "..cl(61,46),
			"	a. Use your Protectorate Ignitor on Withered Corpses here and inside the mine",
			"	b. Don't get too close or the corpses turn into a monster",
			"	c. Burn 12 Withered Corpses",
			completion={{questgoal={"*","Withered Corpses Burned",12}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=46510740,
		}, {
			"Go into the mine",
			completion={{location={mapzone="Netherstorm",x=61.1,y=45.4, dist=0.3}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(61,41),
			"	a. Talk to Agent Ya-six",
			"		i. Accept "..cq("Arconus the Insatiable"),
			"	b. Click the Teleporter Power Pack",
			"	c. Get the Teleporter Power Pack",
			completion={{questaccepted="Arconus the Insatiable"},{questgoal={"*","Teleporter Power Pack",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41510240,
		}, {
			"Go inside the mine to "..cl(60,40),
			"	a. Kill Arconus the Insatiable",
			completion={{questgoal={"*","Arconus the Insatiable slain",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=39909990,
		}, {
			"Leave the mine",
			completion={{location={mapzone="Netherstorm",x=61.1,y=45.4, dist=0.3}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go west to "..cl(59,45),
			"	a. Talk to Agent Araxes",
			"		i. Turn in "..cq("The Flesh Lies..."),
			completion={{questturnedin="The Flesh Lies..."}},
			mapzone="Netherstorm",
			level=69,
			mapnote=45010440,
		}, {
			"Go east to "..cl(64,47),
			"	a. Use Navuud's Concoction",
			"	b. Kill Seeping Sludges",
			"	c. Kill Seeping Sludge Globules that spawn",
			"	d. Kill 30 Seeping Sludge Globules",
			completion={{questgoal={"*","Seeping Sludge Globule slain",30}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=47111110,
		}, {
			"Go northeast to "..cl(66,42),
			"	a. Kill Voidshriekers",
			"	b. Kill Unstable Voidwraths",
			"	c. Get 8 Fragments of Dimensius",
			completion={{questgoal={"*","Fragment of Dimensius",8}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=42110850,
		}, {
			"Go north to "..cl(67,34),
			"	a. Use your Triangulation Device",
			"	b. Walk to the red arrow",
			"	c. Discover the First Triangulation Point",
			completion={{questgoal={"*","First triangulation point discovered",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=33810050,
		}, {
			"Go east down the path into Celestial Ridge",
			completion={{location={mapzone="Netherstorm",x=71.0,y=40.0, dist=0.5}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(71,39),
			"	a. Click the Teleport Pad",
			"	b. Talk to the Image of Wind Trader Marid",
			"		i. Turn in "..cq("A Not-So-Modest Proposal"),
			"		ii. Accept "..cq("Getting Down to Business"),
			completion={{questturnedin="A Not-So-Modest Proposal"},{questaccepted="Getting Down to Business"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=39011010,
		}, {
			"Go northeast to "..cl(72,38),
			"	a. Kill Nether Drakes",
			"	b. Kill Nether Dragons",
			"	c. Get 8 Nether Dragon Essences",
			completion={{questgoal={"*","Nether Dragon Essence",8}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=38211040,
		}, {
			"Go southwest to "..cl(71,39),
			"	a. Talk to the Shrouded Figure",
			"		i. Turn in "..cq("Getting Down to Business"),
			"		ii. Accept "..cq("Formal Introductions"),
			completion={{questturnedin="Getting Down to Business"},{questaccepted="Formal Introductions"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=38810970,
		}, {
			"Go north to "..cl(71,35),
			"	a. Talk to Tyri",
			"		i. Turn in "..cq("Formal Introductions"),
			"		ii. Accept "..cq("A Promising Start"),
			completion={{questturnedin="Formal Introductions"},{questaccepted="A Promising Start"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35110630,
		}, {
			"Go south to "..cl(72,36),
			"	a. Click the dark colored eggs with spikes on them",
			"	b. Get 15 Nether Dragonkin Eggs",
			completion={{questgoal={"*","Nether Dragonkin Egg",15}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=36310790,
		}, {
			"Go north to "..cl(71,35),
			"	a. Talk to Tyri",
			"		i. Turn in "..cq("A Promising Start"),
			"		ii. Accept "..cq("Troublesome Distractions"),
			completion={{questturnedin="A Promising Start"},{questaccepted="Troublesome Distractions"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35110630,
		}, {
			"Go west to "..cl(60,32),
			"	a. Talk to Professor Dabiri",
			"		i. Turn in "..cq("Recipe for Destruction"),
			"		ii. Accept "..cq("On Nethery Wings"),
			completion={{questturnedin="Recipe for Destruction"},{questaccepted="On Nethery Wings"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31709180,
		}, {
			"Also at "..cl(60,32),
			"	a. Talk to Commander Ameer",
			"		i. Turn in "..cq("Arconus the Insatiable"),
			completion={{questturnedin="Arconus the Insatiable"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32409190,
		}, {
			"Also at "..cl(60,32),
			"	a. Talk to Flesh Handler Viridius",
			"		i. Turn in "..cq("Captain Tyralius"),
			completion={{questturnedin="Captain Tyralius"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32109120,
		}, {
			"Go to "..cl(60,33),
			"	a. Talk to Researcher Navuud",
			"		i. Turn in "..cq("Electro-Shock Goodness!"),
			completion={{questturnedin="Electro-Shock Goodness!"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=32609180,
		}, {
			"Go to "..cl(58,31),
			"	a. Talk to Dealer Hazzin",
			"		i. Turn in "..cq("Triangulation Point One"),
			"		ii. Accept "..cq("Triangulation Point Two"),
			completion={{questturnedin="Triangulation Point One"},{questaccepted="Triangulation Point Two"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31308960,
		}, {
			"Go to "..cl(58,32),
			"	a. Talk to Wind Trader Marid",
			"	b. Lure Wind Trader Marid away",
			"	c. Kill Wind Trader Marid",
			completion={{questgoal={"*","Wind Trader Marid slain",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31709000,
		}, {
			"Go to "..cl(60,32),
			"	a. Talk to the Protectorate Nether Drake next to Professor Dabiri",
			"	b. Put the Phase Disruptor in a slot on your spell bar",
			"	c. Click it repeatedly while you ride the Nether Drake",
			"	d. Destroy the Void Conduit",
			"	e. Talk to Professor Dabiri",
			"		i. Turn in "..cq("On Nethery Wings"),
			completion={{questturnedin="On Nethery Wings"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=31709180,
		}, {
			"Go east into the Celestial Ridge",
			completion={{location={mapzone="Netherstorm",x=71.0,y=40.0, dist=0.5}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(71,35),
			"	a. Talk to Tyri",
			"		i. Turn in "..cq("Troublesome Distractions"),
			completion={{questturnedin="Troublesome Distractions"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=35110630,
		}, {
			"Hearth to Stormspire",
			completion={{location={mapzone="Netherstorm",x=44.8,y=35.6, dist=6}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go southwest to "..cl(29,41),
			"	a. Use your Triangulation Device",
			"	b. Walk up the rocks to the red arrow",
			"	c. Discover the Second Triangulation Point",
			completion={{questgoal={"*","Second triangulation point discovered",1}}},
			mapzone="Netherstorm",
			level=69,
			mapnote=41307020,
		}, {
			"Go east to "..cl(35,38),
			"	a. Talk to Wind Trader Tuluman",
			"		i. Turn in "..cq("Triangulation Point Two"),
			completion={{questturnedin="Triangulation Point Two"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=37807240,
		}, {
			"Go east to Stormspire",
			completion={{location={mapzone="Netherstorm",x=44.8,y=35.6, dist=6}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Fly to Area 52",
			completion={{location={mapzone="Netherstorm",x=32.3,y=65.5, dist=3}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(32,64),
			"	a. Talk to Spymaster Thalodien",
			"		i. Turn in "..cq("Damning Evidence"),
			completion={{questturnedin="Damning Evidence"}},
			mapzone="Netherstorm",
			level=69,
			mapnote=64009600,
		}, {
			"Fly to Thunderlord Stronghold",
			completion={{location={mapzone="Blade's Edge Mountains",x=52.1,y=56.7, dist=4}}},
			mapzone="Netherstorm",
			level=69,
		}, {
			"Go to "..cl(52,54),
			"	a. Talk to Agadai",
			"		i. Accept "..cq("The Apprentice's Request"),
			completion={{questaccepted="The Apprentice's Request"}},
			mapzone="Blade's Edge Mountains",
			level=69,
			mapnote=54410640,
		}, {
			"Fly to Stonebreaker Hold",
			completion={{location={mapzone="Terokkar Forest",x=49.2,y=45.3, dist=2.5}}},
			mapzone="Blade's Edge Mountains",
			level=69,
		}, {
			"Go southeast to Shadowmoon Valley",
			completion={{location={mapzone="Shadowmoon Valley"}}},
			mapzone="Terokkar Forest",
			level=69,
		}, {
			"Go southeast to "..cl(30,32),
			"	a. Talk to Blood Guard Gulmok",
			"		i. Accept "..cq("Besieged!"),
			completion={{questaccepted="Besieged!"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=32406280,
		}, {
			"Go to "..cl(31,30),
			"	a. Talk to Sergeant Kargrul",
			"		i. Accept "..cq("The Sketh'lon Wreckage"),
			completion={{questaccepted="The Sketh'lon Wreckage"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=29806080,
		}, {
			"Go to "..cl(29,29),
			"	a. Talk to Dama Wildmane",
			"		i. Turn in "..cq("The Apprentice's Request"),
			completion={{questturnedin="The Apprentice's Request"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=29505860,
		}, {
			"Go to "..cl(30,29),
			"	a. Talk to Drek'Gol",
			"		i. Get the Shadowmoon Village Flight Path",
			completion={{flightpath="Shadowmoon Village"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=29205950,
		}, {
			"Go to "..cl(30,28),
			"	a. Talk to Researcher Tiorus",
			"		i. Accept "..cq("What Strange Creatures..."),
			completion={{questaccepted="What Strange Creatures..."}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=28305840,
		}, {
			"Also at "..cl(30,28),
			"	a. Talk to Chief Apothecary Hildagard",
			"		i. Accept "..cq("A Haunted History"),
			completion={{questaccepted="A Haunted History"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=27705760,
		}, {
			"Make Shadowmoon Village your home",
			completion={{home="Shadowmoon Village"}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(28,27),
			"	a. Talk to Earthmender Splinthoof",
			"		i. Accept "..cq("The Hand of Gul'dan"),
			"	b. Talk to Overlord Or'barokh",
			"		i. Accept "..cq("A Grunt's Work..."),
			completion={{questaccepted="The Hand of Gul'dan"},{questaccepted="A Grunt's Work..."}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=26505500,
		}, {
			"Go southeast to "..cl(31,35),
			"	a. Kill 10 Infernal Attackers",
			completion={{questgoal={"*","Infernal Attacker slain",10}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=34706600,
		}, {
			"Go northwest to "..cl(30,32),
			"	a. Talk to Blood Guard Gulmok",
			"		i. Turn in "..cq("Besieged!"),
			"		ii. Accept "..cq("To Legion Hold"),
			completion={{questturnedin="Besieged!"},{questaccepted="To Legion Hold"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=32406280,
		}, {
			"Kill 20 Shadowmoon Valley Wildlife as you quest in Shadowmoon Valley",
			"	a. The Shadowmoon Valley Wildlife are:",
			"		i. Felboars",
			"		ii. Vilewing Chimeras",
			"		iii. Scorchshell Pincers",
			completion={{questgoal={"*","Shadowmoon Valley Wildlife slain",20}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go south to "..cl(31,41),
			"	a. Kill Felfire Diemetradons",
			"	b. Get 8 Felfire Spleens",
			"	c. Click the little volcanos that puff green smoke",
			"	d. Get 15 Ever-burning Ash",
			completion={{questgoal={"*","Felfire Spleen",8}},{questgoal={"*","Ever-burning Ash",15}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=41207190,
		}, {
			"Go northwest to Legion Hold",
			completion={{location={mapzone="Shadowmoon Valley",x=23.4,y=38.3, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go up the big platform wall thing",			
			completion={{location={mapzone="Shadowmoon Valley",x=23.4,y=38.3, dist=0.5}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(24,37),
			"	a. Use the Box o' Tricks next to the Legion Communication Device",
			"	b. Watch the conversation",
			"	c. Discover Legion's Plans",
			completion={{questgoal={"*","Discover Legion's Plans",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=36906050,
		}, {
			"Make sure you've killed 20 Shadowmoon Valley Wildlife",
			"	a. The Shadowmoon Valley Wildlife are:",
			"		i. Felboars",
			"		ii. Vilewing Chimeras",
			"		iii. Scorchshell Pincers",
			completion={{questgoal={"*","Shadowmoon Valley Wildlife slain",20}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go northeast to Shadowmoon Village",
			completion={{location={mapzone="Shadowmoon Valley",x=30.2,y=30.5, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(30,32),
			"	a. Talk to Blood Guard Gulmok",
			"		i. Turn in "..cq("To Legion Hold"),
			"		ii. Accept "..cq("Setting Up the Bomb"),
			completion={{questturnedin="To Legion Hold"},{questaccepted="Setting Up the Bomb"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=32406280,
		}, {
			"Go to "..cl(30,28),
			"	a. Talk to Researcher Tiorus",
			"		i. Turn in "..cq("What Strange Creatures..."),
			"	b. Talk to Chief Apothecary Hildegard",
			"		i. Turn in "..cq("A Haunted History"),
			"		ii. Accept "..cq("Spectrecles"),
			completion={{questturnedin="What Strange Creatures..."},{questturnedin="A Haunted History"},{questaccepted="Spectrecles"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=28305840,
		}, {
			"Go to "..cl(28,26),
			"	a. Talk to Overlord Or'barokh",
			"		i. Turn in "..cq("A Grunt's Work..."),
			completion={{questturnedin="A Grunt's Work..."}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=26505500,
		}, {
			"Go to "..cl(29,28),
			"	a. Equip the Spectrecles in your bags",
			"	b. Kill 12 Shadowmoon Zealots around Shadowmoon Village",
			completion={{questgoal={"*","Shadowmoon Zealot slain",12}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=27605680,
		}, {
			"Go to "..cl(30,28),
			"	a. Talk to Chief Apothecary Hildagard",
			"		i. Turn in "..cq("Spectrecles"),
			"		ii. Accept "..cq("Teron Gorefiend - Lore and Legend"),
			completion={{questturnedin="Spectrecles"},{questaccepted="Teron Gorefiend - Lore and Legend"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=27705760,
		}, {
			"Go southwest to Legion Hold",
			completion={{location={mapzone="Shadowmoon Valley",x=23.4,y=38.3, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(22,35),
			"	a. Click the big green glowing helmet on the ground",
			"	b. Get the Fel Reaver Armor Plate",
			"	c. Kill mobs around this area",
			"	d. Get an Illidari-Bane Shard",
			"	e. Click the Illidari-Bane Shard",
			"		i. Accept "..cq("Illidari-Bane Shard"),
			completion={{questgoal={"*","Fel Reaver Armor Plate",1}},{questaccepted="Illidari-Bane Shard"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=35505770,
		}, {
			"Go southeast to "..cl(26,41),
			"	a. Click the jetpack looking thing underwater in the middle of the lake",
			"	b. Get Fel Reaver Power Core",
			completion={{questgoal={"*","Fel Reaver Power Core",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=41206750,
		}, {
			"Go northeast to Shadowmoon Village",
			completion={{location={mapzone="Shadowmoon Valley",x=30.2,y=30.5, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(30,32),
			"	a. Talk to Blood Guard Gulmok",
			"		i. Turn in "..cq("Setting Up the Bomb"),
			"		ii. Accept "..cq("Blast the Infernals!"),
			completion={{questturnedin="Setting Up the Bomb"},{questaccepted="Blast the Infernals!"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=32406280,
		}, {
			"Go to "..cl(30,31),
			"	a. Talk to Grokom Deatheye",
			"		i. Turn in "..cq("Illidari-Bane Shard"),
			completion={{questturnedin="Illidari-Bane Shard"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=31306110,
		}, {
			"Go southwest to Legion Hold",
			completion={{location={mapzone="Shadowmoon Valley",x=23.4,y=38.3, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(23,40),
			"	a. Stand inside the green summoning circle looking thing",
			"	b. Use your Fel Bomb",
			"	c. Destroy the Legion Infernals",
			completion={{questgoal={"*","Destroy Legion Hold Infernals",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39906250,
		}, {
			"Hearth to Shadowmoon Village",
			completion={{location={mapzone="Shadowmoon Valley",x=30.2,y=30.5, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(30,32),
			"	a. Talk to Blood Guard Gulmok",
			"		i. Turn in "..cq("Blast the Infernals!"),
			"		ii. Accept "..cq("The Deathforge"),
			completion={{questturnedin="Blast the Infernals!"},{questaccepted="The Deathforge"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=32406280,
		}, {
			"Go east to "..cl(40,31),
			"	a. Kill Dark Conclave arakkoas",
			"	b. Get the Sketh'lon Commander's Journal Page 1",
			"	c. Get the Sketh'lon Commander's Journal Page 2",
			"	d. Get the Sketh'lon Commander's Journal Page 3",
			completion={{questgoal={"*","Sketh'lon Commander's Journal - Page 1",1}},{questgoal={"*","Sketh'lon Commander's Journal - Page 2",1}},{questgoal={"*","Sketh'lon Commander's Journal - Page 3",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=30507080,
		}, {
			"Go southwest to "..cl(39,38),
			"	a. Talk to Scout Zagran",
			"		i. Turn in "..cq("The Deathforge"),
			"		ii. Accept "..cq("Minions of the Shadow Council"),
			completion={{questturnedin="The Deathforge"},{questaccepted="Minions of the Shadow Council"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=38207680,
		}, {
			"Go northeast to "..cl(40,36),
			"	a. Kill 10 Deathforge Guardians",
			"	b. Kill 5 Deathforge Summoners",
			completion={{questgoal={"*","Deathforge Guardian slain",10}},{questgoal={"*","Deathforge Summoner slain",5}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=36307640,
		}, {
			"Go southwest to "..cl(39,38),
			"	a. Talk to Scout Zagran",
			"		i. Turn in "..cq("Minions of the Shadow Council"),
			completion={{questturnedin="Minions of the Shadow Council"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=38207680,
		}, {
			"Go southeast to "..cl(42,45),
			"	a. Talk to Earthmender Torlok",
			"		i. Turn in "..cq("The Hand of Gul'dan"),
			"		ii. Accept "..cq("Enraged Spirits of Fire and Earth"),
			completion={{questturnedin="The Hand of Gul'dan"},{questaccepted="Enraged Spirits of Fire and Earth"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=45108730,
		}, {
			"Go southeast to "..cl(43,48),
			"	a. Use your Totem of Spirits",
			"	b. Kill Enraged Earth Spirits near the totem",
			"	c. Capture 8 Earthen Souls",
			completion={{questgoal={"*","Earthen Soul Captured",8}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=48009100,
		}, {
			"Go east to "..cl(47,48),
			"	a. Use your Totem of Spirits",
			"	b. Kill Enraged Fire Spirits near the totem",
			"	c. Capture 8 Fiery Souls",
			completion={{questgoal={"*","Fiery Soul Captured",8}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=48109470,
		}, {
			"Go northwest to "..cl(42,45),
			"	a. Talk to Earthmender Torlok",
			"		i. Turn in "..cq("Enraged Spirits of Fire and Earth"),
			"		ii. Accept "..cq("Enraged Spirits of Water"),
			completion={{questturnedin="Enraged Spirits of Fire and Earth"},{questaccepted="Enraged Spirits of Water"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=45108730,
		}, {
			"Go northwest to Shadowmoon Village",
			completion={{location={mapzone="Shadowmoon Valley",x=30.2,y=30.5, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go to "..cl(31,30),
			"	a. Talk to Sergeant Kargrul",
			"		i. Turn in "..cq("The Sketh'lon Wreckage"),
			"		ii. Accept "..cq("Find the Deserter"),
			completion={{questturnedin="The Sketh'lon Wreckage"},{questaccepted="Find the Deserter"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=29806080,
		}, {
			"Go southeast to "..cl(35,40),
			"	a. Talk to Parshah",
			"	b. He walks north and south on this road",
			"		i. Turn in "..cq("Find the Deserter"),
			"		ii. Accept "..cq("Asghar's Totem"),
			completion={{questturnedin="Find the Deserter"},{questaccepted="Asghar's Totem"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39907510,
		}, {
			"Go northeast to "..cl(40,29),
			"	a. Kill Asghar",
			"	b. Get the Sketh'lon War Totem",
			completion={{questgoal={"*","Sketh'lon War Totem",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=29206940,
		}, {
			"Go northeast to "..cl(50,25),
			"	a. Use your Totem of Spirits",
			"	b. Kill Enraged Water Spirits near the totem",
			"	c. Capture 5 Watery Souls",
			completion={{questgoal={"*","Watery Soul Captured",5}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=24707520,
		}, {
			"Go southwest to "..cl(35,40),
			"	a. Talk to Parshah",
			"	b. He walks north and south on this road",
			"		i. Turn in "..cq("Asghar's Totem"),
			"		ii. Accept "..cq("The Rod of Lianthe"),
			completion={{questturnedin="Asghar's Totem"},{questaccepted="The Rod of Lianthe"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39907510,
		}, {
			"Go southeast to "..cl(42,45),
			"	a. Talk to Earthmender Torlok",
			"		i. Turn in "..cq("Enraged Spirits of Water"),
			"		ii. Accept "..cq("Enraged Spirits of Air"),
			completion={{questturnedin="Enraged Spirits of Water"},{questaccepted="Enraged Spirits of Air"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=45108730,
		}, {
			"Go southeast to "..cl(47,66),
			"	a. Kill Eclipsion blood elves",
			"	b. Get Lianthe's Key",
			completion={{questgoal={"*","Lianthe's Key",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=66411390,
		}, {
			"Go south to "..cl(47,72),
			"	a. Click Lianthe's Strongbox",
			"	b. Get the Rod of Lianthe",
			completion={{questgoal={"*","Rod of Lianthe",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=71711920,
		}, {
			"Go northeast to "..cl(56,58),
			"	a. Talk to Alieshor",
			"		i. Get the Sanctum of the Stars Flight Path",
			completion={{flightpath="Sanctum of the Stars"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=57811410,
		}, {
			"Go northeast to "..cl(62,54),
			"	a. Use your Totem of Spirits",
			"	b. Kill Enraged Air Spirits near the totem",
			"	c. Capture 10 Airy Souls",
			completion={{questgoal={"*","Airy Soul Captured",10}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=54511650,
		}, {
			"Go south to "..cl(62,62),
			"	a. The path to the Ancient Shadowmoon Spirit starts here",
			completion={{location={mapzone="Shadowmoon Valley",x=62.5,y=62.6, dist=0.5}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=62612500,
		}, {
			"Go southwest to "..cl(58,71),
			"	a. Talk to the Ancient Shadowmoon Spirit",
			"		i. Turn in "..cq("Teron Gorefiend - Lore and Legend"),
			completion={{questturnedin="Teron Gorefiend - Lore and Legend"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=70812900,
		}, {
			"Hearth to Shadowmoon Village",
			completion={{location={mapzone="Shadowmoon Valley",x=30.2,y=30.5, dist=4}}},
			mapzone="Shadowmoon Valley",
			level=69,
		}, {
			"Go southeast to "..cl(35,40),
			"	a. Talk to Parshah",
			"	b. He walks north and south on this road",
			"		i. Turn in "..cq("The Rod of Lianthe"),
			"		ii. Accept "..cq("Sketh'lon Feathers"),
			completion={{questturnedin="The Rod of Lianthe"},{questaccepted="Sketh'lon Feathers"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39907510,
		}, {
			"Go southeast to "..cl(42,45),
			"	a. Talk to Earthmender Torlok",
			"		i. Turn in "..cq("Enraged Spirits of Air"),
			completion={{questturnedin="Enraged Spirits of Air"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=45108730,
		}, {
			"Go south to "..cl(43,56),
			"	a. Click the big red and black feathers on the ground",
			"	b. Get 8 Sketh'lon Feathers",
			completion={{questgoal={"*","Sketh'lon Feather",8}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=56009860,
		}, {
			"Go northwest to "..cl(35,40),
			"	a. Talk to Parshah",
			"	b. He walks north and south on this road",
			"		i. Turn in "..cq("Sketh'lon Feathers"),
			"		ii. Accept "..cq("Imbuing the Headpiece"),
			completion={{questturnedin="Sketh'lon Feathers"},{questaccepted="Imbuing the Headpiece"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39907510,
		}, {
			"Go southeast to "..cl(43,45),
			"	a. Equip the Unfinished Headpiece when you are NOT close to the altar",
			"		i. Wait for the cooldown to be done",
			"	b. Go up to the altar",
			"	c. Use the Unfinished Headpiece",
			"	d. Energize the Headpiece",
			completion={{questgoal={"*","Energized Headpiece",1}}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=44908790,
		}, {
			"Go northwest to "..cl(35,40),
			"	a. Talk to Parshah",
			"	b. He walks north and south on this road",
			"		i. Turn in "..cq("Imbuing the Headpiece"),
			completion={{questturnedin="Imbuing the Headpiece"}},
			mapzone="Shadowmoon Valley",
			level=69,
			mapnote=39907510,
		}, {
			"Grind to level 70",
			completion={{level=70}},
		}
	  }
	}
}